package gov.va.med.hds.cd.ccow.desktop;
import java.awt.Component;
import java.util.LinkedList;

import gov.va.med.hds.cd.ccow.ICCowDesktopCoreConstants;
import gov.va.med.hds.cd.ccow.IContextMapper;
import gov.va.med.hds.cd.ccow.internal.ContextModule;
import gov.va.med.hds.cd.runtime.IConfigurationElement;
import gov.va.med.hds.cd.runtime.IPlugin;
import gov.va.med.hds.cd.runtime.IPluginDescriptor;
import gov.va.med.hds.cd.runtime.IPluginRegistry;
import gov.va.med.hds.cd.runtime.IRuntimeContext;
import gov.va.med.hds.cd.runtime.logging.ILogger;

/**
 * @author vhaisltumad
 *
 * To change this generated comment go to 
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
public class DesktopContextModule extends ContextModule implements IPlugin {

	private IRuntimeContext runtimeContext;
	private IPluginDescriptor pluginDescriptor;

	public DesktopContextModule() {
		super(
			ICCowDesktopCoreConstants.APP_NAME,
			ICCowDesktopCoreConstants.APP_PASSCODE);
	}

	// Implementation of the IPlugin interface

	public void startup(IRuntimeContext runtime, IPluginDescriptor plugin) {
		this.runtimeContext = runtime;
		this.pluginDescriptor = plugin;
	}

	public String browseCCOWHyperlink(Object hyperlink, Component parent) {
		DesktopChartLauncher.init(runtimeContext);
		return super.browseCCOWHyperlink(hyperlink, parent);
	}

	protected void initContextMappers() {
		contextMappers = new LinkedList();

		IPluginRegistry pluginRegistry = runtimeContext.getPluginRegistry();
		IConfigurationElement[] extensions =
			pluginRegistry.getConfigurationElementsFor(
				IContextMapper.EXTENSION_POINT_ID);

		ILogger log = runtimeContext.getLogger(DesktopContextModule.class);

		if (extensions != null)
			for (int i = 0; i < extensions.length; i++)
				try {
					IContextMapper m =
						(
							IContextMapper) extensions[i]
								.createExecutableExtension(
							"className");
					contextMappers.add(m);
				} catch (Exception e) {
					String className = extensions[i].getAttribute("className");
					log.error(
						"Could not create context mapper class " + className);
				}
	}

	public String getCcowHref(Object patient) {
		return "scriptlet:"
			+ "gov.va.med.hds.cd.ccow.ui.Hyperlink.openCCOWHyperlink"
			+ "('Patient.id.MRN.DFN=" + patient + "')";
	}
}
