/*
 * Created on May 20, 2003
 *
 */
package gov.va.med.hds.cd.ccow.desktop;

import java.util.Map;

import gov.va.med.hds.cd.ccow.IContextMapper;
import gov.va.med.hds.cd.daoregistry.IDaoRegistry;
import gov.va.med.hds.cd.runtime.IConfigurationElement;
import gov.va.med.hds.cd.runtime.IExecutableExtension;
import gov.va.med.hds.cd.runtime.IRuntimeContext;

/**
 * 
 * @author vhaisltumad
 *
 */
public class MPatientMapper implements IExecutableExtension, IContextMapper {

	IRuntimeContext runtime;
	IMPatientMapperDAO dao = null;

	public void setInitializationData(
		IRuntimeContext runtime,
		IConfigurationElement config,
		String propertyName,
		Object data) {

		this.runtime = runtime;
	}

	public boolean mapSubjects(Map context) {

		if (dao == null)
			try {
				IDaoRegistry daoRegistry =
					(IDaoRegistry) runtime.getPluginInstance(
						IDaoRegistry.PLUGIN_ID);
				dao =
					(IMPatientMapperDAO) daoRegistry.getDAO(
						IMPatientMapperDAO.class.getName());
			} catch (Exception e) {
				runtime.getLogger(MPatientMapper.class).error(
					"Could not create an MPatientMapper DAO.");
			}

		if (dao != null)
			return dao.mapSubjects(context);
		else
			return false;
	}

}
