package gov.va.med.hds.cd.ccow.ui;

import java.awt.Cursor;
import java.util.LinkedList;

import javax.swing.JComponent;
import javax.swing.JOptionPane;

import gov.va.med.hds.cd.ccow.IContextModule;
import gov.va.med.hds.cd.runtime.IRuntimeContext;
import gov.va.med.hds.cd.spectrum.dhtml.scriptlet.IScriptlet;
import gov.va.med.hds.cd.spectrum.dhtml.scriptlet.IScriptletEvent;

public class Hyperlink implements IScriptlet {
	private static String WARNING =
		"Sorry, this feature is unavailable "
			+ "because you do not have a CCOW-enabled version of CPRS "
			+ "installed on your computer.";

	public void init(IScriptletEvent event) {
	}

	public void openCCOWHyperlink(IScriptletEvent event, String contextInfo) {
		try {
			JComponent pane = event.getPane();
			JComponent rootPane = pane.getRootPane();
			pane.setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
			rootPane.setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
			IRuntimeContext runtime = (IRuntimeContext) event.getEnvironment();
			IContextModule context =
				(IContextModule) runtime.getPluginInstance(
					"gov.va.med.hds.cd.ccow");
			String result = context.browseCCOWHyperlink(contextInfo, rootPane);
			rootPane.setCursor(null);
			pane.setCursor(null);

			if (result == null
				|| result.equals(IContextModule.BROWSE_SUCCESS)
				|| result.equals(IContextModule.BROWSE_CANCELLED))
				return;

			CCOWAlert("Problem with Hyperlink", result);
		} catch (Exception e) {
		}
	}

	public void CCOWAlert(String title, String message) {
		LinkedList l = new LinkedList();

		while (message.length() > 60) {
			int pos = message.lastIndexOf(' ', 60);
			l.add(message.substring(0, pos));
			message = message.substring(pos + 1);
		}
		l.add(message);

		String[] lines = (String[]) l.toArray(new String[l.size()]);
		JOptionPane.showMessageDialog(
			null,
			lines,
			title,
			JOptionPane.ERROR_MESSAGE);
	}
}
