

package gov.va.med.hds.cd.ccow;

import java.util.*;

/** This interface should be implemented by any visual component which
 * displays patient data.
 *
 * Note that to receive context change notifications, the

a ContextObserver wil
 */
public interface IContextObserver {

    /** This method is called by the context management broker to
     * alert the component to a change in context.
     */
    public void contextChanged();

    /** Called by the context management plugin to find out which
     * patient the context observer is displaying data for.
     *
     * @returns A map containing one or more name/value pairs that
     *       correspond to data elements in the CCOW patient subject
     */
    public Map getDisplayedPatient();

    /** @link dependency */
    /*#ClinicalContextBroker lnkClinicalContextBroker;*/
}
