package gov.va.med.hds.clinicaldata.test;

import gov.va.med.hds.clinicaldata.IPatientDemographics;
import gov.va.med.hds.clinicaldata.PatientDemographics;
import junit.framework.TestCase;

/**
 * Tests simple accessors to the PatientDemographics implementation
 */
public class PatientDemographicsTest extends TestCase {

	private static final String PATIENT_FILEMAN_DOB = "19220202";
	private static final String PATIENT_DOB = "02 Feb 1922";
	private static final String PATIENT_SSN = "222-22-1965";
	private static final String PATIENT_NAME = "JONES,ARNOLD";
	private static final String PATIENT_ID = "29";
	/**
	 * Constructor for PatientDemographicsTest.
	 * @param arg0
	 */
	public PatientDemographicsTest(String arg0) {
		super(arg0);
	}

	public void testPatientDemographics() {
		IPatientDemographics pdemos = new PatientDemographics(PATIENT_ID,PATIENT_NAME,PATIENT_SSN,PATIENT_FILEMAN_DOB);
		assertEquals("Wrong patient id",PATIENT_ID,pdemos.getPatientId());
		assertEquals("Wrong patient name",PATIENT_NAME,pdemos.getPatientName());
		assertEquals("Wrong patient ssn",PATIENT_SSN,pdemos.getSsn());
		assertEquals("Wrong patient ssn",PATIENT_DOB,pdemos.getDob());
		assertTrue("Wrong patient age",Integer.parseInt(pdemos.getAge()) > 80);
	}
}
