package gov.va.med.hds.clinicaldata.dao;

import gov.va.med.hds.cd.daoregistry.IDataAccessObject;
import gov.va.med.hds.clinicaldata.IPatientDemographics;

/**
 * Data Access Object interface for patient demographics
 */
public interface IPatientDemographicsDAO extends IDataAccessObject {
	/**
	 * Creates a patient demographics object given a patient ID
	 * 
	 * @param patientId Id of the patient
	 * @return patient demographics
	 * @throws PatientDemographicsDAOException
	 */
	public IPatientDemographics createPatient(String patientId)
		throws PatientDemographicsDAOException;
}
