package gov.va.med.hds.cd.config.internal;

import gov.va.med.hds.cd.config.IEntity;

/**
 *
 * @author Joel Russell
 *
 * Department of Veterans Affairs
 * OI Field Office - Salt Lake City
 * Health Data Systems
 * 
 **/
public class DivisionEntity implements IEntity {
	private String name			= "DIVISION";
	private String mixedCaseName	= "Division";
	private String prefix			= "DIV";
	private float fileNumber		= 4.00f;
	private float precedence		= 0;
	private String entityGvn		= ";DIC(4,";
	
	public DivisionEntity() {
	}
	
	public DivisionEntity(float precedence) {
		this.precedence = precedence;
	}
	
	/**
	 * @see gov.va.med.hds.cd.config.IEntity#getEntityName()
	 */
	public String getName() {
		return name;
	}

	/**
	 * @see gov.va.med.hds.cd.config.IEntity#getPrecedence()
	 */
	public float getPrecedence() {
		return precedence;
	}

	/**
	 * @see gov.va.med.hds.cd.config.IEntity#getEntityGvn()
	 */
	public String getEntityGvn() {
		return entityGvn;
	}

	/**
	 * @see gov.va.med.hds.cd.config.IEntity#setPrecedence(float)
	 */
	public void setPrecedence(float precedence) {
		this.precedence = precedence;
	}
	
	/**
	 * @see java.lang.Object#toString()
	 */
	public String toString() {
		return mixedCaseName;
	}
	/**
	 * @see gov.va.med.hds.cd.config.IEntity#getFileNumber()
	 */
	public float getFileNumber() {
		return fileNumber;
	}

	/**
	 * @see gov.va.med.hds.cd.config.IEntity#getMixedCaseName()
	 */
	public String getMixedCaseName() {
		return mixedCaseName;
	}

	/**
	 * @see gov.va.med.hds.cd.config.IEntity#getPrefix()
	 */
	public String getPrefix() {
		return prefix;
	}

}
