package gov.va.med.hds.cd.config.internal;

import gov.va.med.hds.cd.config.ICallResultHandler;
import gov.va.med.hds.cd.config.IParameterDefinition;
import gov.va.med.hds.cd.config.ParameterDefinitionException;
import gov.va.med.hds.cd.config.ResultHandlerException;

import java.util.ArrayList;
import java.util.List;

/**
 *
 * @author Joel Russell
 *
 * Department of Veterans Affairs
 * OI Field Office - Salt Lake City
 * Health Data Systems
 * 
 **/
public class ParameterDefinitionListHandler implements ICallResultHandler {
	private List parameterDefinitions = new ArrayList();

	/**
	 * @see gov.va.med.hds.cd.config.ICallResultHandler#processResult(java.lang.String)
	 */
	public Object processResult(String callResult)
		throws ResultHandlerException {
		parameterDefinitions.clear();
		try {
			parseResult(callResult);
		} catch (ParameterDefinitionException e) {
			throw new ResultHandlerException("ParameterDefinitionException caught: " + e.getMessage());
		}
		return parameterDefinitions;
	}

	private void parseResult(String callResult) throws ParameterDefinitionException {
		String[] results = callResult.split("\n");

		for (int i = 0; i < results.length; i++) {
			IParameterDefinition pDef = new ParameterDefinition(results[i]);
			parameterDefinitions.add(pDef);
		}
	}
}
