package gov.va.med.hds.cd.config.internal;

import gov.va.med.hds.cd.config.*;
import gov.va.med.hds.cd.config.IParameter;
import gov.va.med.hds.cd.config.IParameterCategory;

import java.util.ArrayList;
import java.util.List;

/**
 *
 * @author Joel Russell
 *
 * Department of Veterans Affairs
 * OI Field Office - Salt Lake City
 * Health Data Systems
 * 
 **/
public class ParameterList implements IParameterList {
	private String name = "";
	private List parameters = new ArrayList();
	private IParameterCategory category = null;
	
	public ParameterList() {
	}
	
	public ParameterList(IParameter parameter) {
		this.name = parameter.getName();
		category = parameter.getCategory();
		parameters.add(parameter);
	}

	public void setName(String name) {
		this.name = name;
	}
	
	public void addParameter(IParameter parameter) {
		parameters.add(parameter);
	}
	
	public IParameter getParameter(int index) {
		return (IParameter) parameters.get(index);
	}

	public int indexOf(IParameter parameter) {
		return parameters.indexOf(parameter);
	}
	
	public int size() {
		return parameters.size();
	}
	
	public String toString() {
		return name;
	}
	/**
	 * @see gov.va.med.hds.cd.config.internal.IParameterList#parameters()
	 */
	public ArrayList parameters() {
		return (ArrayList) parameters;
	}

	/**
	 * @see gov.va.med.hds.cd.config.internal.IParameterList#getCategory()
	 */
	public IParameterCategory getCategory() {
		return category;
	}

}
