package gov.va.med.hds.cd.config.test;

import gov.va.med.hds.cd.config.ConfigurationException;
import gov.va.med.hds.cd.config.ConfigurationReadyEvent;
import gov.va.med.hds.cd.config.IConfiguration;
import gov.va.med.hds.cd.config.IConfigurationReadyListener;
import gov.va.med.hds.cd.config.IConfigurator;
import junit.framework.TestCase;

/**
 *
 * @author Joel Russell
 *
 * Department of Veterans Affairs
 * OI Field Office - Salt Lake City
 * Health Data Systems
 * 
 **/
public class ConfiguratorTest extends TestCase implements IConfigurationReadyListener {

	private IConfigurator configurator;
	private IConfiguration dashConfig;
	/**
	 * Constructor for ConfiguratorTest.
	 * @param arg0
	 */
	public ConfiguratorTest(String arg0) {
		super(arg0);
	}

	public static void main(String[] args) {
		junit.textui.TestRunner.run(ConfiguratorTest.class);
	}

	/**
	 * @see TestCase#setUp()
	 */
	protected void setUp() throws Exception {
		super.setUp();
	}

	/**
	 * @see TestCase#tearDown()
	 */
	protected void tearDown() throws Exception {
		super.tearDown();
	}

	public void testInstance() {
		configurator = new MockConfigurator();
		assertTrue(configurator instanceof gov.va.med.hds.cd.config.IConfigurator);
	}

	public void testGetConfiguration() {
		try {
			dashConfig = new MockConfigurator().getConfiguration("gov.va.med.hds.dash", this);
		} catch (ConfigurationException e) {
			fail("ConfigurationException caught: " + e.getMessage());
		}
		assertEquals("Dashboard", dashConfig.getParameterRoot().toString());
	}
	/**
	 * @see gov.va.med.hds.cd.config.IConfigurationReadyListener#configurationReady(gov.va.med.hds.cd.config.ConfigurationReadyEvent)
	 */
	public void configurationReady(ConfigurationReadyEvent cre) {
	}
	/**
	 * @see gov.va.med.hds.cd.config.IConfigurationReadyListener#configurationCallFailed(gov.va.med.hds.cd.config.ConfigurationException)
	 */
	public void configurationCallFailed(ConfigurationException ce) {
	}

}
