package gov.va.med.hds.cd.config.test;

import gov.va.med.hds.cd.config.ConfigurationException;
import gov.va.med.hds.cd.config.IConfigDAO;
import gov.va.med.hds.cd.config.IConfiguration;
import gov.va.med.hds.cd.config.IConfigurationReadyListener;
import gov.va.med.hds.cd.config.IConfigurator;
import gov.va.med.hds.cd.config.IParameterDefinitionCallListener;
import gov.va.med.hds.cd.config.IPreferencePage;
import gov.va.med.hds.cd.config.PreferencePageException;

import java.util.HashMap;
import java.util.Map;

/**
 *
 * @author Joel Russell
 *
 * Department of Veterans Affairs
 * OI Field Office - Salt Lake City
 * Health Data Systems
 * 
 **/
class MockConfigurator implements IConfigurator {

	private static MockConfigurator instance;
	private static Map configMap = new HashMap();
	
	public MockConfigurator() {
	}
	
	public IConfiguration getConfiguration(String pluginId, int timeOut) {
		return null;
	}
	
	public IConfiguration getConfiguration(String pluginId, IConfigurationReadyListener crl) throws ConfigurationException {
		
		IConfiguration pluginConfig;
		
		if (configMap.containsKey(pluginId)) {
			pluginConfig = (MockConfiguration) configMap.get(pluginId);
		} else {
			pluginConfig = new MockConfiguration(pluginId);
			configMap.put(pluginId, pluginConfig);
		}
			
		return pluginConfig;
		
	}

	/**
	 * @see gov.va.med.hds.cd.config.IConfigurator#parameterDefinitionQuery(gov.va.med.hds.cd.config.IParameterDefinitionCallListener)
	 */
	public void parameterDefinitionQuery(IParameterDefinitionCallListener listener)
		throws ConfigurationException {
	}
	/**
	 * @see gov.va.med.hds.cd.config.IConfigurator#getPreferencePage(java.lang.String)
	 */
	public IPreferencePage getPreferencePage(String preferencePageId)
		throws PreferencePageException {
		return null;
	}

	/* (non-Javadoc)
	 * @see gov.va.med.hds.cd.config.IConfigurator#getDAO()
	 */
	public IConfigDAO getDAO() {
		// TODO Auto-generated method stub
		return null;
	}

}
