package gov.va.med.hds.cd.config.dialog;

import gov.va.med.hds.cd.config.*;

import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
/**
 *
 * @author Joel Russell
 *
 * Department of Veterans Affairs
 * OI Field Office - Salt Lake City
 * Health Data Systems
 * 
 **/
public class PreferencePageMap {
	
	private Map ppMap = new HashMap();
	
	public PreferencePageMap() {
	}
	
	public void add(String key, PreferencePage pp) {
		ppMap.put(key, pp);
	}
	
	public void remove(PreferencePage pp) {
		ppMap.remove(pp.getName());
	}
	
	public PreferencePage get(String key) {
		return (PreferencePage) ppMap.get(key);
	}
	
	public boolean containsKey(String key) {
		return ppMap.containsKey(key);
	}
	
	public int size() {
		return ppMap.size();
	}

	public FieldEditorList getDirtyEditors() {
		Iterator ppIt = ppMap.keySet().iterator();
		FieldEditorList result = new FieldEditorList();
		
		while (ppIt.hasNext()) {
			IPreferencePage preferencePage = (IPreferencePage) ppMap.get(ppIt.next());
			FieldEditorList dirtyEditors = ((PreferencePage) preferencePage).getDirtyEditors();
			
			for (int i=0; i < dirtyEditors.size(); i++) {
				result.add(dirtyEditors.get(i));
			}
		}
		
		return result;
	}
}
