package gov.va.med.hds.cd.config;

import java.awt.Dimension;
import java.awt.GridLayout;

import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.ImageIcon;
import javax.swing.JPanel;
import javax.swing.JSeparator;
import javax.swing.border.EmptyBorder;

/**
 *
 * @author Joel Russell
 *
 * Department of Veterans Affairs
 * OI Field Office - Salt Lake City
 * Health Data Systems
 * 
 **/
public class BlankFieldEditor extends FieldEditor implements IFieldEditor {

	public static final int TOP_SEPARATOR = 0;
	public static final int BOTTOM_SEPARATOR = 1;
	public static final int TOP_AND_BOTTOM_SEPARATORS = 2;
	
	public BlankFieldEditor() {
		super(new JPanel());
	}

	public BlankFieldEditor(String labelText, int topGap, int bottomGap) {
		super(new JPanel());
		this.label.setText(labelText);
		setLayout(new GridLayout());
		setBorder(new EmptyBorder(topGap, 0, bottomGap, 0));
		add(label);
	}
	
	public BlankFieldEditor(int separatorPosition, int height) {
		super(new JPanel());
		this.label.setText("");
		setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
		if (separatorPosition == TOP_SEPARATOR || (separatorPosition == TOP_AND_BOTTOM_SEPARATORS)) {
			add(new JSeparator());
		}
		add(Box.createRigidArea(new Dimension(10, height)));
		if (separatorPosition == BOTTOM_SEPARATOR || (separatorPosition == TOP_AND_BOTTOM_SEPARATORS)) {
			add(new JSeparator());
		}
	}

	public BlankFieldEditor(String labelText, int separatorPosition) {
		super(new JPanel());
		this.label.setText(labelText);
		setLayout(new GridLayout(0,1));
		if (separatorPosition == TOP_SEPARATOR || (separatorPosition == TOP_AND_BOTTOM_SEPARATORS)) {
			add(new JSeparator());
		}
		add(label);
		if (separatorPosition == BOTTOM_SEPARATOR || (separatorPosition == TOP_AND_BOTTOM_SEPARATORS)) {
			add(new JSeparator());
		}
	}

	/**
	 * @param icon
	 * @param labelText
	 * @param topGap
	 * @param bottomGap
	 */
	public BlankFieldEditor(ImageIcon icon, String labelText, int topGap, int bottomGap) {
		super(new JPanel());
		this.label.setText(labelText);
		this.label.setIcon(icon);
		this.label.setIconTextGap(10);
		setLayout(new GridLayout());
		setBorder(new EmptyBorder(topGap, 0, bottomGap, 0));
		add(label);
	}

	/**
	 * @see gov.va.med.hds.cd.config.dialog.IFieldEditor#commitChange()
	 */
	public void commitChange() {
	}

	/**
	 * @see gov.va.med.hds.cd.config.dialog.IFieldEditor#doApply()
	 */
	public void doApply() {
	}

	/**
	 * @see gov.va.med.hds.cd.config.dialog.IFieldEditor#loadDefault()
	 */
	public void loadDefault() {
	}

	/**
	 * @see gov.va.med.hds.cd.config.dialog.IFieldEditor#loadInitialValue()
	 */
	public void loadInitialValue() {
	}

}
