package gov.va.med.hds.cd.config;

import gov.va.med.hds.cd.spectrum.DoubleLookupListBox;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.DefaultListModel;
import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.JSeparator;
import javax.swing.ListModel;
import javax.swing.border.EmptyBorder;

/**
 * @author vhaislrussej
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public class BrowseListFieldLookupDialog extends JDialog {
	private DoubleLookupListBox listBox;
	private JPanel propertyPanel;
	private JPanel bottomPanel;
	private JPanel buttonPanel;
	private JButton okButton;
	private JButton cancelButton;
	private ListModel listModel;
	
	public BrowseListFieldLookupDialog(ListModel model) {
		super();
		this.listModel = model;
		initGUI();
	}
	private void initGUI() {

		setTitle("Parameter Definition Selection");
		setModal(true);
		setResizable(false);

		listBox = new DoubleLookupListBox(getRootPane(), listModel);
		propertyPanel = new JPanel();
		propertyPanel.setLayout(new BorderLayout());
		propertyPanel.add(listBox);
		setComponentSize(propertyPanel, new Dimension(500, 435));
		getContentPane().add(propertyPanel, BorderLayout.CENTER);

		bottomPanel = new JPanel();
		setComponentSize(bottomPanel, new Dimension(500, 57));
		bottomPanel.setLayout(new BorderLayout());
		bottomPanel.add(new JSeparator(), BorderLayout.NORTH);
		
		okButton = new JButton("Finish");
		setComponentSize(okButton, new Dimension(75, 27));
		okButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				doFinish();
				setVisible(false);
				dispose();
			}
		});

		cancelButton = new JButton("Cancel");
		setComponentSize(cancelButton, new Dimension(75, 27));
		cancelButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				doCancel();
				setVisible(false);
				dispose();
			}
		});
		
		buttonPanel = new JPanel();
		buttonPanel.setLayout(new BoxLayout(buttonPanel, BoxLayout.X_AXIS));
		buttonPanel.setBorder(new EmptyBorder(5, 10, 5, 10));
		buttonPanel.add(okButton);
		buttonPanel.add(Box.createRigidArea(new Dimension(10, buttonPanel.getHeight())));
		buttonPanel.add(cancelButton);
		bottomPanel.add(buttonPanel, BorderLayout.EAST);		
		getContentPane().add(bottomPanel, BorderLayout.SOUTH);

		pack();
	}

	private void doCancel() {
		// TODO
	}

	private void doFinish() {
		// TODO
	}

	private void setComponentSize(JComponent component, Dimension dimension) {
		component.setMaximumSize(dimension);
		component.setMinimumSize(dimension);
		component.setPreferredSize(dimension);
	}

	public static void main(String[] args) {
		ListModel model = new DefaultListModel();
		for (int i=0; i<1000; i++) { 
			((DefaultListModel) model).add(i, "item " + i);
		}
		
		JDialog dialog = (JDialog) new BrowseListFieldLookupDialog(model);

		dialog.addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e) {
				System.exit(0);
			}
		});
		dialog.show();
	}

}
