package gov.va.med.hds.cd.config;

import gov.va.med.hds.cd.m.CallRequest;
import gov.va.med.hds.cd.m.ICallRequest;

import java.util.EventObject;

/**
 *
 * @author Joel Russell
 *
 * Department of Veterans Affairs
 * OI Field Office - Salt Lake City
 * Health Data Systems
 * 
 **/
public class ConfigDAOEvent extends EventObject {
	private String type = null;
	private Exception exception = null;
	private Object resultObject = null;
	private ICallRequest request = null;
	
	/**
	 * Constructor for ConfigDAOEvent.
	 * @param source
	 */
	public ConfigDAOEvent(Object source) {
		super(source);
	}

	/**
	 * Constructor ConfigDAOEvent.
	 * @param mConfigDAO
	 * @param request
	 */
	public ConfigDAOEvent(Object source, ICallRequest request) {
		super(source);
		this.request = request;
	}
	
	/**
	 * @see java.util.EventObject#getSource()
	 */
	public Object getSource() {
		return super.getSource();
	}

	/**
	 * @see java.lang.Object#toString()
	 */
	public String toString() {
		return super.toString();
	}

	/**
	 * Returns the exception.
	 * @return Exception
	 */
	public Exception getException() {
		return exception;
	}

	/**
	 * Sets the exception.
	 * @param exception The exception to set
	 */
	public void setException(Exception exception) {
		this.exception = exception;
	}

	/**
	 * Returns the resultObject.
	 * @return Object
	 */
	public Object getResultObject() {
		return resultObject;
	}

	/**
	 * Sets the resultObject.
	 * @param resultObject The resultObject to set
	 */
	public void setResultObject(Object resultObject) {
		this.resultObject = resultObject;
	}

	/**
	 * Returns the request.
	 * @return CallRequest
	 */
	public ICallRequest getRequest() {
		return request;
	}

	/**
	 * Sets the request.
	 * @param request The request to set
	 */
	public void setRequest(CallRequest request) {
		this.request = request;
	}

}
