package gov.va.med.hds.cd.config;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

/**
 *
 * @author Joel Russell
 *
 * Department of Veterans Affairs
 * OI Field Office - Salt Lake City
 * Health Data Systems
 * 
 **/
public class FieldEditorList {
	
	private List feList = new ArrayList();
	
	public FieldEditorList() {
	}
	
	public void add(FieldEditor fe) {
		feList.add(fe);
	}
	
	public void remove(FieldEditor fe) {
		feList.remove(fe);
	}
	
	public void remove(int index) {
		feList.remove(index);
	}
	
	public FieldEditor get(int index) {
		return (FieldEditor) feList.get(index);
	}
	
	public FieldEditor get(FieldEditor fe) {
		return (FieldEditor) feList.get(feList.indexOf(fe));
	}

	public int size() {
		return feList.size();
	}
	
	public FieldEditorList getDirtyEditors() {
		FieldEditorList dirtyList = new FieldEditorList();
		
		Iterator feIt = feList.iterator();
		while (feIt.hasNext()) {
			FieldEditor fe = (FieldEditor) feIt.next();
			if (fe.isDirty()) {
				dirtyList.add(fe);
			}
		}
		return dirtyList;
	}
	/**
	 * Method addAll.
	 * @param fieldEditorList
	 */
	public void addAll(List fieldEditorList) {
		feList.addAll(fieldEditorList);
	}

}
