package gov.va.med.hds.cd.config;

import java.util.List;

/**
 *
 * @author Joel Russell
 *
 * Department of Veterans Affairs
 * OI Field Office - Salt Lake City
 * Health Data Systems
 * 
 **/
public interface IParameterDefinition {
	
	/**
	 * Method getDescription.
	 * @return String
	 */
	String getDescription();
	/**
	 * Method getDisplayText.
	 * @return String
	 */
	String getDisplayText();
	/**
	 * Method getEntities.
	 * @return List
	 */
	List getEntities();
	/**
	 * Method getFullName.
	 * @return String
	 */
	String getFullName();
	/**
	 * Method getId.
	 * @return long
	 */
	long getId();
	/**
	 * Method getInstanceDomain.
	 * @return String
	 */
	String getInstanceDomain();
	/**
	 * Method getInstanceHelp.
	 * @return String
	 */
	String getInstanceHelp();
	/**
	 * Method getInstanceScreenCode.
	 * @return String
	 */
	String getInstanceScreenCode();
	/**
	 * Method getInstanceTerm.
	 * @return String
	 */
	String getInstanceTerm();
	/**
	 * Method getInstanceType.
	 * @return String
	 */
	String getInstanceType();
	/**
	 * Method getInstanceValidationCode.
	 * @return String
	 */
	String getInstanceValidationCode();
	/**
	 * Method isMultiValued.
	 * @return boolean
	 */
	boolean isMultiValued();
	/**
	 * Method isProhibitEditing.
	 * @return boolean
	 */
	boolean isProhibitEditing();
	/**
	 * Method getValueDomain.
	 * @return String
	 */
	String getValueDomain();
	/**
	 * Method getValueHelp.
	 * @return String
	 */
	String getValueHelp();
	/**
	 * Method getValueScreenCode.
	 * @return String
	 */
	String getValueScreenCode();
	/**
	 * Method getValueTerm.
	 * @return String
	 */
	String getValueTerm();
	/**
	 * Method getValueType.
	 * @return String
	 */
	String getValueType();
	/**
	 * Method getValueValidationCode.
	 * @return String
	 */
	String getValueValidationCode();
	/**
	 * Method setDescription.
	 * @param description
	 */
	void setDescription(String description);
	/**
	 * Method setDisplayText.
	 * @param displayText
	 */
	void setDisplayText(String displayText);
	/**
	 * Method setEntities.
	 * @param entities
	 */
	void setEntities(List entities);
	/**
	 * Method addEntity.
	 * @param entity
	 */
	void addEntity(IEntity entity);
	/**
	 * Method removeEntity.
	 * @param index
	 */
	void removeEntity(int index);
	/**
	 * Method removeEntity.
	 * @param entity
	 */
	void removeEntity(IEntity entity);
	/**
	 * Method setFullName.
	 * @param fullName
	 */
	void setFullName(String fullName);
	/**
	 * Method setId.
	 * @param id
	 */
	void setId(long id);
	/**
	 * Method setInstanceDomain.
	 * @param instanceDomain
	 */
	void setInstanceDomain(String instanceDomain);
	/**
	 * Method setInstanceHelp.
	 * @param instanceHelp
	 */
	void setInstanceHelp(String instanceHelp);
	/**
	 * Method setInstanceScreenCode.
	 * @param instanceScreenCode
	 */
	void setInstanceScreenCode(String instanceScreenCode);
	/**
	 * Method setInstanceTerm.
	 * @param instanceTerm
	 */
	void setInstanceTerm(String instanceTerm);
	/**
	 * Method setInstanceType.
	 * @param instanceType
	 */
	void setInstanceType(String instanceType);
	/**
	 * Method setInstanceValidationCode.
	 * @param instanceValidationCode
	 */
	void setInstanceValidationCode(String instanceValidationCode);
	/**
	 * Method setMultiValued.
	 * @param multiValued
	 */
	void setMultiValued(boolean multiValued);
	/**
	 * Method setProhibitEditing.
	 * @param prohibitEditing
	 */
	void setProhibitEditing(boolean prohibitEditing);
	/**
	 * Method setValueDomain.
	 * @param valueDomain
	 */
	void setValueDomain(String valueDomain);
	/**
	 * Method setValueHelp.
	 * @param valueHelp
	 */
	void setValueHelp(String valueHelp);
	/**
	 * Method setValueScreenCode.
	 * @param valueScreenCode
	 */
	void setValueScreenCode(String valueScreenCode);
	/**
	 * Method setValueTerm.
	 * @param valueTerm
	 */
	void setValueTerm(String valueTerm);
	/**
	 * Method setValueType.
	 * @param valueType
	 */
	void setValueType(String valueType);
	/**
	 * Method setValueValidationCode.
	 * @param valueValidationCode
	 */
	void setValueValidationCode(String valueValidationCode);
	/**
	 * Method getKeyWords.
	 * @return List keyWords
	 */
	List getKeyWords();

}
