package gov.va.med.hds.cd.config;
import java.util.ArrayList;

/**
 *
 * @author Joel Russell
 *
 * Department of Veterans Affairs
 * OI Field Office - Salt Lake City
 * Health Data Systems
 * 
 **/
public interface IParameterList {
	
	/**
	 * Method setName.
	 * @param name
	 */
	void setName(String name);
	
	/**
	 * Method addParameter.
	 * @param parameter
	 */
	void addParameter(IParameter parameter);
	
	/**
	 * Method getParameter.
	 * @param index
	 * @return IParameter
	 */
	IParameter getParameter(int index);
	
	/**
	 * Method indexOf.
	 * @param parameter
	 * @return int
	 */
	int indexOf(IParameter parameter);
	
	/**
	 * Method size.
	 * @return int
	 */
	int size();
	
	/**
	 * Method toString.
	 * @return String
	 */
	String toString();
	
	/**
	 * Method parameters.
	 * @return List
	 */
	ArrayList parameters();
	
	/**
	 * Method getCategory.
	 * @return IParameterCategory
	 */
	IParameterCategory getCategory();
	
}