package gov.va.med.hds.cd.config;



/**
 *
 * @author Joel Russell
 *
 * Department of Veterans Affairs
 * OI Field Office - Salt Lake City
 * Health Data Systems
 * 
 **/
public interface IParameterTree {
	
	void setRoot(IParameterCategory root);

	Object getRoot();
	
	int getIndexOfChild(IParameterCategory parent, IParameterCategory child);

	IParameterCategory getChild(IParameterCategory parent, int index);

	int getChildCount(IParameterCategory parent);

	void reload();

	void insertNodeInto(IParameterCategory newChild,
		IParameterCategory parent);

	void insertNodeInto(IParameterCategory newChild,
		IParameterCategory parent, int index);

	void removeNodeFromParent(IParameterCategory node);

	void nodeChanged(IParameterCategory node);

	void reload(IParameterCategory node);

	void nodesWereInserted(IParameterCategory node, int[] childIndices);

	void nodesWereRemoved(IParameterCategory node, int[] childIndices,	IParameterCategory[] removedChildren);

	void nodesChanged(IParameterCategory node, int[] childIndices);
	
	void nodeStructureChanged(IParameterCategory node);

	IParameterCategory[] getPathToRoot(IParameterCategory aNode);

}
