package gov.va.med.hds.cd.config;

import gov.va.med.hds.cd.runtime.IConfigurationElement;

/**
 *
 * @author Joel Russell
 *
 * Department of Veterans Affairs
 * OI Field Office - Salt Lake City
 * Health Data Systems
 * 
 **/
public interface IPreferencePageManager {

	public static final String ID_ATTRIBUTE = "id";
	public static final String NAME_ATTRIBUTE = "name";
	public static final String CLASS_ATTRIBUTE = "class";
	public static final String CONTEXT_ATTRIBUTE = "context";
	public static final String PLUGIN_ATTRIBUTE = "plugin";
	public static final String EXTENSION_POINT_ID = "gov.va.med.hds.cd.config.preferencePage";
	public static final String PLUGIN_ID = "gov.va.med.hds.cd.config.ui";
	/**
	 * Method getPreferencePage.
	 * @param preferencePageId
	 * @return IPreferencePage
	 */
	IPreferencePage getPreferencePage(String preferencePageId) throws PreferencePageException;

	/**
	 * @return
	 */
	IConfigurationElement[] getPreferencePageElements();

}
