package gov.va.med.hds.cd.daoregistry.cookbook;

import gov.va.med.hds.cd.daoregistry.IDaoRegistry;
import gov.va.med.hds.cd.runtime.IRuntimeContext;

/**
 * This class is a code fragment to supplement the DAL Module of the
 * HealtheVet Desktop SDD. It requires a reference to a
 * IRuntimeContext which can be obtained when running inside
 * of the HealtheVet Desktop framework.
 */
public class DaoRegistryCookbook {
	private IRuntimeContext runtime;
	public DaoRegistryCookbook(IRuntimeContext runtime) {
		super();
		this.runtime = runtime;
	}
	public void getSetSomeData() throws Exception {
		// Get a reference to the DAO Registry plugin. 
		// Assume in this example that runtime is a valid IRuntime Context
		IDaoRegistry registry = (IDaoRegistry) runtime.getPluginInstance(IDaoRegistry.PLUGIN_ID);

		// Ask the DAO Registry for an instance of the implementation mapped
		// to the IMyData interface.
		IMyData dao = (IMyData) registry.getDAO(IMyData.class.getName());

		// Get data from the Data Access Object
		int workingData = dao.getData();

		// Modify the data
		workingData = 100;

		// Set data back in the data store through the Data Access Object
		dao.setData(workingData);
	}
}
