package gov.va.med.hds.cd.daoregistry.test;
import gov.va.med.hds.cd.daoregistry.IDaoRegistry;
import gov.va.med.hds.cd.runtime.PluginNotFoundException;
import gov.va.med.hds.cd.runtime.PluginStartupException;
import gov.va.med.hds.cd.runtime.test.RuntimeTestCase;

/**
 * Tests DAO registry interface
 */
public class TestDaoRegistry extends RuntimeTestCase {
	public TestDaoRegistry(String arg0) throws PluginStartupException, PluginNotFoundException {
		super(arg0);
	}
	protected void setUp() throws Exception {
		super.setUp();
		parseRegistryResource("registry.xml");
		registry = (IDaoRegistry) getRuntime().getPluginInstance(IDaoRegistry.PLUGIN_ID);
	}
	public void testCreateDaoFromRegistry() throws Exception {
		IMockDao dao = (IMockDao) registry.getDAO(IMockDao.class.getName());
		assertNotNull(dao);
		dao.setSomeData("My New Data");
		assertEquals("My New Data", dao.getSomeData());
	}
	public void testCreateDaoFromFactoryFromRegistry() throws Exception {
		IMockDaoFactory factory =
			(IMockDaoFactory) registry.getDAO(IMockDaoFactory.class.getName());
		assertNotNull(factory);
		IMockDao dao1 = factory.create(100);
		assertEquals("100", dao1.getSomeData());
		IMockDao dao2 = factory.create((Object) new Integer(1000));
		assertEquals("1000", dao2.getSomeData());
		IMockDao dao3 = factory.create("-1");
		assertEquals("-1", dao3.getSomeData());
	}
	protected void tearDown() throws Exception {
		super.tearDown();
	}
	IDaoRegistry registry;
}
