package gov.va.med.hds.cd.daoregistry.test;
import gov.va.med.hds.cd.daoregistry.IDaoRegistry;
import gov.va.med.hds.cd.runtime.logging.IHandler;
import gov.va.med.hds.cd.runtime.logging.ILogRecord;
import gov.va.med.hds.cd.runtime.logging.Level;
import gov.va.med.hds.cd.runtime.test.RuntimeTestCase;

/**
 * DAO Registry failure test
 */
public class TestDaoRegistryFail extends RuntimeTestCase {

	private ILogRecord logRecord;

	public TestDaoRegistryFail(String name) {
		super(name);
	}

	protected void setUp() throws Exception {
		super.setUp();
		parseRegistryResource("registryFail.xml");
		getRuntime().getLogger("gov.va.med.hds.cd.daoregistry").setUseParentHandlers(false);
	}

	public void testErrorsForDuplicateEntries() throws Exception {
		getRuntime().getLogger("gov.va.med.hds.cd.daoregistry").addHandler(new IHandler() {
			public void publish(ILogRecord logRecord) {
				TestDaoRegistryFail.this.logRecord = logRecord;
			}

			public void close() {
				// NOOP
			}
		});
		IDaoRegistry registry =
			(IDaoRegistry) getRuntime().getPluginInstance(IDaoRegistry.PLUGIN_ID);
		assertNotNull(logRecord);
		assertEquals(Level.ERROR, logRecord.getLevel());
	}

	protected void tearDown() throws Exception {
		getRuntime().getLogger("gov.va.med.hds.cd.daoregistry").setUseParentHandlers(true);
		super.tearDown();
	}

}
