package gov.va.med.hds.cd.daoregistry;

import gov.va.med.hds.cd.runtime.IPlugin;

/**
 * Plugin interface for obtaining a DataAccessObject from the DaoRegistry
 */
public interface IDaoRegistry extends IPlugin {
	/**
	 * dao extension point identifier
	 */
	public static final String EXTENSION_POINT_ID = "gov.va.med.hds.cd.daoregistry.dao";
	/**
	 * Plugin identifier for the DAO Registry
	 */
	public static final String PLUGIN_ID = "gov.va.med.hds.cd.daoregistry";

	/**
	 * XML tag associated with the dao extension point interface tag
	 */
	public static final String INTERFACE_NAME_ATTRIBUTE = "interfaceName";

	/**
	 * XML tag associated with the dao extension point class tag
	 */
	public static final String CLASS_NAME_ATTRIBUTE = "className";
	/**
	 * Creates a data access object given an interface string. The interface name is looked
	 * up in the DaoRegistry and the corresponding type is activated, initialized and returned
	 * 
	 * @param daoInterfaceName
	 * @return IDataAccessObject
	 * @throws DaoRegistryException
	 */
	public IDataAccessObject getDAO(String daoInterfaceName) throws Exception;
}
