/*
 * Created on May 20, 2003
 *
 * Department of Veterans Affairs
 * OI Field Office - Salt Lake City
 * Health Data Systems
 * 
 */
package gov.va.med.hds.dashboard.dao.m;

import java.util.Iterator;

import gov.va.med.hds.cd.runtime.IConfigurationElement;
import gov.va.med.hds.cd.runtime.IRuntimeContext;
import gov.va.med.hds.dashboard.IDashboardPlugin;
import gov.va.med.hds.dashboard.clinician.ClinicianDashboardPlugin;
import gov.va.med.hds.dashboard.items.IDashboardEntry;
import gov.va.med.hds.dashboard.items.IItemEntry;

/**
 *
 * Department of Veterans Affairs
 * OI Field Office - Salt Lake City
 * Health Data Systems
 * 
 * @author vhaislschras
 */
public class ClinicianPatientListDAO extends AbstractPatientDAO
{
  protected static final String DASHBOARD_PATIENT_LIST = "PHY DASHBD PATIENTS";
  protected static final String DASHBOARD_TYPE = "C"; // Clinician
  protected static final String DASHBOARD_PERSPECTIVE_OPTION_NAME = "ORRCMM CLINICIAN";

	/* (non-Javadoc)
	 * @see gov.va.med.hds.cd.runtime.IExecutableExtension#setInitializationData(gov.va.med.hds.cd.runtime.IRuntimeContext, gov.va.med.hds.cd.runtime.IConfigurationElement, java.lang.String, java.lang.Object)
	 */
	public void setInitializationData(IRuntimeContext runtime, IConfigurationElement config, String propertyName, Object data)
		throws Exception
	{
    super.setInitializationData(runtime, config, propertyName, data);
    dashboardPatientList = DASHBOARD_PATIENT_LIST;
    dashboardType = DASHBOARD_TYPE;
    dashboardOptionName = DASHBOARD_PERSPECTIVE_OPTION_NAME;
    
    IDashboardPlugin plugin = (IDashboardPlugin)runtime
      .getPluginInstance(ClinicianDashboardPlugin.PLUGIN_ID);

    Iterator iter = plugin.getItemTypes(); 
    while (iter.hasNext())
    {
      IItemEntry item = (IItemEntry)((IDashboardEntry)iter.next()).getItemEntry();
      itemTypes.put(item.getItemShortId(), item);
      if (ITEM_TYPE_ID.equals(item.getItemType()))
        patientItem = item;
    }
	}

}
