/*
 * Created on May 20, 2003
 *
 * Department of Veterans Affairs
 * OI Field Office - Salt Lake City
 * Health Data Systems
 * 
 */
package gov.va.med.hds.dashboard.itemtype;

import gov.va.med.hds.cd.runtime.IConfigurationElement;
import gov.va.med.hds.cd.runtime.IRuntimeContext;
import gov.va.med.hds.dashboard.IDashboardPlugin;
import gov.va.med.hds.dashboard.clinician.ClinicianDashboardPlugin;
import gov.va.med.hds.dashboard.items.IDashboardItemTypes;

/**
 *
 * Department of Veterans Affairs
 * OI Field Office - Salt Lake City
 * Health Data Systems
 * 
 * @author vhaislschras
 */
public class ClincianDashboardPatient extends AbstractDashboardPatient
{
  public static final String ITEM_TYPE_ID = "dashboard.clinician.patient";
  
	/* (non-Javadoc)
	 * @see gov.va.med.hds.cd.runtime.IExecutableExtension#setInitializationData(gov.va.med.hds.cd.runtime.IRuntimeContext, gov.va.med.hds.cd.runtime.IConfigurationElement, java.lang.String, java.lang.Object)
	 */
	public void setInitializationData(IRuntimeContext runtime, IConfigurationElement config, String propertyName, Object data)
		throws Exception
	{
    super.setInitializationData(runtime, config, propertyName, data);
    IDashboardItemTypes itemTypes = (IDashboardItemTypes)runtime.getPluginInstance(IDashboardItemTypes.PLUGIN_ID);
    dashDef = itemTypes.getDashboardDefinition(ClinicianDashboardPlugin.PLUGIN_MODULE);
    itemEntry = dashDef.getDefinition(ITEM_TYPE_ID).getItemEntry();
    patientURL = itemEntry.getURL();
    
    plugin = (IDashboardPlugin)runtime.getPluginInstance(ClinicianDashboardPlugin.PLUGIN_ID);
	}

}
