package gov.va.med.hds.dashboard;
import gov.va.med.hds.dashboard.items.IDashboardItem;
/**
 * @author VHAISLSCHRAS
 *
 * Department of Veterans Affairs
 * OI Field Office - Salt Lake City
 * Health Data Systems
 * 
 * @version 
 */
public class DashboardIconView
{
  private String itemType = "Item";
  private Integer iconValue = IDashboardItem.NOTHING;
  private int itemCount = 0;
  private boolean acknowledged = false;

  public boolean typeEquals(Integer type)
  {
    return type.equals(iconValue);
  }
  
  public void setItemType(String itemType)
  {
    this.itemType = itemType;
  }
  
  public String getItemType()
  {
    return itemType;
  }
  
  public void setIconValue(Integer iconValue)
  {
    if (iconValue.equals(IDashboardItem.ACKNOWLEDGED))
      setAcknowledged(true);
    else
      this.iconValue = iconValue;
  }
  
  public void setAcknowledged(boolean b)
  {
    this.acknowledged = b;
  }
  
  public void setItemCount(int itemCount)
  {
    this.itemCount = itemCount;
  }
  
  public int getItemCount()
  {
    return itemCount;
  }
  
  public boolean isCritical()
  {
    return iconValue.equals(IDashboardItem.CRITICAL);
  }
  
  public boolean isNormal()
  {
    return iconValue.equals(IDashboardItem.NORMAL);
  }
  
  public boolean isAcknowledged()
  {
    return acknowledged;
  }
  
  /* (non-Javadoc)
   * @see java.lang.Object#toString()
   */
  public String toString()
  {
    return (isCritical() ? "critical" :
           (isNormal() ? "normal" : "nothing")) +
           (isAcknowledged() ? " acknowledged" : "");
  }

}
