/*
 * Created on Apr 14, 2003
 *
 * Department of Veterans Affairs
 * OI Field Office - Salt Lake City
 * Health Data Systems
 * 
 */
package gov.va.med.hds.dashboard.itemtype;

import java.util.Date;

import gov.va.med.hds.task.data.ITask;

/**
 * Department of Veterans Affairs
 * OI Field Office - Salt Lake City
 * Health Data Systems
 * 
 * @author vhaislschras
 */
public class DashboardTaskItem extends AbstractDashboardItem
{
  public static final String ITEM_TYPE_ID = "dashboard.task";  

  public DashboardTaskItem()
  {
    itemTypeID = ITEM_TYPE_ID;
  }
  
  /* (non-Javadoc)
   * @see gov.va.med.hds.dashboard.itemtype.IDashboardItem#getDate()
   */
  public Date getDate()
  {
    return (null != data ? ((ITask)data).getDueDate() : super.getDate());
  }

  /* (non-Javadoc)
   * @see gov.va.med.hds.dashboard.itemtype.IDashboardItem#getFormattedDate()
   */
  public String getFormattedDate()
  {
    Date dueDate = getDate();
    return (null != dueDate ? dateOutputFormat.format(dueDate) : "");
  }

  /* (non-Javadoc)
   * @see gov.va.med.hds.dashboard.itemtype.IDashboardItem#getTitle()
   */
  public String getTitle()
  {
    return ((ITask)data).getSubject();
  }

  /* (non-Javadoc)
   * @see gov.va.med.hds.dashboard.itemtype.IDashboardItem#isComplete()
   */
  public boolean isComplete()
  {
    return (null != data ? null != ((ITask)data).getCompletingUserID() : super.isComplete());
  }

  /* (non-Javadoc)
   * @see gov.va.med.hds.dashboard.itemtype.IDashboardItem#isCritical()
   */
  public boolean isCritical()
  {
    return (null != data ? "High".equals(((ITask)data).getPriority()) : super.isCritical());
  }

  /* (non-Javadoc)
   * @see gov.va.med.hds.dashboard.itemtype.IDashboardItem#isDirty()
   */
  public boolean isDirty()
  {
    return (null != data ? ((ITask)data).isDirty() : super.isDirty());
  }

  public void setCritical(String priority)
  {
    super.setCritical("High".equals(priority));
  }
  
  public void setData(Object data)
  {
    ITask task = (ITask)data;
    setCritical(task.getPriority());
    setComplete(null != task.getCompletingUserID());
  }

}
