/*
 * Created on Apr 25, 2003
 *
 * Department of Veterans Affairs
 * OI Field Office - Salt Lake City
 * Health Data Systems
 * 
 */
package gov.va.med.hds.dashboard;

import java.util.Iterator;

import gov.va.med.hds.cd.daoregistry.IDataAccessObject;
import gov.va.med.hds.dashboard.dao.IDashboardItemDAO;
import gov.va.med.hds.dashboard.items.IDashboardEntry;
import gov.va.med.hds.dashboard.items.IItemEntry;

/**
 *
 * Department of Veterans Affairs
 * OI Field Office - Salt Lake City
 * Health Data Systems
 * 
 * @author vhaislschras
 */
public class ItemDAOUpdater
{
  public void updateDirtyItems(Iterator itemTypes, boolean flush) throws Exception
  {
    while (itemTypes.hasNext())
    {
      IDashboardEntry entry = (IDashboardEntry)itemTypes.next();
      IItemEntry itemEntry = entry.getItemEntry();
      if (flush || !itemEntry.requiresSignature())
      {
        IDataAccessObject dao = itemEntry.getItemDAOInstance();
        if (dao instanceof IDashboardItemDAO)
          ((IDashboardItemDAO)dao).updateItems(flush);
      }
    } 
  }
}
