/*
 * Created on Apr 30, 2003
 *
 * Department of Veterans Affairs
 * OI Field Office - Salt Lake City
 * Health Data Systems
 * 
 */
package gov.va.med.hds.dashboard;

import java.util.Iterator;
import java.util.List;

import gov.va.med.hds.util.collections.ListUtil;

/**
 *
 * Department of Veterans Affairs
 * OI Field Office - Salt Lake City
 * Health Data Systems
 * 
 * @author vhaislschras
 */
public class PatientList
{
  private boolean defaultList = false;
  public List listIDs;
  public String listName;
  
  public PatientList(String listName, List listIDs)
  {
    this.listIDs = listIDs;
    this.listName = listName;
  }

  public PatientList(String listName, List listIDs, boolean defaultList)
  {
    this(listName, listIDs);
    this.defaultList = defaultList;
  }

  public boolean isNull()
  {
    return (null == listIDs);
  }
  
  public String toXML()
  {
    if (null != listIDs)  // There should only be one entry with a null list - the "New List..."
                          // which is not stored in the parameter file, but added dynamically.
    {
      StringBuffer xml = new StringBuffer("<list name=\"" + listName + "\"" +
        (isDefault() ? " default=\"true\"" : "")  +">" + "\n");
      for (Iterator iter = listIDs.iterator(); iter.hasNext();)
        xml.append("<source id=\"" + (String)iter.next() + "\"/>" + "\n");
      xml.append("</list>" + "\n");
      return xml.toString();
    }
    return "";
  }
    
  public String toString()
  {
    return listName;
  }
  /* (non-Javadoc)
   * @see java.lang.Object#equals(java.lang.Object)
   */
  public boolean equals(Object obj)
  {
    if (!(obj instanceof PatientList))
      return false;
      
    return ListUtil.equals(listIDs,((PatientList)obj).listIDs);
  }
  
  public boolean isDefault()
  {
    return defaultList;
  }

}
