/*
 * Created on Mar 31, 2003
 *
 * To change this generated comment go to 
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package gov.va.med.hds.dashboard.ui;

import java.awt.Color;
import java.awt.Component;
import java.awt.Graphics;

import javax.accessibility.AccessibleContext;
import javax.swing.Icon;
import javax.swing.JTable;
import javax.swing.table.DefaultTableCellRenderer;
import javax.swing.table.TableColumn;

import gov.va.med.hds.dashboard.IDashPatients;
import gov.va.med.hds.dashboard.ui.IndicatorRendererX;

/**
 * Department of Veterans Affairs
 * OI Field Office - Salt Lake City
 * Health Data Systems
 * 
 * @author vhaislschras
 */
public class HeaderRendererX extends DefaultTableCellRenderer
{
  public static final Color HEADER_COLOR = IndicatorRendererX.DARK_BLUE;
  private Color             lineColor = HEADER_COLOR;

  public HeaderRendererX()
  {
    super();

    // Create a gap between the line and the text
    setIcon(new Icon()
      {
        public void paintIcon(Component c, Graphics g, int x, int y) {}

        public int getIconWidth()
        {
          return 3;
        }

        public int getIconHeight()
        {
          return 1;
        }
      });
    setIconTextGap(0);

    // Set the background and foreground colors
    setBackground(HEADER_COLOR);
    setForeground(Color.white);
  }

  public void setLineColor(Color lineColor)
  {
    this.lineColor = lineColor;
  }

  public Component getTableCellRendererComponent(JTable table, Object value, boolean isSelected, boolean hasFocus, int row,
    int column)
  {
    HeaderRendererX result = (HeaderRendererX)super.getTableCellRendererComponent(table, value, isSelected, hasFocus, row, column);
    TableColumn    tc = table.getTableHeader().getColumnModel().getColumn(column);
    AccessibleContext ac = result.getAccessibleContext();
    ac.setAccessibleDescription("Dashboard " + value.toString() + " column");
    ac.setAccessibleName(value.toString());

    if(0 == (column % ((IDashPatients)table).getNumDataCols()))
    {
      tc.setResizable(true);
      result.setLineColor(Color.black);
      result.setHorizontalAlignment(LEFT);
    }
    else
    {
      tc.setResizable(false);

      int width = (int)result.getPreferredSize().getWidth();
      tc.setMinWidth(width);
      tc.setPreferredWidth(width);
      tc.setMaxWidth(width);
      result.setLineColor(HEADER_COLOR);
      result.setHorizontalAlignment(CENTER);
    }

    return result;
  }

  public void paint(Graphics g)
  {
    super.paint(g);
    g.setColor(lineColor);
    g.drawLine(0, 0, 0, getHeight());
  }
}
