package gov.va.med.hds.dashboard.ui;

import gov.va.med.hds.cd.config.PreferencePage;

import java.awt.BorderLayout;
import java.awt.event.KeyEvent;

import javax.swing.border.EmptyBorder;

/**
 * Master preference page container for all the nursing dashboard dates preference pages.
 **/
public class NurseDashboardDatesPreferencePage extends PreferencePage {

	private String name;

	public NurseDashboardDatesPreferencePage() {
	}

	public void initializeFieldEditors() {
		setBorder(new EmptyBorder(5, 0, 0 , 0));

		NurseResultDatesPreferencePage nrdpp = new NurseResultDatesPreferencePage();
		nrdpp.setParameterCategory(getParameterCategory());
		nrdpp.setRuntime(getRuntime());
		nrdpp.initializeFieldEditors();
		addTab("Results", nrdpp, KeyEvent.VK_R);

		NurseEventDatesPreferencePage nedpp = new NurseEventDatesPreferencePage();
		nedpp.setParameterCategory(getParameterCategory());
		nedpp.setRuntime(getRuntime());
		nedpp.initializeFieldEditors();
		addTab("Events", nedpp, KeyEvent.VK_E);

		NurseOrderDatesPreferencePage nodpp = new NurseOrderDatesPreferencePage();
		nodpp.setParameterCategory(getParameterCategory());
		nodpp.setRuntime(getRuntime());
		nodpp.initializeFieldEditors();
		addTab("Orders", nodpp, KeyEvent.VK_O);

		NurseVitalsDatesPreferencePage nvdpp = new NurseVitalsDatesPreferencePage();
		nvdpp.setParameterCategory(getParameterCategory());
		nvdpp.setRuntime(getRuntime());
		nvdpp.initializeFieldEditors();
		addTab("Vitals", nvdpp, KeyEvent.VK_V);

		initGUI(new BorderLayout());
	}

	public void setName(String name) {
		this.name = name;
	}

	public String getName() {
		return name;
	}

}
