package gov.va.med.hds.dashboard.ui;

import gov.va.med.hds.cd.config.BlankFieldEditor;
import gov.va.med.hds.cd.config.ComboBoxFieldEditor;
import gov.va.med.hds.cd.config.PreferencePage;
import gov.va.med.hds.dashboard.PatientListSources;

import javax.swing.BoxLayout;
import javax.swing.ImageIcon;
import javax.swing.border.EmptyBorder;

/**
 *
 * @author Joel Russell
 *
 * Department of Veterans Affairs
 * OI Field Office - Salt Lake City
 * Health Data Systems
 * 
 **/
public class NurseDashboardPreferencePage extends PreferencePage {

	private String name;
	private ComboBoxFieldEditor defaultPatientList;

	public NurseDashboardPreferencePage() {

		setBorder(new EmptyBorder(10, 10, 10, 10));

		//		try {
		//			defaultPatientList =
		//				new ComboBoxFieldEditor(
		//					"Open to Patient List:",
		//					new EmptyBorder(0, 0, 0, 0));
		//			addFieldEditor(defaultPatientList);
		//		} catch (ComboBoxFieldEditorException e) {
		//			// TODO Auto-generated catch block
		//			e.printStackTrace();
		//		}

		addFieldEditor(
			new BlankFieldEditor(
				new ImageIcon(getClass().getResource("underConstruction.png")),
				"Coming Soon: Nurse Dashboard Preference Page",
				10,
				10));

		int padTo = 30 - fieldEditors.size();
		for (int i = 0; i < padTo; i++) {
			addFieldEditor(new BlankFieldEditor());
		}

		initGUI(new BoxLayout(this, BoxLayout.Y_AXIS));
	}

	/**
	 * @see gov.va.med.hds.cd.config.dialog.IPreferencePage#initializeFieldEditors()
	 */
	public void initializeFieldEditors() {
		//		defaultPatientList.setComboBoxModel(buildPatientListModel());
	}

	/**
	 * @return
	 */
	private Object[] buildPatientListModel() {
		PatientListSources sources = new PatientListSources(getRuntime());
		return sources.readConfiguration(configuration).toArray();
	}

	/**
	 * @see java.awt.Component#setName(String)
	 */
	public void setName(String name) {
		this.name = name;
	}

	/**
	 * @see java.awt.Component#getName()
	 */
	public String getName() {
		return name;
	}

}
