/*
 * Created on Mar 27, 2003
 *
 * To change this generated comment go to 
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package gov.va.med.hds.dashboard.ui.scriptlet;

import java.io.IOException;

//import javax.swing.JComponent;
import javax.swing.JToggleButton;
import javax.swing.text.AttributeSet;
import javax.swing.text.BadLocationException;
import javax.swing.text.Element;
import javax.swing.text.StyleConstants;
import javax.swing.text.html.HTML;

import gov.va.med.hds.cd.runtime.IRuntimeContext;
import gov.va.med.hds.cd.spectrum.dhtml.DHTMLDocument;
import gov.va.med.hds.cd.spectrum.dhtml.scriptlet.IScriptlet;
import gov.va.med.hds.cd.spectrum.dhtml.scriptlet.IScriptletEvent;
import gov.va.med.hds.dashboard.dao.IDashboardItemDAO;
import gov.va.med.hds.dashboard.items.IDashboardItem;
import gov.va.med.hds.dashboard.items.IDashboardItemTypes;
import gov.va.med.hds.signature.ISignableItem;

/**
 * Department of Veterans Affairs
 * OI Field Office - Salt Lake City
 * Health Data Systems
 * 
 * @author vhaislschras
 */
public class DisableCheckboxScriptlet implements IScriptlet
{
  IDashboardItemDAO itemsDAO = null;

  /* (non-Javadoc)
   * @see gov.va.med.hds.cd.spectrum.dhtml.scriptlet.IScriptlet#init(gov.va.med.hds.cd.spectrum.dhtml.scriptlet.IScriptletEvent)
   */
  public void init(IScriptletEvent event)
  {
    if (IScriptletEvent.DOCUMENT_LOADED == event.getType())
//      disableAllCheckboxes(event, event.getDocument().getDefaultRootElement());
      disableSignedCheckboxes(event, event.getDocument().getDefaultRootElement());
    if (IScriptletEvent.SUBDOCUMENT_LOADED == event.getType())
    {
      AttributeSet attrs = event.getElement().getAttributes();
      String id = (String)attrs.getAttribute(HTML.Attribute.ID);
      String itemType = (String)attrs.getAttribute("itemtype");
      boolean enable = new Boolean((String)attrs.getAttribute("enable")).booleanValue();
      if (enable)
        enableCheckbox(event, id, itemType);
    }
  }

  public void disableCheckboxes(IScriptletEvent event)
  {
    disableAllCheckboxes(event, event.getDocument().getDefaultRootElement());  
  }
  
  private void enableCheckbox(IScriptletEvent event, String id, String itemType)
  {
    String itemID = id.split("_")[1];
    String ckID = "ck_" + itemID;
//    Element node = event.getDocument().getElement(ckID);
    IDashboardItem item = getItem(event, itemID, itemType);
    item.setViewed(true);
    setEnable(event, true, ckID);
  }
  
//  private void disableUnviewedCheckboxes(IScriptletEvent event, Element node)
//  {
//    if (node.isLeaf())
//    {
//      String name = node.getName();
//      if (name.equalsIgnoreCase("input"))
//      {
//        AttributeSet attrs = node.getAttributes();
//        if ("checkbox".equalsIgnoreCase((String)attrs.getAttribute(HTML.Attribute.TYPE)))
//        {
//          String id = (String)attrs.getAttribute(HTML.Attribute.ID);
//          IDashboardItem item = getItem(event, id.split("_")[1], (String)attrs.getAttribute("itemtype"));
//          setEnable(event, item.isViewed(), id);
//        }
//      }
//    }
//    else
//    {
//      for (int i=0; i<node.getElementCount(); i++)
//        disableUnviewedCheckboxes(event, node.getElement(i));
//    }
//  }
  
  private void disableAllCheckboxes(IScriptletEvent event, Element node)
  {
    if (node.isLeaf())
    {
      String name = node.getName();
      if (name.equalsIgnoreCase("input"))
      {
        AttributeSet attrs = node.getAttributes();
        if ("checkbox".equalsIgnoreCase((String)attrs.getAttribute(HTML.Attribute.TYPE)))
        {
          String id = (String)attrs.getAttribute(HTML.Attribute.ID);
          setEnable(event, false, id);
        }
      }
    }
    else
    {
      for (int i=0; i<node.getElementCount(); i++)
        disableAllCheckboxes(event, node.getElement(i));
    }
  }
  
  private void disableSignedCheckboxes(IScriptletEvent event, Element node)
  {
    if (node.isLeaf())
    {
      String name = node.getName();
      if (name.equalsIgnoreCase("input"))
      {
        AttributeSet attrs = node.getAttributes();
        if ("checkbox".equalsIgnoreCase((String)attrs.getAttribute(HTML.Attribute.TYPE)))
        {
          String id = (String)attrs.getAttribute(HTML.Attribute.ID);
          if (null != id) // The id can be null if the checkbox is a 'All' checkbox.
          {
            IDashboardItem item = getItem(event, id.split("_")[1], (String)attrs.getAttribute("itemtype"));
            setEnable(event, !((ISignableItem)item).isSigned(), id);
          }
        }
      }
    }
    else
    {
      for (int i=0; i<node.getElementCount(); i++)
      disableSignedCheckboxes(event, node.getElement(i));
    }
  }
  
  private void setEnable(IScriptletEvent event, boolean enable, String id)
  {
    Element node = event.getDocument().getElement(id);
    AttributeSet attrs = node.getAttributes();
    JToggleButton.ToggleButtonModel model = (JToggleButton.ToggleButtonModel) attrs.getAttribute(StyleConstants.ModelAttribute);
    model.setEnabled(enable);
  }
  
  /**
   * Add a checkbox and label as a child of the a tag whose id attribute is
   * 'ckplace_<i>itemID</i>'.  If there is a scriptlet associated with the onChange
   * event of the checkbox, the name of the method is stored as a ClientProperty of 
   * the DHTMLPane.  The key is &quot;gov.va.med.hds.dashboard.CheckBoxScriptlet.<i>itemType</i>&quot;.
   * The parameters for to the scriptlet will always be ('ck_<i>itemID</id>', <i>itemType</i>) where
   * @param event - the IScriptleEvent object
   * @param id - the ID of the deferredsrc DIV in the form <i>discriminator</i>_<i>itemID</i>
   * @param itemType - the type of the item.  One of :
   * <ul>
   * <li>IDashItem.DASH_RESULT</li>
   * <li>IDashItem.DASH_TASK</li>
   * <li>IDashItem.DASH_EVENT</li>
   * <li>IDashItem.DASH_UNSIGNEDITEM</li>
   * </ul>
   */
  protected void showAckCheckbox(IScriptletEvent event, String id, String itemType)
  {
    boolean checked = false;
    String[] itemId = {id.split("_")[1]};
    getItemDAO(event, itemType);
    IDashboardItem item = (IDashboardItem)itemsDAO.getItems(itemId).get(0);
    if (item.isViewed())
      return;
    item.setViewed(true);
    checked = item.isComplete();

    DHTMLDocument doc = event.getDocument();
    Element outter = doc.getElement("ckplace_" + itemId[0]);
    if (null != outter)
    {
//      JComponent pane = event.getPane();
      String scriptlet = (String)event.getPane().getClientProperty("gov.va.med.hds.dashboard.CheckBoxScriptlet." + itemType);
      String onChange = "";
      if (null != scriptlet && 0 < scriptlet.length())
        onChange = " onChange=\"" + scriptlet + "('ck_" + itemId[0] + "', '" + itemType + "')\"";
      String inner = "<div><input disabled type='checkbox' id='ck_" + itemId[0] + "'" +
        onChange +  
        (checked ? " checked" : "") +
        ">&nbsp Add to Sign List&nbsp</div>";
      try
      {
        doc.setInnerHTML(outter, inner);
      }
      catch (IOException ioe)
      {
		IRuntimeContext runtime = (IRuntimeContext)event.getEnvironment();
		runtime.getLogger(this.getClass()).error(ioe.getLocalizedMessage(), ioe);
      }
      catch (BadLocationException ble)
      {
		IRuntimeContext runtime = (IRuntimeContext)event.getEnvironment();
		runtime.getLogger(this.getClass()).error(ble.getLocalizedMessage(), ble);
      }
    }
  }

  private IDashboardItem getItem(IScriptletEvent event, String id, String itemType)
  {
    getItemDAO(event, itemType);
    return (IDashboardItem)itemsDAO.getItem(id);
  }
  
  private void getItemDAO(IScriptletEvent event, String itemType)
  {
    IRuntimeContext runtime = (IRuntimeContext)event.getEnvironment();
    if (null == itemsDAO)
      try
      {
        IDashboardItemTypes types = (IDashboardItemTypes)runtime.getPluginInstance(IDashboardItemTypes.PLUGIN_ID);
        itemsDAO = (IDashboardItemDAO)types.getItemType(itemType).getItemDAOInstance();
      }
      catch (Exception e)
      {
        runtime.getLogger(this.getClass()).error(e.getLocalizedMessage(), e);
      }
  }  

}
