/*
 * Created on Apr 9, 2003
 *
 * To change this generated comment go to 
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package gov.va.med.hds.dashboard;

import java.util.EventObject;

import javax.swing.JTable;

/**
 * @author vhaislschras
 * 
 * Department of Veterans Affairs
 * OI Field Office - Salt Lake City
 * Health Data Systems
 *
 * Describes an event that occurs on the Dashboard patient list table. 
 */
public class DashTableEvent extends EventObject
{
  int row;
  int column;
  
  /**
   * Constructor for a DashTableEvent
   * @param source the JTable object on which the event occurred.
   */
	public DashTableEvent(JTable source) {
		super(source);
		this.row = source.getSelectedRow();
		this.column = source.getSelectedColumn();
	}

  /**
   * Gets the row on which the event occurred.
   * @return the event row.
   */
  public int getRow()
  {
    return row;
  }

  /**
   * Gets the column on which the event occurred.
   * @return the event column.
   */
  public int getColumn()
  {
    return column;
  }

  /**
   * Gets the value at the row and column at which the event occurred.
   * @return the value at the row and column of the event.
   */
  public Object getValue()
  {
    return ((JTable) getSource()).getValueAt(row, column);
  }

}
