/*
 * Created on Mar 31, 2003
 *
 * To change this generated comment go to 
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package gov.va.med.hds.dashboard;

import javax.swing.table.TableModel;

/**
 * @author vhaislschras
 * 
 * Department of Veterans Affairs
 * OI Field Office - Salt Lake City
 * Health Data Systems
 *
 * <p>The dashboard table model is defined a table with the patient list as the first column
 * and one or more item types as subsequent columns.  This can be displayed as multiple occurances
 * (horizontally) like newpaper columns.  The methods in this interface are intended to expose
 * the underlying table mode.</p>  
 */
public interface IDashPatients
{
  /**
   * Gets the number of columns in the underlying table model.
   * @return the number of columns in the underlying table model.
   */
  public int getNumDataCols();

  /**
   * Gets the underlying table model.
   * @return the underlying table model.
   */
  public TableModel getInternalModel();
  
}
