/*
 * Created on Mar 31, 2003
 *
 * To change this generated comment go to 
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package gov.va.med.hds.dashboard;

import java.util.Iterator;

import javax.swing.JComponent;

import gov.va.med.hds.cd.prism.IDesktop;
import gov.va.med.hds.cd.runtime.IPlugin;
import gov.va.med.hds.dashboard.items.IDashboardEntry;

/**
 * @author vhaislschras
 * 
 * Department of Veterans Affairs
 * OI Field Office - Salt Lake City
 * Health Data Systems
 *
 * Interface for a dashboard plugin. 
 */
public interface IDashboardPlugin extends IPlugin
{
  public static final String PLUGIN_ID = "dashboard.plugin";

  /**
   * Returns the patient list component (the dashboard itself) for the current dashboard perspective.
   * Typically the patient list table is the child of a JScrollPane component.
   * To retrieve the patient list component you must get the
   * ((JScrollPane)component).getViewport().getView() of the returned JComponent.
   * @return a JComponent that is the patient list.
   */
  public JComponent getPatientListComponent();

  /**
   * Returns the detail component for the current dashboard perspective.
   * Typically the patient list table is the child of a JScrollPane component.
   * To retrieve the patient list component you must get the
   * ((JScrollPane)component).getViewport().getView() of the returned JComponent.
   * @return a JComponent that is the detail component.
   */
  public JComponent getDetailPaneComponent();

  /**
   * Gets the number of item types defined by this dashboard.
   * @return the number of item types.
   */
  public int getItemTypeCount();

  /**
   * Gets the number of item types that will be displayed in the dashboard patient list table.
   * This value is not necessarily the same as getItemTypeCount because some item types defined
   * for the dashboard may not be displayed in a separate column.
   * @return the number of columns for the dashboard.
   */
  public int getHeaderCount();

  /**
   * Gets an iterator for the item types included in this dashboard.  The elements of the iterator
   * are of type gov.va.med.hds.dashboard.items.IDashboardEntry.
   * @return an iterator for the item types included in this dashboard.
   * @see gov.va.med.hds.dashboard.items.IDashboardEntry
   */
  public Iterator getItemTypes();
  
  public IDashboardEntry getDashboardItemDefinition(String id);

  public Object getUser();
  
  public IDesktop getDesktop();
  
  public String getPluginID();
  
  public String getModuleID();
  
  public boolean hasPermission(String permission);
  
}
