/*
 * Created on Apr 26, 2003
 *
 * Department of Veterans Affairs
 * OI Field Office - Salt Lake City
 * Health Data Systems
 * 
 */
package gov.va.med.hds.dashboard;

import java.util.Set;

import javax.security.auth.Subject;

import gov.va.med.hds.cd.m.IMumpsUserInfo;

/**
 *
 * Department of Veterans Affairs
 * OI Field Office - Salt Lake City
 * Health Data Systems
 * 
 * @author vhaislschras
 */
public class ResolveUserId
{
  /**
   * Resolves a user identifier.  If the argument type is a javax.security.Subject object
   * this method will get the 'M' user id out of the object.  Otherwise, the method returns
   * the value of the <pre>toString()</pre> method of the object.
   * 
   * @param userID A javax.security.Subject object.
   * @return A String object containing the user's ID.
   */
  static public String resolveUser(Object userID)
  {
    if (userID instanceof Subject)
      try {
        Subject subject = (Subject) userID;
        Set principals = subject.getPrincipals(IMumpsUserInfo.class);
        IMumpsUserInfo uinfo = (IMumpsUserInfo) principals.iterator().next();
        return uinfo.getDuz();
      }
      catch (Exception e) {}
    if (userID == null)
      return null;
    else
      return userID.toString();
  }

}
