/*
 * Created on May 28, 2003
 *
 * Department of Veterans Affairs
 * OI Field Office - Salt Lake City
 * Health Data Systems
 * 
 */
package gov.va.med.hds.dashboard;

import java.awt.Component;

import javax.swing.Box;
import javax.swing.JLabel;
import javax.swing.JTextPane;
import javax.swing.SwingConstants;

/**
 *
 * Department of Veterans Affairs
 * OI Field Office - Salt Lake City
 * Health Data Systems
 * 
 * @author vhaislschras
 */
public class SensitivePatient extends Exception
{
  private int status;
  public SensitivePatient(String message, int status)
  {
    super(message);
    this.status = status;
  }
  
  public int getStatus()
  {
    return status;
  }
  
  public Object restrictedRecordMessage()
  {
    Box box = Box.createVerticalBox();

    String [] msgs = getLocalizedMessage().split("\n", 3);
    for (int i = 0; i < msgs.length; i++)
    {
      String segment = msgs[i].trim();
      if (-1 != segment.indexOf("WARNING") ||
          -1 != segment.indexOf("ERROR") ||
          -1 != segment.indexOf("RESTRICTED RECORD"))
      {
        JLabel header = new JLabel(segment, SwingConstants.CENTER);
        header.setAlignmentX(Component.CENTER_ALIGNMENT);
        box.add(header);
      }
      else
      {
        JTextPane msg = new JTextPane();
        msg.setBackground(box.getBackground());
        msg.setText(segment.replaceAll("\\*", "").replaceAll("\\p{Blank}+\n", "\n") +
          (2 == status ? "\nDo you want to continue processing this patient?" : ""));
        msg.setEditable(false);
        msg.setFocusable(false);
        box.add(msg);
      }
    }
    return box;
  }

}
