package gov.va.med.hds.dashboard.action;

import java.awt.event.ActionEvent;
import java.awt.event.KeyEvent;

import javax.swing.JComboBox;
import javax.swing.JTable;
import javax.swing.KeyStroke;
import javax.swing.event.EventListenerList;

import gov.va.med.hds.cd.spectrum.EditableTableHeader;
import gov.va.med.hds.dashboard.DashTableEvent;
import gov.va.med.hds.dashboard.IDashTableListener;
import gov.va.med.hds.dashboard.IDashboardPlugin;

public class RefreshDashboardAction extends AbstractDashboardAction {

	private static final Integer DEFAULT_MNEMONIC = new Integer(KeyEvent.VK_R);
	private static final KeyStroke DEFAULT_ACCELERATOR =
		KeyStroke.getKeyStroke(KeyEvent.VK_F5, 0);

	private EventListenerList listenerList = new EventListenerList();

	public RefreshDashboardAction() {
		putValue(MNEMONIC_KEY, DEFAULT_MNEMONIC);
    putValue(ACCELERATOR_KEY, DEFAULT_ACCELERATOR);
	}

	protected void actionPerformed(
		ActionEvent e,
		IDashboardPlugin dashboardPlugin)
		throws Exception {
		JTable patientListTable = getPatientList();
		if (null != patientListTable) {
			EditableTableHeader header =
				(EditableTableHeader) patientListTable.getTableHeader();
			JComboBox editor = (JComboBox) header.getHeaderEditor(0);
			editor.setSelectedIndex(editor.getSelectedIndex());
			fireTableChanged();
		}
	}

	public void addDashTableListener(IDashTableListener l) {
		listenerList.add(IDashTableListener.class, l);
	}

	public void removeDashTableListener(IDashTableListener l) {
		listenerList.remove(IDashTableListener.class, l);
	}

	protected void fireTableChanged() {
		final DashTableEvent e = new DashTableEvent(getPatientList());
		IDashTableListener[] listeners =
			(IDashTableListener[]) listenerList.getListeners(
				IDashTableListener.class);
		for (int i = 0; i < listeners.length; i++) {
			listeners[i].tableChanged(e);
		}
	}
}
