package gov.va.med.hds.dashboard.dao;

import gov.va.med.hds.cd.daoregistry.IDataAccessObject;
import gov.va.med.hds.cd.m.IMumpsListener;
import gov.va.med.hds.dashboard.PatientParseException;
import gov.va.med.hds.dashboard.SensitivePatient;

import java.util.List;

/**
 * Patient List DAO interface.
 */
public interface IPatientListDAO extends IDataAccessObject {
	static final String ITEM_TYPE_ID = "dashboard.patient";

	static final int PATIENT_LIST_DEFAULT = 0;
	static final int PATIENT_LIST_PROVIDER = 1;
	static final int PATIENT_LIST_TEAM = 2;
	static final int PATIENT_LIST_SPECIALITY = 3;
	static final int PATIENT_LIST_CLINIC = 4;
	static final int PATIENT_LIST_WARD = 5;
	static final int PATIENT_LIST_REGISTRY = 6;
	static final int PATIENT_LIST_MAX = 7;

	String getDefaultPatientListSource();

	void getDashboardPatientList(
		Object user,
		List sourceIds,
		IMumpsListener listener);

	Object getPatientDemographics(Object patientId);

	boolean getSensitivePatient(Object patientId) throws SensitivePatient;

	void logSensitivePatient(Object patientId);

	List parsePatientList(Object rawData) throws PatientParseException;
	
	List getErrorStrings();

}
