package gov.va.med.hds.dashboard.itemtype;

/**
 * @author vhaislschras
 *
 * Interface for Chemistry Lab Result data
 * 
 * Department of Veterans Affairs
 * OI Field Office - Salt Lake City
 * Health Data Systems
 * 
 * @version 
 */

public interface IChemistryLabResult
{
  public void setResult(String resultName, String resultValue,
    String units, String refRange, String criticalFlag);

  public void setResultName(String resultName);
  
  public void setResultValue(String resultValue);
  
  public void setUnits(String units);
  
  public void setRefRange(String refRange);
  
  public void setCriticalFlag(String criticalFlag);
  
  /**
   * Returns the name of the result
   * 
   * @return the name of the result as a String.
   */
  public String getResultName();
  
  /**
   * Returns the value of the result.
   * 
   * @return the value of the result as a String.
   */
  public String getResultValue();
  
  /**
   * Returns the units of the result.
   * 
   * @return the units of the result as a String.
   */
  public String getUnits();
  
  /**
   * Returns the reference ranges of the result.
   * 
   * @return the reference ranges of the result as a String.
   */
  public String getRefRange();
  
  /**
   * Returns the critical flag of the result.
   * 
   * @return the critical flag of the result as a String.
   */
  public String getCriticalFlag();
  
  /**
   * Returns whether or not the result is critical.
   * 
   * @return true if the result is critical, otherwise false.
   */
  public boolean isCriticalResult();
}
