/*
 * Created on Apr 21, 2003
 *
 * Department of Veterans Affairs
 * OI Field Office - Salt Lake City
 * Health Data Systems
 * 
 */
package gov.va.med.hds.dashboard.items;

import gov.va.med.hds.cd.runtime.IConfigurationElement;
import gov.va.med.hds.cd.runtime.IRuntimeContext;
import gov.va.med.hds.dashboard.items.IDashboardEntry;
import gov.va.med.hds.dashboard.items.IDashboardItemTypes;
import gov.va.med.hds.dashboard.items.IItemEntry;

/**
 * Department of Veterans Affairs
 * OI Field Office - Salt Lake City
 * Health Data Systems
 * 
 * @author vhaislschras
 */
public class DashboardEntry implements IDashboardEntry
{
  private IRuntimeContext runtime;
  private IConfigurationElement dashEntry;
  int sequence = -1;
  String id;
  String label;
  IItemEntry itemEntry;
  
  public DashboardEntry(IRuntimeContext runtime, IConfigurationElement dashEntry, IItemEntry itemEntry)
  {
    this.runtime = runtime;
    this.dashEntry = dashEntry;
    this.itemEntry = itemEntry;

    this.id = dashEntry.getAttribute(IDashboardItemTypes.DASH_ITEM_ATTR_ID);
    this.label = dashEntry.getAttribute(IDashboardItemTypes.DASH_ITEM_ATTR_LABEL);
    String seq = dashEntry.getAttribute(IDashboardItemTypes.DASH_ITEM_ATTR_SEQ);
    if (null != seq && 0 != seq.length())
      this.sequence = Integer.parseInt(seq);
  }

  public String getID()
  {
    return id;
  }
  
  public String getLabel()
  {
    return label;
  }
  
  public int getSequence()
  {
    return sequence;
  }
  
  public IItemEntry getItemEntry()
  {
    return itemEntry;
  }
}
