/*
 * Created on Apr 11, 2003
 *
 * To change this generated comment go to 
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package gov.va.med.hds.dashboard.dao;

import java.util.Comparator;
import java.util.Date;
import java.util.List;

import gov.va.med.hds.cd.daoregistry.IDataAccessObject;
import gov.va.med.hds.dashboard.items.IDashboardItem;

/**
 * Department of Veterans Affairs
 * OI Field Office - Salt Lake City
 * Health Data Systems
 * 
 * @author vhaislschras
 */
public interface IDashboardItemDAO extends IDataAccessObject
{
  public static Comparator descendingDate = new Comparator(){
    public int compare(Object obj1, Object obj2)
    {
      Date date1 = ((IDashboardItem)obj1).getDate();
      Date date2 = ((IDashboardItem)obj2).getDate();

      // If either one is null, just pretend their equal
      if (null == date1 || null == date2)
        return 0;
      return date2.compareTo(date1);
    }
  };
  
  public List getItems(boolean onlyDirty);
  
  public List getItems(List ids);
  
  public Object getItem(Object id);
  
  public List getItems(Object patient);

  public List parseItems(Object data);

  public void putItems(List items);
  
  public void putItem(Object item);
  
  public void deleteItem(Object item);
  
  public void deleteItems(List items);
  
  public int size();
  
  public void updateItems(boolean flush);

  public void updateItems(List ids, boolean flush);
  
}
