/*
 * Created on Apr 14, 2003
 *
 * Department of Veterans Affairs
 * OI Field Office - Salt Lake City
 * Health Data Systems
 * 
 */
package gov.va.med.hds.dashboard.items;

import java.util.EventObject;

/**
 * Department of Veterans Affairs
 * OI Field Office - Salt Lake City
 * Health Data Systems
 * 
 * @author vhaislschras
 */
public class DashItemChangeEvent extends EventObject {
	public static final int ITEM_ADDED = 0;
	public static final int ITEM_MODIFIED = 1;
	public static final int ITEM_DELETED = 2;
	public static final int ITEM_SIGNED = 3;
	public static final int ITEM_COMPLETED = 4;

	private static final String[] events =
		{ "Added", "Modified", "Deleted", "Signed", "Completed" };

	protected int eventType;
	protected Object sourceItem;
	protected Object itemType;
	protected String strEvent;

	public DashItemChangeEvent(IDashboardItem source, int eventType) {
		super(source);
		this.eventType = eventType;
		this.sourceItem = source;
		this.itemType = source.getTypeID();
		if (this.itemType instanceof String) {
			int suffixIdx = ((String) itemType).lastIndexOf('~');
			if (-1 != suffixIdx)
				this.itemType =
					((String) this.itemType).substring(0, suffixIdx);
		}
	}

	public DashItemChangeEvent(Object source, Object itemType, int eventType) {
		super(source);
		this.sourceItem = source;
		this.itemType = itemType;
		this.eventType = eventType;
	}

	public int getEventType() {
		return eventType;
	}

	public String getEventDescription() {
		return events[eventType];
	}

	public Object getItemType() {
		return itemType;
	}

}
