package gov.va.med.hds.dashboard.items;

import java.util.EventListener;


/**
 * @author VHAISLSCHRAS
 * 
 * The interface to be implemented when an object wants to listen
 * to changes in dashboard items.
 *
 * Department of Veterans Affairs
 * OI Field Office - Salt Lake City
 * Health Data Systems
 * 
 * @version 
 */
public interface IDashItemChangeListener extends EventListener
{
  public static final String CLIENT_PROPERTY = 
    "gov.va.med.hds.dashboard.IDashItemChangeListener";

  /**
   * This method is called for each listener whenever a dashboard item is changed.
   * 
   * @param type the type of item.  One of 
   * <ul><li>IDashItem.DASH_RESULT</li>
   * <li>IDashItem.DASH_TASK</li>
   * <li>IDashItem.DASH_EVENT</li>
   * <li>IDashItem.DASH_UNSIGNEDITEM</li></ul>
   * @param item the item that changed.
   */
  public void itemUpdated(DashItemChangeEvent e);

}
