/*
 * Created on Apr 11, 2003
 *
 * To change this generated comment go to 
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package gov.va.med.hds.dashboard.items;

import java.util.Date;
import java.util.List;

import gov.va.med.hds.cd.runtime.IExecutableExtension;

/**
 * Department of Veterans Affairs
 * OI Field Office - Salt Lake City
 * Health Data Systems
 * 
 * @author vhaislschras
 */
public interface IDashboardItem extends IExecutableExtension
{
  /** 
   * Detail display context
   */
  public static final int     DASH_VIEW_DETAIL = 1;

  /** 
   * Completed display context
   */
  public static final int     DASH_VIEW_COMPLETE = 2;

  /** 
   * Summary display context
  */
  public static final int     DASH_VIEW_SUMMARY = 3;

  /** 
   * Iconic display context
   */
  public static final int     DASH_VIEW_ICON = 4;

  /** 
   * Nothing to display
   */
  public static final Integer NOTHING = new Integer(0);

  /** 
   * No critical items
   */
  public static final Integer NORMAL = new Integer(1);

  /** 
   * Contains critical items
   */
  public static final Integer CRITICAL = new Integer(2);

  /** 
   * All items have been acknowledged or signed.
   */
  public static final Integer ACKNOWLEDGED = new Integer(3);

  public static final String INPUT_DATE_FORMAT = "yyyyMMddHHmmssZ";
  public static final String OUTPUT_DATE_FORMAT = "MMM dd, yyyy@HH:mm:ss";

  public void initDashboardItem(String itemID, Object patientID);

  public String getTypeID();

  public String getID();
  
  public String getTitle();
  
  public String getShortTitle();
    
  public boolean isComplete();

  public boolean isViewed();
  
  public boolean isDirty();
  
  public boolean isCritical();
  
  public Date getDate();
  
  public String getStatus();
  
  public String getLinkURL();
  
  public String getFormattedDate();
  
  public Object getPatient();
  
  public Object getData();
  
  public List getComments();
  
  public void setID(String id);
  
  public void setTitle(String title);
  
  public void setShortTitle(String shortTitle);
  
  public void setComplete(boolean complete);

  public void setViewed(boolean viewed);
  
  public void setDirty(boolean dirty);
  
  public void setCritical(boolean critical);
  
  public void setDate(Object date);
  
  public void setStatus(String status);
  
  public void setPatient(Object patient);
  
  public void setData(Object data);
  
  public void addComment(Object comment);
  
}
