/*
 * Created on Apr 21, 2003
 *
 * Department of Veterans Affairs
 * OI Field Office - Salt Lake City
 * Health Data Systems
 * 
 */
package gov.va.med.hds.dashboard.items;

import java.util.Iterator;

/**
 * Department of Veterans Affairs
 * OI Field Office - Salt Lake City
 * Health Data Systems
 * 
 * @author vhaislschras
 */
public interface IDashboardItemTypes
{
  public static final String PLUGIN_ID = "gov.va.med.hds.dashboard.items";
  // Common attributes
  public static final String DASH_ITEM_ATTR_ID = "id";
  public static final String DASH_ITEM_ATTR_NAME = "name";

  // Attributes for ItemEntry
  public static final String DASH_ITEM_EXTENSION = PLUGIN_ID + ".itemType";
  public static final String DASH_ITEM_ATTR_ITEM_TYPE = "itemType";
  public static final String DASH_ITEM_ATTR_CLASS = "itemClass";
  public static final String DASH_ITEM_ATTR_URL = "itemURL";
  public static final String DASH_ITEM_ATTR_DAO = "itemDAO";
  public static final String DASH_ITEM_ATTR_SHORT_ID = "shortId";
  public static final String DASH_ITEM_ATTR_SIGNABLE = "signature";
//  public static final String DASH_ITEM_ATTR_COMMUNICATOR = "comunicatorId";
  public static final String DASH_ITEM_ATTR_PERMISSIONS = "permissions";

  // Attributes for Dashboard Entry
  public static final String DASH_DEFINITION_EXTENSION = PLUGIN_ID + ".definition";
  public static final String DASH_ITEM_ATTR_LABEL = "label";
  public static final String DASH_ITEM_ATTR_SEQ = "sequence";
  
  public Iterator itemIterator();
  
  public Iterator dashboardIterator();
  
  public IDashboardDefinition getDashboardDefinition(String id);

  public IItemEntry getItemType(String id);
  
  public int dashboardDefinitionSize();
  
  public int itemTypeSize();
  
}
