/*
 * Created on Apr 2, 2003
 *
 * To change this generated comment go to 
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package gov.va.med.hds.dashboard.dao.m;

import java.util.Iterator;

import gov.va.med.hds.cd.runtime.IConfigurationElement;
import gov.va.med.hds.cd.runtime.IRuntimeContext;
import gov.va.med.hds.dashboard.IDashboardPlugin;
import gov.va.med.hds.dashboard.items.IDashboardEntry;
import gov.va.med.hds.dashboard.items.IItemEntry;
import gov.va.med.hds.dashboard.nurse.NurseDashboardPlugin;

/**
 * Department of Veterans Affairs
 * OI Field Office - Salt Lake City
 * Health Data Systems
 * 
 * @author vhaislschras
 */
public class NursePatientListDAO extends AbstractPatientDAO
{
  protected static final String DASHBOARD_PATIENT_LIST = "NURS DASHBD PATIENTS";
  protected static final String DASHBOARD_TYPE = "N"; // Nurse
  protected static final String DASHBOARD_PERSPECTIVE_OPTION_NAME = "ORRCMM NURSING";

	/* (non-Javadoc)
	 * @see gov.va.med.hds.cd.runtime.IExecutableExtension#setInitializationData(gov.va.med.hds.cd.runtime.IRuntimeContext, gov.va.med.hds.cd.runtime.IConfigurationElement, java.lang.String, java.lang.Object)
	 */
	public void setInitializationData(IRuntimeContext runtime, IConfigurationElement config, String propertyName, Object data)
		throws Exception
	{
		super.setInitializationData(runtime, config, propertyName, data);
    dashboardPatientList = DASHBOARD_PATIENT_LIST;
    dashboardType = DASHBOARD_TYPE;
    
    IDashboardPlugin plugin = (IDashboardPlugin)runtime
      .getPluginInstance(NurseDashboardPlugin.PLUGIN_ID);

    Iterator iter = plugin.getItemTypes(); 
    while (iter.hasNext())
    {
      IItemEntry item = (IItemEntry)((IDashboardEntry)iter.next()).getItemEntry();
      itemTypes.put(item.getItemShortId(), item);
      if (ITEM_TYPE_ID.equals(item.getItemType()))
        patientItem = item;
    }
	}

}

