package gov.va.med.hds.dashboard.nurse;

import java.awt.event.ActionEvent;

import javax.swing.JScrollPane;
import javax.swing.JTable;

import gov.va.med.hds.cd.prism.action.AbstractAction;
import gov.va.med.hds.cd.prism.perspective.IPerspectiveListener;
import gov.va.med.hds.cd.prism.perspective.IPerspectiveReference;
import gov.va.med.hds.cd.prism.perspective.PerspectiveEvent;
import gov.va.med.hds.cd.prism.visualcomponent.IVisualComponentReference;
import gov.va.med.hds.cd.runtime.IConfigurationElement;
import gov.va.med.hds.cd.runtime.IRuntimeContext;
import gov.va.med.hds.cd.spectrum.dhtml.DHTMLPane;
import gov.va.med.hds.dashboard.IDashboardDetailVisualComponent;
import gov.va.med.hds.dashboard.IDashboardPatientVisualComponent;
import gov.va.med.hds.dashboard.IDashboardPlugin;

public abstract class AbstractDashboardActionX
	extends AbstractAction
	implements IPerspectiveListener {

	public void setInitializationData(
		IRuntimeContext runtime,
		IConfigurationElement config,
		String propertyName,
		Object data)
		throws Exception {
		super.setInitializationData(runtime, config, propertyName, data);
		getDesktop().getPerspectiveEventSource().addPerspectiveListener(this);
	}

	public void actionPerformed(ActionEvent e) {
		try {
			IDashboardPlugin dashboardPlugin =
				(IDashboardPlugin) runtime.getPluginInstance(
					NurseDashboardPlugin.PLUGIN_ID);
			actionPerformed(e, dashboardPlugin);
		} catch (Exception ex) {
			runtime.getLogger(getClass()).error("Unable to get reference to dashboard plugin", ex);
		}
	}

	protected DHTMLPane getDashPane() {
    IPerspectiveReference perspective = getDesktop().getActiveWindow().getActivePerspective();
    IVisualComponentReference[] components = perspective.getVisualComponents();
    for (int i = 0; i < components.length; i++)
    {
      if (components[i].getVisualComponent() instanceof IDashboardDetailVisualComponent)
      {
        JScrollPane scroller = (JScrollPane)components[i].getVisualComponent().getComponent();
        return (DHTMLPane)scroller.getViewport().getView();
      }
    }
    return null;
	}

  protected JTable getPatientList() {
    IPerspectiveReference perspective = getDesktop().getActiveWindow().getActivePerspective();
    IVisualComponentReference[] components = perspective.getVisualComponents();
    for (int i = 0; i < components.length; i++)
    {
      if (components[i].getVisualComponent() instanceof IDashboardPatientVisualComponent)
      {
        JScrollPane scroller = (JScrollPane)components[i].getVisualComponent().getComponent();
        return (JTable)scroller.getViewport().getView();
      }
    }
    return null;
  }

	protected abstract void actionPerformed(
		ActionEvent e,
		IDashboardPlugin dashboardPlugin
  )
		throws Exception;

	public void perspectiveActivated(PerspectiveEvent e) {
		reenable();
	}
	public void perspectiveClosed(PerspectiveEvent e) {
	}
	public void perspectiveOpened(PerspectiveEvent e) {
		reenable();
	}

	protected void reenable() {
		try {
			IDashboardPlugin dashboardPlugin =
				(IDashboardPlugin) runtime.getPluginInstance(
					NurseDashboardPlugin.PLUGIN_ID);
			if (dashboardPlugin == null) {
				setEnabled(false);
				return;
			}
			setEnabled(shouldEnable(dashboardPlugin));
		} catch (Exception ex) {
			setEnabled(false);
		}
	}

	protected boolean shouldEnable(
		IDashboardPlugin dashboardPlugin)
		throws Exception {

		return true;
	}
}
