package gov.va.med.hds.cd.help.internal.demo.uitest;

import java.awt.Component;

import javax.swing.JFrame;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.JTabbedPane;

import junit.extensions.jfcunit.JFCTestHelper;
import junit.extensions.jfcunit.eventdata.JTabbedPaneMouseEventData;
import junit.extensions.jfcunit.eventdata.MouseEventData;
import junit.extensions.jfcunit.finder.JMenuItemFinder;

import gov.va.med.hds.cd.help.HelpAction;
import gov.va.med.hds.cd.help.internal.demo.HelpDemo;
import gov.va.med.hds.cd.runtime.test.RuntimeJFCTestCase;
import gov.va.med.hds.cd.runtime.test.TestRuntime;

public class TestHelpDemo extends RuntimeJFCTestCase {
	private static final String REGISTRY_RESOURCE= "TestHelpDemoRegistry.xml";
	public TestHelpDemo(String arg0) {
		super(arg0);
	}

	public static void main(String[] args) {
		TestRuntime runtime= new TestRuntime();
		runtime.readPluginDescriptors(
			TestHelpDemo.class.getResourceAsStream(REGISTRY_RESOURCE));
		runtime.readSettings(TestHelpDemo.class.getResourceAsStream("CacheSettings.xml"));

		runtime.run();
	}
	protected void setUp() throws Exception {
		super.setUp();
		parseRegistryResource(REGISTRY_RESOURCE);
		getRuntime().readSettings(TestHelpDemo.class.getResourceAsStream("CacheSettings.xml"));
		this.setHelper(new JFCTestHelper());

		//		JFCEventManager.setDebug(true);
		//		JFCEventManager.setDebugType(JFCEventManager.DEBUG_OUTPUT);
		//		JFCEventManager.setRecording(true);
	}
	protected void tearDown() throws Exception{
		super.tearDown();
	}

	public void testCreateHelpDemoPlugin() throws Exception {
		HelpDemo demo= (HelpDemo) getRuntime().getPluginInstance(HelpDemo.PLUGIN_ID);
		assertNotNull(demo);
	}

	public void testLauchSingleMerge() throws Exception {
		getRuntime().run();
		flushAWT();

		final String CD_WINDOW_NAME= "HealtheVet Desktop in use by: GEARY,JOREL";
		final String HELP_WINDOW_NAME= "HealtheVet Desktop Help";

		JFrame frame= (JFrame) JFCTestHelper.getWindow(CD_WINDOW_NAME);
		assertNotNull(CD_WINDOW_NAME, frame);

		JMenu helpMenu=
			(JMenu) JFCTestHelper.findComponent(
				new JMenuItemFinder("Help"),
				frame,
				0);
		assertNotNull("Could not find the \"Help\" menu", helpMenu);
		helper.enterClickAndLeave(new MouseEventData(this, helpMenu));
		flushAWT();

		Component[] menuItems= helpMenu.getMenuComponents();
		JMenuItem item= null;
		boolean foundIt= false;
		for (int i= 0; i < menuItems.length; i++) {
			item= (JMenuItem) menuItems[i];
			if (item.getText().equals(HelpAction.DEFAULT_NAME)) {
				foundIt= true;
				break;
			}
		}

		assertTrue(
			"Missing a \"" + HelpAction.DEFAULT_NAME + "\" meunu item",
			foundIt);
		helper.enterClickAndLeave(new MouseEventData(this, item));
		flushAWT();

		JFrame helpFrame= (JFrame) JFCTestHelper.getWindow(HELP_WINDOW_NAME);
		assertNotNull(
			"Could not find the window titled \"" + HELP_WINDOW_NAME + "\"",
			helpFrame);

		JTabbedPane tabbedPane=
			(JTabbedPane) JFCTestHelper.findComponent(
				JTabbedPane.class,
				helpFrame,
				0);
		assertNotNull("Could not find the help tab pane", tabbedPane);
		helper.enterClickAndLeave(
			new JTabbedPaneMouseEventData(this, tabbedPane, 1, 1));

		//		Thread.sleep(10000);
//		JFCTestHelper.removeAllSystemWindows();
	}
}
