package gov.va.med.hds.cd.help;

import gov.va.med.hds.cd.prism.action.AbstractAction;
import gov.va.med.hds.util.ExceptionStackTrace;

import java.awt.event.ActionEvent;
import java.awt.event.KeyEvent;
import java.net.URL;

import javax.swing.Action;
import javax.swing.ImageIcon;
import javax.swing.JOptionPane;
import javax.swing.KeyStroke;

public class DirectHelpAction extends AbstractAction {
	public static final String 		DEFAULT_NAME 			= "What's This?";
	private static final Integer		DEFAULT_MNEMONIC_KEY	= new Integer(KeyEvent.VK_T);
	private static final KeyStroke 	DEFAULT_ACCELERATOR_KEY = KeyStroke.getKeyStroke("shift F1");
	private static final String		DIRECT_HELP_ICON_PATH	= "images/directhelpicon.png";

	public DirectHelpAction(){
		super();
		URL imageURL = DirectHelpAction.class.getResource(DIRECT_HELP_ICON_PATH);
		ImageIcon icon = new ImageIcon(imageURL);
		putValue(Action.SMALL_ICON,icon);
		putValue(Action.NAME, DEFAULT_NAME);
		putValue(Action.MNEMONIC_KEY, DEFAULT_MNEMONIC_KEY);
		putValue(Action.ACCELERATOR_KEY, DEFAULT_ACCELERATOR_KEY);
		setEnabled(true);
	}
	public void actionPerformed(ActionEvent e) {
		try {
			IHelp helpModule = (IHelp)this.getDesktop().getRuntime().getPluginInstance(IHelp.PLUGIN_ID);
			helpModule.launchDirectHelp(e);
		} catch (Exception exp) {
			JOptionPane.showMessageDialog(null, "Could not find the Help module.\n"+ExceptionStackTrace.getStackTrace(exp), "Direct Help Action Error", JOptionPane.ERROR_MESSAGE); 
		}	
	}
}
