package gov.va.med.hds.cd.help;

import gov.va.med.hds.cd.prism.action.AbstractAction;
import gov.va.med.hds.util.ExceptionStackTrace;

import java.awt.event.ActionEvent;
import java.awt.event.KeyEvent;

import javax.swing.Action;
import javax.swing.JOptionPane;
import javax.swing.KeyStroke;


public class HelpAction extends AbstractAction {
	public static final String 		DEFAULT_NAME 			= "Help Contents...";
	private static final Integer		DEFAULT_MNEMONIC_KEY	= new Integer(KeyEvent.VK_H);
	private static final KeyStroke 	DEFAULT_ACCELERATOR_KEY = KeyStroke.getKeyStroke("F1");
	public HelpAction() {
		super();
		putValue(Action.NAME, DEFAULT_NAME);
		putValue(Action.MNEMONIC_KEY, DEFAULT_MNEMONIC_KEY);
		putValue(Action.ACCELERATOR_KEY, DEFAULT_ACCELERATOR_KEY);
		setEnabled(true);
	}
	public void actionPerformed(ActionEvent e){
		try {
			IHelp helpModule = (IHelp)this.getDesktop().getRuntime().getPluginInstance(IHelp.PLUGIN_ID);
			helpModule.displayHelpWindow(e);
		} catch (Exception exp) {
			JOptionPane.showMessageDialog(null, "Could not find the Help module.\n"+ExceptionStackTrace.getStackTrace(exp), "Help Action Error", JOptionPane.ERROR_MESSAGE); 
		}	
	}
}
