package gov.va.med.hds.cd.help;

import java.awt.Component;
import java.awt.MenuItem;
import java.awt.event.ActionEvent;

import javax.swing.JRootPane;

import gov.va.med.hds.cd.runtime.IPlugin;

/**
 * Main help plugin interface
 */
public interface IHelp extends IPlugin {
	/**
	 * Plugin Id of the help plugin
	 */
	public final String PLUGIN_ID = "gov.va.med.hds.cd.help";
	/**
	 * Help property key associated with descendents of java.awt.Component
	 */
	public final String HELPID_CLIENT_PROPERTY_KEY = "HelpID";

	/**
	 * Displays a help browsing dialog window
	 * @param e
	 */
	public void displayHelpWindow(ActionEvent e);

	/**
	 * The direct help icon and puts the help system in direct help mode
	 * @param e
	 */
	public void launchDirectHelp(ActionEvent e);
	/**
	 * Sets the root pane from which the help browser window will be set relative to
	 * @param pane
	 */
	public void setRootPane(JRootPane pane);
	/**
	 * Shows a help browser window with the help id associated with the component.
	 * If there is no help id property then the default top level root help will be displayed
	 * @param component
	 */
	public void showHelp(Component component);
	/** 
	 * Shows a help browser window with the content specified by the help id property
	 * associated with the menu item. If there is no help id or it is invalid then
	 * the default root help content will be used.
	 * @param menuItem
	 */
	public void showHelp(MenuItem menuItem);
	/**
	 * Shows a help browser window with the content specified by the helpId param.
	 * If the helpId value is invalid then the default root help id will be displayed.
	 * @param helpId
	 */
	public void showHelp(String helpId);
}
