unit uLogger;

interface

uses
        Classes;

type
        TLogger = class
        private
                messages: TStringList;
                procedure SaveMessage(const owner:TObject; const line:string; descr:string);
        public
                constructor Create;
                destructor Destroy; override;
                procedure Debug(const owner: TObject; const line: string);
                procedure Error(const owner: TObject; const line: string);
                function SaveToFile(const fileName: string): boolean;
        end;

implementation

uses
        Sysutils,Windows;

procedure TLogger.Debug(const owner: TObject; const line: string);
begin
        SaveMessage(owner, line, 'Debug');
end;

constructor TLogger.Create;
begin
        messages := TStringList.Create;
end;

destructor TLogger.Destroy;
begin
  inherited;

end;

function TLogger.SaveToFile(const fileName: string): boolean;
var
        fileStream: TFileStream;
begin
        fileStream := TFileStream.Create(fileName,fmCreate or fmShareDenyWrite);
        messages.SaveToStream(fileStream);
        result := true;
end;

procedure TLogger.Error(const owner: TObject; const line: string);
begin
        SaveMessage(owner, line, 'Error');
end;

procedure TLogger.SaveMessage(const owner: TObject; const line: string;
  descr: string);
var
        completeLine: string;
        timeString: string;
begin
        DateTimeToString(timeString, 'mm/dd/yyyy hh:nn:ss.zzz', Now);
        completeLine := '[' + timeString + ' ' + owner.ClassName + '] [' + descr + '] ' + line;
        messages.Add(completeLine);
end;

end.
