package gov.va.med.hds.cd.m;
/**
 * Abstracts a cache that manages call requests
 * 
 * */
public interface ICallRequestCache {
	public static final String CALL_CACHE_ROOT_ELEMENT_NAME= "callRequestCache";
	public static final String CALLS_ELEMENT_NAME = "calls";
	public static final String USERINFO_ELEMENT_NAME = "userInfo";
	public static final String DIVISIONIEN_ELEMENT_NAME = "divisionIEN";
	public static final String DIVISIONSTATIONNAME_ELEMENT_NAME = "divisionStationName";
	public static final String DIVISIONSTATIONNUMBER_ELEMENT_NAME = "divisionStationNumber";
	public static final String DTIME_ELEMENT_NAME = "dTime";
	public static final String DUZ_ELEMENT_NAME = "duz";
	public static final String NEWPERSON01_ELEMENT_NAME = "newPerson01";
	public static final String FIRSTNAME_ELEMENT_NAME = "firstName";
	public static final String LASTNAME_ELEMENT_NAME = "lastName";
	public static final String MIDDLENAME_ELEMENT_NAME = "middleName";
	public static final String PREFIX_ELEMENT_NAME = "prefix";
	public static final String SUFFIX_ELEMENT_NAME = "suffix";
	public static final String TITLE_ELEMENT_NAME = "title";
	public static final String SSNLAST4_ELEMENT_NAME = "SSNLast4";
	public static final String LANGUAGE_ELEMENT_NAME = "language";
	public static final String SERVICESECTION_ELEMENT_NAME = "serviceSection";
	
    
	/**
	 * Returns the TimedResult for a given call request
	 * 
	 * @param callRequest
	 * @return TimedResult
	 */
	TimedResult getResult(ICallRequest callRequest);
	/**
	 * Adds a call request / timed result pair to the cache
	 * 
	 * @param request
	 * @param result
	 * @throws CallRequestCacheException
	 */
	void add(ICallRequest request, TimedResult result)
		throws CallRequestCacheException;
		
	/**
	 * Returns true if the cache contains the request. False otherwise.
	 * @param request
	 * @return boolean
	 */
	boolean contains(ICallRequest request);
	
	/**
	 * Retrieves the user info from the cache
	 * 
	 * @return IMumpsUserInfo
	 */
	IMumpsUserInfo retrieveUserInfo();
}