package gov.va.med.hds.cd.m.internal;

import gov.va.med.hds.cd.runtime.IRuntimeContext;

import java.awt.Frame;
import java.util.HashMap;

import javax.security.auth.login.Configuration;

/**
 * Abstracts a vistalink configuration
 */
abstract class AbstractVistalinkConfiguration extends Configuration {

	/**
	 * Default constructor
	 *
	 */
	public AbstractVistalinkConfiguration() {
		super();
	}

	/* (non-Javadoc)
	 * @see javax.security.auth.login.Configuration#refresh()
	 */
	public void refresh() {
	}

	/**
	 * Sets server name property in the options map passed to the configuration.
	 * 
	 * @param name server name
	 */
	protected void setServerName(String name) {
		options.put(VistalinkLoginModuleBase.VLJ_SERVER_ADDRESS_KEY, name);
	}

	/**
	 * Sets the server port property in the options map passed to the configuration
	 * 
	 * @param port
	 */
	protected void setServerPort(int port) {
		options.put(VistalinkLoginModuleBase.VLJ_SERVER_PORT_KEY, String.valueOf(port));
	}

	/**
	 * Sets the runtime context property in the options map passed to the configuration.
	 * @param runtime
	 */
	protected void setRuntimeContext(IRuntimeContext runtime) {
		options.put(LoginModuleBase.RUNTIME_CONTEXT_KEY, runtime);
	}

	/**
	 * Sets the main frame property in the options map passed to the configuration
	 * @param frame main frame
	 */
	protected void setMainFrame(Frame frame){
		options.put(LoginModuleBase.MAIN_FRAME_KEY,frame);
	}
	/**
	 * The options map passed to the configuration
	 */
	protected HashMap options = new HashMap();
}
