package gov.va.med.hds.cd.m.internal;
import gov.va.med.hds.cd.runtime.IRuntimeContext;
import java.util.HashMap;

import javax.security.auth.login.AppConfigurationEntry;
import javax.security.auth.login.Configuration;
/**
 * Provides a Configuration overload for JAAS that specifies config information for a BrokerLoginModule.
 * Note that this class is a singleton.
 */
public class BrokerConfiguration extends Configuration {
	protected BrokerConfiguration() {
		super();
	}
	/**
	 * @see javax.security.auth.login.Configuration#getAppConfigurationEntry(String)
	 */
	public AppConfigurationEntry[] getAppConfigurationEntry(String applicationName) {
		if (applicationName == BrokerLoginModule.class.getName()) {
			AppConfigurationEntry[] result = new AppConfigurationEntry[1];
			result[0] =
				new AppConfigurationEntry(
					BrokerLoginModule.class.getName(),
					AppConfigurationEntry.LoginModuleControlFlag.REQUISITE,
					options);
			return result;
		}
		return null;
	}
	/**
	 * @see javax.security.auth.login.Configuration#refresh()
	 */
	public void refresh() {
	}
	/**
	 * Gets the unique instance
	 * 
	 * @return BrokerConfiguration
	 */
	public static BrokerConfiguration getInstance() {
		if (instance == null)
			instance = new BrokerConfiguration();
		return instance;
	}
	void setServerName(String name) {
		options.put(BrokerLoginModule.SERVER_NAME_KEY, name);
	}
	void setServerPort(int port) {
		options.put(BrokerLoginModule.SERVER_PORT_KEY, String.valueOf(port));
	}
	void setRuntimeContext(IRuntimeContext runtime) {
		options.put(BrokerLoginModule.RUNTIME_CONTEXT_KEY, runtime);
	}
	void setWantDebug(Boolean programmerDebug) {
		options.put(BrokerLoginModule.PROGRAMMER_DEBUG_KEY, programmerDebug);
	}
	private static BrokerConfiguration instance = null;
	private HashMap options = new HashMap();
}
