package gov.va.med.hds.cd.m.internal;

import gov.va.med.hds.cd.m.IMumpsUserInfo;

import java.io.StringReader;
import java.security.Principal;

import org.dom4j.Document;
import org.dom4j.DocumentException;
import org.dom4j.Node;
import org.dom4j.io.SAXReader;
import org.jaxen.JaxenException;
import org.jaxen.dom4j.Dom4jXPath;

/**
 * M based principal for Shared Broker implementations
 */
class BrokerMumpsPrincipal implements Principal, IMumpsUserInfo {
	BrokerMumpsPrincipal(String data) throws DocumentException, JaxenException {
		SAXReader reader = new SAXReader();
		Document doc = reader.read(new StringReader(data));
		duz =
			((Node) (new Dom4jXPath("result/userInfo/uniqueId")).selectSingleNode(doc))
				.getStringValue();
		first =
			((Node) (new Dom4jXPath("result/userInfo/firstName")).selectSingleNode(doc))
				.getStringValue();
		last =
			((Node) (new Dom4jXPath("result/userInfo/lastName")).selectSingleNode(doc))
				.getStringValue();
		middle =
			((Node) (new Dom4jXPath("result/userInfo/middleInitial")).selectSingleNode(doc))
				.getStringValue();
		title =
			((Node) (new Dom4jXPath("result/userInfo/title")).selectSingleNode(doc))
				.getStringValue();
	}
	/**
	 * User name
	 * @see java.security.Principal#getName()
	 */
	public String getName() {
		return name;
	}
	/**
	 * User ID
	 * @see gov.va.med.hds.cd.m.IMumpsUserInfo#getDuz()
	 */
	public String getDuz() {
		return duz;
	}
	/**
	 * User first name
	 * @see gov.va.med.hds.cd.security.IUserInfo#getFirstName()
	 */
	public String getFirstName() {
		return first;
	}
	/** 
	 * User last name
	 * @see gov.va.med.hds.cd.security.IUserInfo#getLastName()
	 */
	public String getLastName() {
		return last;
	}
	/**
	 * User middle name
	 * @see gov.va.med.hds.cd.security.IUserInfo#getMiddleName()
	 */
	public String getMiddleName() {
		return middle;
	}
	/**
	 * User title
	 * @see gov.va.med.hds.cd.security.IUserInfo#getTitle()
	 */
	public String getTitle() {
		return title;
	}
	/**
	 * User division IEN
	 * @see gov.va.med.hds.cd.m.IMumpsUserInfo#getDivisionIEN()
	 */
	public String getDivisionIEN() {
		return "";
	}
	/**
	 * User division station name
	 * @see gov.va.med.hds.cd.m.IMumpsUserInfo#getDivisionStationName()
	 */
	public String getDivisionStationName() {
		return "";
	}
	/** 
	 * User division station number
	 * @see gov.va.med.hds.cd.m.IMumpsUserInfo#getDivisionStationNumber()
	 */
	public String getDivisionStationNumber() {
		return "";
	}
	/**
	 * @see gov.va.med.hds.cd.m.IMumpsUserInfo#getDTime()
	 */
	public String getDTime() {
		return "";
	}
	/**
	 * 
	 * @see gov.va.med.hds.cd.m.IMumpsUserInfo#getNewPerson01()
	 */
	public String getNewPerson01() {
		return "";
	}
	/**
	 * 
	 * @see gov.va.med.hds.cd.security.IUserInfo#getPrefix()
	 */
	public String getPrefix() {
		return "";
	}
	/**
	 * 
	 * @see gov.va.med.hds.cd.security.IUserInfo#getSuffix()
	 */
	public String getSuffix() {
		return "";
	}
	/**
	 * 
	 * @see gov.va.med.hds.cd.security.IUserInfo#getLanguage()
	 */
	public String getLanguage() {
		return "";
	}
	/**
	 * 
	 * @see gov.va.med.hds.cd.security.IUserInfo#getServiceSection()
	 */
	public String getServiceSection() {
		return "";
	}
	/**
	 * 
	 * @see gov.va.med.hds.cd.security.IUserInfo#getStandardConcatenated()
	 */
	public String getStandardConcatenated() {
		return "";
	}
	private String name = BrokerMumpsPrincipal.class.getName();
	private String duz, first, last, middle, title;
}
