package gov.va.med.hds.cd.m.internal;
import gov.va.med.hds.cd.m.IMumpsConnectionSettings;
import gov.va.med.hds.cd.m.InvalidSettingsException;
import gov.va.med.hds.cd.runtime.IRuntimeContext;

import javax.security.auth.login.Configuration;
/**
 * Provides a security plugin implementation of IPlugin based on the BrokerCallQueue
 */
public class BrokerPlugin extends AbstractPlugin {
	/**
	 * Constructs based on a runtime context and configuration info.
	 * @param runtime runtime context
	 * @param settings boot settings
	 * @throws InvalidSettingsException
	 */
	public BrokerPlugin(IRuntimeContext runtime, IMumpsConnectionSettings settings)
		throws InvalidSettingsException {
		super(runtime, settings);
		BrokerConfiguration.getInstance().setServerName(server);
		BrokerConfiguration.getInstance().setServerPort(port);
		BrokerConfiguration.getInstance().setRuntimeContext(runtime);
		BrokerConfiguration.getInstance().setWantDebug(new Boolean(settings.isDebug()));
	}
	/**
	 * 
	 * @see gov.va.med.hds.cd.m.internal.AbstractPlugin#getLoginModuleKeyName()
	 */
	protected String getLoginModuleKeyName() {
		return BrokerLoginModule.class.getName();
	}
	/**
	 * @see gov.va.med.hds.cd.security.IPlugin#getConfiguration()
	 */
	public Configuration getConfiguration() {
		return BrokerConfiguration.getInstance();
	}
}
