package gov.va.med.hds.cd.m.internal;
import gov.va.med.hds.cd.runtime.IRuntimeContext;
import java.util.HashMap;

import javax.security.auth.login.AppConfigurationEntry;
import javax.security.auth.login.Configuration;

/**
 * Configuration for Shared Broker based integratino testing
 */
class IntegrationTestBrokerConfiguration extends Configuration {
	protected IntegrationTestBrokerConfiguration() {
		super();
	}
	public AppConfigurationEntry[] getAppConfigurationEntry(String applicationName) {
		if (applicationName == IntegrationTestBrokerLoginModule.class.getName()) {
			AppConfigurationEntry[] result = new AppConfigurationEntry[1];
			result[0] =
				new AppConfigurationEntry(
					IntegrationTestBrokerLoginModule.class.getName(),
					AppConfigurationEntry.LoginModuleControlFlag.REQUISITE,
					options);
			return result;
		}
		return null;
	}
	public void refresh() {
	}
	public static IntegrationTestBrokerConfiguration getInstance() {
		if (instance == null)
			instance = new IntegrationTestBrokerConfiguration();
		return instance;
	}
	void setServerName(String name) {
		options.put(IntegrationTestBrokerLoginModule.SERVER_NAME_KEY, name);
	}
	void setServerPort(int port) {
		options.put(IntegrationTestBrokerLoginModule.SERVER_PORT_KEY, String.valueOf(port));
	}
	void setRuntimeContext(IRuntimeContext runtime) {
		options.put(IntegrationTestBrokerLoginModule.RUNTIME_CONTEXT_KEY, runtime);
	}
	void setWantDebug(Boolean programmerDebug) {
		options.put(IntegrationTestBrokerLoginModule.PROGRAMMER_DEBUG_KEY, programmerDebug);
	}
	private static IntegrationTestBrokerConfiguration instance = null;
	private HashMap options = new HashMap();
}
