package gov.va.med.hds.cd.m.internal;
import gov.va.med.hds.cd.m.IMumpsConnectionSettings;
import gov.va.med.hds.cd.m.InvalidSettingsException;
import gov.va.med.hds.cd.runtime.IRuntimeContext;
import gov.va.med.hds.cd.security.PluginException;

import javax.security.auth.login.Configuration;
/**
 * Security plugin for Shared Broker based integration testing
 */
class IntegrationTestBrokerPlugin extends AbstractPlugin {
	public IntegrationTestBrokerPlugin(IRuntimeContext runtime, IMumpsConnectionSettings settings)
		throws InvalidSettingsException {
		super(runtime, settings);
		IntegrationTestBrokerConfiguration.getInstance().setServerName(server);
		IntegrationTestBrokerConfiguration.getInstance().setServerPort(port);
		IntegrationTestBrokerConfiguration.getInstance().setRuntimeContext(runtime);
		IntegrationTestBrokerConfiguration.getInstance().setWantDebug(
			new Boolean(settings.isDebug()));
	}
	public Configuration getConfiguration() throws PluginException {
		return IntegrationTestBrokerConfiguration.getInstance();
	}
	protected String getLoginModuleKeyName() {
		return IntegrationTestBrokerLoginModule.class.getName();
	}
}
