package gov.va.med.hds.cd.m.internal;
import javax.security.auth.login.AppConfigurationEntry;
/**
 * Vistalink based integration testing configuration
 */
class IntegrationTestVistalinkConfiguration extends AbstractVistalinkConfiguration {
	private static final String CODE_A = "jorel1";
	private static final String CODE_B = "5big.man";
	private static final String DIVISION = "";

	protected IntegrationTestVistalinkConfiguration() {
		super();
		options.put(VistalinkLoginModuleBase.VLJ_ACCESS_CODE_KEY, CODE_A);
		options.put(VistalinkLoginModuleBase.VLJ_VERIFY_CODE_KEY, CODE_B);
		options.put(VistalinkLoginModuleBase.VLJ_DIVISION_KEY, DIVISION);
	}
	public AppConfigurationEntry[] getAppConfigurationEntry(String applicationName) {
		if (applicationName == IntegrationTestVistalinkLoginModule.class.getName()) {
			AppConfigurationEntry[] result = new AppConfigurationEntry[1];
			result[0] =
				new AppConfigurationEntry(
					IntegrationTestVistalinkLoginModule.class.getName(),
					AppConfigurationEntry.LoginModuleControlFlag.REQUISITE,
					options);
			return result;
		}
		return null;
	}
	public static IntegrationTestVistalinkConfiguration getInstance() {
		if (instance == null)
			instance = new IntegrationTestVistalinkConfiguration();
		return instance;
	}
	private static IntegrationTestVistalinkConfiguration instance = null;
}
