package gov.va.med.hds.cd.m.internal;
import gov.va.med.foundations.security.vistalink.CallbackHandlerUnitTest;

import java.util.Map;

import javax.security.auth.Subject;
import javax.security.auth.callback.CallbackHandler;
/**
 * Used as a login module for integration testing. A hard coded login
 * and password are used to match the integration system user
 * credentials.
 */
public class IntegrationTestVistalinkLoginModule extends VistalinkLoginModuleBase {
	/* (non-Javadoc)
	 * @see javax.security.auth.spi.LoginModule#initialize(javax.security.auth.Subject, javax.security.auth.callback.CallbackHandler, java.util.Map, java.util.Map)
	 * 
	 * Adds a silent callback handler to handle login interaction.
	 */
	public void initialize(
		Subject subject,
		CallbackHandler callbackHandler,
		Map sharedState,
		Map options) {
		CallbackHandler handler =
			new CallbackHandlerUnitTest(
				(String) options.get(VistalinkLoginModuleBase.VLJ_ACCESS_CODE_KEY),
				(String) options.get(VistalinkLoginModuleBase.VLJ_VERIFY_CODE_KEY),
				(String) options.get(VistalinkLoginModuleBase.VLJ_DIVISION_KEY));
		super.initialize(subject, handler, sharedState, options);
	}

}
