package gov.va.med.hds.cd.m.internal;
import gov.va.med.hds.cd.runtime.IRuntimeContext;
import java.util.HashMap;

import javax.security.auth.login.AppConfigurationEntry;
import javax.security.auth.login.Configuration;
/**
 * Security configuration for silent XML cache
 */
class SilentXmlCacheConfiguration extends Configuration {
	protected SilentXmlCacheConfiguration() {
		super();
	}
	public AppConfigurationEntry[] getAppConfigurationEntry(String applicationName) {
		if (applicationName == SilentXmlCacheLoginModule.class.getName()) {
			AppConfigurationEntry[] result = new AppConfigurationEntry[1];
			result[0] =
				new AppConfigurationEntry(
					SilentXmlCacheLoginModule.class.getName(),
					AppConfigurationEntry.LoginModuleControlFlag.REQUISITE,
					options);
			return result;
		}
		return null;
	}
	void setRuntimeContext(IRuntimeContext runtime) {
		options.put(SilentXmlCacheLoginModule.RUNTIME_CONTEXT_KEY, runtime);
	}
	public void refresh() {
	}
	public static SilentXmlCacheConfiguration getInstance() {
		if (instance == null)
			instance = new SilentXmlCacheConfiguration();
		return instance;
	}
	private static SilentXmlCacheConfiguration instance = null;
	private HashMap options = new HashMap();
}
