package gov.va.med.hds.cd.m.internal;
import gov.va.med.foundations.security.vistalink.VistaKernelPrincipalImpl;
import gov.va.med.hds.cd.m.IConnectRequest;
/**
 * Implements a connect request for VistALink connections
 */
class VistalinkConnectRequest implements IConnectRequest {
	private int MIN_TIMEOUT_IN_SECONDS = 30;

	public VistalinkConnectRequest(VistaKernelPrincipalImpl principal, int timeout) {
		this.principal = principal;
		this.timeout = Math.max(MIN_TIMEOUT_IN_SECONDS, timeout);
	}
	public VistaKernelPrincipalImpl getPrincipal() {
		return principal;
	}
	public int getTimeLimit() {
		return timeout;
	}
	private VistaKernelPrincipalImpl principal;
	private int timeout = MIN_TIMEOUT_IN_SECONDS;
}
