package gov.va.med.hds.cd.m.internal;
import gov.va.med.foundations.security.vistalink.CallbackHandlerSwing;

import java.awt.Frame;
import java.util.Map;

import javax.security.auth.Subject;
import javax.security.auth.callback.CallbackHandler;
/**
 * Provides a JAAS security compatable login module that connects to
 * MUMPS for credentials and a data connection. The user is prompted
 * for login credentials.
 */
public class VistalinkLoginModule extends VistalinkLoginModuleBase {
	/* (non-Javadoc)
	 * @see javax.security.auth.spi.LoginModule#initialize(javax.security.auth.Subject, javax.security.auth.callback.CallbackHandler, java.util.Map, java.util.Map)
	 * 
	 * Adds a Vistalink callback handler to handle user interaction on login.
	 */
	public void initialize(
		Subject subject,
		CallbackHandler callbackHandler,
		Map sharedState,
		Map options) {
		super.initialize(subject, new CallbackHandlerSwing((Frame)options.get(LoginModuleBase.MAIN_FRAME_KEY)), sharedState, options);
	}
}
