package gov.va.med.hds.cd.m.internal;
import gov.va.med.hds.cd.m.IMumpsConnectionSettings;
import gov.va.med.hds.cd.m.InvalidSettingsException;
import gov.va.med.hds.cd.runtime.IRuntimeContext;
import gov.va.med.hds.cd.security.PluginException;

import javax.security.auth.login.Configuration;

/**
 * Vistalink security plugin implementation
 */
class VistalinkPlugin extends AbstractPlugin {
	/**
	 * Constructor
	 * @param runtime
	 * @param settings
	 * @throws InvalidSettingsException
	 */
	public VistalinkPlugin(IRuntimeContext runtime, IMumpsConnectionSettings settings)
		throws InvalidSettingsException {
		super(runtime, settings);
		VistalinkConfiguration.getInstance().setServerName(server);
		VistalinkConfiguration.getInstance().setServerPort(port);
		VistalinkConfiguration.getInstance().setRuntimeContext(runtime);
		VistalinkConfiguration.getInstance().setMainFrame(null);
	}
	/**
	 * @see gov.va.med.hds.cd.security.IPlugin#getConfiguration()
	 */
	public Configuration getConfiguration() throws PluginException {
		return VistalinkConfiguration.getInstance();
	}
	/**
	 * 
	 * @see gov.va.med.hds.cd.m.internal.AbstractPlugin#getLoginModuleKeyName()
	 */
	protected String getLoginModuleKeyName() {
		return VistalinkLoginModule.class.getName();
	}
}
