package gov.va.med.hds.cd.m.internal.broker.jni.itest;
import gov.va.med.hds.cd.m.internal.broker.jni.COMException;
import gov.va.med.hds.cd.m.internal.broker.jni.Connector;
import gov.va.med.hds.util.DisposeException;

import junit.framework.TestCase;
/**
 * Tests Shared Broker based connector
 */
public class ConnectorTest extends TestCase {
	public ConnectorTest(String arg0) {
		super(arg0);
	}
	public void setUp() throws COMException {
		connector = new Connector();
	}
	public void testConnect() throws DisposeException {
		String accessCode = "jorel1";
		String verifyCode = "5big.man";
		String department = null;
		String loginStr = connector.createLoginStr(accessCode, verifyCode, department);
		String appName = "ConnectorTest";
		String connectionTarget = "isl-reengkm:9000";
		int connectionTimeOutInSeconds = 0;
		boolean connectorCollectsCredentials = false;
		boolean wantDebug = false;
		try {
			connector.connect(
				appName,
				connectionTarget,
				connectionTimeOutInSeconds,
				connectorCollectsCredentials,
				loginStr,
				wantDebug);
		} catch (Exception e) {
			fail("Should not fail to connect:  " + e.getMessage());
		}
	}
	public void tearDown() throws DisposeException {
		connector.dispose();
	}
	private static Connector connector = null;
}
