package gov.va.med.hds.cd.m.internal.itest;
import gov.va.med.hds.cd.m.IMumpsUserInfo;
import gov.va.med.hds.cd.m.test.TestConstants;
import gov.va.med.hds.cd.runtime.test.RuntimeTestCase;
import gov.va.med.hds.cd.security.ISecurity;
import gov.va.med.hds.cd.security.IUserInfo;

import java.util.Set;

import javax.security.auth.Subject;

/**
 * Exercies the IUserInfo interface
 */
public class UserInfoTest extends RuntimeTestCase {
	public UserInfoTest(String arg0) {
		super(arg0);
	}
	private IUserInfo uinfo;
	protected void setUp() throws Exception {
		super.setUp();
		parseRegistryResource(TestConstants.DEFAULT_REGISTRY_PATH);
		getRuntime().readSettings(getClass().getResourceAsStream("VistalinkSettings.xml"));
		securityModule = (ISecurity) getRuntime().getPluginInstance(ISecurity.PLUGIN_ID);
		uinfo = securityModule.login();
	}
	public void testUserInfoFromLogin() throws Exception {
		IUserInfo uinfo2 = securityModule.getUserInfo();
		assertEquals("JOREL", uinfo.getFirstName());
		assertEquals("GEARY", uinfo.getLastName());
		assertEquals("", uinfo.getMiddleName());

		assertEquals(uinfo, uinfo2);

		assertEquals("JOREL", uinfo2.getFirstName());
		assertEquals("GEARY", uinfo2.getLastName());
		assertEquals("", uinfo2.getMiddleName());
	}
	public void testFindUserInfoPrincipal() throws Exception {
		Subject subject = securityModule.getSubject();
		Set principals = subject.getPrincipals(IUserInfo.class);
		assertEquals(1, principals.size());
		IUserInfo uinfo = (IUserInfo) principals.iterator().next();

		assertEquals("JOREL", uinfo.getFirstName());
		assertEquals("GEARY", uinfo.getLastName());
		assertEquals("", uinfo.getMiddleName());
	}
	public void testFindMumpsInfoPrincipal() {
		Subject subject = securityModule.getSubject();
		Set principals = subject.getPrincipals(IMumpsUserInfo.class);
		assertEquals(1, principals.size());
		IMumpsUserInfo uinfo = (IMumpsUserInfo) principals.iterator().next();

		assertEquals("JOREL", uinfo.getFirstName());
		assertEquals("GEARY", uinfo.getLastName());
		assertEquals("", uinfo.getMiddleName());
	}
	protected void tearDown() throws Exception {
		securityModule.logout();
		super.tearDown();
	}
	private ISecurity securityModule;
}
