package gov.va.med.hds.cd.m.internal.vistalink.itest;

import gov.va.med.hds.cd.m.IMumps;
import gov.va.med.hds.cd.m.IMumpsFactory;
import gov.va.med.hds.cd.m.test.CallFactory;
import gov.va.med.hds.cd.m.test.TestConstants;
import gov.va.med.hds.cd.runtime.IPluginDescriptor;
import gov.va.med.hds.cd.runtime.test.RuntimeTestCase;
import gov.va.med.hds.cd.security.ISecurity;

public class RpcTimeoutOverrideTest extends RuntimeTestCase {
	public RpcTimeoutOverrideTest(String name) {
		super(name);
	}
	protected void setUp() throws Exception {
		super.setUp();
		parseRegistryResource(TestConstants.DEFAULT_REGISTRY_PATH);
		// This test exercises the rpc timeout override feature.
		// The override is specified in the settings file below.
		getRuntime().readSettings(getClass().getResourceAsStream("RpcTimeoutOverrideSettings.xml"));
		securityModule = (ISecurity) getRuntime().getPluginInstance(ISecurity.PLUGIN_ID);
		securityModule.login();
		IPluginDescriptor desc =
			getRuntime().getPluginRegistry().getPluginDescriptor(IMumpsFactory.PLUGIN_ID);
		IMumpsFactory factory =
			(IMumpsFactory) getRuntime().getPluginInstance(IMumpsFactory.PLUGIN_ID);
		mumps = factory.create(desc);
	}
	public void testCallSuiteAgainstRPCOverride() throws Exception {
		CallFactory.getInstance().executeCallSuite(mumps);
	}
	protected void tearDown() throws Exception {
		securityModule.logout();
		super.tearDown();
	}
	private static ISecurity securityModule = null;
	private IMumps mumps = null;
}
