package gov.va.med.hds.cd.m.internal.vistalink.itest;

import gov.va.med.hds.cd.m.IMumps;
import gov.va.med.hds.cd.m.IMumpsFactory;
import gov.va.med.hds.cd.m.test.CallFactory;
import gov.va.med.hds.cd.m.test.TestConstants;
import gov.va.med.hds.cd.runtime.IPluginDescriptor;
import gov.va.med.hds.cd.runtime.test.RuntimeTestCase;
import gov.va.med.hds.cd.security.ISecurity;

/**
 * Executes the RPC test calls against the Vistalink driver
 */
public class VistalinkCallTest extends RuntimeTestCase {

	public VistalinkCallTest(String arg0) {
		super(arg0);
	}

	protected void setUp() throws Exception {
		super.setUp();
		parseRegistryResource(TestConstants.DEFAULT_REGISTRY_PATH);
		getRuntime().readSettings(getClass().getResourceAsStream("VistalinkSettings.xml"));
		securityModule = (ISecurity) getRuntime().getPluginInstance(ISecurity.PLUGIN_ID);
		securityModule.login();
		IPluginDescriptor desc =
			getRuntime().getPluginRegistry().getPluginDescriptor(IMumpsFactory.PLUGIN_ID);
		IMumpsFactory factory =
			(IMumpsFactory) getRuntime().getPluginInstance(IMumpsFactory.PLUGIN_ID);
		mumps = factory.create(desc);
	}
	public void testCallSuite() throws Exception {
		CallFactory.getInstance().executeCallSuite(mumps);
	}
	protected void tearDown() throws Exception {
		securityModule.logout();
		super.tearDown();
	}
	private static ISecurity securityModule = null;
	private IMumps mumps = null;

}
