package gov.va.med.hds.cd.m.test;
import gov.va.med.hds.cd.m.CallQueueException;
import gov.va.med.hds.cd.m.ICallQueue;
import gov.va.med.hds.cd.m.ICallQueueFactory;
import gov.va.med.hds.cd.m.IMumpsListener;
import gov.va.med.hds.cd.m.IRPCLogListener;
import gov.va.med.hds.cd.m.ICallRequest;
import gov.va.med.hds.cd.runtime.IConfigurationElement;
import gov.va.med.hds.cd.runtime.IRuntimeContext;

import junit.framework.TestCase;

/**
 * Tests the ICallQueueFactory interface
 */
public class ICallQueueFactoryTest extends TestCase {
	public ICallQueueFactoryTest(String arg0) {
		super(arg0);
	}
	protected void setUp() throws Exception {
		super.setUp();
	}
	public void testCreate() {
		ICallQueue callQueue = new MockCallQueueFactory().create(null, null);
		assertNotNull(callQueue);
	}
	protected void tearDown() throws Exception {
		super.tearDown();
	}

	class MockCallQueueFactory implements ICallQueueFactory {
		public ICallQueue create(IRuntimeContext runtime, IConfigurationElement[] configs) {
			return new ICallQueue() {
				public void add(ICallRequest request, IMumpsListener listener)
					throws CallQueueException {
				}
				public String add(ICallRequest request) throws CallQueueException {
					return null;
				}
				public void addLogListener(IRPCLogListener listener) throws CallQueueException {
				}
				public void removeLogListener(IRPCLogListener listener) throws CallQueueException {
				}
				public String decrypt(String data) {
					return data;
				}
				public String encrypt(String data) {
					return data;
				}
				public void enableTimeLimitOverride(int rpcTimeoutOverride) {
				}
				public void disableTimeLimitOverride() {
				}
			};
		}
	}
}
