package gov.va.med.hds.cd.m;

/**
 * Used for pairing call requests with their expected results
 */
public abstract class CallRequestExpectedResultPair {
	/**
	 * Constructs from a request and call result
	 * @param request
	 * @param expectedResult
	 */
	public CallRequestExpectedResultPair(ICallRequest request, String expectedResult) {
		this.request = request;
		this.expectedResult = expectedResult;
	}
	public abstract boolean matchesExpectedResult(String result) throws Exception;

	public ICallRequest request;
	public String expectedResult;
}
