package gov.va.med.hds.cd.m;

/**
 * Provides an abstraction of a listener to a connect call
 */
public interface IConnectListener {
	
	/**
	 * Called by a connect processor when the connect attempt fails
	 * 
	 * @param request original connect request
	 * @param e thrown by the asynchronous connect request processor.
	 * This should generally be rethrown or handled by the listener.
	 */
	public void ConnectFailed(IConnectRequest request, Exception e);
	/**
	 * Called by a connect processor when the connect attempt succeeds.
	 * @param request original connect request
	 */
	public void ConnectSucceeded(IConnectRequest request);
}
