package gov.va.med.hds.cd.m;
/**
 * Abstracts a listener for Disconnect requests
 */
public interface IDisconnectListener {
	
	/**
	 * Called by a disconnect processor when a disconnect fails
	 * @param e thrown by the disconnect processor. 
	 * This exception should be handled or rethrown in this call.
	 */
	public void DisconnectFailed(DisconnectException e);
	
	/**
	 * Called by a disconnect processor when a disconnect succeeds
	 */
	public void DisconnectSucceeded();
}
