package gov.va.med.hds.cd.m;

/**
 * Abstracts M connection settings
 */
public interface IMumpsConnectionSettings {
	/**
	 * The debug setting is set
	 * @return
	 */
	boolean isDebug();
	/**
	 * Name of the M driver
	 * @return
	 */
	String getDriver();
	/**
	 * TCP connection port for the M connection
	 * @return
	 */
	int getPort();
	/**
	 * TCP connection server for the M connection
	 * @return
	 */
	String getServer();
	/**
	 * Should the user be prompted for credentials.
	 * If not hard coded credentials are assumed
	 * @return
	 */
	boolean isSilent();
	/**
	 * Should RPC calls be recorded and appended to the 
	 * configured record cache file
	 * @return
	 */
	boolean isRecordAppend();
	/**
	 * Name of the RPC record cache file
	 * @return
	 */
	String getRecordFileName();
	/**
	 * Is recording to an RPC cache file enabled
	 * @return
	 */
	boolean isRecord();
	/**
	 * Should all rpc timeeouts be overridden
	 */
	boolean isRpcTimeoutOverride();
	/**
	 * RPC timeout override value in milliseconds.
	 * Defaults to 0 if isRpcTimeoutOverride() returns false
	 * @return
	 */
	int getTimeoutOverride();
}