package gov.va.med.hds.cd.m;

import gov.va.med.hds.cd.runtime.IPluginDescriptor;

/**
 * Abstracts a plugin which provides connections to a MUMPS installation
 */
public interface IMumpsFactory{
	public final String SETTINGS_ROOT_ELEMENT_NAME = "mumpsConnection";
	public final String SETTINGS_SERVER_ELEMENT_NAME = "server";
	public final String SETTINGS_PORT_ELEMENT_NAME = "port";
	public final String SETTINGS_DRIVER_ELEMENT_NAME = "driver";
	public final String SETTINGS_RPC_TIMEOUT_OVERRIDE = "rpcTimeoutOverride";
	public final String SETTINGS_CONNECTION_ATTR_NAME = "connection";
	public final String SETTINGS_TEST_ATTR_NAME = "test";
	public final String SETTINGS_DEBUG_ATTR_NAME = "debug";
	public final String SETTINGS_RECORDPARAMS_ELEMENT_NAME = "recordParams";
	public final String SETTINGS_RECORD_ELEMENT_NAME = "record";
	public final String SETTINGS_FILENAME_ELEMENT_NAME = "fileName";
	public final String SETTINGS_APPEND_ELEMENT_NAME = "appendToFile";
	public final String SETTINGS_VISTALINK = "vistalink";
	public final String SETTINGS_BROKER = "broker";
	public final String SETTINGS_CACHE = "cache";
	public final String SETTINGS_CACHEPARAMS_ELEMENT_NAME = "cacheParams";
	public final String SETTINGS_RESOURCES_ELEMENT_NAME = "resources";
	public final String SETTINGS_RESOURCE_NAME_ELEMENT_NAME = "resourceName";
	public final String SETTINGS_USE_CALL_LATENCY_ELEMENT_NAME = "useCallLatency";
	
	/**
	 * The name of the plugin
	 */
	public static final String PLUGIN_ID = "gov.va.med.hds.cd.m";
	/**
	 * Name of the call queue extension
	 */
	public static final String CALLQUEUE_EXTENSION_NAME = "gov.va.med.hds.cd.m.callqueue";
	/**
	 * Call queue element name
	 */
	public static final String CALLQUEUE_ELEMENT_NAME = "callqueue";
	/** 
	 * Call queue class factory attribute name
	 */
	public static final String CALLQUEUE_CLASSFACTORY_ATTRIBUTE_NAME = "classFactory";
	
	/**
	 * Gets the server name
	 * @return
	 */
	public String getServerName();
	
	/**
	 * Gets the server port
	 * @return
	 */
	public int getServerPort();

	/**
	 * Creates an IMumps object based on the plugin descriptor
	 * @param descriptor
	 * @return
	 * @throws MumpsFactoryException
	 */
	public IMumps create(IPluginDescriptor descriptor) throws MumpsFactoryException;
}
