package gov.va.med.hds.cd.m;

/**
 * Abstracts a listener for a call queue request
 */
public interface IMumpsListener {
	
	/**
	 * Called by the ICallQueue request processor when the request fails
	 * 
	 * @param request the original request
	 * @param e the exception thrown due to the request
	 */
	public void CallFailed(ICallRequest request, MumpsException e);
	
	/**
	 * Called by the ICallQueue request processor when the request succeeds
	 * 
	 * @param request the original request
	 * @param result the result of processing the request
	 */
	public void CallSucceeded(ICallRequest request, String result);
}
