package gov.va.med.hds.cd.m;

import gov.va.med.hds.cd.mum.Version;
import gov.va.med.hds.cd.mum.VersionMatch;
import gov.va.med.hds.cd.runtime.IPluginDescriptor;

/**
 * Enumerates values need for a MUMPS option
 */
public interface IOptionContext {
	/**
	 * Option name
	 * @return
	 */
	String getName();
	/**
	 * Option version
	 * @return
	 */
	Version getVersion();
	/**
	 * Plugin descriptor associated with the option.
	 * Note that more than one plugin can be associated
	 * with the same option, but only one option can 
	 * be assigned to a plugin.
	 * @return
	 */
	IPluginDescriptor getPluginDescriptor();
	/**
	 * Version matching algorithm to use.
	 * @return
	 */
	VersionMatch getVersionMatch();
}
