package gov.va.med.hds.cd.mum.config;

import gov.va.med.hds.cd.mum.boot.utils.SimpleList;

import java.net.URL;

/**
 * Simple data class representing a plugin file's URL, as detected by the plugin
 * locator.  It also includes a list of packages contained in a jar file, if the
 * url is to a jar.
 */
public class ConfigFileEntry {

	/**
	 * Constructor for ConfigFileEntry.
	 */
	public ConfigFileEntry(URL url) {
		super();
		this.url = url;
	}

	private URL url;
	private SimpleList packages;

	/**
	 * Returns the packages in a jar, or null if there are no packages.
	 * @return List
	 */
	public SimpleList getPackages() {
		return packages;
	}

	/**
	 * Returns the file url.
	 * @return URL
	 */
	public URL getURL() {
		return url;
	}

	/**
	 * Sets the packages.
	 * @param packages The packages to set
	 */
	public void setPackages(SimpleList packages) {
		this.packages = packages;
	}

}
