package gov.va.med.hds.cd.mum.config;

import java.io.File;

/**
 * Creates an instance of the IConfigPluginLocator interface.
 */
public class ConfigPluginLocatorFactory {
	
	private static IConfigPluginLocator locator;

	/**
	 * Returns a new instance of the IApplicationLauncher
	 * @return IConfigPluginLocator
	 */
	public static IConfigPluginLocator newConfigPluginLocator(File rootDir, ClassDataCache cache) {
		if (locator == null)
			return new ConfigPluginLocator(rootDir, cache);
		else
			return locator;
	}

	/**
	 * Allows subsequent calls to newConfigPluginLocator to return a
	 * predetermined instance of the IConfigPluginLocator interface.  This is
	 * used primarily in unit testing.
	 * @param pluginLocator
	 */
	public static void assignConfigPluginLocator(IConfigPluginLocator pluginLocator) {
		locator = pluginLocator;
	}
}
