package gov.va.med.hds.cd.mum.config;

import gov.va.med.hds.cd.mum.IMUMConstants;
import gov.va.med.hds.cd.mum.boot.IPluginConstants;

/**
 * Constants used throughout the MUM.Config package.
 */
public interface IConfigConstants extends IMUMConstants {

    String IGNORE_ATTRIBUTE = "ignore";
    String IGNORE_UNAVAILABLE_VALUE = "unavailable";
    //	String IGNORE_UNRESOLVED_VALUE = "unresolved";
    //	String IGNORE_UNPUBLISHED_VALUE = "unpublished";
    //	String IGNORE_ALL_VALUE = "all";

    int IGNORE_NONE = 0;
    int IGNORE_UNAVAILABLE = 1;
    //	int IGNORE_UNRESOLVED = 2;
    //	int IGNORE_UNPUBLISHED = 4;
    //	int IGNORE_ALL_VALUE = 8;

    String BAD_FILE = "Invalid Class File";
    String FILE_IO_ERROR = "IO Error Reading File Stream";

    String MISSING_PLUGIN_ID = "No plugin ID specified";

    String MULTIPLE_DISTRIBUTION_SECTIONS =
        MULTIPLE_TXT + DISTRIBUTION_ELEMENT + MANIFEST_SECTION_FOUND_TXT;

    String MULTIPLE_PUBLISHED_SECTIONS =
        MULTIPLE_TXT + IPluginConstants.PUBLISHED_ELEMENT + MANIFEST_SECTION_FOUND_TXT;

    String INVALID_FILE_ENTRY =
        INVALID_TXT + FILENAME_ATTRIBUTE + ENTRY_TEXT + DISTRIBUTION_ELEMENT + MANFIEST_SECTION_TXT;

    String INVALID_PUBLISHED_ENTRY =
        INVALID_TXT
            + IPluginConstants.PUBLISH_ELEMENT
            + ENTRY_TEXT
            + IPluginConstants.PUBLISHED_ELEMENT
            + MANFIEST_SECTION_TXT;

    String CLASS_NOT_FOUND = " published class not found";

    String ILLEGAL_BOOT_DEPENDENCY_START = BOOT_JAR + " has a dependency on ";
    String ILLEGAL_BOOT_DEPENDENCY_END =
        ".  "
            + BOOT_JAR
            + " can not have dependencies on classes outside the "
            + BOOT_PACKAGE
            + " package";

    String INVALID_WILDCARD = "* only allowed at the end of a published class";

    String NO_CLASSES_FOUND = "No published classes found under ";

    String LOCATOR_NOT_INITIALIZED = "PluginLocator object has not been propertly intiailized";

    String PLUGIN_DIRECTORY_NOT_FOUND = PLUGIN_DIRECTORY_NAME + " directory not found";

    String PLUGIN_IMPLEMENTING_TXT = "  Plugins found implementing the ";
    String PLUGIN_REQUIRING_DEPENDENCY_TXT = "requiring dependency";
    String PLUGIN_EXTENDING_EXTENSION_POINT_TXT = "extending extension point";
    String PLUGIN_IMPLEMENTING_EXTENSION_POINT_TXT = "implementing extension point";
    String PLUGIN_SATISFYING_DEPENDENCY_TXT = "satisfying dependency";
    String PLUGIN_SATISFYING_UNPUBLISHED_DEPENDENCY_TXT =
        "satisfying dependency if class were published";
    String PLUGIN_DEPENDENCY_TXT = "Plugin dependency: ";
    String CLASS_DEPENDENCY_TXT = "Class dependency: ";
	String DECLARED_CLASS_DEPENDENCY_TXT = "Manifest declared class dependency: ";
    String EXENSION_POINT_TXT = "Extension point: ";
    String CLASS_TXT = "Class: ";
    String MULTIPLE_PLUGIN_IMPLEMENTS_TXT = "More than one plugin implements the ";
    String MULTI_VERSION_DEPENDENCY_TXT =
        "Exported dependencies have resulted in multiple versions of the same plugin being required.";

    String MULTIPLE_STARTUP_PLUGINS_TXT =
        MULTIPLE_PLUGIN_IMPLEMENTS_TXT + STARTUP_INTERFACE_NAME + INTERFACE_TXT;

    String MULTIPLE_APPLICATION_PLUGINS_TXT =
        MULTIPLE_PLUGIN_IMPLEMENTS_TXT + APPLICATION_INTERFACE_NAME + INTERFACE_TXT;

    String STARTUP_PLUGIN_MISSING_BOOT_TXT =
        "The startup plugin does not have the required " + BOOT_JAR + " file";

    String JVM_PATH_PROPERTY = "sun.boot.class.path";

    String MISSING_STARTUP_PLUGIN_ERROR_DESCRIPTION = "Configuration is missing a startup plugin.";
    String MISSING_APPLICATION_PLUGIN_ERROR_DESCRIPTION =
        "Configuration is missing an application plugin.";
    String MULTIPLE_STARTUP_PLUGINS_ERROR_DESCRIPTION =
        "More than one plugin specified as a startup plugin.";
    String MULTIPLE_APPLICATION_PLUGINS_ERROR_DESCRIPTION =
        "More than one plugin specified as an application plugin.";
    String UNAVAILABLE_DEPENDENT_PLUGIN_ERROR_DESCRIPTION =
        "No plugin satisfies required plugin dependency.";
    String UNAVAILABLE_DEPENDENT_CLASS_ERROR_DESCRIPTION =
        "No plugin implements required class dependency.";
    String UNRESOLVED_DEPENDENT_PLUGIN_ERROR_DESCRIPTION =
        "Required plugin dependency available but not satisfied in the configuration.";
    String UNREACHABLE_DEPENDENT_CLASS_ERROR_DESCRIPTION =
        "Plugin implementing needed class not listed as a required plugin.";
	String UNRESOLVED_DEPENDENT_CLASS_ERROR_DESCRIPTION =
		"Plugin implementing needed class not specified as part of the configuration.";
    String UNPUBLISHED_DEPENDENT_CLASS_ERROR_DESCRIPTION =
        "Required class available but not published by the providing plugin.";
    String STARTUP_PLUGIN_MISSING_BOOT_JAR_ERROR_DESCRIPTION = "Invalid startup plugin.";
    String CYCLIC_DEPENDENCY_ERROR_DESCRIPTION =
        "The following cyclic dependency chain has been detected:";
    String MULTI_VERSION_DEPENDENCY_ERROR_DESCRIPTION =
        "Multiple versions of the same plugin required.";
    String UNAVAILABLE_EXTENSION_POINT_ERROR_DESCRIPTION =
        "Plugin specifies an extension on a non-existant extension point.";
    String UNREACHABLE_EXTENSION_POINT_ERROR_DESCRIPTION =
        "Plugin implementing extension point not listed as a required plugin.";
	String UNRESOLVED_EXTENSION_POINT_ERROR_DESCRIPTION =
		"Plugin implementing extension point not specified as part of the configuration.";
	String MULTI_VERSION_HAS_EXTENSIONS_DESCRIPTION =
		"When multiple versions of the same plugin exists, none can have extensions or extension points";
}
