package gov.va.med.hds.cd.mum.config;

import gov.va.med.hds.cd.mum.boot.utils.ListMap;

/**
 * Used to locate plugins in the gold directory.
 */
public interface IConfigPluginLocator {

	/**
	 * Populates the passed in list with IConfigPlugin objects (created by
	 * calling the IConfigPluginFactory above). Each IConfigPlugin object represents
	 * a jar file available to the unit manager, and any of it's child
	 * configurations.
	 * @param list - the list to populate
	 * @throws PluginLocatorException
	 */
	void createDistributionPlugins(ListMap list) throws PluginLocatorException;
}
