/*
 * Created on May 2, 2003
 *
 * To change the template for this generated file go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package gov.va.med.hds.cd.mum.config;

import gov.va.med.hds.cd.mum.*;
import gov.va.med.hds.cd.mum.IDependentPlugin;
import gov.va.med.hds.cd.mum.PluginID;
import gov.va.med.hds.cd.mum.boot.utils.SimpleList;

import java.util.HashMap;
import java.util.Map;

/**
 * @author vhaislmerrij
 *
 * To change the template for this generated type comment go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
public class PluginDependency {

    private static Map map = new HashMap();
    private PluginID id;
    private VersionMatch condition;
    private SimpleList plugins;
    private boolean export;
    private String key;

    private static String exportValue(boolean export) {
        if (export)
            return "EXPORT";
        else
            return "";
    }

    private static final String delim = ".*.";
    private static StringBuffer buffer;

    public static PluginDependency getDependency(PluginID id, String matches, boolean export) {
        if (id == null)
            throw new NullPointerException();
        if(buffer == null)
        	buffer = new StringBuffer();
        VersionMatch match = VersionMatch.getVersionMatch(matches);
        buffer.setLength(0);
        buffer.append(id);
		buffer.append(delim);
		buffer.append(match.toString());
		buffer.append(delim);
		buffer.append(exportValue(export));
		String key = buffer.substring(0, buffer.length());
        PluginDependency dependency = (PluginDependency) map.get(key);
        if (dependency == null) {
            dependency = new PluginDependency(id, match, export, key);
            map.put(key, dependency);
        }
        return dependency;
    }

    private PluginDependency(PluginID id, VersionMatch condition, boolean export, String key) {
        super();
        this.id = id;
        this.condition = condition;
        this.export = export;
        this.key = key;
        plugins = new SimpleList();
    }

    /**
     * Returns the PluginID of this dependency
     */
    public PluginID getPluginID() {
        return id;
    }

    /**
     * @return the version match condition for this dependency
     */
    public VersionMatch getMatchCondition() {
        return condition;
    }

	
    /**
     * Returns true if this dependency is satisified by the indicated pluginID
     * @return
     */
    public boolean satisifiedBy(PluginID pluginID) {
        if (pluginID.getID().equals(id.getID()))
            return condition.matches(pluginID.getVersion(), id.getVersion());
        else
            return false;
    }

    /**
     * Returns the plugin that satisfies this dependency, if assigned by setPlugin
     */
    public SimpleList getPlugins() {
        return plugins;
    }

    /**
     * Assigns a plugin that is specified as satisfying this dependency
     */
    public void addPlugin(IDependentPlugin plugin) {
        plugins.add(plugin);
    }

    public boolean export() {
        return export;
    }
    
    public String getKey() {
    	return key;
    }
    
    private Object data; 

    
    public Object getData() {
        return data;
    }

    public void setData(Object object) {
        data = object;
    }

}
