package gov.va.med.hds.cd.mum.config;

/**
 * Creates an instance of the IPluginManager interface.
 */
public class PluginManagerFactory {

	private static IPluginManager manager;

	/**
	 * Returns a new instance of the IPluginManager
	 * @return IPluginManager
	 */
	public static IPluginManager newPluginManager() {
		if (manager == null)
			return new PluginManager();
		else
			return manager;
	}

	/**
	 * Allows subsequent calls to newPluginManager to return a predetermined
	 * instance of the IPluginManager interface.  This is used primarily in unit
	 * testing.
	 * @param pluginManager
	 */
	public static void assignPluginManager(IPluginManager pluginManager) {
		manager = pluginManager;
	}
}
