/*
 * Created on May 13, 2003
 *
 * To change the template for this generated file go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package gov.va.med.hds.cd.mum.boot.utils.test;

import gov.va.med.hds.cd.mum.boot.utils.KeyedList;
import gov.va.med.hds.cd.mum.boot.utils.ListMap;
import gov.va.med.hds.cd.mum.boot.utils.SimpleList;

import java.util.ArrayList;
import java.util.List;

import junit.framework.TestCase;

/**
 * @author vhaislmerrij
 *
 * To change the template for this generated type comment go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
public class ListTest extends TestCase {
	
    public void testSimpleList() {
        SimpleList list = new SimpleList();
        assertEquals(0, list.size());
        Object one = new Object();
        Object two = new Object();
        Object three = "testing";
        assertFalse(list.contains(one));
        assertFalse(list.contains(two));
        assertFalse(list.contains(three));
        list.add(one);
        assertEquals(1, list.size());
        list.add(two);
        assertEquals(2, list.size());
        list.add(one);
        list.add(two);
        assertEquals(2, list.size());
        list.add(three);
        assertEquals(3, list.size());
        list.add(one);
        list.add(two);
        list.add(null);
        list.add(three);
        assertEquals(3, list.size());
        assertTrue(list.contains(one));
        assertTrue(list.contains(two));
        assertTrue(list.contains(three));

        list.remove(two);
        assertEquals(2, list.size());
        assertTrue(list.contains(one));
        assertFalse(list.contains(two));
        assertTrue(list.contains(three));

        list.add(two);
        assertEquals(3, list.size());
        assertTrue(list.contains(one));
        assertTrue(list.contains(two));
        assertTrue(list.contains(three));

        int idx = list.getList().indexOf(three);
        list.remove(idx);
        assertEquals(2, list.size());
        assertTrue(list.contains(one));
        assertTrue(list.contains(two));
        assertFalse(list.contains(three));

        list.clear();
        assertEquals(0, list.size());
        assertFalse(list.contains(one));
        assertFalse(list.contains(two));
        assertFalse(list.contains(three));

        String s1 = "1";
        String s2 = "2";
        String s3 = "3";
        String s4 = "4";
        String s5 = "5";
        String s6 = "6";
        String s7 = "7";
        list.add(s1);
        list.add(s2);
        list.add(s3);
        list.add(s4);
        list.add(s5);
        list.add(s6);
        list.add(s7);
        assertEquals(7, list.size());
        assertTrue(list.contains(s1));
        assertTrue(list.contains(s2));
        assertTrue(list.contains(s3));
        assertTrue(list.contains(s4));
        assertTrue(list.contains(s5));
        assertTrue(list.contains(s6));
        assertTrue(list.contains(s7));
        list.setLength(6);
        assertEquals(6, list.size());
        assertTrue(list.contains(s1));
        assertTrue(list.contains(s2));
        assertTrue(list.contains(s3));
        assertTrue(list.contains(s4));
        assertTrue(list.contains(s5));
        assertTrue(list.contains(s6));
        assertFalse(list.contains(s7));
        list.setLength(4);
        assertEquals(4, list.size());
        assertTrue(list.contains(s1));
        assertTrue(list.contains(s2));
        assertTrue(list.contains(s3));
        assertTrue(list.contains(s4));
        assertFalse(list.contains(s5));
        assertFalse(list.contains(s6));
        assertFalse(list.contains(s7));
        list.setLength(0);
        assertEquals(0, list.size());
        assertFalse(list.contains(s1));
        assertFalse(list.contains(s2));
        assertFalse(list.contains(s3));
        assertFalse(list.contains(s4));
        assertFalse(list.contains(s5));
        assertFalse(list.contains(s6));
        assertFalse(list.contains(s7));
        try {
            list.setLength(1);
            fail("Should have thrown IndexOutOfBoundsException");
        } catch (IndexOutOfBoundsException e) {
        }
    }

    public void testKeyedList() {
        KeyedList list = new KeyedList();
        assertEquals(0, list.size());
        try {
            list.get(0);
            fail("Should have thrown IndexOutOfBoundsException");
        } catch (IndexOutOfBoundsException e) {
        }
        assertEquals(0, list.getKeys().size());
        list.add("one", "two");
        assertEquals(1, list.size());
        assertEquals("two", list.get(0));
        assertEquals("two", list.get("one"));
        list.add("three", "four");
        assertEquals(2, list.size());
        assertEquals("four", list.get(1));
        assertEquals("four", list.get("three"));
        list.add("one", "five");
        assertEquals(2, list.size());
        assertEquals("two", list.get(0));

        assertEquals(2, list.getKeys().size());
        assertTrue(list.getKeys().contains("one"));
        assertTrue(list.getKeys().contains("three"));
        assertFalse(list.getKeys().contains("four"));
        assertFalse(list.getKeys().contains("fdsaf"));

        assertTrue(list.containsKey("one"));
        assertTrue(list.containsKey("three"));
        assertFalse(list.containsKey("four"));
        assertFalse(list.containsKey("fdsaf"));
        assertFalse(list.containsKey(null));

        assertTrue(list.containsValue("two"));
        assertTrue(list.containsValue("four"));
        assertFalse(list.containsValue("three"));
        assertFalse(list.containsValue("one"));
        assertFalse(list.containsValue("12345456s"));

		list.add("one", "testing");
		assertEquals(2, list.size());
		assertTrue(list.containsKey("one"));
		assertTrue(list.containsValue("two"));
		assertFalse(list.containsValue("testing"));
		
        list.update("one", "xyz");
        assertEquals(2, list.size());
        assertTrue(list.containsKey("one"));
        assertFalse(list.containsValue("two"));
        assertTrue(list.containsValue("xyz"));

        list.remove("one");
        assertEquals(1, list.size());
        assertFalse(list.containsKey("one"));
        assertFalse(list.containsValue("xyz"));

        list.clear();
        assertEquals(0, list.size());
        assertEquals(0, list.getKeys().size());
        assertFalse(list.containsKey("aaa"));
        assertFalse(list.containsValue("bbb"));
    }

    public void testListMap() {
        ListMap list = new ListMap();
        assertEquals(0, list.size());
        assertEquals(0, list.get("x").size());
        assertEquals(0, list.get(null).size());
        try {
            list.get(0);
            fail("Should have thrown IndexOutOfBoundsException");
        } catch (IndexOutOfBoundsException e) {
        }
        try {
            list.add("abc", new ArrayList());
            fail("Should have thrown IllegalArgumentException");
        } catch (IllegalArgumentException e) {
        }
        assertEquals(0, list.getKeys().size());
        List temp = list.add("aaa", "bbb");
        assertEquals(list.get("aaa"), temp);

        assertEquals(1, list.size());
        assertEquals("bbb", list.get(0));
        assertEquals(1, list.get("aaa").size());
        assertEquals("bbb", list.get("aaa").get(0));
        list.add("ccc", "ddd");
        assertEquals(2, list.size());
        assertEquals("ddd", list.get(1));
        assertEquals(1, list.get("ccc").size());
        assertEquals("ddd", list.get("ccc").get(0));
        list.add("aaa", "eee");
        assertEquals(3, list.size());
        assertEquals("eee", list.get(2));
        assertEquals(2, list.get("aaa").size());
        assertEquals("bbb", list.get("aaa").get(0));
        assertEquals("eee", list.get("aaa").get(1));
        list.add("aaa", "xyz");
        assertEquals(4, list.size());
        assertEquals("xyz", list.get(3));
        assertEquals(3, list.get("aaa").size());
        assertEquals("bbb", list.get("aaa").get(0));
        assertEquals("eee", list.get("aaa").get(1));
        assertEquals("xyz", list.get("aaa").get(2));

        assertEquals(2, list.getKeys().size());
        assertTrue(list.getKeys().contains("aaa"));
        assertTrue(list.getKeys().contains("ccc"));
        assertFalse(list.getKeys().contains("xyz"));

        assertTrue(list.containsKey("aaa"));
        assertTrue(list.containsKey("ccc"));
        assertFalse(list.containsKey("xyz"));
        assertFalse(list.containsKey("12315"));
        assertFalse(list.containsKey(null));

        assertTrue(list.containsValue("bbb"));
        assertTrue(list.containsValue("ddd"));
        assertTrue(list.containsValue("eee"));
        assertTrue(list.containsValue("xyz"));
        assertFalse(list.containsValue("aaa"));
        assertFalse(list.containsValue("ccc"));
        assertFalse(list.containsValue("12345456s"));

        list.remove("aaa", "eee");
        assertEquals(3, list.size());
        assertEquals(2, list.get("aaa").size());
        assertEquals("bbb", list.get("aaa").get(0));
        assertEquals("xyz", list.get("aaa").get(1));
        list.remove("123456", "sdfsaf");
        assertEquals(3, list.size());

        list.clear();
        assertEquals(0, list.size());
        assertEquals(0, list.getKeys().size());
        assertFalse(list.containsKey("aaa"));
        assertFalse(list.containsValue("bbb"));

        Object test = new Object();
        list.add("testing", test);
        assertEquals(1, list.size());
        list.add("testing", test);
        assertEquals(1, list.size());
        assertEquals(1, list.get("testing").size());
        list.add("testing2", test);
        assertEquals(2, list.size());
        list.add("testing", "hi there");
        assertEquals(3, list.size());
        assertEquals(2, list.get("testing").size());
        assertEquals(test, list.get("testing").get(0));
        assertEquals("hi there", list.get("testing").get(1));
        
        list.clear();
        list.add("a","c");
		list.add("a","d");
		list.add("b","e");
		list.add("b","f");
		assertEquals(4, list.size());
		assertEquals(2, list.getKeys().size());
		assertTrue(list.containsKey("a"));
		assertTrue(list.containsKey("b"));
		assertTrue(list.containsValue("c"));
		assertTrue(list.containsValue("d"));
		assertTrue(list.containsValue("e"));
		assertTrue(list.containsValue("f"));
		list.removeList("a");
		assertEquals(2, list.size());
		assertEquals(1, list.getKeys().size());
		assertFalse(list.containsKey("a"));
		assertTrue(list.containsKey("b"));
		assertFalse(list.containsValue("c"));
		assertFalse(list.containsValue("d"));
		assertTrue(list.containsValue("e"));
		assertTrue(list.containsValue("f"));

    }

    //********************
    //*** end of tests ***
    //********************
    public ListTest(String name) {
        super(name);
    }

    protected void setUp() throws Exception {
        super.setUp();
    }

    protected void tearDown() throws Exception {
        super.tearDown();
    }

}
