/*
 * Created on May 2, 2003
 *
 * To change the template for this generated file go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package gov.va.med.hds.cd.mum.config.test;

import gov.va.med.hds.cd.mum.IMUMConstants;
import gov.va.med.hds.cd.mum.PluginID;
import gov.va.med.hds.cd.mum.VersionFormatException;
import gov.va.med.hds.cd.mum.VersionMatch;
import gov.va.med.hds.cd.mum.boot.IPluginConstants;
import gov.va.med.hds.cd.mum.config.PluginDependency;
import junit.framework.TestCase;

/**
 * @author vhaislmerrij
 *
 * To change the template for this generated type comment go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
public class PluginDependencyTest extends TestCase {

    public void testPluginDependencies() {
        String name = "testing";
        String name2 = "testing2";
        PluginID id = PluginID.getPluginID(name, "1.2.3");
        PluginDependency dep = PluginDependency.getDependency(id, null, false);
        assertEquals(id, dep.getPluginID());
        assertEquals(VersionMatch.DEFAULT_MATCH_CONDITION, dep.getMatchCondition());
        assertFalse(dep.export());
        dep = PluginDependency.getDependency(id, "", true);
        assertEquals(id, dep.getPluginID());
        assertEquals(VersionMatch.DEFAULT_MATCH_CONDITION, dep.getMatchCondition());
		assertTrue(dep.export());
        dep =
            PluginDependency.getDependency(
                id,
                IPluginConstants.GREATER_OR_EQUAL_MATCH_CONDITION,
                false);
        assertEquals(id, dep.getPluginID());
        assertEquals(VersionMatch.GREATER_OR_EQUAL, dep.getMatchCondition());
        assertFalse(dep.satisifiedBy(PluginID.getPluginID(name, "0.0.0")));
        assertFalse(dep.satisifiedBy(PluginID.getPluginID(name, "1.2.2")));
        assertTrue(dep.satisifiedBy(PluginID.getPluginID(name, "1.2.3")));
        assertTrue(dep.satisifiedBy(PluginID.getPluginID(name, "1.2.4")));
        assertTrue(dep.satisifiedBy(PluginID.getPluginID(name, "1.3.3")));
        assertTrue(dep.satisifiedBy(PluginID.getPluginID(name, "2.2.3")));
        assertFalse(dep.satisifiedBy(PluginID.getPluginID(name2, "1.2.3")));
        dep =
            PluginDependency.getDependency(id, IPluginConstants.COMPATIBLE_MATCH_CONDITION, false);
        assertEquals(id, dep.getPluginID());
        assertEquals(VersionMatch.COMPATIBLE, dep.getMatchCondition());
        assertFalse(dep.satisifiedBy(PluginID.getPluginID(name, "0.0.0")));
        assertFalse(dep.satisifiedBy(PluginID.getPluginID(name, "1.2.2")));
        assertTrue(dep.satisifiedBy(PluginID.getPluginID(name, "1.2.3")));
        assertTrue(dep.satisifiedBy(PluginID.getPluginID(name, "1.2.4")));
        assertTrue(dep.satisifiedBy(PluginID.getPluginID(name, "1.3.3")));
        assertFalse(dep.satisifiedBy(PluginID.getPluginID(name, "2.2.3")));
        assertFalse(dep.satisifiedBy(PluginID.getPluginID(name2, "1.2.3")));
        dep =
            PluginDependency.getDependency(id, IPluginConstants.EQUIVALENT_MATCH_CONDITION, false);
        assertEquals(id, dep.getPluginID());
        assertEquals(VersionMatch.EQUIVALENT, dep.getMatchCondition());
        assertFalse(dep.satisifiedBy(PluginID.getPluginID(name, "0.0.0")));
        assertFalse(dep.satisifiedBy(PluginID.getPluginID(name, "1.2.2")));
        assertTrue(dep.satisifiedBy(PluginID.getPluginID(name, "1.2.3")));
        assertTrue(dep.satisifiedBy(PluginID.getPluginID(name, "1.2.4")));
        assertFalse(dep.satisifiedBy(PluginID.getPluginID(name, "1.3.3")));
        assertFalse(dep.satisifiedBy(PluginID.getPluginID(name, "2.2.3")));
        assertFalse(dep.satisifiedBy(PluginID.getPluginID(name2, "1.2.3")));
        dep = PluginDependency.getDependency(id, IPluginConstants.PERFECT_MATCH_CONDITION, false);
        assertEquals(id, dep.getPluginID());
        assertEquals(VersionMatch.PERFECT, dep.getMatchCondition());
        assertFalse(dep.satisifiedBy(PluginID.getPluginID(name, "0.0.0")));
        assertFalse(dep.satisifiedBy(PluginID.getPluginID(name, "1.2.2")));
        assertTrue(dep.satisifiedBy(PluginID.getPluginID(name, "1.2.3")));
        assertFalse(dep.satisifiedBy(PluginID.getPluginID(name, "1.2.4")));
        assertFalse(dep.satisifiedBy(PluginID.getPluginID(name, "1.3.3")));
        assertFalse(dep.satisifiedBy(PluginID.getPluginID(name, "2.2.3")));
        assertFalse(dep.satisifiedBy(PluginID.getPluginID(name2, "1.2.3")));
        try {
            PluginDependency.getDependency(id, "fjdkslafjkdsf", false);
            fail("Should have thrown VersionFormatException");
        } catch (VersionFormatException e) {
            assertTrue(e.getMessage().startsWith(IMUMConstants.UNKNOWN_VERSION_MATCH_ERROR));
        }
        try {
            dep = PluginDependency.getDependency(null, null, false);
            fail("Should have thrown NullPointerException");
        } catch (NullPointerException e) {
        }
    }

    /**
     * Constructor for PluginIDDependencyTest.
     * @param arg0
     */
    public PluginDependencyTest(String arg0) {
        super(arg0);
    }

    /*
     * @see TestCase#setUp()
     */
    protected void setUp() throws Exception {
        super.setUp();
    }

    /*
     * @see TestCase#tearDown()
     */
    protected void tearDown() throws Exception {
        super.tearDown();
    }

}
