package gov.va.med.hds.cd.mum.config.test;

import gov.va.med.hds.cd.mum.boot.utils.ListMap;
import gov.va.med.hds.cd.mum.config.ConfigPluginFactory;
import gov.va.med.hds.cd.mum.config.ConfigPluginLocatorFactory;
import gov.va.med.hds.cd.mum.config.IConfigConstants;
import gov.va.med.hds.cd.mum.config.IConfigPluginLocator;
import gov.va.med.hds.cd.mum.config.PluginLocatorException;

import java.io.File;

import junit.framework.TestCase;

public class PluginLocatorTest extends TestCase implements IConfigConstants {

    public void testNoFactory() {
        IConfigPluginLocator locator =
            ConfigPluginLocatorFactory.newConfigPluginLocator(null, null);
        try {
            locator.createDistributionPlugins(null);
            fail("Should have thrown PluginLocatorException");
        } catch (PluginLocatorException e) {
            assertEquals(LOCATOR_NOT_INITIALIZED, e.getMessage());
        }
        try {
            locator.createDistributionPlugins(null);
            fail("Should have thrown PluginLocatorException");
        } catch (PluginLocatorException e) {
            assertEquals(LOCATOR_NOT_INITIALIZED, e.getMessage());
        }
        File file = new File("/fjsjlafds.afsda.fasd.fasd.fsaf234");
        locator = ConfigPluginLocatorFactory.newConfigPluginLocator(file, null);
        ListMap list = new ListMap();
        try {
            locator.createDistributionPlugins(list);
            fail("Should have thrown PluginLocatorException");
        } catch (PluginLocatorException e) {
            assertEquals(PLUGIN_DIRECTORY_NOT_FOUND, e.getMessage());
        }
    }
    //********************
    //*** end of tests ***
    //********************

    public PluginLocatorTest(String arg0) {
        super(arg0);
    }

    protected void setUp() throws Exception {
        super.setUp();
        ConfigPluginFactory.setEnabled(false);
    }

    protected void tearDown() throws Exception {
        super.tearDown();
        ConfigPluginFactory.setEnabled(true);
    }
}
