package gov.va.med.hds.cd.mum.config.test;

import gov.va.med.hds.cd.mum.InvalidPluginException;
import gov.va.med.hds.cd.mum.boot.utils.ListMap;
import gov.va.med.hds.cd.mum.config.ConfigPluginFactory;
import gov.va.med.hds.cd.mum.config.ConfigPluginLocator;
import gov.va.med.hds.cd.mum.config.IConfigPlugin;
import gov.va.med.hds.cd.mum.config.PluginLocatorException;

import java.net.URL;
import java.util.ArrayList;
import java.util.List;

public class RedirectedPluginLocator extends ConfigPluginLocator {

    private List plugins;

    public RedirectedPluginLocator() {
        super(null, null);
        plugins = new ArrayList();
    }

    public void addPlugin(URL manifest) {
        plugins.add(manifest);
    }

    public void createDistributionPlugins(ListMap list) throws PluginLocatorException {
        for (int i = 0; i < plugins.size(); i++) {
            try {
                IConfigPlugin plugin =
                    ConfigPluginFactory.newConfigPlugin(null, (URL) plugins.get(i));
                list.add(plugin.getID(), plugin);
            } catch (InvalidPluginException e) {
                throw new PluginLocatorException(e);
            }
        }

    }
}
