package gov.va.med.hds.cd.mum.loader.test;

import gov.va.med.hds.cd.mum.InvalidConfigurationException;
import gov.va.med.hds.cd.mum.boot.utils.ITreeData;
import gov.va.med.hds.cd.mum.boot.utils.Utils;
import gov.va.med.hds.cd.mum.update.PluginSpec;
import gov.va.med.hds.cd.mum.update.SpecFileEntry;

import java.io.File;
import java.io.IOException;
import java.net.URL;
import java.util.Enumeration;
import java.util.zip.ZipEntry;
import java.util.zip.ZipException;
import java.util.zip.ZipFile;

public class TestPluginSpec extends PluginSpec {

    private URL newManifestURL;
    private File[] files;

    public TestPluginSpec(ITreeData xml, int plugin, URL manifest, File[] files)
        throws InvalidConfigurationException {
        super(xml, plugin);
        newManifestURL = manifest;
        this.files = new File[getFileCount()];
        for (int i = 0; i < files.length; i++) {
            this.files[i + 1] = files[i];
            SpecFileEntry specEntry = getFile(i+1);
            try {
                ZipFile zip = new ZipFile(files[i]);
                for (Enumeration enum = zip.entries(); enum.hasMoreElements();) {
                    ZipEntry entry = (ZipEntry) enum.nextElement();
					specEntry.addPackage(Utils.getPackageFromZipEntry(entry));
                }
                zip.close();
            } catch (ZipException e) {
            } catch (IOException e) {
            }

        }
    }

    public File getPhysicalFile(int index) {
    	if(files == null)
    		return null;
        return files[index];
    }

    public File[] getFiles(File rootDirectory) {
        return files;
    }

    public URL[] getURLs(File rootDirectory) {
        return null;
    }

    public URL getManifestURL() {
        return newManifestURL;
    }

}
