package gov.va.med.hds.cd.mum.test;

import gov.va.med.hds.cd.mum.IMUMConstants;
import gov.va.med.hds.cd.mum.boot.IBootConstants;
import gov.va.med.hds.cd.mum.boot.IPluginConstants;

public interface IMUMTestConstants extends IMUMConstants, IBootConstants, IPluginConstants {

    int mjEditor1 = 0;
    int mjEditor2 = 1;
    int mjEditor3 = 2;
    int mjEditor4 = 3;
    int mjNoteCore1 = 4;
    int mjNoteCore2 = 5;
    int mjTemplates1 = 6;
    int mjTemplatesCore = 7;
    int mjTemplateFields1 = 8;
    int mjTemplateFields2 = 9;
    int mjEncounters = 10;
    int mjEncounterForms = 11;
    int mjInMedOrders = 12;
    int mjOutMedOrders = 13;
    int mjMedCore = 14;
    int mjRemCore = 15;
    int mjRemDialogs1 = 16;
    int mjRemDialogs2 = 17;
    int mjLib1 = 18;
    int mjLib2 = 19;
    int mjRuntime = 20;

    int[] STARTUP_PACKAGES = { mjEditor1, mjNoteCore1, mjEditor3 };
    int[] APPLICATION_PACKAGES = { mjTemplateFields1, mjNoteCore1, mjNoteCore2 };

    int[] GOOD_CONFIG =
        {
            mjInMedOrders,
            mjLib1,
            mjLib2,
            mjNoteCore1,
            mjEditor4,
            mjMedCore,
            mjOutMedOrders,
            mjEncounters,
            mjEncounterForms,
            mjRemDialogs2,
            mjRemCore,
            mjRuntime,
            mjTemplatesCore,
            mjTemplateFields2,
            mjTemplates1 };

    int[] EXISTING_CONFIG =
        {
            mjEditor3,
            mjNoteCore2,
            mjLib1,
            mjEncounters,
            mjEncounterForms,
            mjRemCore,
            mjRemDialogs1,
            mjRuntime };

    int[] ALL_PLUGINS =
        {
            mjEditor1,
            mjEditor2,
            mjEditor3,
            mjEditor4,
            mjNoteCore1,
            mjNoteCore2,
            mjTemplates1,
            mjTemplatesCore,
            mjTemplateFields1,
            mjTemplateFields2,
            mjEncounters,
            mjEncounterForms,
            mjInMedOrders,
            mjOutMedOrders,
            mjMedCore,
            mjRemCore,
            mjRemDialogs1,
            mjRemDialogs2,
            mjLib1,
            mjLib2,
            mjRuntime,
            };

    int[][] GOOD_CONFIG_PREREQUISITE_PLUGINS = { { mjNoteCore1, mjLib2 }, // mjEditor4
        {
            mjRuntime }, // mjNoteCore1
        {
        }, // mjLib1
        {
        }, // mjLib2
        {
            mjTemplatesCore }, // mjTemplates1
        {
        }, // mjTemplatesCore
        {
            mjTemplatesCore, mjRuntime }, // mjTemplateFields2
        {
            mjEncounters, mjLib2 }, // mjEncounterForms
        {
            mjLib2 }, // mjEncounters
        {
            mjLib2 }, // mjRemCore
        {
            mjRemCore, mjOutMedOrders, mjInMedOrders, mjEncounters, mjMedCore }, // mjRemDialogs2
        {
            mjMedCore }, // mjInMedOrders
        {
            mjMedCore }, // mjOutMedOrders
        {
        }, // mjMedCore
        {
        } // mjRuntime
    };

    int miDir = 0;
    int miGoldDir = 1;
    int miModule = 2;
    int miRequiredPlugins = 3;
    int miPackages = 4;
    int miRequiredPackages = 5;
    int miPublishedStatements = 6;
    int miAdditionalClasses = 7;

    Object[][] MOCKJAR_DATA = { { // mjEditor1
            "NoteEditor_1.0.0",
                "NoteEditor1",
                "MoreNotes",
                new String[] { "Runtime_1", "NoteCore_1", "NoteTest_0.7534" },
                new String[] { "tiu.notes.editor" },
                new String[] { "tiu.notes.editor", "tiu.notes.internal", "something.not.found" },
                new String[] { "*" },
                new String[] {
            }
        }, {

            // mjEditor2
            "NoteEditor_2.0.0",
                "NoteEditor2",
                "Notes",
                new String[] { "NoteCore_1", "NoteOther_1.3" },
                new String[] { "tiu.notes", "tiu.notes.editor" },
                new String[] { "tiu.notes", "tiu.notes.editor", "tiu.notes.internal" },
                new String[] {
            }, new String[] {
            }
        }, {

            // mjEditor3
            "VendorNoteEditor_0.0.1",
                "VendorNoteEditor1",
                "",
                new String[] { "NoteCore_1", "Runtime_0.5" },
                new String[] { "vendor.notes", "vendor.notes.editor", "vendor.notes.utils" },
                new String[] { "vendor.notes", "vendor.notes.editor", "tiu.notes.internal" },
                new String[] { "mumtest.mum.AnotherTestStartup" },
                new String[] {
            }
        }, {

            // mjEditor4
            "NoteEditor_3.0.0",
                "NoteEditor3",
                "Notes",
                new String[] { "NoteCore_2", "MyLib_2" },
                new String[] { "tiu.notes.editor" },
                new String[] { "tiu.notes.editor", "tiu.notes.internal", "util.three" },
                new String[] {
            }, new String[] {
            }
        }, {

            // mjNoteCore1
            "NoteCore_2.0.0",
                "NoteCore1",
                "Notes",
                new String[] { "Runtime_0" },
                new String[] { "tiu.notes", "tiu.notes.internal" },
                new String[] { "tiu.notes", "tiu.notes.internal" },
                new String[] { "mumtest.mum.*", "mumtest.mum.TestApplication" },
                new String[] {
            }
        }, {

            // mjNoteCore2
            "NoteCore_1.0.0",
                "NoteCore2",
                "Notes",
                new String[] { "MyLib_1", "Runtime_0.9.99" },
                new String[] { "tiu.notes", "tiu.notes.internal", "tiu.notes.utilities" },
                new String[] { "tiu.notes", "tiu.notes.internal", "util.two" },
                new String[] { "tiu.notes.internal.*" },
                new String[] {
            }
        }, {

            // mjTemplates1
            "Templates_2.0.0",
                "Templates2",
                "Templates",
                new String[] { "TemplateCore_1" },
                new String[] { "tiu.templates", "tiu.templates.internal" },
                new String[] { "tiu.templates", "tiu.templates.internal" },
                new String[] {
            }, new String[] {
            }
        }, {

            // mjTemplatesCore
            "TemplateCore_1.2.0", "TemplatesCore1", "Templates", new String[] {
            },
                new String[] { "tiu.templates", "tiu.templates.core", "tiu.templates.internal" },
                new String[] { "tiu.templates", "tiu.templates.core", "tiu.templates.internal" },
                new String[] {
            }, new String[] {
            }
        }, {

            // mjTemplateFields1
            "TemplateFields_1.0.0",
                "TemplateFields1",
                "Templates",
                new String[] { "TemplateCore_1", "Runtime_1" },
                new String[] {
                    "tiu.templates",
                    "tiu.templates.fields",
                    "tiu.templates.fields.internal" },
                new String[] {
                    "tiu.templates",
                    "tiu.templates.fields",
                    "tiu.templates.fields.internal",
                    "tiu.templates.core" },
                new String[] {
            }, new String[] {
            }
        }, {

            // mjTemplateFields2
            "TemplateFields_1.5.0",
                "TemplateFields2",
                "Templates",
                new String[] { "TemplateCore_1" },
                new String[] {
                    "tiu.templates",
                    "tiu.templates.fields",
                    "tiu.templates.fields.internal" },
                new String[] {
                    "tiu.templates",
                    "tiu.templates.fields",
                    "tiu.templates.fields.internal",
                    "tiu.templates.internal" },
                new String[] { "tiu.templates.*", "tiu.templates.fields.DummyClass" },
                new String[] {
            }
        }, {

            // mjEncounters
            "PCE_1.0.0",
                "PCE_1.0.0",
                "PCE",
                new String[] { "MyLib_0.75" },
                new String[] { "pce", "pce.internal" },
                new String[] { "pce", "pce.internal", "util.two" },
                new String[] { "pce.DummyClass" },
                new String[] {
            }
        }, {

            // mjEncounterForms
            "PCEForms_1.0.0",
                "pceForms_1.0.0",
                "PCE",
                new String[] { "PCE_0", "MyLib_0.5" },
                new String[] { "pce", "pce.forms" },
                new String[] { "pce", "pce.forms", "util.one" },
                new String[] {
            }, new String[] {
            }
        }, {

            // mjInMedOrders
            "InpatientMedOrders_1.0.0",
                "Inpatient1",
                "Orders",
                new String[] { "OrdersCore_1" },
                new String[] { "orders.inpatient" },
                new String[] { "orders.inpatient" },
                new String[] {
            }, new String[] {
            }
        }, {

            // mjOutMedOrders
            "OutpatientMedOrders_1.0.0",
                "Outpatient1",
                "Orders",
                new String[] { "OrdersCore_1" },
                new String[] { "orders.outpatient" },
                new String[] { "orders.outpatient" },
                new String[] {
            }, new String[] {
            }
        }, {

            // mjMedCore
            "OrdersCore_2.0.0", "Orders", "Orders", new String[] {
            },
                new String[] { "orders", "orders.internal", "orders.meds" },
                new String[] { "orders", "orders.internal", "orders.meds" },
                new String[] { "orders.DummyClass" },
                new String[] {
            }
        }, {

            // mjRemCore
            "ReminderCore_1.0.0",
                "RemCore",
                "Reminders",
                new String[] { "MyLib_1" },
                new String[] { "reminders", "reminders.internal" },
                new String[] { "reminders", "reminders.internal", "util.one" },
                new String[] { "*" },
                new String[] {
            }
        }, {

            // mjRemDialogs1
            "RemDialogs_2.0.0",
                "RemDlgs1",
                "Reminders",
                new String[] { "ReminderCore_1", "PCE_0" },
                new String[] { "reminders.dialogs" },
                new String[] { "reminders.dialogs", "pce" },
                new String[] {
            }, new String[] {
            }
        }, {

            // mjRemDialogs2
            "RemDialogs_1.0.0",
                "RemDlgs2",
                "Reminders",
                new String[] {
                    "ReminderCore_0.5",
                    "OutpatientMedOrders_0.5",
                    "InpatientMedOrders_0.998",
                    "PCE_0.5",
                    "OrdersCore_2" },
                new String[] { "reminders.dialogs" },
                new String[] { "reminders.dialogs", "pce", "orders" },
                new String[] {
            }, new String[] {
            }
        }, {

            // mjLib1
            "MyLib_1.0.0", "Lib1", "", new String[] {
            },
                new String[] { "util.one", "util.two" },
                new String[] { "util.one", "util.two" },
                new String[] { "*" },
                new String[] {
            }
        }, {

            // mjLib2
            "MyLib_2.0.0", "Lib2", "", new String[] {
            },
                new String[] { "util.one", "util.two", "util.three" },
                new String[] { "util.one", "util.two", "util.three" },
                new String[] { "*" },
                new String[] {
            }
        }, {

            // mjRuntime
            "Runtime_1.0.0", "Runtime1", "", new String[] {
            },
                new String[] {
                    "gov.va.med.hds.cd.mum.update",
                    "mum.common",
                    "gov.va.med.hds.cd.mum" },
                new String[] {
                    "gov.va.med.hds.cd.mum.update",
                    "mum.common",
                    "gov.va.med.hds.cd.mum" },
                new String[] {
                    "gov.va.med.hds.cd.mum.*",
                    "gov.va.med.hds.cd.mum.utils.*",
                    "gov.va.med.hds.cd.mum.update.*" },
                new String[] {
                    "gov.va.med.hds.cd.mum.update.Startup",
                    "gov.va.med.hds.cd.mum.IApplication",
                    "gov.va.med.hds.cd.mum.utils.TreeDataFactory",
                    "gov.va.med.hds.cd.mum.utils.ITreeData",
                    "gov.va.med.hds.cd.mum.utils.TreeDataException",
                    "gov.va.med.hds.cd.mum.utils.ISavableTreeData",
                    "gov.va.med.hds.cd.mum.utils.TreeDataFactory" }
        }
    };

    String TEST_CONFIG_FILE = "TestConfiguration.xml";

    long CONFIG_XML_CRC = 693752509L;

    String[] CONFIG_XML =
        {
            "<?xml version=\"1.0\" encoding=\"UTF-8\"?>",
            "<configuration crc=\"" + Long.toString(CONFIG_XML_CRC) + "\">",
            "  <startup plugin=\"NoteCore_2.0.0\" run=\"boot.jar\" source=\"NoteCore1\">",
            "    <files>",
            "      <file>manifest.xml</file>",
            "      <file>boot.jar</file>",
            "      <file>mum.jar</file>",
            "    </files>",
            "  </startup>",
            "  <settings>",
            "    <testSetting1>one</testSetting1>",
            "    <testSetting2 setting=\"two\">two</testSetting2>",
            "    <testSetting3 setting=\"three\"/>",
            "  </settings>",
            "  <plugin name=\"Inpatient Med Orders\" directory=\"InpatientMedOrders_1.0.0\" module=\"Orders\" source=\"Inpatient1\">",
            "    <file filename=\"manifest.xml\" crc=\"2141284005\" size=\"325\"/>",
            "    <file filename=\"tempjar_InpatientMedOrders.jar\" crc=\"2766407334\" size=\"242\">",
            "      <package>orders.inpatient</package>",
            "    </file>",
            "    <requires plugin=\"OrdersCore_2.0.0\"/>",
            "  </plugin>",
            "  <plugin name=\"My Lib\" directory=\"MyLib_1.0.0\" source=\"Lib1\">",
            "    <file filename=\"manifest.xml\" crc=\"1429690339\" size=\"238\"/>",
            "    <file filename=\"tempjar_MyLib.jar\" crc=\"3855682574\" size=\"407\">",
            "      <package>util.one</package>",
            "      <package>util.two</package>",
            "    </file>",
            "    <publish class=\"*\"/>",
            "  </plugin>",
            "  <plugin name=\"My Lib\" directory=\"MyLib_2.0.0\" source=\"Lib2\">",
            "    <file filename=\"manifest.xml\" crc=\"1438865380\" size=\"238\"/>",
            "    <file filename=\"tempjar_MyLib.jar\" crc=\"731583020\" size=\"606\">",
            "      <package>util.one</package>",
            "      <package>util.two</package>",
            "      <package>util.three</package>",
            "    </file>",
            "    <publish class=\"*\"/>",
            "  </plugin>",
            "  <plugin name=\"Note Core\" directory=\"NoteCore_2.0.0\" module=\"Notes\" source=\"NoteCore1\">",
            "    <application class=\"mumtest.mum.TestApplication\"/>",
            "    <file filename=\"manifest.xml\" crc=\"2956433602\" size=\"431\"/>",
            "    <file filename=\"boot.jar\" crc=\"0\" size=\"0\"/>",
            "    <file filename=\"mum.jar\" crc=\"329521987\" size=\"2164\">",
            "      <package>tiu.notes</package>",
            "      <package>tiu.notes.internal</package>",
            "      <package>mumtest.mum</package>",
            "    </file>",
            "    <requires plugin=\"Runtime_1.0.0\"/>",
            "    <publish class=\"mumtest.mum.TestApplication\"/>",
            "    <publish class=\"mumtest.mum.TestStartup\"/>",
            "  </plugin>",
            "  <plugin name=\"Note Editor\" directory=\"NoteEditor_3.0.0\" module=\"Notes\" source=\"NoteEditor3\">",
            "    <file filename=\"manifest.xml\" crc=\"1340765402\" size=\"341\"/>",
            "    <file filename=\"tempjar_NoteEditor.jar\" crc=\"3403876271\" size=\"274\">",
            "      <package>tiu.notes.editor</package>",
            "    </file>",
            "    <requires plugin=\"MyLib_2.0.0\"/>",
            "    <requires plugin=\"NoteCore_2.0.0\"/>",
            "  </plugin>",
            "  <plugin name=\"Orders Core\" directory=\"OrdersCore_2.0.0\" module=\"Orders\" source=\"Orders\">",
            "    <file filename=\"manifest.xml\" crc=\"1163353978\" size=\"285\"/>",
            "    <file filename=\"tempjar_OrdersCore.jar\" crc=\"386273718\" size=\"632\">",
            "      <package>orders</package>",
            "      <package>orders.internal</package>",
            "      <package>orders.meds</package>",
            "    </file>",
            "    <publish class=\"orders.DummyClass\"/>",
            "  </plugin>",
            "  <plugin name=\"Outpatient Med Orders\" directory=\"OutpatientMedOrders_1.0.0\" module=\"Orders\" source=\"Outpatient1\">",
            "    <file filename=\"manifest.xml\" crc=\"1615030051\" size=\"328\"/>",
            "    <file filename=\"tempjar_OutpatientMedOrders.jar\" crc=\"2897020622\" size=\"245\">",
            "      <package>orders.outpatient</package>",
            "    </file>",
            "    <requires plugin=\"OrdersCore_2.0.0\"/>",
            "  </plugin>",
			"  <plugin name=\"PCE\" directory=\"PCE_1.0.0\">",
			"    <file filename=\"manifest.xml\" crc=\"693991820\" size=\"343\"/>",
			"    <file filename=\"tempjar_PCE.jar\" crc=\"2744322793\" size=\"426\">",
			"      <package>pce</package>",
			"      <package>pce.internal</package>",
			"    </file>",
			"    <requires plugin=\"MyLib_2.0.0\"/>",
			"    <publish class=\"pce.DummyClass\"/>",
			"  </plugin>",
            "  <plugin name=\"PCE Forms\" directory=\"PCEForms_1.0.0\" module=\"PCE\" source=\"pceForms_1.0.0\">",
            "    <file filename=\"manifest.xml\" crc=\"3742397585\" size=\"330\"/>",
            "    <file filename=\"tempjar_PCEForms.jar\" crc=\"2222459563\" size=\"413\">",
            "      <package>pce</package>",
            "      <package>pce.forms</package>",
            "    </file>",
            "    <requires plugin=\"MyLib_2.0.0\"/>",
            "    <requires plugin=\"PCE_1.0.0\"/>",
            "  </plugin>",
			"  <plugin name=\"Rem Dialogs\" directory=\"RemDialogs_1.0.0\" module=\"Reminders\" source=\"RemDlgs2\">",
			"    <file filename=\"manifest.xml\" crc=\"2670178149\" size=\"521\"/>",
			"    <file filename=\"tempjar_RemDialogs.jar\" crc=\"2622949022\" size=\"264\">",
			"      <package>reminders.dialogs</package>",
			"    </file>",
			"    <requires plugin=\"InpatientMedOrders_1.0.0\"/>",
			"    <requires plugin=\"OrdersCore_2.0.0\"/>",
			"    <requires plugin=\"OutpatientMedOrders_1.0.0\"/>",
			"    <requires plugin=\"PCE_1.0.0\"/>",
			"    <requires plugin=\"ReminderCore_1.0.0\"/>",
			"  </plugin>",
            "  <plugin name=\"Reminder Core\" directory=\"ReminderCore_1.0.0\" module=\"Reminders\" source=\"RemCore\">",
            "    <file filename=\"manifest.xml\" crc=\"4155603745\" size=\"361\"/>",
            "    <file filename=\"tempjar_ReminderCore.jar\" crc=\"4187687909\" size=\"462\">",
            "      <package>reminders</package>",
            "      <package>reminders.internal</package>",
            "    </file>",
            "    <requires plugin=\"MyLib_2.0.0\"/>",
            "    <publish class=\"*\"/>",
            "  </plugin>",
            "  <plugin name=\"Runtime\" directory=\"Runtime_1.0.0\" source=\"Runtime1\">",
            "    <file filename=\"manifest.xml\" crc=\"473336326\" size=\"374\"/>",
            "    <file filename=\"tempjar_Runtime.jar\" crc=\"851538084\" size=\"2340\">",
            "      <package>gov.va.med.hds.cd.mum.update</package>",
            "      <package>mum.common</package>",
            "      <package>gov.va.med.hds.cd.mum</package>",
            "      <package>gov.va.med.hds.cd.mum.utils</package>",
            "    </file>",
            "    <publish class=\"gov.va.med.hds.cd.mum.DummyClass\"/>",
            "    <publish class=\"gov.va.med.hds.cd.mum.IApplication\"/>",
            "    <publish class=\"gov.va.med.hds.cd.mum.update.DummyClass\"/>",
            "    <publish class=\"gov.va.med.hds.cd.mum.update.Startup\"/>",
            "    <publish class=\"gov.va.med.hds.cd.mum.utils.ISavableTreeData\"/>",
            "    <publish class=\"gov.va.med.hds.cd.mum.utils.ITreeData\"/>",
            "    <publish class=\"gov.va.med.hds.cd.mum.utils.TreeDataException\"/>",
            "    <publish class=\"gov.va.med.hds.cd.mum.utils.TreeDataFactory\"/>",
            "  </plugin>",
			"  <plugin name=\"Template Core\" directory=\"TemplateCore_1.2.0\" module=\"Templates\" source=\"TemplatesCore1\">",
			"    <file filename=\"manifest.xml\" crc=\"3780003692\" size=\"221\"/>",
			"    <file filename=\"tempjar_TemplateCore.jar\" crc=\"1093277248\" size=\"697\">",
			"      <package>tiu.templates</package>",
			"      <package>tiu.templates.core</package>",
			"      <package>tiu.templates.internal</package>",
			"    </file>",
			"  </plugin>",
            "  <plugin name=\"Template Fields\" directory=\"TemplateFields_1.5.0\" module=\"Templates\" source=\"TemplateFields2\">",
            "    <file filename=\"manifest.xml\" crc=\"1422495857\" size=\"444\"/>",
            "    <file filename=\"tempjar_TemplateFields.jar\" crc=\"369825762\" size=\"733\">",
            "      <package>tiu.templates</package>",
            "      <package>tiu.templates.fields</package>",
            "      <package>tiu.templates.fields.internal</package>",
            "    </file>",
            "    <requires plugin=\"TemplateCore_1.2.0\"/>",
            "    <publish class=\"tiu.templates.DummyClass\"/>",
            "    <publish class=\"tiu.templates.fields.DummyClass\"/>",
            "  </plugin>",
            "  <plugin name=\"Templates\" directory=\"Templates_2.0.0\" source=\"Templates2\">",
            "    <file filename=\"manifest.xml\" crc=\"2255184617\" size=\"301\"/>",
            "    <file filename=\"tempjar_Templates.jar\" crc=\"3218869893\" size=\"473\">",
            "      <package>tiu.templates</package>",
            "      <package>tiu.templates.internal</package>",
            "    </file>",
            "    <requires plugin=\"TemplateCore_1.2.0\"/>",
            "  </plugin>",
            "</configuration>" };

    String TESTFILE_COMMAND_TAG = "-testfile=";

    String OS_NAME_PROPERTY = "os.name";
    String WINDOWS_OS_PREFIX = "Windows";
}
