package gov.va.med.hds.cd.mum.update.test;

import gov.va.med.hds.cd.mum.update.InvalidPluginDirectoryException;
import gov.va.med.hds.cd.mum.update.PluginClassFactory;

import java.io.File;
import java.io.FileNotFoundException;

import junit.framework.TestCase;

public class ExistingPluginTest extends TestCase {

	public void testErrorConditions() {
		try {
			PluginClassFactory.newExistingPlugin(null);
			fail("Should have thrown an InvalidPluginDirectoryException");
		} catch (FileNotFoundException e) {
			fail(e.getMessage());
		} catch (InvalidPluginDirectoryException e) {
		}
		try {
			PluginClassFactory.newExistingPlugin(
				new File("/fdsaf/fdsaf/fdsa/werqwr/234qesfr324r.4321424fdsqqr"));
			fail("Should have thrown a FileNotFoundException");
		} catch (FileNotFoundException e) {
		} catch (InvalidPluginDirectoryException e) {
			fail(e.getMessage());
		}
	}

	//********************
	//*** end of tests ***
	//********************

	public ExistingPluginTest(String arg0) {
		super(arg0);
	}

	protected void setUp() throws Exception {
		super.setUp();
	}

	protected void tearDown() throws Exception {
		super.tearDown();
	}

}
