package gov.va.med.hds.cd.mum.update.test;

import gov.va.med.hds.cd.mum.InvalidConfigurationException;
import gov.va.med.hds.cd.mum.boot.utils.ListMap;
import gov.va.med.hds.cd.mum.boot.utils.Settings;
import gov.va.med.hds.cd.mum.test.IMUMTestConstants;
import gov.va.med.hds.cd.mum.update.IConfigReader;
import gov.va.med.hds.cd.mum.update.IPluginSpec;

import java.net.URL;

public class MockConfigReader implements IConfigReader, IMUMTestConstants {

    public MockConfigReader() {
        super();
    }

    private int startupPlugin = -1;
    private long startupCRC = 0;
    private MockPluginSpec startup;
    private Settings settings;

    public void setStartupPlugin(int index) {
        startupPlugin = index;
    }

    public void setStartupPlugin(int index, long crc) {
        startupPlugin = index;
        startupCRC = crc;
    }

    public void readConfiguration(URL configFile, ListMap plugins)
        throws InvalidConfigurationException {
        settings = new Settings(null);
        for (int i = 0; i < GOOD_CONFIG.length; i++) {
            MockPluginSpec plugin = new MockPluginSpec(GOOD_CONFIG[i]);
            if (GOOD_CONFIG[i] == startupPlugin) {
                plugin.setStartupClass("SomeClass");
                if (startupCRC != 0)
                    plugin.setJarCRC(startupCRC);
                startup = plugin;
            }
            int[] prereqs = GOOD_CONFIG_PREREQUISITE_PLUGINS[i];
            for (int j = 0; j < prereqs.length; j++)
                plugin.requiredPlugins().add(MOCKJAR_DATA[prereqs[j]][miDir], "");
            plugins.add(plugin.getID(), plugin);
        }
    }

    public long getCRC() {
        return 0;
    }
    /**
     * @see gov.va.med.hds.cd.mum.update.IConfigReader#getStartupPlugin()
     */
    public IPluginSpec getStartupPlugin() {
        return startup;
    }

    public Settings getSettings() {
        return settings;
    }

}
