package gov.va.med.hds.cd.mum.update.test;

import gov.va.med.hds.cd.mum.IMUMConstants;
import gov.va.med.hds.cd.mum.Version;
import gov.va.med.hds.cd.mum.test.IMUMTestConstants;
import gov.va.med.hds.cd.mum.update.ExistingFileEntry;
import gov.va.med.hds.cd.mum.update.IExistingPlugin;

import java.io.File;
import java.util.ArrayList;
import java.util.List;

public class MockExistingPlugin
	implements IExistingPlugin, IMUMConstants, IMUMTestConstants {

	public MockExistingPlugin(int index) {
		this((String) MOCKJAR_DATA[index][miDir], 12345, 70, "test.jar,98765,1000");
	}

	public MockExistingPlugin(
		String dir,
		long manifestCRC,
		long manifestSize,
		String jar1) {
		this(dir, manifestCRC, manifestSize, jar1, null, null);
	}

	public MockExistingPlugin(
		String dir,
		long manifestCRC,
		long manifestSize,
		String jar1,
		String jar2) {
		this(dir, manifestCRC, manifestSize, jar1, jar2, null);
	}

	public MockExistingPlugin(
		String dir,
		long manifestCRC,
		long manifestSize,
		String jar1,
		String jar2,
		String jar3) {
		super();
		files = new ArrayList();
		directory = dir;
		int i = dir.indexOf(VERSION_SEPARATOR);
		id = dir.substring(0, i);
		version = new Version(dir.substring(i + 1));
		File file = new File(MANIFEST_FILE);
		files.add(new ExistingFileEntry(file, manifestCRC, manifestSize));
		addJar(jar1);
		addJar(jar2);
		addJar(jar3);
	}

	private void addJar(String jar) {
		if (jar != null) {
			String[] bits = jar.split(",");
			File file = new File(bits[0]);
			files.add(
				new ExistingFileEntry(
					file,
					Long.parseLong(bits[1]),
					Long.parseLong(bits[2])));
		}
	}

	public ExistingFileEntry getFile(int index) {
		return (ExistingFileEntry) files.get(index);
	}

	public String getID() {
		return id;
	}

	public Version getVersion() {
		return version;
	}

	public String getDirectory() {
		return directory;
	}

	public int getFileCount() {
		return files.size();
	}

	private String directory;
	private String id;
	private Version version;
	private List files;

	public File[] getFiles() {
		File[] fileList = new File[getFileCount()];
		for (int i = 0; i < fileList.length; i++)
			fileList[i] = getFile(i).getFile();
		return fileList;
	}

}
