package gov.va.med.hds.cd.mum.update.test;

import gov.va.med.hds.cd.mum.boot.utils.ListMap;
import gov.va.med.hds.cd.mum.update.IPluginLocator;
import gov.va.med.hds.cd.mum.update.InvalidPluginDirectoryException;
import gov.va.med.hds.cd.mum.update.PluginClassFactory;

import java.io.File;
import java.io.FileNotFoundException;

import junit.framework.TestCase;

public class PluginLocatorTest extends TestCase {

	public void testErrors() throws InvalidPluginDirectoryException {
		IPluginLocator locator = PluginClassFactory.newPluginLocator(false);
		File file = new File("fkdlfd/saf/dsaf/dsaf/dsa/fsda/few421/4fds/a41");
		ListMap list = new ListMap();
		try {
			locator.locatePlugins(null, null);
			fail("Should have thrown an NullPointerException");
		} catch (NullPointerException e) {
		} catch (FileNotFoundException e) {
			fail(e.getMessage());
		}
		try {
			locator.locatePlugins(null, list);
			fail("Should have thrown an NullPointerException");
		} catch (NullPointerException e) {
		} catch (FileNotFoundException e) {
			fail(e.getMessage());
		}
		try {
			locator.locatePlugins(file, null);
			fail("Should have thrown an NullPointerException");
		} catch (NullPointerException e) {
		} catch (FileNotFoundException e) {
			fail(e.getMessage());
		}
		try {
			locator.locatePlugins(file, list);
			fail("Should have thrown a FileNotFoundException");
		} catch (FileNotFoundException e) {
		}
	}

	//********************
	//*** end of tests ***
	//********************

	public PluginLocatorTest(String arg0) {
		super(arg0);
	}

	protected void setUp() throws Exception {
		super.setUp();
	}

	protected void tearDown() throws Exception {
		super.tearDown();
	}

}
