package gov.va.med.hds.cd.mum.update.test;

import gov.va.med.hds.cd.mum.IPluginSource;
import gov.va.med.hds.cd.mum.boot.utils.ITreeData;
import gov.va.med.hds.cd.mum.boot.utils.TreeDataException;
import gov.va.med.hds.cd.mum.test.TestUtils;
import gov.va.med.hds.cd.mum.update.IPluginSpec;
import gov.va.med.hds.cd.mum.update.PluginClassFactory;

import java.io.IOException;

import javax.xml.parsers.FactoryConfigurationError;
import javax.xml.parsers.ParserConfigurationException;

import junit.framework.TestCase;

public class PluginSourceTest extends TestCase {

	public void testSourceCreation()
		throws
			IOException,
			ParserConfigurationException,
			FactoryConfigurationError,
			TreeDataException {

		IPluginSource source =
			PluginClassFactory.newPluginSource(new MockPluginSpec());
		assertNull(source.getManifest());
		assertNull(source.getClassLoader());

		ITreeData xml = utils.getManifestXML(utils.MANIFEST1);
		ClassLoader loader = this.getClass().getClassLoader();
		IPluginSpec spec = new MockPluginSpec(xml, loader);
		source = PluginClassFactory.newPluginSource(spec);
		assertEquals(xml, source.getManifest());
		assertEquals(loader, source.getClassLoader());
	}

	//********************
	//*** end of tests ***
	//********************

	public PluginSourceTest(String arg0) {
		super(arg0);
	}

	protected void setUp() throws Exception {
		super.setUp();
		utils = new TestUtils(this);
	}

	protected void tearDown() throws Exception {
		super.tearDown();
	}

	private TestUtils utils;

}
