package gov.va.med.hds.cd.mum.update.test;

import gov.va.med.hds.cd.mum.boot.UpdateAuthorizationFailureException;
import gov.va.med.hds.cd.mum.update.IPluginSpec;
import gov.va.med.hds.cd.mum.update.IPluginUpdater;
import gov.va.med.hds.cd.mum.update.IUpdateConstants;
import gov.va.med.hds.cd.mum.update.PluginClassFactory;
import gov.va.med.hds.cd.mum.update.UpdateException;

import java.io.File;
import java.net.MalformedURLException;
import java.net.URL;

import junit.framework.TestCase;

public class PluginUpdaterTest extends TestCase implements IUpdateConstants {

	public void testErrorConditions()
		throws
			MalformedURLException,
			UpdateException,
			UpdateAuthorizationFailureException {
		URL pluginDir = new URL("file:/fdsafdsaff/dsa/fds/afdsa/f/wer214");
		File rootDir = new File("/fdsa/fdsa/fd/saf/safweqr345rf/w");
		IPluginSpec plugin = new MockPluginSpec();
		assertError(null, null, null);
		assertError(null, null, plugin);
		assertError(null, rootDir, null);
		assertError(null, rootDir, plugin);
		assertError(pluginDir, null, null);
		assertError(pluginDir, null, plugin);
		assertError(pluginDir, rootDir, null);
		try {
			updater.update(pluginDir, rootDir, plugin);
			fail("Should have thrown an UpdateException");
		} catch (UpdateException e) {
			assertEquals(UPDATER_NOT_STARTED_ERROR, e.getMessage());
		}
	}

	//********************
	//*** end of tests ***
	//********************

	public PluginUpdaterTest(String arg0) {
		super(arg0);
	}

	protected void setUp() throws Exception {
		super.setUp();
		updater = PluginClassFactory.newPluginUpdater();
	}

	protected void tearDown() throws Exception {
		super.tearDown();
	}

	private void assertError(URL pluginDir, File rootDir, IPluginSpec plugin)
		throws UpdateException, UpdateAuthorizationFailureException {
		try {
			updater.update(pluginDir, rootDir, plugin);
			fail("Should have thrown an NullPointerException");
		} catch (NullPointerException e) {
		}
	}

	private IPluginUpdater updater;

}
