package gov.va.med.hds.cd.mum.update.test;

import gov.va.med.hds.cd.mum.update.SpecFileEntry;
import junit.framework.TestCase;

/**
 * enclosing_type
 */
public class SpecFileEntryTest extends TestCase {

	public void testPackages() {
		SpecFileEntry entry = new SpecFileEntry("testFile", 1, 2);
		assertEquals("testFile", entry.getFileName());
		assertEquals(1, entry.getCRC());
		assertEquals(2, entry.getSize());
		assertNull(entry.getPackages());
		entry.addPackage(null);
		assertNull(entry.getPackages());
		entry.addPackage("one.two.three");
		assertNotNull(entry.getPackages());
		assertEquals(1, entry.getPackages().size());
		entry.addPackage("three.four.five");
		entry.addPackage("one.two.three");
		assertEquals(2, entry.getPackages().size());
		assertTrue(entry.getPackages().contains("one.two.three"));
		assertTrue(entry.getPackages().contains("three.four.five"));
	}

	//********************
	//*** end of tests ***
	//********************
	/**
	 * Constructor for SpecFileEntryTest.
	 * @param arg0
	 */
	public SpecFileEntryTest(String arg0) {
		super(arg0);
	}

	/**
	 * @see TestCase#setUp()
	 */
	protected void setUp() throws Exception {
		super.setUp();
	}

	/**
	 * @see TestCase#tearDown()
	 */
	protected void tearDown() throws Exception {
		super.tearDown();
	}

}
