package gov.va.med.hds.cd.mum.update.test;

import gov.va.med.hds.cd.mum.boot.IStatusManager;
import gov.va.med.hds.cd.mum.boot.StatusNotifierFactory;

import javax.swing.JOptionPane;

import junit.framework.TestCase;

/**
 * enclosing_type
 */
public class SplashScreenTest extends TestCase {

    // Set to true to see the splash screen in action in the tests.
    private static final boolean testSplashScreen = false;

    public void testSplashScreenDisplay() {
        if (testSplashScreen) {
            IStatusManager screen = (IStatusManager) StatusNotifierFactory.newSplashScreen();
            try {
                screen.setVersion("Version: Alpha 1.2.0");
                screen.showProgressBar(100, "Cache Test");
                screen.updateProgressBar(50);
                screen.updateProgressMessage("Testing");
                screen.showCancelButton(true);
                screen.ensureWindowDisplayed();
                JOptionPane.showMessageDialog(null, "Cache Test");
                screen.hideProgressBar();
                screen.showCancelButton(false);
                screen.displayMessage(null);
                JOptionPane.showMessageDialog(null, "No Text");
                screen.displayMessage("Test Message");
                JOptionPane.showMessageDialog(null, "Test Message");
                screen.displayMessage(null);
                JOptionPane.showMessageDialog(null, "Hide Message");
                screen.showCancelButton(true);
                JOptionPane.showMessageDialog(null, "Cancel Button Show");
				screen.setVersion("Version: 1.0");
				JOptionPane.showMessageDialog(null, "Version Change");
                long max = ((long) Integer.MAX_VALUE) * 73;
                long inc = max / 140;
                long max2 = inc * 140;
                screen.showProgressBar(max, null);
                screen.displayMessage("Updating Stuff");
                JOptionPane.showMessageDialog(null, "Show Progress Bar");
                for (long i = 0; i <= max2; i += inc) {
                    screen.updateProgressBar(inc);
                    screen.updateProgressMessage(
                        Long.toString(i / 17)
                            + screen.PROGRESS_MESSAGE_SEPERATOR
                            + Long.toString(i));
                    try {
                        Thread.sleep(1);
                    } catch (InterruptedException e) {
                    }
                    if (screen.isCanceled()) {
                        JOptionPane.showMessageDialog(null, "Cancel Button Pressed");
                        break;
                    }
                }
                JOptionPane.showMessageDialog(null, "Update Progress Bar");
                screen.hideProgressBar();
                JOptionPane.showMessageDialog(null, "Hide Progress Bar");
                screen.showCancelButton(false);
                JOptionPane.showMessageDialog(null, "Cancel Button Hide");
            } finally {
                screen.close();
            }
        }
    }

    //********************
    //*** end of tests ***
    //********************

    /**
     * Constructor for SplashScreenTest.
     * @param arg0
     */
    public SplashScreenTest(String arg0) {
        super(arg0);
    }

    /**
     * @see TestCase#setUp()
     */
    protected void setUp() throws Exception {
        super.setUp();
    }

    /**
     * @see TestCase#tearDown()
     */
    protected void tearDown() throws Exception {
        super.tearDown();
    }

}
