/*
 * Created on Apr 23, 2003
 *
 * To change the template for this generated file go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package gov.va.med.hds.cd.mum.utils.test;

import gov.va.med.hds.cd.mum.test.TestFileBuilder;
import gov.va.med.hds.cd.mum.test.WinUtils;
import gov.va.med.hds.cd.mum.utils.MUMUtils;

import java.io.File;
import java.io.IOException;
import java.net.MalformedURLException;
import java.net.URL;

import junit.framework.TestCase;

/**
 * @author vhaislmerrij
 *
 * To change the template for this generated type comment go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
public class MUMUtilsTest extends TestCase {

    public void testDerivedURLs() throws MalformedURLException {
        try {
            MUMUtils.newURL(null);
            fail("Should have thrown NullPointerException");
        } catch (NullPointerException e) {
        }
        assertEquals(
            "http://six.seven/eight",
            MUMUtils.newURL("http://six.seven/eight").toString());
        if (WinUtils.isWindows()) {
            URL url = MUMUtils.newURL("C:\\six.seven\\eight");
            assertEquals("file", url.getProtocol());
            assertEquals("/C:/six.seven/eight", url.getPath());
            assertEquals("/z:/testing/one", MUMUtils.newURL("\\z:\\testing\\one").getPath());
            assertEquals("//MyPC/testing", MUMUtils.newURL("file://MyPC/testing").getPath());
        }
    }

    public void testBaseClassName() {
        assertEquals("testing", MUMUtils.getBaseClassName("one.two.testing"));
        assertEquals("testing", MUMUtils.getBaseClassName("one.testing"));
        assertEquals("testing", MUMUtils.getBaseClassName("testing"));
        assertEquals("testing", MUMUtils.getBaseClassName("one.two.three$testing"));
        assertEquals("whatever", MUMUtils.getBaseClassName("one.two.whatever"));
        assertEquals("whatever", MUMUtils.getBaseClassName("one.whatever"));
        assertEquals("whatever", MUMUtils.getBaseClassName("one.two.three$whatever"));
        assertEquals("whatever", MUMUtils.getBaseClassName("whatever"));
    }

    public void testDeleteWithExclude() throws IOException {

        TestFileBuilder.initRootTestDirs();
        try {
            File dir = new File(TestFileBuilder.getGoldFile(), "test directory");
            dir.mkdirs();
            File file1 = new File(dir, fileName1);
            File file2 = new File(dir, fileName2);
            File file3 = new File(dir, fileName3);
            File file4 = new File(dir, fileName4);
            file1.createNewFile();
            file2.createNewFile();
            file3.createNewFile();
            file4.createNewFile();
            assertTrue(file1.exists());
            assertTrue(file2.exists());
            assertTrue(file3.exists());
            assertTrue(file4.exists());
            File[] file = new File[3];
            file[0] = file2;
            file[1] = null;
            file[2] = file4;
            MUMUtils.deleteTree(dir, file);
            assertFalse(file1.exists());
            assertTrue(file2.exists());
            assertFalse(file3.exists());
            assertTrue(file4.exists());
            assertTrue(dir.exists());
        } finally {
            TestFileBuilder.eraseTestDirectories(true);
        }
    }

    //********************
    //*** end of tests ***
    //********************

    private String fileName1 = "test file 1.a";
    private String fileName2 = "test file 2.b";
    private String fileName3 = "test file 3.c";
    private String fileName4 = "test file 4.d";

    /**
     * Constructor for MUMUitlsTest.
     * @param arg0
     */
    public MUMUtilsTest(String arg0) {
        super(arg0);
    }

    /*
     * @see TestCase#setUp()
     */
    protected void setUp() throws Exception {
        super.setUp();
    }

    /*
     * @see TestCase#tearDown()
     */
    protected void tearDown() throws Exception {
        super.tearDown();
    }

}
