package gov.va.med.hds.cd.mum;

import gov.va.med.hds.cd.mum.boot.ISplashScreen;
import gov.va.med.hds.cd.mum.boot.utils.ITreeData;

/**
 * Classes that implement this interface can be launched by the MUM.
 */
public interface IApplication {
	
	/**
	 * Called by the MUM to run the main application plugin.
	 * @param args - command line arguments for the application.
	 * @param configXML - the settings xml of the configuration file, merged with command
	 * line parameters and values from the settings file.
	 * @param plugins - A list of information for each plugin, including the
	 * manifest xml element, and the class loader used to load the plug-ins
	 * class files.
	 */
	public void run(
		String[] args,
		ITreeData configXML,
		IPluginSource[] plugins,
		ISplashScreen splash);
}
