package gov.va.med.hds.cd.mum;

/**
 * The core interface for all plugin classes used by the MUM.
 */
public interface IBasePlugin {
	
	/**
	 * Returns the ID of the plugin, as specified in the plugin manifest.
	 * @return String
	 */
	String getID();

	/**
	 * Returns the version of the plugin, as specified in the plugin manifest.
	 * @return Version
	 */
	Version getVersion();

	/**
	 * Returns the directory where the plugin in located, inside the plugins
	 * directory.
	 * @return String
	 */
	String getDirectory();

	/**
	 * Returns the number of files in the plugin.
	 * @return int
	 */
	int getFileCount();
}
