package gov.va.med.hds.cd.mum;

import gov.va.med.hds.cd.mum.boot.IBootConstants;
import gov.va.med.hds.cd.mum.boot.IPluginConstants;
import gov.va.med.hds.cd.mum.boot.IStartup;
import gov.va.med.hds.cd.mum.utils.MUMUtils;

/**
 * Constants used throughout the MUM.
 */
public interface IMUMConstants {
    String FILE_ELEMENT = "file";
    String FILES_ELEMENT = "files";
    String FILENAME_ATTRIBUTE = "filename";
    String DISTRIBUTION_ELEMENT = "distribution";
    String SOURCE_ATTRIBUTE = "source";
    String SIZE_ATTRIBUTE = "size";
    String DATE_ATTRIBUTE = "date";
    String CACHE_ELEMENT = "cache";
    String PACKAGE_ELEMENT = "package";

    String CONFIGURATION_ELEMENT = "configuration";
    String RUN_ATTRIBUTE = "run";
    String CRC_ATTRIBUTE = "crc";
    String DIRECTORY_ATTRIBUTE = "directory";
    String APPLICATION_ELEMENT = "application";
    String STARTUP_ELEMENT = "startup";
    String PLUGINS_ELEMENT = "plugins";
    String LAST_USED_ATTRIBUTE = "used";

    String COMMANDS_ELEMENT = "commands";
    String COMMAND_ELEMENT = "command";
    String TAG_ATTRIBUTE = "tag";

    String BOOT_JAR = "boot" + IBootConstants.JAR_EXT;

    int PLUGIN_USAGE_DAYS_BEFORE_DELETE = 90;

    String UPDATE_DIRECTORY = "updates";
    String LAST_UPDATE_FILE = "lastUpdate" + IBootConstants.XML_EXT;

    //	String CONFIG_INDEX_FILENAME = "/" + CONFIG_DIRECTORY + "/index" + XML_EXT;
    String PLUGIN_USAGE_FILENAME =
        "/" + IBootConstants.CONFIG_DIRECTORY + "/usage" + IBootConstants.XML_EXT;
    String PLUGIN_CLASS_DATA_CACHE_FILENAME =
        "/" + IBootConstants.CONFIG_DIRECTORY + "/ClassData" + IBootConstants.XML_EXT;
    String CRC_CACHE_FILENAME =
        "/" + IBootConstants.CONFIG_DIRECTORY + "/crcCache" + IBootConstants.SERIALIZED_OBJ_EXT;

    String USER_CURRENT_DIR_PROPERTY = "user.dir";

    String ZIP_EXT = ".zip";

    String[] TEXT_EXTENSIONS =
        { IBootConstants.XML_EXT, IBootConstants.SETTINGS_EXT, ".txt", ".html", ".htm", ".ini" };
    String[] BINARY_EXTENSIONS = { IBootConstants.JAR_EXT, ZIP_EXT, ".dll", ".so", ".exe" };

    String VERSION_SEPARATOR = "_";
    String WILDCARD = "*";

    String PLUGIN_DIRECTORY_NAME = "plugins";
    String PLUGIN_DIRECTORY = PLUGIN_DIRECTORY_NAME;
    //	String CACHE_DIRECTORY = ROOT_DIRECTORY + "mum/cache"; 

    String INTERFACE_TXT = " interface";
    String MISSING_IMPLEMENTS_TXT = "No plugin implements the ";

    String TOO_MANY_PUBLISHED_ENTRIES =
        "No other publish entries allowed with \"*\" published entry";

    String DUPLICATE_DEPENDENCY_TXT = "Plugin specifies more than one dependency on the plugin ";

    String SELF_DEPENDENCY_TXT = "Plugin specifies a dependency on itself";

    String BOOT_PACKAGE_NAME = "gov.va.med.hds.cd.mum.boot";
    String BOOT_PACKAGE = BOOT_PACKAGE_NAME + ".";
    String STARTUP_INTERFACE_NAME = IStartup.class.getName();
    String APPLICATION_INTERFACE_NAME = IApplication.class.getName();
    String STARTUP_INTERFACE_BASE_NAME = MUMUtils.getBaseClassName(STARTUP_INTERFACE_NAME);
    String APPLICATION_INTERFACE_BASE_NAME = MUMUtils.getBaseClassName(APPLICATION_INTERFACE_NAME);

    String MISSING_STARTUP_PLUGIN_TXT =
        MISSING_IMPLEMENTS_TXT + STARTUP_INTERFACE_NAME + INTERFACE_TXT;

    String MISSING_APPLICATION_PLUGINS_TXT =
        MISSING_IMPLEMENTS_TXT + APPLICATION_INTERFACE_NAME + INTERFACE_TXT;

    String MULTIPLE_IMPLEMNTATION_TXT = "More than one class implements the ";

    String MULTIPLE_STARTUP_CLASSES =
        MULTIPLE_IMPLEMNTATION_TXT + STARTUP_INTERFACE_NAME + INTERFACE_TXT;

    String MULTIPLE_APPLICATION_CLASSES =
        MULTIPLE_IMPLEMNTATION_TXT + APPLICATION_INTERFACE_NAME + INTERFACE_TXT;

    String INVALID_TXT = "Invalid ";
    String ENTRY_TEXT = " entry in the ";
    String MANFIEST_SECTION_TXT = " section of the manifest";
    String MULTIPLE_TXT = "More than one ";
    String MANIFEST_SECTION_FOUND_TXT = " section found in manifest";
    String INVALID_MANIFEST = "Invalid manifest file";

    String INVALID_PREREQUISITES_ENTRY =
        INVALID_TXT
            + IPluginConstants.PREREQUISITE_ELEMENT
            + ENTRY_TEXT
            + IPluginConstants.PREREQUISITES_ELEMENT
            + MANFIEST_SECTION_TXT;

    String MULTIPLE_PREREQUISITES_SECTIONS =
        MULTIPLE_TXT + IPluginConstants.PREREQUISITES_ELEMENT + MANIFEST_SECTION_FOUND_TXT;

    String PLUGIN_ERROR = "Error processing plugin:" + IBootConstants.EOL + "  ";

    String WRITE_FAILURE_ERROR =
        "Error trying to install required system updates."
            + IBootConstants.EOL
            + "Please contact your system administrator for assistance.";

    String UNKNOWN_VERSION_MATCH_ERROR = "Unknown version match condition '";
}
