package gov.va.med.hds.cd.mum;

/**
 * Used to provide a common mechanism for formatting InvalidPluginException
 * error messages for a variety of different classes. 
 */
public interface IPluginExceptionManager {
	/**
	 * Throws an InvalidPluginException with proper formatting.
	 * @param message - the error message text
	 * @param cause - the exception causing the error
	 * @throws InvalidPluginException
	 */
	void badPlugin(String message, Throwable cause) throws InvalidPluginException;

	/**
	 * Throws an InvalidPluginException with proper formatting.
	 * @param cause - the exception causing the error
	 * @throws InvalidPluginException
	 */
	void badPlugin(Throwable cause) throws InvalidPluginException;

	/**
	 * Throws an InvalidPluginException with proper formatting.
	 * @param message - the error message text
	 * @throws InvalidPluginException
	 */
	void badPlugin(String message) throws InvalidPluginException;

	/**
	 * Throws an InvalidPluginException with proper formatting.
	 * @throws InvalidPluginException
	 */
	void badPlugin() throws InvalidPluginException;
}
