package gov.va.med.hds.cd.mum;

import gov.va.med.hds.cd.mum.boot.MUMException;

/**
 * Indicates that a given plugin is invalid, usually as a result from
 * invalid information in the plugin manifest, or invalid jar or class files
 * within the plugin.
 */
public class InvalidPluginException extends MUMException {

	/**
     * Constructor for InvalidPluginException with null as its detail message. 
     */
    public InvalidPluginException() {
		super();
	}

	/**
     * Constructor for InvalidPluginException with the specified detail message. 
     */
    public InvalidPluginException(String message) {
		super(message);
	}

	/**
     * Constructor for InvalidPluginException with the specified detail message and cause. 
     */
    public InvalidPluginException(String message, Throwable cause) {
		super(message, cause);
	}

	/**
     * Constructor for InvalidPluginException with the specified cause.
     */
    public InvalidPluginException(Throwable cause) {
		super(cause);
	}

}
