package gov.va.med.hds.cd.mum.boot;

import javax.swing.event.EventListenerList;

public class DesktopThreadGroup extends ThreadGroup {

	public static final String DESKTOP_THREAD_GROUP = "Desktop Thread Group";

	private static EventListenerList listenerList = new EventListenerList();

	public static void addUncaughtExceptionHandler(IUncaughtExceptionHandler h) {
		listenerList.add(IUncaughtExceptionHandler.class, h);
	}

	public static void removeUncaughtExceptionHandler(IUncaughtExceptionHandler h) {
		listenerList.remove(IUncaughtExceptionHandler.class, h);
	}

	public DesktopThreadGroup() {
		super(DESKTOP_THREAD_GROUP);
	}

	public void uncaughtException(Thread t, Throwable e) {
		fireUncaughtException(t, e);
	}

	private static void fireUncaughtException(Thread t, Throwable e) {
		IUncaughtExceptionHandler[] handlers = (IUncaughtExceptionHandler[]) listenerList.getListeners(IUncaughtExceptionHandler.class);
		for (int i = 0; i < handlers.length; i++) {
			handlers[i].uncaughtException(t, e);
		}
	}

}
