package gov.va.med.hds.cd.mum.boot;

/**
 * Used when a fatal error has occured that will result if
 * program termination
 */
public interface IAbortManager {
	/**
	 * Aborts the applciation, warning the user if requested.
	 * @param e - the error being thrown that is resulting in termination.
	 * @param warnUser - used to tell the abort manager to display a message to
	 * the user indicating the fatal error.  The only time this should be set to
	 * false is when an alternate message dialog has already been displayed.
	 */
	void abort(Throwable e, boolean warnUser);
}
