package gov.va.med.hds.cd.mum.boot;

/**
 * Constants used throughout the Boot packages
 */
public interface IBootConstants {

    /**
     * This is how the Boot knows which class to launch.  If the startup class
     * is changed, this value must be modified accrodingly!
     */
    String STARTUP_CLASS = "gov.va.med.hds.cd.mum.update.Startup";

    /**
     * This is how the Boot knows which jar to launch.  If the startup jar is
     * changed, this value must be modified accordingly!
     */

    String CLASS_EXT = ".class";
    String JAR_EXT = ".jar";
    String SERIALIZED_OBJ_EXT = ".ser";
    String ZIP_EXT = ".zip";
    String XML_EXT = ".xml";

    String CONFIG_DIRECTORY = "configuration";
    String PLUGINS_DIRECTORY = "plugins";
    
    String DESKTOP_ELEMENT = "desktop";
    
    String JAR_PROTOCOL = "jar:";
    String FILE_PROTOCOL = "file:";
    String JAR_FILE_PROTOCOL = JAR_PROTOCOL + FILE_PROTOCOL;

    String OPTION_PREFIX = "-";
    String ARG_ASSIGNMENT = "=";

    String DEFAULT_PACKAGE = "";

    String EOL = System.getProperty("line.separator");
    String WIN_EOL = "\r\n";

    String STARTUP_JAR = "mum" + JAR_EXT;

    String MANIFEST_FILE = "manifest" + XML_EXT;

    String LOAD_ALL_COMMAND_TAG = OPTION_PREFIX + "loadall";
    String LOAD_WEB_COMMAND_TAG = OPTION_PREFIX + "load";
    String TEST_TEXT_COMMAND_TAG = OPTION_PREFIX + "test" + ARG_ASSIGNMENT;
    String TEST_UI_COMMAND_TAG = OPTION_PREFIX + "guitest" + ARG_ASSIGNMENT;
    String SILENT_UPDATE_TAG = OPTION_PREFIX + "silent";

    String ABORT_TITLE = "Aborted";
    String ABORT_MESSAGE = "Fatal Error - Aborting";

    String SETTING_ATTRIBUTE = "setting";
    String SETTING_SUB_ATTRIBUTE = "-" + SETTING_ATTRIBUTE;
    String SETTINGS_ELEMENT = "settings";
    String COMMAND_LINE_PARAM_ATTRIBUTE = "clparam";
    String COMMAND_LINE_PARAM_SUB_ATTRIBUTE = "-" + COMMAND_LINE_PARAM_ATTRIBUTE;
    String SETTINGS_EXT = ".settings";

    String JVM_VERSION_PROPERTY = "java.version";

    int JVM_MINIMUM_VERSION_MAJOR = 1;
    int JVM_MINIMUM_VERSION_MINOR = 4;
    int JVM_MINIMUM_VERSION_BUILD = 1;

    String SPLASH_SCREEN_TITLE = "HealtheVet Desktop";

    String JVM_MINIMUM_VERSION =
        Integer.toString(JVM_MINIMUM_VERSION_MAJOR)
            + "."
            + Integer.toString(JVM_MINIMUM_VERSION_MINOR)
            + "."
            + Integer.toString(JVM_MINIMUM_VERSION_BUILD);

    String JVM_VERSION_ERROR_1 = "Currently running Java Virtual Machine version ";

    String JVM_VERSION_ERROR_2 =
        EOL + "This application requires a minimum version of " + JVM_MINIMUM_VERSION;

    String TOTAL_FAILURE = EOL + "Unable to launch application.";

    String INVALID_TAG_NAME_ERROR = "Invalid tag name";

    String NO_STARTUP_JAR_FOUND =
        "The required file \"" + STARTUP_JAR + "\" was not found." + TOTAL_FAILURE;

    String UNEXPECTED_STARTUP_FAILURE = "An unexpected startup error has occured." + TOTAL_FAILURE;
}
