package gov.va.med.hds.cd.mum.boot;

/**
 * Used when the abort manager should terminate without sending a message to the
 * end user.  This should be used when program termination is expected, such as
 * when the user presses the cancel button on a login.
 */
public class SilentAbortException extends RuntimeException {
	
	/**
     * Constructor for SilentAbortException with null as its detail message.
     */
	public SilentAbortException(String message) {
		super(message);
	}

	/**
     * Constructor for SilentAbortException with the specified detail message.
     */
	public SilentAbortException(String message, Throwable cause) {
		super(message, cause);
	}

	/**
     * Constructor for SilentAbortException with the specified detail message and cause.
     */
	public SilentAbortException(Throwable cause) {
		super(cause);
	}

	/**
     * Constructor for SilentAbortException with the specified cause.
     */
	public SilentAbortException() {
		super();
	}

}
