package gov.va.med.hds.cd.mum.boot;

/**
 * Creates an instance of the IStatusNotifier interface
 */
public class StatusNotifierFactory {

	private static IStatusNotifier notifier;

	/**
	 * Creates an instance of the IStatusNotifier interface
	 * @return IStatusNotifier
	 */
	public static ISplashScreen newSplashScreen() {
		if (notifier == null)
			return new Notifier();
		else
			return notifier;
	}

	/**
	 * Allows subsequent calls to newStatusNotifier to return a predetermined
	 * instance of the IStatusNotifier the interface.  This is used primarily in
	 * unit testing.
	 * @param statusNotifier
	 */
	public static void assignStatusNotifier(IStatusNotifier statusNotifier) {
		notifier = statusNotifier;
	}
}
