package gov.va.med.hds.cd.mum.boot;

/**
 * Used to represent the fact the user does not have write authority to the local hard disk,
 * and the plugins required by the current configration are not all present on the workstation.
 * It is intended that only users on locked down or thin client environments will ever see this
 * error message. 
 */
public class UpdateAuthorizationFailureException extends MUMException {

	/**
     * Constructor for UpdateAuthorizationFailureException with null as its detail message.
     */
	public UpdateAuthorizationFailureException() {
		super();
	}

	/**
     * Constructor for UpdateAuthorizationFailureException with the specified detail message.
     */
	public UpdateAuthorizationFailureException(String message) {
		super(message);
	}

	/**
     * Constructor for UpdateAuthorizationFailureException with the specified detail message and cause.
     */
	public UpdateAuthorizationFailureException(String message, Throwable cause) {
		super(message, cause);
	}

	/**
     * Constructor for UpdateAuthorizationFailureException with the specified cause.
     */
	public UpdateAuthorizationFailureException(Throwable cause) {
		super(cause);
	}

}
