package gov.va.med.hds.cd.mum.boot.loader;

import gov.va.med.hds.cd.mum.boot.MUMException;

/**
 * Thrown when one of the custom class loaders has an error that is not normal to class loaders,
 * such as when assigning a jar file to a class loader that does not exist. 
 */
public class ClassLoaderException extends MUMException {

    /**
     * Constructor for ClassLoaderException with null as its detail message.
     */
    public ClassLoaderException() {
        super();
    }

	/**
     * Constructor for ClassLoaderException with the specified detail message.
     */
    public ClassLoaderException(String message) {
        super(message);
    }

	/**
     * Constructor for ClassLoaderException with the specified detail message and cause.
     */
    public ClassLoaderException(String message, Throwable cause) {
        super(message, cause);
    }

	/**
     * Constructor for ClassLoaderException with the specified cause.
     */
    public ClassLoaderException(Throwable cause) {
        super(cause);
    }

}
