package gov.va.med.hds.cd.mum.boot.loader;

import gov.va.med.hds.cd.mum.boot.utils.KeyedList;

import java.io.File;
import java.net.URL;
import java.net.URLClassLoader;

/**
 * 
 */
public class LibraryClassLoader extends URLClassLoader {

    private KeyedList otherFiles;

    /**
     * Constructor for LibraryClassLoader 
     */
    public LibraryClassLoader(ClassLoader parent) {
        super(new URL[0], parent);
    }

	protected KeyedList getOtherFiles() {
        return otherFiles;
    }

	protected void ensureOtherFileList() {
        if (otherFiles == null)
            otherFiles = new KeyedList();
    }
    
	protected void assignOtherFile(File file) {
		ensureOtherFileList();
		getOtherFiles().add(file.getName(), file);
	}

    /**
     * @see java.lang.ClassLoader#findLibrary(java.lang.String)
     */
    protected String findLibrary(String libname) {
        if (getOtherFiles() == null)
            return null;
        String lib = System.mapLibraryName(libname);
        File file = (File) getOtherFiles().get(lib);
        if (file == null)
            return null;
        return file.getAbsolutePath();
    }
}
