package gov.va.med.hds.cd.mum.boot.plaf.desktop;

import java.awt.Color;
import java.awt.Font;

import javax.swing.plaf.ColorUIResource;
import javax.swing.plaf.FontUIResource;

public class DefaultDesktopTheme implements IDesktopTheme {

	private static final FontUIResource DIALOG_PLAIN_11 =
		new FontUIResource("Dialog", Font.PLAIN, 11);
	private static final FontUIResource TAHOMA_PLAIN_8 =
			new FontUIResource("Tahoma", Font.PLAIN, 8);
	private static final FontUIResource SANS_SERIF_PLAIN_11 =
			new FontUIResource("SansSerif", Font.PLAIN, 11);
	private static final FontUIResource MONO_SPACED_PLAIN_12 =
		new FontUIResource("MonoSpaced", Font.PLAIN, 12);
	private static final FontUIResource DIALOG_BOLD_11 = new FontUIResource("Dialog", Font.BOLD, 11);

	private static final ColorUIResource DARK_BLUE = new ColorUIResource(52, 88, 154);
	private static final ColorUIResource LIGHT_BLUE = new ColorUIResource(168, 178, 216);
	private static final ColorUIResource YELLOW = new ColorUIResource(Color.YELLOW);
	private static final ColorUIResource BLACK = new ColorUIResource(Color.BLACK);
	private static final ColorUIResource WHITE = new ColorUIResource(Color.WHITE);
	private static final ColorUIResource SCROLL_BAR_GRAY = new ColorUIResource(224, 224, 224);
	private static final ColorUIResource TOOL_TIP_YELLOW = new ColorUIResource(255, 255, 225);
	private static final ColorUIResource DESKTOP_GRAY = new ColorUIResource(0, 92, 92);
	
	private static final ColorUIResource DISABLED_TEXT_GRAY = new ColorUIResource(128,128,128);
	
	private static final ColorUIResource CONTROL_GRAY = new ColorUIResource(201, 201, 209);
	private static final ColorUIResource CONTROL_SHADOW = new ColorUIResource(CONTROL_GRAY.darker());
	private static final ColorUIResource CONTROL_DARK_SHADOW = new ColorUIResource(CONTROL_GRAY.darker().darker());
	private static final ColorUIResource CONTROL_LIGHT = new ColorUIResource(CONTROL_GRAY.brighter());
	private static final ColorUIResource CONTROL_HIGHLIGHT = WHITE;
	
	private static final ColorUIResource PRIMARY = LIGHT_BLUE;
	private static final ColorUIResource PRIMARY_SHADOW = new ColorUIResource(PRIMARY.darker());
	private static final ColorUIResource PRIMARY_DARK_SHADOW = DARK_BLUE;
	private static final ColorUIResource PRIMARY_LIGHT = new ColorUIResource(PRIMARY.brighter());
	private static final ColorUIResource PRIMARY_HIGHLIGHT = WHITE;
	
	/* @see gov.va.med.hds.cd.spectrum.plaf.desktop.IDesktopTheme#getName() */
	public String getName() {
		return "Default HealtheVet Desktop Theme";
	}

	/* @see gov.va.med.hds.cd.spectrum.plaf.desktop.IDesktopTheme#getControlTextFont() */
	public FontUIResource getControlTextFont() {
		return DIALOG_PLAIN_11;
	}

	/* @see gov.va.med.hds.cd.spectrum.plaf.desktop.IDesktopTheme#getSystemTextFont() */
	public FontUIResource getSystemTextFont() {
		return DIALOG_PLAIN_11;
	}

	/* @see gov.va.med.hds.cd.spectrum.plaf.desktop.IDesktopTheme#getUserTextFont() */
	public FontUIResource getUserTextFont() {
		return MONO_SPACED_PLAIN_12;
	}

	/* @see gov.va.med.hds.cd.spectrum.plaf.desktop.IDesktopTheme#getMenuTextFont() */
	public FontUIResource getMenuTextFont() {
		return DIALOG_PLAIN_11;
	}

	/* @see gov.va.med.hds.cd.spectrum.plaf.desktop.IDesktopTheme#getWindowTitleFont() */
	public FontUIResource getWindowTitleFont() {
		return DIALOG_BOLD_11;
	}

	/* @see gov.va.med.hds.cd.spectrum.plaf.desktop.IDesktopTheme#getInfoFont() */
	public FontUIResource getInfoFont() {
		return SANS_SERIF_PLAIN_11;
	}

	/* @see gov.va.med.hds.cd.spectrum.plaf.desktop.IDesktopTheme#getFocusColor() */
	public ColorUIResource getFocusColor() {
		return BLACK;
	}

	/* @see gov.va.med.hds.cd.spectrum.plaf.desktop.IDesktopTheme#getDesktopColor() */
	public ColorUIResource getDesktopColor() {
		return DESKTOP_GRAY;
	}

	/* @see gov.va.med.hds.cd.spectrum.plaf.desktop.IDesktopTheme#getControl() */
	public ColorUIResource getControl() {
		return CONTROL_GRAY;
	}

	/* @see gov.va.med.hds.cd.spectrum.plaf.desktop.IDesktopTheme#getControlShadow() */
	public ColorUIResource getControlShadow() {
		return CONTROL_SHADOW;
	}

	/* @see gov.va.med.hds.cd.spectrum.plaf.desktop.IDesktopTheme#getControlDarkShadow() */
	public ColorUIResource getControlDarkShadow() {
		return CONTROL_DARK_SHADOW;
	}

	/* @see gov.va.med.hds.cd.spectrum.plaf.desktop.IDesktopTheme#getControlHighlight() */
	public ColorUIResource getControlLight() {
		return CONTROL_LIGHT;
	}

	/* @see gov.va.med.hds.cd.spectrum.plaf.desktop.IDesktopTheme#getControlLightHighlight() */
	public ColorUIResource getControlHighlight() {
		return CONTROL_HIGHLIGHT;
	}

	/* @see gov.va.med.hds.cd.spectrum.plaf.desktop.IDesktopTheme#getControlDisabled() */
	public ColorUIResource getControlDisabled() {
		return null;
	}

	/* @see gov.va.med.hds.cd.spectrum.plaf.desktop.IDesktopTheme#getPrimaryControl() */
	public ColorUIResource getPrimaryControl() {
		return PRIMARY;
	}

	/* @see gov.va.med.hds.cd.spectrum.plaf.desktop.IDesktopTheme#getPrimaryControlShadow() */
	public ColorUIResource getPrimaryControlShadow() {
		return PRIMARY_SHADOW;
	}

	/* @see gov.va.med.hds.cd.spectrum.plaf.desktop.IDesktopTheme#getPrimaryControlDarkShadow() */
	public ColorUIResource getPrimaryControlDarkShadow() {
		return PRIMARY_DARK_SHADOW;
	}

	/* @see gov.va.med.hds.cd.spectrum.plaf.desktop.IDesktopTheme#getPrimaryControlHighlight() */
	public ColorUIResource getPrimaryControlLight() {
		return PRIMARY_LIGHT;
	}

	/* @see gov.va.med.hds.cd.spectrum.plaf.desktop.IDesktopTheme#getPrimaryControlLightHighlight() */
	public ColorUIResource getPrimaryControlHighlight() {
		return PRIMARY_HIGHLIGHT;
	}

	/* @see gov.va.med.hds.cd.spectrum.plaf.desktop.IDesktopTheme#getSystemTextColor() */
	public ColorUIResource getSystemTextColor() {
		return BLACK;
	}

	/* @see gov.va.med.hds.cd.spectrum.plaf.desktop.IDesktopTheme#getControlTextColor() */
	public ColorUIResource getControlTextColor() {
		return BLACK;
	}

	/* @see gov.va.med.hds.cd.spectrum.plaf.desktop.IDesktopTheme#getInactiveControlTextColor() */
	public ColorUIResource getInactiveControlTextColor() {
		return DISABLED_TEXT_GRAY;
	}

	/* @see gov.va.med.hds.cd.spectrum.plaf.desktop.IDesktopTheme#getInactiveSystemTextColor() */
	public ColorUIResource getInactiveSystemTextColor() {
		return DISABLED_TEXT_GRAY;
	}

	/* @see gov.va.med.hds.cd.spectrum.plaf.desktop.IDesktopTheme#getUserTextColor() */
	public ColorUIResource getUserTextColor() {
		return BLACK;
	}

	/* @see gov.va.med.hds.cd.spectrum.plaf.desktop.IDesktopTheme#getTextHighlightColor() */
	public ColorUIResource getTextHighlightColor() {
		return DARK_BLUE;
	}

	/* @see gov.va.med.hds.cd.spectrum.plaf.desktop.IDesktopTheme#getHighlightedTextColor() */
	public ColorUIResource getHighlightedTextColor() {
		return WHITE;
	}

	/* @see gov.va.med.hds.cd.spectrum.plaf.desktop.IDesktopTheme#getWindowBackground() */
	public ColorUIResource getWindowBackground() {
		return WHITE;
	}

	/* @see gov.va.med.hds.cd.spectrum.plaf.desktop.IDesktopTheme#getWindowTitleBackground() */
	public ColorUIResource getWindowTitleBackground() {
		return LIGHT_BLUE;
	}

	/* @see gov.va.med.hds.cd.spectrum.plaf.desktop.IDesktopTheme#getWindowTitleForeground() */
	public ColorUIResource getWindowTitleForeground() {
		return WHITE;
	}

	/* @see gov.va.med.hds.cd.spectrum.plaf.desktop.IDesktopTheme#getWindowTitleInactiveBackground() */
	public ColorUIResource getWindowTitleInactiveBackground() {
		return LIGHT_BLUE;
	}

	/* @see gov.va.med.hds.cd.spectrum.plaf.desktop.IDesktopTheme#getWindowTitleInactiveForeground() */
	public ColorUIResource getWindowTitleInactiveForeground() {
		return BLACK;
	}

	/* @see gov.va.med.hds.cd.spectrum.plaf.desktop.IDesktopTheme#getMenuBackground() */
	public ColorUIResource getMenuBackground() {
		return CONTROL_GRAY;
	}

	/* @see gov.va.med.hds.cd.spectrum.plaf.desktop.IDesktopTheme#getMenuForeground() */
	public ColorUIResource getMenuForeground() {
		return BLACK;
	}

	/* @see gov.va.med.hds.cd.spectrum.plaf.desktop.IDesktopTheme#getMenuSelectedBackground() */
	public ColorUIResource getMenuSelectedBackground() {
		return getTextHighlightColor();
	}

	/* @see gov.va.med.hds.cd.spectrum.plaf.desktop.IDesktopTheme#getMenuSelectedForeground() */
	public ColorUIResource getMenuSelectedForeground() {
		return getHighlightedTextColor();
	}

	/* @see gov.va.med.hds.cd.spectrum.plaf.desktop.IDesktopTheme#getMenuDisabledForeground() */
	public ColorUIResource getMenuDisabledForeground() {
		return DISABLED_TEXT_GRAY;
	}

	/* @see gov.va.med.hds.cd.spectrum.plaf.desktop.IDesktopTheme#getAcceleratorForeground() */
	public ColorUIResource getAcceleratorForeground() {
		return BLACK;
	}

	/* @see gov.va.med.hds.cd.spectrum.plaf.desktop.IDesktopTheme#getAcceleratorSelectedForeground() */
	public ColorUIResource getAcceleratorSelectedForeground() {
		return getMenuSelectedForeground();
	}

	/* @see gov.va.med.hds.cd.spectrum.plaf.desktop.IDesktopTheme#getScrollbarBackground() */
	public ColorUIResource getScrollbarBackground() {
		return SCROLL_BAR_GRAY;
	}

	/* @see gov.va.med.hds.cd.spectrum.plaf.desktop.IDesktopTheme#getInfoBackground() */
	public ColorUIResource getInfoBackground() {
		return TOOL_TIP_YELLOW;
	}

	/* @see gov.va.med.hds.cd.spectrum.plaf.desktop.IDesktopTheme#getInfoForeground() */
	public ColorUIResource getInfoForeground() {
		return BLACK;
	}

	/* @see gov.va.med.hds.cd.spectrum.plaf.desktop.IDesktopTheme#getInactiveUserTextColor() */
	public ColorUIResource getInactiveUserTextColor() {
		return getInactiveControlTextColor();
	}
}
