package gov.va.med.hds.cd.mum.boot.plaf.desktop;
import javax.swing.plaf.ColorUIResource;
import javax.swing.plaf.FontUIResource;

/**
 * This interface acts as a generic way to describe the colors used by the
 * Desktop Look And Feel. Classes which implement this interface can
 * be used to swap the colors in the Desktop.
 */
public interface IDesktopTheme {
	String getName();

	FontUIResource getControlTextFont();
	FontUIResource getSystemTextFont();
	FontUIResource getUserTextFont();
	FontUIResource getMenuTextFont();
	FontUIResource getWindowTitleFont();
	FontUIResource getInfoFont();

	ColorUIResource getFocusColor();

	ColorUIResource getDesktopColor();

	ColorUIResource getControl();
	ColorUIResource getControlShadow();
	ColorUIResource getControlDarkShadow();
	ColorUIResource getControlLight();
	ColorUIResource getControlHighlight();
	ColorUIResource getControlDisabled();
	
	ColorUIResource getPrimaryControl();
	ColorUIResource getPrimaryControlShadow(); 
	ColorUIResource getPrimaryControlDarkShadow();
	ColorUIResource getPrimaryControlLight();
	ColorUIResource getPrimaryControlHighlight();

	ColorUIResource getSystemTextColor();
	ColorUIResource getInactiveSystemTextColor();
	ColorUIResource getControlTextColor();
	ColorUIResource getInactiveControlTextColor();
	ColorUIResource getUserTextColor();
	ColorUIResource getInactiveUserTextColor();
	ColorUIResource getTextHighlightColor();
	ColorUIResource getHighlightedTextColor();

	ColorUIResource getWindowBackground();
	ColorUIResource getWindowTitleBackground();
	ColorUIResource getWindowTitleForeground();  
	ColorUIResource getWindowTitleInactiveBackground();
	ColorUIResource getWindowTitleInactiveForeground();

	ColorUIResource getMenuBackground();
	ColorUIResource getMenuForeground();
	ColorUIResource getMenuSelectedBackground();
	ColorUIResource getMenuSelectedForeground();
	ColorUIResource getMenuDisabledForeground();
//	ColorUIResource getSeparatorBackground();
//	ColorUIResource getSeparatorForeground();
	ColorUIResource getAcceleratorForeground();
	ColorUIResource getAcceleratorSelectedForeground();
	
	ColorUIResource getScrollbarBackground();
	ColorUIResource getInfoBackground();
	ColorUIResource getInfoForeground();
}