package gov.va.med.hds.cd.mum.boot.utils;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.InputStream;
import java.io.Reader;
import java.net.URL;

import org.xml.sax.InputSource;

/**
 * Tree data that can be loaded from a resource
 */
public interface ILoadableTreeData extends ITreeData {
	/**
	 * Loads xml from the passed in file
	 * @param file
	 * @throws SAXParseException
	 * @throws FileNotFoundException
	 * @throws IOException
	 */
	void load(File file) throws FileNotFoundException, TreeDataException;

	/**
	 * Loads xml from the passed in url 
	 * @param url
	 * @throws SAXParseException
	 * @throws IOException
	 */
	void load(URL url) throws FileNotFoundException, TreeDataException;

	/**
	 * Loads xml from the passed in input stream
	 * @param stream
	 * @throws SAXParseException
	 * @throws IOException
	 */
	void load(InputStream stream) throws TreeDataException;

	/**
	 * Loads xml from the passed in input source
	 * @param stream
	 * @throws SAXException
	 * @throws IOException
	 */
	void load(InputSource source) throws TreeDataException;

	/**
	 * Method xml from the passed in reader
	 * @param source
	 * @throws SAXException
	 * @throws IOException
	 */
	void load(Reader reader) throws TreeDataException;
}
