package gov.va.med.hds.cd.mum.update;

/**
 * Creates an instance of the IApplicationLauncher interface.
 */
public class ApplicationLauncherFactory {

	private static IApplicationLauncher launcher;

	/**
	 * Returns a new instance of the IApplicationLauncher
	 * @return IApplicationLauncher
	 */
	public static IApplicationLauncher newApplicationLauncher() {
		if (launcher == null)
			return new ApplicationLauncher();
		else
			return launcher;
	}

	/**
	 * Allows subsequent calls to newApplicationLauncher to return a predetermined
	 * instance of the IApplicationLauncher interface.  This is used primarily
	 * in unit testing.
	 * @param appLauncher
	 */
	public static void assignApplicationLauncher(IApplicationLauncher appLauncher) {
		launcher = appLauncher;
	}
}
