package gov.va.med.hds.cd.mum.update;

/**
 * Creates an instance of the IConfigReader interface
 */
public class ConfigReaderFactory {

	private static IConfigReader reader;

	/**
	 * Returns a new instance of the IConfigReader
	 * @return IConfigReader
	 */
	public static IConfigReader newConfigReader() {
		if (reader == null)
			return new ConfigReader();
		else
			return reader;
	}

	/**
	 * Allows subsequent calls to newConfigReader to return a predetermined
	 * instance of the IConfigReader interface.  This is used primarily
	 * in unit testing.
	 * @param configReader
	 */
	public static void assignConfigReader(IConfigReader configReader) {
		reader = configReader;
	}
}
