package gov.va.med.hds.cd.mum.update;

import java.io.File;

/**
 * Simple data class representing an existing file on the workstation. Contains
 * both the file, it's size, and the CRC value of the file.
 */
public class ExistingFileEntry extends FileData {

	/**
	 * Loads the inital data values.
	 * @param file
	 * @param crc
	 */
	public ExistingFileEntry(File file, long crc, long size) {
		super(crc, size);
		this.file = file;
	}

	/**
	 * Returns the file instance associated with the file.
	 * @return File
	 */
	public File getFile() {
		return file;
	}

	private File file;

}
