package gov.va.med.hds.cd.mum.update;

/**
 * Simple data class representing file data.
 */
public abstract class FileData {

	/**
	 * Constructor for FileData.
	 */
	public FileData(long crc, long size) {
		super();
		this.crc = crc;
		this.size = size;
	}

	/**
	 * Returns the crc of the file.
	 * @return long
	 */
	public long getCRC() {
		return crc;
	}

	/**
	 * Returns the size of the file.
	 * @return int
	 */
	public long getSize() {
		return size;
	}

	private long crc;
	private long size;
}
