package gov.va.med.hds.cd.mum.update;

import gov.va.med.hds.cd.mum.boot.IStartupInfo;
import gov.va.med.hds.cd.mum.boot.utils.ListMap;

import java.net.URL;

/**
 * Interface used for launching an application, by running the plugin with the
 * class implementing the IApplication interface.
 */
public interface IApplicationLauncher {
    /**
     * Launches the application
     * @param configFile - the URL to the configuration file.
     * @param specs - a list of IPluginSpecs, one for each plugin in the
     * configuration.
     * @param info - the Startup info for the application.
     * @param startupSpec - the IPluginSpec for the startup plugin.
     * @throws Throwable
     */
    void launchApplication(
        URL configFile,
        ListMap specs,
        IStartupInfo info,
        IPluginSpec startupSpec)
        throws Throwable;
}
