package gov.va.med.hds.cd.mum.update;

import gov.va.med.hds.cd.mum.boot.utils.ListMap;

import java.io.File;
import java.io.FileNotFoundException;

/**
 * Locates plugins on the current workstation.
 */
public interface IPluginLocator {
	/**
	 * This method populates the passed in list with newly created
	 * IExistingPlugin instances, one for each plugin currently installed on the
	 * workstation.
	 * @param pluginDirectory - the plugin directory
	 * @param list - the list to populate with IExistingPlugin instances
	 * @throws FileNotFoundException
	 * @throws InvalidPluginDirectoryException
	 */
	void locatePlugins(File pluginDirectory, ListMap list)
		throws FileNotFoundException, InvalidPluginDirectoryException;
}
