package gov.va.med.hds.cd.mum.update;

import gov.va.med.hds.cd.mum.boot.utils.ListMap;

/**
 * Tracks plugin usages and deletes unused plugins
 */
public interface IPluginUsageTracker {

	/**
	 * Assigns a date/time stamp to the plugins in the list. 
	 * @param plugins - a list of IPluginSpec objects representing the list of
	 * plugins used by the current configuration.
	 */
	void trackPluginUsage(ListMap plugins);

	/**
	 * Deletes unused plugins.
	 * @param plugins - a list of IExistingPlugin objects representing the
	 * plugins installed on the workstation prior to any updates.
	 */
	void deleteUnusedPlugins(ListMap plugins);
}
