package gov.va.med.hds.cd.mum.update;

import gov.va.med.hds.cd.mum.IMUMConstants;
import gov.va.med.hds.cd.mum.boot.IBootConstants;
import gov.va.med.hds.cd.mum.boot.IPluginConstants;

/**
 * Constants used throughout the MUM.Update package
 */
public interface IUpdateConstants {
    String JUNIT = "org.junit";
    String JUNIT_TEXT_TEST_CLASS = "junit.textui.TestRunner";
    String JUNIT_UI_TEST_CLASS = "junit.swingui.TestRunner";
    String JUNIT_RUN_ERROR = "Error running JUnit";
    String MAIN_METHOD = "main";
	String JUNIT_RUN_METHOD = "run";

    String UPDATE_PROGRESS_FILE = "updating";
    long UPDATE_TIMEOUT = 12 * 60 * 60 * 1000; // 12 hours

    String JUNIT_PLUGIN_NOT_FOUND = "The JUnit plugin was not found.";
    String NO_CONFIG_SPECIFIED = "No Configuration File Specified";
    String BAD_CONFIG_SPECIFIED = "Invalid Configuration File Specified";
    String PLUGIN_NODE_MISSING = "Plugin node was null";
    String MISSING_DIRECTORY =
        "Plugin " + IMUMConstants.DIRECTORY_ATTRIBUTE + " information not found in configuration";
    String INVALID_DIRECTORY_ENTRY = "Plugin directory is not in the format \"name_version\"";
    String INVALID_PLUGIN_VERSION = "Plugin directory version is invalid";
    String INVALID_MODULE_ENTRY = "Plugin module entry can not be blank";

    String NO_MORE_TEXT = "No more than one ";
    String ENTRY_ALLOWED_TEXT = " entry is allowed";

    String MULTIPLE_STARTUP_ENTRIES =
        NO_MORE_TEXT + IMUMConstants.STARTUP_ELEMENT + ENTRY_ALLOWED_TEXT;
    String MULTIPLE_APPLICATION_ENTRIES =
        NO_MORE_TEXT + IMUMConstants.APPLICATION_ELEMENT + ENTRY_ALLOWED_TEXT;
    String NO_WILDCARD_ENTRIES =
        "No configuration wild card publish classes allowed other than \"*\" published entry";
    String DUPLICATE_CLASS_ENTRIES = "The same class is entered twice in the configuration";
    String MISSING_CLASS_TEXT =
        " entry has a blank or missing " + IPluginConstants.CLASS_ATTRIBUTE + " value";
    String MISSING_STARTUP_CLASS = IMUMConstants.STARTUP_ELEMENT + MISSING_CLASS_TEXT;
    String MISSING_APPLICATION_CLASS = IMUMConstants.APPLICATION_ELEMENT + MISSING_CLASS_TEXT;
    String MISSING_PUBLISHED_CLASS = IPluginConstants.PUBLISH_ELEMENT + MISSING_CLASS_TEXT;
    String MISSING_MANIFEST_FILE = "No " + IBootConstants.MANIFEST_FILE + " file found in plugin";
    String INVALID_FILE_ENTRY = "File entry does not have a valid file name or crc";
    String NO_CONFIG_ROOT =
        "configuration files must have a root " + IMUMConstants.CONFIGURATION_ELEMENT + " section";
    String MISSING_CONFIG_CRC =
        IMUMConstants.CONFIGURATION_ELEMENT + " element must have a valid, non-zero crc";
    String MULTIPLE_SETTINGS =
        "More than one " + IBootConstants.SETTINGS_ELEMENT + " sections found in configuration";
    String INCORRET_CONFIGURATION_CRC =
        "The configuration's " + IMUMConstants.CRC_ATTRIBUTE + " value is incorrect";
    String FILE_NOT_DIRECTORY = "File is not a directory";
    String NO_PLUGINS_DIRECTORY_FOUND =
        "No " + IMUMConstants.PLUGIN_DIRECTORY_NAME + " directory found";

    String INVALID_CLASS_LOADER =
        "Plugin Class Loader must be a descendant of the java.lang.ClassLoader Class";

    String MUM_UPDATE_MESSAGE = "Updating Module Update Manager...";
    String PLUGIN_UPDATE_MESSAGE = "Updating Plug-ins...";
    String PLUGINS_UPDATED_MESSAGE = "All plug-ins are up to date.";
    String LAUNCHING_APP_MESSAGE = "Launching Application...";

    String ERROR_MOVING_PLUGIN_FILES =
        "A plug-in update has failed on this workstation."
            + IBootConstants.EOL
            + "The plug-in being updated may be in use by another application."
            + IBootConstants.EOL
            + "Plugin reason for failure:"
            + IBootConstants.EOL
            + "    Unable to move plugin on local file system:"
            + IBootConstants.EOL
            + "    ";

    int MAX_COPY_TRIES = 3;
    String COPY_FAILED_ERROR = "Failure updating plugin ";
    String COPY_FAILED_REASON =
        IBootConstants.EOL
            + "The configuration file may be out of date, or the plugin may contain corrupt files.";

    String UPDATER_NOT_STARTED_ERROR = "beginUpdate must be called before updates are allowed";
    String UPDATER_NOT_STOPPED_ERROR = "endUpdate must be called before calling beginUpdate again";

    String UPDATE_ABORTED_TITLE = "Update Aborted";
    String UPDATE_IN_PROGRESS_ERROR =
        "A plug-in update is currently in progress on this workstation."
            + IBootConstants.EOL
            + "You can not launch this application until the update has completed.";

    String FORCE_COPY_FILENAME = "force.update";
    String INVALID_STARTUP_TITLE = "Internal Error";
    String INVALID_STARTUP = "System updates require you to restart the HealtheVet Application";

    String MISSING_PREREQUISITES_ERROR = "Prerequisite plugins not found in configuration";
}
