package gov.va.med.hds.cd.mum.update;

import gov.va.med.hds.cd.mum.IPluginSource;
import gov.va.med.hds.cd.mum.boot.utils.ITreeData;

/**
 * A simple data class used to store plugin information that is passed to the
 * application in the IApplication interface.
 */
public class PluginSource implements IPluginSource {

	/**
	 * Pulls the needed information from the IPluginSpec for the plugin.
	 * @param spec
	 */
	protected PluginSource(IPluginSpec spec) {
		super();
		this.manifest = spec.getManifestXML();
		this.loader = (ClassLoader) spec.getClassLoader();
	}

	/**
	 * @see gov.va.med.hds.cd.mum.IPluginSource#getManifest()
	 */
	public ITreeData getManifest() {
		return manifest;
	}

	/**
	 * @see gov.va.med.hds.cd.mum.IPluginSource#getClassLoader()
	 */
	public ClassLoader getClassLoader() {
		return loader;
	}

	private ITreeData manifest;
	private ClassLoader loader;
}
