package gov.va.med.hds.cd.mum.update;

/**
 * Represents an error in the plugin update process resulting from a normal
 * condition, such as not having write authority to the disk, or another process
 * already performing an update to the workstation.
 */
public class UnauthorizedUpdateException extends UpdateException {

	/**
     * Constructor for UnauthorizedUpdateException with null as its detail message.
     */
	public UnauthorizedUpdateException() {
		super();
	}

	/**
     * Constructor for UnauthorizedUpdateException with the specified detail message.
     */
	public UnauthorizedUpdateException(String message) {
		super(message);
	}

	/**
     * Constructor for UnauthorizedUpdateException with the specified detail message and cause.
     */
	public UnauthorizedUpdateException(String message, Throwable cause) {
		super(message, cause);
	}

	/**
     * Constructor for UnauthorizedUpdateException with the specified cause.
     */
	public UnauthorizedUpdateException(Throwable cause) {
		super(cause);
	}

}
