
package gov.va.med.hds.cd.mum.utils;

import java.io.File;
import java.io.Serializable;

/**
 * This class is used by {@link ChecksumCache} to hold information about a
 * single file in the cache.
 */
public class ChecksumCacheInfo implements Serializable {

	public long size;
	public long modDate;
	public long crc;

	public ChecksumCacheInfo(File f, long crc) {
		this.size = f.length();
		this.modDate = f.lastModified();
		this.crc = crc;
	}

	public boolean inSync(File file) {
		return (file.length() == size && file.lastModified() == modDate);
	}
}