package gov.va.med.hds.cd.mum.utils;

import java.util.zip.Adler32;
import java.util.zip.Checksum;

/**
 * This class provides the Checksum interface implementation used throughout the MUM.  
 */
public class MUMChecksum implements Checksum {

    private Checksum parent;

    /**
     * Constructor for MUMChecksum 
     */
    public MUMChecksum() {
        super();
        parent = new Adler32();
    }

    /**
     * @see java.util.zip.Checksum#update(int)
     */
    public void update(int value) {
        parent.update(value);
    }

	/**
     * @param value
     */
    public void update(long value) {
		update(Long.toString(value));
	}

    /**
     * @see java.util.zip.Checksum#update(byte[], int, int)
     */
    public void update(byte[] b, int off, int len) {
        parent.update(b, off, len);

    }

    /**
     * @see java.util.zip.Checksum#getValue()
     */
    public long getValue() {
        if (parent.getValue() == 1)
            return 0;
        return parent.getValue();
    }

    /**
     * @see java.util.zip.Checksum#reset()
     */
    public void reset() {
		parent.reset();
    }
    
	/**
     * @param string
     */
    public void update(String string) {
		for (int i = 0; i < string.length(); i++)
			parent.update(Character.getNumericValue(string.charAt(i)));
	}
}
