package mumtest.mum;

import gov.va.med.hds.cd.mum.IApplication;
import gov.va.med.hds.cd.mum.IPluginSource;
import gov.va.med.hds.cd.mum.boot.ISplashScreen;
import gov.va.med.hds.cd.mum.boot.utils.ISavableTreeData;
import gov.va.med.hds.cd.mum.boot.utils.ITreeData;
import gov.va.med.hds.cd.mum.boot.utils.TreeDataException;
import gov.va.med.hds.cd.mum.boot.utils.TreeDataFactory;

import java.io.File;
import java.io.IOException;

public class TestApplication implements IApplication {

	private String TESTFILE_COMMAND_TAG = "-testfile=";

	public TestApplication() {
		super();
	}

	public void run(
		String[] args,
		ITreeData configXML,
		IPluginSource[] plugins,
		ISplashScreen splash) {
		if (splash != null)
			splash.close();
		if ((args != null) && (args.length > 0)) {
			for (int i = 0; i < args.length; i++) {
				if (args[i].startsWith(TESTFILE_COMMAND_TAG)) {
					File file =
						new File(
							args[i].substring(TESTFILE_COMMAND_TAG.length()));
					file.getParentFile().mkdirs();
					ISavableTreeData xml;
					try {
						xml = TreeDataFactory.newSimpleXMLTreeData();
						xml.createChildCopy(configXML, configXML.getRootID(), -1);
						xml.save(file);
					} catch (TreeDataException e) {
					} catch (IOException e) {
					}
					break;
				}
			}
		}
	}

}
