library WinUtils;

{ Important note about DLL memory management: ShareMem must be the
  first unit in your library's USES clause AND your project's (select
  Project-View Source) USES clause if your DLL exports any procedures or
  functions that pass strings as parameters or function results. This
  applies to all strings passed to and from your DLL--even those that
  are nested in records and classes. ShareMem is the interface unit to
  the BORLNDMM.DLL shared memory manager, which must be deployed along
  with your DLL. To avoid using BORLNDMM.DLL, pass string information
  using PChar or ShortString parameters. }

{%File '..\..\..\..\..\Shared\DelphiJNI\PAS\JNI_MD.INC'}

uses
  SysUtils,
  Classes,
  Windows,
  JNI in '..\..\..\..\..\Shared\DelphiJNI\PAS\JNI.pas';

{$R *.res}

function Java_gov_va_med_hds_cd_mum_test_WinUtils_getComputerName(
      PEnv: PJNIEnv; Obj: JObject): JString;
      {$IFDEF WIN32} stdcall; {$ENDIF} {$IFDEF LINUX} cdecl; {$ENDIF}
var
  JVM: TJNIEnv;
  name: String;
  buffer: array [0..255] of char;
  Size: DWORD;

begin
  JVM := TJNIEnv.Create(PEnv);
  Size := Sizeof(buffer);  // Win95 is hypersensitive to size
  if GetComputerName(buffer, Size) then
    SetString(name, buffer, Size)
  else
    name := '';
  Result := JVM.StringToJString(PChar(name));
end;

exports
  Java_gov_va_med_hds_cd_mum_test_WinUtils_getComputerName;

begin
end.

