package gov.va.med.hds.cd.print.printables;

import gov.va.med.hds.cd.daoregistry.IDaoRegistry;
import gov.va.med.hds.cd.print.ConstructionException;
import gov.va.med.hds.cd.print.IPrintable;
import gov.va.med.hds.cd.runtime.IRuntimeContext;
import gov.va.med.hds.util.dao.IServerDateDAO;

import java.util.Date;

/**
 * Provides default printing information for a concrete printable implementation.
 */
abstract public class DefaultPrintable implements IPrintable {
	private IRuntimeContext runtime;
	private Date printDate;
	/**
	 * Constructor 
	 * 
	 * @param runtime
	 */
	public DefaultPrintable(IRuntimeContext runtime) throws ConstructionException{
		this.runtime = runtime;
		IServerDateDAO dateDao;
		try {
			dateDao = (IServerDateDAO) ((IDaoRegistry) getRuntime().getPluginInstance(IDaoRegistry.PLUGIN_ID)).getDAO(IServerDateDAO.class.getName());
			printDate = dateDao.getDate();
		} catch (Exception e) {
			throw new ConstructionException("Couldn't get an instance of "+IServerDateDAO.class.getName());
		}
	}
	/**
	 * Gets the runtime
	 * @return
	 */
	public IRuntimeContext getRuntime() {
		return runtime;
	}
	/**
	 * Gets the date/time of printing
	 * 
	 * @return The date/time set in the constructor
	 */
	public Date getPrintDate() {
		return printDate;
	}

}
