package gov.va.med.hds.cd.print;

import javax.print.DocFlavor;

/**
 * General print interface
 */
public interface IPrint {
	/**
	 * Plugin id
	 */
	public static final String PLUGIN_ID = "gov.va.med.hds.cd.print";
	/**
	 * Print preview extension point name.
	 */
	public static final String PRINT_PREVIEW_EXTENSION_POINT_NAME =
		"gov.va.med.hds.cd.print.previewer";
	/**
	 * Print preview extension point config tag name
	 */
	public static final String PRINT_PREVIEW_CONFIG_TAG_NAME = "previewer";
	/**
	 * Print preview extension point config tag class tag name
	 */
	public static final String PRINT_PREVIEW_CLASS_TAG_NAME = "class";

	/**
	 * Default dots per inch
	 */
	public static final float DEFAULT_DOTS_PER_INCH = 72;

	/**
	 * Displays a page setup dialog for user print selection
	 * 
	 * @param docFlavor specifies the document type
	 */
	void pageSetup(DocFlavor docFlavor);
	/**
	 * Prints the specified Printable
	 * 	 
	 * @param printable
	 * @param docFlavor
	 * @throws PrintFailedException
	 * @throws UserCancelledPrintException
	 */
	void print(Object printable, DocFlavor docFlavor)
		throws PrintFailedException, UserCancelledPrintException;
	/**
	 * Displays the specified Printable in print preview
	 * 	 
	 * @param printable
	 * @param docFlavor
	 * @throws PrintPreviewFailedException
	 * @throws UserCancelledPrintException
	 */
	void printPreview(Object printable, DocFlavor docFlavor)
		throws PrintPreviewFailedException, UserCancelledPrintException;
}
