package gov.va.med.hds.cd.print;

/**
 * Abstraction for providing a print action handler
 */
public interface IPrintActionHandlerProvider {
	/**
	 * Removes IPrintActionEnablingListener for Print
	 * @param listener
	 */
	void removePrintActionEnablingListener(IPrintActionEnablingListener listener);

	/**
	 * Adds IPrintActionEnablingListener for Print
	 * @param listener
	 */
	void addPrintActionEnablingListener(IPrintActionEnablingListener listener);
	/**
	 * Removes IPrintActionEnablingListener for Print Preview
	 * @param listener
	 */
	void removePrintPreviewActionEnablingListener(IPrintActionEnablingListener listener);

	/**
	 * Adds IPrintActionEnablingListener for Print Preview
	 * @param listener
	 */
	void addPrintPreviewActionEnablingListener(IPrintActionEnablingListener listener);
	/**
	 * Removes IPrintActionEnablingListener for Page Setup
	 * @param listener
	 */
	void removePageSetupActionEnablingListener(IPrintActionEnablingListener listener);

	/**
	 * Adds IPrintActionEnablingListener for Page Setup
	 * @param listener
	 */
	void addPageSetupActionEnablingListener(IPrintActionEnablingListener listener);
}
