package gov.va.med.hds.cd.print;
import java.util.EventObject;

/**
 * An event for enabling/disabling print actions
 */
public class PrintActionEnablingEvent extends EventObject {
	/**
	 * Constructor
	 * @param source
	 * @param enabled
	 * @param handler
	 */
	public PrintActionEnablingEvent(Object source, boolean enabled, IPrintActionHandler handler) {
		super(source);
		this.enabled = enabled;
		this.handler = handler;
	}
	/**
	 * Is the action enabled
	 * @return
	 */
	public boolean isEnabled() {
		return enabled;
	}

	/**
	 * Print action handler associated with this event
	 * @return
	 */
	public IPrintActionHandler getHandler() {
		return handler;
	}
	private boolean enabled = false;
	private IPrintActionHandler handler;
}
