package gov.va.med.hds.cd.print.docs.cookbook;

import gov.va.med.hds.cd.print.IPrintable;

import java.awt.Graphics;
import java.awt.print.PageFormat;
import java.awt.print.PrinterException;

/**
 * Cookbook example of a simple graphics based printable object.
 * 
 * This is only a stand alone code fragment. The print method
 * will need to be fully implmented to print something useful.
 */
public class SimplePrintable implements IPrintable {
	/**
	 * Constructor
	 */
	public SimplePrintable() {
		super();
	}

	/**
	 * Implements the main print method. This is defined in the java.awt.print.Printable documentation
	 * The pages can be processed in any order. Index zero is not neccessarily requested first
	 * and the print requests may not be in sequence.
	 * 
	 * @see java.awt.print.Printable#print(java.awt.Graphics, java.awt.print.PageFormat, int)
	 */
	public int print(Graphics graphics, PageFormat pageFormat, int pageIndex)
		throws PrinterException {
		if (pageIndex != 0)
			return IPrintable.NO_SUCH_PAGE;
		else {
			// Use the Graphics2D API to render to the Graphics context
			// The PageFormat object contains the boundaries of the page
			// The pageIndex is the actual page number (zero based).
			return IPrintable.PAGE_EXISTS;
		}
	}
}
