package gov.va.med.hds.cd.prism.action.internal;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Frame;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BorderFactory;
import javax.swing.Icon;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;

import gov.va.med.hds.cd.mum.boot.Splash;
import gov.va.med.hds.cd.mum.boot.plaf.desktop.IDesktopLookAndFeelConstants;
import gov.va.med.hds.cd.prism.IPrismConstants;
import gov.va.med.hds.cd.runtime.IPluginRegistry;

public class AboutDialog extends JDialog {

	private static final String ABOUT = "About ";

	private static final int INSET = IDesktopLookAndFeelConstants.MARGIN;

	public AboutDialog(Frame owner, IPluginRegistry registry) {
		super(owner, ABOUT + IPrismConstants.DESKTOP_NAME, true);
		setDefaultCloseOperation(JDialog.HIDE_ON_CLOSE);
		setResizable(false);
		
		Icon aboutIcon = Splash.getSplashImage();
		
		JTable table = new JTable(new RegistryTableModel(registry));
		table.setPreferredScrollableViewportSize(new Dimension(aboutIcon.getIconWidth(), 70));
		
		JPanel northPanel = new JPanel();
		northPanel.setLayout(new BorderLayout());
		northPanel.add(new JLabel(aboutIcon), BorderLayout.CENTER);
		
		JScrollPane tablePanel = new JScrollPane(table);
			
		JButton okButton = new JButton("OK");
		okButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				setVisible(false);
			}
		});
		
		JPanel buttonPanel = new JPanel();
		((FlowLayout) buttonPanel.getLayout()).setAlignment(FlowLayout.RIGHT);
		buttonPanel.add(okButton);
		
		JPanel contents = new JPanel();
		contents.setBorder(BorderFactory.createEmptyBorder(INSET, INSET, INSET, INSET));
		contents.setLayout(new BorderLayout());
		contents.add(northPanel, BorderLayout.NORTH);
		contents.add(tablePanel, BorderLayout.CENTER);
		contents.add(buttonPanel, BorderLayout.SOUTH);
		
		getContentPane().add(contents);
	
		pack();
		
		int x = owner.getX() + ((owner.getWidth() - getWidth()) / 2);
		int y = owner.getY() + ((owner.getHeight() - getHeight()) / 2);
		setLocation(x, y);
	}
}
