package gov.va.med.hds.cd.prism.action.internal;

import javax.swing.ActionMap;

import gov.va.med.hds.cd.prism.action.IActionDescriptor;
import gov.va.med.hds.cd.prism.action.IActionRegistry;
import gov.va.med.hds.cd.runtime.logging.ILogger;
import gov.va.med.hds.cd.runtime.logging.ILoggingCapable;

public class ActionMapBuilder {

	private ILoggingCapable logging;
	private ILogger log;

	public ActionMapBuilder(ILoggingCapable logging) {
		this.logging = logging;
		log = logging.getLogger(getClass());
	}

	public ActionMap buildActionMap(
		IActionRegistry actionRegistry,
		IActionProxyDelegateListener l) {
		ActionMap map = new ActionMap();
		String[] keys = actionRegistry.keys();
		for (int i = 0; i < keys.length; i++) {
			IActionDescriptor descriptor = actionRegistry.get(keys[i]);
			ActionProxy proxy = new ActionProxy(logging, descriptor);
			if (l != null) proxy.addActionProxyDelegateListener(l);
			map.put(descriptor.getId(), proxy);
		}
		return map;
	}
}