package gov.va.med.hds.cd.prism.action.internal;

import java.util.HashMap;
import java.util.Map;

import gov.va.med.hds.cd.prism.action.IActionDescriptor;
import gov.va.med.hds.cd.prism.action.IActionRegistry;

public class ActionRegistry implements IActionRegistry {

	private Map actions = new HashMap();

	public ActionRegistry() {
		super();
	}

	public boolean contains(String key) {
		return actions.containsKey(key);
	}

	public IActionDescriptor get(String key) {
		return (IActionDescriptor) actions.get(key);
	}	

	public String[] keys() {
		return (String[]) actions.keySet().toArray(new String[actions.size()]);
	}

	public void put(IActionDescriptor action) {
		if (!actions.containsKey(action.getId())) actions.put(action.getId(), action);
	}
	
	public int size() {
		return actions.size();
	}
	
	public void remove(String key) {
		actions.remove(key);
	}
}
