package gov.va.med.hds.cd.prism.action.internal;

import java.awt.event.ActionEvent;
import java.io.IOException;

import javax.swing.Action;

import gov.va.med.hds.cd.mum.boot.ExceptionDialog;
import gov.va.med.hds.cd.prism.action.AbstractAction;
import gov.va.med.hds.cd.prism.internal.Section508Dialog;

/**
 *
 * @author Joel Russell
 *
 * Department of Veterans Affairs
 * OI Field Office - Salt Lake City
 * Health Data Systems
 * 
 **/
public class Section508Action extends AbstractAction {

	public static final String DEFAULT_NAME = "Section 508";

	private Section508Dialog sDialog;

	/**
	 * Constructor for Section508Action.
	 * @param runtime
	 */
	public Section508Action() {
		putValue(Action.NAME, DEFAULT_NAME);
	}

	public void actionPerformed(ActionEvent e) {
		if (sDialog == null) {
			try {
				sDialog =
					new Section508Dialog(getDesktop().getActiveWindow().getFrame());
			} catch (IOException e1) {
				ExceptionDialog.showExceptionDialog("Exception loading Section 508 Dialog", e1.getLocalizedMessage(), e1);
			}
		}
		sDialog.setVisible(true);
	}
}
