package gov.va.med.hds.cd.prism.internal;

import gov.va.med.hds.cd.m.IMumps;
import gov.va.med.hds.cd.m.IMumpsFactory;
import gov.va.med.hds.cd.runtime.IConfigurationElement;
import gov.va.med.hds.cd.runtime.IPluginDescriptor;
import gov.va.med.hds.cd.runtime.IRuntimeContext;

public class PerspectiveListDAO implements IPerspectiveListDAO {
	private static final boolean FORCE_RPCLOGGER = false;
	private static final String PERSPECTIVE_LIST_RPC = "PERSEL";

	private IMumps m;

	/* @see gov.va.med.hds.cd.prism.internal.IPerspectiveListDAO#getPerspectiveIds() */
	public String[] getAvailablePerspectiveIds() throws Exception {
		String perspectiveIds = m.callRPC(PERSPECTIVE_LIST_RPC, new Object[] {});
		if(FORCE_RPCLOGGER)
			perspectiveIds += "\nrpclogger";
		return perspectiveIds.split("\n");
	}

	/* @see gov.va.med.hds.cd.runtime.IExecutableExtension#setInitializationData(gov.va.med.hds.cd.runtime.IRuntimeContext, gov.va.med.hds.cd.runtime.IConfigurationElement, java.lang.String, java.lang.Object) */
	public void setInitializationData(IRuntimeContext runtime, IConfigurationElement config, String propertyName, Object data) throws Exception {
		IPluginDescriptor desc = runtime.getPluginRegistry().getPluginDescriptor(IPrismCoreConstants.PLUGIN_ID);
		m = ((IMumpsFactory) runtime.getPluginInstance(IMumpsFactory.PLUGIN_ID)).create(desc);
	}
}
