package gov.va.med.hds.cd.prism.internal;

import gov.va.med.hds.cd.prism.PrismUtilities;
import gov.va.med.hds.cd.prism.perspective.IPerspectiveListener;
import gov.va.med.hds.cd.prism.perspective.PerspectiveAdapter;
import gov.va.med.hds.cd.prism.perspective.PerspectiveEvent;
import gov.va.med.hds.cd.workspace.IWorkspace;

public class PerspectiveScopeRegistrar
	extends PerspectiveAdapter
	implements IPerspectiveListener {

	private IWorkspace workspace;

	public PerspectiveScopeRegistrar(IWorkspace workspace) {
		this.workspace = workspace;
	}

	public void perspectiveOpening(PerspectiveEvent e) {
		workspace.addScope(getScopeId(e));
	}

	public void perspectiveClosed(PerspectiveEvent e) {
		workspace.removeScope(getScopeId(e));
	}

	private String getScopeId(PerspectiveEvent e) {
		return PrismUtilities.getPerspectiveScopeId(
			e.getWindow(),
			e.getPerspective().getDescriptor());
	}
}
