/*
 * Created on May 30, 2003 10:02:29 AM
 */
package gov.va.med.hds.cd.prism.internal;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Frame;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.IOException;

import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.JDialog;
import javax.swing.JEditorPane;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JSeparator;
import javax.swing.border.EmptyBorder;

import gov.va.med.hds.cd.spectrum.GradientPanel;

/**
 *
 * @author Joel Russell
 *
 * Department of Veterans Affairs
 * OI Field Office - Salt Lake City
 * Health Data Systems
 * 
 **/
public class Section508Dialog extends JDialog {

	private JLabel iconLabel;
	private JEditorPane editorPane;
	private JScrollPane scrollPane;
	private JButton okButton;
	private Frame parent = null;
	private GradientPanel topPanel;
	private JPanel messagePanel;
	private JPanel buttonPanel;

	public Section508Dialog(Frame parent) throws IOException {
		super(parent, true);
		this.parent = parent;
		initGUI();
	}

	private void initGUI() throws IOException {
		setTitle("About Section 508");
//		setResizable(false);

        iconLabel =
            new JLabel(
                new ImageIcon(
                    Section508Dialog.class.getResource("dvaseal.png")));
		iconLabel.setOpaque(false);

		topPanel =
			new GradientPanel(
				"Rehabilitation Act of 1973",
				"Section 508",
				new Color(0, 0, 0),
				new Color(255, 255, 255),
				GradientPanel.LEFT_TO_RIGHT);
		iconLabel.setBorder(new EmptyBorder(0, 0, 0, 20));
		setComponentSize(topPanel, new Dimension(300, 66));
		topPanel.add(iconLabel, BorderLayout.EAST);
		getContentPane().add(topPanel, BorderLayout.NORTH);

		editorPane = new JEditorPane();
		editorPane.setContentType("text/html");
		editorPane.setEditable(false);
        editorPane.setPage(
            Section508Dialog.class.getResource("section 508 notice.htm"));
		scrollPane = new JScrollPane(editorPane);

		messagePanel = new JPanel(new BorderLayout());
		messagePanel.setBorder(new EmptyBorder(10, 10, 10, 10));
		messagePanel.add(scrollPane, BorderLayout.CENTER);
		setComponentSize(messagePanel, new Dimension(300, 300));

		getContentPane().add(messagePanel, BorderLayout.CENTER);
		getContentPane().add(new JSeparator(), BorderLayout.SOUTH);

		okButton = new JButton("OK");
		setComponentSize(okButton, new Dimension(75, 23));
		okButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				setVisible(false);
				dispose();
			}
		});

		buttonPanel = new JPanel();
		buttonPanel.setLayout(new BoxLayout(buttonPanel, BoxLayout.X_AXIS));
		buttonPanel.setBorder(new EmptyBorder(10, 10, 10, 10));
		setComponentSize(buttonPanel, new Dimension(250, 43));
		buttonPanel.add(Box.createHorizontalGlue());
		buttonPanel.add(okButton);
		buttonPanel.add(Box.createHorizontalGlue());
		getContentPane().add(buttonPanel, BorderLayout.SOUTH);

		pack();

		int x = parent.getX() + ((parent.getWidth() - getWidth()) / 2);
		int y = parent.getY() + ((parent.getHeight() - getHeight()) / 2);

		setLocation(x, y);
		
		okButton.grabFocus();
	}

	private void setComponentSize(JComponent component, Dimension dimension) {
		component.setMaximumSize(dimension);
		component.setMinimumSize(dimension);
		component.setPreferredSize(dimension);
	}

}
