package gov.va.med.hds.cd.prism.internal;

import javax.swing.event.EventListenerList;

import gov.va.med.hds.cd.prism.ISelectionListener;
import gov.va.med.hds.cd.prism.ISelectionSource;
import gov.va.med.hds.cd.prism.SelectionEvent;

public abstract class SelectionSource implements ISelectionSource {
	
	protected EventListenerList listeners = new EventListenerList();

	public void addSelectionListener(ISelectionListener listener) {
		listeners.add(ISelectionListener.class, listener);
	}

	public void removeSelectionListener(ISelectionListener listener) {
		listeners.remove(ISelectionListener.class, listener);
	}

	protected void fireSelectionChanged(SelectionEvent event) {
		Object[] l = listeners.getListenerList();
		for (int i = 0; i < l.length; ++i) {
			if (l[i] == event.getSource()) continue;
			if (!(l[i] instanceof ISelectionListener)) continue;
			
			ISelectionListener listener = (ISelectionListener) l[i];
			listener.selectionChanged(event);
		}
	}

}
