package gov.va.med.hds.cd.prism.internal;

import javax.swing.JTable;
import javax.swing.event.EventListenerList;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

import gov.va.med.hds.cd.prism.ISelection;
import gov.va.med.hds.cd.prism.SelectionEvent;

public class TableSelectionSource extends SelectionSource {

	private EventListenerList listeners = new EventListenerList();

	private JTable table;

	public TableSelectionSource(JTable table) {
		this.table = table;
		
		table.getSelectionModel().addListSelectionListener(new SelectionListener());
	}

	public ISelection getSelection() {
		// TODO_SB: handle all selection modes properly (write tests!)
		return new Selection(table.getValueAt(table.getSelectedRow(), table.getSelectedColumn()));
	}
	
	protected class SelectionListener implements ListSelectionListener {
		public void valueChanged(ListSelectionEvent e) {
			if (e.getValueIsAdjusting()) return;
			fireSelectionChanged(new SelectionEvent(TableSelectionSource.this, getSelection()));
		}
	}
}
