package gov.va.med.hds.cd.prism.menu.internal;

import java.util.Iterator;

public class ContainsActionVisitor implements IMenuTreeNodeVisitor {

	private String contextId;
	private String actionId;
	private boolean contains = false;
	private boolean done = false;

	public ContainsActionVisitor(String contextId, String actionId) {
		this.contextId = contextId;
		this.actionId = actionId;
	}

	public void visit(MenuNode node) {
		visitChildren(node);
	}
	
	public void visit(SlotNode node) {
		visitChildren(node);
	}

	public void visit(ActionNode node) {
		if (node.getId().equals(actionId)) contains = true;
	}

	public void visit(SeparatorNode separatorNode) {
		// NOOP
	}

	public void visit(ContextNode node) {
		if (contextId != null && contextId.equals(node.getContextId())) node.getNode().accept(this);
	}

	public boolean contains() {
		return contains;
	}
	
	private boolean isDone() {
		return contains();
	}
	
	private void visitChildren(ParentNode node) {
		if (isDone())
			return;
		for (Iterator i = node.getChildren().iterator(); i.hasNext();) {
			((MenuTreeNode) i.next()).accept(this);
			if (isDone()) return;
		}
	}
}
