package gov.va.med.hds.cd.prism.menu.internal;

import javax.swing.JMenu;

import gov.va.med.hds.cd.prism.IPrismConstants;
import gov.va.med.hds.cd.runtime.IConfigurationElement;

public class MenuNode extends ParentNode {
	
	private String name;
	private Character mnemonic;
	private IConfigurationElement element;
	
	public MenuNode(String id, String name, Character mnemonic) {
		super(id);
		this.name = name;
		this.mnemonic = mnemonic;
	}
	
	public MenuNode(String id, IConfigurationElement element, Character mnemonic) {
		super(id);
		this.mnemonic = mnemonic;
		this.element = element;
	}
	
	public void accept(IMenuTreeNodeVisitor visitor) {
		visitor.visit(this);
	}
	
	public String getName() {
		return name;
	}
	
	public boolean hasCustomMenuClass() {
		return element != null;
	}
	
	public JMenu createMenu() throws Exception {
		return (JMenu) element.createExecutableExtension(IPrismConstants.CLASS_ATTRIBUTE);
	}
	
	public Character getMnemonic() {
		return mnemonic;
	}
}
