package gov.va.med.hds.cd.prism.menu.internal;

import java.util.Collection;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

public abstract class ParentNode extends MenuTreeNode {

	private List children;

	protected ParentNode(String id) {
		super(id);
		this.children = new LinkedList();
	}

	public void addChild(MenuTreeNode node) {
		children.add(node);
	}

	public Collection getChildren() {
		return children;
	}

	public Object clone() {
		ParentNode node = (ParentNode) super.clone();
		node.children = new LinkedList();
		for (Iterator i = children.iterator(); i.hasNext();) {
			MenuTreeNode element = (MenuTreeNode) i.next();
			node.children.add(element.clone());
		}		
		return node;
	}
}
