package gov.va.med.hds.cd.prism.perspective.internal;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import gov.va.med.hds.cd.prism.perspective.IContainerNode;
import gov.va.med.hds.cd.prism.perspective.ILayoutNode;

public abstract class ContainerNode extends LayoutNode implements IContainerNode {

	private List children = new ArrayList();

	public ILayoutNode[] getChildren() {
		return (ILayoutNode[]) children.toArray(new ILayoutNode[children.size()]);
	}
	
	public void add(LayoutNode node) {
		if (children.contains(node)) return;
		children.add(node);
		node.setParent(this);
	}
	
	
	public int getFlexTotal() {
		int flexTotal = 0;
		for (Iterator i = children.iterator(); i.hasNext();) {
			ILayoutNode node = (ILayoutNode) i.next();
			if (node.getFlex() != IContainerNode.UNSPECIFIED) {
				flexTotal += node.getFlex();
			}
		}
		return flexTotal;
	}
	
	public static int getFlexTotal(ILayoutNode[] nodes) {
		int flexTotal = 0;
		for (int i = 0; i < nodes.length; i++) {
			if (nodes[i].getFlex() != IContainerNode.UNSPECIFIED) {
				flexTotal += nodes[i].getFlex();
			}
		}
		return flexTotal;
	}
}
