package gov.va.med.hds.cd.prism.perspective.internal;

import gov.va.med.hds.cd.prism.perspective.IContainerNode;
import gov.va.med.hds.cd.prism.perspective.ILayoutNode;

public abstract class LayoutNode implements ILayoutNode {

	private IContainerNode parent;
	
	private int flex 		= 0;
	private int height 	= UNSPECIFIED;
	private int minHeight	= UNSPECIFIED;
	private int maxHeight	= UNSPECIFIED;
	private int width 	= UNSPECIFIED;
	private int minWidth	= UNSPECIFIED;
	private int maxWidth	= UNSPECIFIED;
	
	public int getFlex() {
		return flex;
	}

	public int getHeight() {
		return height;
	}

	public int getMaxHeight() {
		return maxHeight;
	}

	public int getMaxWidth() {
		return maxWidth;
	}

	public int getMinHeight() {
		return minHeight;
	}

	public int getMinWidth() {
		return minWidth;
	}

	public IContainerNode getParent() {
		return parent;
	}

	public int getWidth() {
		return width;
	}

	public int getOrientation() {
		return UNSPECIFIED;
	}	

	public int getAlign() {
		return UNSPECIFIED;
	}

	public void setFlex(int flex) {
		if (flex < 0) throw new IllegalArgumentException();
		this.flex = flex;
	}

	public void setHeight(int height) {
		if (getMinHeight() != UNSPECIFIED) {
			if (height < getMinHeight()) height = getMinHeight();
		}
		if (getMaxHeight() != UNSPECIFIED) {
			if (height > getMaxHeight()) height = getMaxHeight();
		}
		this.height = height;
	}

	public void setMaxHeight(int maxHeight) {
		if (flex < 0) throw new IllegalArgumentException();
		this.maxHeight = maxHeight;
	}

	public void setMaxWidth(int maxWidth) {
		if (flex < 0) throw new IllegalArgumentException();
		this.maxWidth = maxWidth;
	}

	public void setMinHeight(int minHeight) {
		if (minHeight < 0) throw new IllegalArgumentException();
		if (getMaxHeight() != UNSPECIFIED && minHeight >= getMaxHeight()) throw new IllegalArgumentException();
		this.minHeight = minHeight;
	}

	public void setMinWidth(int minWidth) {
		if (getMaxWidth() != UNSPECIFIED && minWidth >= getMaxWidth()) throw new IllegalArgumentException();
		this.minWidth = minWidth;
	}

	public void setParent(IContainerNode parent) {
		this.parent = parent;
	}

	public void setWidth(int width) {
		if (getMinWidth() != UNSPECIFIED) {
			if (width < getMinWidth()) width = getMinWidth();
		}
		if (getMaxWidth() != UNSPECIFIED) {
			if (width > getMaxWidth()) width = getMaxWidth();
		}
		this.width = width;
	}

}
