package gov.va.med.hds.cd.prism.perspective.internal;

import javax.swing.event.EventListenerList;

import gov.va.med.hds.cd.prism.IDesktopWindow;
import gov.va.med.hds.cd.prism.perspective.IPerspectiveDescriptor;
import gov.va.med.hds.cd.prism.perspective.IPerspectiveEventSource;
import gov.va.med.hds.cd.prism.perspective.IPerspectiveListener;
import gov.va.med.hds.cd.prism.perspective.IPerspectiveReference;
import gov.va.med.hds.cd.prism.perspective.PerspectiveEvent;

public abstract class PerspectiveEventSourceSupport implements IPerspectiveEventSource {

	protected EventListenerList listenerList = new EventListenerList();

	protected void firePerspectiveActivated(IPerspectiveReference p, IDesktopWindow w) {
		final PerspectiveEvent event = new PerspectiveEvent(this, p, w);
		IPerspectiveListener[] listeners =
			(IPerspectiveListener[]) listenerList.getListeners(IPerspectiveListener.class);
		for (int i = 0; i < listeners.length; i++) {
			listeners[i].perspectiveActivated(event);
		}
	}

	protected void firePerspectiveOpening(IPerspectiveDescriptor d, IDesktopWindow w) {
		final OpeningPerspectiveReference p = new OpeningPerspectiveReference(d);
		final PerspectiveEvent event = new PerspectiveEvent(this, p, w);
		IPerspectiveListener[] listeners =
			(IPerspectiveListener[]) listenerList.getListeners(IPerspectiveListener.class);
		for (int i = 0; i < listeners.length; i++) {
			listeners[i].perspectiveOpening(event);
		}
	}

	protected void firePerspectiveOpened(IPerspectiveReference p, IDesktopWindow w) {
		final PerspectiveEvent event = new PerspectiveEvent(this, p, w);
		IPerspectiveListener[] listeners =
			(IPerspectiveListener[]) listenerList.getListeners(IPerspectiveListener.class);
		for (int i = 0; i < listeners.length; i++) {
			listeners[i].perspectiveOpened(event);
		}
	}

	protected void firePerspectiveClosing(IPerspectiveReference p, IDesktopWindow w) {
		final PerspectiveEvent event = new PerspectiveEvent(this, p, w);
		IPerspectiveListener[] listeners =
			(IPerspectiveListener[]) listenerList.getListeners(IPerspectiveListener.class);
		for (int i = 0; i < listeners.length; i++) {
			listeners[i].perspectiveClosing(event);
		}
	}

	protected void firePerspectiveClosed(IPerspectiveReference p, IDesktopWindow w) {
		final PerspectiveEvent event = new PerspectiveEvent(this, p, w);
		IPerspectiveListener[] listeners =
			(IPerspectiveListener[]) listenerList.getListeners(IPerspectiveListener.class);
		for (int i = 0; i < listeners.length; i++) {
			listeners[i].perspectiveClosed(event);
		}
	}

	public void removePerspectiveListener(IPerspectiveListener l) {
		listenerList.remove(IPerspectiveListener.class, l);
	}

	public void addPerspectiveListener(IPerspectiveListener l) {
		listenerList.add(IPerspectiveListener.class, l);
	}










}
