package gov.va.med.hds.cd.prism.perspective.internal;

import java.util.HashMap;
import java.util.Map;

import gov.va.med.hds.cd.prism.perspective.IPerspectiveDescriptor;
import gov.va.med.hds.cd.prism.perspective.IPerspectiveRegistry;

public class PerspectiveRegistry implements IPerspectiveRegistry {

	private Map perspectives = new HashMap();

	public void add(IPerspectiveDescriptor p) {
		perspectives.put(p.getId(), p);
	}

	public void remove(String id) {
		perspectives.remove(id);
	}

	public void remove(IPerspectiveDescriptor p) {
		remove(p.getId());
	}

	public IPerspectiveDescriptor get(String id) {
		return (IPerspectiveDescriptor) perspectives.get(id);
	}

	public int size() {
		return perspectives.size();
	}

	public boolean contains(IPerspectiveDescriptor p) {
		return contains(p.getId());
	}

	public boolean contains(String id) {
		return perspectives.containsKey(id);
	}

	public IPerspectiveDescriptor[] getPerspectiveDescriptors() {
		return (IPerspectiveDescriptor[]) perspectives.values().toArray(new IPerspectiveDescriptor[perspectives.size()]);
	}
}
