package gov.va.med.hds.cd.prism.visualcomponent.internal;

import java.awt.BorderLayout;
import java.awt.GridLayout;

import javax.swing.Icon;
import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.SwingConstants;
import javax.swing.UIManager;

import gov.va.med.hds.cd.prism.visualcomponent.IVisualComponent;
import gov.va.med.hds.cd.prism.visualcomponent.IVisualComponentDescriptor;
import gov.va.med.hds.cd.runtime.IConfigurationElement;
import gov.va.med.hds.cd.runtime.IRuntimeContext;
import gov.va.med.hds.util.ExceptionStackTrace;

public class VisualComponentErrorPlaceholder extends JPanel implements IVisualComponent {

	public VisualComponentErrorPlaceholder(IVisualComponentDescriptor descriptor, Exception e) {
		super();
		setLayout(new GridLayout(2,1));
		Icon icon = UIManager.getIcon("OptionPane.errorIcon");
		JLabel label = new JLabel("Error creating visual component " + descriptor.getName() + " (" + descriptor.getId()+")", icon, SwingConstants.CENTER);
		JTextArea textArea = new JTextArea(ExceptionStackTrace.getStackTrace(e));
		JScrollPane scrollPane = new JScrollPane(textArea);
//		scrollPane.setBorder(BorderFactory.createEmptyBorder(6,6,6,6));
	
		add(label, BorderLayout.NORTH);
		add(scrollPane, BorderLayout.CENTER);
	}

	public JComponent getComponent() {
		return this;
	}

	public void setInitializationData(
		IRuntimeContext runtime,
		IConfigurationElement config,
		String propertyName,
		Object data)
		throws Exception {
		// NOOP
	}
}
