package gov.va.med.hds.cd.prism.visualcomponent.internal;

import javax.swing.event.EventListenerList;

import gov.va.med.hds.cd.prism.visualcomponent.IVisualComponentEventSource;
import gov.va.med.hds.cd.prism.visualcomponent.IVisualComponentListener;
import gov.va.med.hds.cd.prism.visualcomponent.IVisualComponentReference;
import gov.va.med.hds.cd.prism.visualcomponent.VisualComponentEvent;

public abstract class VisualComponentEventSourceSupport
	implements IVisualComponentEventSource {

	protected EventListenerList listenerList = new EventListenerList();

	public void addVisualComponentListener(IVisualComponentListener l) {
		listenerList.add(IVisualComponentListener.class, l);
	}

	public void removeVisualComponentListener(IVisualComponentListener l) {
		listenerList.remove(IVisualComponentListener.class, l);
	}

	protected void fireComponentClosed(IVisualComponentReference c) {
		final VisualComponentEvent event = new VisualComponentEvent(this, c);
		IVisualComponentListener[] listeners =
			(IVisualComponentListener[]) listenerList.getListeners(IVisualComponentListener.class);
		for (int i = 0; i < listeners.length; i++) {
			listeners[i].componentClosed(event);
		}
	}

	protected void fireComponentOpened(IVisualComponentReference c) {
		final VisualComponentEvent event = new VisualComponentEvent(this, c);
		IVisualComponentListener[] listeners =
			(IVisualComponentListener[]) listenerList.getListeners(IVisualComponentListener.class);
		for (int i = 0; i < listeners.length; i++) {
			listeners[i].componentOpened(event);
		}
	}

	protected void fireComponentDeactivated(IVisualComponentReference c) {
		final VisualComponentEvent event = new VisualComponentEvent(this, c);
		IVisualComponentListener[] listeners =
			(IVisualComponentListener[]) listenerList.getListeners(IVisualComponentListener.class);
		for (int i = 0; i < listeners.length; i++) {
			listeners[i].componentDeactivated(event);
		}
	}

	protected void fireComponentActivated(IVisualComponentReference c) {
		final VisualComponentEvent event = new VisualComponentEvent(this, c);
		IVisualComponentListener[] listeners =
			(IVisualComponentListener[]) listenerList.getListeners(IVisualComponentListener.class);
		for (int i = 0; i < listeners.length; i++) {
			listeners[i].componentActivated(event);
		}
	}







}
