package gov.va.med.hds.cd.prism.visualcomponent.internal;

import java.util.ArrayList;
import java.util.List;

import gov.va.med.hds.cd.prism.visualcomponent.IVisualComponentReference;

public class VisualComponentManager extends VisualComponentEventSourceSupport {

	private List components = new ArrayList();
	private IVisualComponentReference activeVisualComponent;

	public void open(IVisualComponentReference component) {
		if (components.contains(component)) return;
		components.add(component);
		fireComponentOpened(component);
		setActiveVisualComponent(component);
	}

	public void close(IVisualComponentReference component) {
		if (!components.contains(component)) return;
		components.remove(component);
		if (getActiveVisualComponent().equals(component)) {
			if (getVisualComponentCount() > 0) {
				setActiveVisualComponent((IVisualComponentReference) components.get(0));
			} else {
				setActiveVisualComponent(null);
			}
		}
		fireComponentClosed(component);
	}

	public void setActiveVisualComponent(IVisualComponentReference component) {
		if (getActiveVisualComponent() != null && getActiveVisualComponent().equals(component)) return;
		if (component != null && !isComponentOpen(component)) open(component);
		if (getActiveVisualComponent() != null) fireComponentDeactivated(activeVisualComponent);
		this.activeVisualComponent = component;
		if (getActiveVisualComponent() != null) fireComponentActivated(activeVisualComponent);
	}

	public IVisualComponentReference getActiveVisualComponent() {
		return activeVisualComponent;
	}

	public boolean isComponentOpen(IVisualComponentReference component) {
		return components.contains(component);
	}

    public IVisualComponentReference[] getVisualComponents() {
       return (IVisualComponentReference[]) components.toArray(new IVisualComponentReference[components.size()]);
    }

	public int getVisualComponentCount() {
		return components.size();
	}
}
