package gov.va.med.hds.cd.prism.visualcomponent.internal;

import java.util.HashMap;
import java.util.Map;

import gov.va.med.hds.cd.prism.visualcomponent.IVisualComponentDescriptor;
import gov.va.med.hds.cd.prism.visualcomponent.IVisualComponentRegistry;

public class VisualComponentRegistry implements IVisualComponentRegistry {

	private Map components = new HashMap();

	public void add(IVisualComponentDescriptor c) {
		components.put(c.getId(), c);
	}

	public boolean contains(IVisualComponentDescriptor c) {
		return contains(c.getId());
	}

	public boolean contains(String id) {
		return components.containsKey(id);
	}

	public IVisualComponentDescriptor get(String id) {
		return (IVisualComponentDescriptor) components.get(id);
	}

	public int size() {
		return components.size();
	}

}
