package gov.va.med.hds.cd.prism.test;

import junit.framework.TestCase;

import gov.va.med.hds.cd.prism.perspective.internal.ComponentNode;

public class ComponentNodeTest extends TestCase {

	private ComponentNode node;

	public ComponentNodeTest(String name) {
		super(name);
	}

	protected void setUp() throws Exception {
		node = new ComponentNode("test");
	}

	public void testSetFlex() {
		node.setFlex(4);
		assertEquals(4, node.getFlex());
		node.setFlex(0);
		assertEquals(0, node.getFlex());
		try {
			node.setFlex(-1);
			fail("expected illegal argument exception");
		} catch (IllegalArgumentException e) {
		}
	}

	public void testSetMinHeight() {
		node.setMinHeight(4);
		assertEquals(4, node.getMinHeight());
		node.setMinHeight(0);
		assertEquals(0, node.getMinHeight());
		try {
			node.setMinHeight(-1);
			fail("expected illegal argument exception");
		} catch (IllegalArgumentException e) {
		}
		node.setMaxHeight(56);
		try {
			node.setMinHeight(57);
			fail("expected illegal argument exception");
		} catch (IllegalArgumentException e) {
		}
	}

}
