package gov.va.med.hds.cd.prism.test;

import java.util.ArrayList;
import java.util.List;

import javax.swing.JComponent;
import javax.swing.JLabel;

import gov.va.med.hds.cd.prism.perspective.IPerspectiveDescriptor;
import gov.va.med.hds.cd.prism.perspective.IPerspectiveReference;
import gov.va.med.hds.cd.prism.visualcomponent.IVisualComponent;
import gov.va.med.hds.cd.prism.visualcomponent.IVisualComponentDescriptor;
import gov.va.med.hds.cd.prism.visualcomponent.IVisualComponentListener;
import gov.va.med.hds.cd.prism.visualcomponent.IVisualComponentReference;
import gov.va.med.hds.cd.runtime.IConfigurationElement;
import gov.va.med.hds.cd.runtime.IRuntimeContext;
import gov.va.med.hds.cd.workspace.ListenerOfEventDescriptor;
import gov.va.med.hds.cd.workspace.SourceOfEventDescriptor;

public class MockPerspective implements IPerspectiveReference {

	private IPerspectiveDescriptor descriptor;
	private List components = new ArrayList();

	public MockPerspective() {
		super();
		components.add(new MockComponent("mock"));
	}

	public IPerspectiveDescriptor getDescriptor() {
		return descriptor;
	}

	public void setDescriptor(IPerspectiveDescriptor d) {
		this.descriptor = d;
	}

	public IVisualComponentReference[] getVisualComponents() {
		return (IVisualComponentReference[]) components.toArray(new IVisualComponentReference[components.size()]);
	}

	public void addSourceVisualComponent(String id, String eventClassName) {
		MockComponent c = new MockComponent(id);
		c.setSourceOfEvent(eventClassName);
		components.add(c);
	}

	public void addListeningVisualComponent(String id, String eventClassName) {
		MockComponent c = new MockComponent(id);
		c.setListenerOfEvent(eventClassName);
		components.add(c);
	}

	public JComponent getComponent() {
		return null;
	}

	public IVisualComponentReference getActiveVisualComponent() {
		return (IVisualComponentReference) components.get(0);
	}

	public void addVisualComponentListener(IVisualComponentListener l) {
	}

	public void removeVisualComponentListener(IVisualComponentListener l) {
	}

	private class MockComponent extends JLabel implements IVisualComponentReference, IVisualComponentDescriptor, IVisualComponent {
		
		private String id;
		private String sourceEvent;
		private String listenerEvent;
		
		public MockComponent(String id) {
			super(id);
			this.id = id;
		}
		
		public JComponent getComponent() {
			return this;
		}

		/* @see gov.va.med.hds.cd.runtime.IExecutableExtension#setInitializationData(gov.va.med.hds.cd.runtime.IRuntimeContext, gov.va.med.hds.cd.runtime.IConfigurationElement, java.lang.String, java.lang.Object) */
		public void setInitializationData(IRuntimeContext runtime, IConfigurationElement config, String propertyName, Object data) throws Exception {
			
		}

		/* @see gov.va.med.hds.cd.prism.visualcomponent.IVisualComponentReference#getDescriptor() */
		public IVisualComponentDescriptor getDescriptor() {
			return this;
		}

		/* @see gov.va.med.hds.cd.prism.visualcomponent.IVisualComponentReference#getVisualComponent() */
		public IVisualComponent getVisualComponent() {
			return this;
		}

		public String getId() {
			return id;
		}

		public IVisualComponent createVisualComponent() {
			return null;
		}

		public SourceOfEventDescriptor[] getSourceOfEventDescriptors() {
			if (sourceEvent == null) return new SourceOfEventDescriptor[] { };
			return new SourceOfEventDescriptor[] { new SourceOfEventDescriptor(sourceEvent) };
		}

		public ListenerOfEventDescriptor[] getListenerOfEventDescriptors() {
			if (listenerEvent == null) return new ListenerOfEventDescriptor[] {};
			return new ListenerOfEventDescriptor[] { new ListenerOfEventDescriptor(listenerEvent) };
		}
		
		public void setSourceOfEvent(String eventClassName) {
			sourceEvent = eventClassName;
		}
		
		public void setListenerOfEvent(String eventClassName) {
			listenerEvent = eventClassName;
		}
	}
}
