package gov.va.med.hds.cd.prism.test;

import java.io.PrintWriter;
import java.io.StringWriter;

import junit.framework.Assert;

import gov.va.med.hds.cd.mum.Version;
import gov.va.med.hds.cd.runtime.IConfigurationElement;
import gov.va.med.hds.cd.runtime.IPluginActivationListener;
import gov.va.med.hds.cd.runtime.IPluginRegistry;
import gov.va.med.hds.cd.runtime.IRuntimeContext;
import gov.va.med.hds.cd.runtime.PluginNotFoundException;
import gov.va.med.hds.cd.runtime.PluginStartupException;
import gov.va.med.hds.cd.runtime.logging.IHandler;
import gov.va.med.hds.cd.runtime.logging.ILogger;
import gov.va.med.hds.cd.runtime.logging.Level;

public class MockRuntime implements IRuntimeContext {

	/* @see gov.va.med.hds.cd.runtime.IRuntimeContext#getSettings() */
	public IConfigurationElement[] getSettings() {
		return null;
	}

	/* @see gov.va.med.hds.cd.runtime.IRuntimeContext#getPluginRegistry() */
	public IPluginRegistry getPluginRegistry() {
		return null;
	}

	/* @see gov.va.med.hds.cd.runtime.IRuntimeContext#isPluginActive(java.lang.String) */
	public boolean isPluginActive(String pluginId) {
		return true;
	}

	/* @see gov.va.med.hds.cd.runtime.IRuntimeContext#getPluginInstance(java.lang.String) */
	public Object getPluginInstance(String pluginId)
		throws PluginStartupException, PluginNotFoundException {
		return null;
	}

	/* @see gov.va.med.hds.cd.runtime.IRuntimeContext#getPluginInstance(java.lang.String, gov.va.med.hds.cd.mum.Version) */
	public Object getPluginInstance(String pluginId, Version version)
		throws PluginStartupException, PluginNotFoundException {
		return null;
	}

	/* @see gov.va.med.hds.cd.runtime.logging.ILoggingCapable#getLogger(java.lang.Class) */
	public ILogger getLogger(Class c) {
		return getLogger(c.getName());
	}

	/* @see gov.va.med.hds.cd.runtime.logging.ILoggingCapable#getLogger(java.lang.String) */
	public ILogger getLogger(String name) {
		return new ILogger() {

			public void fatal(String message) {
				Assert.fail(message);
			}

			public void fatal(String message, Throwable t) {
				Assert.fail(getInternalMessage(message, t));
			}

			public void error(String message) {
				Assert.fail(message);
			}

			public void error(String message, Throwable t) {
				Assert.fail(getInternalMessage(message, t));
			}

			public void warning(String message) {
			}

			public void warning(String message, Throwable t) {
			}

			public void info(String message) {
			}

			public void info(String message, Throwable t) {
			}

			public void debug(String message) {
			}

			public void debug(String message, Throwable t) {
			}

			public void log(Level level, String message) {
			}

			public void log(Level level, String message, Throwable t) {
			}

			public void addHandler(IHandler logHandler) {
			}

			public void removeHandler(IHandler logHandler) {

			}

			public void setUseParentHandlers(boolean b) {
			}
			
			private String getInternalMessage(String message, Throwable t) {
				StringWriter w = new StringWriter();
				StringBuffer buffer = w.getBuffer();
				buffer.append(message);
				buffer.append(": ");
				t.printStackTrace(new PrintWriter(w));
				return w.toString();
			}

			public boolean getUseParentHandlers() {
				// TODO_SB: Auto-generated method stub
				return false;
			}
		};
	}
	
	public ILogger getRootLogger() {
		return getLogger("root");	
	}

	/* @see gov.va.med.hds.cd.runtime.IRuntimeContext#isPluginActive(java.lang.String, gov.va.med.hds.cd.mum.Version) */
	public boolean isPluginActive(String pluginId, Version version) {
		// TODO_SB: Auto-generated method stub
		return false;
	}

	/* @see gov.va.med.hds.cd.runtime.IRuntimeContext#isPluginActivating(java.lang.String, gov.va.med.hds.cd.mum.Version) */
	public boolean isPluginActivating(String pluginId, Version version) {
		// TODO_SB: Auto-generated method stub
		return false;
	}

	/* @see gov.va.med.hds.cd.runtime.IRuntimeContext#addPluginActivationListener(gov.va.med.hds.cd.runtime.IPluginActivationListener) */
	public void addPluginActivationListener(IPluginActivationListener l) {
		// TODO_SB: Auto-generated method stub
		
	}

	/* @see gov.va.med.hds.cd.runtime.IRuntimeContext#removePluginActivationListener(gov.va.med.hds.cd.runtime.IPluginActivationListener) */
	public void removePluginActivationListener(IPluginActivationListener l) {
		// TODO_SB: Auto-generated method stub
		
	}

}
