package gov.va.med.hds.cd.prism.test;

import javax.swing.ActionMap;
import javax.swing.JFrame;
import javax.swing.event.EventListenerList;

import gov.va.med.hds.cd.prism.IDesktop;
import gov.va.med.hds.cd.prism.IDesktopWindow;
import gov.va.med.hds.cd.prism.perspective.IPerspectiveListener;
import gov.va.med.hds.cd.prism.perspective.IPerspectiveReference;
import gov.va.med.hds.cd.prism.visualcomponent.IVisualComponentEventSource;
import gov.va.med.hds.cd.prism.visualcomponent.internal.VisualComponentManager;

public class MockWindow extends JFrame implements IDesktopWindow {
	
	private EventListenerList listenerList = new EventListenerList();
	private IDesktop desktop;
	private MockPerspective perspective = new MockPerspective();
	private VisualComponentManager manager = new VisualComponentManager();
	
	public MockWindow() {
		this(null);
	}
	
	public MockWindow(IDesktop desktop) {
		this.desktop = desktop;
	}

	public IDesktop getDesktop() {
		return desktop;
	}

	public JFrame getFrame() {
		return this;
	}
	
	public ActionMap getActionMap() {
		return null;
	}
	
	public IVisualComponentEventSource getVisualComponentEventSource() {
		return manager;
	}

	public void addPerspectiveListener(IPerspectiveListener l) {
		listenerList.add(IPerspectiveListener.class, l);
	}

	public IPerspectiveReference getActivePerspective() {
		return perspective;
	}

	public void removePerspectiveListener(IPerspectiveListener l) {
		listenerList.remove(IPerspectiveListener.class, l);
	}
	
	public IPerspectiveReference[] getPerspectives() {
		return new IPerspectiveReference[] { perspective };
	}

	/* @see gov.va.med.hds.cd.prism.IDesktopWindow#setActivePerspective(java.lang.String) */
	public void setActivePerspective(String perspectiveId) {
		// TODO_SB: Auto-generated method stub
		
	}
}
