package gov.va.med.hds.cd.prism.test;

import junit.framework.TestCase;

import gov.va.med.hds.cd.prism.PrismUtilities;
import gov.va.med.hds.cd.prism.internal.PerspectiveScopeRegistrar;
import gov.va.med.hds.cd.prism.perspective.PerspectiveEvent;
import gov.va.med.hds.cd.workspace.IWorkspace;
import gov.va.med.hds.cd.workspace.IWorkspaceListener;
import gov.va.med.hds.cd.workspace.IWorkspaceScope;

public class PerspectiveScopeRegistrarTest extends TestCase implements IWorkspace {
	
	private MockWindow w;
	private MockPerspective p;
	private int sourceCount = 0;
	private int listenerCount = 0;
	private PerspectiveScopeRegistrar r;
	
	public PerspectiveScopeRegistrarTest(String name) {
		super(name);
	}

	protected void setUp() throws Exception {
		w = new MockWindow();
		p = new MockPerspective();
		p.setDescriptor(new MockPerspectiveDescriptor("scopeTestPerspective"));
		r = new PerspectiveScopeRegistrar(this);
	}

	public void testDispatcherAdditionAndRemoval() {
		r.perspectiveOpening(new PerspectiveEvent(this, p, w));
		r.perspectiveClosed(new PerspectiveEvent(this, p, w));
	}

	public void addWorkspaceListener(IWorkspaceListener l) {
		// NOOP
	}

	public void removeWorkspaceListener(IWorkspaceListener l) {
		// NOOP
	}

	public IWorkspaceScope getScope(String scopeId) {
		return null; // NOOP
	}

	public void addScope(String scopeId) {
		assertEquals(PrismUtilities.getPerspectiveScopeId(w, p.getDescriptor()), scopeId);
		
	}

	public void removeScope(String scopeId) {
		assertEquals(PrismUtilities.getPerspectiveScopeId(w, p.getDescriptor()), scopeId);	
	}
}
