package gov.va.med.hds.cd.prism.test;

import javax.swing.table.TableModel;

import junit.framework.Test;
import junit.framework.TestSuite;

import gov.va.med.hds.cd.prism.action.internal.RegistryTableModel;
import gov.va.med.hds.cd.runtime.internal.RuntimeDescriptor;
import gov.va.med.hds.cd.runtime.test.PluginRegistryTest;

public class RegistryTableModelTest extends PluginRegistryTest {

	public static Test suite() {
		TestSuite suite = new TestSuite("Test for RegistryTableModel");
		suite.addTest(new RegistryTableModelTest("testTableModel"));
		return suite;
	}

	public RegistryTableModelTest(String name) {
		super(name);
	}

	public void testTableModel() {
		TableModel model = new RegistryTableModel(registry);
		assertEquals(3, model.getRowCount());
		assertEquals(4, model.getColumnCount());
		assertEquals("Plug-in Name", model.getColumnName(RegistryTableModel.PLUGIN_LABEL_COLUMN));
		assertEquals("Version", model.getColumnName(RegistryTableModel.PLUGIN_VERSION_COLUMN));
		assertEquals("Provider", model.getColumnName(RegistryTableModel.PLUGIN_PROVIDER_COLUMN));
		assertEquals("Plug-in Id", model.getColumnName(RegistryTableModel.PLUGIN_ID_COLUMN));
		
		assertEquals("Prism", model.getValueAt(0, RegistryTableModel.PLUGIN_LABEL_COLUMN));
		assertEquals("0.1.0", model.getValueAt(0, RegistryTableModel.PLUGIN_VERSION_COLUMN));
		
		assertEquals(RuntimeDescriptor.NAME, model.getValueAt(1, RegistryTableModel.PLUGIN_LABEL_COLUMN));
		assertEquals(RuntimeDescriptor.VERSION.toString(), model.getValueAt(1, RegistryTableModel.PLUGIN_VERSION_COLUMN));
		assertEquals(RuntimeDescriptor.PROVIDER_NAME.toString(), model.getValueAt(1, RegistryTableModel.PLUGIN_PROVIDER_COLUMN));
		assertEquals(RuntimeDescriptor.PLUGIN_ID.toString(), model.getValueAt(1, RegistryTableModel.PLUGIN_ID_COLUMN));
	}
}
