package gov.va.med.hds.cd.prism;

import java.util.EventListener;

/**
 * Interface for listening to window lifecycle events. 
 * 
 * This interface may be implemented by clients.
 */
public interface IDesktopWindowListener extends EventListener {
	/**
	 * Notifies this listener that the given window has been activated.
	 */
	void windowActivated(DesktopWindowEvent e);
	/**
	 * Notifies this listener that the given window has been deactivated. 
	 */
	void windowDeactivated(DesktopWindowEvent e);
	/**
	 * Notifies this listener that the given window is about to open. 
	 */
	void windowOpening(DesktopWindowEvent e);
	/**
	 * Notifies this listener that the given window has been opened. 
	 */
	void windowOpened(DesktopWindowEvent e);
	/**
	 * Notifies this listener that the given window is about to close.
	 */
	void windowClosing(DesktopWindowEvent e) throws DesktopWindowCloseVetoException;
	/**
	 * Notifies this listener that the given window has been closed. 
	 */
	void windowClosed(DesktopWindowEvent e);
}
