package gov.va.med.hds.cd.prism;

/**
 * A collection of constants relating to the desktop user interface (also
 * known as "Prism").  They are generally string constants used during the
 * parsing of plugin manifests.
 */
public interface IPrismConstants {
	
	public String	DESKTOP_NAME								= "HealtheVet Desktop"; // TODO: move this to a .properties file
	
	public String	PLUGIN_ID 									= "gov.va.med.hds.cd.prism";
	
	public String	ACTION_EXTENSION_POINT_ID					= "action";
	public String	MAIN_MENU_EXTENSION_POINT_ID				= "mainMenu";
	public String	PERSPECTIVE_EXTENSION_POINT_ID				= "perspective";
	public String	VISUAL_COMPONENT_EXTENSION_POINT_ID			= "visualComponent";
    public String   PLAF_PROVIDER_EXTENSION_POINT_ID            = "api.plafProvider";
	
	public String	UNIQUE_ACTION_EXTENSION_POINT_ID			= PLUGIN_ID + "." + ACTION_EXTENSION_POINT_ID;
	public String	UNIQUE_MENU_EXTENSION_POINT_ID				= PLUGIN_ID + "." + MAIN_MENU_EXTENSION_POINT_ID;
	public String	UNIQUE_PERSPECTIVE_EXTENSION_POINT_ID		= PLUGIN_ID + "." + PERSPECTIVE_EXTENSION_POINT_ID;
	public String	UNIQUE_VISUAL_COMPONENT_EXTENSION_POINT_ID	= PLUGIN_ID + "." + VISUAL_COMPONENT_EXTENSION_POINT_ID;
    public String   UNIQUE_PLAF_PROVIDER_EXTENSION_POINT_ID     = PLUGIN_ID + "." + PLAF_PROVIDER_EXTENSION_POINT_ID;
	
	public String	ACTION_CONFIGURATION_ELEMENT				= "action";
	public String	ID_ATTRIBUTE								= "id";
	public String	CLASS_ATTRIBUTE								= "class";
	public String	PROPERTY_CONFIGURATION_ELEMENT				= "property";
	public String	VALUE_ATTRIBUTE								= "value";
	
	public String	MENU_CONFIGURATION_ELEMENT					= "menu";
	public String	MENU_ITEM_CONFIGURATION_ELEMENT				= "menuItem";
	public String	SLOT_CONFIGURATION_ELEMENT					= "slot";
	public String	SEPARATOR_CONFIGURATION_ELEMENT				= "separator";
	public String	NAME_ATTRIBUTE								= "name";
	public String	PATH_ATTRIBUTE								= "path";
	public String	ACTION_ATTRIBUTE							= ACTION_CONFIGURATION_ELEMENT;
	public String	MNEMONIC_ATTRIBUTE							= "mnemonic";
	public String	CONTEXT_ATTRIBUTE							= "context";
	
	public String	PERSPECTIVE_CONFIGURATION_ELEMENT			= PERSPECTIVE_EXTENSION_POINT_ID;
	public String	FLEX_ATTRIBUTE								= "flex";
	public String	HEIGHT_ATTRIBUTE							= "height";
	public String	MIN_HEIGHT_ATTRIBUTE						= "minHeight";
	public String	MAX_HEIGHT_ATTRIBUTE						= "maxHeight";
	public String	WIDTH_ATTRIBUTE								= "width";
	public String	MIN_WIDTH_ATTRIBUTE							= "minWidth";
	public String	MAX_WIDTH_ATTRIBUTE							= "maxWidth";
	
	public String	BOX_CONFIGURATION_ELEMENT					= "box";
	public String	HORIZONTAL_BOX_CONFIGURATION_ELEMENT		= "hbox";
	public String	VERTICAL_BOX_CONFIGURATION_ELEMENT			= "vbox";
	public String	ORIENTATION_ATTRIBUTE						= "orientation";
	
	public String	COMPONENT_CONFIGURATION_ELEMENT				= "component";
	public String	SOURCE_CONFIGURATION_ELEMENT				= "source";
	public String	LISTENER_CONFIGURATION_ELEMENT				= "listener";
	public String	EVENT_ATTRIBUTE								= "event";
	public String	SCOPE_ATTRIBUTE								= "scope";
	
	public String	SPACER_CONFIGURATION_ELEMENT				= "spacer";
	public String	SPLITTER_CONFIGURATION_ELEMENT				= "splitter";
}
