package gov.va.med.hds.cd.prism.perspective;

import java.util.EventListener;

/**
 * Interface for listening to perspective status events.
 * 
 * This interface may be implemented by clients.
 */
public interface IPerspectiveListener extends EventListener {
	/**
	 * Notifies this listener that the given perspective has been activated.
	 */
	public void perspectiveActivated(PerspectiveEvent e);
	
	/**
	 * Notifies this listener that the given perspective is about to close.
	 */
	public void perspectiveClosing(PerspectiveEvent e);
	
	/**
	 * Notifies this listener that the given perspective has been closed.
	 */
	public void perspectiveClosed(PerspectiveEvent e);
	
	/**
	 * Notifies this listener that the given perspective is about to open.
	 */
	public void perspectiveOpening(PerspectiveEvent e);
	
	/**
	 * Notifies this listener that the given perspective has been opened.
	 */
	public void perspectiveOpened(PerspectiveEvent e);
}
