package gov.va.med.hds.cd.prism.perspective;

import javax.swing.JComponent;

import gov.va.med.hds.cd.prism.visualcomponent.IVisualComponentEventSource;
import gov.va.med.hds.cd.prism.visualcomponent.IVisualComponentReference;

/**
 * A perspective consists of an arrangement of visual components intended
 * to be presented together to the user in a single desktop window.
 *
 * A perspective can contain 0 or more visual components. These components are
 * contained wholly within the perspective and are not shared with other
 * perspectives. The layout and visible action set for the perspective is
 * defined per perspective.
 *
 * This interface is not intended to be implemented by clients.
 *
 * @see gov.va.med.hds.cd.prism.IPerspectiveDescriptor
 */
public interface IPerspectiveReference extends IVisualComponentEventSource {
	/**
	 * Returns this perspective's corresponding descriptor.
	 *
	 * @return
	 */
	public IPerspectiveDescriptor getDescriptor();
	
	public IVisualComponentReference[] getVisualComponents();
	
	public JComponent getComponent();
}
