package gov.va.med.hds.cd.prism.visualcomponent;

import javax.swing.JComponent;

import gov.va.med.hds.cd.runtime.IExecutableExtension;

/**
 * An <code>IVisualComponent</code> is a visual component within a perspective. 
 * It is typically used to navigate a hierarchy of information.
 * 
 * A visual component is added to the desktop in two steps: 
 * 
 * A visual component extension is contributed to the desktop registry. This 
 * extension defines the extension id and extension class. The component is
 * included in the default layout for a perspective. 
 * 
 */
public interface IVisualComponent extends IExecutableExtension {
	/**
	 * Returns this component's corresponding descriptor.
	 * 
	 * @return
	 */
//	public IVisualComponentDescriptor getDescriptor();
	
	/**
	 * Returns the Swing component that corresponds to this visual component.
	 * 
	 * @return
	 */
	public JComponent getComponent();
	
	// public void setModel(Object model) ?
}
