package gov.va.med.hds.cd.prism.visualcomponent;

import java.util.EventListener;


/**
 * Interface for listening to visual component status events.
 * 
 * This interface may be implemented by clients.
 */
public interface IVisualComponentListener extends EventListener {
	/**
	 * Notifies this listener that a visual component has been activated.
	 */
	public void componentActivated(VisualComponentEvent e);
	
	/**
	 * Notifies this listener that a visual component has been closed.
	 */
	public void componentClosed(VisualComponentEvent e);
	
	/**
	 * Notifies this listener that a visual component has been deactivated.
	 */
	public void componentDeactivated(VisualComponentEvent e);
	
	/**
	 * Notifies this listener that a visual component has been opened.
	 */
	public void componentOpened(VisualComponentEvent e);
}
