/*
 * Created on Apr 9, 2003 by vhaislmonsos
 */
package gov.va.med.hds.querytool;

import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.util.HashMap;
import java.util.Map;

/**
 * Hard reference manager implementation for IQuery's
 */
public class HardReferenceManager implements IHardReferenceManager {
	private Map queryMap = new HashMap();
	private PropertyChangeListener changeListener = new PropertyChangeListener() {
		public void propertyChange(PropertyChangeEvent e) {
			evaluateQuery((IQuery)e.getSource());
		}
	};

	public HardReferenceManager() {
		super();
	}

	public void addItem(Object item) throws HardReferenceManagerException {
		validateObject(item);
		if (queryMap.containsKey(item)) {
			return;
		}
		evaluateQuery((IQuery)item);
		((IQuery)item).addPropertyChangeListener(changeListener);
	}

	public void removeItem(Object item) throws HardReferenceManagerException {
		validateObject(item);
		queryMap.remove(item);
		((IQuery)item).removePropertyChangeListener(changeListener);
	}
	
	private void validateObject(Object item) throws HardReferenceManagerException {
		if (!(item instanceof IQuery)) {
			throw new HardReferenceManagerException("Invalid object in parameter list.");
		}
	}
	
	private void evaluateQuery(IQuery query) {
		if (query.isNullQueryID() || query.isUnsavedQueryID() || query.isQueryChanged()) {
			queryMap.put(query,null);
		}
		else {
			queryMap.remove(query);
		}
	}

}
