package gov.va.med.hds.querytool;

/**
 * IQueryID implementation.
 */
public class QueryID implements IQueryID {
	private Comparable queryID = nullID;
	public static final QueryID nullID = new QueryID("nullID");
	public static final QueryID unsavedID = new QueryID("newID");

	public QueryID() {
	}

	public QueryID(Comparable id) {
		queryID = id;
	}

	public String toString() {
		return queryID.toString();
	}

	public void setQueryID(Comparable queryID) {
		this.queryID = queryID;
	}
	
	public boolean equals(Object o) {
		return (o instanceof QueryID) && (queryID.equals(((QueryID)o).queryID));
	}

	public static boolean isValid(IQueryID queryID) {
		return (queryID!=null) && (!queryID.equals(nullID)) && (!queryID.equals(unsavedID));
	}

	public int compareTo(Object o) {
		if ((queryID.equals(nullID)) || (queryID.equals(unsavedID))) {
			return 1;
		}
		return queryID.compareTo((Comparable)o);
	}

	public int hashCode() {
		return this.queryID.hashCode();
	}

}
