/*
 * Initially Created on May 30, 2003 by vhaislmonsos
 *
 */
package gov.va.med.hds.querytool;

import java.util.EventObject;

/**
 * QueryTool event implementation.
 */
public class QueryToolEvent extends EventObject implements IQueryToolEvent {
	private int eventID = IQueryToolEvent.NO_EVENT;
	private IQuery query;
	private IValue value;
	
	/**
	 * Base constructor.  If used, the eventID is set to a default of NO_EVENT.
	 * @param source - Source of the event.
	 */
	public QueryToolEvent(Object source) {
		super(source);
	}
	
	/**
	 * @param source - Source of the event.
	 * @param eventID - The event ID (see IQueryToolEvent)
	 */
	public QueryToolEvent(Object source, int eventID) {
		super(source);
		this.eventID = eventID;
	}

	/**
	 * @param source - Source of the event.
	 * @param eventID - The event ID (see IQueryToolEvent)
	 * @param query - The query reference associated with the event.
	 */
	public QueryToolEvent(Object source, int eventID, IQuery query) {
		super(source);
		this.eventID = eventID;
		this.query = query;
	}

	/**
	 * @param source - Source of the event.
	 * @param eventID - The event ID (see IQueryToolEvent)
	 * @param query - The query reference associated with the event.
	 * @param value - The value involved in the query tool event (e.g. for editing)
	 */
	public QueryToolEvent(Object source, int eventID, IQuery query, IValue value) {
		super(source);
		this.eventID = eventID;
		this.query = query;
		this.value = value;
	}

	public int getEventID() {
		return eventID;
	}

	public IQuery getQuery() {
		return query;
	}

	public IValue getValue() {
		return value;
	}

}
