/*
 * Initially Created on Apr 14, 2003 by vhaislmonsos
 *
 */
package gov.va.med.hds.querytool;

import gov.va.med.hds.querytool.types.ITypeFactory;

import java.util.Iterator;

/**
 * Query utilities.
 */
public class QueryUtil implements IQueryUtil {

	/**
	 * Copies all query properties from the sourceQuery to the targetQuery, except for
	 * the query ID.  The targetQuery must already exist before the call.
	 * @param sourceQuery
	 * @param targetQuery
	 */
	public static void copyContents(IQuery sourceQuery, IQuery targetQuery, ITypeFactory typeFactory) {
		targetQuery.setChanging(true);
		targetQuery.getConstraints().clearAll();
		targetQuery.setDisplayName(sourceQuery.getDisplayName());
		for (Iterator i = sourceQuery.getConstraints().iterator(); i.hasNext();) {
			IValue value = (IValue)i.next();
			IValue newValue = typeFactory.getValue(value.getEditorID());
			for (int j = 0; j < value.getValues().size(); j++) {
				newValue.getValues().add(value.getValues().get(j));
			}
			newValue.setConstraintName(value.getConstraintName());
			newValue.setDefaultDisplayText(value.getDefaultDisplayText());
			newValue.setDisplayText(value.getDisplayText());
			newValue.setID(value.getID());
			newValue.setDisplayFieldCategory(value.getDisplayFieldCategory());
			targetQuery.getConstraints().addValue(newValue);
		}
		
		for (int i = 0; i < sourceQuery.getDisplayFields().size(); i++) {
			targetQuery.getDisplayFields().add(sourceQuery.getDisplayFields().get(i));
		}
		targetQuery.setChanging(false);
	}

}
