/*
 * Initially Created on Jun 2, 2003 by vhaislmonsos
 *
 */
package gov.va.med.hds.querytool.actions;

import gov.va.med.hds.cd.runtime.logging.ILogger;
import gov.va.med.hds.querytool.IQueryAction;
import gov.va.med.hds.querytool.IQueryTool;
import gov.va.med.hds.querytool.IStateEvent;
import gov.va.med.hds.querytool.IStateListener;
import gov.va.med.hds.querytool.QueryActionEvent;
import gov.va.med.hds.querytool.ui.IQueryActionEvent;

import java.awt.event.ActionEvent;

import javax.swing.AbstractAction;
import javax.swing.Action;

/**
 * Abstract query action.
 */
public abstract class AbstractQueryAction
	extends AbstractAction
	implements IQueryAction {
		
	protected IQueryTool qt;
	protected ILogger logger;
	private IStateListener stateListener = new IStateListener() {
		public void stateChanged(IStateEvent event) {
			validateState();
		}
	};
	
	private AbstractQueryAction() {
		super();
	}
	
	public AbstractQueryAction(IQueryTool queryTool, String actionName) {
		super(actionName);
		setModel(queryTool);
	}

	public void setModel(IQueryTool queryTool) {
		if (this.qt!=null) {
			this.qt.removeStateListener(stateListener);
		}
		this.qt = queryTool;
		if (qt!=null) {
			qt.addStateListener(stateListener);
		}
	}

	public void actionPerformed(ActionEvent e) {
		IQueryActionEvent event = null;
		if (!(e instanceof IQueryActionEvent)) {
			event = new QueryActionEvent(e.getSource(),e.getID());
		}
		else {
			event = (IQueryActionEvent)e;
		}
		if (enabled && qt!=null) {
			dispatchActionEvent(event);
		}
	}
	
	public abstract void dispatchActionEvent(IQueryActionEvent e);

	public void setLogger(ILogger logger) {
		this.logger = logger;
	}
	
	public void validateState() {
		if (!qt.isActionAuthorized(getValue(Action.NAME))) {
			setEnabled(false);
		}
	}

}
