/*
 * Initially Created on Jun 3, 2003 by vhaislmonsos
 *
 */
package gov.va.med.hds.querytool.actions;

import gov.va.med.hds.querytool.IQueryAction;
import gov.va.med.hds.querytool.IQueryTool;
import gov.va.med.hds.querytool.QueryCollectionException;
import gov.va.med.hds.querytool.ui.IQueryActionEvent;

import javax.swing.Action;

/**
 * Delete confirmed action
 */
public class DeleteConfirmed
	extends AbstractQueryAction
	implements IQueryAction {

	/**
	 * @param queryTool
	 * @param actionName
	 */
	public DeleteConfirmed(IQueryTool queryTool) {
		super(queryTool, IQueryTool.DELETE_CONFIRMED_ACTION);
		putValue(Action.MNEMONIC_KEY, new Integer(IQueryTool.DELETE_CONFIRMED_CHAR));
	}

	public void dispatchActionEvent(IQueryActionEvent e) {
		try {
			qt.getQueryCollection().removeUserQuery(qt.getCurrentQuery());
			qt.setCurrentQuery(null);
			qt.getQueryCollection().refresh();
		}
		catch (QueryCollectionException ex) {
			logger.error("Error deleting query.", ex);
		}
	}

	public void validateState() {
		setEnabled(qt.getCurrentQuery()!=null && qt.getQueryCollection()!=null && !qt.getQueryCollection().isPredefinedQuery(qt.getCurrentQuery()));
		super.validateState();
	}

}
