/*
 * Initially Created on Jun 3, 2003 by vhaislmonsos
 *
 */
package gov.va.med.hds.querytool.actions;

import gov.va.med.hds.querytool.IQuery;
import gov.va.med.hds.querytool.IQueryAction;
import gov.va.med.hds.querytool.IQueryTool;
import gov.va.med.hds.querytool.IQueryToolEvent;
import gov.va.med.hds.querytool.QueryToolEvent;
import gov.va.med.hds.querytool.QueryUtil;
import gov.va.med.hds.querytool.ui.IQueryActionEvent;

import javax.swing.Action;

/**
 * Edit action.
 */
public class Edit extends AbstractQueryAction implements IQueryAction {

	public Edit(IQueryTool queryTool) {
		super(queryTool, IQueryTool.EDIT_ACTION);
		putValue(Action.MNEMONIC_KEY, new Integer(IQueryTool.EDIT_CHAR));
	}
	
	public Edit(IQueryTool queryTool, String actionString, char mnemonic) {
		super(queryTool, actionString);
		putValue(Action.MNEMONIC_KEY, new Integer(mnemonic));
	}
	
	public void dispatchActionEvent(IQueryActionEvent e) {
		if (qt.getCurrentQuery()!=null && qt.getQueryCollection().isPredefinedQuery(qt.getCurrentQuery())) {
			IQuery newQuery = qt.getNewQuery(null);
			if (newQuery==null) {
				logger.error(qt.getMessage(), qt.getError());
				return;
			}
			QueryUtil.copyContents(qt.getCurrentQuery(), newQuery, qt.getTypeFactory());
			qt.setCurrentQuery(newQuery);
		}
		else {
			if (qt.getCurrentQuery()==null) {
				return;
			}
		}
		qt.dispatchEvent(new QueryToolEvent(this, IQueryToolEvent.EDIT_QUERY, qt.getCurrentQuery()));
	}

	public void validateState() {
		setEnabled(qt.getCurrentQuery()!=null && qt.getResultsModel()==null && qt.getRunModel()==null);
		super.validateState();
	}

}
