/*
 * Created on Jun 3, 2003 by vhaislmonsos
 */
package gov.va.med.hds.querytool.actions;

import gov.va.med.hds.querytool.IQueryAction;
import gov.va.med.hds.querytool.IQueryTool;
import gov.va.med.hds.querytool.IQueryToolEvent;
import gov.va.med.hds.querytool.QueryCollectionException;
import gov.va.med.hds.querytool.QueryID;
import gov.va.med.hds.querytool.QueryToolEvent;
import gov.va.med.hds.querytool.ui.IQueryActionEvent;

import javax.swing.Action;

/**
 * Edit complete / no save action
 */
public class EditCompleteNoSave
	extends AbstractQueryAction
	implements IQueryAction {

	/**
	 * Delegates to parent.
	 * @param queryTool
	 */
	public EditCompleteNoSave(IQueryTool queryTool) {
		super(queryTool, IQueryTool.EDIT_COMPLETE_NOSAVE_ACTION);
		putValue(Action.MNEMONIC_KEY, new Integer(IQueryTool.EDIT_COMPLETE_NOSAVE_CHAR));
	}

	public void dispatchActionEvent(IQueryActionEvent e) {
		if (qt.isValidQueryName(e.getNewValue().toString())) {
			qt.getCurrentQuery().setDisplayName(e.getNewValue().toString());
			if (qt.getCurrentQuery().isNullQueryID()) {
				try {
					qt.getCurrentQuery().setQueryID(QueryID.unsavedID);
					qt.getQueryCollection().addQueryWithoutSave(qt.getCurrentQuery());
				}
				catch (QueryCollectionException ex) {
					logger.error("Error trying to store an unsaved query in the query collection.", ex);
				}
			}
			qt.dispatchEvent(new QueryToolEvent(this, IQueryToolEvent.HOME_PAGE));
		}
		else {
			qt.dispatchEvent(new QueryToolEvent(this, IQueryToolEvent.MESSAGE));
		}
	}

	public void validateState() {
		setEnabled(qt.getCurrentQuery()!=null && qt.getResultsModel()==null && qt.getRunModel()==null);
		super.validateState();
	}

}
