/*
 * Created on Jun 3, 2003 by vhaislmonsos
 */
package gov.va.med.hds.querytool.actions;

import gov.va.med.hds.querytool.IQueryAction;
import gov.va.med.hds.querytool.IQueryTool;
import gov.va.med.hds.querytool.IQueryToolEvent;
import gov.va.med.hds.querytool.QueryCollectionException;
import gov.va.med.hds.querytool.QueryToolEvent;
import gov.va.med.hds.querytool.ui.IQueryActionEvent;

import javax.swing.Action;

/**
 * Edit Complete - Save  action
 */
public class EditCompleteSave
	extends AbstractQueryAction
	implements IQueryAction {
		
	public EditCompleteSave(IQueryTool queryTool) {
		super(queryTool, IQueryTool.EDIT_COMPLETE_SAVE_ACTION);
		putValue(Action.MNEMONIC_KEY, new Integer(IQueryTool.EDIT_COMPLETE_SAVE_CHAR));
	}
	
	public void dispatchActionEvent(IQueryActionEvent e) {
		String name = e.getNewValue().toString();
		
		if (qt.getCurrentQuery().isNullQueryID() || qt.getCurrentQuery().isUnsavedQueryID()) {
			if (qt.isNameCorrectLength(name)) {
				if (qt.isValidQueryName(name)) {
					doSaveCurrent(e.getNewValue().toString());
					doGoHome();
				}
				else {
					doMessage();
				}
			}
			else {
				doMessage();
			}
		}
		else {
			if (qt.isNameCorrectLength(name)) {
				doSaveCurrent(e.getNewValue().toString());
				doGoHome();
			}
			else {
				doMessage();
			}
		}
		
	}
	
	private void doMessage() {
		qt.dispatchEvent(new QueryToolEvent(this, IQueryToolEvent.MESSAGE));
	}

	private void doGoHome() {
		qt.dispatchEvent(new QueryToolEvent(this, IQueryToolEvent.HOME_PAGE));
	}

	private void doSaveCurrent(String newName) {
		try {
			qt.getCurrentQuery().setDisplayName(newName);
			qt.getQueryCollection().saveQuery(qt.getCurrentQuery());
			qt.getQueryCollection().refresh();
		}
		catch (QueryCollectionException e) {
			logger.debug("Error saving query " + qt.getCurrentQuery().getDisplayName() + ".", e);
		}
	}

	public void validateState() {
		setEnabled(qt.getCurrentQuery()!=null && qt.getResultsModel()==null && qt.getRunModel()==null);
		super.validateState();
	}

}
