/*
 * Created on Jun 3, 2003 by vhaislmonsos
 */
package gov.va.med.hds.querytool.actions;

import gov.va.med.hds.querytool.IQueryAction;
import gov.va.med.hds.querytool.IQueryTool;
import gov.va.med.hds.querytool.IQueryToolEvent;
import gov.va.med.hds.querytool.ISensitiveList;
import gov.va.med.hds.querytool.QueryToolEvent;
import gov.va.med.hds.querytool.SensitivePatientException;
import gov.va.med.hds.querytool.ui.IQueryActionEvent;

import javax.swing.Action;

/**
 * Run continue action
 */
public class RunContinue extends AbstractQueryAction implements IQueryAction {

	/**
	 * @param queryTool
	 */
	public RunContinue(IQueryTool queryTool) {
		super(queryTool, IQueryTool.RUN_CONTINUE_ACTION);
		putValue(Action.MNEMONIC_KEY, new Integer(IQueryTool.RUN_CONTINUE_CHAR));
	}

	public void dispatchActionEvent(IQueryActionEvent e) {
		ISensitiveList list = qt.getRunModel().getSensitiveDataModel().getSensitivePtList();
		for (int i = 0; i < list.getSize(); i++) {
			if (!list.getItem(i).isChecked()) {
				try {
					qt.getRunModel().getSensitiveDataModel().remove(list.getItem(i).getPatientID());
				}
				catch (SensitivePatientException ex) {
					logger.error("Error removing patient from sensitive patient list.", ex);
				}
			}
		}
		qt.getRunModel().resumeFromPause();
		qt.dispatchEvent(new QueryToolEvent(this, IQueryToolEvent.RUN_RESTARTED));
	}

	public void validateState() {
		setEnabled(qt.getRunModel()!=null);
		super.validateState();
	}

}
