/*
 * Initially Created on Jun 3, 2003 by vhaislmonsos
 *
 */
package gov.va.med.hds.querytool.actions;

import gov.va.med.hds.querytool.IQuery;
import gov.va.med.hds.querytool.IQueryAction;
import gov.va.med.hds.querytool.IQueryTool;
import gov.va.med.hds.querytool.IQueryToolEvent;
import gov.va.med.hds.querytool.QueryToolEvent;
import gov.va.med.hds.querytool.ui.IQueryActionEvent;

import javax.swing.Action;

/**
 * Run start query action
 */
public class RunStart extends AbstractQueryAction implements IQueryAction {
	/**
	 * @param queryTool
	 */
	public RunStart(IQueryTool queryTool) {
		super(queryTool, IQueryTool.RUN_ACTION);
		putValue(Action.MNEMONIC_KEY, new Integer(IQueryTool.RUN_CHAR));
	}

	public void dispatchActionEvent(IQueryActionEvent e) {
		if (qt.getCurrentQuery()==null || !qt.getCurrentQuery().isValueSetComplete()) return;
		qt.setupRunModel();
		qt.dispatchEvent(new QueryToolEvent(this, IQueryToolEvent.RUN_STARTED));
		qt.getRunModel().runQuery();
	}

	public void validateState() {
		IQuery query;
		if ((query=qt.getCurrentQuery())!=null) {
			while (query.isChanging()) {}
		}
		setEnabled(qt.getCurrentQuery()!=null && qt.getCurrentQuery().isValueSetComplete() && qt.getRunModel()==null);
		super.validateState();
	}

}
