/*
 * Initially Created on Jun 3, 2003 by vhaislmonsos
 *
 */
package gov.va.med.hds.querytool.actions;

import gov.va.med.hds.querytool.IQuery;
import gov.va.med.hds.querytool.IQueryAction;
import gov.va.med.hds.querytool.IQueryTool;
import gov.va.med.hds.querytool.IQueryToolEvent;
import gov.va.med.hds.querytool.QueryCollectionException;
import gov.va.med.hds.querytool.QueryToolEvent;
import gov.va.med.hds.querytool.QueryUtil;
import gov.va.med.hds.querytool.ui.IQueryActionEvent;

import javax.swing.Action;

/**
 * Save As Confirmed action
 */
public class SaveAsConfirmed
	extends AbstractQueryAction
	implements IQueryAction {
		
	/**
	 * @param queryTool
	 */
	public SaveAsConfirmed(IQueryTool queryTool) {
		super(queryTool, IQueryTool.SAVEAS_CONFIRMED_ACTION);
		putValue(Action.MNEMONIC_KEY, new Integer(IQueryTool.SAVEAS_CONFIRMED_CHAR));
	}

	public void dispatchActionEvent(IQueryActionEvent e) {
		if (!qt.getQueryCollection().containsDisplayName(e.getNewValue().toString())) {
			doCreateNewFromExisting(e.getNewValue().toString());
			qt.dispatchEvent(new QueryToolEvent(this, IQueryToolEvent.SELECT));
			if (qt.getCurrentQuery()!=null) {
				try {
					qt.getQueryCollection().saveQuery(qt.getCurrentQuery());
				}
				catch (QueryCollectionException ex) {
					logger.error("Error saving a query from a 'Save As' operation.", ex);
				}
			}
			try {
				qt.getQueryCollection().refresh();
			}
			catch (QueryCollectionException ex) {
				logger.error("Error refreshing the query collection after a 'Save As' operation.", ex);
			}
		}
		else {
			qt.dispatchEvent(new QueryToolEvent(this, IQueryToolEvent.MESSAGE));
		}
	}

	private void doCreateNewFromExisting(String string) {
		IQuery newQuery = qt.getNewQuery(null);
		if (newQuery==null) {
			logger.error(qt.getMessage(), qt.getError());
			return;
		}
		QueryUtil.copyContents(qt.getCurrentQuery(), newQuery, qt.getTypeFactory());
		newQuery.setDisplayName(string);
		qt.setCurrentQuery(newQuery);
	}
	
	public void validateState() {
		setEnabled(qt.getCurrentQuery()!=null);
		super.validateState();
	}

}
