/*
 * Initially Created on Jun 2, 2003 by vhaislmonsos
 *
 */
package gov.va.med.hds.querytool.actions;

import gov.va.med.hds.querytool.IQueryAction;
import gov.va.med.hds.querytool.IQueryTool;
import gov.va.med.hds.querytool.ISoftListItem;
import gov.va.med.hds.querytool.QueryCollectionException;
import gov.va.med.hds.querytool.ui.IQueryActionEvent;

import javax.swing.Action;

/**
 * Querytool select action.
 */
public class Select extends AbstractQueryAction implements IQueryAction {

	public Select(IQueryTool queryTool, String string, char mnemonic) {
		super(queryTool, string);
		putValue(Action.MNEMONIC_KEY, new Integer(mnemonic));
	}

	public Select(IQueryTool queryTool) {
		this(queryTool, IQueryTool.SELECT_ACTION, IQueryTool.SELECT_CHAR);
	}

	public void dispatchActionEvent(IQueryActionEvent e) {
		if (qt.getQueryCollection().isQueryItem(e.getNewValue())) { 
			try {
				ISoftListItem item = (ISoftListItem)e.getNewValue();
				if (qt.getCurrentQuery()!=null && qt.getCurrentQuery()==item.getItem()) {
					qt.getQueryCollection().reloadChangedQuery(item);
				}
				qt.setCurrentQuery(qt.getQueryCollection().getQuery(e.getNewValue()));
			}
			catch (QueryCollectionException ex) {
				logger.error("Error setting the current query.", ex);
			}
		}
		else {
			qt.setCurrentQuery(null);
		}
	}

	public void validateState() {
		setEnabled(qt.getRunModel()==null);
		super.validateState();
	}

}
