/*
 * Initially Created on Jun 5, 2003 by vhaislmonsos
 *
 */
package gov.va.med.hds.querytool.actions;

import gov.va.med.hds.querytool.IQueryAction;
import gov.va.med.hds.querytool.IQueryTool;
import gov.va.med.hds.querytool.ISensitiveListItem;
import gov.va.med.hds.querytool.ui.IQueryActionEvent;

import javax.swing.Action;

/**
 * Select a sensitive patient
 */
public class SelectSensitive
	extends AbstractQueryAction
	implements IQueryAction {
		
	/**
	 * @param queryTool
	 */
	public SelectSensitive(IQueryTool queryTool) {
		super(queryTool, IQueryTool.SELECT_SENSITIVE_ACTION);
		putValue(Action.MNEMONIC_KEY, new Integer(IQueryTool.SELECT_SENSITIVE_CHAR));
	}

	public void dispatchActionEvent(IQueryActionEvent e) {
		try {
			ISensitiveListItem item = (ISensitiveListItem)e.getNewValue();
			qt.getRunModel().getSensitiveDataModel().setSensitiveMessagePatient(item);
		}
		catch (Exception ex) {
			logger.error("Error trying to set selected patients sensitive text.", ex);
		}
	}

	public void validateState() {
		setEnabled(qt.getRunModel()!=null && qt.getRunModel().getSensitiveDataModel()!=null && qt.getRunModel().getSensitiveDataModel().getSensitivePtList()!=null);
		super.validateState();
	}

}
