/*
 * Initially Created on Jun 4, 2003 by vhaislmonsos
 *
 */
package gov.va.med.hds.querytool.actions;

import gov.va.med.hds.querytool.IQueryAction;
import gov.va.med.hds.querytool.IQueryTool;
import gov.va.med.hds.querytool.dao.QueryDAOException;
import gov.va.med.hds.querytool.ui.IQueryActionEvent;
import gov.va.med.hds.querytool.ui.IResultsTable;

import javax.swing.Action;

/**
 * Sort column action
 */
public class SortColumn extends AbstractQueryAction implements IQueryAction {

	/**
	 * @param queryTool
	 */
	public SortColumn(IQueryTool queryTool) {
		super(queryTool, IQueryTool.SORT_COLUMN_ACTION);
		putValue(Action.MNEMONIC_KEY, new Integer(IQueryTool.SORT_COLUMN_CHAR));
	}

	public void dispatchActionEvent(IQueryActionEvent e) {
		int col = Integer.parseInt(e.getNewValue().toString());
		int currentColumn = qt.getResultsModel().getSortColumnPosition();
		int direction = qt.getResultsModel().getSortDirection();
		
		if (currentColumn==col) {
			if (direction==IResultsTable.ASCENDING) {
				direction = IResultsTable.DESCENDING;
			}
			else {
				direction = IResultsTable.ASCENDING;
			}
		}
		else {
			currentColumn = col;
			direction = IResultsTable.ASCENDING;
		}
		try {
			qt.getResultsModel().setSortColumn(currentColumn, direction);
		}
		catch (QueryDAOException ex) {
			logger.error("Server error resorting the results table.", ex);
		}
	}

	public void validateState() {
		setEnabled(qt.getResultsModel()!=null);
		super.validateState();
	}

}
