package gov.va.med.hds.querytool.dao.factory;

import gov.va.med.hds.cd.daoregistry.IDaoRegistry;
import gov.va.med.hds.cd.spectrum.longlist.BufferModelException;
import gov.va.med.hds.cd.spectrum.longlist.IDataNeededListener;
import gov.va.med.hds.querytool.dao.IClinicListDAOFactory;
import gov.va.med.hds.querytool.types.AbstractListFactory;

/**
 * @author vhaislmonsos
 *
 */
public class ClinicListFactory extends AbstractListFactory {

	/**
	 * @see gov.va.med.hds.querytool.types.AbstractBufferedListStrategy#getDataProvider(IDaoRegistry)
	 */
	protected IDataNeededListener getDataProvider(IDaoRegistry daoRegistry) throws BufferModelException {
		IClinicListDAOFactory factory;
		try {
			factory = (IClinicListDAOFactory)daoRegistry.getDAO(IClinicListDAOFactory.class.getName());
		}
		catch (Exception e) {
			throw new BufferModelException(e);
		}
		return factory.getBufferModelDAO();
	}

}
