package gov.va.med.hds.querytool.dao.factory;

import gov.va.med.hds.cd.daoregistry.IDaoRegistry;
import gov.va.med.hds.cd.runtime.IRuntimeContext;
import gov.va.med.hds.querytool.dao.IClinicRefDAO;
import gov.va.med.hds.querytool.dao.INameValuePairDAO;
import gov.va.med.hds.querytool.dao.QueryDAOException;
import gov.va.med.hds.querytool.ui.types.IReferenceDAOFactory;

/**
 * @author vhaislmonsos
 *
 */
public class ClinicRefFactory implements IReferenceDAOFactory {

	/**
	 * @see gov.va.med.hds.querytool.ui.types.IReferenceDAOFactory#getReferenceDAO(IRuntimeContext)
	 */
	public INameValuePairDAO getReferenceDAO(IRuntimeContext runtime,IDaoRegistry daoRegistry) throws QueryDAOException {
		IClinicRefDAO clinicListDAO;
		try {
			clinicListDAO = (IClinicRefDAO)daoRegistry.getDAO(IClinicRefDAO.class.getName());
		}
		catch (Exception e) {
			throw new QueryDAOException(e);
		}
		return clinicListDAO;
	}

}
