package gov.va.med.hds.querytool.dao.factory;

import gov.va.med.hds.cd.daoregistry.IDaoRegistry;
import gov.va.med.hds.cd.spectrum.longlist.BufferModelException;
import gov.va.med.hds.cd.spectrum.longlist.IDataNeededListener;
import gov.va.med.hds.querytool.dao.IClinicianListDAOFactory;
import gov.va.med.hds.querytool.types.AbstractListFactory;

/**
 * @author vhaislmonsos
 *
 * Dec 19, 2002 9:59:19 AM
 */
public class ClinicianListFactory extends AbstractListFactory {

	/**
	 * @see gov.va.med.hds.querytool.types.AbstractBufferedListStrategy#getDataProvider(IDaoRegistry)
	 */
	protected IDataNeededListener getDataProvider(IDaoRegistry daoRegistry) throws BufferModelException{
		IClinicianListDAOFactory factory;
		try {
			factory = (IClinicianListDAOFactory) daoRegistry.getDAO(IClinicianListDAOFactory.class.getName());
		}
		catch (Exception e) {
			throw new BufferModelException(e);
		}
		return factory.getBufferModelDAO();
	}

}
