package gov.va.med.hds.querytool.dao.factory;

import gov.va.med.hds.cd.daoregistry.IDaoRegistry;
import gov.va.med.hds.cd.spectrum.longlist.BufferModelException;
import gov.va.med.hds.cd.spectrum.longlist.IDataNeededListener;
import gov.va.med.hds.querytool.dao.IConsServListDAOFactory;
import gov.va.med.hds.querytool.types.AbstractListFactory;

/**
 * @author vhaislmonsos
 *
 */
public class ConsServListFactory extends AbstractListFactory {

	/**
	 * @see gov.va.med.hds.querytool.types.AbstractListFactory#getDataProvider(IDaoRegistry)
	 */
	protected IDataNeededListener getDataProvider(IDaoRegistry daoRegistry) throws BufferModelException {
		IConsServListDAOFactory factory;
		try {
			factory = (IConsServListDAOFactory)daoRegistry.getDAO(IConsServListDAOFactory.class.getName());
		}
		catch (Exception e) {
			throw new BufferModelException(e);
		}
		return factory.getBufferModelDAO();
	}

}
