package gov.va.med.hds.querytool.dao.factory;

import gov.va.med.hds.cd.daoregistry.IDaoRegistry;
import gov.va.med.hds.cd.runtime.IRuntimeContext;
import gov.va.med.hds.querytool.dao.IConsServRefDAO;
import gov.va.med.hds.querytool.dao.INameValuePairDAO;
import gov.va.med.hds.querytool.dao.QueryDAOException;
import gov.va.med.hds.querytool.ui.types.IReferenceDAOFactory;

/**
 * @author vhaislmonsos
 *
 */
public class ConsServRefFactory implements IReferenceDAOFactory {

	/**
	 * @see gov.va.med.hds.querytool.ui.types.IReferenceDAOFactory#getReferenceDAO(IRuntimeContext)
	 */
	public INameValuePairDAO getReferenceDAO(IRuntimeContext runtime,IDaoRegistry daoRegistry)
		throws QueryDAOException {
		IConsServRefDAO consServRefDAO;
		try {
			consServRefDAO = (IConsServRefDAO)daoRegistry.getDAO(IConsServRefDAO.class.getName());
		}
		catch (Exception e) {
			throw new QueryDAOException(e);
		}
		return consServRefDAO;
	}

}
