package gov.va.med.hds.querytool.dao.factory;

import gov.va.med.hds.cd.daoregistry.IDaoRegistry;
import gov.va.med.hds.cd.runtime.IRuntimeContext;
import gov.va.med.hds.querytool.dao.IDisplayGroupTreeDAO;
import gov.va.med.hds.querytool.dao.ITreeModelDAO;
import gov.va.med.hds.querytool.dao.QueryDAOException;
import gov.va.med.hds.querytool.ui.types.ITreeModelDAOFactory;

/**
 * @author vhaislmonsos
 *
 */
public class DisplayGroupTreeFactory implements ITreeModelDAOFactory {

	/**
	 * @see gov.va.med.hds.querytool.ui.types.ITreeDAOFactory#getTreeModelDAO()
	 */
	public ITreeModelDAO getTreeModelDAO(IRuntimeContext runtime, IDaoRegistry daoRegistry) throws QueryDAOException {
		IDisplayGroupTreeDAO treeModelDAO;
		try {
			treeModelDAO = (IDisplayGroupTreeDAO)daoRegistry.getDAO(IDisplayGroupTreeDAO.class.getName());
		}
		catch (Exception e) {
			throw new QueryDAOException(e);
		}
		return treeModelDAO;
	}

}
