package gov.va.med.hds.querytool.dao.factory;

import gov.va.med.hds.cd.daoregistry.IDaoRegistry;
import gov.va.med.hds.cd.runtime.IRuntimeContext;
import gov.va.med.hds.querytool.dao.INameValuePairDAO;
import gov.va.med.hds.querytool.dao.IOrderSetRefDAO;
import gov.va.med.hds.querytool.dao.QueryDAOException;
import gov.va.med.hds.querytool.ui.types.IReferenceDAOFactory;

/**
 * @author vhaislmonsos
 *
 */
public class OrderSetRefFactory implements IReferenceDAOFactory {

	/**
	 * @see gov.va.med.hds.querytool.ui.types.IReferenceDAOFactory#getReferenceDAO(IRuntimeContext)
	 */
	public INameValuePairDAO getReferenceDAO(IRuntimeContext runtime,IDaoRegistry daoRegistry) throws QueryDAOException {
		IOrderSetRefDAO orderSetRefDAO;
		try {
			orderSetRefDAO = (IOrderSetRefDAO)daoRegistry.getDAO(IOrderSetRefDAO.class.getName());
		}
		catch (Exception e) {
			throw new QueryDAOException(e);
		}
		return orderSetRefDAO;
	}

}
