package gov.va.med.hds.querytool.dao.factory;

import gov.va.med.hds.cd.daoregistry.IDaoRegistry;
import gov.va.med.hds.cd.spectrum.longlist.BufferModelException;
import gov.va.med.hds.cd.spectrum.longlist.IDataNeededListener;
import gov.va.med.hds.querytool.dao.IProcedureListDAOFactory;
import gov.va.med.hds.querytool.types.AbstractListFactory;

/**
 * @author vhaislmonsos
 *
 */
public class ProcedureListFactory extends AbstractListFactory {

	/**
	 * @see gov.va.med.hds.querytool.types.AbstractListFactory#getDataProvider(IDaoRegistry)
	 */
	protected IDataNeededListener getDataProvider(IDaoRegistry daoRegistry)
		throws BufferModelException {
		IProcedureListDAOFactory factory;
		try {
			factory = (IProcedureListDAOFactory) daoRegistry.getDAO(IProcedureListDAOFactory.class.getName());
		}
		catch (Exception e) {
			throw new BufferModelException(e);
		}
		return factory.getBufferModelDAO();
	}

}
