package gov.va.med.hds.querytool.dao.factory;

import gov.va.med.hds.cd.daoregistry.IDaoRegistry;
import gov.va.med.hds.cd.runtime.IRuntimeContext;
import gov.va.med.hds.querytool.dao.INameValuePairDAO;
import gov.va.med.hds.querytool.dao.ISpecialtyRefDAO;
import gov.va.med.hds.querytool.dao.QueryDAOException;
import gov.va.med.hds.querytool.ui.types.IReferenceDAOFactory;

/**
 * Sets up a specialty reference DAO.
 */
public class SpecialtyRefFactory implements IReferenceDAOFactory {

	public INameValuePairDAO getReferenceDAO(
		IRuntimeContext runtime,
		IDaoRegistry daoRegistry)
		throws QueryDAOException {
		ISpecialtyRefDAO specRefDAO;
		try {
			specRefDAO = (ISpecialtyRefDAO)daoRegistry.getDAO(ISpecialtyRefDAO.class.getName());
		}
		catch (Exception e) {
			throw new QueryDAOException(e);
		}
		return specRefDAO;
	}

}
