package gov.va.med.hds.querytool.dao.factory;

import gov.va.med.hds.cd.daoregistry.IDaoRegistry;
import gov.va.med.hds.cd.runtime.IRuntimeContext;
import gov.va.med.hds.querytool.dao.INameValuePairDAO;
import gov.va.med.hds.querytool.dao.ITeamRefDAO;
import gov.va.med.hds.querytool.dao.QueryDAOException;
import gov.va.med.hds.querytool.ui.types.IReferenceDAOFactory;

/**
 * @author vhaislmonsos
 *
 * Jan 8, 2003 1:26:29 PM
 */
public class TeamRefFactory implements IReferenceDAOFactory {

	/**
	 * @see gov.va.med.hds.querytool.ui.types.IReferenceDAOFactory#getReferenceDAO(IRuntimeContext, IDaoRegistry)
	 */
	public INameValuePairDAO getReferenceDAO(
		IRuntimeContext runtime,
		IDaoRegistry daoRegistry)
		throws QueryDAOException {
		ITeamRefDAO teamRefDAO;
		try {
			teamRefDAO = (ITeamRefDAO)daoRegistry.getDAO(ITeamRefDAO.class.getName());
		}
		catch (Exception e) {
			throw new QueryDAOException(e);
		}
		return teamRefDAO;
	}

}
