package gov.va.med.hds.querytool.dao.factory;

import gov.va.med.hds.cd.daoregistry.IDaoRegistry;
import gov.va.med.hds.cd.runtime.IRuntimeContext;
import gov.va.med.hds.querytool.dao.INameValuePairDAO;
import gov.va.med.hds.querytool.dao.IWardRefDAO;
import gov.va.med.hds.querytool.dao.QueryDAOException;
import gov.va.med.hds.querytool.ui.types.IReferenceDAOFactory;

/**
 * @author vhaislmonsos
 *
 * Jan 8, 2003 9:09:59 AM
 */
public class WardRefFactory implements IReferenceDAOFactory {

	/**
	 * @see gov.va.med.hds.querytool.ui.types.IReferenceDAOFactory#getReferenceDAO(IRuntimeContext, IDaoRegistry)
	 */
	public INameValuePairDAO getReferenceDAO(
		IRuntimeContext runtime,
		IDaoRegistry daoRegistry)
		throws QueryDAOException {
		IWardRefDAO wardRefDAO;
		try {
			wardRefDAO = (IWardRefDAO)daoRegistry.getDAO(IWardRefDAO.class.getName());
		}
		catch (Exception e) {
			throw new QueryDAOException(e);
		}
		return wardRefDAO;
	}

}
