package gov.va.med.hds.querytool.m;

import java.util.Collection;

/**
 * @author vhaislmonsos
 *
 * Dec 19, 2002 7:08:56 AM
 */
public interface IMBufferListCall {

	/**
	 * Returns the name of the M RPC.
	 * @return String
	 */
	String getCallName();

	/**
	 * Clears the parameters returned by the getParms() method.
	 */
	void clearParms();

	/**
	 * Sets the parameter for the string to begin searching for.
	 * @param startString
	 */
	void setStartParm(String startString);

	/**
	 * Sets the direction parameter.
	 * @param DIRECTION
	 */
	void setDirectionParm(int DIRECTION);

	/**
	 * Returns all of the defined parameters in the order that the M call expects
	 * them.
	 * @return Collection
	 */
	Collection getParms();

	/**
	 * Gets the piece in the M string that contains the value text.
	 * @param string
	 * @return String
	 */
	String getValue(String mString);

	/**
	 * Gets the piece in the M string that contains the name or key
	 * @param string
	 * @return String
	 */
	String getKey(String mString);

	/**
	 * Method getExpectedCallSize.
	 * @return int
	 */
	int getExpectedCallSize();
	
	/**
	 * Method setFilter.
	 * @param filter
	 */
	void setFilterParm(Object filter);

}
