package gov.va.med.hds.querytool.m;

import gov.va.med.hds.querytool.dao.IBooleanDAO;
import gov.va.med.hds.querytool.dao.QueryDAOException;

import java.util.LinkedList;
import java.util.List;

/**
 * Abstract boolean DAO for Mumps.
 */
public abstract class MAbstractBooleanDAO extends AbstractMDAO implements IBooleanDAO {
	private static final int RPC_CALL_TIMEOUT_MILLIS = 10000;

	protected boolean getData() throws QueryDAOException {
		String result;
		try {
			result = mumps.callRPC(getCallName(), RPC_CALL_TIMEOUT_MILLIS);
		} catch (Exception e) {
			throw new QueryDAOException(e);
		}
		return ((result != null) && (result.startsWith("1")));
	}

	protected boolean getData(Object key) throws QueryDAOException {
		List parms = new LinkedList();
		parms.add(key.toString());
		String result;
		try {
			result = mumps.callRPC(getCallName(), parms, RPC_CALL_TIMEOUT_MILLIS);
		} catch (Exception e) {
			throw new QueryDAOException(e);
		}
		return ((result != null) && (result.startsWith("1")));
	}

	protected abstract String getCallName();

}
