package gov.va.med.hds.querytool.m;

import gov.va.med.hds.querytool.dao.INameValuePairDAO;
import gov.va.med.hds.querytool.dao.QueryDataDAOException;
import gov.va.med.hds.util.mumps.StringUtil;

import java.io.BufferedReader;
import java.io.StringReader;
import java.util.Map;
import java.util.TreeMap;

/**
 * @author vhaislmonsos
 *
 */
public abstract class MAbstractReferenceDAO extends AbstractMDAO implements INameValuePairDAO {

	public TreeMap get(Map items) throws QueryDataDAOException {
		TreeMap tree = new TreeMap();
		String result = null;
		try {
			result = mumps.callRPC(getCallName());
		}
		catch (Exception e) {
			throw new QueryDataDAOException("Call to '" + getCallName() + "' failed:",e);
		}
		if ((result != null) && (result.length()>0)) {
			items.clear();
			BufferedReader reader = new BufferedReader(new StringReader(result));
			String line;
			try {
				while ((line=reader.readLine())!=null) {
					String key = getKey(line).toString();
					String value = getValue(line).toString();
					items.put(key,value);
					tree.put(value+0x0+key,new Entry(key,value));
				}
			}
			catch (Exception e) {
				throw new QueryDataDAOException("Data error from database.",e);
			}
		}
		return tree;
	}
	
	public abstract String getCallName();
	
	public Object getKey(Object item) throws QueryDataDAOException {
		return StringUtil.piece(item.toString(),'^',1);
	}

	public Object getValue(Object item) throws QueryDataDAOException {
		return StringUtil.piece(item.toString(),'^',2);
	}

}
