package gov.va.med.hds.querytool.m;

import gov.va.med.hds.util.mumps.StringUtil;
import java.util.Collection;
import java.util.LinkedList;

/**
 * @author vhaislmonsos
 *
 * Dec 19, 2002 11:08:06 AM
 */
public class MClinicianListCalls implements IMBufferListCall {
	private static final String NEWPERS_RPC_KEY = "NEWPERS";
	private String startString;
	private String direction;
	
	public MClinicianListCalls() {
		super();
		init();
	}
	
	private void init() {
		startString = new String();
		direction = new String();
	}

	/**
	 * @see gov.va.med.hds.querytool.IMBufferListCall#clearParms()
	 */
	public void clearParms() {
		init();
	}

	/**
	 * @see gov.va.med.hds.querytool.IMBufferListCall#getCallName()
	 */
	public String getCallName() {
		return NEWPERS_RPC_KEY;
	}

	/**
	 * @see gov.va.med.hds.querytool.IMBufferListCall#getName(String)
	 */
	public String getKey(String mString) {
		return StringUtil.piece(mString,'^',1);
	}

	/**
	 * @see gov.va.med.hds.querytool.IMBufferListCall#getParms()
	 */
	public Collection getParms() {
		LinkedList parms = new LinkedList();
		parms.add(startString);
		parms.add(direction);
		parms.add("PROVIDER");
		return parms;
	}

	/**
	 * @see gov.va.med.hds.querytool.IMBufferListCall#getValue(String)
	 */
	public String getValue(String mString) {
		return StringUtil.toMixedCase(StringUtil.piece(mString, '^', 2));
	}

	/**
	 * @see gov.va.med.hds.querytool.IMBufferListCall#setDirectionParm(int)
	 */
	public void setDirectionParm(int DIRECTION) {
		direction = Integer.toString(DIRECTION);
	}

	/**
	 * @see gov.va.med.hds.querytool.IMBufferListCall#setStartParm(String)
	 */
	public void setStartParm(String startString) {
		this.startString = startString;
	}

	/**
	 * @see gov.va.med.hds.querytool.IMBufferListCall#getExpectedCallSize()
	 */
	public int getExpectedCallSize() {
		return 44;
	}

	/**
	 * @see gov.va.med.hds.querytool.m.IMBufferListCall#setFilterParm(java.lang.Object)
	 */
	public void setFilterParm(Object filter) {
	}

}
