package gov.va.med.hds.querytool.m;

import gov.va.med.hds.querytool.DisplayField;
import gov.va.med.hds.querytool.IDisplayField;
import gov.va.med.hds.querytool.IQuery;
import gov.va.med.hds.querytool.dao.IDisplayFieldListDAO;
import gov.va.med.hds.util.mumps.NameValuePair;

/**
 * Gets the query display field list from the M data string list.
 */
public class MDisplayFieldListDAO extends AbstractMDAO implements IDisplayFieldListDAO {
	
	public void get(IQuery query, String[] alist) {
		if (alist == null) {
			return;
		}
		for (int i=0; i<alist.length; i++) {
			NameValuePair nvp1 = new NameValuePair(alist[i]);
			if (nvp1.getLeft().compareTo("ColumnName")==0) {
				IDisplayField df = new DisplayField();
				NameValuePair nvp2 = new NameValuePair(alist[++i]);
				NameValuePair nvp3 = new NameValuePair(alist[++i]);
				df.setID(nvp1.getRight());
				df.setDisplayText(nvp2.getRight());
				df.setColumnWidth(Integer.parseInt(nvp3.getRight()));
				query.getDisplayFields().add(df);
			}
		}
	}
	
}
