package gov.va.med.hds.querytool.m;

import gov.va.med.hds.util.mumps.StringUtil;
import java.util.Collection;
import java.util.LinkedList;
import java.util.List;

/**
 * @author vhaislmonsos
 *
 * Jan 15, 2003 11:09:08 AM
 */
public class MDocTitleListCalls implements IMBufferListCall {
	private String start;
	private int direction;
	private String filter;

	/**
	 * @see gov.va.med.hds.querytool.m.IMBufferListCall#getCallName()
	 */
	public String getCallName() {
		return "TIU LONG LIST OF TITLES";
	}

	/**
	 * @see gov.va.med.hds.querytool.m.IMBufferListCall#clearParms()
	 */
	public void clearParms() {
		start = null;
		direction = 0;
	}

	/**
	 * @see gov.va.med.hds.querytool.m.IMBufferListCall#setStartParm(String)
	 */
	public void setStartParm(String startString) {
		start = startString;
	}

	/**
	 * @see gov.va.med.hds.querytool.m.IMBufferListCall#setDirectionParm(int)
	 */
	public void setDirectionParm(int DIRECTION) {
		direction = DIRECTION;
	}

	/**
	 * @see gov.va.med.hds.querytool.m.IMBufferListCall#getParms()
	 */
	public Collection getParms() {
		List parms = new LinkedList();
		parms.add(filter);
		parms.add(start);
		parms.add(Integer.toString(direction));
		return parms;
	}

	/**
	 * @see gov.va.med.hds.querytool.m.IMBufferListCall#getValue(String)
	 */
	public String getValue(String mString) {
		return StringUtil.toMixedCase(StringUtil.piece(mString,'^',2));
	}

	/**
	 * @see gov.va.med.hds.querytool.m.IMBufferListCall#getKey(String)
	 */
	public String getKey(String mString) {
		return StringUtil.piece(mString,'^',1);
	}

	/**
	 * @see gov.va.med.hds.querytool.m.IMBufferListCall#getExpectedCallSize()
	 */
	public int getExpectedCallSize() {
		return 44;
	}

	/**
	 * @see gov.va.med.hds.querytool.m.IMBufferListCall#setFilterParm(java.lang.Object)
	 */
	public void setFilterParm(Object filter) {
		this.filter = filter.toString();
	}

}
