package gov.va.med.hds.querytool.m;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.StringReader;

import gov.va.med.hds.cd.m.CallQueueException;
import gov.va.med.hds.cd.m.ICallRequest;
import gov.va.med.hds.querytool.dao.IPatDetailDAO;

/**
 * @author vhaislmonsos
 *
 * Feb 10, 2003 3:58:00 PM
 */
public class MPatDetailDAO extends MAbstractDetailDAO implements IPatDetailDAO {

	/**
	 * @see gov.va.med.hds.querytool.m.MAbstractDetailDAO#callFailed(ICallRequest, CallQueueException)
	 */
	public void callFailed(ICallRequest request, CallQueueException e) {
		logger.error("Error getting patient detail data.", e);
	}

	/**
	 * @see gov.va.med.hds.querytool.m.MAbstractDetailDAO#getCallString()
	 */
	public String getCallString() {
		return "PTDFN";
	}

	/**
	 * @see gov.va.med.hds.querytool.m.MAbstractDetailDAO#callSucceeded(ICallRequest, String)
	 */
	public void callSucceeded(ICallRequest request, String result) {
		BufferedReader reader = new BufferedReader(new StringReader(result));
		String line;
		try {
			line = reader.readLine();
			if ((line==null) || (line.length()<1)) {
				line = reader.readLine();
			}
		}
		catch (IOException e) {
			throw new RuntimeException("Error reading user detail data.",e);
		}
		super.callSucceeded(request,line);
	}

}
