/*
 * Initially Created on Apr 7, 2003 by vhaislmonsos
 *
 */
package gov.va.med.hds.querytool.m;

import gov.va.med.hds.querytool.dao.IPredefinedQueryListDAO;
import gov.va.med.hds.util.mumps.StringUtil;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.StringReader;
import java.util.HashMap;
import java.util.Map;

/**
 * M query list for the predefined queries.
 */
public class PredefinedQueryListDAO
	extends AbstractQueryListDAO
	implements IPredefinedQueryListDAO {

	protected void processData(String result) {
		Map predefinedMap = new HashMap();
		BufferedReader reader = new BufferedReader(new StringReader(result));
		String line = null;
		try {
			while ((line=reader.readLine())!=null) {
				String key = StringUtil.piece(line,SEPARATOR,1);
				String value = StringUtil.piece(line,SEPARATOR,2);
				if (key.equals("0")) {
					break;
				}
				predefinedMap.put(key, value);
			}
		}
		catch (IOException e) {
			logError("Error processing query list data.");
		}
		
		updateQueries(predefinedMap);
		removeUnfoundQueries(predefinedMap);
		addUnfoundQueries(predefinedMap);
	}

}
