/*
 * Initially Created on Jun 5, 2003 by vhaislmonsos
 *
 */
package gov.va.med.hds.querytool.m;

import gov.va.med.hds.cd.daoregistry.IDaoRegistry;
import gov.va.med.hds.cd.runtime.IConfigurationElement;
import gov.va.med.hds.cd.runtime.IRuntimeContext;
import gov.va.med.hds.querytool.IQuery;
import gov.va.med.hds.querytool.dao.IQueryDAO;
import gov.va.med.hds.querytool.dao.IRunSetupDAO;
import gov.va.med.hds.querytool.dao.QueryDAOException;

/**
 * Sets up a query run in M.
 */
public class RunSetupDAO extends AbstractMDAO implements IRunSetupDAO {
	private static final String REPORT_SETUP = "ORRHCQ SETUP";
	private IQueryDAO queryDAO;
	private String iterator;

	public RunSetupDAO() {
		super();
	}

	public void setQuery(IQuery query) throws QueryDAOException {
		Object[] parms = new Object[1];
		parms[0] = queryDAO.getReportStrings(query);
		//		for (Iterator i = list.iterator(); i.hasNext();) {
		//			System.out.println(i.next().toString());
		//		}
		try {
			iterator = mumps.callRPC(REPORT_SETUP, parms);
		}
		catch (Exception e) {
			throw new QueryDAOException("Error saving the query before running.",e);
		}
	}
	
	public Object getIterator() {
		return iterator;
	}

	public void setInitializationData(
		IRuntimeContext runtime,
		IConfigurationElement config,
		String propertyName,
		Object data)
		throws Exception {

		super.setInitializationData(runtime, config, propertyName, data);
		IDaoRegistry daoRegistry = (IDaoRegistry)runtime.getPluginInstance(IDaoRegistry.PLUGIN_ID);
		queryDAO = (IQueryDAO)daoRegistry.getDAO(IQueryDAO.class.getName());
	}

}
