/*
 * Initially Created on Apr 7, 2003 by vhaislmonsos
 *
 */
package gov.va.med.hds.querytool.m;

import gov.va.med.hds.querytool.dao.IUserQueryListDAO;
import gov.va.med.hds.util.mumps.StringUtil;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.StringReader;
import java.util.HashMap;
import java.util.Map;

/**
 * M implementation of the user query list data access object.
 */
public class UserQueryListDAO extends AbstractQueryListDAO implements IUserQueryListDAO {

	protected void processData(String result) {
		Map userDefinedMap = new HashMap();
		BufferedReader reader = new BufferedReader(new StringReader(result));
		String line = null;
		boolean separatorFound = false;
		try {
			while ((line=reader.readLine())!=null) {
				String key = StringUtil.piece(line,SEPARATOR,1);
				String value = StringUtil.piece(line,SEPARATOR,2);
				if (key.equals("0")) {
					separatorFound = true;
					continue;
				}
				if (!separatorFound) {
					continue;
				}
				userDefinedMap.put(key, value);
			}
		}
		catch (IOException e) {
			logError("Error processing query list data.");
		}
		
		updateQueries(userDefinedMap);
		removeUnfoundQueries(userDefinedMap);
		addUnfoundQueries(userDefinedMap);
	}
	
}
