/*
 * Initially Created on Jun 10, 2003 by vhaislmonsos
 *
 */
package gov.va.med.hds.querytool.state;

import gov.va.med.hds.cd.runtime.IRuntimeContext;
import gov.va.med.hds.cd.runtime.logging.ILogger;
import gov.va.med.hds.querytool.IAvailableColumnsList;
import gov.va.med.hds.querytool.ICombinedQueryCollection;
import gov.va.med.hds.querytool.IQuery;
import gov.va.med.hds.querytool.IQueryToolState;
import gov.va.med.hds.querytool.IRunQuery;
import gov.va.med.hds.querytool.ISensitiveList;
import gov.va.med.hds.querytool.dao.IQueryDAO;
import gov.va.med.hds.querytool.ui.IResultsTable;

import javax.swing.text.Document;

/**
 * Abstract query state object; includes the runtime and logger, and empty methods for all interface methods.
 */
public abstract class AbstractQueryState implements IQueryToolState {
	protected IRuntimeContext runtime;
	protected ILogger logger;
	protected String message;
	protected Throwable error;
	protected IQuery currentQuery;

	public AbstractQueryState() {
		super();
	}

	public AbstractQueryState(IRuntimeContext runtime) {
		super();
		setRuntime(runtime);
	}

	public void setRuntime(IRuntimeContext runtime) {
		this.runtime = runtime;
		logger = runtime.getLogger(this.getClass());
	}

	public void setException(Throwable exception) {
		this.error = exception;
	}
	
	public Throwable getException() {
		return error;
	}
	
	public void setMessage(String message) {
		this.message = message;
	}
	
	public String getMessage() {
		return message;
	}
	
	public void setCurrentQuery(IQuery query) {
		this.currentQuery = query;
	}
	
	public IQueryDAO getQueryDAO() {return null;}
	public void setQueryDAO(IQueryDAO queryDAO) {}
	public IResultsTable getResults() {return null;}
	public void setRunModel(IRunQuery runQuery) {}
	public IRunQuery getRunModel() {return null;}
	public Document getSensitiveMessage() {return null;}
	public ISensitiveList getSensitivePatientList() {return null;}
	public ICombinedQueryCollection getQueryCollection() {return null;}
	public void reset() {}
	public void setQueryCollection(ICombinedQueryCollection queryCollection) {}
	public void setResultsTable(IResultsTable resultsTable) {}
	public void setSensitiveMessage(Document message) {}
	public void setSensitivePatientList(ISensitiveList sensitiveList) {}
	public void setAvailableColumnList(IAvailableColumnsList availableColumnList) {}
	public IAvailableColumnsList getAvailableColumnList() {return null;}

}
