/*
 * Created on Jun 10, 2003 by vhaislmonsos
 */
package gov.va.med.hds.querytool.state;

import gov.va.med.hds.cd.runtime.IRuntimeContext;
import gov.va.med.hds.querytool.CombinedQueryCollection;
import gov.va.med.hds.querytool.IAvailableColumnsList;
import gov.va.med.hds.querytool.ICombinedQueryCollection;
import gov.va.med.hds.querytool.IQuery;
import gov.va.med.hds.querytool.IQueryToolState;
import gov.va.med.hds.querytool.QueryCollectionException;
import gov.va.med.hds.querytool.dao.IQueryDAO;

/**
 * Select and Edit State
 */
public class SelectAndEdit
	extends AbstractQueryState
	implements IQueryToolState {

	protected ICombinedQueryCollection queryCollection;
	protected IQueryDAO queryDAO;
	private IAvailableColumnsList availableColumns;

	public SelectAndEdit() {
		super();
	}

	/**
	 * Delegates to parent.
	 * @param runtime
	 */
	public SelectAndEdit(IRuntimeContext runtime) {
		super(runtime);
	}
	
	public IQueryDAO getQueryDAO() {
		return queryDAO;
	}

	public void setQueryDAO(IQueryDAO queryDAO) {
		this.queryDAO = queryDAO;
	}

	public void reset() {
		super.reset();
		if (queryCollection==null) {
			queryCollection = new CombinedQueryCollection();
			try {
				queryCollection.setRuntime(runtime);
			}
			catch (QueryCollectionException e) {
				logger.error("Error setting up query collection.",e);
			}
			queryCollection.setQueryDAO(queryDAO);
		}
		try {
			queryCollection.refresh();
		}
		catch (QueryCollectionException e) {
			logger.error("Error refreshing query collection.",e);
		}
	}

	public ICombinedQueryCollection getQueryCollection() {
		return queryCollection;
	}

	public IAvailableColumnsList getAvailableColumnList() {
		return availableColumns;
	}

	public void setAvailableColumnList(IAvailableColumnsList availableColumnList) {
		if (this.availableColumns!=null && availableColumnList==null) {
			this.availableColumns.setModel(null);
		}
		this.availableColumns = availableColumnList;
		if (availableColumnList!=null) {
			availableColumnList.setModel(currentQuery);
		}
	}

	public void setCurrentQuery(IQuery query) {
		super.setCurrentQuery(query);
		if (availableColumns!=null) {
			availableColumns.setModel(query);
		}
	}

}
