/*
 * Initially Created on Jun 10, 2003 by vhaislmonsos
 *
 */
package gov.va.med.hds.querytool.state;

import gov.va.med.hds.cd.runtime.IRuntimeContext;
import gov.va.med.hds.querytool.IQueryToolState;
import gov.va.med.hds.querytool.IRunQuery;
import gov.va.med.hds.querytool.ISensitiveList;

import javax.swing.text.Document;

/**
 * Pause state in between running the main query list and running the sensitive patients.  Allows the user
 * to choose which sensitive patients to continue with.
 */
public class SensitiveReview extends AbstractQueryState implements IQueryToolState {
	private ISensitiveList sensitiveList;
	private Document sensitiveMessage;
	private IRunQuery runQuery;
	
	public SensitiveReview() {
		super();
	}

	/**
	 * Delegates to parent class.
	 * @param runtime
	 */
	public SensitiveReview(IRuntimeContext runtime) {
		super(runtime);
	}

	public void setSensitiveMessage(Document message) {
		this.sensitiveMessage = message;
	}

	public Document getSensitiveMessage() {
		return sensitiveMessage;
	}

	public ISensitiveList getSensitivePatientList() {
		return sensitiveList;
	}

	public void setSensitivePatientList(ISensitiveList sensitiveList) {
		this.sensitiveList = sensitiveList;
	}
	
	public IRunQuery getRunModel() {
		return runQuery;
	}

	public void setRunModel(IRunQuery runQuery) {
		this.runQuery = runQuery;
	}

}
