/*
 * Initially Created on Jun 10, 2003 by vhaislmonsos
 *
 */
package gov.va.med.hds.querytool.state;

import gov.va.med.hds.cd.runtime.IRuntimeContext;
import gov.va.med.hds.querytool.IQueryToolState;
import gov.va.med.hds.querytool.IRunQuery;
import gov.va.med.hds.querytool.ui.IResultsTable;

/**
 * View state that is valid after a query execution is complete.
 */
public class ViewCompleteState
	extends AbstractQueryState
	implements IQueryToolState {
		
	private IResultsTable resultsTable;
	private IRunQuery runQuery;

	public ViewCompleteState() {
		super();
	}

	/**
	 * Delegates to parent.
	 * @param runtime
	 */
	public ViewCompleteState(IRuntimeContext runtime) {
		super(runtime);
	}

	public IResultsTable getResults() {
		return resultsTable;
	}

	public IRunQuery getRunModel() {
		return runQuery;
	}

	public void setRunModel(IRunQuery runQuery) {
		this.runQuery = runQuery;
	}

	public void setResultsTable(IResultsTable resultsTable) {
		this.resultsTable = resultsTable;
	}

}
