package gov.va.med.hds.querytool.types;

import gov.va.med.hds.cd.daoregistry.IDaoRegistry;
import gov.va.med.hds.cd.runtime.IRuntimeContext;
import gov.va.med.hds.cd.spectrum.longlist.BufferModelException;
import gov.va.med.hds.cd.spectrum.longlist.IDataNeededListener;
import gov.va.med.hds.querytool.ui.types.IBufferedListFactory;

/**
 * @author vhaislmonsos
 *
 * Dec 19, 2002 10:01:00 AM
 */
public abstract class AbstractListFactory implements IBufferedListFactory {
	private IDaoRegistry daoRegistry;

	/**
	 * @see gov.va.med.hds.querytool.ui.types.IBufferedListFactory#getBufferModelDataProvider(IRuntimeContext)
	 */
	public IDataNeededListener getBufferModelDataProvider(IRuntimeContext runtime) throws BufferModelException {
		try {
			daoRegistry = (IDaoRegistry)runtime.getPluginInstance(IDaoRegistry.PLUGIN_ID);
		}
		catch (Exception e) {
			throw new BufferModelException(e);
		}
		return getDataProvider(daoRegistry);
	}
	
	protected abstract IDataNeededListener getDataProvider(IDaoRegistry daoRegistry) throws BufferModelException;

}
