package gov.va.med.hds.querytool.types;

import gov.va.med.hds.querytool.IDateRange;
import gov.va.med.hds.util.date.RelativeDate;

import java.util.Date;
import java.util.Iterator;
import java.util.List;

/**
 * Time frame value object.
 */
public class TimeFrame extends AbstractType {
	private String emptyDisplayText = "< select date range >";
	private Date referenceDate;
	
	public void setReferenceDate(Date referenceDate) {
		this.referenceDate = referenceDate;
		getDefaultDisplayText();
	}
	
	public String getEmptyDisplayText() {
		return emptyDisplayText;
	}

	/**
	 * @see gov.va.med.hds.querytool.IValue#getDefaultDisplayText()
	 */
	public String getDefaultDisplayText() {
		if (getValues()!=null) {
			StringBuffer defaultText = new StringBuffer();
			List values = getValues();
			Iterator it = values.iterator();
			boolean first = true;
			while (it.hasNext()) {
				if (first) {
					first = false;
				}
				else {
					defaultText.append(" ");
				}
				IDateRange dateRange = (IDateRange)it.next();
				defaultText.append(RelativeDate.getDateRangeDisplayText(dateRange.getReferenceDate(), dateRange.toString()));
			}
			if (defaultText.length() < 1) {
				defaultText.append(emptyDisplayText);
			}
			if (!defaultText.toString().equals(super.getDefaultDisplayText())) {
				super.setDefaultDisplayTextNoEvent(defaultText.toString());
			}
		}
		return super.getDefaultDisplayText();
	}

}
