/*
 * Initially Created on Apr 2, 2003 by vhaislmonsos
 *
 */
package gov.va.med.hds.querytool.types;

import gov.va.med.hds.cd.daoregistry.IDaoRegistry;
import gov.va.med.hds.cd.runtime.IRuntimeContext;
import gov.va.med.hds.cd.runtime.logging.ILogger;
import gov.va.med.hds.querytool.IValue;
import gov.va.med.hds.querytool.IValueFactory;
import gov.va.med.hds.util.dao.IServerDateDAO;

import java.util.Date;

/**
 * Creates a TimeFrame IValue; necessary to set the reference date from a server
 * date/time DAO.
 */
public class TimeFrameFactory implements IValueFactory {
	private IRuntimeContext runtime;

	public IValue getValue(IRuntimeContext runtime) {
		this.runtime = runtime;
		TimeFrame value = new TimeFrame();
		IDaoRegistry daoRegistry;
		try {
			daoRegistry = (IDaoRegistry)runtime.getPluginInstance(IDaoRegistry.PLUGIN_ID);
		}
		catch (Exception e) {
			sendError("Error retrieving the DaoRegistry plugin.");
			return null;
		}
		IServerDateDAO serverDateDAO;
		Date date;
		try {
			serverDateDAO = (IServerDateDAO)daoRegistry.getDAO(IServerDateDAO.class.getName());
			date = serverDateDAO.getDate();
		}
		catch (Exception e1) {
			sendError("ServerDateDAO failed to return a date.");
			return null;
		}
		value.setReferenceDate(date);
		return value;
	}
	
	private void sendError(String message) {
		ILogger logger = runtime.getLogger(TimeFrameFactory.class);
		logger.error(message);
	}

}
