package gov.va.med.hds.querytool.itest;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.List;

import gov.va.med.hds.querytool.DateRange;
import gov.va.med.hds.querytool.IDateRange;
import gov.va.med.hds.querytool.ui.types.DateRangePanel;
import gov.va.med.hds.querytool.ui.types.EditorException;
import gov.va.med.hds.querytool.ui.types.EditorPanel;
import gov.va.med.hds.util.dao.IServerDateDAO;
import gov.va.med.hds.util.dao.UtilDaoException;

/**
 * @author vhaislmonsos
 *
 * Dec 15, 2002 12:21:07 AM
 */
public class DateRangePanelTest extends MAbstractTestCase {

	/**
	 * Constructor for DateRangePanelTest.
	 * @param arg0
	 */
	public DateRangePanelTest(String arg0) {
		super(arg0);
	}

	/**
	 * Method main.
	 * @param args
	 */
	public static void main(String[] args) {
		junit.textui.TestRunner.run(DateRangePanelTest.class);
	}
	
	/**
	 * @see junit.framework.TestCase#setUp()
	 */
	protected void setUp() throws Exception {
		super.setUp();
	}

	public void testEmptyValue() throws EditorException {
		EditorPanel editorPanel = new DateRangePanel(new Date());
		editorPanel.setRuntime(runtime);
		editorPanel.init();
		assertEquals("DateRangePanel.getDisplayText failed:","",editorPanel.getDisplayText());
		assertEquals("DateRangePanel.getValues failed:",1,editorPanel.getValues().size());
		String val = ((IDateRange)editorPanel.getValues().get(0)).toString();
		assertEquals("DateRangePanel.getValues failed:","",val);
	}
	
	public void testValidValue() throws EditorException, Exception, UtilDaoException {
		List values = new ArrayList();
		Date now = null;
		IServerDateDAO server = (IServerDateDAO)daoRegistry.getDAO(IServerDateDAO.class.getName());
		now = server.getDate();
		values.add(new DateRange(now,"T-10:T+10"));
		GregorianCalendar cal = new GregorianCalendar();
		cal.setTime(now);
		SimpleDateFormat dateFormat = new SimpleDateFormat("dd MMM yyyy");
		EditorPanel editorPanel = new DateRangePanel(now);
		editorPanel.setValues(values);
		editorPanel.setRuntime(runtime);
		editorPanel.init();
		cal.setTime(now);
		cal.add(GregorianCalendar.DATE,-10);
		String pastString = dateFormat.format(cal.getTime());
		cal.add(GregorianCalendar.DATE,20);
		String futureString = dateFormat.format(cal.getTime());
		assertEquals("DateRangePanel.getDisplayText failed:","from " + pastString + " through " + futureString,editorPanel.getDisplayText());
		assertEquals("DateRangePanel.getValues failed:",1,editorPanel.getValues().size());
		String val = ((IDateRange)editorPanel.getValues().get(0)).toString();
		assertEquals("DateRangePanel.getValues failed:","T-10:T+10",val);
	}

}
