/*
 * Initially Created on Jun 9, 2003 by vhaislmonsos
 *
 */
package gov.va.med.hds.querytool.itest;

import gov.va.med.hds.querytool.IValue;
import gov.va.med.hds.querytool.IValueFactory;
import gov.va.med.hds.querytool.types.PatientSelection;
import gov.va.med.hds.querytool.types.TimeFrameFactory;
import gov.va.med.hds.querytool.ui.EditorFactoryFactory;
import gov.va.med.hds.querytool.ui.FactoryException;
import gov.va.med.hds.querytool.ui.IEditorFactoryFactory;
import gov.va.med.hds.querytool.ui.editor.IRunnableEditorPanel;
import gov.va.med.hds.querytool.ui.editor.factory.IEditorFactory;
import gov.va.med.hds.querytool.ui.types.EditorException;

/**
 * EditorFactoryFactory tests
 */
public class EditorFactoryFactoryTest extends MAbstractTestCase {
	private IEditorFactoryFactory factory;

	/**
	 * Constructor for EditorFactoryFactoryTest.
	 * @param name
	 */
	public EditorFactoryFactoryTest(String name) {
		super(name);
	}

	public static void main(String[] args) {
		junit.textui.TestRunner.run(EditorFactoryFactoryTest.class);
	}

	protected void setUp() throws Exception {
		super.setUp();
		factory = new EditorFactoryFactory();
	}

	public void testSetRuntime() throws FactoryException {
		factory.setRuntime(runtime);
	}

	public void testGetFactory() throws FactoryException, EditorException {
		testSetRuntime();
		assertNull("EditorFactoryFactory.getFactory failed: null value expected.",factory.getFactory("fred"));
		IValue patSelection = new PatientSelection();
		IEditorFactory editorFactory = factory.getFactory(patSelection.getClass().getName());
		assertNotNull("EditorFactoryFactory.getFactory failed: null value NOT expected.",editorFactory);
		IRunnableEditorPanel panel = editorFactory.getEditor();
		assertNotNull("EditorFactoryFactory.getFactory failed: null value NOT expected.",panel);
		IValueFactory valueFactory = new TimeFrameFactory();
		IValue timeValue = valueFactory.getValue(runtime);
		editorFactory = factory.getFactory(timeValue.getClass().getName());
		assertNotNull("EditorFactoryFactory.getFactory failed: null value NOT expected.",editorFactory);
		panel = editorFactory.getEditor();
		assertNotNull("EditorFactoryFactory.getFactory failed: null value NOT expected.",panel);
	}

}
