package gov.va.med.hds.querytool.itest;

import gov.va.med.hds.cd.runtime.PluginNotFoundException;
import gov.va.med.hds.cd.runtime.PluginStartupException;
import gov.va.med.hds.cd.spectrum.linkpanel.HTMLSelectionModel;
import gov.va.med.hds.cd.spectrum.linkpanel.IHTMLSelectionModel;
import gov.va.med.hds.querytool.HTMLQueryTextFactory;
import gov.va.med.hds.querytool.IQuery;
import gov.va.med.hds.querytool.QueryID;
import gov.va.med.hds.querytool.dao.IQueryDAO;
import gov.va.med.hds.querytool.dao.QueryDAOException;

import java.awt.Font;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;

/**
 * Tests for the HTMLSelectionModelFactory; uses the MQueryDAO to get a test query.
 */
public class HTMLSelectionModelFactoryTest extends MAbstractTestCase {
	private Thread testThread;

	public HTMLSelectionModelFactoryTest(String arg0) {
		super(arg0);
	}

	public static void main(String[] args) {
		junit.textui.TestRunner.run(HTMLSelectionModelFactoryTest.class);
	}
	
	public void testCreate() throws PluginNotFoundException, PluginStartupException, Exception, QueryDAOException, InterruptedException {
		IQueryDAO queryDAO = (IQueryDAO)daoRegistry.getDAO(IQueryDAO.class.getName());
		IQuery q = null;
		q = queryDAO.getAsync(new QueryID("88"), "title");
		q.addPropertyChangeListener(new PropertyChangeListener() {
			public void propertyChange(PropertyChangeEvent e) {
				synchronized(testThread) {
					testThread.notify();
				}
			}
		});
		q.getName();
		synchronized(testThread) {
			testThread.wait(5000);
		}
		IHTMLSelectionModel model = new HTMLSelectionModel();
		HTMLQueryTextFactory.updateText(model,q);
		
		String actualResult = "<html><header></header><body STYLE=\"font-family:Dialog.bold;font-size:12;background-color:#FFFFFF;\">Patient Lists for Search:&nbsp;<a href=\"http://.1.\" style=\"color: #800080\"> Specialty: Blind Rehab Observation and Specialty: Domiciliary Chv and Specialty: Medical Observation and Specialty: Medicine and Specialty: Neurology Observation and Specialty: Psychiatric Observation and Specialty: Rehab Medicine Observation and Specialty: Spinal Cord Injury Observation and Specialty: Surgery and Specialty: Surgical Observation and Local HepC Registry</a><br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;include only patients with inpt/outpt/pharmacy visits&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<a href=\"http://.2.\" style=\"color: #800080\">during Today</a><br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;where the primary outpatient provider is&nbsp;<a href=\"http://.3.\" style=\"color: #800080\">BAYLIS,RANDALL</a><br>Searching Reports&nbsp;<a href=\"http://.4.\" style=\"color: #800080\">during 2002</a><br>Find Orders<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;where the service category (display group) is&nbsp;<a href=\"http://.5.\" style=\"color: #0000FF\">&lt; select service category &gt;</a><br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;where the text of the order contains&nbsp;<a href=\"http://.6.\" style=\"color: #0000FF\">&lt; enter text &gt;</a><br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;where the order has abnormal results or significant findings<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;where the order status is&nbsp;<a href=\"http://.7.\" style=\"color: #0000FF\">&lt; select order status &gt;</a><br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;where the signature status is&nbsp;<a href=\"http://.8.\" style=\"color: #0000FF\">&lt; select signature status &gt;</a><br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;where the requesting clinician is&nbsp;<a href=\"http://.9.\" style=\"color: #0000FF\">&lt; select clinician &gt;</a><br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;List only patients where NO ORDERS meeting the above criteria were found.<br>Find Consults<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;where the consulting service is&nbsp;<a href=\"http://.10.\" style=\"color: #800080\">GMRCTVTEST</a><br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;where the text of the consult request contains&nbsp;<a href=\"http://.11.\" style=\"color: #800080\">RRE</a><br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;where the consult has significant findings<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;where the consult status is&nbsp;<a href=\"http://.12.\" style=\"color: #800080\">PENDING</a><br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;where the signature status is&nbsp;<a href=\"http://.13.\" style=\"color: #800080\">NOT REQUIRED due to cancel</a><br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;where the requesting clinician is&nbsp;<a href=\"http://.14.\" style=\"color: #800080\">BARNACLE,BILL</a><br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;List only patients where NO CONSULTS meeting the above criteria were found.<br>Find Documents<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;where the document class is&nbsp;<a href=\"http://.15.\" style=\"color: #800080\">Progress Notes</a><br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;where the title is&nbsp;<a href=\"http://.16.\" style=\"color: #800080\">DISCHARGE SUMMARY or ERRONEOUS DISCHARGE SUMMARY</a><br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;where the document status is&nbsp;<a href=\"http://.17.\" style=\"color: #800080\">UNTRANSCRIBED</a><br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;where the author is&nbsp;<a href=\"http://.18.\" style=\"color: #800080\">BARRON,LUANNE</a><br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;where the visit location is&nbsp;<a href=\"http://.19.\" style=\"color: #800080\">GENERAL MEDICINE</a><br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;List only patients where NO DOCUMENTS meeting the above criteria were found.<br>Find Appointments/Visits<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;where the visit is for&nbsp;<a href=\"http://.20.\" style=\"color: #800080\">REPORT OF CONTACTS</a><br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;List only patients where NO VISITS meeting the above criteria were found.<br></body></html>";
//		System.out.println(model.getHTML());
		assertEquals("HTMLQueryTextFactory.create failed:",actualResult,model.getHTML());
		actualResult = "<html><header></header><body STYLE=font-family:sansserif;font-size:12;background-color:#FFFFFF;\">Patient Lists for Search:&nbsp;<a href=\"http://.1.\" style=\"color: #800080\"> Specialty: Blind Rehab Observation and Specialty: Domiciliary Chv and Specialty: Medical Observation and Specialty: Medicine and Specialty: Neurology Observation and Specialty: Psychiatric Observation and Specialty: Rehab Medicine Observation and Specialty: Spinal Cord Injury Observation and Specialty: Surgery and Specialty: Surgical Observation and Local HepC Registry</a><br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;include only patients with inpt/outpt/pharmacy visits&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<a href=\"http://.2.\" style=\"color: #800080\">during Today</a><br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;where the primary outpatient provider is&nbsp;<a href=\"http://.3.\" style=\"color: #800080\">BAYLIS,RANDALL</a><br>Searching Reports&nbsp;<a href=\"http://.4.\" style=\"color: #800080\">during 2002</a><br>Find Orders<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;where the service category (display group) is&nbsp;<a href=\"http://.5.\" style=\"color: #0000FF\">&lt; select service category &gt;</a><br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;where the text of the order contains&nbsp;<a href=\"http://.6.\" style=\"color: #0000FF\">&lt; enter text &gt;</a><br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;where the order has abnormal results or significant findings<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;where the order status is&nbsp;<a href=\"http://.7.\" style=\"color: #0000FF\">&lt; select order status &gt;</a><br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;where the signature status is&nbsp;<a href=\"http://.8.\" style=\"color: #0000FF\">&lt; select signature status &gt;</a><br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;where the requesting clinician is&nbsp;<a href=\"http://.9.\" style=\"color: #0000FF\">&lt; select clinician &gt;</a><br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;List only patients where NO ORDERS meeting the above criteria were found.<br>Find Consults<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;where the consulting service is&nbsp;<a href=\"http://.10.\" style=\"color: #800080\">GMRCTVTEST</a><br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;where the text of the consult request contains&nbsp;<a href=\"http://.11.\" style=\"color: #800080\">RRE</a><br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;where the consult has significant findings<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;where the consult status is&nbsp;<a href=\"http://.12.\" style=\"color: #800080\">PENDING</a><br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;where the signature status is&nbsp;<a href=\"http://.13.\" style=\"color: #800080\">NOT REQUIRED due to cancel</a><br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;where the requesting clinician is&nbsp;<a href=\"http://.14.\" style=\"color: #800080\">BARNACLE,BILL</a><br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;List only patients where NO CONSULTS meeting the above criteria were found.<br>Find Documents<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;where the document class is&nbsp;<a href=\"http://.15.\" style=\"color: #800080\">Progress Notes</a><br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;where the title is&nbsp;<a href=\"http://.16.\" style=\"color: #800080\">DISCHARGE SUMMARY or ERRONEOUS DISCHARGE SUMMARY</a><br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;where the document status is&nbsp;<a href=\"http://.17.\" style=\"color: #800080\">UNTRANSCRIBED</a><br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;where the author is&nbsp;<a href=\"http://.18.\" style=\"color: #800080\">BARRON,LUANNE</a><br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;where the visit location is&nbsp;<a href=\"http://.19.\" style=\"color: #800080\">GENERAL MEDICINE</a><br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;List only patients where NO DOCUMENTS meeting the above criteria were found.<br>Find Appointments/Visits<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;where the visit is for&nbsp;<a href=\"http://.20.\" style=\"color: #800080\">REPORT OF CONTACTS</a><br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;List only patients where NO VISITS meeting the above criteria were found.<br></body></html>";
//		System.out.println(model.getHTML(new Font("MS Sans Serif",Font.PLAIN,12)));
		assertEquals("HTMLQueryTextFactory.create failed:",actualResult,model.getHTML(new Font("MS Sans Serif",Font.PLAIN,12)));
	}

	/**
	 * @see junit.framework.TestCase#setUp()
	 */
	protected void setUp() throws Exception {
		super.setUp();
		testThread = Thread.currentThread();
	}

}
