package gov.va.med.hds.querytool.itest;

import java.util.logging.Handler;
import java.util.logging.LogRecord;
import java.util.logging.Logger;

import gov.va.med.hds.cd.daoregistry.IDaoRegistry;
import gov.va.med.hds.cd.runtime.IRuntimeContext;
import gov.va.med.hds.cd.runtime.itest.IntegrationTestRuntimeContextHolder;

/**
 * @author vhaislmonsos
 *
 */
public class MAbstractJFCTestCase extends AbstractJFCTestCase {
	IRuntimeContext runtime;
	IDaoRegistry daoRegistry;
	private TestHandler testHandler = new TestHandler();

	/**
	 * Constructor for MAbstractJFCTestCase.
	 * @param name
	 */
	public MAbstractJFCTestCase(String name) {
		super(name);
	}

	public static void main(String[] args) {
	}
	
	class TestHandler extends Handler {
		public void close() throws SecurityException {
		}
		public void flush() {
		}
		public void publish(LogRecord record) {
			fail(record.getMessage());
		}
	}

	/**
	 * @see junit.framework.TestCase#setUp()
	 */
	protected void setUp() throws Exception {
		super.setUp();
		Logger.getLogger(this.getName()).setUseParentHandlers(false);
		Logger.getLogger(this.getName()).addHandler(testHandler);
		runtime = IntegrationTestRuntimeContextHolder.getInstance();
		daoRegistry = (IDaoRegistry) runtime.getPluginInstance(IDaoRegistry.PLUGIN_ID);
	}

	protected void tearDown() throws Exception {
		super.tearDown();
		Logger.getLogger(this.getName()).removeHandler(testHandler);
	}

}
