package gov.va.med.hds.querytool.itest;

import gov.va.med.hds.cd.daoregistry.IDaoRegistry;
import gov.va.med.hds.cd.runtime.IRuntimeContext;
import gov.va.med.hds.cd.runtime.itest.IntegrationTestRuntimeContextHolder;
import gov.va.med.hds.cd.runtime.logging.IHandler;
import gov.va.med.hds.cd.runtime.logging.ILogRecord;
import gov.va.med.hds.cd.runtime.logging.ILogger;
import junit.framework.TestCase;

/**
 * Abstract M integration testcase class.
 */
public abstract class MAbstractTestCase extends TestCase {
	public IRuntimeContext runtime;
	public IDaoRegistry daoRegistry;
	private TestHandler testHandler = new TestHandler();

	/**
	 * Constructor for MAbstractTestCase.
	 * @param arg0
	 */
	public MAbstractTestCase(String arg0) {
		super(arg0);
	}

	class TestHandler implements IHandler {
		private ILogger logger;
		
		public void setLogger(ILogger logger) {
			this.logger = logger;
		}
		
		public void publish(ILogRecord logRecord) {
			fail(logRecord.getMessage());
		}

		public void close() {}
	}
	
	/**
	 * @see junit.framework.TestCase#setUp()
	 */
	protected void setUp() throws Exception {
		super.setUp();
		runtime = IntegrationTestRuntimeContextHolder.getInstance();
		runtime.getRootLogger().addHandler(testHandler);
		runtime.getRootLogger().setUseParentHandlers(false);
		daoRegistry = (IDaoRegistry)runtime.getPluginInstance(IDaoRegistry.PLUGIN_ID);
	}

	protected void tearDown() throws Exception {
		super.tearDown();
		runtime.getRootLogger().removeHandler(testHandler);
	}

}
