package gov.va.med.hds.querytool.itest;

import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import java.util.TreeMap;
import java.util.logging.Handler;
import java.util.logging.LogRecord;
import java.util.logging.Logger;

import junit.framework.TestCase;

import gov.va.med.hds.cd.daoregistry.IDaoRegistry;
import gov.va.med.hds.cd.runtime.IRuntimeContext;
import gov.va.med.hds.cd.runtime.itest.IntegrationTestRuntimeContextHolder;
import gov.va.med.hds.querytool.dao.IClinicRefDAO;
import gov.va.med.hds.querytool.dao.QueryDataDAOException;

/**
 * @author vhaislmonsos
 *
 * Jan 2, 2003 11:09:53 AM
 */
public class MClinicRefDAOTest extends TestCase {
	private IRuntimeContext runtime;
	private IDaoRegistry daoRegistry;
	private TestHandler testHandler = new TestHandler();
	private IClinicRefDAO clinicRefDAO;

	/**
	 * Constructor for MClinicRefDAOTest.
	 * @param arg0
	 */
	public MClinicRefDAOTest(String arg0) {
		super(arg0);
	}

	public static void main(String[] args) {
		junit.textui.TestRunner.run(MClinicRefDAOTest.class);
	}

	/**
	 * @see TestCase#setUp()
	 */
	protected void setUp() throws Exception {
		super.setUp();
		Logger.getLogger(MClinicRefDAOTest.class.getName()).setUseParentHandlers(false);
		Logger.getLogger(MClinicRefDAOTest.class.getName()).addHandler(testHandler);
		runtime = IntegrationTestRuntimeContextHolder.getInstance();
		daoRegistry = (IDaoRegistry) runtime.getPluginInstance(IDaoRegistry.PLUGIN_ID);
		clinicRefDAO = (IClinicRefDAO)daoRegistry.getDAO(IClinicRefDAO.class.getName());
	}
	
	public void testGet() throws QueryDataDAOException {
		Map clinics = new HashMap();
		clinics.put("5","");
		clinics.put("16","");
		TreeMap tree = clinicRefDAO.get(clinics);
		assertEquals("MClinicRefDAO.get failed:",2,clinics.size());
		assertEquals("MClinicRefDAO.get failed:",2,tree.size());
		Iterator it = clinics.keySet().iterator();
		String key = (String)it.next();
		String value = (String)clinics.get(key);
		assertEquals("MClinicRefDAO.get failed:","5",key);
		assertEquals("MClinicRefDAO.get failed:","ONCOLOGY",value);
		key = (String)it.next();
		value = (String)clinics.get(key);
		assertEquals("MClinicRefDAO.get failed:","16",key);
		assertEquals("MClinicRefDAO.get failed:","PULMONARY CLINIC",value);
	}

	class TestHandler extends Handler {
		public void close() throws SecurityException {
		}
		public void flush() {
		}
		public void publish(LogRecord record) {
			fail(record.getMessage());
		}
	}
	
}
