package gov.va.med.hds.querytool.itest;

import gov.va.med.hds.querytool.IQuery;
import gov.va.med.hds.querytool.QueryID;
import gov.va.med.hds.querytool.dao.IQueryDAO;
import gov.va.med.hds.querytool.dao.QueryDAOException;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;

/**
 * Tests for the M display field list DAO.
 */
public class MDisplayFieldListDAOTest extends MAbstractTestCase {
	private IQueryDAO queryDAO;
	private Thread thread;

	/**
	 * Constructor for MDisplayFieldListDAOTest.
	 * @param arg0
	 */
	public MDisplayFieldListDAOTest(String arg0) {
		super(arg0);
	}

	public static void main(String[] args) {
		junit.textui.TestRunner.run(MDisplayFieldListDAOTest.class);
	}

	/**
	 * @see TestCase#setUp()
	 */
	protected void setUp() throws Exception {
		super.setUp();
		queryDAO = (IQueryDAO)daoRegistry.getDAO(IQueryDAO.class.getName());
		thread = Thread.currentThread();
	}
	
	public void testGet() throws InterruptedException, QueryDAOException {
		final IQuery q = queryDAO.getAsync(new QueryID("88"),"test");
		q.addPropertyChangeListener(new PropertyChangeListener() {
			public void propertyChange(PropertyChangeEvent e) {
				if (q.getDisplayFields().size()>0) {
					synchronized(thread) {
						thread.notify();
					}
				}
			}
		});
		q.init();
		synchronized(thread) {
			thread.wait(5000);
		}
		assertEquals("MDisplayFieldListDAO failed:",4,q.getDisplayFields().size());
	}

}
