package gov.va.med.hds.querytool.itest;
import gov.va.med.hds.cd.daoregistry.IDaoRegistry;
import gov.va.med.hds.cd.runtime.IRuntimeContext;
import gov.va.med.hds.cd.runtime.itest.IntegrationTestRuntimeContextHolder;
import gov.va.med.hds.querytool.dao.IDocClassRefDAO;
import gov.va.med.hds.querytool.dao.QueryDataDAOException;
import java.util.Arrays;
import java.util.HashMap;
import java.util.Map;
import java.util.logging.Handler;
import java.util.logging.LogRecord;
import java.util.logging.Logger;

import junit.framework.TestCase;

/**
 * @author vhaislmonsos
 *
 * Dec 17, 2002 12:57:29 PM
 */
public class MDocClassRefDAOTest extends TestCase {
	private IRuntimeContext runtime;
	private IDaoRegistry daoRegistry;
	private TestHandler testHandler = new TestHandler();
	private IDocClassRefDAO docClassRefDAO;

	/**
	 * Constructor for MDocClassRefDAOTest.
	 * @param arg0
	 */
	public MDocClassRefDAOTest(String arg0) {
		super(arg0);
	}

	class TestHandler extends Handler {
		public void close() throws SecurityException {
		}
		public void flush() {
		}
		public void publish(LogRecord record) {
			fail(record.getMessage());
		}
	}
	
	public static void main(String[] args) {
		junit.textui.TestRunner.run(MDocClassRefDAOTest.class);
	}

	/**
	 * @see TestCase#setUp()
	 */
	protected void setUp() throws Exception {
		super.setUp();
		Logger.getLogger(MDocClassRefDAOTest.class.getName()).setUseParentHandlers(false);
		Logger.getLogger(MDocClassRefDAOTest.class.getName()).addHandler(testHandler);
		runtime = IntegrationTestRuntimeContextHolder.getInstance();
		daoRegistry = (IDaoRegistry) runtime.getPluginInstance(IDaoRegistry.PLUGIN_ID);
		docClassRefDAO = (IDocClassRefDAO)daoRegistry.getDAO(IDocClassRefDAO.class.getName());
	}

	public void testGet() throws QueryDataDAOException {
		Map docClass = new HashMap();
		docClassRefDAO.get(docClass);
		assertEquals("MDocClassRefDAO.get failed:",5,docClass.size());
		String[] values = (String[]) docClass.values().toArray(new String[0]);
		Arrays.sort(values);
		assertEquals("MDocClassRefDAO.get failed:","Clinical Procedures",values[0]);
		assertEquals("MDocClassRefDAO.get failed:","Rad/Nuc Med Reports",values[4]);
	}

}
