package gov.va.med.hds.querytool.itest;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.StringReader;

import gov.va.med.hds.querytool.IDetailReceivable;
import gov.va.med.hds.querytool.dao.IDocDetailDAO;
import gov.va.med.hds.querytool.dao.QueryDAOException;

/**
 * Tests the M implementation of the Document Detail DAO.
 */
public class MDocDetailDAOTest extends MAbstractTestCase {
	private IDocDetailDAO docDetailDAO;
	private String text;

	/**
	 * Constructor for MDocDetailDAOTest.
	 * @param arg0
	 */
	public MDocDetailDAOTest(String arg0) {
		super(arg0);
	}

	public static void main(String[] args) {
		junit.textui.TestRunner.run(MDocDetailDAOTest.class);
	}

	/**
	 * @see junit.framework.TestCase#setUp()
	 */
	protected void setUp() throws Exception {
		super.setUp();
		docDetailDAO = (IDocDetailDAO)daoRegistry.getDAO(IDocDetailDAO.class.getName());
	}
	
	public void testGetDetailRequest() throws QueryDAOException, InterruptedException, IOException {
		docDetailDAO.getDetailRequest("3003",new IDetailReceivable() {
			public void setDetail(String text) {
				MDocDetailDAOTest.this.text = text;
				synchronized(MDocDetailDAOTest.this) {
					MDocDetailDAOTest.this.notify();
				}
			}
		});
		synchronized(this) {
			this.wait(5000);
		}
		BufferedReader reader = new BufferedReader(new StringReader(text));
		int count = 0;
		while (reader.readLine()!=null) {
			count++;
		}
		assertEquals("MDocDetailDAOTest.getDetailRequest failed:",16,count);
	}

}
