package gov.va.med.hds.querytool.itest;

import gov.va.med.hds.cd.daoregistry.IDaoRegistry;
import gov.va.med.hds.cd.runtime.IRuntimeContext;
import gov.va.med.hds.cd.runtime.itest.IntegrationTestRuntimeContextHolder;
import gov.va.med.hds.querytool.dao.INameListDAO;
import gov.va.med.hds.querytool.dao.QueryDataDAOException;

import java.util.HashMap;
import java.util.Map;
import java.util.logging.Handler;
import java.util.logging.LogRecord;
import java.util.logging.Logger;

import junit.framework.TestCase;

/**
 * @author vhaislmonsos
 *
 * Dec 20, 2002 9:17:14 AM
 */
public class MNameListDAOTest extends TestCase {
	private IRuntimeContext runtime;
	private IDaoRegistry daoRegistry;
	private TestHandler testHandler = new TestHandler();
	private INameListDAO nameListDAO;

	/**
	 * Constructor for MNameListDAOTest.
	 * @param arg0
	 */
	public MNameListDAOTest(String arg0) {
		super(arg0);
	}

	public static void main(String[] args) {
		junit.textui.TestRunner.run(MNameListDAOTest.class);
	}

	/**
	 * @see TestCase#setUp()
	 */
	protected void setUp() throws Exception {
		super.setUp();
		Logger.getLogger(MNameListDAOTest.class.getName()).setUseParentHandlers(false);
		Logger.getLogger(MNameListDAOTest.class.getName()).addHandler(testHandler);
		runtime = IntegrationTestRuntimeContextHolder.getInstance();
		daoRegistry = (IDaoRegistry) runtime.getPluginInstance(IDaoRegistry.PLUGIN_ID);
		nameListDAO = (INameListDAO)daoRegistry.getDAO(INameListDAO.class.getName());
	}

	class TestHandler extends Handler {
		public void close() throws SecurityException {
		}
		public void flush() {
		}
		public void publish(LogRecord record) {
			fail(record.getMessage());
		}
	}
	
	/**
	 * @see junit.framework.TestCase#tearDown()
	 */
	protected void tearDown() throws Exception {
		super.tearDown();
		Logger.getLogger(MNameListDAOTest.class.getName()).removeHandler(testHandler);
	}

	public void testGet() throws QueryDataDAOException {
		Map map = new HashMap();
		map.put("10000000","10000000");
		map.put("200000000","200000000");
		nameListDAO.get(map);
		assertEquals("MNameListDAO.get failed:",0,map.size());
		map.clear();
		map.put("1","1");
		map.put("5","5");
		map.put("10","10");
		nameListDAO.get(map);
		assertEquals("MNameListDAO.get failed:",2,map.size());
		assertNull("MNameListDAO.get failed:",map.get("1"));
		assertEquals("MNameListDAO.get failed:","MALMROSE,CARY",map.get("5"));
		assertEquals("MNameListDAO.get failed:","BUECHLER,MELANIE",map.get("10"));
	}
	
}
