package gov.va.med.hds.querytool.itest;

import gov.va.med.hds.querytool.IDetailReceivable;
import gov.va.med.hds.querytool.dao.IOrderDetailDAO;
import gov.va.med.hds.querytool.dao.QueryDAOException;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.StringReader;

/**
 * Tests the M implementation of the Order detail DAO.
 */
public class MOrderDetailDAOTest extends MAbstractTestCase {
	private IOrderDetailDAO orderDetailDAO;
	private String detail;

	/**
	 * Constructor for MOrderDetailDAOTest.
	 * @param arg0
	 */
	public MOrderDetailDAOTest(String arg0) {
		super(arg0);
	}

	public static void main(String[] args) {
	}

	/**
	 * @see MAbstractTestCase#setUp()
	 */
	protected void setUp() throws Exception {
		super.setUp();
		orderDetailDAO = (IOrderDetailDAO)daoRegistry.getDAO(IOrderDetailDAO.class.getName());
	}

	public void testGetDetailRequest() throws QueryDAOException, InterruptedException, IOException {
		orderDetailDAO.getDetailRequest("7091655;1", new IDetailReceivable() {
			public void setDetail(String text) {
				detail = text;
				synchronized(MOrderDetailDAOTest.this) {
					MOrderDetailDAOTest.this.notify();
				}
			}
		});
		synchronized(this) {
			this.wait(5000);
		}
		BufferedReader reader = new BufferedReader(new StringReader(detail));
		int count = 0;
		while (reader.readLine()!=null) {
			count++;
		}
		assertEquals("MOrderDetailDAOTest.getDetailRequest failed:",3,count);
	}

}
