package gov.va.med.hds.querytool.itest;

import gov.va.med.hds.cd.daoregistry.IDaoRegistry;
import gov.va.med.hds.cd.runtime.IRuntimeContext;
import gov.va.med.hds.cd.runtime.itest.IntegrationTestRuntimeContextHolder;
import gov.va.med.hds.querytool.dao.IOrderItemRefDAO;
import gov.va.med.hds.querytool.dao.QueryDataDAOException;
import java.util.HashMap;
import java.util.Map;
import java.util.logging.Handler;
import java.util.logging.LogRecord;
import java.util.logging.Logger;

import junit.framework.TestCase;

/**
 * @author vhaislmonsos
 *
 * Dec 20, 2002 9:17:14 AM
 */
public class MOrderItemRefDAOTest extends TestCase {
	private IRuntimeContext runtime;
	private IDaoRegistry daoRegistry;
	private TestHandler testHandler = new TestHandler();
	private IOrderItemRefDAO orderItemRefDAO;

	/**
	 * Constructor for MNameListDAOTest.
	 * @param arg0
	 */
	public MOrderItemRefDAOTest(String arg0) {
		super(arg0);
	}

	public static void main(String[] args) {
		junit.textui.TestRunner.run(MOrderItemRefDAOTest.class);
	}

	/**
	 * @see TestCase#setUp()
	 */
	protected void setUp() throws Exception {
		super.setUp();
		Logger.getLogger(MOrderItemRefDAOTest.class.getName()).setUseParentHandlers(false);
		Logger.getLogger(MOrderItemRefDAOTest.class.getName()).addHandler(testHandler);
		runtime = IntegrationTestRuntimeContextHolder.getInstance();
		daoRegistry = (IDaoRegistry) runtime.getPluginInstance(IDaoRegistry.PLUGIN_ID);
		orderItemRefDAO = (IOrderItemRefDAO)daoRegistry.getDAO(IOrderItemRefDAO.class.getName());
	}

	class TestHandler extends Handler {
		public void close() throws SecurityException {
		}
		public void flush() {
		}
		public void publish(LogRecord record) {
			fail(record.getMessage());
		}
	}
	
	/**
	 * @see junit.framework.TestCase#tearDown()
	 */
	protected void tearDown() throws Exception {
		super.tearDown();
		Logger.getLogger(MNameListDAOTest.class.getName()).removeHandler(testHandler);
	}

	public void testGet() throws QueryDataDAOException {
		Map map = new HashMap();
		map.put("10000000","10000000");
		map.put("200000000","200000000");
		orderItemRefDAO.get(map);
		assertEquals("MOrderItemRefDAO.get failed:",0,map.size());
		map.clear();
		map.put("1","1");
		map.put("5","5");
		map.put("10","10");
		map.put("100000","100000");
		orderItemRefDAO.get(map);
		assertEquals("MOrderItemRefDAO.get failed:",3,map.size());
		assertNull("MOrderItemRefDAO.get failed: null value not returned.",map.get("100000"));
		assertEquals("MOrderItemRefDAO.get failed:","CISTERNOGRAM POS CONT S&I",map.get("5"));
		assertEquals("MOrderItemRefDAO.get failed:","EYE DETECTION FOREIGN BODY",map.get("10"));
	}
	
}
