package gov.va.med.hds.querytool.itest;

import gov.va.med.hds.cd.daoregistry.IDaoRegistry;
import gov.va.med.hds.cd.runtime.IRuntimeContext;
import gov.va.med.hds.cd.runtime.itest.IntegrationTestRuntimeContextHolder;
import gov.va.med.hds.querytool.dao.ITeamRefDAO;
import gov.va.med.hds.querytool.dao.QueryDataDAOException;
import java.util.HashMap;
import java.util.Map;
import java.util.TreeMap;
import java.util.logging.Handler;
import java.util.logging.LogRecord;
import java.util.logging.Logger;

import junit.framework.TestCase;

/**
 * @author vhaislmonsos
 *
 * Jan 9, 2003 8:59:59 AM
 */
public class MTeamRefDAOTest extends TestCase {
	private IRuntimeContext runtime;
	private IDaoRegistry daoRegistry;
	private TestHandler testHandler = new TestHandler();
	private ITeamRefDAO teamRefDAO;

	/**
	 * Constructor for MTeamRefDAOTest.
	 * @param arg0
	 */
	public MTeamRefDAOTest(String arg0) {
		super(arg0);
	}

	public static void main(String[] args) {
		junit.textui.TestRunner.run(MTeamRefDAOTest.class);
	}

	/**
	 * @see TestCase#setUp()
	 */
	protected void setUp() throws Exception {
		super.setUp();
		Logger.getLogger(MOrderItemRefDAOTest.class.getName()).setUseParentHandlers(false);
		Logger.getLogger(MOrderItemRefDAOTest.class.getName()).addHandler(testHandler);
		runtime = IntegrationTestRuntimeContextHolder.getInstance();
		daoRegistry = (IDaoRegistry) runtime.getPluginInstance(IDaoRegistry.PLUGIN_ID);
		teamRefDAO = (ITeamRefDAO)daoRegistry.getDAO(ITeamRefDAO.class.getName());
	}

	public void testGet() throws QueryDataDAOException {
		Map items = new HashMap();
		TreeMap sorted = teamRefDAO.get(items);
		assertEquals("MTeamRefDAO.get failed:",98,sorted.size());
		assertEquals("MTeamRefDAO.get failed:",98,items.size());
		Map.Entry item = (Map.Entry) sorted.entrySet().iterator().next();
		Object key = item.getKey();
		Map.Entry actualItem = (Map.Entry) item.getValue();
		assertEquals("MTeamRefDAO.get failed:",(String)key,actualItem.getValue().toString()+0x0+actualItem.getKey().toString());
		assertEquals("MTeamRefDAO.get failed:",actualItem.getValue(),items.get(actualItem.getKey()));
	}
	
	/**
	 * @see junit.framework.TestCase#tearDown()
	 */
	protected void tearDown() throws Exception {
		super.tearDown();
		Logger.getLogger(MNameListDAOTest.class.getName()).removeHandler(testHandler);
	}

	class TestHandler extends Handler {
		public void close() throws SecurityException {
		}
		public void flush() {
		}
		public void publish(LogRecord record) {
			fail(record.getMessage());
		}
	}
	

}
