/*
 * Initially Created on Apr 7, 2003 by vhaislmonsos
 *
 */
package gov.va.med.hds.querytool.itest;

import gov.va.med.hds.querytool.AbstractQueryList;
import gov.va.med.hds.querytool.IQueryList;
import gov.va.med.hds.querytool.ISoftListItem;
import gov.va.med.hds.querytool.QueryID;
import gov.va.med.hds.querytool.QueryListException;
import gov.va.med.hds.querytool.SoftListException;
import gov.va.med.hds.querytool.dao.IPredefinedQueryListDAO;
import gov.va.med.hds.querytool.dao.QueryDAOException;


/**
 * Tests for the M predefined queries list DAO.
 */
public class PredefinedQueryListDAOTest extends MAbstractTestCase {
	private IPredefinedQueryListDAO listDAO;

	public PredefinedQueryListDAOTest(String arg0) {
		super(arg0);
	}

	public static void main(String[] args) {
		junit.textui.TestRunner.run(PredefinedQueryListDAOTest.class);
	}

	protected void setUp() throws Exception {
		super.setUp();
		listDAO = (IPredefinedQueryListDAO)daoRegistry.getDAO(IPredefinedQueryListDAO.class.getName());
	}

	public void testRefresh_empty() throws QueryDAOException, InterruptedException {
		IQueryList preList = new AbstractQueryList();
		listDAO.refresh(preList);
		synchronized (Thread.currentThread()) {
			Thread.currentThread().wait(500);
		}
		assertEquals("PredefinedQueryListDAO.refresh failed:",5,preList.getSize());
		assertEquals("PredefinedQueryListDAO.refresh failed:","Abnormal Results",((ISoftListItem)preList.getItemAt(0)).getDisplayName());
		assertEquals("PredefinedQueryListDAO.refresh failed:","Consult Follow-up",((ISoftListItem)preList.getItemAt(1)).getDisplayName());
		assertEquals("PredefinedQueryListDAO.refresh failed:","Incomplete Orders",((ISoftListItem)preList.getItemAt(2)).getDisplayName());
		assertEquals("PredefinedQueryListDAO.refresh failed:","Recent Activity",((ISoftListItem)preList.getItemAt(3)).getDisplayName());
		assertEquals("PredefinedQueryListDAO.refresh failed:","Scheduled/Due Activity",((ISoftListItem)preList.getItemAt(4)).getDisplayName());
	}

	public void testRefresh_add() throws QueryDAOException, InterruptedException, QueryListException {
		IQueryList preList = new AbstractQueryList();
		listDAO.refresh(preList);
		synchronized (Thread.currentThread()) {
			Thread.currentThread().wait(500);
		}
		preList.removeElementAt(2);
		preList.removeElementAt(2);
		listDAO.refresh(preList);
		synchronized (Thread.currentThread()) {
			Thread.currentThread().wait(500);
		}
		assertEquals("PredefinedQueryListDAO.refresh failed:",5,preList.getSize());
		assertEquals("PredefinedQueryListDAO.refresh failed:","Abnormal Results",((ISoftListItem)preList.getItemAt(0)).getDisplayName());
		assertEquals("PredefinedQueryListDAO.refresh failed:","Consult Follow-up",((ISoftListItem)preList.getItemAt(1)).getDisplayName());
		assertEquals("PredefinedQueryListDAO.refresh failed:","Incomplete Orders",((ISoftListItem)preList.getItemAt(2)).getDisplayName());
		assertEquals("PredefinedQueryListDAO.refresh failed:","Recent Activity",((ISoftListItem)preList.getItemAt(3)).getDisplayName());
		assertEquals("PredefinedQueryListDAO.refresh failed:","Scheduled/Due Activity",((ISoftListItem)preList.getItemAt(4)).getDisplayName());
	}

	public void testRefresh_delete() throws QueryDAOException, InterruptedException, SoftListException, QueryListException {
		IQueryList preList = new AbstractQueryList();
		listDAO.refresh(preList);
		synchronized (Thread.currentThread()) {
			Thread.currentThread().wait(500);
		}
		preList.addElement(new QueryID("fred"), "fred query");
		preList.addElement(new QueryID("jane"), "jane query");
		listDAO.refresh(preList);
		synchronized (Thread.currentThread()) {
			Thread.currentThread().wait(500);
		}
		assertEquals("PredefinedQueryListDAO.refresh failed:",5,preList.getSize());
		assertEquals("PredefinedQueryListDAO.refresh failed:","Abnormal Results",((ISoftListItem)preList.getItemAt(0)).getDisplayName());
		assertEquals("PredefinedQueryListDAO.refresh failed:","Consult Follow-up",((ISoftListItem)preList.getItemAt(1)).getDisplayName());
		assertEquals("PredefinedQueryListDAO.refresh failed:","Incomplete Orders",((ISoftListItem)preList.getItemAt(2)).getDisplayName());
		assertEquals("PredefinedQueryListDAO.refresh failed:","Recent Activity",((ISoftListItem)preList.getItemAt(3)).getDisplayName());
		assertEquals("PredefinedQueryListDAO.refresh failed:","Scheduled/Due Activity",((ISoftListItem)preList.getItemAt(4)).getDisplayName());
	}

}
