/*
 * Initially Created on Jul 30, 2003 by vhaislmonsos
 *
 */
package gov.va.med.hds.querytool.itest;

import gov.va.med.hds.cd.daoregistry.IDaoRegistry;
import gov.va.med.hds.cd.runtime.IRuntimeContext;
import gov.va.med.hds.querytool.ExecutionException;
import gov.va.med.hds.querytool.IAvailableColumnsList;
import gov.va.med.hds.querytool.IDetailReceivable;
import gov.va.med.hds.querytool.IDisplayField;
import gov.va.med.hds.querytool.IPatDetailReceivable;
import gov.va.med.hds.querytool.IQuery;
import gov.va.med.hds.querytool.IQueryToolState;
import gov.va.med.hds.querytool.IRunListener;
import gov.va.med.hds.querytool.IRunQuery;
import gov.va.med.hds.querytool.ISensitiveDataModel;
import gov.va.med.hds.querytool.dao.ICompleteQueryDataDAO;
import gov.va.med.hds.querytool.dao.IQueryDAO;
import gov.va.med.hds.querytool.dao.QueryDAOException;
import gov.va.med.hds.querytool.state.QueryExecuteMain;
import gov.va.med.hds.querytool.ui.IResultsTable;

import java.util.Date;

import javax.swing.event.ListDataListener;
import javax.swing.event.TableModelListener;

/**
 * Tests for the QueryExecuteMain state.
 */
public class QueryExecuteMainTest extends MAbstractTestCase implements IRunQuery,IResultsTable,IAvailableColumnsList {
	private IQueryToolState state;
	private IDaoRegistry daoReg;

	public QueryExecuteMainTest(String name) {
		super(name);
	}

	public static void main(String[] args) {
		junit.textui.TestRunner.run(QueryExecuteMainTest.class);
	}

	protected void setUp() throws Exception {
		super.setUp();
		state = new QueryExecuteMain();
		state.setRuntime(runtime);
		daoReg = (IDaoRegistry)runtime.getPluginInstance(IDaoRegistry.PLUGIN_ID);
	}

	public void testSetRunModel() {
		state.setRunModel(this);
		assertEquals("QueryExecuteMain.getRunModel failed:",this,state.getRunModel());
	}

	public void testSetException() {
		Throwable error = new QueryDAOException("test exception");
		state.setException(error);
		assertEquals("QueryExecuteMain.getException failed:",error,state.getException());
	}

	public void testSetMessage() {
		String message = "high their";
		state.setMessage(message);
		assertEquals("QueryExecuteMain.getMessage failed:",message,state.getMessage());
	}

	public void testSetQueryDAO() throws Exception {
		IQueryDAO queryDAO = (IQueryDAO)daoReg.getDAO(IQueryDAO.class.getName());
		state.setQueryDAO(queryDAO);
		assertNull("QueryExecuteMain failed: null expected.",state.getQueryDAO());
	}

	public void testSetResultsTable() {
		state.setResultsTable(this);
		assertNull("QueryExecuteMain.getResults failed: null expected.",state.getResults());
	}

	public void testGetSensitiveMessage() {
		assertNull("QueryExecuteMain failed: null expected.",state.getSensitiveMessage());
	}

	public void testSetSensitivePatientList() {
		assertNull("QueryExecuteMain failed: null expected.",state.getSensitivePatientList());
	}

	public void testSetAvailableColumnList() {
		state.setAvailableColumnList(this);
		assertNull("QueryExecuteMain failed: null expected.",state.getAvailableColumnList());
	}

	public void setQuery(IQuery query) {}
	public void setRuntime(IRuntimeContext runtime) {}
	public int getRowCount() {return 0;}
	public int getScreenedCount() {return 0;}
	public int getPatientCount() {return 0;}
	public boolean isRunning() {return false;}
	public void runQuery() {}
	public void stopQuery() {}
	public void addRunListener(IRunListener listener) {}
	public void removeRunListener(IRunListener listener) {}
	public ExecutionException getException() {return null;}
	public void setMaxRows(int maxRows) {}
	public void resumeFromPause() {}
	public ISensitiveDataModel getSensitiveDataModel() {return null;}
	public ICompleteQueryDataDAO getCompleteQueryDataDAO() {return null;}
	public Date getStartDate() {return null;}
	public void clear() {}
	public void setSortColumn(int columnPosition, int direction) throws QueryDAOException {}
	public int getSortColumnPosition() {return 0;}
	public int getSortDirection() {return 0;}
	public void reset() throws QueryDAOException {}
	public void setSortColumn(IDisplayField field, boolean ascending) throws QueryDAOException {}
	public void setDAOModel(ICompleteQueryDataDAO completeQueryDataDAO) {}
	public void getDetailRequest(int row, IDetailReceivable detailReceivable) {}
	public void getPatientDetailRequest(int row, IPatDetailReceivable patDetailReceivable) {}
	public void clearModels() {}
	public int getColumnCount() {return 0;}
	public String getColumnName(int columnIndex) {return null;}
	public Class getColumnClass(int columnIndex) {return null;}
	public boolean isCellEditable(int rowIndex, int columnIndex) {return false;}
	public Object getValueAt(int rowIndex, int columnIndex) {return null;}
	public void setValueAt(Object aValue, int rowIndex, int columnIndex) {}
	public void addTableModelListener(TableModelListener l) {}
	public void removeTableModelListener(TableModelListener l) {}
	public void addListDataListener(ListDataListener listener) {}
	public void removeListDataListener(ListDataListener listener) {}
	public IDisplayField get(int index) {return null;}
	public int size() {return 0;}
	public void setModel(IQuery query) {}
	public int indexOf(IDisplayField field) {return 0;}
	public IDisplayField getMutable(int index) {return null;}

}
