package gov.va.med.hds.querytool.itest;

import gov.va.med.hds.querytool.dao.QueryDAOException;
import gov.va.med.hds.querytool.ui.EnablePanel;
import gov.va.med.hds.querytool.ui.IQueryPanelItems;
import gov.va.med.hds.querytool.ui.ITagComponent;
import gov.va.med.hds.querytool.ui.QueryPanelFactory;

import java.awt.HeadlessException;
import java.util.Iterator;
import java.util.List;

import javax.swing.JFrame;
import javax.swing.JPanel;

import junit.extensions.jfcunit.JFCTestHelper;

/**
 * @author vhaislmonsos
 *
 * Jan 24, 2003 10:51:58 AM
 */
public class QueryPanelFactoryJFCTest extends AbstractJFCTestCase {
	private QueryPanelFactory factory;

	/**
	 * Constructor for QueryPanelFactoryJFCTest.
	 */
	public QueryPanelFactoryJFCTest() {
		super();
	}

	/**
	 * Constructor for QueryPanelFactoryJFCTest.
	 * @param arg0
	 */
	public QueryPanelFactoryJFCTest(String arg0) {
		super(arg0);
	}

	/**
	 * @see junit.framework.TestCase#setUp()
	 */
	protected void setUp() throws Exception {
		super.setUp();
		factory = new QueryPanelFactory();
	}
	
	public void testInitializeButtons() throws QueryDAOException {
		factory.getPanels();
		ITagComponent button = (ITagComponent)factory.getButtonMap().get("1010500");
		button.setSelected(true);
		button = (ITagComponent)factory.getButtonMap().get("4000500");
		button.setSelected(true);
		button = (ITagComponent)factory.getButtonMap().get("2012000");
		button.setSelected(true);
		factory.initializeCheckGroups();
		for (Iterator i = factory.getButtons().iterator(); i.hasNext();) {
			ITagComponent b = (ITagComponent)i.next();
			if (b.getText().equals("Type of Order")) {
				assertTrue("QueryPanelFactory.initializeCheckGroups failed: check box group not property initialized.",b.isSelected());
				break;
			}
		}
	}
	
	public void testGetPanels() throws QueryDAOException {
		List panels = factory.getPanels();
		factory.initializeCheckGroups();
		doTest(panels, 0);
		doTest(panels, 1);
		doTest(panels, 2);
		doTest(panels, 3);
		doTest(panels, 4);
	}

	private void doTest(List panels, int num) throws HeadlessException {
		JFCTestHelper.disposeWindow(frame,this);
		frame = new JFrame("Panel");
		JPanel panel = ((IQueryPanelItems)panels.get(num)).getPanel();
		frame.getContentPane().add(panel);
		frame.pack();
		frame.show();
		flushAWT();
		EnablePanel ePanel = (EnablePanel)JFCTestHelper.findComponent(EnablePanel.class, frame.getContentPane(), 0);
		assertNotNull("QueryPanelFactory.getPanels failed: panel #" + Integer.toString(num) + " not found.",ePanel);
	}

}
