package gov.va.med.hds.querytool.itest;

import gov.va.med.hds.querytool.IQueryTool;

/**
 * Tests for the main query tool plugin.
 */
public class QueryToolTest extends MAbstractTestCase {
	private IQueryTool queryTool;
	
	/**
	 * Constructor for QueryToolTest.
	 * @param arg0
	 */
	public QueryToolTest(String arg0) {
		super(arg0);
	}

	public static void main(String[] args) {
		junit.textui.TestRunner.run(QueryToolTest.class);
	}

	/**
	 * @see junit.framework.TestCase#setUp()
	 */
	protected void setUp() throws Exception {
		super.setUp();
		queryTool = (IQueryTool)runtime.getPluginInstance(IQueryTool.PLUGIN_ID);
	}
	
	public void testDefault() {
		assertNull("QueryTool.getCurrentQuery failed: null expected.",queryTool.getCurrentQuery());
		assertNull("QueryTool.getError failed: null expected.",queryTool.getError());
		assertNull("QueryTool.getMessage failed: null expected.",queryTool.getMessage());
	}
	
	public void testGetCollection() {
		assertNotNull("QueryTool.getQueryCollection failed: null not expected",queryTool.getQueryCollection());
		assertEquals("QueryTool.getQueryCollection size failed:",7,queryTool.getQueryCollection().getSize());
	}
	
	public void testAvailableActions() {
		assertNotNull("QueryTool.getQueryAction failed: null returned.",queryTool.getQueryAction(IQueryTool.CREATE_ACTION));
		assertNotNull("QueryTool.getQueryAction failed: null returned.",queryTool.getQueryAction(IQueryTool.DELETE_ACTION));
		assertNotNull("QueryTool.getQueryAction failed: null returned.",queryTool.getQueryAction(IQueryTool.DELETE_CONFIRMED_ACTION));
		assertNotNull("QueryTool.getQueryAction failed: null returned.",queryTool.getQueryAction(IQueryTool.EDIT_ACTION));
		assertNotNull("QueryTool.getQueryAction failed: null returned.",queryTool.getQueryAction(IQueryTool.EDIT_CANCEL_ACTION));
		assertNotNull("QueryTool.getQueryAction failed: null returned.",queryTool.getQueryAction(IQueryTool.EDIT_COMPLETE_NOSAVE_ACTION));
		assertNotNull("QueryTool.getQueryAction failed: null returned.",queryTool.getQueryAction(IQueryTool.EDIT_COMPLETE_SAVE_ACTION));
		assertNotNull("QueryTool.getQueryAction failed: null returned.",queryTool.getQueryAction(IQueryTool.EDIT_PARM_ACTION));
		assertNotNull("QueryTool.getQueryAction failed: null returned.",queryTool.getQueryAction(IQueryTool.EDIT_PARM_COMPLETE_ACTION));
		assertNotNull("QueryTool.getQueryAction failed: null returned.",queryTool.getQueryAction(IQueryTool.EXPORT_ACTION));
		assertNotNull("QueryTool.getQueryAction failed: null returned.",queryTool.getQueryAction(IQueryTool.HOME_ACTION));
		assertNotNull("QueryTool.getQueryAction failed: null returned.",queryTool.getQueryAction(IQueryTool.PRINT_ACTION));
		assertNotNull("QueryTool.getQueryAction failed: null returned.",queryTool.getQueryAction(IQueryTool.RENAME_ACTION));
		assertNotNull("QueryTool.getQueryAction failed: null returned.",queryTool.getQueryAction(IQueryTool.RUN_ACTION));
		assertNotNull("QueryTool.getQueryAction failed: null returned.",queryTool.getQueryAction(IQueryTool.RUN_COMPLETE_ACTION));
		assertNotNull("QueryTool.getQueryAction failed: null returned.",queryTool.getQueryAction(IQueryTool.RUN_COMPLETE_ERROR_ACTION));
		assertNotNull("QueryTool.getQueryAction failed: null returned.",queryTool.getQueryAction(IQueryTool.RUN_COMPLETE_MESSAGE_ACTION));
		assertNotNull("QueryTool.getQueryAction failed: null returned.",queryTool.getQueryAction(IQueryTool.RUN_COMPLETE_NON_SENSITIVE_ACTION));
		assertNotNull("QueryTool.getQueryAction failed: null returned.",queryTool.getQueryAction(IQueryTool.RUN_CONTINUE_ACTION));
		assertNotNull("QueryTool.getQueryAction failed: null returned.",queryTool.getQueryAction(IQueryTool.SAVEAS_ACTION));
		assertNotNull("QueryTool.getQueryAction failed: null returned.",queryTool.getQueryAction(IQueryTool.SAVEAS_CONFIRMED_ACTION));
		assertNotNull("QueryTool.getQueryAction failed: null returned.",queryTool.getQueryAction(IQueryTool.SELECT_ACTION));
		assertNotNull("QueryTool.getQueryAction failed: null returned.",queryTool.getQueryAction(IQueryTool.SELECT_ALL_ACTION));
		assertNotNull("QueryTool.getQueryAction failed: null returned.",queryTool.getQueryAction(IQueryTool.SELECT_NONE_ACTION));
		assertNotNull("QueryTool.getQueryAction failed: null returned.",queryTool.getQueryAction(IQueryTool.SELECT_SENSITIVE_ACTION));
		assertNotNull("QueryTool.getQueryAction failed: null returned.",queryTool.getQueryAction(IQueryTool.SORT_COLUMN_ACTION));
		assertNotNull("QueryTool.getQueryAction failed: null returned.",queryTool.getQueryAction(IQueryTool.STOP_ACTION));
		assertNotNull("QueryTool.getQueryAction failed: null returned.",queryTool.getQueryAction(IQueryTool.UNSELECT_ACTION));
	}
}
