/*
 * Initially Created on Apr 14, 2003 by vhaislmonsos
 *
 */
package gov.va.med.hds.querytool.itest;

import gov.va.med.hds.querytool.IDisplayField;
import gov.va.med.hds.querytool.IQuery;
import gov.va.med.hds.querytool.IValue;
import gov.va.med.hds.querytool.QueryID;
import gov.va.med.hds.querytool.QueryUtil;
import gov.va.med.hds.querytool.dao.IQueryDAO;
import gov.va.med.hds.querytool.types.ITypeFactory;
import gov.va.med.hds.querytool.types.TypeFactory;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

/**
 * Test the query utilities collection QueryUtil.
 */
public class QueryUtilTest extends MAbstractTestCase {

	/**
	 * Constructor for QueryUtilTest.
	 * @param arg0
	 */
	public QueryUtilTest(String arg0) {
		super(arg0);
	}

	public static void main(String[] args) {
		junit.textui.TestRunner.run(QueryUtilTest.class);
	}

	protected void setUp() throws Exception {
		super.setUp();
	}

	public void testCopyContents() throws Exception {
		IQueryDAO queryDAO = (IQueryDAO)daoRegistry.getDAO(IQueryDAO.class.getName());
		IQuery oldQuery = queryDAO.getSync(new QueryID("88"));
		IQuery newQuery = queryDAO.getNew(null);
		ITypeFactory typeFactory = new TypeFactory(runtime);
		QueryUtil.copyContents(oldQuery, newQuery, typeFactory);
		
		assertEquals("QueryUtil.copyContents failed:","Everything Report",newQuery.getDisplayName());
		assertEquals("QueryUtil.copyContents failed:",4,newQuery.getDisplayFields().size());
		IDisplayField field = (IDisplayField)newQuery.getDisplayFields().get(0);
		assertEquals("QueryUtil.copyContents failed:","Name",field.getDisplayText());
		field = (IDisplayField)newQuery.getDisplayFields().get(3);
		assertEquals("QueryUtil.copyContents failed:","Ward",field.getDisplayText());
		List list = new ArrayList();
		for (Iterator i = newQuery.getConstraints().iterator(); i.hasNext();) {
			list.add(i.next());
		}
		assertEquals("QueryUtil.copyContents failed:",31,list.size());
		assertEquals("QueryUtil.copyContents failed:","1",((IValue)list.get(0)).getEditorID());
		assertEquals("QueryUtil.copyContents failed:","Patient.ListSource",((IValue)list.get(0)).getConstraintName());
		
		assertEquals("QueryUtil.copyContents failed:","12",((IValue)list.get(30)).getEditorID());
		assertEquals("QueryUtil.copyContents failed:","Visit.NegativeSearch",((IValue)list.get(30)).getConstraintName());
		assertEquals("QueryUtil failed: test data not set up.",4,oldQuery.getConstraints().getDisplayFieldTypes().size());
		assertNotNull("QueryUtil.copyContents failed: null displayFieldCategory.",((IValue)list.get(0)).getDisplayFieldCategory());
	}

}
