/*
 * Initially Created on Jun 9, 2003 by vhaislmonsos
 *
 */
package gov.va.med.hds.querytool.itest;

import gov.va.med.hds.querytool.IQuery;
import gov.va.med.hds.querytool.QueryID;
import gov.va.med.hds.querytool.dao.IMainRunDAO;
import gov.va.med.hds.querytool.dao.IQueryDAO;
import gov.va.med.hds.querytool.dao.QueryDAOException;

import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;

/**
 * 
 */
public class RunMainIterationTest extends MAbstractTestCase {
	private IMainRunDAO mainRunDAO;
	private IQuery query;
	private IQueryDAO queryDAO;

	/**
	 * Constructor for RunMainIterationTest.
	 * @param name
	 */
	public RunMainIterationTest(String name) {
		super(name);
	}

	public static void main(String[] args) {
		junit.textui.TestRunner.run(RunMainIterationTest.class);
	}

	protected void setUp() throws Exception {
		super.setUp();
		queryDAO = (IQueryDAO)daoRegistry.getDAO(IQueryDAO.class.getName());
		mainRunDAO = (IMainRunDAO)daoRegistry.getDAO(IMainRunDAO.class.getName());
	}

	public void testGetIteratorCall() throws QueryDAOException, InterruptedException {
		mainRunDAO.setInitialIterator("");
		query = queryDAO.getAsync(new QueryID("88"),"blaaaah");
		query.addPropertyChangeListener(new PropertyChangeListener() {
			public void propertyChange(PropertyChangeEvent e) {
				synchronized(RunMainIterationTest.this) {
					RunMainIterationTest.this.notify();
				}
			}
		});
		query.init();
		synchronized(this) {
			this.wait(5000);
		}
		
		while (!mainRunDAO.isReportFinished()) {
			mainRunDAO.getNextIteration();
		}

	}

}
