/*
 * Created on Jun 9, 2003 by vhaislmonsos
 */
package gov.va.med.hds.querytool.itest;

import gov.va.med.hds.querytool.IQuery;
import gov.va.med.hds.querytool.QueryID;
import gov.va.med.hds.querytool.dao.IQueryDAO;
import gov.va.med.hds.querytool.dao.IRunSetupDAO;
import gov.va.med.hds.querytool.dao.QueryDAOException;

import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;

/**
 * 
 */
public class RunSetupDAOTest extends MAbstractTestCase {
	private IQuery query;
	private IQueryDAO queryDAO;
	private IRunSetupDAO runSetupDAO;

	/**
	 * @param arg0
	 */
	public RunSetupDAOTest(String arg0) {
		super(arg0);
	}

	public static void main(String[] args) {
		junit.textui.TestRunner.run(RunSetupDAOTest.class);
	}
	
	protected void setUp() throws Exception {
		super.setUp();
		queryDAO = (IQueryDAO)daoRegistry.getDAO(IQueryDAO.class.getName());
		runSetupDAO = (IRunSetupDAO)daoRegistry.getDAO(IRunSetupDAO.class.getName());
	}

	public void testSetupQuery() throws QueryDAOException, InterruptedException {
		query = queryDAO.getAsync(new QueryID("88"),"blaaaah");
		query.addPropertyChangeListener(new PropertyChangeListener() {
			public void propertyChange(PropertyChangeEvent e) {
				synchronized(RunSetupDAOTest.this) {
					RunSetupDAOTest.this.notify();
				}
			}
		});
		query.init();
		synchronized(this) {
			this.wait(5000);
		}
		
		runSetupDAO.setQuery(query);
		
		assertEquals("RunSetupDAO.setQuery failed:","r:VA HEPC:1;10;0",runSetupDAO.getIterator());
	}
	
}
