/*
 * Initially Created on Jul 30, 2003 by vhaislmonsos
 *
 */
package gov.va.med.hds.querytool.itest;

import gov.va.med.hds.cd.runtime.IConfigurationElement;
import gov.va.med.hds.cd.runtime.IRuntimeContext;
import gov.va.med.hds.querytool.IAvailableColumnsList;
import gov.va.med.hds.querytool.ICombinedQueryCollection;
import gov.va.med.hds.querytool.IDisplayField;
import gov.va.med.hds.querytool.IQuery;
import gov.va.med.hds.querytool.IQueryCollectionListener;
import gov.va.med.hds.querytool.IQueryID;
import gov.va.med.hds.querytool.IQueryToolState;
import gov.va.med.hds.querytool.ISoftListItem;
import gov.va.med.hds.querytool.Query;
import gov.va.med.hds.querytool.QueryCollectionException;
import gov.va.med.hds.querytool.QueryID;
import gov.va.med.hds.querytool.dao.IQueryDAO;
import gov.va.med.hds.querytool.dao.QueryDAOException;
import gov.va.med.hds.querytool.state.SelectAndEdit;

import java.util.List;

import javax.swing.event.ListDataListener;

/**
 * Tests for the query SelectAndEdit state
 */
public class SelectAndEditTest extends MAbstractTestCase implements IQueryDAO,ICombinedQueryCollection,IAvailableColumnsList {
	private IQueryToolState state;
	private boolean isTest1;
	private boolean isTest2;

	public SelectAndEditTest(String name) {
		super(name);
	}

	public static void main(String[] args) {
		junit.textui.TestRunner.run(SelectAndEditTest.class);
	}

	protected void setUp() throws Exception {
		super.setUp();
		state = new SelectAndEdit(runtime);
	}

	public void testSetCurrentQuery() {
		state.setAvailableColumnList(this);
		IQuery q = new Query(new QueryID("whatever"),null);
		isTest1 = true;
		state.setCurrentQuery(q);
		isTest1 = false;
		
		isTest2 = true;
		state.setCurrentQuery(null);
		isTest2 = false;
	}

	public void testGetQueryDAO() {
		state.setQueryDAO(this);
		assertEquals("SelectAndEdit.getQueryDAO failed:",this,state.getQueryDAO());
	}

	public void testGetQueryCollection() throws InterruptedException {
		state.setQueryDAO(this);
		state.reset();
		synchronized (Thread.currentThread()) {
			Thread.currentThread().wait(200);
		}
		assertNotNull("SelectAndEdit.getQueryCollection failed:",state.getQueryCollection());
	}

	public void testGetAvailableColumnList() {
		state.setAvailableColumnList(this);
		assertEquals("SelectAndEdit.getAvailableColumnList failed:",this,state.getAvailableColumnList());
	}

	public void setQuery(IQuery query) {}
	public void clearQuery(IQuery query) {}
	public IQuery getAsync(IQueryID queryID, String displayText) throws QueryDAOException {return null;}
	public IQuery getNew(String displayText) throws QueryDAOException {return null;}
	public IQuery getSync(IQueryID queryID) throws QueryDAOException {return null;}
	public void save(IQuery query) throws QueryDAOException {}
	public boolean delete(IQueryID queryID) throws QueryDAOException {return false;}
	public List getReportStrings(IQuery query) {return null;}
	
	public void setInitializationData(IRuntimeContext runtime, IConfigurationElement config, String propertyName, Object data) throws Exception {}
	public void addChangeListener(IQueryCollectionListener l) {}
	public boolean containsDisplayName(String displayName) {return false;}
	public ISoftListItem getUserQueryItem(int index) {return null;}
	public ISoftListItem getPredefinedQueryItem(int index) {return null;}
	public boolean isPredefinedItem(ISoftListItem item) {return false;}
	public boolean isUserQuery(ISoftListItem item) {return false;}
	public void reloadChangedQuery(ISoftListItem item) throws QueryCollectionException {}
	public void removeChangeListener(IQueryCollectionListener l) {}
	public void removeUserItem(ISoftListItem item) throws QueryCollectionException {}
	public void setQueryDAO(IQueryDAO queryDAO) {}
	public int getSize() {return 0;}
	public int getUserDefinedQuerySize() {return 0;}
	public int getPredefinedQuerySize() {return 0;}
	public boolean isQueryItem(Object item) {return false;}
	public IQuery getQuery(Object item) throws QueryCollectionException {return null;}
	public void saveQuery(IQuery query) throws QueryCollectionException {}
	public void refresh() throws QueryCollectionException {}
	public void addQueryWithoutSave(IQuery query) throws QueryCollectionException {}
	public boolean isPredefinedQuery(IQuery query) {return false;}
	public void removeUserQuery(IQuery query) throws QueryCollectionException {}
	
	public void addListDataListener(ListDataListener listener) {}
	public void removeListDataListener(ListDataListener listener) {}
	public IDisplayField get(int index) {return null;}
	public int size() {return 0;}
	public void setModel(IQuery query) {
		if (isTest1) {
			assertNotNull("SelectAndEdit.setCurrentQuery failed: query is null.",query);
		}
		if (isTest2) {
			assertNull("SelectAndEdit.setCurrentQuery failed: query is not null.",query);
		}
	}
	public void setRuntime(IRuntimeContext runtime) {}
	public int indexOf(IDisplayField field) {return 0;}
	public IDisplayField getMutable(int index) {return null;}

}
