/*
 * Initially Created on Apr 7, 2003 by vhaislmonsos
 *
 */
package gov.va.med.hds.querytool.itest;

import gov.va.med.hds.querytool.AbstractQueryList;
import gov.va.med.hds.querytool.IQueryList;
import gov.va.med.hds.querytool.ISoftListItem;
import gov.va.med.hds.querytool.QueryID;
import gov.va.med.hds.querytool.QueryListException;
import gov.va.med.hds.querytool.SoftListException;
import gov.va.med.hds.querytool.dao.IUserQueryListDAO;
import gov.va.med.hds.querytool.dao.QueryDAOException;


/**
 * Tests for the M user query list DAO.
 */
public class UserQueryListDAOTest extends MAbstractTestCase {
	private IUserQueryListDAO userQueryListDAO;

	public UserQueryListDAOTest(String arg0) {
		super(arg0);
	}

	public static void main(String[] args) {
		junit.textui.TestRunner.run(UserQueryListDAOTest.class);
	}

	protected void setUp() throws Exception {
		super.setUp();
		userQueryListDAO = (IUserQueryListDAO)daoRegistry.getDAO(IUserQueryListDAO.class.getName());
	}

	public void testRefresh_empty() throws QueryDAOException, InterruptedException {
		IQueryList userList = new AbstractQueryList();
		userQueryListDAO.refresh(userList);
		synchronized (Thread.currentThread()) {
			Thread.currentThread().wait(1000);
		}
		assertEquals("UserQueryListDAO.refresh failed:",2,userList.getSize());
		assertEquals("UserQueryListDAO.refresh failed:","Everything Report",((ISoftListItem)userList.getItemAt(0)).getDisplayName());
		assertEquals("UserQueryListDAO.refresh failed:","There and Back Again",((ISoftListItem)userList.getItemAt(1)).getDisplayName());
	}
	
	public void testRefresh_add() throws QueryDAOException, InterruptedException, QueryListException {
		IQueryList userList = new AbstractQueryList();
		userQueryListDAO.refresh(userList);
		synchronized (Thread.currentThread()) {
			Thread.currentThread().wait(1000);
		}
		userList.removeElementAt(0);
		userQueryListDAO.refresh(userList);
		synchronized (Thread.currentThread()) {
			Thread.currentThread().wait(1000);
		}
		assertEquals("UserQueryListDAO.refresh failed:",2,userList.getSize());
		assertEquals("UserQueryListDAO.refresh failed:","Everything Report",((ISoftListItem)userList.getItemAt(0)).getDisplayName());
		assertEquals("UserQueryListDAO.refresh failed:","There and Back Again",((ISoftListItem)userList.getItemAt(1)).getDisplayName());
	}

	public void testRefresh_delete() throws QueryDAOException, InterruptedException, SoftListException, QueryListException {
		IQueryList userList = new AbstractQueryList();
		userQueryListDAO.refresh(userList);
		synchronized (Thread.currentThread()) {
			Thread.currentThread().wait(1000);
		}
		userList.addElement(new QueryID("fred"), "fred query");
		userQueryListDAO.refresh(userList);
		synchronized (Thread.currentThread()) {
			Thread.currentThread().wait(1000);
		}
		assertEquals("UserQueryListDAO.refresh failed:",2,userList.getSize());
		assertEquals("UserQueryListDAO.refresh failed:","Everything Report",((ISoftListItem)userList.getItemAt(0)).getDisplayName());
		assertEquals("UserQueryListDAO.refresh failed:","There and Back Again",((ISoftListItem)userList.getItemAt(1)).getDisplayName());
	}

}
