package gov.va.med.hds.querytool.test;

import gov.va.med.hds.querytool.itest.AbstractQueryListTest;
import junit.framework.Test;
import junit.framework.TestSuite;

/**
 * Querytool test suite, to test items the generally don't involve the DAO.
 */
public class AllTests {

	public static void main(String[] args) {
		junit.textui.TestRunner.run(AllTests.class);
	}

	public static Test suite() {
		TestSuite suite =
			new TestSuite("Test for gov.va.med.hds.querytool.tests");
		//$JUnit-BEGIN$
		suite.addTest(new TestSuite(ConstraintTest.class));
		suite.addTest(new TestSuite(CriteriaItemTest.class));
		suite.addTest(new TestSuite(DisplayFieldListTest.class));
		suite.addTest(new TestSuite(DisplayFieldTest.class));
		suite.addTest(new TestSuite(HTMLSelectionModelTest.class));
		suite.addTest(new TestSuite(HTMLTest.class));
		suite.addTest(new TestSuite(MDatetimeTest.class));
		suite.addTest(new TestSuite(MockMBufferListDAOTest.class));
		suite.addTest(new TestSuite(MockMClinicianListDAOFactoryTest.class));
		suite.addTest(new TestSuite(MockMConstraintDAOTest.class));
		suite.addTest(new TestSuite(MockMDisplayFieldListDAOTest.class));
		suite.addTest(new TestSuite(MockMDisplayGroupTreeDAOTest.class));
		suite.addTest(new TestSuite(MockMDocClassRefDAOTest.class));
		suite.addTest(new TestSuite(MockMDocStatusListDAOTest.class));
		suite.addTest(new TestSuite(MockMNameListDAOTest.class));
		suite.addTest(new TestSuite(MockMOrderSigStatusListDAOTest.class));
		suite.addTest(new TestSuite(MockMOrderStatusListDAOTest.class));
		suite.addTest(new TestSuite(MockMQueryDAOTest.class));
		suite.addTest(new TestSuite(QueryIDTest.class));
		suite.addTest(new TestSuite(QueryTest.class));
		suite.addTest(new TestSuite(DateRangeTest.class));
		suite.addTest(new TestSuite(ColumnListModelTest.class));
		suite.addTest(new TestSuite(QueryListItemTest.class));
		suite.addTest(new TestSuite(AbstractQueryListTest.class));
		suite.addTest(new TestSuite(EventToStateFactoryTest.class));
		suite.addTest(new TestSuite(SaveResultsTest.class));
		suite.addTest(new TestSuite(RunQueryTest.class));
		suite.addTest(new TestSuite(SensitiveDataModelTest.class));
		suite.addTest(new TestSuite(SensitiveListTest.class));
		suite.addTest(new TestSuite(StateFactoryTest.class));
		//$JUnit-END$
		suite.addTest(gov.va.med.hds.querytool.types.test.AllTests.suite());
		suite.addTest(gov.va.med.hds.querytool.ui.test.AllTests.suite());
		suite.addTest(gov.va.med.hds.querytool.ui.types.test.AllTests.suite());
		return suite;
	}

}
