package gov.va.med.hds.querytool.test;

import gov.va.med.hds.querytool.Constraint;
import gov.va.med.hds.querytool.IConstraint;
import gov.va.med.hds.querytool.IValue;
import gov.va.med.hds.querytool.types.Empty;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import junit.framework.TestCase;

/**
 * @author vhaislmonsos
 *
 * Oct 30, 2002 9:07:17 AM
 */
public class ConstraintTest extends TestCase {
	private IConstraint pi = null;
	
	/**
	 * Constructor for ConstraintTest.
	 * @param name
	 */
	public ConstraintTest(String name) {
		super(name);
	}

	public static void main(String[] args) {
		junit.textui.TestRunner.run(ConstraintTest.class);
	}

	/**
	 * @see TestCase#setUp()
	 */
	protected void setUp() throws Exception {
		super.setUp();
		pi = new Constraint();
	}
	
	public void testGet() {
		assertNotNull("Constraint is null.",pi);
	}
	
	public void testClearTag() {
		IConstraint c = new Constraint();
		c.addRelationship("0=1000500");
		c.addRelationship("0=1001000");
		c.addRelationship("0=1500500");
		c.addRelationship("0=2000500");
		c.addRelationship("0=3000500");
		c.addRelationship("0=4000500");
		c.addRelationship("0=5000500");
		c.clearAll();
		IValue v1 = new Empty();
		v1.setID("0");
		IValue v2 = new Empty();
		v2.setID("1000500");
		c.addValue(v1);
		c.addValue(v2);
		assertNotNull("Constraint.addValue failed:",c.getCriterion("1000500"));
		List list = new ArrayList();
		c.getSetTags(list);
		assertEquals("Constraint.createChildValue failed:",2,list.size());
		c.clearTag("0");
		list.clear();
		c.getSetTags(list);
		assertEquals("Constraint.createChildValue failed:",0,list.size());
//		assertNull("Constraint.createChildValue failed: value found.",c.getChildCriterion("0",0));
//		assertNull("Constraint.createChildValue failed: value found.",c.getChildCriterion("1000500",0));
	}

	public void testGetDisplayFieldTypes() {
		IConstraint c = new Constraint();
		c.addRelationship("0=1000500");
		c.addRelationship("0=1001000");
		c.addRelationship("0=1500500");
		c.addRelationship("0=2000500");
		c.addRelationship("0=3000500");
		c.addRelationship("0=4000500");
		c.addRelationship("0=5000500");
		IValue v1 = new Empty();
		v1.setID("0");
		IValue v2 = new Empty();
		v2.setID("1000500");
		c.addValue(v1);
		c.addValue(v2);
		v1.setConstraintName("fred.one");
		v1.setDisplayFieldCategory("fred");
		v2.setConstraintName("jill.two");
		v2.setDisplayFieldCategory("jill");
		String[] strings = (String[]) c.getDisplayFieldTypes().toArray(new String[0]);
		Arrays.sort(strings);
		assertEquals("Constraint.getDisplayFieldTypes failed:","fred",strings[0]);
		assertEquals("Constraint.getDisplayFieldTypes failed:","jill",strings[1]);
	}
	
}
