package gov.va.med.hds.querytool.test;

import gov.va.med.hds.querytool.*;

import junit.framework.*;

/**
 * @author vhaislmonsos
 *
 * Oct 30, 2002 10:01:20 AM
 */
public class DisplayFieldTest extends TestCase {

	private IDisplayField displayField = new DisplayField();

	/**
	 * Constructor for DisplayFieldTest.
	 * @param name
	 */
	public DisplayFieldTest(String name) {
		super(name);
	}

	/**
	 * @see TestCase#setUp()
	 */
	protected void setUp() throws Exception {
		super.setUp();
		displayField.setColumnWidth(20);
		displayField.setID("Test.Column");
		displayField.setDisplayText("This is a test column");
	}

	public static void main(String[] args) {
		junit.textui.TestRunner.run(DisplayFieldTest.class);
	}

	public void testSetGetColumnWidth() {
		assertEquals("DisplayField.setColumnWidth or getColumnWidth failed:",20,displayField.getColumnWidth());
	}

	public void testSetID() {
		assertEquals("DisplayField.setID or getID failed:","Test.Column",displayField.getID());
	}

	public void testSetText() {
		assertEquals("DisplayField.setDisplayText or getDisplayText failed:","This is a test column",displayField.getDisplayText());
	}

	public void testEquals() {
		IDisplayField df1 = new DisplayField();
		df1.setDisplayText("wewe");
		df1.setID(new String("Disp.Name"));
		IDisplayField df2 = new DisplayField();
		df2.setDisplayText("wowo");
		df2.setID(new String("Disp.Name"));
		assertTrue("DisplayField.equals failed:",df1.equals(df2));
		assertTrue("DisplayField.equals failed:",df2.equals(df1));
	}

}
