package gov.va.med.hds.querytool.test;

import gov.va.med.hds.cd.spectrum.linkpanel.HTML;

import junit.framework.TestCase;

/**
 * @author vhaislmonsos
 *
 * Nov 20, 2002 11:07:38 AM
 */
public class HTMLTest extends TestCase {

	/**
	 * Constructor for HTMLTest.
	 * @param arg0
	 */
	public HTMLTest(String arg0) {
		super(arg0);
	}

	public static void main(String[] args) {
		junit.textui.TestRunner.run(HTMLTest.class);
	}
	
	public void testSpaces() {
		assertEquals("HTML.spaces failed:","",HTML.spaces(0));
		assertEquals("HTML.spaces failed:","&nbsp;",HTML.spaces(1));
		assertEquals("HTML.spaces failed:","&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;",HTML.spaces(5));
		assertEquals("HTML.spaces failed:","&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;",HTML.spaces(10));
	}

	public void testEncode() {
		String s = "><&;s";
		String x = "<meta name=\"keywords\" content=\"template,VDSI,VISTA,Architecture,COTS,Interface Engine,dotNET,.NET,Migration,VISTA Data Systems &amp; Integration\">";
		assertEquals("HTML.encode failed:","&gt;&lt;&amp;;s",HTML.encode(s));
		assertEquals("HTML.encode failed:","&lt;meta name=\"keywords\" content=\"template,VDSI,VISTA,Architecture,COTS,Interface Engine,dotNET,.NET,Migration,VISTA Data Systems &amp;amp; Integration\"&gt;",HTML.encode(x));
		assertEquals("HTML.encode failed; it corrupted the original string:","<meta name=\"keywords\" content=\"template,VDSI,VISTA,Architecture,COTS,Interface Engine,dotNET,.NET,Migration,VISTA Data Systems &amp; Integration\">",x);
	}
	
	public void testDecode() {
		String s = "&gt;&lt;&amp;;s";
		String x = "&lt;meta name=\"keywords\" content=\"template,VDSI,VISTA,Architecture,COTS,Interface Engine,dotNET,.NET,Migration,VISTA Data Systems &amp;amp; Integration\"&gt;";
		assertEquals("HTML.decode failed:","><&;s",HTML.decode(s));
		assertEquals("HTML.decode failed:","<meta name=\"keywords\" content=\"template,VDSI,VISTA,Architecture,COTS,Interface Engine,dotNET,.NET,Migration,VISTA Data Systems &amp; Integration\">",HTML.decode(x));
		assertEquals("HTML.decode failed: it corrupted the original string:","&lt;meta name=\"keywords\" content=\"template,VDSI,VISTA,Architecture,COTS,Interface Engine,dotNET,.NET,Migration,VISTA Data Systems &amp;amp; Integration\"&gt;",x);
	}
}
