package gov.va.med.hds.querytool.test;

import gov.va.med.hds.querytool.dao.formatter.IFormatter;


/**
 * @author vhaislmonsos
 *
 * Feb 20, 2003 1:05:56 PM
 */
public class MDatetimeTest extends MAbstractTestCase {
	private IFormatter orderDateTimeFormatter;
	private IFormatter visitDateTimeFormatter;

	/**
	 * Constructor for MDatetimeTest.
	 * @param arg0
	 */
	public MDatetimeTest(String arg0) {
		super(arg0);
	}

	public static void main(String[] args) {
		junit.textui.TestRunner.run(MDatetimeTest.class);
	}

	public void testFormat() {
		String datetime = "3020731.221000";
		assertEquals("MDatetime.format failed:","07/31/02 22:10",orderDateTimeFormatter.format(datetime));
		assertEquals("MDatetime.format failed:","07/31/02 22:10",visitDateTimeFormatter.format(datetime));
	}
	
	public void testNullOrEmpty() {
		String datetime = "";
		assertEquals("MDatetime.format failed:","",orderDateTimeFormatter.format(datetime));
		assertEquals("MDatetime.format failed:","",visitDateTimeFormatter.format(datetime));
		datetime = null;
		assertNull("MDatetime.format failed: Null expected.",orderDateTimeFormatter.format(datetime));
		assertNull("MDatetime.format failed: Null expected.",visitDateTimeFormatter.format(datetime));
	}

	/**
	 * @see junit.framework.TestCase#setUp()
	 */
	protected void setUp() throws Exception {
		super.setUp();
		orderDateTimeFormatter = (IFormatter)daoRegistry.getDAO(IFormatter.PROJECT_PREFIX + ".order.IDatetime");
		visitDateTimeFormatter = (IFormatter)daoRegistry.getDAO(IFormatter.PROJECT_PREFIX + ".visit.IDatetime");
	}

}
