package gov.va.med.hds.querytool.test;

import java.util.Map;
import java.util.TreeMap;

import gov.va.med.hds.cd.runtime.IConfigurationElement;
import gov.va.med.hds.cd.runtime.IRuntimeContext;
import gov.va.med.hds.querytool.dao.INameValuePairDAO;
import gov.va.med.hds.querytool.dao.QueryDataDAOException;
import gov.va.med.hds.util.mumps.StringUtil;

/**
 * @author vhaislmonsos
 *
 * Dec 19, 2002 5:39:17 PM
 */
public abstract class MockMAbstractNameValueDAO implements INameValuePairDAO {
	private TreeMap sortedMap = new TreeMap();

	/**
	 * @see gov.va.med.hds.querytool.INameValuePairDAO#get(Map)
	 */
	public abstract TreeMap get(Map items) throws QueryDataDAOException;

	protected TreeMap getSortedMap() {
		return sortedMap;
	}
	
	/**
	 * @see gov.va.med.hds.cd.daoregistry.IDataAccessObject#init(IRuntimeContext)
	 */
	public void setInitializationData(
		IRuntimeContext runtime,
		IConfigurationElement config,
		String propertyName, Object data)
		throws Exception {
	}

	/**
	 * @see gov.va.med.hds.querytool.INameValuePairDAO#getKey()
	 */
	public Object getKey(Object item) throws QueryDataDAOException {
		return StringUtil.piece(item.toString(),'^',1);
	}

	/**
	 * @see gov.va.med.hds.querytool.INameValuePairDAO#getValue()
	 */
	public Object getValue(Object item) throws QueryDataDAOException {
		return StringUtil.piece(item.toString(),'^',2);
	}
	
}
