package gov.va.med.hds.querytool.test;

import gov.va.med.hds.cd.m.ICallQueue;
import gov.va.med.hds.cd.spectrum.longlist.DataNeededEvent;
import gov.va.med.hds.cd.spectrum.longlist.DataProviderException;
import gov.va.med.hds.cd.spectrum.longlist.IBufferModel;
import gov.va.med.hds.cd.spectrum.longlist.IDataNeededListener;
import gov.va.med.hds.querytool.m.IMBufferListCall;

/**
 * Mock m buffer list DAO implementation.
 */
public class MockMBufferListDAO implements IDataNeededListener {
	private static final String NEWPERS_RPC_KEY = "NEWPERS";
	public static final int FORWARD_DIRECTION = 1;
	public static final int REVERSE_DIRECTION = 1;
	private ICallQueue queue;
	private IMBufferListCall mBufferListCall;
	private MockSharedBroker sharedBroker = new MockSharedBroker();
	private IBufferModel bufferModel;
	private Object filter;
	
	/**
	 * Constructor for MBufferListDAO.
	 */
	private MockMBufferListDAO() {
		super();
		sharedBroker.setCallString(NEWPERS_RPC_KEY);
	}
	
	/**
	 * Method MBufferListDAO.
	 * @param call
	 */
	public MockMBufferListDAO(IMBufferListCall call, ICallQueue queue) {
		this();
		mBufferListCall = call;
		this.queue = queue;
	}

	/**
	 * Returns the mBufferListCall.
	 * @return IMBufferListCall
	 */
	public IMBufferListCall getMBufferListCall() {
		return mBufferListCall;
	}

	/**
	 * Sets the mBufferListCall.
	 * @param mBufferListCall The mBufferListCall to set
	 */
	public void setMBufferListCall(IMBufferListCall mBufferListCall) {
		this.mBufferListCall = mBufferListCall;
	}

	/**
	 * @see gov.va.med.hds.cd.spectrum.IDataNeededListener#getData(DataNeededEvent)
	 */
	public void getDataRequest(DataNeededEvent dataNeededEvent)
		throws DataProviderException {
	}

	/**
	 * @see gov.va.med.hds.cd.spectrum.IDataNeededListener#setBufferModel(IBufferModel)
	 */
	public void setBufferModel(IBufferModel bufferModel) {
		this.bufferModel = bufferModel;
	}

	/**
	 * @see gov.va.med.hds.cd.spectrum.IDataNeededListener#setFilter(String)
	 */
	public void setFilter(Object filter) {
		this.filter = filter;
	}

}
