package gov.va.med.hds.querytool.test;

import gov.va.med.hds.cd.daoregistry.IDaoRegistry;
import gov.va.med.hds.cd.runtime.test.RuntimeTestCase;
import gov.va.med.hds.cd.spectrum.longlist.BufferModelException;
import gov.va.med.hds.cd.spectrum.longlist.IDataNeededListener;
import gov.va.med.hds.querytool.dao.IClinicianListDAOFactory;

/**
 * @author vhaislmonsos
 *
 * Dec 18, 2002 5:13:41 PM
 */
public class MockMClinicianListDAOFactoryTest extends RuntimeTestCase {
	private IClinicianListDAOFactory clinicianListDAOFactory;

	/**
	 * Constructor for MockMClinicianListDAOTest.
	 * @param arg0
	 */
	public MockMClinicianListDAOFactoryTest(String arg0) {
		super(arg0);
	}

	public static void main(String[] args) {
		junit.textui.TestRunner.run(MockMClinicianListDAOFactoryTest.class);
	}

	/**
	 * @see TestCase#setUp()
	 */
	protected void setUp() throws Exception {
		super.setUp();
		parseRegistryResource("QueryToolTest.xml");
		IDaoRegistry daoRegistry = (IDaoRegistry) getRuntime().getPluginInstance(IDaoRegistry.PLUGIN_ID);
		clinicianListDAOFactory = (IClinicianListDAOFactory)daoRegistry.getDAO(IClinicianListDAOFactory.class.getName());
	}
	
	public void testGetBufferModelDAO() throws BufferModelException {
		IDataNeededListener listener = clinicianListDAOFactory.getBufferModelDAO();
		assertNotNull("MockMClinicianListDAOFactory.getBufferModelDAO failed: null item returned.",listener);
	}

}
