package gov.va.med.hds.querytool.test;

import gov.va.med.hds.cd.runtime.IConfigurationElement;
import gov.va.med.hds.cd.runtime.IRuntimeContext;
import gov.va.med.hds.querytool.DisplayField;
import gov.va.med.hds.querytool.IDisplayField;
import gov.va.med.hds.querytool.IDisplayFieldList;
import gov.va.med.hds.querytool.IQuery;
import gov.va.med.hds.querytool.dao.IDisplayFieldListDAO;
import gov.va.med.hds.querytool.dao.QueryDAOException;
import gov.va.med.hds.util.mumps.NameValuePair;

/**
 * @author vhaislmonsos
 *
 * Nov 1, 2002 2:48:30 PM
 */
public class MockMDisplayFieldListDAO implements IDisplayFieldListDAO {
	private IRuntimeContext runtime;

	/**
	 * Constructor for MDisplayFieldListDAO.
	 */
	public MockMDisplayFieldListDAO() {
		super();
	}

	/**
	 * @see gov.va.med.hds.cd.daoregistry.IDataAccessObject#init(IRuntimeContext)
	 */
	public void setInitializationData(
		IRuntimeContext runtime,
		IConfigurationElement config,
		String propertyName, Object data) {
		this.runtime = runtime;
	}

	/**
	 * @see gov.va.med.hds.querytool.dao.IDisplayFieldListDAO#get(IDisplayFieldList, String[])
	 */
	public void get(IQuery query, String[] alist) {
		if (alist == null) {
			return;
		}
		for (int i = 0; i < alist.length; i++) {
			NameValuePair nvp1 = new NameValuePair(alist[i]);
			if (nvp1.getLeft().compareTo("ColumnName") == 0) {
				IDisplayField df = new DisplayField();
				NameValuePair nvp2 = new NameValuePair(alist[++i]);
				NameValuePair nvp3 = new NameValuePair(alist[++i]);
				df.setID(nvp1.getRight());
				df.setDisplayText(nvp2.getRight());
				df.setColumnWidth(Integer.parseInt(nvp3.getRight()));
				query.getDisplayFields().add(df);
			}
		}
	}

	/**
	 * @see gov.va.med.hds.querytool.dao.IDisplayFieldListDAO#getDefaults(IDisplayFieldList, String[])
	 */
	public void getDefaults(IDisplayFieldList displayList) throws QueryDAOException {
		String[] lines = MockSharedBroker.getDisplayData();
		IDisplayField field = null;
		NameValuePair item = null;
		String[] samples = null;
		int num = 0;
		for (int i = 0; i < lines.length; i++) {
			item = new NameValuePair(lines[i]);
			if (item.getLeft().equals("DisplayName")) {
				if (field != null) {
					field.setSampleData(samples);
					displayList.add(field);
				}
				field = new DisplayField();
				samples = new String[2];
				num = 0;
				field.setListDisplayName(item.getRight());
			} else if (item.getLeft().equals("InternalName")) {
				field.setID(item.getRight());
			} else if (item.getLeft().equals("HeaderName")) {
				field.setDisplayText(item.getRight());
			} else if (item.getLeft().equals("SortType")) {
				field.setSortType(item.getRight());
			} else if (item.getLeft().equals("SampleData")) {
				samples[num] = item.getRight();
				num++;
			}
		}
	}

}
