package gov.va.med.hds.querytool.test;

import gov.va.med.hds.cd.daoregistry.IDaoRegistry;
import gov.va.med.hds.cd.runtime.test.RuntimeTestCase;
import gov.va.med.hds.querytool.IDisplayField;
import gov.va.med.hds.querytool.IQuery;
import gov.va.med.hds.querytool.Query;
import gov.va.med.hds.querytool.QueryID;
import gov.va.med.hds.querytool.dao.IDisplayFieldListDAO;
import gov.va.med.hds.querytool.dao.QueryDAOException;

/**
 * @author vhaislmonsos
 *
 * Nov 1, 2002 2:49:08 PM
 */
public class MockMDisplayFieldListDAOTest extends RuntimeTestCase {
	private IDisplayFieldListDAO dflDAO = null;
	private IQuery query;
	
	/**
	 * Constructor for MockMDisplayFieldListDAOTest.
	 * @param name
	 */
	public MockMDisplayFieldListDAOTest(String name) {
		super(name);
	}

	public static void main(String[] args) {
		junit.textui.TestRunner.run(MockMDisplayFieldListDAOTest.class);
	}

	/**
	 * @see TestCase#setUp()
	 */
	protected void setUp() throws Exception {
		super.setUp();
		parseRegistryResource("QueryToolTest.xml");
		IDaoRegistry daoRegistry = (IDaoRegistry) getRuntime().getPluginInstance(IDaoRegistry.PLUGIN_ID);
		dflDAO = (IDisplayFieldListDAO)daoRegistry.getDAO(IDisplayFieldListDAO.class.getName());
		query = new Query(new QueryID("77"),null);
	}

	public void testGet() throws QueryDAOException {
		String[] stringList = new String[12];
		stringList[0] = new String("Document.Cosigner");
		stringList[1] = new String("ColumnName=Document.Cosigner");
		stringList[2] = new String("ColumnHeader=Expected Cosigner");
		stringList[3] = new String("ColumnWidth=80");
		stringList[4] = new String("ColumnName=Document.Reference");
		stringList[5] = new String("ColumnHeader=Note Date/Time");
		stringList[6] = new String("ColumnWidth=80");
		stringList[7] = new String("ColumnWidth=80");
		stringList[8] = new String("ColumnHeader=Note Date/Time");
		stringList[9] = new String("ColumnName=Document.Setting");
		stringList[10] = new String("ColumnHeader=Settings ");
		stringList[11] = new String("ColumnWidth=79");
		dflDAO.get(query,stringList);

		IDisplayField df = query.getDisplayFields().get(2);
		assertNotNull("MDisplayFieldListDAO failed: null pointer not expected.",df);
		assertEquals("MDisplayFieldListDAO returned incorrect data:","Document.Setting",df.getID());
		assertEquals("MDisplayFieldListDAO returned incorrect data:","Settings ",df.getDisplayText());
		assertEquals("MDisplayFieldListDAO returned incorrect data:",79,df.getColumnWidth());
	}

}
