package gov.va.med.hds.querytool.test;

import java.util.HashMap;
import java.util.Map;

import gov.va.med.hds.cd.daoregistry.IDaoRegistry;
import gov.va.med.hds.cd.runtime.test.RuntimeTestCase;
import gov.va.med.hds.querytool.dao.IDocClassRefDAO;
import gov.va.med.hds.querytool.dao.QueryDataDAOException;

/**
 * @author vhaislmonsos
 *
 * Dec 17, 2002 12:21:06 PM
 */
public class MockMDocClassRefDAOTest extends RuntimeTestCase {
	private IDocClassRefDAO oslDAO;
	/**
	 * Constructor for MockMDocClassRefDAOTest.
	 * @param arg0
	 */
	public MockMDocClassRefDAOTest(String arg0) {
		super(arg0);
	}

	public static void main(String[] args) {
		junit.textui.TestRunner.run(MockMDocClassRefDAOTest.class);
	}

	public void testGet() throws QueryDataDAOException {
		Map itemList = new HashMap();
		oslDAO.get(itemList);
		assertEquals("MockMDocClassRefDAO.get failed:",5,itemList.size());
		assertTrue("MockMDocClassRefDAO.get failed: key item not found.",itemList.containsKey("3"));
		assertTrue("MockMDocClassRefDAO.get failed: key item not found.",itemList.containsKey("964"));
		assertTrue("MockMDocClassRefDAO.get failed: key item not found.",itemList.containsKey("1143"));
		assertEquals("MockMDocClassRefDAO.get failed:","Progress Notes",(String)itemList.get("3"));
		assertEquals("MockMDocClassRefDAO.get failed:","Rad/Nuc Med Reports",(String)itemList.get("964"));
		assertEquals("MockMDocClassRefDAO.get failed:","Clinical Procedures",(String)itemList.get("1143"));
		
	}
	
	/**
	 * @see junit.framework.TestCase#setUp()
	 */
	protected void setUp() throws Exception {
		super.setUp();
		parseRegistryResource("QueryToolTest.xml");
		IDaoRegistry daoRegistry = (IDaoRegistry) getRuntime().getPluginInstance(IDaoRegistry.PLUGIN_ID);
		oslDAO = (IDocClassRefDAO)daoRegistry.getDAO(IDocClassRefDAO.class.getName());
	}

}
