package gov.va.med.hds.querytool.test;

import gov.va.med.hds.querytool.dao.IDocStatusListDAO;
import gov.va.med.hds.querytool.dao.QueryDataDAOException;
import gov.va.med.hds.querytool.m.Entry;

import java.util.Map;
import java.util.TreeMap;

/**
 * @author vhaislmonsos
 *
 * Dec 17, 2002 12:10:29 PM
 */
public class MockMDocStatusListDAO extends MockMAbstractNameValueDAO implements IDocStatusListDAO {
	private TreeMap tree;
	
	public MockMDocStatusListDAO() {
		super();
		tree = getSortedMap();
	}

	/**
	 * Method callBroker.
	 */
	private String callBroker() {
		String items = "11^ACTIVE\n" +
						"8^AMENDED\n" +
						"7^COMPLETED\n" +
						"14^DELETED\n" +
						"13^INACTIVE\n" +
						"9^PURGED\n" +
						"15^RETRACTED\n" +
						"10^TEST\n" +
						"6^UNCOSIGNED\n" +
						"1^UNDICTATED\n" +
						"3^UNRELEASED\n" +
						"5^UNSIGNED\n" +
						"2^UNTRANSCRIBED\n" +
						"4^UNVERIFIED\n";
		return items;
	}


	/**
	 * @see gov.va.med.hds.querytool.MAbstractNameValueDAO#getResults()
	 */
	public TreeMap get(Map items) throws QueryDataDAOException {
		String result = callBroker();
		String[] r = result.split("\\n");
		for (int i=0;i<r.length;i++) {
			Object key = getKey(r[i]);
			Object value = getValue(r[i]);
			items.put(key,value);
			tree.put(value.toString()+key.toString(),new Entry(key,value));
		}
		return tree;
	}

}
