package gov.va.med.hds.querytool.test;

import java.util.HashMap;
import java.util.Map;

import gov.va.med.hds.cd.daoregistry.IDaoRegistry;
import gov.va.med.hds.cd.runtime.test.RuntimeTestCase;
import gov.va.med.hds.querytool.dao.IDocStatusListDAO;
import gov.va.med.hds.querytool.dao.QueryDataDAOException;

/**
 * @author vhaislmonsos
 *
 * Dec 17, 2002 12:24:45 PM
 */
public class MockMDocStatusListDAOTest extends RuntimeTestCase {
	private IDocStatusListDAO oslDAO;
	
	/**
	 * Constructor for MockMDocStatusListDAOTest.
	 * @param arg0
	 */
	public MockMDocStatusListDAOTest(String arg0) {
		super(arg0);
	}

	public static void main(String[] args) {
		junit.textui.TestRunner.run(MockMDocStatusListDAOTest.class);
	}

	public void testGet() throws QueryDataDAOException {
		Map itemList = new HashMap();
		oslDAO.get(itemList);
		assertEquals("MockMDocStatusListDAO.get failed:",14,itemList.size());
		assertTrue("MockMDocStatusListDAO.get failed: key item not found.",itemList.containsKey("10"));
		assertTrue("MockMDocStatusListDAO.get failed: key item not found.",itemList.containsKey("4"));
		assertTrue("MockMDocStatusListDAO.get failed: key item not found.",itemList.containsKey("11"));
		assertEquals("MockMDocStatusListDAO.get failed:","UNVERIFIED",(String)itemList.get("4"));
		assertEquals("MockMDocStatusListDAO.get failed:","ACTIVE",(String)itemList.get("11"));
		assertEquals("MockMDocStatusListDAO.get failed:","TEST",(String)itemList.get("10"));
		
	}
	/**
	 * @see junit.framework.TestCase#setUp()
	 */
	protected void setUp() throws Exception {
		super.setUp();
		parseRegistryResource("QueryToolTest.xml");
		IDaoRegistry daoRegistry = (IDaoRegistry) getRuntime().getPluginInstance(IDaoRegistry.PLUGIN_ID);

		oslDAO = (IDocStatusListDAO)daoRegistry.getDAO(IDocStatusListDAO.class.getName());
	}

}
