package gov.va.med.hds.querytool.test;

import gov.va.med.hds.querytool.dao.INameListDAO;
import gov.va.med.hds.querytool.dao.QueryDataDAOException;
import gov.va.med.hds.querytool.m.Entry;
import gov.va.med.hds.util.mumps.StringUtil;
import java.util.Iterator;
import java.util.Map;
import java.util.TreeMap;

/**
 * @author vhaislmonsos
 *
 * Dec 19, 2002 4:12:12 PM
 */
public class MockMNameListDAO extends MockMAbstractNameValueDAO implements INameListDAO {
	private TreeMap tree;
	
	public MockMNameListDAO() {
		super();
		tree = super.getSortedMap();
	}

	/**
	 * @see gov.va.med.hds.querytool.MAbstractNameValueDAO#getResults(Map)
	 */
	public TreeMap get(Map items) throws QueryDataDAOException {
		Iterator it = items.keySet().iterator();
		StringBuffer result = new StringBuffer();
		while (it.hasNext()) {
			String key = (String)it.next();
			if (key.equals("1")) {
				result.append("12^1^Fred Man\n");
			}
			else if (key.equals("2")) {
				result.append("13^2^Jill dude\n");
			}
			else if (key.equals("3")) {
				result.append("14^3^Marmaduke\n");
			}
			else if (key.equals("4")) {
				result.append("15^4^Charles Emmerson Winchester\n");
			}
			else if (key.equals("5")) {
				result.append("16^5^The Third\n");
			}
			else if (key.equals("6")) {
				result.append("17^6^Twice and again\n");
			}
			else if (key.equals("7")) {
				result.append("18^7^I have to see\n");
			}
			else if (key.equals("8")) {
				result.append("19^8^This is test data\n");
			}
			else if (key.equals("9")) {
				result.append("20^9^I hate test data\n");
			}
			else if (key.equals("10")) {
				result.append("21^10^Do you want some more test data?\n");
			}
			else {
				result.append("^" + key + "^+" + key + "+\n");
			}
		}
		items.clear();
		if (result.length()>0) {
			String[] results = result.toString().split("\\n");
			for (int i=0;i<results.length;i++) {
				String key = getKey(results[i]).toString();
				String value = getValue(results[i]).toString();
				items.put(key,value);
				tree.put(value+key,new Entry(key,value));
			}
		}
		return tree;
	}
	
	public Object getKey(Object text) {
		return StringUtil.piece(text.toString(),'^',2);
	}

	public Object getValue(Object text) {
		return StringUtil.piece(text.toString(),'^',3);
	}

}
