package gov.va.med.hds.querytool.test;

import java.util.HashMap;
import java.util.Map;

import gov.va.med.hds.cd.daoregistry.IDaoRegistry;
import gov.va.med.hds.cd.runtime.test.RuntimeTestCase;
import gov.va.med.hds.querytool.dao.INameListDAO;
import gov.va.med.hds.querytool.dao.QueryDataDAOException;

/**
 * @author vhaislmonsos
 *
 * Dec 19, 2002 5:46:33 PM
 */
public class MockMNameListDAOTest extends RuntimeTestCase {
	private INameListDAO nameListDAO;
	
	/**
	 * Constructor for MockMNameListDAOTest.
	 * @param arg0
	 */
	public MockMNameListDAOTest(String arg0) {
		super(arg0);
	}

	public static void main(String[] args) {
		junit.textui.TestRunner.run(MockMNameListDAOTest.class);
	}

	/**
	 * @see TestCase#setUp()
	 */
	protected void setUp() throws Exception {
		super.setUp();
		parseRegistryResource("QueryToolTest.xml");
		IDaoRegistry daoRegistry = (IDaoRegistry) getRuntime().getPluginInstance(IDaoRegistry.PLUGIN_ID);
		nameListDAO = (INameListDAO)daoRegistry.getDAO(INameListDAO.class.getName());
	}
	
	public void testGet() throws QueryDataDAOException {
		Map map = new HashMap();
		map.put("100","100");
		map.put("200","200");
		nameListDAO.get(map);
		assertEquals("MockMNameListDAO.get failed:",2,map.size());
		map.clear();
		map.put("1","1");
		map.put("5","5");
		map.put("10","10");
		nameListDAO.get(map);
		assertEquals("MockMNameListDAO.get failed:",3,map.size());
		assertEquals("MockMNameListDAO.get failed:","Fred Man",map.get("1"));
		assertEquals("MockMNameListDAO.get failed:","The Third",map.get("5"));
		assertEquals("MockMNameListDAO.get failed:","Do you want some more test data?",map.get("10"));
	}

}
