package gov.va.med.hds.querytool.test;

import gov.va.med.hds.querytool.dao.IOrderSigStatusListDAO;
import gov.va.med.hds.querytool.dao.QueryDataDAOException;
import gov.va.med.hds.querytool.m.Entry;

import java.util.Map;
import java.util.TreeMap;

/**
 * @author vhaislmonsos
 *
 * Dec 17, 2002 12:08:39 PM
 */
public class MockMOrderSigStatusListDAO extends MockMAbstractNameValueDAO implements IOrderSigStatusListDAO {
	private TreeMap tree;
	
	public MockMOrderSigStatusListDAO() {
		super();
		tree = super.getSortedMap();
	}

	/**
	 * Method callBroker.
	 */
	private String callBroker() {
		String items = "6^ACTIVE\n13^CANCELLED\n2^COMPLETE\n10^DELAYED\n1^DISCONTINUED\n12^DISCONTINUED/EDIT\n7^EXPIRED\n4^FLAGGED\n3^HOLD\n14^LAPSED\n99^NO STATUS\n9^PARTIAL RESULTS\n5^PENDING\n15^RENEWED\n8^SCHEDULED\n11^UNRELEASED\n";
		return items;
	}

	/**
	 * @see gov.va.med.hds.querytool.MAbstractNameValueDAO#getResults()
	 */
	public TreeMap get(Map items) throws QueryDataDAOException {
		String result = callBroker();
		String[] results = result.split("\\n");
		items.clear();
		for (int i=0;i<results.length;i++) {
			String key = getKey(results[i]).toString();
			String value = getValue(results[i]).toString();
			items.put(key,value);
			tree.put(value+key,new Entry(key,value));
		}
		return tree;
	}

}
