package gov.va.med.hds.querytool.test;

import java.util.HashMap;
import java.util.Map;

import gov.va.med.hds.cd.daoregistry.IDaoRegistry;
import gov.va.med.hds.cd.runtime.test.RuntimeTestCase;
import gov.va.med.hds.querytool.dao.IOrderSigStatusListDAO;
import gov.va.med.hds.querytool.dao.QueryDataDAOException;

/**
 * @author vhaislmonsos
 *
 * Dec 17, 2002 12:15:49 PM
 */
public class MockMOrderSigStatusListDAOTest extends RuntimeTestCase {
	private IOrderSigStatusListDAO oslDAO;
	
	/**
	 * Constructor for MockMOrderSigStatusListDAOTest.
	 * @param arg0
	 */
	public MockMOrderSigStatusListDAOTest(String arg0) {
		super(arg0);
	}

	public static void main(String[] args) {
		junit.textui.TestRunner.run(MockMOrderSigStatusListDAOTest.class);
	}

	public void testGet() throws QueryDataDAOException {
		Map itemList = new HashMap();
		oslDAO.get(itemList);
		assertEquals("MockMOrderSigStatusListDAO.get failed:",16,itemList.size());
		assertTrue("MockMOrderSigStatusListDAO.get failed: key item not found.",itemList.containsKey("10"));
		assertTrue("MockMOrderSigStatusListDAO.get failed: key item not found.",itemList.containsKey("6"));
		assertTrue("MockMOrderSigStatusListDAO.get failed: key item not found.",itemList.containsKey("11"));
		assertEquals("MockMOrderSigStatusListDAO.get failed:","ACTIVE",(String)itemList.get("6"));
		assertEquals("MockMOrderSigStatusListDAO.get failed:","UNRELEASED",(String)itemList.get("11"));
		assertEquals("MockMOrderSigStatusListDAO.get failed:","DELAYED",(String)itemList.get("10"));
		
	}
	/**
	 * @see junit.framework.TestCase#setUp()
	 */
	protected void setUp() throws Exception {
		super.setUp();
		parseRegistryResource("QueryToolTest.xml");
		IDaoRegistry daoRegistry = (IDaoRegistry) getRuntime().getPluginInstance(IDaoRegistry.PLUGIN_ID);

		oslDAO = (IOrderSigStatusListDAO)daoRegistry.getDAO(IOrderSigStatusListDAO.class.getName());
	}

}
