package gov.va.med.hds.querytool.test;

import gov.va.med.hds.querytool.dao.IOrderStatusListDAO;
import gov.va.med.hds.querytool.dao.QueryDataDAOException;
import gov.va.med.hds.querytool.m.Entry;

import java.util.Map;
import java.util.TreeMap;

/**
 * @author vhaislmonsos
 *
 * Dec 16, 2002 10:27:56 AM
 */
public class MockMOrderStatusListDAO extends MockMAbstractNameValueDAO implements IOrderStatusListDAO {
	private TreeMap tree;
	
	public MockMOrderStatusListDAO() {
		super();
		tree = super.getSortedMap();
	}

	/**
	 * Method callBroker.
	 */
	private String callBroker() {
		String items = "6^ACTIVE\n"+
						"13^CANCELLED\n"+
						"2^COMPLETE\n"+
						"10^DELAYED\n"+
						"1^DISCONTINUED\n"+
						"12^DISCONTINUED/EDIT\n"+
						"7^EXPIRED\n"+
						"4^FLAGGED\n"+
						"3^HOLD\n"+
						"14^LAPSED\n"+
						"99^NO STATUS\n"+
						"9^PARTIAL RESULTS\n"+
						"5^PENDING\n"+
						"15^RENEWED\n"+
						"8^SCHEDULED\n"+
						"11^UNRELEASED\n";
		return items;
	}


	/**
	 * @see gov.va.med.hds.querytool.MAbstractNameValueDAO#getResults()
	 */
	public TreeMap get(Map items) throws QueryDataDAOException {
		String result = callBroker();
		String[] r = result.split("\\n");
		for (int i=0;i<r.length;i++) {
			String key = getKey(r[i]).toString();
			String value = getValue(r[i]).toString();
			items.put(key,value);
			tree.put(value+key,new Entry(key,value));
		}
		return tree;
	}

}
