package gov.va.med.hds.querytool.test;

import java.util.HashMap;
import java.util.Map;

import gov.va.med.hds.cd.daoregistry.IDaoRegistry;
import gov.va.med.hds.cd.runtime.test.RuntimeTestCase;
import gov.va.med.hds.querytool.dao.IOrderStatusListDAO;
import gov.va.med.hds.querytool.dao.QueryDataDAOException;

/**
 * @author vhaislmonsos
 *
 * Dec 16, 2002 10:39:14 AM
 */
public class MockMOrderStatusListDAOTest extends RuntimeTestCase {
	private IOrderStatusListDAO oslDAO;
	
	/**
	 * Constructor for MockMOrderStatusListDAOTest.
	 * @param arg0
	 */
	public MockMOrderStatusListDAOTest(String arg0) {
		super(arg0);
	}

	public static void main(String[] args) {
		junit.textui.TestRunner.run(MockMOrderStatusListDAOTest.class);
	}
	
	public void testGet() throws QueryDataDAOException {
		Map itemList = new HashMap();
		oslDAO.get(itemList);
		assertEquals("MockMOrderStatusListDAO.get failed:",16,itemList.size());
		assertTrue("MockMOrderStatusListDAO.get failed: key item not found.",itemList.containsKey("6"));
		assertTrue("MockMOrderStatusListDAO.get failed: key item not found.",itemList.containsKey("99"));
		assertTrue("MockMOrderStatusListDAO.get failed: key item not found.",itemList.containsKey("11"));
		assertEquals("MockMOrderStatusListDAO.get failed:","UNRELEASED",(String)itemList.get("11"));
		assertEquals("MockMOrderStatusListDAO.get failed:","ACTIVE",(String)itemList.get("6"));
		assertEquals("MockMOrderStatusListDAO.get failed:","NO STATUS",(String)itemList.get("99"));
		
	}

	/**
	 * @see junit.framework.TestCase#setUp()
	 */
	protected void setUp() throws Exception {
		super.setUp();
		parseRegistryResource("QueryToolTest.xml");
		IDaoRegistry daoRegistry = (IDaoRegistry) getRuntime().getPluginInstance(IDaoRegistry.PLUGIN_ID);
		oslDAO = (IOrderStatusListDAO)daoRegistry.getDAO(IOrderStatusListDAO.class.getName());
	}

}
