package gov.va.med.hds.querytool.test;

import gov.va.med.hds.cd.daoregistry.IDaoRegistry;
import gov.va.med.hds.cd.runtime.test.RuntimeTestCase;
import gov.va.med.hds.querytool.IDataNeededListener;
import gov.va.med.hds.querytool.IQuery;
import gov.va.med.hds.querytool.QueryID;
import gov.va.med.hds.querytool.dao.IQueryDAO;
import gov.va.med.hds.querytool.dao.QueryDAOException;
import java.awt.event.ActionEvent;

/**
 * @author vhaislmonsos
 *
 * Oct 30, 2002 9:06:24 AM
 */
public class MockMQueryDAOTest extends RuntimeTestCase {
	private IQueryDAO queryDAO = null;
	private boolean called;

	/**
	 * Constructor for MockMQueryDAOTest.
	 * @param name
	 */
	public MockMQueryDAOTest(String name) {
		super(name);
	}

	public static void main(String[] args) {
		junit.textui.TestRunner.run(MockMQueryDAOTest.class);
	}

	/**
	 * Sets up the fixture, for example, open a network connection.
	 * This method is called before a test is executed.
	 */
	protected void setUp() throws Exception {
		super.setUp();
		parseRegistryResource("QueryToolTest.xml");
		IDaoRegistry daoRegistry = (IDaoRegistry) getRuntime().getPluginInstance(IDaoRegistry.PLUGIN_ID);
		queryDAO = (IQueryDAO)daoRegistry.getDAO(IQueryDAO.class.getName());
	}

	public void testGetQueryIDIUserContext() throws QueryDAOException {
		IQuery q = queryDAO.getAsync(new QueryID("74"), "Steve Custom Full with Values");
		assertEquals("MockMQueryDAO.getLightweight failed:","Steve Custom Full with Values",q.getDisplayName());
		assertEquals("MockMQueryDAO.getLightweight failed:","74",q.getQueryID().toString());
		assertEquals("MockMQueryDAO.getName failed:","RPT CONSULT FOLLOW-UP",q.getName());
	}

	public void testGet() throws QueryDAOException {
		IQuery q = queryDAO.getSync(new QueryID("79"));
		assertNotNull("QueryDAO.get exception: Query not found.",q);
		assertEquals("MockMQueryDAO.getName failed:","RPTU123456789065 EVERYTHING REPORT",q.getName());
	}

	public void testDataNeededListener() throws QueryDAOException {
		IQuery q = queryDAO.getAsync(new QueryID("77"), "Alpha query");
		q.addDataNeededListener(new IDataNeededListener() {
			public void actionPerformed(ActionEvent e) {
				called = true;
			}
		});
		called = false;
		q.getName();
		assertTrue("MockMQueryDAO did not handle the data needed event.",called);
	}

}
