package gov.va.med.hds.querytool.test;

import gov.va.med.hds.querytool.dao.ITeamRefDAO;
import gov.va.med.hds.querytool.dao.QueryDataDAOException;
import java.util.Iterator;
import java.util.Map;
import java.util.TreeMap;

/**
 * @author vhaislmonsos
 *
 * Jan 8, 2003 1:32:24 PM
 */
public class MockMTeamRefDAO
	extends MockMAbstractNameValueDAO
	implements ITeamRefDAO {
	private TreeMap tree;
	
	public MockMTeamRefDAO() {
		super();
		tree = super.getSortedMap();
	}

	/**
	 * @see gov.va.med.hds.querytool.dao.INameValuePairDAO#get(Map)
	 */
	public TreeMap get(Map items) throws QueryDataDAOException {
		items.clear();
		items.put("172", "123TEAM");
		items.put("169", "1A TEST");
		items.put("150", "ANDERSON1");
		items.put("184", "AUTOB");
		items.put("185", "AUTOC");
		items.put("186", "AUTOD");
		items.put("187", "AUTOE");
		items.put("188", "AUTOF");
		items.put("189", "AUTOG");
		items.put("190", "AUTOH");
		items.put("191", "AUTOI");
		items.put("192", "AUTOJ");
		items.put("165", "AUTOLINKED TEAM--PROVIDER");
		items.put("176", "BIGTEAM");
		items.put("208", "BOB'S TEAM AUTO LINKED");
		items.put("179", "CAMP CPRS 98 TEAM LIST");
		items.put("143", "CAPERSONAL1");
		items.put("177", "CARY'S CLINIC");
		items.put("173", "CARY1");
		items.put("182", "CAUTO");
		items.put("142", "CA_10-22");
		items.put("193", "CA_1A+2B");
		items.put("210", "CLINICTEAM");
		items.put("211", "CLINICTEAM2");
		items.put("163", "CURTAUTO");
		items.put("250", "CURTNEW");
		items.put("157", "CURTTEAM");
		items.put("159", "DEFA'S TEAM");
		items.put("151", "DEFA,T");
		items.put("158", "DEFA,TANA");
		items.put("175", "DIETICIANS");
		items.put("212", "DOE'S LIST");
		items.put("140", "DWIGHT'S TEAM");
		items.put("155", "DWIGHT'S TEAM11");
		items.put("220", "Dr. Ruth's Other List");
		items.put("219", "Dr. Ruth's list");
		items.put("146", "GOLD");
		items.put("147", "GREEN");
		items.put("167", "GREENLIST");
		items.put("200", "HENDRY");
		items.put("152", "HOOD'S HELPERS10");
		items.put("153", "HOOD'S HELPERS11");
		items.put("168", "House of Murph");
		items.put("223", "Howser Primary ");
		items.put("225", "INSLEYTEST");
		items.put("196", "JEREMY'S PATIENT LIST");
		items.put("180", "LABALERTS");
		items.put("161", "MALMROSE,C 1");
		items.put("226", "MARCIA TEST");
		items.put("215", "MARGY");
		items.put("149", "MEDBLUE");
		items.put("246", "Marcia's Mixed Case");
		items.put("217", "Metal Health");
		items.put("197", "NOTIFICATION TEST");
		items.put("139", "OERR1");
		items.put("154", "OERR111");
		items.put("228", "PAULAUTO");
		items.put("248", "PAULP2");
		items.put("229", "PAULTEST");
		items.put("249", "PAULYYY");
		items.put("251", "PAULxxx");
		items.put("174", "PULM1");
		items.put("178", "RANDY'S PL");
		items.put("252", "RANDY'S TEST OF PATCH 47");
		items.put("145", "RED");
		items.put("204", "ROBIN'S PATIENT LIST");
		items.put("243", "SNOW01TM");
		items.put("240", "SNOW03");
		items.put("242", "SNOW04");
		items.put("244", "SNOW06");
		items.put("233", "SNOWABC");
		items.put("241", "SNOWXYZ");
		items.put("239", "SNW01");
		items.put("222", "Specialty: Psych Observ");
		items.put("221", "Specialty: surgery");
		items.put("207", "TA DA");
		items.put("160", "TANA'S ATTENDING TEAM LIST");
		items.put("164", "TANA'S AUTOLINKED WARD LIST");
		items.put("162", "TANA'S LM TEAM");
		items.put("206", "TANA'S TA DA");
		items.put("203", "TEAM 1A");
		items.put("214", "TEAM MEL");
		items.put("183", "TEAMA");
		items.put("144", "TEAMPSY01");
		items.put("253", "TEAMRICK");
		items.put("194", "TEAM_1A+2B");
		items.put("213", "TEST LIST FOR BOB");
		items.put("201", "TESTAUTO");
		items.put("198", "WARD 1A CUSTOM LIST");
		items.put("148", "YELLOW");
		items.put("181", "Z3 EAST");
		for (Iterator i = items.entrySet().iterator(); i.hasNext();) {
			Map.Entry e = (Map.Entry) i.next();
			tree.put(e.getValue().toString()+e.getKey().toString(),e);
		}
		return tree;
	}

}
