package gov.va.med.hds.querytool.test;

import gov.va.med.hds.querytool.IQueryID;
import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;

/**
 * @author vhaislmonsos
 *
 * Nov 1, 2002 3:11:25 PM
 */
public class MockSharedBroker {

	/**
	 * Constructor for MockSharedBroker.
	 */
	public MockSharedBroker() {
		super();
	}

	public static String[] getCriteriaHierarchy() {
		return new String[] {
			"3000500=3013500",
			"3000500=3011000",
			"3000500=3019500",
			"3000500=3012000",
			"3000500=3012500",
			"3000500=3010500",
			"3000500=3015000",
			"3000500=3011500",
			"3000500=3014500",
			"3000500=3014000",
			"3000500=3013000",
			"4000500=4012500",
			"4000500=4011000",
			"4000500=4013000",
			"4000500=4019500",
			"4000500=4010500",
			"4000500=4012000",
			"4000500=4011500",
			"2000500=2014000",
			"2000500=2012000",
			"2000500=2012500",
			"2000500=2013000",
			"2000500=2011500",
			"2000500=2019500",
			"2000500=2015500",
			"2000500=2011000",
			"2000500=2015000",
			"2000500=2010500",
			"2000500=2014500",
			"2000500=2013500",
			"1001000=1011500",
			"1001000=1010500",
			"1001000=1011000",
			"5000500=5011000",
			"5000500=5019500",
			"5000500=5010500",
			"0=3000500",
			"0=4000500",
			"0=2000500",
			"0=1000500",
			"0=1001000",
			"0=1500500",
			"0=5000500" };
	}

	public static String[] getQuery(IQueryID queryID)
		throws NullPointerException {
		String[] result = null;

		if (queryID.toString().equals("78")) {
			result =
				new String[] {
					"Name=RPT ABNORMAL RESULTS",
					"DisplayText=Abnormal Results",
					"QueryText=1",
					"CriterionTag=1000500",
					"Caption=Patient Lists for Search:",
					"QueryText=2",
					"CriterionTag=1000500",
					"Caption=< select patient list >",
					"ConstraintName=Patient.ListSource",
					"EditorID=1",
					"QueryText=3",
					"CriterionTag=1500500",
					"Caption=Date Range for Search:",
					"QueryText=4",
					"CriterionTag=1500500",
					"Caption=from 14 May 2002 through 14 Nov 2002",
					"ConstraintName=Search.DateRange",
					"EditorID=2",
					"Value=T-184:T",
					"QueryText=5",
					"CriterionTag=2000500",
					"Caption=Find Orders",
					"ConstraintName=Order.Search",
					"EditorID=12",
					"Value=1",
					"QueryText=6",
					"CriterionTag=2014000",
					"Caption=where the order has abnormal results or significant findings",
					"ConstraintName=Order.Abnormal",
					"EditorID=12",
					"Value=1",
					"ColumnName=Patient.Name",
					"ColumnHeader=Name",
					"ColumnWidth=106",
					"ColumnName=Order.Provider",
					"ColumnHeader=Requestor",
					"ColumnWidth=100",
					"ColumnName=Order.Text",
					"ColumnHeader=Order/Request",
					"ColumnWidth=219",
					"ColumnName=Order.Finding",
					"ColumnHeader=Finding",
					"ColumnWidth=199" };
		} else if (queryID.toString().equals("22")) {
			result =
				new String[] {
					"Name=RPT BASELINE STUB",
					"DisplayText=New Custom Report",
					"QueryText=1",
					"CriterionTag=1000500",
					"Caption=Patient Lists for Search:",
					"QueryText=2",
					"CriterionTag=1000500",
					"Caption=< select patient list >",
					"ConstraintName=Patient.ListSource",
					"EditorID=1",
					"QueryText=3",
					"CriterionTag=1500500",
					"Caption=Date Range for Search:",
					"QueryText=4",
					"CriterionTag=1500500",
					"Caption=< select date range >",
					"ConstraintName=Search.DateRange",
					"EditorID=2",
					"ColumnName=Patient.Name",
					"ColumnHeader=Name",
					"ColumnWidth=130" };
		} else if (queryID.toString().equals("74")) {
			result =
				new String[] {
					"Name=RPT CONSULT FOLLOW-UP",
					"DisplayText=Consult Follow-up",
					"QueryText=1",
					"CriterionTag=1000500",
					"Caption=Patient Lists for Search:",
					"QueryText=2",
					"CriterionTag=1000500",
					"Caption=< select patient list >",
					"ConstraintName=Patient.ListSource",
					"EditorID=1",
					"QueryText=3",
					"CriterionTag=1500500",
					"Caption=Date Range for Search:",
					"QueryText=4",
					"CriterionTag=1500500",
					"Caption=from 13 May 2002 through 13 Nov 2002",
					"ConstraintName=Search.DateRange",
					"EditorID=2",
					"Value=T-184:T",
					"QueryText=5",
					"CriterionTag=3000500",
					"Caption=Find Consults",
					"ConstraintName=Consult.Search",
					"EditorID=12",
					"Value=1",
					"QueryText=6",
					"CriterionTag=3011500",
					"Caption=where the consulting service is",
					"QueryText=7",
					"CriterionTag=3011500",
					"Caption=ALL SERVICES",
					"ConstraintName=Consult.DisplayGroup",
					"EditorID=14",
					"Value=3360",
					"ColumnName=Patient.Name",
					"ColumnHeader=Name",
					"ColumnWidth=112",
					"ColumnName=Order.Datetime",
					"ColumnHeader=Date",
					"ColumnWidth=80",
					"ColumnName=Order.Provider",
					"ColumnHeader=Requestor",
					"ColumnWidth=99",
					"ColumnName=Order.Text",
					"ColumnHeader=Order/Request",
					"ColumnWidth=288",
					"ColumnName=Order.Status",
					"ColumnHeader=Status",
					"ColumnWidth=44" };
		} else if (queryID.toString().equals("75")) {
			result =
				new String[] {
					"Name=RPT INCOMPLETE ORDERS",
					"DisplayText=Incomplete Orders",
					"QueryText=1",
					"CriterionTag=1000500",
					"Caption=Patient Lists for Search:",
					"QueryText=2",
					"CriterionTag=1000500",
					"Caption=< select patient list >",
					"ConstraintName=Patient.ListSource",
					"EditorID=1",
					"QueryText=3",
					"CriterionTag=1500500",
					"Caption=Date Range for Search:",
					"QueryText=4",
					"CriterionTag=1500500",
					"Caption=from 13 May 2002 through 13 Nov 2002",
					"ConstraintName=Search.DateRange",
					"EditorID=2",
					"Value=T-184:T",
					"QueryText=5",
					"CriterionTag=2000500",
					"Caption=Find Orders",
					"ConstraintName=Order.Search",
					"EditorID=12",
					"Value=1",
					"QueryText=6",
					"CriterionTag=2014500",
					"Caption=where the order status is",
					"QueryText=7",
					"CriterionTag=2014500",
					"Caption=PARTIAL RESULTS or PENDING",
					"ConstraintName=Order.Status",
					"EditorID=6",
					"Value=9",
					"Value=5",
					"ColumnName=Patient.Name",
					"ColumnHeader=Name",
					"ColumnWidth=106",
					"ColumnName=Order.Datetime",
					"ColumnHeader=Date",
					"ColumnWidth=80",
					"ColumnName=Order.Provider",
					"ColumnHeader=Requestor",
					"ColumnWidth=99",
					"ColumnName=Order.Text",
					"ColumnHeader=Order/Request",
					"ColumnWidth=294",
					"ColumnName=Order.Status",
					"ColumnHeader=Status",
					"ColumnWidth=43",
					};
		} else if (queryID.toString().equals("76")) {
			result =
				new String[] {
					"Name=RPT RECENT ACTIVITY",
					"DisplayText=Recent Activity",
					"QueryText=1",
					"CriterionTag=1000500",
					"Caption=Patient Lists for Search:",
					"QueryText=2",
					"CriterionTag=1000500",
					"Caption=< select patient list >",
					"ConstraintName=Patient.ListSource",
					"EditorID=1",
					"QueryText=3",
					"CriterionTag=1500500",
					"Caption=Date Range for Search:",
					"QueryText=4",
					"CriterionTag=1500500",
					"Caption=during the Past 24 Hours",
					"ConstraintName=Search.DateRange",
					"EditorID=2",
					"Value=T-1:T",
					"QueryText=5",
					"CriterionTag=2000500",
					"Caption=Find Orders",
					"ConstraintName=Order.Search",
					"EditorID=12",
					"Value=1",
					"QueryText=6",
					"CriterionTag=4000500",
					"Caption=Find Documents",
					"ConstraintName=Document.Search",
					"EditorID=12",
					"Value=1",
					"QueryText=7",
					"CriterionTag=4011000",
					"Caption=where the document class is",
					"QueryText=8",
					"CriterionTag=4011000",
					"Caption=Consults or Discharge Summaries or Progress Notes",
					"ConstraintName=Document.Class",
					"EditorID=13",
					"Value=677",
					"Value=244",
					"Value=3",
					"ColumnName=Patient.Name",
					"ColumnHeader=Name",
					"ColumnWidth=99",
					"ColumnName=Document.Author",
					"ColumnHeader=Author",
					"ColumnWidth=99",
					"ColumnName=Document.Title",
					"ColumnHeader=Title",
					"ColumnWidth=105",
					"ColumnName=Document.Status",
					"ColumnHeader=Status",
					"ColumnWidth=57",
					"ColumnName=Order.Provider",
					"ColumnHeader=Requestor",
					"ColumnWidth=80",
					"ColumnName=Order.Text",
					"ColumnHeader=Order/Request",
					"ColumnWidth=138",
					"ColumnName=Order.Status",
					"ColumnHeader=Status",
					"ColumnWidth=44",
					};
		} else if (queryID.toString().equals("77")) {
			result =
				new String[] {
					"Name=RPT SCHEDULED/DUE ACTIVITY",
					"DisplayText=Scheduled/Due Activity",
					"QueryText=1",
					"CriterionTag=1000500",
					"Caption=Patient Lists for Search:",
					"QueryText=2",
					"CriterionTag=1000500",
					"Caption=< select patient list >",
					"ConstraintName=Patient.ListSource",
					"EditorID=1",
					"QueryText=3",
					"CriterionTag=1500500",
					"Caption=Date Range for Search:",
					"QueryText=4",
					"CriterionTag=1500500",
					"Caption=from 14 May 2002 through 14 Nov 2002",
					"ConstraintName=Search.DateRange",
					"EditorID=2",
					"Value=T-183:T+1",
					"QueryText=5",
					"CriterionTag=2000500",
					"Caption=Find Orders",
					"ConstraintName=Order.Search",
					"EditorID=12",
					"Value=1",
					"QueryText=6",
					"CriterionTag=2012000",
					"Caption=where the service category (display group) is",
					"QueryText=7",
					"CriterionTag=2012000",
					"Caption=IMAGING",
					"ConstraintName=Order.DisplayGroup",
					"EditorID=4",
					"Value=13",
					"QueryText=8",
					"CriterionTag=2014500",
					"Caption=where the order status is",
					"QueryText=9",
					"CriterionTag=2014500",
					"Caption=PENDING or SCHEDULED",
					"ConstraintName=Order.Status",
					"EditorID=6",
					"Value=5",
					"Value=8",
					"QueryText=10",
					"CriterionTag=3000500",
					"Caption=Find Consults",
					"ConstraintName=Consult.Search",
					"EditorID=12",
					"Value=1",
					"QueryText=11",
					"CriterionTag=3014000",
					"Caption=where the consult status is",
					"QueryText=12",
					"CriterionTag=3014000",
					"Caption=PENDING or SCHEDULED",
					"ConstraintName=Consult.Status",
					"EditorID=6",
					"Value=5",
					"Value=8",
					"ColumnName=Patient.Name",
					"ColumnHeader=Name",
					"ColumnWidth=107",
					"ColumnName=Order.Datetime",
					"ColumnHeader=Date",
					"ColumnWidth=80",
					"ColumnName=Order.Provider",
					"ColumnHeader=Requestor",
					"ColumnWidth=76",
					"ColumnName=Order.Text",
					"ColumnHeader=Order/Request",
					"ColumnWidth=318",
					"ColumnName=Order.Status",
					"ColumnHeader=Status",
					"ColumnWidth=42",
					};
		} else if (queryID.toString().equals("79")) {
			result =
				new String[] {
					"Name=RPTU123456789065 EVERYTHING REPORT",
					"DisplayText=Everything Report",
					"QueryText=1",
					"CriterionTag=1000500",
					"Caption=Patient Lists for Search:",
					"QueryText=2",
					"CriterionTag=1000500",
					"Caption= Clinic: 1 Cary's Clinic and Clinic: Cardiology and Clinic: Diabetic Ede",
					"ConstraintName=Patient.ListSource",
					"EditorID=1",
					"Value=c:7:T",
					"Value=c:27:T",
					"Value=c:21:T",
					"Value=w:6:",
					"Value=w:1:",
					"Value=w:3:",
					"Value=t:172:",
					"Value=t:169:",
					"Value=t:150:",
					"Value=t:184:",
					"Value=s:7:",
					"Value=s:10:",
					"Value=s:3:",
					"Value=s:1:",
					"Value=p:7:",
					"Value=p:27:",
					"Value=p:21:",
					"Value=p:15:",
					"QueryText=3",
					"CriterionTag=1500500",
					"Caption=Date Range for Search:",
					"QueryText=4",
					"CriterionTag=1500500",
					"Caption=during the Past Month",
					"ConstraintName=Search.DateRange",
					"EditorID=2",
					"Value=T-30:T",
					"QueryText=5",
					"CriterionTag=1011000",
					"Caption=include only patients with inpt/outpt/pharmacy visits during",
					"ConstraintName=Patient.AnyVisit",
					"EditorID=12",
					"QueryText=6",
					"CriterionTag=1011000",
					"Caption=during the Current Year",
					"ConstraintName=Patient.DateRange",
					"EditorID=2",
					"Value=YF",
					"QueryText=7",
					"CriterionTag=1011500",
					"Caption=where the primary outpatient provider is",
					"QueryText=8",
					"CriterionTag=1011500",
					"Caption=ACKERMAN,NIEN-CHIN or ANDREWS,BOB or BARNES,LENORA or BAYLIS,RANDALL orE",
					"ConstraintName=Patient.Primary",
					"EditorID=8",
					"Value=1323",
					"Value=1117",
					"Value=123456789031",
					"Value=1312",
					"Value=1360",
					"QueryText=9",
					"CriterionTag=2000500",
					"Caption=Find Orders",
					"ConstraintName=Order.Search",
					"EditorID=12",
					"Value=1",
					"QueryText=10",
					"CriterionTag=2012000",
					"Caption=where the service category (display group) is",
					"QueryText=11",
					"CriterionTag=2012000",
					"Caption=LABORATORY or DIET ORDERS or CONSULTS or ACTIVITY or SURGERY or CONDITIN",
					"ConstraintName=Order.DisplayGroup",
					"EditorID=4",
					"Value=3",
					"Value=19",
					"Value=30",
					"Value=43",
					"Value=27",
					"Value=58",
					"QueryText=12",
					"CriterionTag=2013500",
					"Caption=where the text of the order contains",
					"QueryText=13",
					"CriterionTag=2013500",
					"Caption=tHIS IS fREE tEXT..D",
					"ConstraintName=Order.Text",
					"EditorID=9",
					"Value=tHIS IS fREE tEXT..D",
					"QueryText=14",
					"CriterionTag=2014000",
					"Caption=where the order has abnormal results or significant findings",
					"ConstraintName=Order.Abnormal",
					"EditorID=12",
					"Value=1",
					"QueryText=15",
					"CriterionTag=2014500",
					"Caption=where the order status is",
					"QueryText=16",
					"CriterionTag=2014500",
					"Caption=ACTIVE or DELAYED or DISCONTINUED/EDIT or HOLD or PARTIAL RESULTS or RED",
					"ConstraintName=Order.Status",
					"EditorID=6",
					"Value=6",
					"Value=10",
					"Value=12",
					"Value=3",
					"Value=9",
					"Value=15",
					"Value=11",
					"QueryText=17",
					"CriterionTag=2015000",
					"Caption=where the signature status is",
					"QueryText=18",
					"CriterionTag=2015000",
					"Caption=ON CHART w/written orders or NOT SIGNED or ON CHART w/printed orders orD",
					"ConstraintName=Order.SignStatus",
					"EditorID=7",
					"Value=0",
					"Value=2",
					"Value=4",
					"Value=7",
					"QueryText=19",
					"CriterionTag=2015500",
					"Caption=where the requesting clinician is",
					"QueryText=20",
					"CriterionTag=2015500",
					"Caption=ACKERMAN,SHIRLEY or ANWER,MOHAMED or BARNACLE,BILL or BROWN,STANLEY A oN",
					"ConstraintName=Order.Requestor",
					"EditorID=8",
					"Value=1307",
					"Value=123456789017",
					"Value=12",
					"Value=1314",
					"Value=123456789032",
					"QueryText=21",
					"CriterionTag=3000500",
					"Caption=Find Consults",
					"ConstraintName=Consult.Search",
					"EditorID=12",
					"Value=1",
					"QueryText=22",
					"CriterionTag=3011500",
					"Caption=where the consulting service is",
					"QueryText=23",
					"CriterionTag=3011500",
					"Caption=TEST CONSULT TYPE or GMRCTVTEST or VTEST or ZZTEST CONSULT",
					"ConstraintName=Consult.DisplayGroup",
					"EditorID=14",
					"Value=3350",
					"Value=3354",
					"Value=3355",
					"Value=3357",
					"QueryText=1",
					"CriterionTag=3012500",
					"Caption=where orders for",
					"QueryText=2",
					"CriterionTag=3012500",
					"Caption=< select procedure >",
					"ConstraintName=Consult.ItemCombo1",
					"EditorID=5",
					"QueryText=3",
					"CriterionTag=3012500",
					"Caption=and also for",
					"QueryText=4",
					"CriterionTag=3012500",
					"Caption=<select orderable item >",
					"ConstraintName=Consult.ItemCombo2",
					"EditorID=5",
					"QueryText=5",
					"CriterionTag=3012500",
					"Caption=are found",
					"QueryText=24",
					"CriterionTag=3013000",
					"Caption=where the text of the consult request contains",
					"QueryText=25",
					"CriterionTag=3013000",
					"Caption=mORE FREE TESXT",
					"ConstraintName=Consult.Text",
					"EditorID=9",
					"Value=mORE FREE TESXT",
					"QueryText=26",
					"CriterionTag=3013500",
					"Caption=where the consult has significant findings",
					"ConstraintName=Consult.Abnormal",
					"EditorID=12",
					"Value=1",
					"QueryText=27",
					"CriterionTag=3014000",
					"Caption=where the consult status is",
					"QueryText=28",
					"CriterionTag=3014000",
					"Caption=ACTIVE or DISCONTINUED or EXPIRED or LAPSED or PENDING or SCHEDULED",
					"ConstraintName=Consult.Status",
					"EditorID=6",
					"Value=6",
					"Value=1",
					"Value=7",
					"Value=14",
					"Value=5",
					"Value=8",
					"QueryText=29",
					"CriterionTag=3014500",
					"Caption=where the signature status is",
					"QueryText=30",
					"CriterionTag=3014500",
					"Caption=ON CHART w/written orders or ELECTRONIC or NOT REQUIRED or ON CHART w/pD",
					"ConstraintName=Consult.SignStatus",
					"EditorID=7",
					"Value=0",
					"Value=1",
					"Value=3",
					"Value=4",
					"Value=7",
					"QueryText=31",
					"CriterionTag=3015000",
					"Caption=where the requesting clinician is",
					"QueryText=32",
					"CriterionTag=3015000",
					"Caption=ARCENEAUX,CHARLES or EATON,DENIS or MALMROSE,CARY or MAUSETH,PATRICIA A",
					"ConstraintName=Consult.Requestor",
					"EditorID=8",
					"Value=1299",
					"Value=1273",
					"Value=5",
					"Value=123456789025",
					"QueryText=33",
					"CriterionTag=4000500",
					"Caption=Find Documents",
					"ConstraintName=Document.Search",
					"EditorID=12",
					"Value=1",
					"QueryText=34",
					"CriterionTag=4011000",
					"Caption=where the document class is",
					"QueryText=35",
					"CriterionTag=4011000",
					"Caption=Clinical Procedures or Discharge Summaries or Rad/Nuc Med Reports",
					"ConstraintName=Document.Class",
					"EditorID=13",
					"Value=1143",
					"Value=244",
					"Value=964",
					"QueryText=36",
					"CriterionTag=4011500",
					"Caption=where the title is",
					"QueryText=37",
					"CriterionTag=4011500",
					"Caption=519 or  or  or",
					"ConstraintName=Document.Title",
					"EditorID=10",
					"Value=8",
					"Value=723",
					"Value=1138",
					"Value=1091",
					"QueryText=38",
					"CriterionTag=4012000",
					"Caption=where the document status is",
					"QueryText=39",
					"CriterionTag=4012000",
					"Caption=ACTIVE or COMPLETED or INACTIVE or RETRACTED or UNCOSIGNED or UNRELEASED",
					"ConstraintName=Document.Status",
					"EditorID=11",
					"Value=11",
					"Value=7",
					"Value=13",
					"Value=15",
					"Value=6",
					"Value=3",
					"Value=5",
					"Value=2",
					"QueryText=40",
					"CriterionTag=4012500",
					"Caption=where the author is",
					"QueryText=41",
					"CriterionTag=4012500",
					"Caption=BROWN,CLINICIAN or MISSING,USER or MORGAN,BRAD or MODERSITZKI,MARC or MY",
					"ConstraintName=Document.Author",
					"EditorID=8",
					"Value=1352",
					"Value=1121",
					"Value=1363",
					"Value=1343",
					"Value=1324",
					"QueryText=42",
					"CriterionTag=4013000",
					"Caption=where the visit location is",
					"QueryText=43",
					"CriterionTag=4013000",
					"Caption=ULTRASOUND CLINIC or REPORT OF CONTACTS or MARCIA or GENERAL MEDICINE oC",
					"ConstraintName=Document.Location",
					"EditorID=3",
					"Value=20",
					"Value=38",
					"Value=30",
					"Value=15",
					"Value=21",
					"Value=27",
					"Value=7",
					"QueryText=44",
					"CriterionTag=5000500",
					"Caption=Find Appointments/Visits",
					"ConstraintName=Visit.Search",
					"EditorID=12",
					"Value=1",
					"QueryText=45",
					"CriterionTag=5011000",
					"Caption=where the visit is for",
					"QueryText=46",
					"CriterionTag=5011000",
					"Caption=XRAY CLINIC or PULMONARY CLINIC or Metal Health or DIABETIC EDUCATION-IC",
					"ConstraintName=Visit.Location",
					"EditorID=3",
					"Value=19",
					"Value=16",
					"Value=36",
					"Value=21",
					"Value=7",
					"ColumnName=Patient.Name",
					"ColumnHeader=Name",
					"ColumnWidth=130",
					"ColumnName=Document.Author",
					"ColumnHeader=Author",
					"ColumnWidth=80",
					"ColumnName=Document.Cosigner",
					"ColumnHeader=Expected Cosigner",
					"ColumnWidth=80",
					"ColumnName=Document.Reference",
					"ColumnHeader=Note Date/Time",
					"ColumnWidth=80",
					"ColumnName=Document.Status",
					"ColumnHeader=Status",
					"ColumnWidth=80",
					"ColumnName=Document.Title",
					"ColumnHeader=Title",
					"ColumnWidth=80",
					"ColumnName=Order.Abnormal",
					"ColumnHeader=Abnormal",
					"ColumnWidth=80",
					"ColumnName=Order.Datetime",
					"ColumnHeader=Date",
					"ColumnWidth=80",
					"ColumnName=Order.Finding",
					"ColumnHeader=Finding",
					"ColumnWidth=80",
					"ColumnName=Order.Provider",
					"ColumnHeader=Requestor",
					"ColumnWidth=80",
					"ColumnName=Order.DisplayGroup",
					"ColumnHeader=Service",
					"ColumnWidth=80",
					"ColumnName=Order.Signature",
					"ColumnHeader=Signature",
					"ColumnWidth=80",
					"ColumnName=Order.Status",
					"ColumnHeader=Status",
					"ColumnWidth=80",
					"ColumnName=Order.Text",
					"ColumnHeader=Order/Request",
					"ColumnWidth=80",
					"ColumnName=Patient.Age",
					"ColumnHeader=Age",
					"ColumnWidth=80",
					"ColumnName=Patient.Last4",
					"ColumnHeader=SSN",
					"ColumnWidth=80",
					"ColumnName=Patient.Ward",
					"ColumnHeader=Ward",
					"ColumnWidth=80",
					"ColumnName=Visit.Datetime",
					"ColumnHeader=Visit Date/Time",
					"ColumnWidth=80",
					"ColumnName=Visit.Location",
					"ColumnHeader=Clinic",
					"ColumnWidth=80",
					"ColumnName=Visit.Status",
					"ColumnHeader=Status",
					"ColumnWidth=80",
					};
		}

		return result;
	}

	public static String[] getReportQueries() {
		return new String[] {
			"78^Abnormal Results",
			"74^Consult Follow-up",
			"75^Incomplete Orders",
			"76^Recent Activity",
			"77^Scheduled/Due Activity",
			"0^",
			"79^Everything Report" };
	}

	private String callString;

	/**
	 * Method getLongListValues.
	 * @param string
	 * @param parms
	 * @return String
	 */
	public String getLongListValues(String callString, ArrayList parms)
		throws Exception {
		if (!callString.equals(this.callString)) {
			throw new RuntimeException("Wrong call made");
		}
		if ((parms.get(1).toString().compareTo("-1") != 0)
			&& (parms.get(1).toString().compareTo("1") != 0)) {
			throw new RuntimeException(
				"Wrong direction for call:" + parms.get(1).toString());
		}
		if (parms.get(2).toString().compareTo("PROVIDER") != 0) {
			throw new RuntimeException(
				"Incorrect call parameter:" + parms.get(2).toString());
		}
		StringBuffer result = new StringBuffer();
		result.append("1^");
		result.append(parms.get(0).toString());
		result.append("\n");
		if (parms.get(1).equals("1")) {
			getString1(result);
			getString2(result);
			getString3(result);
		} else {
			getString3(result);
			getString2(result);
			getString1(result);
		}
		return result.toString();
	}

	private void getString1(StringBuffer result) {
		for (int i = 0; i < 10; i++) {
			result.append(
				"5^XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX\n");
		}
	}

	private void getString2(StringBuffer result) {
		for (int i = 0; i < 10; i++) {
			result.append(
				"10^YYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYYY\n");
		}
	}

	private void getString3(StringBuffer result) {
		for (int i = 0; i < 10; i++) {
			result.append(
				"15^ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ\n");
		}
	}

	/**
	 * Returns the callString.
	 * @return String
	 */
	public String getCallString() {
		return callString;
	}

	/**
	 * Sets the callString.
	 * @param callString The callString to set
	 */
	public void setCallString(String callString) {
		this.callString = callString;
	}

	public static String[] getParmLines(String tag) {
		String[] longString =
			{
				"***3013500",
				"Name=CTN CONSULT ABNORMAL",
				"DisplayText=Abnormal Results",
				"QueryText=1",
				"CriterionTag=3013500",
				"Caption=where the consult has significant findings",
				"ConstraintName=Consult.Abnormal",
				"EditorID=12",
				"Value=1",
				"***3011000",
				"Name=CTN CONSULT COMPLETE DATE",
				"DisplayText=Consult Completion Date",
				"QueryText=1",
				"CriterionTag=3011000",
				"Caption=where the date the consult was completed is",
				"QueryText=2",
				"CriterionTag=3011000",
				"Caption=< select date range >",
				"ConstraintName=Consult.ResultTime",
				"EditorID=2",
				"***3019500",
				"Name=CTN CONSULT NEGATIVE SEARCH",
				"DisplayText=List No Consults Found",
				"QueryText=1",
				"CriterionTag=3019500",
				"Caption=List only patients where NO CONSULTS meeting the above criteria were fo.",
				"ConstraintName=Consult.NegativeSearch",
				"EditorID=12",
				"Value=1",
				"***3012000",
				"Name=CTN CONSULT PROCEDURE",
				"DisplayText=Procedure",
				"QueryText=1",
				"CriterionTag=3012000",
				"Caption=where the procedure is",
				"QueryText=2",
				"CriterionTag=3012000",
				"Caption=< select procedure >",
				"ConstraintName=Consult.Orderable",
				"EditorID=15",
				"***3012500",
				"Name=CTN CONSULT PROCEDURE COMBO",
				"DisplayText=Procedure Combination",
				"QueryText=1",
				"CriterionTag=3012500",
				"Caption=where orders for",
				"QueryText=2",
				"CriterionTag=3012500",
				"Caption=< select procedure >",
				"ConstraintName=Consult.ItemCombo1",
				"EditorID=5",
				"QueryText=3",
				"CriterionTag=3012500",
				"Caption=and also for",
				"QueryText=4",
				"CriterionTag=3012500",
				"Caption=<select orderable item >",
				"ConstraintName=Consult.ItemCombo2",
				"EditorID=5",
				"QueryText=5",
				"CriterionTag=3012500",
				"Caption=are found",
				"***3010500",
				"Name=CTN CONSULT REQUEST DATE",
				"DisplayText=Consult Request Date",
				"QueryText=1",
				"CriterionTag=3010500",
				"Caption=where the consult request date is",
				"QueryText=2",
				"CriterionTag=3010500",
				"Caption=< select date range >",
				"ConstraintName=Consult.TimeFrame",
				"EditorID=2",
				"***3015000",
				"Name=CTN CONSULT REQUESTOR",
				"DisplayText=Requesting Clinician",
				"QueryText=1",
				"CriterionTag=3015000",
				"Caption=where the requesting clinician is",
				"QueryText=2",
				"CriterionTag=3015000",
				"Caption=< select clinician >",
				"ConstraintName=Consult.Requestor",
				"EditorID=8",
				"***3011500",
				"Name=CTN CONSULT SERVICE",
				"DisplayText=Consulting Service",
				"QueryText=1",
				"CriterionTag=3011500",
				"Caption=where the consulting service is",
				"QueryText=2",
				"CriterionTag=3011500",
				"Caption=< select consulting service >",
				"ConstraintName=Consult.DisplayGroup",
				"EditorID=14",
				"***3014500",
				"Name=CTN CONSULT SIGN STATUS",
				"DisplayText=Signature Status",
				"QueryText=1",
				"CriterionTag=3014500",
				"Caption=where the signature status is",
				"QueryText=2",
				"CriterionTag=3014500",
				"Caption=< select signature status >",
				"ConstraintName=Consult.SignStatus",
				"EditorID=7",
				"***3014000",
				"Name=CTN CONSULT STATUS",
				"DisplayText=Consult Status",
				"QueryText=1",
				"CriterionTag=3014000",
				"Caption=where the consult status is",
				"QueryText=2",
				"CriterionTag=3014000",
				"Caption=< select consult status >",
				"ConstraintName=Consult.Status",
				"EditorID=6",
				"***3013000",
				"Name=CTN CONSULT TEXT",
				"DisplayText=Request Text Contains",
				"QueryText=1",
				"CriterionTag=3013000",
				"Caption=where the text of the consult request contains",
				"QueryText=2",
				"CriterionTag=3013000",
				"Caption=< enter text >",
				"ConstraintName=Consult.Text",
				"EditorID=9",
				"***4012500",
				"Name=CTN DOCUMENT AUTHOR",
				"DisplayText=Document Author",
				"QueryText=1",
				"CriterionTag=4012500",
				"Caption=where the author is",
				"QueryText=2",
				"CriterionTag=4012500",
				"Caption=< select author >",
				"ConstraintName=Document.Author",
				"EditorID=8",
				"***4011000",
				"Name=CTN DOCUMENT CLASS",
				"DisplayText=Document Class",
				"QueryText=1",
				"CriterionTag=4011000",
				"Caption=where the document class is",
				"QueryText=2",
				"CriterionTag=4011000",
				"Caption=< select document class >",
				"ConstraintName=Document.Class",
				"EditorID=13",
				"***4013000",
				"Name=CTN DOCUMENT LOCATION",
				"DisplayText=Visit Location",
				"QueryText=1",
				"CriterionTag=4013000",
				"Caption=where the visit location is",
				"QueryText=2",
				"CriterionTag=4013000",
				"Caption=< select location >",
				"ConstraintName=Document.Location",
				"EditorID=3",
				"***4019500",
				"Name=CTN DOCUMENT NEGATIVE SEARCH",
				"DisplayText=List No Documents Found",
				"QueryText=1",
				"CriterionTag=4019500",
				"Caption=List only patients where NO DOCUMENTS meeting the above criteria were f.",
				"ConstraintName=Document.NegativeSearch",
				"EditorID=12",
				"Value=1",
				"***4010500",
				"Name=CTN DOCUMENT REFERENCE",
				"DisplayText=Date/Time of Note",
				"QueryText=1",
				"CriterionTag=4010500",
				"Caption=where the date/time for the note is",
				"QueryText=2",
				"CriterionTag=4010500",
				"Caption=< select date range >",
				"ConstraintName=Document.Reference",
				"EditorID=2",
				"***4012000",
				"Name=CTN DOCUMENT STATUS",
				"DisplayText=Document Status",
				"QueryText=1",
				"CriterionTag=4012000",
				"Caption=where the document status is",
				"QueryText=2",
				"CriterionTag=4012000",
				"Caption=< select status >",
				"ConstraintName=Document.Status",
				"EditorID=11",
				"***4011500",
				"Name=CTN DOCUMENT TITLE",
				"DisplayText=Document Title",
				"QueryText=1",
				"CriterionTag=4011500",
				"Caption=where the title is",
				"QueryText=2",
				"CriterionTag=4011500",
				"Caption=< select title >",
				"ConstraintName=Document.Title",
				"EditorID=10",
				"***2014000",
				"Name=CTN ORDER ABNORMAL",
				"DisplayText=Abnormal Results",
				"QueryText=1",
				"CriterionTag=2014000",
				"Caption=where the order has abnormal results or significant findings",
				"ConstraintName=Order.Abnormal",
				"EditorID=12",
				"Value=1",
				"***2012000",
				"Name=CTN ORDER DISPLAY GROUP",
				"DisplayText=Service Category",
				"QueryText=1",
				"CriterionTag=2012000",
				"Caption=where the service category (display group) is",
				"QueryText=2",
				"CriterionTag=2012000",
				"Caption=< select service category >",
				"ConstraintName=Order.DisplayGroup",
				"EditorID=4",
				"***2012500",
				"Name=CTN ORDER ITEM",
				"DisplayText=Orderable Item",
				"QueryText=1",
				"CriterionTag=2012500",
				"Caption=where the order is for",
				"QueryText=2",
				"CriterionTag=2012500",
				"Caption=< select orderable item >",
				"ConstraintName=Order.Orderable",
				"EditorID=5",
				"***2013000",
				"Name=CTN ORDER ITEM COMBO",
				"DisplayText=Orderable Item Combination",
				"QueryText=1",
				"CriterionTag=2013000",
				"Caption=where orders for",
				"QueryText=2",
				"CriterionTag=2013000",
				"Caption=< select orderable item >",
				"ConstraintName=Order.ItemCombo1",
				"EditorID=5",
				"QueryText=3",
				"CriterionTag=2013000",
				"Caption=and also for",
				"QueryText=4",
				"CriterionTag=2013000",
				"Caption=< select orderable item >",
				"ConstraintName=Order.ItemCombo2",
				"EditorID=5",
				"QueryText=5",
				"CriterionTag=2013000",
				"Caption=are found",
				"***2011500",
				"Name=CTN ORDER LAST ACTIVITY DATE",
				"DisplayText=Last Activity Date",
				"QueryText=1",
				"CriterionTag=2011500",
				"Caption=where the last order activity is",
				"QueryText=2",
				"CriterionTag=2011500",
				"Caption=< select date range >",
				"ConstraintName=Order.Activity",
				"EditorID=2",
				"***2019500",
				"Name=CTN ORDER NEGATIVE SEARCH",
				"DisplayText=List No Orders Found",
				"QueryText=1",
				"CriterionTag=2019500",
				"Caption=List only patients where NO ORDERS meeting the above criteria were foun.",
				"ConstraintName=Order.NegativeSearch",
				"EditorID=12",
				"Value=1",
				"***2015500",
				"Name=CTN ORDER REQUESTOR",
				"DisplayText=Requesting Clinician",
				"QueryText=1",
				"CriterionTag=2015500",
				"Caption=where the requesting clinician is",
				"QueryText=2",
				"CriterionTag=2015500",
				"Caption=< select clinician >",
				"ConstraintName=Order.Requestor",
				"EditorID=8",
				"***2011000",
				"Name=CTN ORDER RESULTS DATE",
				"DisplayText=Results Available Date",
				"QueryText=1",
				"CriterionTag=2011000",
				"Caption=where results became available",
				"QueryText=2",
				"CriterionTag=2011000",
				"Caption=< select date range >",
				"ConstraintName=Order.ResultTime",
				"EditorID=2",
				"***2015000",
				"Name=CTN ORDER SIGN STATUS",
				"DisplayText=Signature Status",
				"QueryText=1",
				"CriterionTag=2015000",
				"Caption=where the signature status is",
				"QueryText=2",
				"CriterionTag=2015000",
				"Caption=< select signature status >",
				"ConstraintName=Order.SignStatus",
				"EditorID=7",
				"***2010500",
				"Name=CTN ORDER START DATE",
				"DisplayText=Order Start Date",
				"QueryText=1",
				"CriterionTag=2010500",
				"Caption=where the order start date/time is",
				"QueryText=2",
				"CriterionTag=2010500",
				"Caption=< select date range >",
				"ConstraintName=Order.TimeFrame",
				"EditorID=2",
				"***2014500",
				"Name=CTN ORDER STATUS",
				"DisplayText=Order Status",
				"QueryText=1",
				"CriterionTag=2014500",
				"Caption=where the order status is",
				"QueryText=2",
				"CriterionTag=2014500",
				"Caption=< select order status >",
				"ConstraintName=Order.Status",
				"EditorID=6",
				"***2013500",
				"Name=CTN ORDER TEXT",
				"DisplayText=Order Text Contains",
				"QueryText=1",
				"CriterionTag=2013500",
				"Caption=where the text of the order contains",
				"QueryText=2",
				"CriterionTag=2013500",
				"Caption=< enter text >",
				"ConstraintName=Order.Text",
				"EditorID=9",
				"***1011500",
				"Name=CTN PATIENT SCREEN PROVIDER",
				"DisplayText=Primary Outpatient Provider",
				"QueryText=1",
				"CriterionTag=1011500",
				"Caption=where the primary outpatient provider is",
				"QueryText=2",
				"CriterionTag=1011500",
				"Caption=< select providers >",
				"ConstraintName=Patient.Primary",
				"EditorID=8",
				"***1010500",
				"Name=CTN PATIENT SCREEN VISIT",
				"DisplayText=Inpt/Outpt/Pharmacy Visits",
				"QueryText=1",
				"CriterionTag=1010500",
				"Caption=include only patients with visits to",
				"QueryText=2",
				"CriterionTag=1010500",
				"Caption=< select clinics >",
				"ConstraintName=Patient.Location",
				"EditorID=3",
				"QueryText=3",
				"CriterionTag=1010500",
				"Caption=< during the date range >",
				"ConstraintName=Patient.DateRange",
				"EditorID=2",
				"***1011000",
				"Name=CTN PATIENT SCREEN VISIT ANY",
				"DisplayText=Any Inpt/Outpt/Pharmacy Visits",
				"QueryText=1",
				"CriterionTag=1011000",
				"Caption=include only patients with inpt/outpt/pharmacy visits",
				"ConstraintName=Patient.AnyVisit",
				"EditorID=12",
				"QueryText=2",
				"CriterionTag=1011000",
				"Caption=< during date range >",
				"ConstraintName=Patient.DateRange",
				"EditorID=2",
				"***5011000",
				"Name=CTN VISIT LOCATION",
				"DisplayText=Clinic Visit",
				"QueryText=1",
				"CriterionTag=5011000",
				"Caption=where the visit is for",
				"QueryText=2",
				"CriterionTag=5011000",
				"Caption=< select clinic(s) >",
				"ConstraintName=Visit.Location",
				"EditorID=3",
				"***5019500",
				"Name=CTN VISIT NEGATIVE SEARCH",
				"DisplayText=List No Visits Found",
				"QueryText=1",
				"CriterionTag=5019500",
				"Caption=List only patients where NO VISITS meeting the above criteria were foun.",
				"ConstraintName=Visit.NegativeSearch",
				"EditorID=12",
				"Value=1",
				"***5010500",
				"Name=CTN VISIT TIME FRAME",
				"DisplayText=Visit Date/Time",
				"QueryText=1",
				"CriterionTag=5010500",
				"Caption=where the visit occurs during",
				"QueryText=2",
				"CriterionTag=5010500",
				"Caption=< select date range >",
				"ConstraintName=Visit.TimeFrame",
				"EditorID=2",
				"***3000500",
				"Name=CTP CONSULT",
				"DisplayText=Find Consults",
				"QueryText=1",
				"Caption=Find Consults",
				"ConstraintName=Consult.Search",
				"EditorID=12",
				"Value=1",
				"***4000500",
				"Name=CTP DOCUMENT",
				"DisplayText=Find Documents",
				"QueryText=1",
				"Caption=Find Documents",
				"ConstraintName=Document.Search",
				"EditorID=12",
				"Value=1",
				"***2000500",
				"Name=CTP ORDER",
				"DisplayText=Find Orders",
				"QueryText=1",
				"Caption=Find Orders",
				"ConstraintName=Order.Search",
				"EditorID=12",
				"Value=1",
				"***1000500",
				"Name=CTP PATIENT LIST",
				"DisplayText=Patient List",
				"QueryText=1",
				"Caption=For Patients listed by",
				"QueryText=2",
				"Caption=< select patient list >",
				"ConstraintName=Patient.ListSource",
				"EditorID=1",
				"***1001000",
				"Name=CTP PATIENT SCREEN",
				"DisplayText=Screen Selected Patients",
				"QueryText=1",
				"Caption=Screen Selected Patients",
				"ConstraintName=Patient.Screen",
				"EditorID=12",
				"***1500500",
				"Name=CTP SEARCH DATE RANGE",
				"DisplayText=Find Reports in the",
				"QueryText=1",
				"CriterionTag=1500500",
				"Caption=Find Reports in the",
				"QueryText=2",
				"CriterionTag=1500500",
				"Caption=< date range >",
				"ConstraintName=Search.DateRange",
				"EditorID=2",
				"***5000500",
				"Name=CTP VISIT",
				"DisplayText=Find Appointments/Visits",
				"QueryText=1",
				"Caption=Find Appointments/Visits",
				"ConstraintName=Visit.Search",
				"EditorID=12",
				"Value=1" };
		List list = new LinkedList();
		for (int i = 0; i < longString.length; i++) {
			if ((longString[i].startsWith("***"))
				&& (longString[i].substring(3).equals(tag))) {
				for (int j = i + 1; j < longString.length; j++) {
					if (longString[j].startsWith("***")) {
						i = longString.length;
						break;
					}
					list.add(longString[j]);
				}
			}
		}
		return (String[]) list.toArray(new String[0]);
	}

	public static String[] getDisplayData() {
		String[] longList =
			{
				"DisplayName=Patient Name",
				"InternalName=Patient.Name",
				"HeaderName=Name",
				"SortType=F",
				"SampleData=DOE,JOHN ROBERT",
				"SampleData=WINCHESTER,CHARLES EMERSON",
				"DisplayName=Patient SSN",
				"InternalName=Patient.Last4",
				"HeaderName=SSN",
				"SortType=F",
				"SampleData=D3432",
				"SampleData=W5433",
				"DisplayName=Patient Age",
				"InternalName=Patient.Age",
				"HeaderName=Age",
				"SortType=N",
				"SampleData=45",
				"SampleData=69",
				"DisplayName=Patient Ward",
				"InternalName=Patient.Ward",
				"HeaderName=Ward",
				"SortType=F",
				"SampleData=2B 345",
				"SampleData=2B 393",
				"DisplayName=Order/Consult Date",
				"InternalName=Order.Datetime",
				"HeaderName=Date",
				"SortType=D",
				"SampleData=10/20/02 7:30",
				"SampleData=10/20/02 10:30",
				"DisplayName=Order/Consult Requestor",
				"InternalName=Order.Provider",
				"HeaderName=Requestor",
				"SortType=F",
				"SampleData=JOHNSON,WILLIAM C.",
				"SampleData=MICHAELS,JOSEPH",
				"DisplayName=Order/Consult Text",
				"InternalName=Order.Text",
				"HeaderName=Order/Request",
				"SortType=F",
				"SampleData=DIGOXIN 0.25MG PO QAM",
				"SampleData=Electrocardiogram CARDIOLOGY (SOUTH)",
				"DisplayName=Order/Consult Status",
				"InternalName=Order.Status",
				"HeaderName=Status",
				"SortType=F",
				"SampleData=pending",
				"SampleData=active",
				"DisplayName=Order/Consult Signature Status",
				"InternalName=Order.Signature",
				"HeaderName=Signature",
				"SortType=F",
				"SampleData=ELECTRONIC",
				"SampleData=NOT SIGNED",
				"DisplayName=Order/Consult Service",
				"InternalName=Order.DisplayGroup",
				"HeaderName=Service",
				"SortType=F",
				"SampleData=INPATIENT MEDICATIONS",
				"SampleData=CONSULTS",
				"DisplayName=Order/Consult Abnormal Results",
				"InternalName=Order.Abnormal",
				"HeaderName=Abnormal",
				"SortType=F",
				"SampleData=x",
				"DisplayName=Order/Consult Finding Text",
				"InternalName=Order.Finding",
				"HeaderName=Finding",
				"SortType=F",
				"DisplayName=Document Reference Date/Time",
				"InternalName=Document.Reference",
				"HeaderName=Note Date/Time",
				"SortType=D",
				"SampleData=10/20/02 10:30",
				"SampleData=10/20/02 17:54",
				"DisplayName=Document Title",
				"InternalName=Document.Title",
				"HeaderName=Title",
				"SortType=F",
				"SampleData=PRIMARY CARE GENERAL",
				"SampleData=CARDIOLOGY CONSULT",
				"DisplayName=Document Author",
				"InternalName=Document.Author",
				"HeaderName=Author",
				"SortType=F",
				"SampleData=JOHNSON,WILLIAM C.",
				"SampleData=MICHAELS,JOSEPH",
				"DisplayName=Document Status",
				"InternalName=Document.Status",
				"HeaderName=Status",
				"SortType=F",
				"SampleData=UNSIGNED",
				"SampleData=UNCOSIGNED",
				"DisplayName=Document Expected Cosigner",
				"InternalName=Document.Cosigner",
				"HeaderName=Expected Cosigner",
				"SortType=F",
				"SampleData=JACOBSEN,JAMES",
				"SampleData=OLDHAM,JONATHAN G.",
				"DisplayName=Visit/Appointment Date/Time",
				"InternalName=Visit.Datetime",
				"HeaderName=Visit Date/Time",
				"SortType=D",
				"SampleData=11/1/02 10:00",
				"SampleData=12/22/02 8:30",
				"DisplayName=Visit/Appointment Location",
				"InternalName=Visit.Location",
				"HeaderName=Clinic",
				"SortType=F",
				"SampleData=PULMONARY CLINIC (JOHNSON)",
				"SampleData=CARDIOLOGY CLINIC",
				"DisplayName=VIsit/Appointment Status",
				"InternalName=Visit.Status",
				"HeaderName=Status",
				"SortType=F",
				"SampleData=NO SHOW" };
		return longList;
	}
}
