package gov.va.med.hds.querytool.test;

import gov.va.med.hds.querytool.QueryID;

import junit.framework.*;

/**
 * @author vhaislmonsos
 *
 * Oct 30, 2002 9:09:38 AM
 */
public class QueryIDTest extends TestCase {

	/**
	 * Constructor for QueryIDTest.
	 * @param name
	 */
	public QueryIDTest(String name) {
		super(name);
	}

	public static void main(String[] args) {
		junit.textui.TestRunner.run(QueryIDTest.class);
	}

	public void testHashCode() {
		QueryID queryID = new QueryID("12345678");
		assertTrue("QueryID.hashCode failed: no hash code",0!=queryID.hashCode());
	}

	public void testToString() {
		QueryID queryID = new QueryID("12345678");
		assertEquals("QueryID.toString function in error:","12345678",queryID.toString());
	}

	public void testSetQueryID() {
		QueryID queryID = new QueryID("12345678");
		queryID.setQueryID("87654321");
		assertEquals("QueryID.getQueryID failed:","87654321",queryID.toString());
	}

	public void testEqualsObject() {
		QueryID queryID = new QueryID("12345678");
		QueryID queryID2 = new QueryID("12345678");
		assertTrue("QueryID.equals function failed.",queryID.equals(queryID2));
		assertTrue("QueryID.equals function failed.",queryID2.equals(queryID));
		String string = new String("010101010");
		QueryID qid3 = new QueryID(string.substring(8));
		assertTrue("QueryID.equals function failed.",!qid3.equals(QueryID.nullID));
	}

	public void testIsValidID() {
		QueryID newOrNull = new QueryID("0");
		assertTrue("QueryID.equals failed.",!newOrNull.equals(QueryID.nullID));
		assertTrue("QueryID.isValid failed with a nullID.",!QueryID.isValid(QueryID.nullID));
		QueryID anotherID = new QueryID("-10");
		assertTrue("QueryID.isValid failed with an invalid ID.",QueryID.isValid(anotherID));
		QueryID empty = null;
		assertFalse("QueryID.isValid failed to acknowledge a null ID.",QueryID.isValid(empty));
	}

}
