/*
 * Created on Apr 8, 2003 by vhaislmonsos
 */
package gov.va.med.hds.querytool.test;

import gov.va.med.hds.querytool.HardReferenceManager;
import gov.va.med.hds.querytool.IHardReferenceManager;
import gov.va.med.hds.querytool.IQuery;
import gov.va.med.hds.querytool.ISoftListItem;
import gov.va.med.hds.querytool.Query;
import gov.va.med.hds.querytool.QueryID;
import gov.va.med.hds.querytool.QueryListItem;
import junit.framework.TestCase;

/**
 * Tests for the QueryListItem
 */
public class QueryListItemTest extends TestCase {
	private ISoftListItem item;
	private IHardReferenceManager refManager = new HardReferenceManager();

	public QueryListItemTest(String arg0) {
		super(arg0);
	}

	public static void main(String[] args) {
	}

	public void testGetItem() {
		IQuery query = new Query(new QueryID("88"), null);
		item.setDisplayName("one-two");
		item.setID(new QueryID("whoa"));
		assertNull("QueryListItem.getItem failed: item not null.",item.getItem());
		item.setItem(query);
		assertNotNull("QueryListItem.getItem failed: null item returned.",item.getItem());
	}

	public void testGetDisplayName() {
		IQuery query = new Query(new QueryID("88"), null);
		query.setDisplayName("fred");
		item.setDisplayName("one-two");
		item.setID(new QueryID("whoa"));
		assertEquals("QueryListItem.getDisplayName failed:","one-two",item.getDisplayName());
		item.setItem(query);
		assertEquals("QueryListItem.getDisplayName failed:","fred",item.getDisplayName());
		item.setItem(null);
		assertEquals("QueryListItem.getDisplayName failed:","fred",item.getDisplayName());
	}

	public void testGetID() {
		IQuery query = new Query(new QueryID("88"), null);
		query.setDisplayName("fred");
		item.setDisplayName("one-two");
		item.setID(new QueryID("whoa"));
		assertEquals("QueryListItem.getID failed:","whoa",item.getID().toString());
		item.setItem(query);
		assertEquals("QueryListItem.getID failed:","88",item.getID().toString());
		query.setQueryID(new QueryID("john"));
		assertEquals("QueryListItem.getID failed:","john",item.getID().toString());
		item.setItem(null);
		assertEquals("QueryListItem.getID failed:","john",item.getID().toString());
	}

	public void testToString() {
		IQuery query = new Query(new QueryID("88"), null);
		query.setDisplayName("fred");
		item.setDisplayName("one-two");
		item.setID(new QueryID("whoa"));
		assertEquals("QueryListItem.toString failed:","one-two",item.toString());
		item.setItem(query);
		assertEquals("QueryListItem.toString failed:","fred",item.toString());
		item.setItem(null);
		assertEquals("QueryListItem.toString failed:","fred",item.toString());
	}

	public void testEqualsObject() {
		IQuery query = new Query(new QueryID("88"), null);
		query.setDisplayName("frEd");
		item.setDisplayName("one-two");
		item.setID(new QueryID("whoa"));
		item.setItem(query);
		item.setDisplayName("waa");
		ISoftListItem item2 = new QueryListItem(new QueryID("88"), "fred", refManager);
		assertTrue("QueryListItem.equals failed: items not equal.",item.equals(item2));
	}

	public void testCompareTo() {
		IQuery query = new Query(new QueryID("88"), null);
		query.setDisplayName("a1");
		item.setDisplayName("one-two");
		item.setID(new QueryID("whoa"));
		item.setItem(query);
		ISoftListItem item2 = new QueryListItem(new QueryID("87"), "A2", refManager);
		ISoftListItem item3 = new QueryListItem(new QueryID("89"), "adam", refManager);
		assertTrue("QueryListItem.compareTo failed: item & item2 compare wrong.",item.compareTo(item2)<0);
		assertTrue("QueryListItem.compareTo failed: item & item3 compare wrong.",item.compareTo(item3)<0);
		assertTrue("QueryListItem.compareTo failed: item2 & item3 compare wrong.",item2.compareTo(item3)<0);
		assertTrue("QueryListItem.compareTo failed: item3 & item2 compare wrong.",item3.compareTo(item2)>0);
	}
	
	public void testConstructorFull() {
		IQuery query = new Query(new QueryID("88"), null);
		query.setDisplayName("fred");
		item = new QueryListItem(new QueryID("44"), query, "jane", refManager);
		assertEquals("QueryListItem constructor failed:","fred",item.getDisplayName());
		assertEquals("QueryListItem constructor failed:","88",item.getID().toString());
		assertNotNull("QueryListItem constructor failed: item is null.",item.getItem());
		item.setItem(null);
		assertEquals("QueryListItem constructor failed:","fred",item.getDisplayName());
		assertEquals("QueryListItem constructor failed:","88",item.getID().toString());
	}
	
	protected void setUp() throws Exception {
		super.setUp();
		item = new QueryListItem();
		item.setReferenceManager(new HardReferenceManager());
	}

}
