/*
 * Created on Jul 2, 2003 by vhaislmonsos
 */
package gov.va.med.hds.querytool.test;

import gov.va.med.hds.querytool.ISensitiveDataModel;
import gov.va.med.hds.querytool.ISensitiveList;
import gov.va.med.hds.querytool.SensitiveDataModel;
import gov.va.med.hds.querytool.SensitivePatientException;
import gov.va.med.hds.querytool.dao.ISensitiveDataDAO;

import javax.swing.text.Document;

/**
 * Tests the SensitiveDataModel.
 */
public class SensitiveDataModelTest extends MAbstractTestCase {
	private ISensitiveDataModel model;
	private ISensitiveDataDAO dataDAO;

	public SensitiveDataModelTest(String name) {
		super(name);
	}

	public static void main(String[] args) {
		junit.textui.TestRunner.run(SensitiveDataModelTest.class);
	}

	protected void setUp() throws Exception {
		super.setUp();
		dataDAO = (ISensitiveDataDAO)daoRegistry.getDAO(ISensitiveDataDAO.class.getName());
		model = new SensitiveDataModel(getRuntime(),dataDAO);
	}

	public void testGetSensitivePtList() throws InterruptedException {
		ISensitiveList list = model.getSensitivePtList();
		synchronized(Thread.currentThread()) {
			Thread.currentThread().wait(200);
		}
		assertEquals("SensitiveDataModel.getSensitivePtList failed:",10,list.getSize());
	}

	public void testSetSensitiveMessagePatient() throws SensitivePatientException, InterruptedException {
		Document doc = model.getSensitiveMessageModel();
		ISensitiveList list = model.getSensitivePtList();
		synchronized(Thread.currentThread()) {
			Thread.currentThread().wait(200);
		}
		model.setSensitiveMessagePatient(list.getItem(0));
		synchronized(Thread.currentThread()) {
			Thread.currentThread().wait(200);
		}
		assertEquals("SensitiveDataModel.setSensitiveMessagePatient failed:",60,doc.getLength());
	}

	public void testGetSensitiveMessageModel() {
		Document doc = model.getSensitiveMessageModel();
		assertNotNull("SensitiveDataModel.getSensitiveMessageModel failed:",doc);
	}

}
