package gov.va.med.hds.querytool.ui.test;

import gov.va.med.hds.querytool.dao.QueryDAOException;
import gov.va.med.hds.querytool.ui.IQueryPanelItems;
import gov.va.med.hds.querytool.ui.QueryPanelFactory;

import java.util.List;

import junit.framework.TestCase;

/**
 * @author vhaislmonsos
 *
 * Jan 24, 2003 9:07:48 AM
 */
public class QueryPanelFactoryTest extends TestCase {
	private QueryPanelFactory factory;

	/**
	 * Constructor for QueryPanelFactoryTest.
	 * @param arg0
	 */
	public QueryPanelFactoryTest(String arg0) {
		super(arg0);
	}

	public static void main(String[] args) {
		junit.textui.TestRunner.run(QueryPanelFactoryTest.class);
	}

	/**
	 * @see junit.framework.TestCase#setUp()
	 */
	protected void setUp() throws Exception {
		super.setUp();
		factory = new QueryPanelFactory();
	}
	
	public void testGetPanels() throws QueryDAOException {
		List panels = factory.getPanels();
		assertEquals("QueryPanelFactory.getPanels failed:",5,panels.size());
		assertEquals("QueryPanelFactory.getPanels failed:",38,factory.getButtons().size());
		assertEquals("QueryPanelFactory.getPanels failed:",35,factory.getButtonMap().values().size());
		
		assertEquals("QueryPanelFactory.getPanels failed:","2000500",((IQueryPanelItems)panels.get(1)).getDependencies().get(0).toString());
		assertEquals("QueryPanelFactory.getPanels failed:","3000500",((IQueryPanelItems)panels.get(2)).getDependencies().get(0).toString());
		assertEquals("QueryPanelFactory.getPanels failed:","4000500",((IQueryPanelItems)panels.get(3)).getDependencies().get(0).toString());
		assertEquals("QueryPanelFactory.getPanels failed:","5000500",((IQueryPanelItems)panels.get(4)).getDependencies().get(0).toString());
		
		assertEquals("QueryPanelFactory.getPanels failed:","Create Custom Report - Search Items",((IQueryPanelItems)panels.get(0)).getTitle());
		assertEquals("QueryPanelFactory.getPanels failed:","Create Custom Report - Orders",((IQueryPanelItems)panels.get(1)).getTitle());
		assertEquals("QueryPanelFactory.getPanels failed:","Create Custom Report - Consults",((IQueryPanelItems)panels.get(2)).getTitle());
		assertEquals("QueryPanelFactory.getPanels failed:","Create Custom Report - Documents",((IQueryPanelItems)panels.get(3)).getTitle());
		assertEquals("QueryPanelFactory.getPanels failed:","Create Custom Report - Appointments / Visits",((IQueryPanelItems)panels.get(4)).getTitle());
	}

}
