package gov.va.med.hds.querytool.ui.types.test;

import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.TreeMap;

import gov.va.med.hds.querytool.ui.types.CheckBoxSelection;

import junit.framework.TestCase;

/**
 * @author vhaislmonsos
 *
 * Dec 16, 2002 11:30:00 AM
 */
public class CheckBoxSelectionTest extends TestCase {

	/**
	 * Constructor for CheckBoxSelectionTest.
	 * @param arg0
	 */
	public CheckBoxSelectionTest(String arg0) {
		super(arg0);
	}

	public static void main(String[] args) {
		junit.textui.TestRunner.run(CheckBoxSelectionTest.class);
	}

	public void testAll() {
		CheckBoxSelection panel = new CheckBoxSelection();
		panel.add("alpha","wawawa",true);
		panel.add("fred","wawawa",false);
		panel.add("1","wawawa",true);
		panel.add("22","wawawa",false);
		panel.add("asdas","wawawa",true);
		panel.add("3","wawawa",false);
		panel.add("4","wawawa",true);
		panel.add("7","wawawa",false);
		List selectedItems = panel.getSelectedItems();
		assertEquals("CheckBoxSelection.getSelectedItems failed:",4,selectedItems.size());
		assertTrue("CheckBoxSelection.getSelectedItems failed: item not found.",selectedItems.contains("alpha"));
		assertTrue("CheckBoxSelection.getSelectedItems failed: item not found.",selectedItems.contains("1"));
		assertTrue("CheckBoxSelection.getSelectedItems failed: item not found.",selectedItems.contains("asdas"));
		assertTrue("CheckBoxSelection.getSelectedItems failed: item not found.",selectedItems.contains("4"));
		panel.setSelected("alpha",false);
		panel.setSelected("1",false);
		panel.setSelected("asdas",false);
		panel.setSelected("4",false);
		selectedItems = panel.getSelectedItems();
		assertEquals("CheckBoxSelection.getSelectedItems failed:",0,selectedItems.size());
		panel.setSelected("7",false);
		panel.setSelected("4",false);
		selectedItems = panel.getSelectedItems();
		assertEquals("CheckBoxSelection.getSelectedItems failed:",0,selectedItems.size());
		panel.setSelected("7",true);
		panel.setSelected("4",true);
		selectedItems = panel.getSelectedItems();
		assertEquals("CheckBoxSelection.getSelectedItems failed:",2,selectedItems.size());
		assertTrue("CheckBoxSelection.getSelectedItems failed: item not found.",selectedItems.contains("4"));
		assertTrue("CheckBoxSelection.getSelectedItems failed: item not found.",selectedItems.contains("7"));
	}
	
	public void testSetItems() {
		CheckBoxSelection panel = new CheckBoxSelection();
		Map items = new HashMap();
		items.put("fred","qhjaskdfhj ashfjk");
		items.put("1","as sjkldjf jskdld jfkls");
		items.put("#45893","wewewewe");
		TreeMap treeMap = new TreeMap();
		for (Iterator i = items.entrySet().iterator(); i.hasNext();) {
			Map.Entry e = (Map.Entry) i.next();
			treeMap.put(e.getValue().toString()+e.getKey().toString(),e);
		}
		panel.setItems(treeMap);
		List selectedItems = panel.getSelectedItems();
		assertEquals("CheckBoxSelection.getSelectedItems failed:",0,selectedItems.size());
		
		items = new HashMap();
		items.put("joe","qhjaskdfhj ashfjk");
		items.put("john","as sjkldjf jskdld jfkls");
		items.put("##45893","wewewewe");
		treeMap = new TreeMap();
		for (Iterator i = items.entrySet().iterator(); i.hasNext();) {
			Map.Entry e = (Map.Entry) i.next();
			treeMap.put(e.getValue().toString()+e.getKey().toString(),e);
		}
		panel.setItems(treeMap);
		panel.setSelected("john",true);
		panel.setSelected("##45893",true);
		selectedItems = panel.getSelectedItems();
		assertEquals("CheckBoxSelection.getSelectedItems failed:",2,selectedItems.size());
		assertTrue("CheckBoxSelection.getSelectedItems failed: item not found.",selectedItems.contains("##45893"));
		assertTrue("CheckBoxSelection.getSelectedItems failed: item not found.",selectedItems.contains("john"));
		
	}
	
	public void testSortedReturnItems() {
		CheckBoxSelection panel = new CheckBoxSelection();
		Map items = new HashMap();
		items.put("2","yak");
		items.put("1","zebra");
		items.put("45893","ardvark");
		items.put("50000","beastly");
		TreeMap treeMap = new TreeMap();
		for (Iterator i = items.entrySet().iterator(); i.hasNext();) {
			Map.Entry e = (Map.Entry) i.next();
			treeMap.put(e.getValue().toString()+e.getKey().toString(),e);
		}
		panel.setItems(treeMap);
		panel.setSelected("50000",true);
		panel.setSelected("45893",true);
		panel.setSelected("2",true);
		panel.setSelected("1",true);
		List selectedItems = panel.getSelectedItems();
		assertEquals("CheckBoxSelection.getSelectedItems failed:",4,selectedItems.size());
		assertEquals("CheckBoxSelection.getSelectedItems failed:","45893",(String)selectedItems.get(0));
		assertEquals("CheckBoxSelection.getSelectedItems failed:","50000",(String)selectedItems.get(1));
		assertEquals("CheckBoxSelection.getSelectedItems failed:","2",(String)selectedItems.get(2));
		assertEquals("CheckBoxSelection.getSelectedItems failed:","1",(String)selectedItems.get(3));
		
		panel = new CheckBoxSelection();
		items = new HashMap();
		items.put("2","yaaaaaa");
		items.put("1","yaaaaaa");
		items.put("45893","yaaaaaa");
		items.put("50000","yaaaaaa");
		treeMap = new TreeMap();
		for (Iterator i = items.entrySet().iterator(); i.hasNext();) {
			Map.Entry e = (Map.Entry) i.next();
			treeMap.put(e.getValue().toString()+e.getKey().toString(),e);
		}

		panel.setItems(treeMap);
		panel.setSelected("50000",true);
		panel.setSelected("45893",true);
		panel.setSelected("2",true);
		panel.setSelected("1",true);
		selectedItems = panel.getSelectedItems();
		assertEquals("CheckBoxSelection.getSelectedItems failed:",4,selectedItems.size());
		assertEquals("CheckBoxSelection.getSelectedItems failed:","1",(String)selectedItems.get(0));
		assertEquals("CheckBoxSelection.getSelectedItems failed:","2",(String)selectedItems.get(1));
		assertEquals("CheckBoxSelection.getSelectedItems failed:","45893",(String)selectedItems.get(2));
		assertEquals("CheckBoxSelection.getSelectedItems failed:","50000",(String)selectedItems.get(3));
	}
}
