package gov.va.med.hds.querytool.ui.types.test;

import gov.va.med.hds.cd.runtime.test.RuntimeTestCase;
import gov.va.med.hds.querytool.ui.types.EditorException;
import gov.va.med.hds.querytool.ui.types.EditorPanel;
import gov.va.med.hds.querytool.ui.types.FreeTextPanel;
import java.util.ArrayList;
import java.util.List;

/**
 * @author vhaislmonsos
 *
 * Dec 15, 2002 8:48:56 PM
 */
public class FreeTextPanelTest extends RuntimeTestCase {
	/**
	 * Constructor for FreeTextPanelTest.
	 * @param arg0
	 */
	public FreeTextPanelTest(String arg0) {
		super(arg0);
	}

	public static void main(String[] args) {
		junit.textui.TestRunner.run(FreeTextPanelTest.class);
	}

	/**
	 * @see junit.framework.TestCase#setUp()
	 */
	protected void setUp() throws Exception {
		super.setUp();
		parseRegistryResource("registry.xml");
	}
	
	public void testFreeTextPanel_empty() throws EditorException {
		EditorPanel editorPanel = new FreeTextPanel();
		editorPanel.setRuntime(getRuntime());
		editorPanel.init();
		assertEquals("DateRangePanel.getDisplayText failed:","",editorPanel.getDisplayText());
		assertEquals("DateRangePanel.getValues failed:",0,editorPanel.getValues().size());

	}

	public void testFreeTextPanel() throws EditorException {
		EditorPanel editorPanel = new FreeTextPanel();
		List values = new ArrayList();
		values.add(new String("TeSt StRiNg!.!"));
		editorPanel.setValues(values);
		editorPanel.setRuntime(getRuntime());
		editorPanel.init();
		assertEquals("DateRangePanel.getDisplayText failed:","TeSt StRiNg!.!",editorPanel.getDisplayText());
		assertEquals("DateRangePanel.getValues failed:",1,editorPanel.getValues().size());
		String val = (String)editorPanel.getValues().get(0);
		assertEquals("DateRangePanel.getValues failed:","TeSt StRiNg!.!",val);

	}

}
