package gov.va.med.hds.querytool.ui.types.test;

import gov.va.med.hds.cd.runtime.test.RuntimeTestCase;
import gov.va.med.hds.querytool.ui.types.EditorException;
import gov.va.med.hds.querytool.ui.types.EditorPanel;
import gov.va.med.hds.querytool.ui.types.OrderStatusStrategy;
import gov.va.med.hds.querytool.ui.types.ShortChecklistPanel;
import java.util.ArrayList;
import java.util.List;

/**
 * @author vhaislmonsos
 *
 * Dec 16, 2002 11:48:31 AM
 */
public class ShortChecklistPanelTest extends RuntimeTestCase {

	/**
	 * Constructor for OrderStatusPanelTest.
	 * @param arg0
	 */
	public ShortChecklistPanelTest(String arg0) {
		super(arg0);
	}

	public static void main(String[] args) {
		junit.textui.TestRunner.run(ShortChecklistPanelTest.class);
	}

	/**
	 * @see junit.framework.TestCase#setUp()
	 */
	protected void setUp() throws Exception {
		super.setUp();
		parseRegistryResource("registry.xml");
	}

	public void testEmptyValue() throws EditorException {
		EditorPanel editorPanel = new ShortChecklistPanel(new OrderStatusStrategy());
		editorPanel.setRuntime(getRuntime());
		editorPanel.init();
		assertEquals("ShortChecklistPanel.getDisplayText failed:","",editorPanel.getDisplayText());
		assertEquals("ShortChecklistPanel.getValues failed:",0,editorPanel.getValues().size());
	}
	
	public void testValidValue() throws EditorException {
		List values = new ArrayList();
		values.add("10");
		EditorPanel editorPanel = new ShortChecklistPanel(new OrderStatusStrategy());
		editorPanel.setRuntime(getRuntime());
		editorPanel.init();
		editorPanel.setValues(values);
		assertEquals("ShortChecklistPanel.getDisplayText failed:","DELAYED",editorPanel.getDisplayText());
		assertEquals("ShortChecklistPanel.getValues failed:",1,editorPanel.getValues().size());
		String val = (String)editorPanel.getValues().get(0);
		assertEquals("ShortChecklistPanel.getValues failed:","10",val);
		values.clear();
		values.add("6");
		values.add("3");
		values.add("11");
		editorPanel.setValues(values);
		assertEquals("ShortChecklistPanel.getDisplayText failed:","ACTIVE or HOLD or UNRELEASED",editorPanel.getDisplayText());
		assertEquals("ShortChecklistPanel.getValues failed:",3,editorPanel.getValues().size());
		List curValues = editorPanel.getValues();
		assertTrue("ShortChecklistPanel.getValues failed: item not in selection.",curValues.contains("11"));
		assertTrue("ShortChecklistPanel.getValues failed: item not in selection.",curValues.contains("3"));
		assertTrue("ShortChecklistPanel.getValues failed: item not in selection.",curValues.contains("6"));
		
	}

}
