/*
 * Initially Created on Jul 17, 2003 by vhaislmonsos
 *
 */
package gov.va.med.hds.querytool.ui;

import gov.va.med.hds.querytool.IAvailableColumnsList;

import javax.swing.AbstractListModel;
import javax.swing.ListModel;
import javax.swing.SwingUtilities;
import javax.swing.event.ListDataEvent;
import javax.swing.event.ListDataListener;

/**
 * ListModel adapter for the IAvailableColumnsList model.
 */
public class AvailableColumnList
	extends AbstractListModel
	implements ListModel {
		
	private IAvailableColumnsList columnList;
	private ListDataListener listener = new ListDataListener() {
		public void intervalAdded(final ListDataEvent e) {
			processListChange(e);
		}

		public void intervalRemoved(final ListDataEvent e) {
			processListChange(e);
		}

		public void contentsChanged(final ListDataEvent e) {
			processListChange(e);
		}
	};

	public void setAvailableColumnModel(IAvailableColumnsList columnList) {
		if (this.columnList!=null) {
			this.columnList.removeListDataListener(listener);
		}
		this.columnList = columnList;
		if (columnList!=null) {
			columnList.addListDataListener(listener);
		}
	}

	public int getSize() {
		return columnList.size();
	}

	public Object getElementAt(int index) {
		return columnList.get(index);
	}

	private void processListChange(final ListDataEvent e) {
		if (!SwingUtilities.isEventDispatchThread()) {
			SwingUtilities.invokeLater(new Runnable() {
				public void run() {
					processListChange(e);
				}
			});
			return;
		}
		switch (e.getType()) {
			case ListDataEvent.CONTENTS_CHANGED: {
				fireContentsChanged(this, e.getIndex0(), e.getIndex1());
				break;
			}
			case ListDataEvent.INTERVAL_ADDED: {
				fireIntervalAdded(this, e.getIndex0(), e.getIndex1());
				break;
			}
			case ListDataEvent.INTERVAL_REMOVED: {
				fireIntervalRemoved(this, e.getIndex0(), e.getIndex1());
				break;
			}
		}
	}
	
}
