package gov.va.med.hds.querytool.ui;

import java.awt.Component;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BoxLayout;

/**
 * @author vhaislmonsos
 *
 */
public class CheckBoxPanel extends EnablePanel {
	private CheckBoxTag checkBox = new CheckBoxTag();
	private EnablePanel enablePanel = new EnablePanel();
	private GridBagConstraints c = new GridBagConstraints();

	/**
	 * Constructor for CheckBoxPanel.
	 */
	public CheckBoxPanel() {
		super();
		setLayout(new GridBagLayout());
		c.anchor = GridBagConstraints.WEST;
		c.fill = GridBagConstraints.NONE;
		c.gridheight = 1;
		c.gridwidth = 1;
		c.gridx = 0;
		c.gridy = 0;
		c.insets = new Insets(0,0,0,0);
		c.ipadx = 0;
		c.ipady = 0;
		c.weightx = 1.0;
		c.weighty = 1.0;
		add(checkBox,c);
		enablePanel.setLayout(new BoxLayout(enablePanel, BoxLayout.Y_AXIS));
		c.gridy = 1;
		c.insets = new Insets(0,15,0,0);
		add(enablePanel,c);
		checkBox.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				fireUpdateCheckBox();
			}
		});
	}
	
	public void setCheckBoxText(String text) {
		checkBox.setText(text);
	}
	
	public void setCheckBoxTag(Object tag) {
		checkBox.setTag(tag.toString());
	}
	
	public CheckBoxTag getCheckBox() {
		return checkBox;
	}
	
	public Component add(Component c) {
		Component result = enablePanel.add(c);
		return result;
	}
	
	public void fireUpdateCheckBox() {
		enablePanel.setEnabled(checkBox.isSelected());
	}

	/**
	 * @see java.awt.Component#setEnabled(boolean)
	 */
	public void setEnabled(boolean enabled) {
		if (enabled) {
			this.setEnabled(enabled);
			checkBox.setEnabled(enabled);
		}
		else {
			if (checkBox.isSelected()) {
				checkBox.doClick();
			}
			else {
				fireUpdateCheckBox();
			}
			checkBox.setEnabled(enabled);
			this.setEnabled(enabled);
		}
	}

}
