/*
 * Initially Created on Jun 5, 2003 by vhaislmonsos
 *
 */
package gov.va.med.hds.querytool.ui;

import gov.va.med.hds.cd.spectrum.checklist.CheckList;

import java.awt.BorderLayout;

import javax.swing.Action;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.ListModel;
import javax.swing.border.EmptyBorder;
import javax.swing.event.ListSelectionListener;

/**
 * Container for a CheckList and a select all button and a select none button.
 */
public class CheckListPanel extends JPanel implements ICheckListPanel {
	private CheckList checkList = new CheckList();
	private JButton selectAllButton = new JButton();
	private JButton selectNoneButton = new JButton();
	private JScrollPane checkListScrollPane;

	/**
	 * Sets up a border layout.
	 */
	public CheckListPanel() {
		super();
		setLayout(new BorderLayout());
		checkListScrollPane = new JScrollPane(checkList);
		add(checkListScrollPane, BorderLayout.CENTER);
		
		JPanel buttonPanel = new JPanel();
		buttonPanel.setBorder(new EmptyBorder(3,3,3,3));
		buttonPanel.setLayout(new BoxLayout(buttonPanel, BoxLayout.X_AXIS));
		buttonPanel.add(Box.createHorizontalGlue());
		buttonPanel.add(selectAllButton);
		buttonPanel.add(Box.createHorizontalStrut(15));
		buttonPanel.add(selectNoneButton);
		buttonPanel.add(Box.createHorizontalGlue());
		add(buttonPanel, BorderLayout.SOUTH);
		
	}
	
	public void setSelectAllAction(Action action) {
		selectAllButton.setAction(action);
	}
	
	public void setSelectNoneAction(Action action) {
		selectNoneButton.setAction(action);
	}
	
	public void setListModel(ListModel model) {
		checkList.setModel(model);
	}

	public static final void main(String args[]) {
		JFrame frame = new JFrame("CheckListPanel");
		CheckListPanel checkListPanel = new CheckListPanel();
		frame.getContentPane().add(checkListPanel);
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		frame.pack();
		frame.show();
	}

	public void addListSelectionListener(ListSelectionListener listListener) {
		checkList.getSelectionModel().addListSelectionListener(listListener);
	}

	public void removeListSelectionListener(ListSelectionListener listListener) {
		checkList.getSelectionModel().removeListSelectionListener(listListener);
	}

	public int[] getSelectedIndices() {
		return checkList.getSelectedIndices();
	}
	
}
