package gov.va.med.hds.querytool.ui;
import gov.va.med.hds.cd.spectrum.list.AssertList;
import gov.va.med.hds.cd.spectrum.list.IAssertListener;

import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.ListModel;
import javax.swing.ListSelectionModel;
import javax.swing.event.ListSelectionListener;

public class ChooseSearchPanel extends JPanel {
	private JPanel topPanel = new JPanel();
	private JPanel bottomPanel = new JPanel();
	private JLabel label = new JLabel();
	private JScrollPane listScroll = new JScrollPane();
	private AssertList reportList = new AssertList();

	public ChooseSearchPanel() {
		init();
	}

	private void init() {
		this.setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
		topPanel.setLayout(new BoxLayout(topPanel, BoxLayout.X_AXIS));
		bottomPanel.setLayout(new BoxLayout(bottomPanel, BoxLayout.X_AXIS));
		label.setText("Choose or create a query search report");
		this.add(topPanel);
		listScroll.getViewport().add(reportList);
		bottomPanel.add(listScroll);
		this.add(bottomPanel);
		topPanel.add(label);
		topPanel.add(Box.createHorizontalGlue());
		reportList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
	}
	
	public void addUserSelectionListener(IAssertListener listener) {
		reportList.addAssertListener(listener);
	}
	
	public void addListSelectionListener(ListSelectionListener listener) {
		reportList.addListSelectionListener(listener);
	}
	
	public void setModel(ListModel listModel) {
		reportList.setModel(listModel);
	}
	
	/**
	 * Method getSelectedIndex.
	 * @return int
	 */
	public int getSelectedIndex() {
		return reportList.getSelectedIndex();
	}

	/**
	 * Method getSelectedValue.
	 */
	public Object getSelectedValue() {
		return reportList.getSelectedValue();
	}

	public static final void main(String args[]) {
		JFrame frame = new JFrame("ChooseSearchPanel");
		ChooseSearchPanel chooseSearchPanel = new ChooseSearchPanel();
		frame.getContentPane().add(chooseSearchPanel);
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		frame.pack();
		frame.show();
	}
	
	public void removeUserSelectionListener(IAssertListener l) {
		reportList.removeAssertListener(l);
	}
	
	public void removeListSelectionListener(ListSelectionListener l) {
		reportList.removeListSelectionListener(l);
	}

	/**
	 * Sets the selected index.
	 * @param index
	 */
	public void setSelectedIndex(int index) {
		reportList.setSelectedIndex(index);
		reportList.ensureIndexIsVisible(index);
	}

}