/*
 * Initially Created on Mar 11, 2003 by vhaislmonsos
 *
 */
package gov.va.med.hds.querytool.ui;

import javax.swing.table.DefaultTableColumnModel;
import javax.swing.table.TableColumn;
import javax.swing.table.TableColumnModel;

import gov.va.med.hds.querytool.IDisplayField;
import gov.va.med.hds.querytool.IQuery;

/**
 * Creates a display column model based on the query.
 */
public class ColumnModelFactory {

	public static TableColumnModel getModel(IQuery q) {
		TableColumnModel model = new DefaultTableColumnModel();
		for (int i = 0; i < q.getDisplayFields().size(); i++) {
			IDisplayField field = q.getDisplayFields().get(i);
			TableColumn col = new TableColumn();
			col.setHeaderValue(field.getDisplayText());
			col.setIdentifier(field);
			col.setModelIndex(i);
			col.setPreferredWidth(field.getColumnWidth());
			col.setResizable(true);
			col.setWidth(field.getColumnWidth());
			model.addColumn(col);
		}
		return model;
	}
}
