/*
 * Initially Created on Jun 9, 2003 by vhaislmonsos
 *
 */
package gov.va.med.hds.querytool.ui;

import gov.va.med.hds.cd.runtime.IRuntimeContext;
import gov.va.med.hds.querytool.ui.editor.factory.IEditorFactory;

/**
 * Editor factory factory interface.
 */
public interface IEditorFactoryFactory {
	
	/**
	 * Uses the runtime to get the factory information from the manifest.
	 * @param runtime
	 * @throws FactoryException
	 */
	void setRuntime(IRuntimeContext runtime) throws FactoryException;
	
	/**
	 * Returns an instance of a factory.
	 * @param key
	 * @return factoryInstance
	 * @throws FactoryException
	 */
	IEditorFactory getFactory(Object key) throws FactoryException;
	
}