/*
 * Initially Created on Jun 4, 2003 by vhaislmonsos
 *
 */
package gov.va.med.hds.querytool.ui;

import gov.va.med.hds.cd.runtime.IRuntimeContext;
import gov.va.med.hds.cd.spectrum.linkpanel.IHTMLSelectionModel;
import gov.va.med.hds.querytool.IDetailReceivable;
import gov.va.med.hds.querytool.IPatDetailReceivable;
import gov.va.med.hds.querytool.IQueryAction;
import gov.va.med.hds.querytool.IQueryTool;

/**
 * Interface for the page to view query results.
 */
public interface IViewReport extends IDetailReceivable,IPatDetailReceivable,IQueryPage {
	
	/**
	 * Sets the print helper model, so the view can complete the helper setup for printing.
	 * @param printHelper
	 */
	void setPrintHelper(IPrintHelper printHelper);

	/**
	 * @param listener
	 */
	void addQueryActionListener(IQueryAction l);
	
	/**
	 * @param listener
	 */
	void removeQueryActionListener(IQueryAction l);
	
	/**
	 * Sets the main model.
	 * @param queryTool
	 */
	void setQueryModel(IQueryTool queryTool);
	
	/**
	 * Sets the HTML selection model, which provides an HTML display string of the current query.
	 * @param model
	 */
	void setQueryHTMLModel(IHTMLSelectionModel model);

	/**
	 * Resets the page based on the current state of the query tool model.
	 */
	void initialize();
	
	/**
	 * @param runtime
	 */
	void setRuntime(IRuntimeContext runtime);

}