/*
 * Initially Created on May 30, 2003 by vhaislmonsos
 *
 */
package gov.va.med.hds.querytool.ui;

import gov.va.med.hds.cd.spectrum.linkpanel.HTMLSelectionModel;
import gov.va.med.hds.cd.spectrum.linkpanel.HTMLSelectionPanel;
import gov.va.med.hds.cd.spectrum.linkpanel.IHTMLSelectionModel;
import gov.va.med.hds.cd.spectrum.linkpanel.ISelectionEventListener;
import gov.va.med.hds.querytool.HTMLQueryTextFactory;
import gov.va.med.hds.querytool.IQuery;

import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;

import javax.swing.SwingUtilities;

/**
 * Encapsulates the HTMLSelectionPanel for a query.
 */
public class QueryHTMLPanel
	extends HTMLSelectionPanel
	implements IQueryHTMLPanel {
	private IHTMLSelectionModel selectionModel = new HTMLSelectionModel();
	private IQuery query;
	private PropertyChangeListener changeListener = new PropertyChangeListener() {
		public void propertyChange(PropertyChangeEvent evt) {
			processChangeEvent(query);
		}
	};

	public QueryHTMLPanel() {
		super();
		setModel(selectionModel);
	}

	public void setQueryModel(IQuery query) {
		if (this.query!=null) {
			this.query.removePropertyChangeListener(changeListener);
		}
		this.query = query;
		if (query!=null) {
			query.addPropertyChangeListener(changeListener);
			if (!query.isChanging()) {
				processChangeEvent(query);
			}
		}
		else {
			processChangeEvent(null);
		}
	}

	private void processChangeEvent(final IQuery query) {
		if (!SwingUtilities.isEventDispatchThread()) {
			SwingUtilities.invokeLater(new Runnable() {
				public void run() {
					processChangeEvent(query);
				}
			});
			return;
		}
		HTMLQueryTextFactory.updateText(selectionModel, query);
	}

	public void addSelectionEventListener(ISelectionEventListener listener) {
		selectionModel.addEventListener(listener);
	}

	public void removeSelectionEventListener(ISelectionEventListener listener) {
		selectionModel.removeEventListener(listener);
	}

	public IHTMLSelectionModel getSelectionModel() {
		return selectionModel;
	}
	
}
