/*
 * Initially Created on Apr 24, 2003 by vhaislmonsos
 *
 */
package gov.va.med.hds.querytool.ui;

import gov.va.med.hds.querytool.ICombinedQueryCollection;
import gov.va.med.hds.querytool.IQueryCollectionEvent;
import gov.va.med.hds.querytool.IQueryCollectionListener;

import java.util.ArrayList;
import java.util.List;

import javax.swing.AbstractListModel;
import javax.swing.SwingUtilities;

/**
 * ListModel adapter for the ICombinedQueryCollection.
 */
public class QueryListModel extends AbstractListModel implements IQueryListModel {
	private ICombinedQueryCollection queryCollection;
	private IQueryCollectionListener collectionListener = new IQueryCollectionListener() {
		public void collectionChanged(final IQueryCollectionEvent event) {
			if (SwingUtilities.isEventDispatchThread()) {
				fireDataChange(event);
			}
			else {
				SwingUtilities.invokeLater(new Runnable() {
					public void run() {
						fireDataChange(event);
					}
				});
			}
		}
	};
	private List stringList = new ArrayList();
	private final String BLANKS = "     ";
	private final String CUSTOM_QUERY_STRING = "Create Custom Search...";

	public QueryListModel() {
		super();
		stringList.add(BLANKS);
		stringList.add(CUSTOM_QUERY_STRING);
		stringList.add(BLANKS);
	}

	public int getSize() {
		return stringList.size()+queryCollection.getSize();
	}

	public Object getElementAt(int index) {
		if (index<queryCollection.getPredefinedQuerySize() && index>-1) {
			return queryCollection.getPredefinedQueryItem(index);
		}
		else {
			index -= queryCollection.getPredefinedQuerySize();
			if (index < stringList.size() && index>-1) {
				return stringList.get(index);
			}
			else {
				index -= stringList.size();
				if (index < queryCollection.getUserDefinedQuerySize() && index>-1) {
					return queryCollection.getUserQueryItem(index);
				}
			}
		}
		return null;
	}
	
	public void setModel(ICombinedQueryCollection collection) {
		if (this.queryCollection!=null) {
			queryCollection.removeChangeListener(collectionListener);
		}
		this.queryCollection = collection;
		if (queryCollection!=null) {
			collection.addChangeListener(collectionListener);
		}
	}

	public void fireDataChange(IQueryCollectionEvent event) {
		fireContentsChanged(this, 0, stringList.size()+queryCollection.getSize()-1);
	}

	public boolean isQueryItem(Object item) {
		return !(item instanceof String);
	}

	public boolean isCustomQuerySelection(Object item) {
		return item instanceof String && item.equals(this.CUSTOM_QUERY_STRING);
	}

}
