/*
 * Initially Created on May 29, 2003 by vhaislmonsos
 *
 */
package gov.va.med.hds.querytool.ui;

import gov.va.med.hds.cd.help.IHelp;

import java.awt.CardLayout;
import java.util.HashMap;
import java.util.Map;

import javax.swing.JComponent;
import javax.swing.JPanel;

/**
 * Query page container for the querytool UI
 */
public class QueryPages extends JPanel implements IQueryPages {
	private CardLayout cardLayout;
	private Map pageMap = new HashMap();
	private static final String ROOT_HELPID = "gov.va.med.hds.querytool.intro";


	public QueryPages() {
		super();
		setLayout(cardLayout=new CardLayout(2,2));
		addHelpIds();
	}

	public boolean selectPage(String pageKey) {
		if (pageMap.containsKey(pageKey)) {
			cardLayout.show(this, pageKey);
			return true;
		}
		return false;
	}

	public void addPage(String pageKey, JComponent page) {
		cardLayout.addLayoutComponent(page, pageKey);
		add(page, pageKey);
		pageMap.put(pageKey, page);
	}

	public boolean contains(String pageKey) {
		return pageMap.containsKey(pageKey);
	}

	private void addHelpIds() {
		this.putClientProperty(IHelp.HELPID_CLIENT_PROPERTY_KEY, ROOT_HELPID);
	}
}
