/*
 * Initially Created on Jul 17, 2003 by vhaislmonsos
 *
 */
package gov.va.med.hds.querytool.ui;

import gov.va.med.hds.querytool.IAvailableColumnsList;
import gov.va.med.hds.querytool.IDisplayField;

import javax.swing.SwingUtilities;
import javax.swing.event.ListDataEvent;
import javax.swing.event.ListDataListener;
import javax.swing.table.AbstractTableModel;
import javax.swing.table.TableModel;

/**
 * Implements a table model from the querytool IAvailableColumnsList as a base.
 */
public class SampleTableModel
	extends AbstractTableModel
	implements TableModel {
		
	private IAvailableColumnsList columnsList;
	private ListDataListener listener = new ListDataListener() {
		public void intervalAdded(final ListDataEvent e) {
			processListChange();
		}

		public void intervalRemoved(final ListDataEvent e) {
			processListChange();
		}

		public void contentsChanged(final ListDataEvent e) {
			processListChange();
		}
		
	};
	
	public void setAvailableColumnsModel(IAvailableColumnsList columnsList) {
		if (this.columnsList!=null) {
			this.columnsList.removeListDataListener(listener);
		}
		this.columnsList = columnsList;
		if (columnsList!=null) {
			columnsList.addListDataListener(listener);
		}
	}

	private void processListChange() {
		if (!SwingUtilities.isEventDispatchThread()) {
			SwingUtilities.invokeLater(new Runnable() {
				public void run() {
					processListChange();
				}
			});
			return;
		}
		fireTableStructureChanged();
	}

	public SampleTableModel() {
		super();
	}

	public int getRowCount() {
		if (columnsList.size()>0) {
			IDisplayField field = columnsList.get(0);
			if (field!=null) {
				return field.getSampleData().length;
			}
		}
		return 0;
	}

	public int getColumnCount() {
		return columnsList.size();
	}

	public Object getValueAt(int rowIndex, int columnIndex) {
		if (rowIndex<0 || rowIndex>1 || columnIndex<0 || columnIndex>columnsList.size()-1) return null;
		IDisplayField item = columnsList.get(columnIndex);
		if (item==null) return null;
		return item.getSampleData()[rowIndex];
	}

}
