/*
 * Initially Created on Apr 11, 2003 by vhaislmonsos
 *
 */
package gov.va.med.hds.querytool.ui;

import java.awt.Dimension;
import java.awt.LayoutManager;
import java.awt.Rectangle;

import javax.swing.JPanel;
import javax.swing.Scrollable;
import javax.swing.UIManager;

/**
 * Supports scrolling in the JScrollPane by the size of the L&F label font size.
 * Otherwise, a JPanel of this sort in a JScrollPane is scrolled a pixel at a time.
 */
public class ScrollableJPanel extends JPanel implements Scrollable {
	private int unitIncrement = 1;
	private int blockIncrement = 10 * unitIncrement;

	/**
	 * Delegates to parent.
	 * @param layout
	 * @param isDoubleBuffered
	 */
	public ScrollableJPanel(LayoutManager layout, boolean isDoubleBuffered) {
		super(layout, isDoubleBuffered);
		init();
	}

	/**
	 * Delegates to parent.
	 * @param layout
	 */
	public ScrollableJPanel(LayoutManager layout) {
		super(layout);
		init();
	}

	/**
	 * Delegates to parent.
	 * @param isDoubleBuffered
	 */
	public ScrollableJPanel(boolean isDoubleBuffered) {
		super(isDoubleBuffered);
		init();
	}

	/**
	 * Delegates to parent.
	 */
	public ScrollableJPanel() {
		super();
		init();
	}

	public Dimension getPreferredScrollableViewportSize() {
		return getPreferredSize();
	}

	public int getScrollableUnitIncrement(
		Rectangle visibleRect,
		int orientation,
		int direction) {
		return unitIncrement;
	}

	public int getScrollableBlockIncrement(
		Rectangle visibleRect,
		int orientation,
		int direction) {
		return blockIncrement;
	}

	public boolean getScrollableTracksViewportWidth() {
		return false;
	}

	public boolean getScrollableTracksViewportHeight() {
		return false;
	}

	private void init() {
		unitIncrement = UIManager.getFont("Label.font").getSize();
		blockIncrement = unitIncrement * 10;
	}
}
