/*
 * Initially Created on Jun 5, 2003 by vhaislmonsos
 *
 */
package gov.va.med.hds.querytool.ui;

import gov.va.med.hds.querytool.ISensitiveList;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.AbstractListModel;
import javax.swing.SwingUtilities;

/**
 * ListModel adapter for the query tool sensitive patient list.
 */
public class SensitiveAdapter extends AbstractListModel implements ISensitiveAdapter {
	private ISensitiveList list;
	private ActionListener listener = new ActionListener() {
		public void actionPerformed(ActionEvent e) {
			fireCheckChange();
		}
	};

	public SensitiveAdapter() {
		super();
	}

	/**
	 * Signals this adapter to call its list change notification mechanism.
	 */
	protected void fireCheckChange() {
		if (!SwingUtilities.isEventDispatchThread()) {
			SwingUtilities.invokeLater(new Runnable() {
				public void run() {
					fireCheckChange();
				}
			});
			return;
		}
		
		fireContentsChanged(this, 0, getSize()-1);
	}

	public int getSize() {
		if (list!=null) {
			return list.getSize();
		}
		else {
			return 0;
		}
	}

	public Object getElementAt(int index) {
		if (list!=null && list.getItem(index)!=null) {
			return list.getItem(index);
		}
		else {
			return null;
		}
	}
	
	public void setModel(ISensitiveList list) {
		if (this.list!=null) {
			this.list.removeActionListener(listener);
		}
		this.list = list;
		if (list!=null) {
			list.addActionListener(listener);
			fireCheckChange();
		}
	}
	
}
