package gov.va.med.hds.querytool.ui;

import gov.va.med.hds.querytool.ui.icon.DownArrowIcon;
import gov.va.med.hds.querytool.ui.icon.UpArrowIcon;

import java.awt.Dimension;

import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JPanel;

/**
 * Side button panel for the up/down buttons for column ordering in the querytool editor.
 */
public class SideButtonPanel extends JPanel {
	private static final int ICON_SIZE = 16;
	public JButton upButton = new JButton(new UpArrowIcon(ICON_SIZE,ICON_SIZE));
	public JButton downButton = new JButton(new DownArrowIcon(ICON_SIZE,ICON_SIZE));

	/**
	 * Constructor for SideButtonPanel.
	 */
	public SideButtonPanel() {
		super();
		upButton.getAccessibleContext().setAccessibleName("Shift element up");
		upButton.setToolTipText(upButton.getAccessibleContext().getAccessibleName());
		downButton.getAccessibleContext().setAccessibleName("Shift element down");
		downButton.setToolTipText(downButton.getAccessibleContext().getAccessibleName());
		
		setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
		this.add(Box.createVerticalStrut(60));
		
		upButton.setMaximumSize(new Dimension(ICON_SIZE+8, ICON_SIZE+8));
		upButton.setMinimumSize(new Dimension(ICON_SIZE+8, ICON_SIZE+8));
		upButton.setPreferredSize(new Dimension(ICON_SIZE+8, ICON_SIZE+8));
		this.add(upButton);
		
		downButton.setMaximumSize(new Dimension(ICON_SIZE+8, ICON_SIZE+8));
		downButton.setMinimumSize(new Dimension(ICON_SIZE+8, ICON_SIZE+8));
		downButton.setPreferredSize(new Dimension(ICON_SIZE+8, ICON_SIZE+8));
		this.add(downButton);
		
		this.add(Box.createVerticalStrut(20));
	}

	public static final void main(String args[]) {
		JFrame frame = new JFrame("SideButtonPanel");
		SideButtonPanel sideButtonPanel = new SideButtonPanel();
		frame.getContentPane().add(sideButtonPanel);
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

		frame.pack();
		frame.show();
	}

}
