package gov.va.med.hds.querytool.ui;

import javax.swing.BoxLayout;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.table.JTableHeader;
import javax.swing.table.TableColumnModel;
import javax.swing.table.TableModel;

/**
 * @author vhaislmonsos
 *
 */
public class TablePanel extends JPanel {
	private JLabel label = new JLabel("Report Preview   (Drag the header bar to set the initial column sizes.)");
	private JTable table = new JTable();
	private JScrollPane scrollPane;


	/**
	 * Constructor for TablePanel.
	 */
	public TablePanel() {
		super();
		this.setLayout(new BoxLayout(this,BoxLayout.Y_AXIS));
		this.add(label);
		scrollPane = new JScrollPane(table);
		table.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
		table.setAutoCreateColumnsFromModel(false);
		this.add(scrollPane);
	}

	/**
	 * Passes model along to the table.
	 * @param model
	 */
	public void setTableModel(TableModel model) {
		table.setModel(model);
		table.revalidate();
	}
	
	/**
	 * Delegates to table method.
	 * @param model
	 */
	public void setTableColumnModel(TableColumnModel model) {
		table.setColumnModel(model);
		table.revalidate();
	}

	public TableColumnModel getColumnModel() {
		return table.getColumnModel();
	}
	
	public TableModel getTableModel() {
		return table.getModel();
	}
	
	public JTableHeader getTableHeader() {
		return table.getTableHeader();
	}
	
}
