package gov.va.med.hds.querytool.ui;

import gov.va.med.hds.cd.spectrum.wizard.IWizardPage;

import javax.swing.JLabel;
import javax.swing.JPanel;

/**
 * Extends the "wait" wizard page set model.
 */
public class WaitPageSetModel
	extends gov.va.med.hds.cd.spectrum.wizard.WaitPageSetModel {
	private IWizardPage page = new WaitPage();

	/**
	 * Constructor for WaitPageSetModel.
	 */
	public WaitPageSetModel() {
		super();
	}

	/**
	 * @see gov.va.med.hds.cd.spectrum.WaitPageSetModel#getWaitPage()
	 */
	public IWizardPage getWaitPage() {
		return page;
	}
	
	private class WaitPage extends JPanel implements IWizardPage {
		
		public WaitPage() {
			super();
			this.add(new JLabel("Loading query data..."));
		}

		/**
		 * @see gov.va.med.hds.cd.spectrum.IWizardPage#getErrorMessage()
		 */
		public String getErrorMessage() {
			return "Please wait for the wizard pages to finish loading.";
		}

		/**
		 * @see gov.va.med.hds.cd.spectrum.IWizardPage#getTitle()
		 */
		public String getTitle() {
			return "Create Custom Report";
		}

		/**
		 * @see gov.va.med.hds.cd.spectrum.IWizardPage#isFinishAllowed()
		 */
		public boolean isFinishAllowed() {
			return false;
		}

		/**
		 * @see gov.va.med.hds.cd.spectrum.IWizardPage#isOkToGoNext()
		 */
		public boolean isOkToGoNext() {
			return false;
		}

	}

	public boolean isComplete() {
		return true;
	}

}
