/*
 * Initially Created on Mar 28, 2003 by vhaislmonsos
 *
 */
package gov.va.med.hds.querytool.ui.editor.factory;

import gov.va.med.hds.querytool.dao.factory.ClinicListFactory;
import gov.va.med.hds.querytool.dao.factory.ClinicRefFactory;
import gov.va.med.hds.querytool.ui.editor.IRunnableEditorPanel;
import gov.va.med.hds.querytool.ui.types.EditorException;
import gov.va.med.hds.querytool.ui.types.SingleBucketEditor;

/**
 * Implements IClinicListFactory and supplies a clinic list editor.
 */
public class ClinicListEditorFactory extends EditorFactory implements IClinicListFactory {

	public IRunnableEditorPanel getEditor() throws EditorException {
		SingleBucketEditor editor = new SingleBucketEditor();
		editor.setRuntime(runtime);
		editor.setDAORegistry(daoRegistry);
		editor.setBufferedListFactory(new ClinicListFactory());
		editor.setReferenceDAOFactory(new ClinicRefFactory());
		editor.setOutBucketLabel("Selected Clinics");
		editor.setWindowHeader("Clinic");
		return editor;
	}

}
