/*
 * Initially Created on Mar 28, 2003 by vhaislmonsos
 *
 */
package gov.va.med.hds.querytool.ui.editor.factory;

import gov.va.med.hds.querytool.dao.factory.ConsServAllRefFactory;
import gov.va.med.hds.querytool.dao.factory.ConsServListFactory;
import gov.va.med.hds.querytool.dao.factory.OrderItemRefFactory;
import gov.va.med.hds.querytool.ui.editor.IRunnableEditorPanel;
import gov.va.med.hds.querytool.ui.types.ConsultServiceEditor;
import gov.va.med.hds.querytool.ui.types.EditorException;

/**
 * Implements IConsultServiceFactory to provide an editor.
 */
public class ConsultServiceFactory
	extends EditorFactory
	implements IConsultServiceFactory {

	public IRunnableEditorPanel getEditor() throws EditorException {
		ConsultServiceEditor editor = new ConsultServiceEditor();
		editor.setRuntime(runtime);
		editor.setDAORegistry(daoRegistry);
		editor.setBufferedListFactory(new ConsServListFactory());
		editor.setReferenceDAOFactory(new OrderItemRefFactory());
		editor.setAllReferenceDAOFactoy(new ConsServAllRefFactory());
		return editor;
	}

}
