/*
 * Initially Created on Mar 28, 2003 by vhaislmonsos
 *
 */
package gov.va.med.hds.querytool.ui.editor.factory;

import gov.va.med.hds.querytool.dao.factory.DocClassRefFactory;
import gov.va.med.hds.querytool.dao.factory.DocTitleListFactory;
import gov.va.med.hds.querytool.dao.factory.DocTitleRefFactory;
import gov.va.med.hds.querytool.ui.editor.IRunnableEditorPanel;
import gov.va.med.hds.querytool.ui.types.EditorException;
import gov.va.med.hds.querytool.ui.types.SingleBucketFilterEditor;

/**
 * Implements a IDocTitleFactory to return an editor.
 */
public class DocTitleFactory
	extends EditorFactory
	implements IDocTitleFactory {

	public IRunnableEditorPanel getEditor() throws EditorException {
		SingleBucketFilterEditor editor = new SingleBucketFilterEditor(new DocTitleListFactory(), new DocTitleRefFactory(), new DocClassRefFactory(),true);
		editor.setRuntime(runtime);
		editor.setDAORegistry(daoRegistry);
		editor.setFilterInstruction("Use 'Limit Document Class' to list titles from a particular class.");
		editor.setFilterPrompt("Limit Document Class to");
		editor.setOutBucketLabel("Selected Document Titles");
		editor.setWindowHeader("Document Title");
		return editor;
	}

}
