/*
 * Initially Created on Mar 28, 2003 by vhaislmonsos
 *
 */
package gov.va.med.hds.querytool.ui.editor.factory;

import gov.va.med.hds.cd.daoregistry.IDaoRegistry;
import gov.va.med.hds.cd.runtime.IRuntimeContext;
import gov.va.med.hds.querytool.ui.types.EditorException;

/**
 * Abstract editor factory.
 */
public abstract class EditorFactory implements IEditorFactory {
	protected IRuntimeContext runtime;
	protected IDaoRegistry daoRegistry;

	public void setRuntime(IRuntimeContext runtime) throws EditorException {
		this.runtime = runtime;
		try {
			daoRegistry = (IDaoRegistry)runtime.getPluginInstance(IDaoRegistry.PLUGIN_ID);
		}
		catch (Exception e) {
			throw new EditorException(e);
		}
	}

	public IRuntimeContext getRuntime() {
		return runtime;
	}

}
