/*
 * Initially Created on Mar 28, 2003 by vhaislmonsos
 *
 */
package gov.va.med.hds.querytool.ui.editor.factory;

import gov.va.med.hds.querytool.dao.factory.OrderItemListFactory;
import gov.va.med.hds.querytool.dao.factory.OrderItemRefFactory;
import gov.va.med.hds.querytool.dao.factory.OrderSetRefFactory;
import gov.va.med.hds.querytool.ui.editor.IRunnableEditorPanel;
import gov.va.med.hds.querytool.ui.types.EditorException;
import gov.va.med.hds.querytool.ui.types.SingleBucketFilterEditor;

/**
 * Implements 
 */
public class OrderItemFactory extends EditorFactory implements IOrderItemFactory {

	public IRunnableEditorPanel getEditor() throws EditorException {
		SingleBucketFilterEditor editor = new SingleBucketFilterEditor(new OrderItemListFactory(), new OrderItemRefFactory(), new OrderSetRefFactory(), false);
		editor.setFilterInstruction("Use 'Limit Orderable Items' to list subsets of orderable items.");
		editor.setFilterPrompt("Limit Orderable Items to");
		editor.setWindowHeader("Orderable Item");
		editor.setOutBucketLabel("Selected Orderable Items");
		editor.setRuntime(runtime);
		editor.setDAORegistry(daoRegistry);
		return editor;
	}

}
