/*
 * Initially Created on Mar 28, 2003 by vhaislmonsos
 *
 */
package gov.va.med.hds.querytool.ui.editor.factory;

import gov.va.med.hds.querytool.dao.factory.ClinicianListFactory;
import gov.va.med.hds.querytool.dao.factory.ClinicianRefFactory;
import gov.va.med.hds.querytool.ui.editor.IRunnableEditorPanel;
import gov.va.med.hds.querytool.ui.types.EditorException;
import gov.va.med.hds.querytool.ui.types.SingleBucketEditor;

/**
 * Implements IPersonFactory to return an editor.
 */
public class PersonFactory extends EditorFactory implements IPersonFactory {

	public IRunnableEditorPanel getEditor() throws EditorException {
		SingleBucketEditor editor = new SingleBucketEditor();
		editor.setBufferedListFactory(new ClinicianListFactory());
		editor.setReferenceDAOFactory(new ClinicianRefFactory());
		editor.setOutBucketLabel("Selected Providers");
		editor.setWindowHeader("Provider");
		editor.setRuntime(runtime);
		editor.setDAORegistry(daoRegistry);
		return editor;
	}

}
