/*
 * Initially Created on Mar 28, 2003 by vhaislmonsos
 *
 */
package gov.va.med.hds.querytool.ui.editor.factory;

import gov.va.med.hds.querytool.dao.factory.OrderItemRefFactory;
import gov.va.med.hds.querytool.dao.factory.ProcedureListFactory;
import gov.va.med.hds.querytool.ui.editor.IRunnableEditorPanel;
import gov.va.med.hds.querytool.ui.types.EditorException;
import gov.va.med.hds.querytool.ui.types.SingleBucketEditor;

/**
 * Implements IProcedureFactoy to return an editor.
 */
public class ProcedureFactory
	extends EditorFactory
	implements IProcedureFactoy {

	public IRunnableEditorPanel getEditor() throws EditorException {
		SingleBucketEditor editor = new SingleBucketEditor();
		editor.setBufferedListFactory(new ProcedureListFactory());
		editor.setReferenceDAOFactory(new OrderItemRefFactory());
		editor.setOutBucketLabel("Selected Procedures");
		editor.setWindowHeader("Procedure");
		editor.setRuntime(runtime);
		editor.setDAORegistry(daoRegistry);
		return editor;
	}

}
