/*
 * Initially Created on Mar 28, 2003 by vhaislmonsos
 *
 */
package gov.va.med.hds.querytool.ui.editor.factory;

import gov.va.med.hds.querytool.ui.editor.IRunnableEditorPanel;
import gov.va.med.hds.querytool.ui.types.DateRangePanel;
import gov.va.med.hds.querytool.ui.types.EditorException;
import gov.va.med.hds.util.dao.IServerDateDAO;

/**
 * Returns an editor for time frames.
 */
public class TimeFrameFactory extends EditorFactory implements ITimeFrameFactory {

	public IRunnableEditorPanel getEditor() throws EditorException {
		IServerDateDAO serverDateDAO;
		DateRangePanel dateRangePanel;
		try {
			serverDateDAO = (IServerDateDAO)daoRegistry.getDAO(IServerDateDAO.class.getName());
			dateRangePanel = new DateRangePanel(serverDateDAO.getDate());
			dateRangePanel.setRuntime(runtime);
			dateRangePanel.setDAORegistry(daoRegistry);
		}
		catch (Exception e) {
			throw new EditorException(e);
		}
		return dateRangePanel;
	}

}
