/*
 * Initially Created on Jun 16, 2003 by vhaislmonsos
 *
 */
package gov.va.med.hds.querytool.ui.icon;

import java.awt.Component;
import java.awt.Graphics;

import javax.swing.Icon;

/**
 * Down arrow icon class that creates an icon of the specified size in the constructor.  The default constructor
 * creates an icon of size 16x16.
 */
public class DownArrowIcon extends ArrowIcon implements Icon {

	/**
	 * Defers to parent
	 */
	public DownArrowIcon() {
		super();
	}

	/**
	 * Defers to parent
	 * @param height
	 * @param width
	 */
	public DownArrowIcon(int height, int width) {
		super(height, width);
	}

	public void paintIcon(Component c, Graphics g, int x, int y) {
		int compWidth = c.getWidth();
		int compHeight = c.getHeight();
		
		xx[0] = compWidth * 3/8;
		yy[0] = compHeight * 1/8;
		
		xx[1] = compWidth * 5/8;
		yy[1] = compHeight * 1/8;
		
		xx[2] = compWidth * 5/8;
		yy[2] = compHeight * 4/8;

		xx[3] = compWidth * 7/8;
		yy[3] = compHeight * 4/8;

		xx[4] = compWidth * 1/2;
		yy[4] = compHeight * 7/8;

		xx[5] = compWidth * 1/8;
		yy[5] = compHeight * 4/8;

		xx[6] = compWidth * 3/8;
		yy[6] = compHeight * 4/8;

		super.paintIcon(c, g, x, y);
	}

}
