package gov.va.med.hds.querytool.ui.types;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.TreeMap;
import java.util.Map.Entry;

import javax.swing.BoxLayout;
import javax.swing.JCheckBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;

/**
 * @author vhaislmonsos
 *
 * Dec 16, 2002 7:16:38 AM
 */
public class CheckBoxSelection extends JPanel {
	private JLabel headerLabel = new JLabel("Check One or More Items");
	private JPanel itemPanel = new JPanel();
	private JScrollPane scrollPane = new JScrollPane(itemPanel);
	private Map items = new HashMap();

	/**
	 * Constructor for CheckBoxSelection.
	 */
	public CheckBoxSelection() {
		super();
//		this.setBackground(Color.WHITE);
		this.setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
		itemPanel.setLayout(new BoxLayout(itemPanel,BoxLayout.Y_AXIS));
//		itemPanel.setBackground(Color.WHITE);
		this.add(headerLabel);
		this.add(scrollPane);
	}
	
	public void add(String dataID, String displayText, boolean selected) {
		if (items==null) {
			items = new HashMap();
		}
		JCheckBox item = new JCheckBox(displayText);
		item.setSelected(selected);
//		item.setBackground(Color.WHITE);
		itemPanel.add(item);
		items.put(dataID, item);
	}
	
	public List getSelectedItems() {
		Set keys = items.keySet();
		TreeMap sortedMap = new TreeMap();
		List result = new ArrayList();
		Iterator it = keys.iterator();
		while (it.hasNext()) {
			String key = (String)it.next();
			JCheckBox item = (JCheckBox)items.get(key);
			if (item.isSelected()) {
				sortedMap.put(item.getText()+key,key);
			}
		}
		it = sortedMap.entrySet().iterator();
		while (it.hasNext()) {
			Map.Entry entry = (Entry) it.next();
			result.add((String)entry.getValue());
		}
		return result;
	}
	
	public static final void main(String args[]) {
		JFrame frame = new JFrame("CheckBoxSelection");
		CheckBoxSelection checkBoxSelection = new CheckBoxSelection();
		checkBoxSelection.add("1","Line 1",true);
		checkBoxSelection.add("2","Line 2",false);
		checkBoxSelection.add("3","Line 3",true);
		checkBoxSelection.add("4","Line 4",false);
		checkBoxSelection.add("5","Line 5",true);
		frame.getContentPane().add(checkBoxSelection);
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

		frame.pack();
		frame.show();
	}
	
	public void setSelected(String key, boolean selected) {
		JCheckBox item = (JCheckBox) items.get(key);
		if (item!=null) {
			item.setSelected(selected);
		}
	}

	/**
	 * Method setItems.
	 * @param items
	 */
	public void setItems(TreeMap items) {
		itemPanel.removeAll();
		for (Iterator i = items.values().iterator(); i.hasNext();) {
			Map.Entry e = (Map.Entry) i.next();
			add(e.getKey().toString(),e.getValue().toString(),false);
		}
	}

	/**
	 * Method clearSelection.
	 */
	public void clearSelection() {
		Iterator keys = items.keySet().iterator();
		while (keys.hasNext()) {
			setSelected((String)keys.next(), false);
		}
	}

}
