package gov.va.med.hds.querytool.ui.types;

import gov.va.med.hds.cd.spectrum.longlist.BufferItem;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionListener;
import java.util.Iterator;
import java.util.Map;
import java.util.TreeMap;

import javax.swing.DefaultComboBoxModel;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JPanel;

/**
 * @author vhaislmonsos
 *
 */
public class FilterPanel extends JPanel {
	private boolean noneAllowed;
	private JLabel label = new JLabel();
	private JComboBox comboBox = new JComboBox();
	private DefaultComboBoxModel model = new DefaultComboBoxModel();

	public FilterPanel() {
		comboBox.setPreferredSize(new Dimension(200,22));
		comboBox.setMaximumSize(new Dimension(200,22));
		this.setLayout(new GridBagLayout());
		GridBagConstraints c = new GridBagConstraints(0,0,1,1,1.0,0.0,GridBagConstraints.WEST,GridBagConstraints.NONE,new Insets(0,0,0,0),0,0);
		this.add(label,c);
//		comboBox.setModel(model);		The JComboBox can't handle adding the BufferItems
//										to the model while the model is assigned to the 
//										component.
		c.gridy = 1;
		this.add(comboBox,c);
	}
	
	/**
	 * Returns the noneAllowed.
	 * @return boolean
	 */
	public boolean isNoneAllowed() {
		return noneAllowed;
	}

	/**
	 * Returns the values.
	 * @return Map
	 */
	public Object getSelectedValue() {
		return comboBox.getSelectedItem();
	}

	/**
	 * Sets the values.
	 * @param values The values to set
	 */
	public void setValues(TreeMap values) {
		Iterator it = values.values().iterator();
		model.removeAllElements();
		if (noneAllowed) {
			model.addElement(new BufferItem("(no limit)","0"));
		}
		while (it.hasNext()) {
			Map.Entry e = (Map.Entry)it.next();
			model.addElement(new BufferItem(e.getValue().toString(),e.getKey().toString()));
		}
		comboBox.setModel(model);
		if (comboBox.getSelectedItem()==null) {
			comboBox.setSelectedIndex(0);
		}
	}

	/**
	 * Sets the displayText.
	 * @param displayText The displayText to set
	 */
	public void setLabelText(String displayText) {
		label.setText(displayText);
	}
	
	public void addSelectActionListener(ActionListener listener) {
		comboBox.addActionListener(listener);
	}
	
	public void removeSelectActionListener(ActionListener listener) {
		comboBox.removeActionListener(listener);
	}

	/**
	 * Sets the noneAllowed.
	 * @param noneAllowed The noneAllowed to set
	 */
	public void setNoneAllowed(boolean noneAllowed) {
		this.noneAllowed = noneAllowed;
	}

}
