package gov.va.med.hds.querytool.ui.types;
import gov.va.med.hds.cd.spectrum.text.GenericDocumentFilter;
import gov.va.med.hds.querytool.ui.editor.IRunnableEditorState;

import java.awt.Dimension;
import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.util.Iterator;
import java.util.List;

import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.text.PlainDocument;

/**
 * Allows entry of 80 characters of free text.
 */
public class FreeTextPanel extends EditorPanel {
	private JLabel caption = new JLabel();
	private JTextField inputBox = new JTextField();
	private String textValues = new String("");
	private String windowHeader;

	public FreeTextPanel() {
		jbInit();
	}
	
	public FreeTextPanel(List values) {
		if ((values != null) && (values.size()>0)) {
			Iterator it = values.iterator();
			if (it.hasNext()) {
				this.textValues = ((String)it.next()).substring(0);
			}
		}
		
		jbInit();
	}

	private void jbInit() {
		PlainDocument doc = new PlainDocument();
		doc.setDocumentFilter(new GenericDocumentFilter(80));
		inputBox.setDocument(doc);
		this.setLayout(new GridBagLayout());
		caption.setText("<Caption><Caption><Caption><Caption><Caption><Caption>");
		caption.setFont(new Font("Dialog", 0, 12));
		caption.setMaximumSize(new Dimension(1000, 22));
		caption.setMinimumSize(new Dimension(65, 22));
		caption.setPreferredSize(new Dimension(300, 22));
		inputBox.setMaximumSize(new Dimension(800, 22));
		inputBox.setMinimumSize(new Dimension(50, 22));
		inputBox.setPreferredSize(new Dimension(400, 22));
		inputBox.setText(textValues);
		GridBagConstraints c = new GridBagConstraints(0,0,1,1,1.0,0.0,GridBagConstraints.WEST,GridBagConstraints.NONE,new Insets(0,0,0,0),0,0);
		this.add(caption,c);
		c.gridy = 1;
		this.add(inputBox,c);
	}

	public void setCaption(String caption) {
		this.caption.setText(caption);
	}
	
	public void init() {
	}

	public static final void main(String args[]) {
		JFrame frame = new JFrame("FreeTextPanel");
		FreeTextPanel freeTextPanel = new FreeTextPanel();
		frame.getContentPane().add(freeTextPanel);
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

		frame.pack();
		frame.show();
	}
	
	public List getValues() {
		super.getValues().clear();
		if (inputBox.getText().length()>0) {
			super.getValues().add(inputBox.getText());
		}
		return super.getValues();
	}

	public void setValues(List values) {
		super.setValues(values);
		if ((values != null) && values.size()>0) {
			inputBox.setText((String)values.get(0));
		}
	}

	public String getDisplayText() {
		getValues();
		if (super.getValues().size()>0) {
			super.setDisplayText((String)super.getValues().get(0));
		}
		else {
			super.setDisplayText("");
		}
		return super.getDisplayText();
	}

	public String getWindowHeader() {
		return windowHeader;
	}

	public void setWindowHeader(String text) {
		windowHeader = text;
	}

	/* (non-Javadoc)
	 * @see gov.va.med.hds.querytool.ui.editor.IRunnableEditorPanel#clearModels()
	 */
	public void clearModels() {
	}

	/* (non-Javadoc)
	 * @see gov.va.med.hds.querytool.ui.editor.IRunnableEditorPanel#getEditorState()
	 */
	public IRunnableEditorState getEditorState() {
		return null;
	}

	/* (non-Javadoc)
	 * @see gov.va.med.hds.querytool.ui.editor.IRunnableEditorPanel#setEditorState(gov.va.med.hds.querytool.ui.editor.IRunnableEditorState)
	 */
	public void setEditorState(IRunnableEditorState state) {

	}

}