package gov.va.med.hds.querytool.ui.types;

import gov.va.med.hds.cd.spectrum.bucket.IConverter;
import gov.va.med.hds.cd.spectrum.longlist.IBufferItem;

/**
 * @author vhaislmonsos
 *
 * Jan 7, 2003 11:16:42 AM
 */
public class MultiConverter implements IConverter {
	private String editorID;
	private String value = "";
	private String descr;

	/**
	 * Constructor for MultiConverter.
	 */
	public MultiConverter() {
		super();
	}
	
	/**
	 * Method MultiConverter.
	 * @param editorID
	 * @param value
	 */
	public MultiConverter(String editorID, String descr) {
		this();
		this.editorID = editorID;
		this.descr = descr;
	}

	/**
	 * @see gov.va.med.hds.cd.spectrum.IConverter#convert(Object)
	 */
	public Object convert(Object item) {
		IBufferItem bItem = (IBufferItem)item;
		MultiSourceItem result = new MultiSourceItem(editorID+":"+bItem.getId().toString()+":"+value,bItem.getValue().toString(),descr);
		return result;
	}

	/**
	 * Returns the editorID.
	 * @return String
	 */
	public String getEditorID() {
		return editorID;
	}

	/**
	 * Returns the value.
	 * @return String
	 */
	public String getValue() {
		return value;
	}

	/**
	 * Sets the editorID.
	 * @param editorID The editorID to set
	 */
	public void setEditorID(String editorID) {
		this.editorID = editorID;
	}

	/**
	 * Sets the value.
	 * @param value The value to set
	 */
	public void setValue(String value) {
		this.value = value;
	}

	/**
	 * Returns the descr.
	 * @return String
	 */
	public String getDescr() {
		return descr;
	}

	/**
	 * Sets the descr.
	 * @param descr The descr to set
	 */
	public void setDescr(String descr) {
		this.descr = descr;
	}

}
