package gov.va.med.hds.querytool.ui.types;

import gov.va.med.hds.querytool.ui.editor.IRunnableEditorPanel;


/**
 * Provides a tabbed pane for multiple editors.
 */
public class MultiSourceEditItem implements IMultiSourceEditItem {
	private String typeID;
	private String tabString;
	private String descr;
	private IRunnableEditorPanel displayPanel;

	/**
	 * Constructor for MultiSourceEditItem.
	 */
	public MultiSourceEditItem() {
		super();
	}
	
	public MultiSourceEditItem(String typeID, String tabString, String descr, IRunnableEditorPanel displayPanel) {
		super();
		this.typeID = typeID;
		this.tabString = tabString;
		this.descr = descr;
		this.displayPanel = displayPanel;
	}

	/**
	 * Returns the descr.
	 * @return String
	 */
	public String getDescr() {
		return descr;
	}

	/**
	 * Returns the displayPanel.
	 * @return JPanel
	 */
	public IRunnableEditorPanel getDisplayPanel() {
		return displayPanel;
	}

	/**
	 * Returns the tabString.
	 * @return String
	 */
	public String getTabString() {
		return tabString;
	}

	/**
	 * Returns the typeID.
	 * @return String
	 */
	public String getTypeID() {
		return typeID;
	}

	/**
	 * Sets the descr.
	 * @param descr The descr to set
	 */
	public void setDescr(String descr) {
		this.descr = descr;
	}

	/**
	 * Sets the displayPanel.
	 * @param displayPanel The displayPanel to set
	 */
	public void setDisplayPanel(IRunnableEditorPanel displayPanel) {
		this.displayPanel = displayPanel;
	}

	/**
	 * Sets the tabString.
	 * @param tabString The tabString to set
	 */
	public void setTabString(String tabString) {
		this.tabString = tabString;
	}

	/**
	 * Sets the typeID.
	 * @param typeID The typeID to set
	 */
	public void setTypeID(String typeID) {
		this.typeID = typeID;
	}

}
