package gov.va.med.hds.querytool.ui.types;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.ButtonGroup;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.border.EtchedBorder;
import javax.swing.border.TitledBorder;

/**
 * @author vhaislmonsos
 *
 * Jan 21, 2003 4:29:01 PM
 */
public class RegistrySelectionPanel extends JPanel {
	public final static int ALL_ENTRIES = 3;
	public final static int ALL_ACTIVE = 1;
	public final static int ALL_INACTIVE = 2;
	public final static String BUTTON_SELECTED = "REGISTRY_BUTTON_SELECTED";
	private JRadioButton allButton = new JRadioButton("Both Active and Inactive");
	private JRadioButton activeButton = new JRadioButton("Active");
	private JRadioButton inactiveButton = new JRadioButton("Inactive");
	private ButtonGroup radioGroup = new ButtonGroup();
	private int selection;
	private ActionListener buttonListener = new ActionListener() {
		public void actionPerformed(ActionEvent event) {
			JRadioButton button = (JRadioButton)event.getSource();
			if (button.isSelected()) {
				int newSelection = getRegistrySelection();
				firePropertyChange(BUTTON_SELECTED, selection, newSelection);
				selection = newSelection;
			}
		}
	};
	
	public RegistrySelectionPanel() {
		super();
		this.setBorder(new TitledBorder(new EtchedBorder(),"Registry Status"));
		GridBagConstraints c = new GridBagConstraints();
		c.anchor = GridBagConstraints.CENTER;
		c.fill = GridBagConstraints.NONE;
		c.gridheight = 1;
		c.gridwidth = 1;
		c.gridx = 0;
		c.gridy = 0;
		c.insets = new Insets(0,0,0,0);
		c.ipadx = 0;
		c.ipady = 0;
		c.weightx = .3333;
		c.weighty = 1.0;
		this.setLayout(new GridBagLayout());
		this.add(activeButton,c);
		c.gridx = 1;
		this.add(inactiveButton,c);
		c.gridx = 2;
		this.add(allButton,c);
		radioGroup.add(allButton);
		radioGroup.add(inactiveButton);
		radioGroup.add(activeButton);
		allButton.doClick();
		selection = getRegistrySelection();
		allButton.addActionListener(buttonListener);
		inactiveButton.addActionListener(buttonListener);
		activeButton.addActionListener(buttonListener);
	}
	
	public static final void main(String args[]) {
		try {
			JFrame frame = new JFrame("RegistrySelectionPanel");
			RegistrySelectionPanel registrySelectionPanel = new RegistrySelectionPanel();
			frame.getContentPane().add(registrySelectionPanel);
			frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	
			frame.pack();
			frame.show();
	
		}
		catch (Exception ioe) {
			ioe.printStackTrace();
		}
	}
	
	public int getRegistrySelection() {
		if (allButton.isSelected()) {
			return ALL_ENTRIES;
		}
		else if (inactiveButton.isSelected()) {
			return ALL_INACTIVE;
		}
		else if (activeButton.isSelected()) {
			return ALL_ACTIVE;
		}
		
		return -1;
	}

}
