package gov.va.med.hds.querytool.ui.types;

import gov.va.med.hds.querytool.ui.editor.IRunnableEditorState;

import java.awt.BorderLayout;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.util.List;

import javax.swing.Box;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;

/**
 * A container for a SingleBucketPanel, which also contains instruction text.
 */
public class SingleBucketEditor extends EditorPanel {
	private JLabel label1 = new JLabel("To select an item, click it in the column on the left, then click '>'. (You may also double-click.)");
	private JLabel label2 = new JLabel("Repeat to add multiple items.");
	private JPanel labelPanel = new JPanel();
	private SingleBucketPanel bucketPanel = new SingleBucketPanel();
	private String windowHeader;

	public SingleBucketEditor() {
		super();
		bucketPanel.setValues(super.getValues());
		labelPanel.setLayout(new GridBagLayout());
		GridBagConstraints c = new GridBagConstraints(0,0,1,1,1.0,0.0,GridBagConstraints.WEST,GridBagConstraints.NONE,new Insets(0,0,0,0),0,0);
		labelPanel.add(label1,c);
		c.gridy = 1;
		labelPanel.add(label2,c);
		this.setLayout(new GridBagLayout());
		c = new GridBagConstraints(0,0,1,1,1.0,0.0,GridBagConstraints.WEST,GridBagConstraints.NONE,new Insets(0,0,0,0),0,0);
		this.add(labelPanel,c);
		c.gridy = 1;
		this.add(Box.createVerticalStrut(10),c);
		c.gridy = 2;
		c.weighty = 1.0;
		c.weighty = 1.0;
		c.fill = GridBagConstraints.BOTH;
		this.add(bucketPanel,c);
	}

	/**
	 * Constructor SingleBucketEditor.
	 * @param clinicianListFactory
	 * @param clinicianRefFactory
	 * @param arrayList
	 */
	public SingleBucketEditor(IBufferedListFactory bufferFactory,IReferenceDAOFactory refFactory,List list) {
		bucketPanel.setBufferedListFactory(bufferFactory);
		bucketPanel.setReferenceDAOFactory(refFactory);
		setValues(list);
	}
	
	public void setLabel1(String label) {
		label1.setText(label);
	}
	
	public void setLabel2(String label) {
		label2.setText(label);
	}
	
	public void setInBucketLabel(String label) {
		bucketPanel.setInBucketLabel(label);
	}
	
	public void setOutBucketLabel(String label) {
		bucketPanel.setOutBucketLabel(label);
	}
	
	public void setBufferedListFactory(IBufferedListFactory factory) {
		bucketPanel.setBufferedListFactory(factory);
	}
	
	public void setReferenceDAOFactory(IReferenceDAOFactory factory) {
		bucketPanel.setReferenceDAOFactory(factory);
	}
	
	public static final void main(String args[]) {
		JFrame frame = new JFrame("SingleBucketEditor");
		SingleBucketEditor bucket = new SingleBucketEditor();
		frame.getContentPane().add(bucket, BorderLayout.CENTER);
		frame.pack();
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		frame.show();
	}
	
	public void init() throws EditorException {
		bucketPanel.setRuntime(super.getRuntime());
		bucketPanel.setDAORegistry(super.getDaoRegistry());
		bucketPanel.setValues(super.getValues());
		bucketPanel.init();
	}

	public String getDisplayText() {
		return bucketPanel.getDisplayText();
	}

	public List getValues() {
		return bucketPanel.getValues();
	}

	public String getWindowHeader() {
		return windowHeader;
	}

	public void setWindowHeader(String text) {
		windowHeader = text;
	}

	/* (non-Javadoc)
	 * @see gov.va.med.hds.querytool.ui.editor.IRunnableEditorPanel#clearModels()
	 */
	public void clearModels() {
		bucketPanel.setModel(null);
	}

	/* (non-Javadoc)
	 * @see gov.va.med.hds.querytool.ui.editor.IRunnableEditorPanel#getEditorState()
	 */
	public IRunnableEditorState getEditorState() {
		return null;
	}

	/* (non-Javadoc)
	 * @see gov.va.med.hds.querytool.ui.editor.IRunnableEditorPanel#setEditorState(gov.va.med.hds.querytool.ui.editor.IRunnableEditorState)
	 */
	public void setEditorState(IRunnableEditorState state) {

	}

}
