package gov.va.med.hds.querytool;

import java.util.List;

/**
 * Criteria item for a given query.
 */
public interface ICriteriaItem {
	public static final String NULL_EDITOR = "null.editor";

	/**
	 * Method getCaption.
	 * @return String
	 */
	String getCaption();

	/**
	 * Method getEditorID.
	 * @return Object
	 */
	Object getEditorID();

	/**
	 * Method getName.
	 * @return String
	 */
	String getConstraintName();

	/**
	 * Method getOrder.
	 * @return int
	 */
	int getOrder();

	/**
	 * Method getTag.
	 * @return String
	 */
	String getTag();

	/**
	 * Method getValues.
	 * @return List
	 */
	List getValues();

	/**
	 * Method setCaption.
	 * @param caption
	 */
	void setCaption(String caption);

	/**
	 * Method setEditorID.
	 * @param editorID
	 */
	void setEditorID(Object editorID);

	/**
	 * Method setName.
	 * @param name
	 */
	void setConstraintName(String constraintName);

	/**
	 * Method setOrder.
	 * @param order
	 */
	void setOrder(int order);

	/**
	 * Method setTag.
	 * @param tag
	 */
	void setTag(String tag);

}
