package gov.va.med.hds.querytool;

import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;


/**
 * Display field interface for an IQuery.
 */
public interface IDisplayField {
	public static String DISPLAY_TEXT_PROPERTY = "disp.displayText";
	public static String COL_WIDTH_PROPERTY = "disp.columnWidth";
	public static String ID_PROPERTY = "disp.id";
	
	/**
	 * Method setDisplayText.
	 * @param string
	 */
	void setDisplayText(String string);

	/**
	 * Method setColumnWidth.
	 * @param i
	 */
	void setColumnWidth(int i);

	/**
	 * Method setID.
	 * @param id
	 */
	void setID(Object id);

	/**
	 * Method getColumnWidth.
	 * @return int
	 */
	int getColumnWidth();

	/**
	 * Method getID.
	 * @return Object
	 */
	Object getID();

	/**
	 * Method getDisplayText.
	 * @return Object
	 */
	String getDisplayText();

	/**
	 * Returns the listDisplayName.
	 * @return String
	 */
	String getListDisplayName();

	/**
	 * Returns the sampleData.
	 * @return String[]
	 */
	String[] getSampleData();

	/**
	 * Returns the sortType.
	 * @return String
	 */
	String getSortType();

	/**
	 * Sets the listDisplayName.
	 * @param listDisplayName The listDisplayName to set
	 */
	void setListDisplayName(String listDisplayName);

	/**
	 * Sets the sampleData.
	 * @param sampleData The sampleData to set
	 */
	void setSampleData(String[] sampleData);

	/**
	 * Sets the sortType.
	 * @param sortType The sortType to set
	 */
	void setSortType(String sortType);

	/**
	 * Returns the first piece of the display field ID.
	 * @return String
	 */
	String getCategory();
	
	/**
	 * Add property listener.
	 * @param listener
	 */
	void addPropertyChangeListener(PropertyChangeListener listener);
	
	/**
	 * Remove property listener.
	 * @param listener
	 */
	void removePropertyChangeListener(PropertyChangeListener listener);
	
	/**
	 * Fires a property change event.
	 * @param e
	 */
	void firePropertyChanged(PropertyChangeEvent e);
	
}
