package gov.va.med.hds.querytool;

import javax.swing.event.ListDataListener;


/**
 * Implements list behavior for report display fields (columns.)
 */
public interface IDisplayFieldList {

	/**
	 * Adds a display field.
	 * @param displayField
	 * @return boolean - whether the field was added (did not previously exist)
	 */
	boolean add(IDisplayField displayField);
	
	/**
	 * Method removeAt.
	 * @param position
	 * @return IDisplayField
	 */
	IDisplayField removeAt(int position);
	
	/**
	 * Method remove.
	 * @param field
	 * @return boolean
	 */
	boolean remove(IDisplayField field);
	
	/**
	 * Returns the position in the displayed field list model that this element is
	 * found.
	 * @param displayField
	 * @return int
	 */
	int contains(IDisplayField displayField);
	
	/**
	 * @param index
	 */
	void moveUp(int index);
	
	/**
	 * @param index
	 */
	void moveDown(int index);
	
	/**
	 * Method setChangingModel.
	 * @param changing
	 */
	void setChangingModel(boolean changing);
	
	/**
	 * Method clearAll.
	 */
	void clearAll();

	/**
	 * Returns the index of the given item.
	 * @param item
	 * @return int
	 */
	int indexOf(IDisplayField item);
	
	/**
	 * @param index
	 * @return displayField
	 */
	IDisplayField get(int index);
	
	/**
	 * @return size
	 */
	int size();
	
	/**
	 * @param listener
	 */
	void addListDataListener(ListDataListener listener);

	/**
	 * @param listener
	 */
	void removeListDataListener(ListDataListener listener);
	
}
