/*
 * Created on Apr 9, 2003 by vhaislmonsos
 */
package gov.va.med.hds.querytool;

/**
 * Interface for a hard reference manager for objects.
 */
public interface IHardReferenceManager {
	
	/**
	 * Adds an item to the reference manager.  This object registers itself as a
	 * listener for property change and/or other events.  If an event is raised,
	 * if the implementing class determines that the item should be retained in a 
	 * hard reference, it puts the object in a list.  If it is determined that the 
	 * object does not need a hard reference, it removes it from it's list.
	 * @param query
	 */
	void addItem(Object item) throws HardReferenceManagerException;
	
	/**
	 * Removes itself as a listener to the specified item, and removes it from the 
	 * reference list, if it exists.
	 * @param query
	 */
	void removeItem(Object item) throws HardReferenceManagerException;
}
