/*
 * Initially Created on May 30, 2003 by vhaislmonsos
 *
 */
package gov.va.med.hds.querytool;

/**
 * Encapsulates a query tool event.
 */
public interface IQueryToolEvent {
	static final int NO_EVENT						= 0;
	static final int MESSAGE						= 1;
	static final int ERROR							= 2;
	static final int CURRENT_QUERY_SET				= 3;
	static final int HOME_PAGE						= 4;
	static final int EDIT_QUERY						= 5;
	static final int EDIT_PARAMETER					= 6;
	static final int CONFIRM_DELETE					= 7;
	static final int RENAME							= 8;
	static final int RUN_STARTED					= 9;
	static final int RUN_RESTARTED					= 10;
	static final int RUN_COMPLETE_NON_SENSITIVE		= 11;
	static final int RUN_COMPLETE					= 12;
	static final int SAVE_AS						= 13;
	static final int SELECT							= 14;
	static final int PRINT							= 15;
	static final int EXPORT							= 16;
	static final int UNSELECT 						= 17;
	static final int STOPPED							= 18;
	
	/**
	 * Returns the eventID.
	 * @return eventID
	 */
	int getEventID();
	
	/**
	 * Returns the source reference of the event.
	 * @return eventSource
	 */
	Object getSource();
	
	/**
	 * Gets the query reference associated with this event.
	 * @return query
	 */
	IQuery getQuery();
	
	/**
	 * Gets the query value involved in the event.
	 * @return queryValue
	 */
	IValue getValue();

}
