/*
 * Initially Created on Jun 10, 2003 by vhaislmonsos
 *
 */
package gov.va.med.hds.querytool;

import gov.va.med.hds.cd.runtime.IRuntimeContext;
import gov.va.med.hds.querytool.dao.IQueryDAO;
import gov.va.med.hds.querytool.ui.IResultsTable;

import javax.swing.text.Document;

/**
 * State manager interface 
 */
public interface IQueryToolState {

	void setResultsTable(IResultsTable resultsTable);
	
	IResultsTable getResults();
	
	void setRunModel(IRunQuery runQuery);
	
	IRunQuery getRunModel();
	
	void setSensitiveMessage(Document message);
	
	Document getSensitiveMessage();
	
	void setSensitivePatientList(ISensitiveList sensitiveList);
	
	ISensitiveList getSensitivePatientList();
	
	void setQueryCollection(ICombinedQueryCollection queryCollection);
	
	ICombinedQueryCollection getQueryCollection();
	
	void setMessage(String message);
	
	String getMessage();
	
	void setException(Throwable exception);
	
	Throwable getException();
	
	void setQueryDAO(IQueryDAO queryDAO);
	
	IQueryDAO getQueryDAO();
	
	void reset();
	
	void setCurrentQuery(IQuery query);
	
	void setRuntime(IRuntimeContext runtime);

	void setAvailableColumnList(IAvailableColumnsList availableColumnList);
	
	IAvailableColumnsList getAvailableColumnList();
	
}
