/*
 * Created on Mar 18, 2003 by vhaislmonsos
 */
package gov.va.med.hds.querytool;

/**
 * Holds an ID, object reference, and an object name string.
 */
public interface ISoftListItem extends Comparable {
	/**
	 * Returns the object reference if it exists; null otherwise.
	 * @return Object
	 */
	Object getItem();
	
	/**
	 * Sets the object reference held by this instance.
	 * @param item
	 */
	void setItem(Object item);
	
	/**
	 * Gets the object display name; used to display in a list of objects.  If the
	 * Object reference contained by this instance is not null, it returns the 
	 * Object.toString name.  Otherwise, returns a locally stored disply name.
	 * @return String
	 */
	String getDisplayName();
	
	/**
	 * Sets the locally stored list display name if the Object reference is null.
	 * Otherwise, routine does nothing.
	 * @param name
	 */
	void setDisplayName(String name);
	
	/**
	 * Returns the ID for the Object if a valid reference exists.
	 * Otherwise returns a locally stored ID.
	 * @return IQueryID
	 */
	Object getID();
	
	/**
	 * If the instance already has an Object and the ID passed into this
	 * method is different, it dumps the reference to the Object and saves the
	 * ID passed in.  Otherwise, does nothing.
	 * @param objectID
	 */
	void setID(Object objectID);
	
	/**
	 * Sets the reference manager.
	 * @param referenceManager
	 */
	void setReferenceManager(IHardReferenceManager referenceManager);
	
	/**
	 * Gets the reference manager.
	 * @return referenceManager
	 */
	IHardReferenceManager getReferenceManager();
	
}
