package gov.va.med.hds.querytool.dao;

import gov.va.med.hds.cd.daoregistry.IDataAccessObject;
import gov.va.med.hds.querytool.IQueryList;

/**
 * IQueryList data access object interface.
 */
public interface IQueryListDAO extends IDataAccessObject {
	
	/**
	 * Refreshes an IQueryList from the database.  If an item on the list does not contain
	 * a null query ID and is not present in the database, the item is deleted from the
	 * list.  If the data has an item not present in the list, it creates a new item.
	 * If the list contains an item with a null query ID, it ignores the item.
	 * 
	 * @param list
	 * @throws QueryDAOException
	 */
	void refresh(IQueryList list) throws QueryDAOException;
}
