package gov.va.med.hds.querytool.dao;

import gov.va.med.hds.cd.daoregistry.IDataAccessObject;

/**
 * Manages query run access to the query iteration source(s).
 */
public interface IRunDAO extends IDataAccessObject {
	
	/**
	 * Sets the initial iterator for the loop.
	 * @param iterator
	 */
	void setInitialIterator(Object iterator);

	/**
	 * Evaluate the next patient/data.
	 */
	void getNextIteration() throws QueryDAOException;

	/**
	 * Returns the patientSelected property from the last iteration.
	 * @return boolean
	 */
	boolean isPatientSelected();

	/**
	 * Get the total number of records iterated through.
	 * @return int
	 */
	int getSize();

	/**
	 * If the iterations are complete and the results are in a complete state on
	 * the server, returns true.
	 * @return boolean
	 */
	boolean isReportFinished();
	
}
