/*
 * Initially Created on May 29, 2003 by vhaislmonsos
 *
 */
package gov.va.med.hds.querytool.dao;

import gov.va.med.hds.cd.daoregistry.IDataAccessObject;
import gov.va.med.hds.querytool.IDetailReceivable;
import gov.va.med.hds.querytool.ISensitiveList;

/**
 * Sensitive query iterator setup DAO interface.
 */
public interface ISensitiveDataDAO extends IDataAccessObject {

	/**
	 * Returns the size of the sensitive patient list.
	 * @return size
	 * @throws QueryDAOException
	 */
	int getSize() throws QueryDAOException;
	
	/**
	 * Removes the specified item, as specified by the patient key.  This key is the key returned by the
	 * getItemAt method.
	 * @param patientKey
	 * @throws QueryDAOException
	 */
	void remove(Object patientKey) throws QueryDAOException;

	/**
	 * Requests the sensitive message for the given patient.
	 * @param patientKey
	 * @param receivable
	 */
	void getSensitiveMessage(Object patientKey, IDetailReceivable receivable) throws QueryDAOException;

	/**
	 * Populates an array of sensitive patient items, sorted by name within the entire list.
	 * @param patientKey
	 */
	void getList(ISensitiveList list);

}
