package gov.va.med.hds.querytool.dao.formatter;

import gov.va.med.hds.cd.daoregistry.IDataAccessObject;

/**
 * Generic interface to format some type of object.  Classes should not directly
 * inherit this interface, but from interfaces derived from this one.
 */
public interface IFormatter extends IDataAccessObject {
	public static String PROJECT_PREFIX = "gov.va.med.hds.querytool.dao.formatter";
	
	/**
	 * Converts or formats one object to another object.  The returned object
	 * will be used to display report information by calling its toString
	 * method.
	 * @param item
	 * @return Object
	 */
	Object format(Object item);
}
