package gov.va.med.hds.querytool.types;

import gov.va.med.hds.cd.runtime.IRuntimeContext;
import gov.va.med.hds.querytool.IValue;

/**
 * Parameter value type factory for query parameters.
 */
public interface ITypeFactory {

	/**
	 * Returns an IValue type based on a database ID.
	 * @param typeID
	 * @return value
	 */
	IValue getValue(Object typeID);
	
	/**
	 * Adds the value class that is identified by the database key.
	 * @param key
	 * @param value
	 */
	void addValueType(Object key, Class value);
	
	/**
	 * Sets the runtime context for the TypeFactory.
	 * @param runtime
	 */
	void setRuntime(IRuntimeContext runtime);
	
}
