package gov.va.med.hds.querytool.ui;
/**
 * Base panel for wizard page panel components.  Implemented to provide support
 * for enabling/disabling the form and all of its components.
 */
public interface IEnablePanel {
	/**
	 * Sets the border title for this panel.
	 * @param text
	 */
	void setBorderText(String text);
	
	/**
	 * Makes a single line border visible for this panel, along with an optional
	 * title set by setBorderText.
	 * @param visible
	 */
	void setBorderVisible(boolean visible);
	
	/**
	 * Returns true if any of the abstract buttons in this panel (or nested
	 * panels) are selected.
	 * @return boolean
	 */
	boolean containsSelectedItems();
}