/*
 * Created on Apr 15, 2003 by vhaislmonsos
 */
package gov.va.med.hds.querytool.ui;

import gov.va.med.hds.querytool.IQueryAction;


/**
 * Intro panel interface; provides an introduction that the user acknowledges.
 */
public interface IIntroPanel {
	
	/**
	 * Adds a query action listener.
	 * @param listener
	 */
	void addQueryActionListener(IQueryAction listener);
	
	/**
	 * Removes a registered listener.
	 * @param listener
	 */
	void removeQueryActionListener(IQueryAction listener);
	
	/**
	 * Sets the text displayed by this form.  If the text begins with &lt;html&gt;, then
	 * it sets the display pane to display an HTML form.
	 * @param text
	 */
	void setText(String text);
	
	/**
	 * Sets the state of the Okay button, whether enabled or disabled.
	 * @param okButtonEnabled
	 */
	void setOkEnabled(boolean okButtonEnabled);
}
