/*
 * Initially Created on Apr 3, 2003 by vhaislmonsos
 *
 */
package gov.va.med.hds.querytool.ui;

import gov.va.med.hds.querytool.IQueryID;

/**
 * Query list user interface events.
 */
public interface IQueryActionEvent {
	static final int CREATE_NEW					= 1;
	static final int DELETE						= 2;
	static final int DELETE_CONFIRMED				= 3;
	static final int RENAME						= 4;
	static final int SAVE_AS						= 5;
	static final int SAVE_AS_CONFIRMED			= 6;
	static final int EDIT_QUERY					= 7;
	static final int SAVE							= 8;
	static final int RUN_START					= 9;
	static final int SELECT						= 10;
	static final int CANCEL						= 11;
	static final int CLOSE						= 12;
	static final int HOME							= 13;
	static final int EDIT_COMPLETE_SAVE			= 14;
	static final int EDIT_COMPLETE_NOSAVE			= 15;
	static final int EDIT_CANCELLED				= 16;
	static final int UN_SELECT					= 17;
	static final int EDIT_PARAMETER				= 18;
	static final int EDIT_PARAMETER_COMPLETE		= 19;
	static final int RUN_COMPLETE					= 20;
	static final int RUN_COMPLETE_WITH_MESSAGE	= 21;
	static final int RUN_COMPLETE_WITH_ERROR		= 22;
	static final int RUN_COMPLETE_NON_SENSITIVE	= 23;
	static final int STOP							= 24;
	static final int RUN_CONTINUE					= 25;
	static final int PRINT						= 26;
	static final int EXPORT						= 27;
	static final int SORT_COLUMN					= 28;
	static final int SELECT_SENSITIVE				= 29;
	
	/**
	 * Returns the action ID of this event.
	 * @return actionID
	 */
	int getID();
	
	/**
	 * Returns the source of this event.
	 * @return source
	 */
	Object getSource();
	
	/**
	 * Sets the query ID associated with this event.
	 * @param queryID
	 */
	void setQueryID(IQueryID queryID);
	
	/**
	 * Returns the query ID associated with this event.  All events will return a non-
	 * null ID except for the CREATE_NEW action.
	 * @return query ID
	 */
	IQueryID getQueryID();

	/**
	 * Sets the oldValue for the RENAME action.
	 * @param oldValue
	 */
	void setOldValue(Object oldValue);
		
	/**
	 * Returns the old name for the RENAME action.
	 * @return oldValue
	 */
	Object getOldValue();
	
	/**
	 * Sets the newValue for the RENAME action.
	 * @param newValue
	 */
	void setNewValue(Object newValue);
	
	/**
	 * Optionally returns the new name for the RENAME action.
	 * @return newValue
	 */
	Object getNewValue();
	
	/**
	 * @return consumedState - query specific consumed state.
	 */
	boolean isEventConsumed();
	
	/**
	 * Consumes the query specific consumed state.
	 */
	void consumeEvent();
	
}
