/*
 * Initially Created on Apr 24, 2003 by vhaislmonsos
 *
 */
package gov.va.med.hds.querytool.ui;

import gov.va.med.hds.querytool.ICombinedQueryCollection;
import gov.va.med.hds.querytool.IQueryCollectionEvent;

import javax.swing.ListModel;

/**
 * Interface for an ICombinedQueryCollection model to ListModel adapter.
 */
public interface IQueryListModel extends ListModel {
	
	/**
	 * Sets the collection model for this ListModel adapter.
	 * @param collection
	 */
	void setModel(ICombinedQueryCollection collection);
	
	/**
	 * Fires off a data changed event.
	 * @param event
	 */
	void fireDataChange(IQueryCollectionEvent event);
	
	/**
	 * Returns the status of the list item passed in.
	 * @param item
	 * @return boolean
	 */
	boolean isQueryItem(Object item);
	
	/**
	 * Returns the status of the list item passed in.
	 * @param item
	 * @return boolean
	 */
	boolean isCustomQuerySelection(Object item);
	
}