/*
 * Initially Created on Mar 12, 2003 by vhaislmonsos
 *
 */
package gov.va.med.hds.querytool.ui;


/**
 * Query page events.
 */
public interface IQueryPageEvent {
	public static final int CLEAR_ALL = 1;
	public static final int SELECT_ALL = 2;
	public static final int SELECT = 3;
	public static final int REMOVE = 4;
	public static final int MOVE_UP = 5;
	public static final int MOVE_DOWN = 6;
	public static final int MOVE_COLUMN = 7;
	public static final int COLUMN_RESIZE = 8;
	
	/**
	 * Gets the "from" index.
	 * @return int
	 */
	int getFromIndex();
	
	/**
	 * Gets the "to" index.
	 * @return int
	 */
	int getToIndex();
	
	/**
	 * Sets the fromIndex.
	 * @param fromIndex The fromIndex to set
	 */
	void setFromIndex(int fromIndex);
	
	/**
	 * Sets the toIndex.
	 * @param toIndex The toIndex to set
	 */
	void setToIndex(int toIndex);
	
	/**
	 * Returns the event ID.
	 * @return int
	 */
	int getEventID();
	
	/**
	 * Sets the eventID.
	 * @param eventID The eventID to set
	 */
	void setEventID(int eventID);
	
	/**
	 * Returns source object of event.
	 * @return source
	 */
	Object getSource();
	
	/**
	 * @param array
	 */
	void setIndexArray(int[] array);
	
	/**
	 * @return indexArray
	 */
	int[] getIndexArray();
	
}