/*
 * Initially Created on Apr 25, 2003 by vhaislmonsos
 *
 */
package gov.va.med.hds.querytool.ui;

import gov.va.med.hds.cd.runtime.IRuntimeContext;
import gov.va.med.hds.cd.spectrum.wizard.IPageSetModel;
import gov.va.med.hds.querytool.IQueryTool;
import gov.va.med.hds.querytool.dao.QueryDAOException;

/**
 * The query wizard page set interface.
 */
public interface IQueryPageSetModel extends IPageSetModel {
	
	/**
	 * Sets the queryTool model.
	 * @param queryToolModel
	 */
	void setModel(IQueryTool queryTool) throws QueryDAOException;
	
	/**
	 * Clears the query model set.
	 */
	void clearModel();
	
	/**
	 * Sets the runtime context.
	 * @param runtime
	 */
	void setRuntime(IRuntimeContext runtime);
	
	/**
	 * Returns the save checkbox state from the final page.
	 * @return boolean
	 */
	boolean isSaveSelected();
	
	/**
	 * Returns the display name entered by the user.
	 * @return displayName
	 */
	String getDisplayName();
	
	/**
	 * @return queryHTMLPanel
	 */
	IQueryHTMLPanel getHTMLPanel();

}