/*
 * Initially Created on May 29, 2003 by vhaislmonsos
 *
 */
package gov.va.med.hds.querytool.ui;

import java.awt.Cursor;

import javax.swing.JComponent;

/**
 * Interface to manage a collection of query pages.
 */
public interface IQueryPages {
	/**
	 * Selects the page to display based on the pageKey.  If the page key exists, this method returns
	 * true; returns false otherwise.
	 * @param pageKey
	 * @return
	 */
	boolean selectPage(String pageKey);
	
	/**
	 * Adds the given page to the collection.
	 * @param pageKey
	 * @param page
	 */
	void addPage(String pageKey, JComponent page);

	/**
	 * Returns the state of the page key.
	 * @param pageKey
	 * @return containsPageKey
	 */
	boolean contains(String pageKey);
	
	/**
	 * @return cursor
	 */
	Cursor getCursor();
	
	/**
	 * @param cursor
	 */
	void setCursor(Cursor cursor);
}
