package gov.va.med.hds.querytool.ui;

import java.util.List;

import javax.swing.JPanel;

/**
 * A collection of constraint panel items.
 */
public interface IQueryPanelItems {
	
	/**
	 * Returns the list of dependencies for the given panel.
	 * @return list
	 */
	List getDependencies();
	
	/**
	 * Returns the constraint panel.
	 * @return panel
	 */
	JPanel getPanel();
	
	/**
	 * Sets the list of dependencies for this panel.
	 * @param dependencies
	 */
	void setDependencies(List dependencies);
	
	/**
	 * Sets the constraint panel.
	 * @param panel
	 */
	void setPanel(JPanel panel);
	
	/**
	 * Returns the title for this constraint panel.
	 * @return title
	 */
	String getTitle();
	
	/**
	 * Sets the title for this constraint panel.
	 * @param title
	 */
	void setTitle(String title);
	
	/**
	 * Returns the list of tag components for this panel.
	 * @return list
	 */
	List getTagComponents();
	
	/**
	 * Gets the panel requirements set.
	 * @return list
	 */
	List getRequirements();
	
	/**
	 * Sets the list of requirements for the panel.
	 * @param requirements
	 */
	void setRequirements(List requirements);
	
}