package gov.va.med.hds.querytool.ui.editor;

import gov.va.med.hds.cd.daoregistry.IDaoRegistry;
import gov.va.med.hds.cd.runtime.IRuntimeContext;
import gov.va.med.hds.cd.runtime.PluginStartupException;
import gov.va.med.hds.querytool.ui.types.EditorException;

import java.util.List;

/**
 * @author vhaislmonsos
 *
 * Dec 12, 2002 3:04:19 PM
 */
public interface IRunnableEditorPanel {
	/**
	 * Method getValues.
	 * @return List
	 */
	List getValues();
	
	/**
	 * Method getDisplayText.
	 * @return String
	 */
	String getDisplayText();
	
	/**
	 * Method setRuntime.
	 * @param runtime
	 */
	void setRuntime(IRuntimeContext runtime) throws PluginStartupException, EditorException;

	/**
	 * Method setDAORegistry.
	 * @param daoRegistry
	 */
	void setDAORegistry(IDaoRegistry daoRegistry);
	
	/**
	 * Method init.
	 */
	void init() throws EditorException;
	
	/**
	 * Method setValues.
	 * @param values
	 */
	void setValues(List values);
	
	/**
	 * Method getWindowHeader.
	 * @return String
	 */
	String getWindowHeader();
	
	/**
	 * Disconnects any registered models; called before object is abandoned.
	 */
	void clearModels();
	
	/**
	 * Gets the state of the editor
	 * @return
	 */
	IRunnableEditorState getEditorState();
	
	/**
	 * Sets the state of the editor
	 */
	void setEditorState(IRunnableEditorState state);
	
	/**
	 * Adds a listener that gets notified when the editor state changes
	 * @param listener
	 */
	void addEditorStateChangeListener(IRunnableEditorStateChangeListener listener);
	
	/**
	 * Removes the specified state change listener
	 * @param listener
	 */
	void removeEditorStateChangeListener(IRunnableEditorStateChangeListener listener);
	
	/**
	 * Notifies all EditorStateChangeListeners of state change
	 * @param e
	 */
	void notifyEditorStateChanged(RunnableEditorStateChangedEvent e);
	
}
