/*
 * Created on Mar 27, 2003 by vhaislmonsos
 */
package gov.va.med.hds.querytool.ui.editor.factory;

import gov.va.med.hds.cd.runtime.IRuntimeContext;
import gov.va.med.hds.querytool.ui.editor.IRunnableEditorPanel;
import gov.va.med.hds.querytool.ui.types.EditorException;

/**
 * This is the top level interface for IRunnableEditorPanel factories.
 */
public interface IEditorFactory {
	
	/**
	 * Returns the implementation specific editor.
	 * @return
	 */
	IRunnableEditorPanel getEditor() throws EditorException;
	
	/**
	 * Initializes the factory with the IRuntimeContext.
	 * @param runtime
	 * @throws EditorException
	 */
	void setRuntime(IRuntimeContext runtime) throws EditorException;
	
	/**
	 * Returns the runtimeContext held by this instance.
	 * @return runtimeContext
	 */
	IRuntimeContext getRuntime();
		
}
