package gov.va.med.hds.cd.runtime.internal;

import java.util.LinkedList;
import java.util.List;

import javax.xml.parsers.DocumentBuilder;

import org.w3c.dom.Attr;
import org.w3c.dom.Element;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.NodeList;
import org.w3c.dom.Text;

import gov.va.med.hds.cd.runtime.IRuntimeContext;

public class DOMConfigurationElementReader {

	private DocumentBuilder builder;
	private IRuntimeContext runtime;

	public DOMConfigurationElementReader(IRuntimeContext runtime) {
		this.runtime = runtime;
	}

	public ConfigurationElement[] readConfigurationElements(Element extensionElement) {
		List configurationElements = new LinkedList();
		NodeList children = extensionElement.getChildNodes();
		for (int i = 0; i < children.getLength(); ++i) {
			if (children.item(i) instanceof Element)
				configurationElements.add(readConfigurationElement((Element) children.item(i)));
		}

		return (ConfigurationElement[]) configurationElements.toArray(
			new ConfigurationElement[configurationElements.size()]);
	}

	public ConfigurationElement readConfigurationElement(Element e) {
		ConfigurationElement configElement = new ConfigurationElement(e.getTagName());

		NamedNodeMap attributes = e.getAttributes();
		for (int i = 0; i < attributes.getLength(); ++i) {
			Attr a = (Attr) attributes.item(i);
			configElement.addAttribute(a.getName(), a.getValue());
		}

		StringBuffer value = new StringBuffer();

		NodeList children = e.getChildNodes();
		for (int i = 0; i < children.getLength(); ++i) {
			if (children.item(i) instanceof Text) {
				value.append(((Text) children.item(i)).getNodeValue());
			}
			if (children.item(i) instanceof Element) {
				configElement.addChild(readConfigurationElement((Element) children.item(i)));
			}
		}

		configElement.setValue(value.toString());

		return configElement;
	}
}
