package gov.va.med.hds.cd.runtime.internal;

import java.util.LinkedList;
import java.util.List;

import gov.va.med.hds.cd.runtime.IConfigurationElement;
import gov.va.med.hds.cd.runtime.IExtension;
import gov.va.med.hds.cd.runtime.IPluginDescriptor;

public class Extension implements IExtension {

	private IPluginDescriptor parent;
	private String extensionPointId;
	private String name;
	private String id;
	
	private List configurationElements = new LinkedList();

	public Extension(
		IPluginDescriptor parent,
		String extensionPointId) {
		this(parent, extensionPointId, null, null);
	}

	public Extension(
		IPluginDescriptor parent,
		String extensionPointId,
		String id,
		String name) {
		this.parent = parent;
		this.extensionPointId = extensionPointId;
		this.name = "".equals(name) ? null : name;
		this.id = "".equals(id) ? null : id;
	}

	public IConfigurationElement[] getConfigurationElements() {
		return (IConfigurationElement[]) configurationElements.toArray(new IConfigurationElement[configurationElements.size()]);
	}

	public IPluginDescriptor getDeclaringPluginDescriptor() {
		return parent;
	}

	public String getExtensionPointUniqueIdentifier() {
		return extensionPointId;
	}

	public String getLabel() {
		return name;
	}

	public String getSimpleIdentifier() {
		return id;
	}

	public String getUniqueIdentifier() {
		if (id == null || id.equals(""))
			return null;
		return parent.getUniqueIdentifier() + "." + id;
	}
	
	public void addConfigurationElement(ConfigurationElement element) {
		element.setDeclaringExtension(this);
		configurationElements.add(element);
	}
}
