package gov.va.med.hds.cd.runtime.internal;

import gov.va.med.hds.cd.runtime.IExtensionPoint;
import gov.va.med.hds.cd.runtime.IPluginDescriptor;

class ExtensionPoint implements IExtensionPoint {

	private IPluginDescriptor parent;
	private String name;
	private String id;
	private String schemaReference;

	ExtensionPoint(IPluginDescriptor parent, String id, String name) {
		this(parent, id, name, null);
	}
	
	ExtensionPoint(IPluginDescriptor parent, String id, String name, String schemaReference) {
		this.parent = parent;
		this.name = name;
		this.id = id;
		this.schemaReference = schemaReference;
	}

	public IPluginDescriptor getDeclaringComponentDescriptor() {
		return parent;
	}

	public String getLabel() {
		return name;
	}

	public String getSimpleIdentifier() {
		return id;
	}

	public String getUniqueIdentifier() {
		return parent.getUniqueIdentifier() + "." + getSimpleIdentifier();
	}
	
	public String getSchemaReference() {
		return schemaReference;
	}
}
