package gov.va.med.hds.cd.runtime.internal;

import gov.va.med.hds.cd.mum.Version;
import gov.va.med.hds.cd.runtime.IPluginPrerequisite;
import gov.va.med.hds.cd.runtime.VersionMatchCondition;

public class PluginPrerequisite implements IPluginPrerequisite {

	public static final VersionMatchCondition DEFAULT_MATCH_CONDITION = VersionMatchCondition.GREATER_OR_EQUAL;

	private String id;
	private Version version;
	private VersionMatchCondition matchCondition;

	public PluginPrerequisite(String prereqId, Version prereqVersion) {
		this(prereqId, prereqVersion, DEFAULT_MATCH_CONDITION);
	}

	public PluginPrerequisite(String prereqId, Version prereqVersion, VersionMatchCondition matchCondition) {
		this.id = prereqId;
		this.version = prereqVersion;
		this.matchCondition = matchCondition;
	}

	public String getUniqueIdentifier() {
		return id;
	}

	public Version getVersion() {
		return version;
	}
	public boolean isMatchedAsGreaterOrEqual() {
		return VersionMatchCondition.GREATER_OR_EQUAL.equals(matchCondition);
	}
	public boolean isMatchedAsCompatible() {
		return VersionMatchCondition.COMPATIBLE.equals(matchCondition);
	}
	public boolean isMatchedAsEquivalent() {
		return VersionMatchCondition.EQUIVALENT.equals(matchCondition);
	}
	public boolean isMatchedAsPerfect() {
		return VersionMatchCondition.PERFECT.equals(matchCondition);
	}
}
