package gov.va.med.hds.cd.runtime.internal;

import gov.va.med.hds.cd.runtime.IPluginDescriptor;
import gov.va.med.hds.cd.runtime.IPluginPrerequisite;
import gov.va.med.hds.cd.runtime.IRuntimeConstants;
import gov.va.med.hds.cd.runtime.VersionMatchCondition;

public class RuntimeUtilities {
	public static boolean isRuntimePlugin(IPluginDescriptor plugin) {
		return isRuntimePlugin(plugin.getUniqueIdentifier());
	}
	
	public static boolean isRuntimePlugin(String pluginId) {
		return IRuntimeConstants.PLUGIN_ID.equals(pluginId) || IRuntimeCoreConstants.PLUGIN_ID.equals(pluginId);
	}
	
	public static VersionMatchCondition getPrerequisiteMatchCondition(IPluginPrerequisite prereq) {
		if (prereq.isMatchedAsGreaterOrEqual()) {
			return VersionMatchCondition.GREATER_OR_EQUAL;
		} else if (prereq.isMatchedAsCompatible()) {
			return VersionMatchCondition.COMPATIBLE;
		} else if (prereq.isMatchedAsEquivalent()) {
			return VersionMatchCondition.EQUIVALENT;
		} else if (prereq.isMatchedAsPerfect()) {
			return VersionMatchCondition.PERFECT;
		}
		return PluginPrerequisite.DEFAULT_MATCH_CONDITION;
		
//		if (prereq.isMatchedAsGreaterOrEqual()
//						&& plugins[i].getVersion().isGreaterOrEqualTo(prereq.getVersion()))
//						return true;
//					else if (
//						prereq.isMatchedAsCompatible()
//							&& plugins[i].getVersion().isCompatibleWith(prereq.getVersion()))
//						return true;
//					else if (
//						prereq.isMatchedAsEquivalent()
//							&& plugins[i].getVersion().isEquivalentTo(prereq.getVersion()))
//						return true;
//					else if (
//						prereq.isMatchedAsPerfect()
//							&& plugins[i].getVersion().isPerfect(prereq.getVersion()))
//						return true;
//					else if (
//						prereq.isMatchedAsExact()
//							&& plugins[i].getVersion().equals(prereq.getVersion()))
//						return true;
	}
}
