package gov.va.med.hds.cd.runtime.internal;

import java.util.LinkedList;
import java.util.List;

import gov.va.med.hds.cd.mum.boot.utils.ITreeData;
import gov.va.med.hds.cd.runtime.IRuntimeContext;

/**
 * enclosing_type
 */
public class TreeDataConfigurationElementReader {

	private IRuntimeContext runtime;

	/**
	 * Constructor for TreeDataConfigurationElementReader.
	 */

	public TreeDataConfigurationElementReader(IRuntimeContext runtime) {
		this.runtime = runtime;
	}

	public ConfigurationElement[] readConfigurationElements(ITreeData xml) {
		return readConfigurationElements(xml, xml.getRootID());
	}
	
	public ConfigurationElement[] readConfigurationElements(ITreeData xml, int root) {
		List configurationElements = new LinkedList();
		for (int i = 0; i < xml.getChildCount(root); i++) {
			configurationElements.add(
				readConfigurationElement(xml, xml.getChildID(root, i)));
		}

		return (ConfigurationElement[]) configurationElements.toArray(
			new ConfigurationElement[configurationElements.size()]);
	}

	public ConfigurationElement readConfigurationElement(
		ITreeData xml,
		int node) {
		ConfigurationElement configElement =
			new ConfigurationElement(xml.getName(node));

		String value = xml.getValue(node);
		if(value == null)
			configElement.setValue("");
		else
			configElement.setValue(value);	

		for (int i = 0; i < xml.getAttributeCount(node); ++i) {
			configElement.addAttribute(
				xml.getAttributeName(node, i),
				xml.getAttributeValue(node, i));
		}

		for (int i = 0; i < xml.getChildCount(node); ++i) {
			int child = xml.getChildID(node, i);
			configElement.addChild(readConfigurationElement(xml, child));
		}
		return configElement;
	}
}
