package gov.va.med.hds.cd.runtime.logging.internal;

import java.util.HashMap;
import java.util.Map;

import org.apache.log4j.Level;
import org.apache.log4j.LogManager;
import org.apache.log4j.Logger;

import gov.va.med.hds.cd.runtime.logging.ILogger;
import gov.va.med.hds.cd.runtime.logging.ILoggingCapable;
import gov.va.med.hds.cd.runtime.logging.log4j.internal.LoggerAdapter;

public class Log4JLogging implements ILoggingCapable {

	private static final String ROOT = "/root";
	
	private Map loggers = new HashMap();

	public Log4JLogging() {
		LogManager.resetConfiguration();
		configure();
		addLogger(ROOT);
	}

	public ILogger getLogger(Class c) {
		return getLogger(c.getName());
	}

	public ILogger getLogger(String name) {
		if (!loggers.containsKey(name)) {
			addLogger(name);
		}
		return (ILogger) loggers.get(name);
	}

	public ILogger getRootLogger() {
		return (ILogger) loggers.get(ROOT);
	}

	private void addLogger(String name) {
		Logger logger = null;
		if (name.equals(ROOT)) {
			logger = Logger.getRootLogger();
		} else {
			logger = Logger.getLogger(name);
		}
		ILogger loggerAdapter = new LoggerAdapter(logger);
		loggers.put(name, loggerAdapter);
	}

	private void configure() {
		Logger.getRootLogger().setLevel(Level.ERROR);
	}
}
