package gov.va.med.hds.cd.runtime.logging.log4j.internal;

import java.util.HashMap;
import java.util.Map;

import org.apache.log4j.Appender;
import org.apache.log4j.Logger;

import gov.va.med.hds.cd.runtime.logging.IHandler;
import gov.va.med.hds.cd.runtime.logging.ILogger;
import gov.va.med.hds.cd.runtime.logging.Level;

/**
 * TODO_SB: Provide description for "Log4JLoggerAdapter".
 */
public class LoggerAdapter implements ILogger {

	private Logger logger;
	private Map handlers = new HashMap();

	public LoggerAdapter(Logger logger) {
		this.logger = logger;
	}
	
	public void fatal(String message) {
		logger.fatal(message);
	}

	public void fatal(String message, Throwable t) {
		logger.fatal(message, t);
	}

	public void error(String message) {
		logger.error(message);
	}

	public void error(String message, Throwable t) {
		logger.error(message, t);
	}

	public void warning(String message) {
		logger.warn(message);
	}

	public void warning(String message, Throwable t) {
		logger.warn(message, t);
	}

	public void info(String message) {
		logger.info(message);
	}

	public void info(String message, Throwable t) {
		logger.info(message, t);
	}

	public void debug(String message) {
		logger.debug(message);
	}

	public void debug(String message, Throwable t) {
		logger.debug(message, t);
	}
	
	public void log(Level level, String message) {
		if (Level.FATAL.equals(level)) {
			logger.log(org.apache.log4j.Level.FATAL, message);
		} else if (Level.ERROR.equals(level)) {
			logger.log(org.apache.log4j.Level.ERROR, message);
		} else if (Level.WARNING.equals(level)) {
			logger.log(org.apache.log4j.Level.WARN, message);
		} else if (Level.INFO.equals(level)) {
			logger.log(org.apache.log4j.Level.INFO, message);
		} else if (Level.DEBUG.equals(level)) {
			logger.log(org.apache.log4j.Level.DEBUG, message);
		}
	}

	public void log(Level level, String message, Throwable t) {
		if (Level.FATAL.equals(level)) {
			logger.log(org.apache.log4j.Level.FATAL, message, t);
		} else if (Level.ERROR.equals(level)) {
			logger.log(org.apache.log4j.Level.ERROR, message, t);
		} else if (Level.WARNING.equals(level)) {
			logger.log(org.apache.log4j.Level.WARN, message, t);
		} else if (Level.INFO.equals(level)) {
			logger.log(org.apache.log4j.Level.INFO, message, t);
		} else if (Level.DEBUG.equals(level)) {
			logger.log(org.apache.log4j.Level.DEBUG, message, t);
		}
	}
	
	public void addHandler(IHandler logHandler) {
		logger.addAppender(getAppender(logHandler));
	}

	public void removeHandler(IHandler logHandler) {
		logger.removeAppender(getAppender(logHandler));
	}

	protected Appender getAppender(IHandler handler) {
		if (!handlers.containsKey(handler)) {
			handlers.put(handler, new HandlerAdapter(handler));
		}
		return (Appender) handlers.get(handler);
	}

	public void setUseParentHandlers(boolean b) {
		logger.setAdditivity(b);
	}

	public boolean getUseParentHandlers() {
		return logger.getAdditivity();
	}
}
