package gov.va.med.hds.cd.runtime.logging.log4j.internal;

import gov.va.med.hds.cd.runtime.logging.ILogRecord;
import gov.va.med.hds.cd.runtime.logging.Level;

import org.apache.log4j.Layout;
import org.apache.log4j.spi.LoggingEvent;

public class LoggingEventAdapter implements ILogRecord {

	private LoggingEvent log;
	private Layout layout = new DesktopLayout();

	public LoggingEventAdapter(LoggingEvent log) {
		this.log = log;
	}

	public Level getLevel() {
		switch (log.getLevel().toInt()) {
			case org.apache.log4j.Level.FATAL_INT :
				return Level.FATAL;
			case org.apache.log4j.Level.ERROR_INT :
				return Level.ERROR;
			case org.apache.log4j.Level.WARN_INT :
				return Level.WARNING;
			case org.apache.log4j.Level.INFO_INT :
				return Level.INFO;
			case org.apache.log4j.Level.DEBUG_INT :
				return Level.DEBUG;
		}
		return null;
	}

	public String getMessage() {
		return layout.format(log);
	}
}
