package gov.va.med.hds.cd.runtime.test;

import junit.framework.TestCase;

import org.apache.log4j.Level;
import org.apache.log4j.LogManager;
import org.apache.log4j.Logger;

import gov.va.med.hds.cd.runtime.internal.ConfigurationElement;
import gov.va.med.hds.cd.runtime.logging.log4j.internal.ConfigurationElementLogConfigurator;

public class ConfigurationElementLogConfiguratorTest extends TestCase {
	
	private ConfigurationElement loggingConfiguration = new ConfigurationElement("logging");
	
	public ConfigurationElementLogConfiguratorTest(String name) {
		super(name);
	}
	
	protected void setUp() throws Exception {
		super.setUp();
		LogManager.resetConfiguration();
	}
	
	public void testSetRootLevel() {
		ConfigurationElement root = new ConfigurationElement("root");
		ConfigurationElement level = new ConfigurationElement("level");
		level.addAttribute("value","debug");
		root.addChild(level);
		loggingConfiguration.addChild(root);	
	
		ConfigurationElementLogConfigurator.configure(loggingConfiguration);
		assertEquals(Level.DEBUG, Logger.getRootLogger().getLevel());
	}
	
	public void testSetCategoryLevel() {
		ConfigurationElement category = new ConfigurationElement("category");
		category.addAttribute("name", getClass().getName());
		ConfigurationElement level = new ConfigurationElement("level");
		level.addAttribute("value","info");
		category.addChild(level);
		loggingConfiguration.addChild(category);	
	
		ConfigurationElementLogConfigurator.configure(loggingConfiguration);
		assertEquals(Level.INFO, Logger.getLogger(getClass()).getLevel());
	}
}
