package gov.va.med.hds.cd.runtime.test;

import mockmaker.ExceptionalReturnValue;
import mockmaker.ReturnValues;
import mockmaker.VoidReturnValues;

import com.mockobjects.ExpectationCounter;
import com.mockobjects.ExpectationList;

import gov.va.med.hds.cd.runtime.IPlugin;
import gov.va.med.hds.cd.runtime.IPluginDescriptor;
import gov.va.med.hds.cd.runtime.IRuntimeContext;

public class MockPlugin implements IPlugin {
	private ExpectationCounter myStartupCalls =
		new ExpectationCounter("gov.va.med.hds.cd.runtime.IPlugin StartupCalls");
	private ReturnValues myActualStartupReturnValues = new VoidReturnValues(false);
	private ExpectationList myStartupParameter0Values =
		new ExpectationList("gov.va.med.hds.cd.runtime.IPlugin gov.va.med.hds.cd.runtime.IRuntimeContext");
	private ExpectationList myStartupParameter1Values =
		new ExpectationList("gov.va.med.hds.cd.runtime.IPlugin gov.va.med.hds.cd.runtime.IPluginDescriptor");
	private ExpectationCounter myShutdownCalls =
		new ExpectationCounter("gov.va.med.hds.cd.runtime.IPlugin ShutdownCalls");
	private ReturnValues myActualShutdownReturnValues = new VoidReturnValues(false);

	public MockPlugin() {
		setExpectedStartupCalls(1);
	}

	public void setExpectedStartupCalls(int calls) {
		myStartupCalls.setExpected(calls);
	}
	public void addExpectedStartupValues(IRuntimeContext arg0, IPluginDescriptor arg1) {
		myStartupParameter0Values.addExpected(arg0);
		myStartupParameter1Values.addExpected(arg1);
	}
	public void startup(IRuntimeContext arg0, IPluginDescriptor arg1) throws Exception {
		myStartupCalls.inc();
		myStartupParameter0Values.addActual(arg0);
		myStartupParameter1Values.addActual(arg1);
		Object nextReturnValue = myActualStartupReturnValues.getNext();
		if (nextReturnValue instanceof ExceptionalReturnValue
			&& ((ExceptionalReturnValue) nextReturnValue).getException() instanceof Exception)
			throw (Exception) ((ExceptionalReturnValue) nextReturnValue).getException();
		if (nextReturnValue instanceof ExceptionalReturnValue
			&& ((ExceptionalReturnValue) nextReturnValue).getException() instanceof RuntimeException)
			throw (RuntimeException) ((ExceptionalReturnValue) nextReturnValue).getException();
	}
	public void setupExceptionStartup(Throwable arg) {
		myActualStartupReturnValues.add(new ExceptionalReturnValue(arg));
	}
	public void setExpectedShutdownCalls(int calls) {
		myShutdownCalls.setExpected(calls);
	}
	public void shutdown() throws Exception {
		myShutdownCalls.inc();
		Object nextReturnValue = myActualShutdownReturnValues.getNext();
		if (nextReturnValue instanceof ExceptionalReturnValue
			&& ((ExceptionalReturnValue) nextReturnValue).getException() instanceof Exception)
			throw (Exception) ((ExceptionalReturnValue) nextReturnValue).getException();
		if (nextReturnValue instanceof ExceptionalReturnValue
			&& ((ExceptionalReturnValue) nextReturnValue).getException() instanceof RuntimeException)
			throw (RuntimeException) ((ExceptionalReturnValue) nextReturnValue).getException();
	}
	public void setupExceptionShutdown(Throwable arg) {
		myActualShutdownReturnValues.add(new ExceptionalReturnValue(arg));
	}
	public void verify() {
		myStartupCalls.verify();
		myStartupParameter0Values.verify();
		myStartupParameter1Values.verify();
		myShutdownCalls.verify();
	}
}
