package gov.va.med.hds.cd.runtime.test;

import java.util.Comparator;

import junit.framework.TestCase;

import gov.va.med.hds.cd.mum.Version;
import gov.va.med.hds.cd.runtime.IPluginDescriptor;
import gov.va.med.hds.cd.runtime.internal.PluginDescriptor;
import gov.va.med.hds.cd.runtime.internal.PluginDescriptorComparator;

public class PluginDescriptorComparatorTest extends TestCase {

	public PluginDescriptorComparatorTest(String arg0) {
		super(arg0);
	}

	public void testEqual() {
		IPluginDescriptor p1 = new PluginDescriptor(null, getClass().getClassLoader(), "comparatorTestPlugin", "A PluginDescriptorComparatorTest plugin descriptor", new Version("3.1.59.pi"));
		IPluginDescriptor p2 = new PluginDescriptor(null, getClass().getClassLoader(), "comparatorTestPlugin", "A PluginDescriptorComparatorTest plugin descriptor", new Version("3.1.59.pi"));
		Comparator c = new PluginDescriptorComparator();
		assertEquals(0, c.compare(p1, p2));
	}

	public void testLessThan() {
		IPluginDescriptor p1 = new PluginDescriptor(null, getClass().getClassLoader(), "comparatorTestPlugin", "A PluginDescriptorComparatorTest plugin descriptor", new Version("1.2.3"));
		IPluginDescriptor p2 = new PluginDescriptor(null, getClass().getClassLoader(), "comparatorTestPlugin", "A PluginDescriptorComparatorTest plugin descriptor", new Version("3.1.59.pi"));
		Comparator c = new PluginDescriptorComparator();
		assertTrue(c.compare(p1, p2) < 0);
		
		p1 = new PluginDescriptor(null, getClass().getClassLoader(), "a", "A PluginDescriptorComparatorTest plugin descriptor", new Version("3.1.59.pi"));
		p2 = new PluginDescriptor(null, getClass().getClassLoader(), "b", "A PluginDescriptorComparatorTest plugin descriptor", new Version("3.1.59.pi"));
		assertTrue(c.compare(p1, p2) < 0);
	}

	public void testGreaterThan() {
		IPluginDescriptor p1 = new PluginDescriptor(null, getClass().getClassLoader(), "comparatorTestPlugin", "A PluginDescriptorComparatorTest plugin descriptor", new Version("3.1.59.pi"));
		IPluginDescriptor p2 = new PluginDescriptor(null, getClass().getClassLoader(), "comparatorTestPlugin", "A PluginDescriptorComparatorTest plugin descriptor", new Version("1.2.3"));
		Comparator c = new PluginDescriptorComparator();
		assertTrue(c.compare(p1, p2) > 0);
		
		p1 = new PluginDescriptor(null, getClass().getClassLoader(), "b", "A PluginDescriptorComparatorTest plugin descriptor", new Version("3.1.59.pi"));
		p2 = new PluginDescriptor(null, getClass().getClassLoader(), "a", "A PluginDescriptorComparatorTest plugin descriptor", new Version("3.1.59.pi"));
		assertTrue(c.compare(p1, p2) > 0);
	}
}
