package gov.va.med.hds.cd.runtime.test;

import java.io.IOException;

import junit.extensions.jfcunit.JFCTestCase;
import junit.extensions.jfcunit.JFCTestHelper;
import junit.extensions.jfcunit.eventdata.JFCEventManager;

import gov.va.med.hds.cd.runtime.InvalidPluginDescriptorException;

public abstract class RuntimeJFCTestCase extends JFCTestCase {

	private RuntimeTestCase runtimeTestCase;

	public RuntimeJFCTestCase(String name) {
		super(name);
	}

	protected void setUp() throws Exception {
		super.setUp();
		runtimeTestCase = new DelegatingRuntimeTestCase(getName());
		runtimeTestCase.setUp();
	}

	protected void tearDown() throws Exception {
		JFCEventManager.setDebug(false);
		JFCEventManager.setRecording(false);
		JFCTestHelper.cleanUp(this);

		runtimeTestCase.tearDown();

		super.tearDown();
	}

	public void parseRegistryResource(String resourceName) throws InvalidPluginDescriptorException, IOException {
		runtimeTestCase.validateRegistryResource(getClass().getResourceAsStream(resourceName));
		runtimeTestCase.parseRegistryResource(getClass().getResourceAsStream(resourceName));
	}

	public TestRuntime getRuntime() {
		return runtimeTestCase.getRuntime();
	}

	private class DelegatingRuntimeTestCase extends RuntimeTestCase {
		public DelegatingRuntimeTestCase(String name) {
			super(name);
		}
	}

}
