package gov.va.med.hds.cd.runtime.test;

import junit.extensions.TestSetup;
import junit.framework.Test;

import org.xml.sax.SAXException;

import gov.va.med.hds.cd.runtime.IRuntimeContext;

public abstract class RuntimeTestSetup extends TestSetup {

	private RuntimeTestCase runtimeTestCase;

	public RuntimeTestSetup(Test name) {
		super(name);
	}
	
	protected void setUp() throws Exception {
		runtimeTestCase = new DelegatingRuntimeTestCase();
		runtimeTestCase.setUp();
	}

	protected void tearDown() throws Exception {
		runtimeTestCase.tearDown();
		runtimeTestCase = null;
	}

	public IRuntimeContext getRuntime() {
		return runtimeTestCase.getRuntime();
	}
	
	public void parseRegistryResource(String resourceName) throws SAXException {
 		runtimeTestCase.parseRegistryResource(getClass().getResourceAsStream(resourceName));
    }
    
    private class DelegatingRuntimeTestCase extends RuntimeTestCase {
		public DelegatingRuntimeTestCase() {
			super("delegating runtime test case");
		}
    }
}
