package gov.va.med.hds.cd.runtime.test;

import java.io.IOException;

import org.custommonkey.xmlunit.XMLTestCase;

import gov.va.med.hds.cd.runtime.InvalidPluginDescriptorException;

public abstract class RuntimeXMLTestCase extends XMLTestCase {
	private RuntimeTestCase runtimeTestCase;

	public TestRuntime getRuntime() {
		return runtimeTestCase.getRuntime();
	}

	private class DelegatingRuntimeTestCase extends RuntimeTestCase {
		public DelegatingRuntimeTestCase(String name) {
			super(name);
		}
	}

	public RuntimeXMLTestCase(String name){
		super(name);
	}
	
	protected void setUp() throws Exception {
		super.setUp();
//		XMLUnit.setControlParser(
//			"org.apache.xerces.jaxp.DocumentBuilderFactoryImpl");
//		// this next line is strictly not required - if no test parser is
//		// explicitly specified then the same factory class will be used for
//		// both test and control
//		XMLUnit.setTestParser(
//			"org.apache.xerces.jaxp.DocumentBuilderFactoryImpl");
//
//		XMLUnit.setSAXParserFactory(
//			"org.apache.xerces.jaxp.SAXParserFactoryImpl");
//		XMLUnit.setTransformerFactory(
//			"org.apache.xalan.processor.TransformerFactoryImpl");

		runtimeTestCase = new DelegatingRuntimeTestCase(getName());
		runtimeTestCase.setUp();
	}

	protected void tearDown() throws Exception {
		runtimeTestCase.tearDown();
		super.tearDown();
	}

	protected void parseRegistryResource(String resourceName) throws InvalidPluginDescriptorException, IOException {
		runtimeTestCase.validateRegistryResource(getClass().getResourceAsStream(resourceName));
		runtimeTestCase.parseRegistryResource(getClass().getResourceAsStream(resourceName));
	}
}
