package gov.va.med.hds.cd.runtime.test;

import java.util.Comparator;

import junit.framework.TestCase;

import gov.va.med.hds.cd.mum.Version;
import gov.va.med.hds.cd.runtime.VersionComparator;

public class VersionComparatorTest extends TestCase {

	public VersionComparatorTest(String name) {
		super(name);
	}

	public void testEqual() {
		Version v1 = new Version("3.1.59.pi");
		Version v2 = new Version("3.1.59.pi");
		Comparator c = new VersionComparator();
		assertEquals(0, c.compare(v1,v2));
	}
	
	public void testLessThan() {
		Version v1 = new Version("0.9");
		Version v2 = new Version("0.9.1");
		Comparator c = new VersionComparator();
		assertTrue(c.compare(v1,v2) < 0);
	}
		
	public void testGreaterThan() {
		Version v1 = new Version("1.4.159.rootTwo");
		Version v2 = new Version("0.8");
		Comparator c = new VersionComparator();
		assertTrue(c.compare(v1,v2) > 0);
	}
}
