package gov.va.med.hds.cd.runtime;

import gov.va.med.hds.cd.mum.boot.ISplashScreen;

/**
 * Classes implementing <code>IMainPlugin</code> can be handed execution control
 * by the runtime when they extend the 'gov.va.med.hds.cd.runtime.mainPlugin"
 * extension point.
 * <p>
 * For example, the default main plugin for the Desktop is Prism, which
 * displays the user interface of the desktop.
 * </p>
 * <p>
 * Clients may implement this interface.
 * </p>
 */
public interface IMainPlugin extends IPlugin {
	/**
	 * Runs the main plugin.
	 * @param runtime instance of runtime so that when the main plugin exits it can shutdown the runtime
	 * @param args command line arguments to pass through to the main plugin
	 */
	void run(IRuntime runtime, ISplashScreen splash, String[] args);
}
