package gov.va.med.hds.cd.runtime;

import java.util.EventListener;

/**
 * The listener interface for receiving plugin events. The class that is interested
 * in processing an plugin activation events implements this interface, and the object
 * created with that class is registered with the runtime.
 * 
 * @see gov.va.med.hds.cd.runtime.IRuntimeContext
 */
public interface IPluginActivationListener extends EventListener {
	/**
	 * Sent after a plugin has been activated by the runtime.
	 * 
	 * @param e a <code>PluginEvent</code> encapsulating the event information
	 */
	void pluginActivated(PluginEvent e);
	/**
	 * Sent after a plugin has been deactivated by the runtime.
	 * 
	 * @param e a <code>PluginEvent</code> encapsulating the event information
	 */
	void pluginDeactivated(PluginEvent e);
}
