package gov.va.med.hds.cd.runtime;

/**
 * An infrequently used interface to the runtime plugin used to shut it down.
 * 
 * This interface is not intended to be implemented by clients.
 */
public interface IRuntime {
	/**
	 * Method for shutting down the platform.  All active plug-ins 
	 * are notified of the impending shutdown. 
	 * 
	 * The exact order of notification is unspecified; however, each plug-in
	 * is assured that it will be told to shut down before any of its prerequisites.
	 * 
	 * Plug-ins are expected to free any shared resources they manage.  Plug-ins 
	 * should not store state at this time; a separate lifecycle event preceding the
	 * shutdown notice tells plug-ins the right time to be saving their state.
	 * 
	 * On exit, the platform will no longer be initialized and any objects derived from
	 * or based on the running platform are invalidated.
	 */
	void shutdown();
}
