package gov.va.med.hds.cd.runtime;

/**
 * Thrown to indicate that an operation could not complete because of a
 * missing required value or the input did not conform to the appropriate XML
 * schema for the plugin extension specification.
 */
public class InvalidExtensionException extends Exception {
	/**
	 * Constructs an <code>InvalidExtensionException</code> with no
	 * detail message.
	 */
	public InvalidExtensionException() {
		super();
	}
	/**
	 * Constructs an <code>InvalidExtensionException</code> with a
	 * specified detail message.
	 * @param message the detail message
	 * @see java.lang.Throwable#Throwable(String)
	 */
	public InvalidExtensionException(String message) {
		super(message);
	}
	/**
	 * Constructs an <code>InvalidExtensionException</code> with a
	 * specified detail message and cause.
	 * @param message the detail message
	 * @param cause the cause
	 * @see java.lang.Throwable#Throwable(String, Throwable)
	 */
	public InvalidExtensionException(String message, Throwable cause) {
		super(message, cause);
	}
	/**
	 * Constructs an <code>InvalidExtensionException</code> with a
	 * specified cause.
	 * @param cause the cause
	 * @see java.lang.Throwable#Throwable(Throwable)
	 */
	public InvalidExtensionException(Throwable cause) {
		super(cause);
	}
}
