package gov.va.med.hds.cd.runtime;

/**
 * Thrown to indicate that an operation could not complete because of a
 * missing required value or the input did not conform to the appropriate XML
 * schema for the plugin extension point specification.
 */
public class InvalidExtensionPointException extends Exception {
	/**
	 * Constructs an <code>InvalidExtensionPointException</code> with no
	 * detail message.
	 */
	public InvalidExtensionPointException() {
		super();
	}
	/**
	 * Constructs an <code>InvalidExtensionPointException</code> with a
	 * specified detail message.
	 * @param message the detail message
	 * @see java.lang.Throwable#Throwable(String)
	 */
	public InvalidExtensionPointException(String message) {
		super(message);
	}
	/**
	 * Constructs an <code>InvalidExtensionPointException</code> with a specified
	 * detail message and cause.
	 * @param message the detail message
	 * @param cause the cause
	 * @see java.lang.Throwable#Throwable(String, Throwable)
	 */
	public InvalidExtensionPointException(String message, Throwable cause) {
		super(message, cause);
	}
	/**
	 * Constructs an <code>InvalidExtensionPointException</code> with a
	 * specified cause.
	 * @param cause the cause
	 * @see java.lang.Throwable#Throwable(Throwable)
	 */
	public InvalidExtensionPointException(Throwable cause) {
		super(cause);
	}
}
