package gov.va.med.hds.cd.runtime;

/**
 * An <code>InvalidMainPluginException</code> is thrown to indicate that the
 * identifier of the plugin that the runtime is expecting to pass execution
 * control to refers to a plugin that has not been registered or does not
 * implement <code>IMainPlugin</code>.
 */
public class InvalidMainPluginException extends Exception {
	/**
	 * Constructs an <code>InvalidMainPluginException</code> with the specified
	 * plugin identifier.
	 * @param mainPluginId the unique identifier of the expected main plugin
	 */
	public InvalidMainPluginException(String mainPluginId) {
		super(mainPluginId, null);
	}
	/**
	 * Constructs an <code>InvalidMainPluginException</code> with the specified
	 * plugin identifier and cause.
	 * @param mainPluginId the unique identifier of the expected main plugin
	 * @param cause the cause
	 */
	public InvalidMainPluginException(String mainPluginId, Throwable cause) {
		super("'" + mainPluginId + "' is an invalid main plugin", cause);
	}
}
