package gov.va.med.hds.cd.runtime;

/**
 * A <code>PluginShutdownException</code> is thrown to indicate that the runtime
 * was unable to shutdown a plugin.
 */
public class PluginShutdownException extends Exception {
	
	IPluginDescriptor plugin;
	
	/**
	 * Constructs a new <code>PluginShutdownException</code> with the specified plugin and cause.
	 * @param pluginId the unique identifier of the plugin that did not
	 * shutdown
	 * @param cause the cause 
	 */
	public PluginShutdownException(IPluginDescriptor plugin, Throwable cause) {
		super("unable to shutdown plugin '" + plugin.getUniqueIdentifier() + " v" + plugin.getVersion() +"'", cause);
		this.plugin = plugin;
	}
}
