package gov.va.med.hds.cd.runtime.logging;

/**
 * LogRecord objects are used to pass logging requests between the logging 
 * framework and individual log IHandlers.
 * 
 * @see gov.va.med.hds.cd.runtime.logging.ILogger
 * @see gov.va.med.hds.cd.runtime.logging.IHandler
 */
public interface ILogRecord {
	/**
	 * Get the logging message level, for example <code>Level.FATAL</code>.
	 *
	 * @return the logging message level
	 */
	Level getLevel();
	
	/**
	 * Get the log message, after formatting.
	 * 
	 * @return the log message after formatting
	 */
	String getMessage();
}
