package gov.va.med.hds.cd.security.test;
import java.security.Principal;
import java.util.Iterator;
import java.util.Map;
import java.util.Set;

import javax.security.auth.Subject;
import javax.security.auth.callback.CallbackHandler;
import javax.security.auth.login.LoginException;
import javax.security.auth.spi.LoginModule;

import gov.va.med.hds.cd.security.IUserInfo;

/**
 * Tests login mechanism
 */
public class MockLoginModule implements LoginModule {
	public MockLoginModule() {
		super();
	}
	public void initialize(Subject subject, CallbackHandler callbackHandler, Map sharedState, Map options) {
		this.subject = subject;
	}
	public boolean login() throws LoginException {
		return true;
	}
	public boolean commit() throws LoginException {
		subject.getPrincipals().add(new MockPrincipal("MockPrincipal","MockFirst","MockLast","MockMiddle","1234","MockM.D."));
		return true;
	}
	public boolean abort() throws LoginException {
		return true;
	}
	public boolean logout() throws LoginException {
		Set allPrincipals = subject.getPrincipals();
		Set principalsIAdded = subject.getPrincipals(MockPrincipal.class);
		Iterator iterator = principalsIAdded.iterator();
		while(iterator.hasNext())
			allPrincipals.remove(iterator.next());
			
		return true;
	}
	private Subject subject;
	class MockPrincipal implements Principal, IUserInfo{
		MockPrincipal(String name,
					String firstName,
					String lastName,
					String middle,
					String last4,
					String title){
			this.name = name;
			this.first = firstName;
			this.last = lastName;
			this.middle = middle;
			this.last4 = last4;
			this.title = title;
		}
		public String getName() {
			return name;
		}

		public String getFirstName() {
			return first;
		}

		public String getLastName() {
			return last;
		}

		public String getMiddleName() {
			return middle;
		}

		public String getTitle() {
			return title;
		}
		public String getPrefix() {
			return null;
		}
		public String getSuffix() {
			return null;
		}
		public String getLanguage() {
			return null;
		}
		public String getServiceSection() {
			return null;
		}
		public String getStandardConcatenated() {
			return null;
		}
		private String name;
		private String first,last,middle,last4,title;
	}
}
