package gov.va.med.hds.cd.security.test;

import gov.va.med.hds.cd.runtime.IRuntimeContext;
import gov.va.med.hds.cd.security.IPlugin;
import gov.va.med.hds.cd.security.PluginException;

import javax.security.auth.login.Configuration;
import javax.security.auth.login.LoginContext;
import javax.security.auth.login.LoginException;

/**
 * Mock security plugin
 */
class MockPlugin implements IPlugin{
	public MockPlugin(IRuntimeContext runtime) {}

	public LoginContext createLoginContext() throws PluginException {
		ClassLoader old = null;
		try {
			old = Thread.currentThread().getContextClassLoader();
			Thread.currentThread().setContextClassLoader(this.getClass().getClassLoader());
			return new LoginContext("MockLoginModule");
		} catch (LoginException e) {
			throw new PluginException(e);
		} finally{
			if (old != null)
				Thread.currentThread().setContextClassLoader(old);
		}
	}

	public Configuration getConfiguration() {
		return new MockConfiguration();
	}

	
}
