package gov.va.med.hds.cd.security;

import javax.security.auth.login.Configuration;
import javax.security.auth.login.LoginContext;

/**
 * Security plugin abstraction
 */
public interface IPlugin {
	/**
	 * Gets the plugin configuration
	 * @return Configuration
	 * @throws PluginException
	 */
	public Configuration getConfiguration() throws PluginException;
	/**
	 * Creates a login context. See the JDK JAAS documentation for usage of the LoginContext.
	 * @return LoginContext
	 * @throws PluginException
	 */
	public LoginContext createLoginContext() throws PluginException;

}
