package gov.va.med.hds.cd.security;

import gov.va.med.hds.cd.runtime.IRuntimeContext;

/**
 * Abstraction of a security plugin creating factory
 */
public interface IPluginFactory {
	/**
	 * Creates a plugin
	 * 
	 * @param runtime referenct to the runtime context
	 * @return IPlugin resulting plugin
	 * @throws PluginCreationFailed
	 */
	public IPlugin create(IRuntimeContext runtime) throws PluginCreationFailedException;
}
