package gov.va.med.hds.cd.security;
/**
 * Contains user informatin
 */
public interface IUserInfo {
	/**
	 * Gets the authenticated user's first name
	 * @return String
	 */
	public String getFirstName();
	/**
	 * Gets the authenticated user's last name
	 * @return String
	 */
	public String getLastName();
	/**
	 * Gets the authenticated user's middle initial
	 * @return String
	 */
	public String getMiddleName();
	/**
	 * Gets the name prefix
	 * @return String
	 */
	public String getPrefix();
	
	/**
	 * Gets the name suffix
	 * @return String
	 */
	public String getSuffix();
	
	/**
	 * Gets the authenticated user's title
	 * @return String
	 */
	public String getTitle();
	
	/**
	 * Gets the language
	 * @return String
	 */
	public String getLanguage();
	
	/**
	 * Gets the service section
	 * @return String
	 */
	public String getServiceSection();
}
