/*
 * Initially Created on Mar 13, 2003 by VHAISLMONSOS
 *
 */
package gov.va.med.hds.cd.spectrum.itest;

import java.awt.Component;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.JFrame;

import junit.extensions.jfcunit.JFCTestHelper;
import junit.extensions.jfcunit.eventdata.MouseEventData;
import junit.extensions.jfcunit.finder.Finder;

import gov.va.med.hds.cd.spectrum.bucket.BasicSlushBucket;
import gov.va.med.hds.cd.spectrum.bucket.ISlushBucket;

/**
 * Tests BasicSlushBucket firing of button events.
 */
public class BasicSlushBucketTest extends AbstractJFCTestCase {
	private ISlushBucket bucket;
	private Thread testThread;
	private ActionEvent event;
	private static final int ONE_CLICK = 1;
	private JButton button;

	/**
	 * Constructor for BasicSlushBucketTest.
	 * @param name
	 */
	public BasicSlushBucketTest(String name) {
		super(name);
	}

	public static void main(String[] args) {
		junit.textui.TestRunner.run(BasicSlushBucketTest.class);
	}
	
	private class ButtonFinder extends Finder {
		private String name;
		
		public void setName(String name) {
			this.name = name;
		}
		
		public String getName() {
			return name;
		}
		
		public boolean testComponent(Component comp) {
			if (comp instanceof JButton) {
				if (comp.getAccessibleContext().getAccessibleName().equals(name)) return true;
			}
			return false;
		}
	}

	public void testFireAction() throws Exception {
		ButtonFinder finder = new ButtonFinder();
		BasicSlushBucket b = (BasicSlushBucket)JFCTestHelper.findComponent(BasicSlushBucket.class, frame, 0);
		assertNotNull("BasicSlushBucket test error: component not found.",b);
		
		finder.setName("Select");
		doTest(finder, b, ISlushBucket.SELECT_ACTION);
		
		finder.setName("Select all");
		doTest(finder, b, ISlushBucket.SELECT_ALL_ACTION);
		
		finder.setName("Remove");
		doTest(finder, b, ISlushBucket.REMOVE_ACTION);
		
		finder.setName("Remove all");
		doTest(finder, b, ISlushBucket.REMOVE_ALL_ACTION);
		
	}

	private void doTest(ButtonFinder finder, BasicSlushBucket b, int eventID) throws Exception {
		button = (JButton)JFCTestHelper.findComponent(finder, b, 0);
		assertNotNull("BasicSlushBucket mouse click test error: button not found:"+finder.getName(),button);
		event = null;
		helper.enterClickAndLeave(new MouseEventData(this, button, ONE_CLICK));
		assertNotNull("BasicSlushBucket mouse click test error: event null on button "+finder.getName(),event);
		assertEquals("BasicSlushBucket mouse click test error: wrong event returned on button "+finder.getName()+":",eventID,event.getID());
	}
	
	protected void setUp() throws Exception {
		testThread = Thread.currentThread();
		super.setUp();
		bucket = new BasicSlushBucket();
		frame = new JFrame("BasicSlushBucket Test");
		frame.getContentPane().add((JComponent)bucket);
		bucket.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				event = e;
			}
		});
		frame.pack();
		frame.show();
		flushAWT();
	}

}
