/*
 * Initially Created on Mar 24, 2003 by vhaislmonsos
 *
 */
package gov.va.med.hds.cd.spectrum.itest;

import java.awt.Dimension;
import java.awt.Point;

import javax.swing.DefaultListModel;
import javax.swing.DefaultListSelectionModel;
import javax.swing.JComponent;
import javax.swing.JFrame;
import javax.swing.JList;
import javax.swing.ListSelectionModel;
import javax.swing.SwingConstants;

import junit.extensions.jfcunit.eventdata.MouseEventData;

import gov.va.med.hds.cd.spectrum.longlist.ILongListComponentListener;
import gov.va.med.hds.cd.spectrum.longlist.ILongListEvent;
import gov.va.med.hds.cd.spectrum.longlist.ISearchList;
import gov.va.med.hds.cd.spectrum.longlist.SearchList;

/**
 * Tests for the SearchList component.
 */
public class SearchListTest extends AbstractJFCTestCase {
	private ISearchList searchList;
	private ILongListEvent event;
	private ILongListComponentListener listener = new ILongListComponentListener() {
		public void actionPerformed(ILongListEvent e) {
			event = e;
		}
	};
	private Thread testThread;

	/**
	 * Constructor for SearchListTest.
	 * @param name
	 */
	public SearchListTest(String name) {
		super(name);
	}

	public static void main(String[] args) {
		junit.textui.TestRunner.run(SearchListTest.class);
	}

	/*
	 * @see JFCTestCase#setUp()
	 */
	protected void setUp() throws Exception {
		super.setUp();
		testThread = Thread.currentThread();
		frame = new JFrame("SearchListTest");
		searchList = new SearchList();
		frame.getContentPane().add((JComponent)searchList);
		((JComponent)searchList).setPreferredSize(new Dimension(200,200));
		DefaultListModel model = new DefaultListModel();
		model.addElement(new String("Line 1"));
		model.addElement(new String("Entry #2"));
		model.addElement(new String("Object -3"));
		searchList.setModel(model);
		frame.pack();
		frame.show();
		flushAWT();
	}

	public void testGetVisibleRowSize() {
		assertEquals("SearchList.getVisibleRowSize failed:",11,searchList.getVisibleRowSize());
	}

	public void testSetListSelectionModel() {
		((JList)searchList).setSelectionModel(new DefaultListSelectionModel());
		((JList)searchList).setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);
		assertEquals("SearchList selection model changes failed:",ListSelectionModel.SINGLE_SELECTION,((JList)searchList).getSelectionMode());
	}

	public void testGetSelectedRow() {
		assertEquals("SearchList.getSelectedRow failed:",-1,searchList.getSelectedRow());
	}

	public void testSetSelectedRow() {
		searchList.setSelectedRow(0);
		assertEquals("SearchList.setSelectedRow failed:",0,searchList.getSelectedRow());
		searchList.setSelectedRow(2);
		assertEquals("SearchList.setSelectedRow failed:",2,searchList.getSelectedRow());
	}
	
	public void testMouseSelection() throws Exception {
		searchList.addLongListListener(listener);
		MouseEventData data = new MouseEventData(this, (JList)searchList, 1);
		data.setPosition(SwingConstants.NORTH_WEST);
		data.setReferencePoint(new Point(5,5));
		event = null;
		helper.enterClickAndLeave(data);
		synchronized (testThread) {
			testThread.wait(200);
		}
		assertNotNull("SearchList mouse selection event failed: null event.",event);
	}

}
