package gov.va.med.hds.cd.spectrum.test;

import junit.framework.TestCase;

import gov.va.med.hds.cd.spectrum.longlist.BufferItem;
import gov.va.med.hds.cd.spectrum.longlist.IBufferItem;

/**
 * @author vhaislmonsos
 *
 * Jan 16, 2003 2:56:24 PM
 */
public class BufferItemTest extends TestCase {

	/**
	 * Constructor for BufferItemTest.
	 * @param arg0
	 */
	public BufferItemTest(String arg0) {
		super(arg0);
	}

	public static void main(String[] args) {
		junit.textui.TestRunner.run(BufferItemTest.class);
	}
	
	public void testCompare1() {
		IBufferItem item1 = new BufferItem("AAAAAAA","0");
		IBufferItem item2 = new BufferItem("ZZZZZZZ","0");
		assertEquals("BufferItem.compareTo failed:",-25,item1.compareTo(item2));
		assertEquals("BufferItem.compareTo failed:",25,item2.compareTo(item1));
		assertEquals("BufferItem.compareTo failed:",0,item1.compareTo(item1));
	}
	
	public void testCompare2() {
		IBufferItem item1 = new BufferItem("AAAAAAA","0");
		IBufferItem item2 = new BufferItem("AAAAAAAaaa","1");
		assertTrue("BufferItem.compareTo failed: items in wrong order.",(item1.compareTo(item2)<0));
		item1 = new BufferItem("OERR1","0");
		item2 = new BufferItem("OERR111","1");
		assertTrue("BufferItem.compareTo failed: items in wrong order.",(item1.compareTo(item2)<0));
	}
	
	public void testEquals() {
		IBufferItem item1 = new BufferItem("AAAAAA","10");
		IBufferItem item2 = new BufferItem("ZZZZZZ","20");
		assertFalse("BufferItem.equals failed:",item1.equals(item2));
		assertFalse("BufferItem.equals failed:",item2.equals(item1));
		assertTrue("BufferItem.equals failed:",item1.equals(item1));
		item1.setId("20");
		assertFalse("BufferItem.equals failed:",item1.equals(item2));
		assertFalse("BufferItem.equals failed:",item2.equals(item1));
		assertTrue("BufferItem.equals failed:",item1.equals(item1));
		item1.setValue("ZZZZZZ");
		assertTrue("BufferItem.equals failed:",item1.equals(item2));
		assertTrue("BufferItem.equals failed:",item2.equals(item1));
		assertTrue("BufferItem.equals failed:",item1.equals(item1));
	}

}
