/*
 * Created on Feb 28, 2003 3:54:44 PM
 */
package gov.va.med.hds.cd.spectrum.test;

import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JOptionPane;

import gov.va.med.hds.cd.spectrum.longlist.BufferModel;
import gov.va.med.hds.cd.spectrum.longlist.BufferedListLookupBox;

/**
 *
 * @author Joel Russell
 *
 * Department of Veterans Affairs
 * OI Field Office - Salt Lake City
 * Health Data Systems
 * 
 **/
public class BufferedListOptionPaneTester {
	
	public BufferedListOptionPaneTester() {
	}
	
	public static final void main(String args[]) {
		try {
			final JFrame frame = new JFrame("Buffered List Option Pane Tester");
			DummyDataProvider dataProvider = new DummyDataProvider();
			BufferModel bufferModel = new BufferModel(300);
			dataProvider.setBufferModel(bufferModel);
			final BufferedListLookupBox lookupBox = new BufferedListLookupBox(bufferModel);
			lookupBox.setPreferredSize(new Dimension(300, 300));
			JButton button = new JButton("Do it...");
			button.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					int result =
						JOptionPane.showOptionDialog(
							frame,
							lookupBox,
							"Choose an Item",
							JOptionPane.OK_CANCEL_OPTION,
							JOptionPane.PLAIN_MESSAGE,
							null,
							null,
							"Item 12345");
				}
			});

			frame.getContentPane().add(button);
			frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

			frame.pack();
			frame.show();

		} catch (Exception ioe) {
			ioe.printStackTrace();
		}
	}


}
