package gov.va.med.hds.cd.spectrum.test;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BorderFactory;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.UIManager;
import javax.swing.UnsupportedLookAndFeelException;

import gov.va.med.hds.cd.mum.boot.plaf.desktop.DesktopLookAndFeel;
import gov.va.med.hds.cd.spectrum.date.DateComboBox;

public class DateComboBoxTester {
	public static void main(String[] args) {
		try {
			UIManager.setLookAndFeel(new DesktopLookAndFeel(DateComboBoxTester.class.getClassLoader()));
		} catch (UnsupportedLookAndFeelException e) {
			e.printStackTrace();
		}

		JFrame f = new JFrame("DateComboBox Tester");
		f.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

		final JComboBox comboBox = new JComboBox(new String[] { "Yoda", "Obi-wan", "Qui-gonn" });
		final DateComboBox dateBox = new DateComboBox();

		final JCheckBox comboEnabled = new JCheckBox("enabled", comboBox.isEnabled());
		final JCheckBox comboEditable = new JCheckBox("editable", comboBox.isEditable());
		final JCheckBox dateComboEnabled = new JCheckBox("enabled", dateBox.isEnabled());
		final JCheckBox dateComboEditable = new JCheckBox("editable", dateBox.isEditable());

		JPanel comboPanel = new JPanel();

		comboPanel.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));
		comboPanel.setLayout(new GridLayout(3, 2));
		comboPanel.add(comboEnabled);
		comboPanel.add(dateComboEnabled);
		comboPanel.add(comboEditable);
		comboPanel.add(dateComboEditable);
		comboPanel.add(comboBox);
		comboPanel.add(dateBox);

		JPanel fieldPanel = new JPanel();
		JLabel aLabel = new JLabel("Some text");
		aLabel.setBackground(Color.white);
		aLabel.setOpaque(true);
		fieldPanel.add(aLabel);
//		fieldPanel.add(new JFormattedTextField(new Date()));
//		fieldPanel.add(new JComboBox(new Object[] {"Yoda","Luke","Obi-wan","Vader"}));

		f.getContentPane().setLayout(new BorderLayout());
		f.getContentPane().add(fieldPanel, BorderLayout.NORTH);
		f.getContentPane().add(comboPanel, BorderLayout.CENTER);

		comboEnabled.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				comboBox.setEnabled(comboEnabled.isSelected());
			}
		});

		dateComboEnabled.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				dateBox.setEnabled(dateComboEnabled.isSelected());
			}
		});

		comboEditable.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				comboBox.setEditable(comboEditable.isSelected());
			}
		});

		dateComboEditable.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				dateBox.setEditable(dateComboEditable.isSelected());
			}
		});

		f.pack();

		Dimension screenSize = f.getToolkit().getScreenSize();
		int x = (screenSize.width - f.getWidth()) / 2;
		int y = (screenSize.height - f.getHeight()) / 2;
		f.setLocation(x, y);

		f.setVisible(true);
	}
}
