package gov.va.med.hds.cd.spectrum;
import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.event.EventListenerList;

public class SlushBucket2 extends JPanel {
	private JPanel buttonPanel = new JPanel();
	private GridBagLayout gridBagLayout = new GridBagLayout();
	private JButton selectAllButton = new JButton();
	private JButton removeAllButton = new JButton();
	private JScrollPane rightScrollPane = new JScrollPane();
	private JScrollPane leftScrollPane = new JScrollPane();
	private JButton selectButton = new JButton();
	private JButton removeButton = new JButton();
	private EventListenerList actionEventListeners = new EventListenerList();

	public SlushBucket2() {
		jbInit();
	}

	private void jbInit() {
		this.setLayout(new BorderLayout());
		this.setBorder(BorderFactory.createEmptyBorder(8, 8, 8, 8));
		buttonPanel.setLayout(gridBagLayout);
		buttonPanel.setMinimumSize(new Dimension(120, 300));
		buttonPanel.setPreferredSize(new Dimension(100, 300));
		buttonPanel.setMaximumSize(new Dimension(200, 2147483647));

		selectAllButton.setText("Select All >>");
		selectAllButton.setMaximumSize(new Dimension(130, 27));
		selectAllButton.setMinimumSize(new Dimension(130, 27));
		selectAllButton.setPreferredSize(new Dimension(130, 27));
		selectAllButton.setMnemonic('A');
		selectAllButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				fireSelectAll();
			}
		});

		removeAllButton.setText("<< Remove All");
		removeAllButton.setMaximumSize(new Dimension(130, 27));
		removeAllButton.setMinimumSize(new Dimension(130, 27));
		removeAllButton.setPreferredSize(new Dimension(130, 27));
		removeAllButton.setMnemonic('e');
		removeAllButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				fireRemoveAll();
			}
		});
		
		rightScrollPane.setPreferredSize(new Dimension(24, 24));
		leftScrollPane.setPreferredSize(new Dimension(24, 24));
		
		selectButton.setText("Select >");
		selectButton.setMnemonic('S');
		selectButton.setMaximumSize(new Dimension(130, 27));
		selectButton.setMinimumSize(new Dimension(130, 27));
		selectButton.setPreferredSize(new Dimension(130, 27));
		selectButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				fireSelect();
			}
		});
		removeButton.setText("< Remove");
		removeButton.setMnemonic('R');
		removeButton.setMaximumSize(new Dimension(130, 27));
		removeButton.setMinimumSize(new Dimension(130, 27));
		removeButton.setPreferredSize(new Dimension(130, 27));
		removeButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				fireRemove();
			}
		});

		buttonPanel.add(
			selectButton,
			new GridBagConstraints(
				1,
				0,
				1,
				1,
				0.0,
				0.0,
				GridBagConstraints.CENTER,
				GridBagConstraints.NONE,
				new Insets(0, 0, 10, 0),
				0,
				0));
		buttonPanel.add(
			selectAllButton,
			new GridBagConstraints(
				1,
				1,
				1,
				1,
				0.0,
				0.0,
				GridBagConstraints.CENTER,
				GridBagConstraints.NONE,
				new Insets(0, 0, 10, 0),
				0,
				0));
		buttonPanel.add(
			removeAllButton,
			new GridBagConstraints(
				1,
				2,
				1,
				1,
				0.0,
				0.0,
				GridBagConstraints.CENTER,
				GridBagConstraints.NONE,
				new Insets(0, 0, 10, 0),
				0,
				0));
		buttonPanel.add(
			removeButton,
			new GridBagConstraints(
				1,
				3,
				1,
				1,
				0.0,
				0.0,
				GridBagConstraints.CENTER,
				GridBagConstraints.NONE,
				new Insets(0, 0, 0, 0),
				0,
				0));
		this.add(buttonPanel, BorderLayout.CENTER);
		this.add(rightScrollPane, BorderLayout.EAST);
		this.add(leftScrollPane, BorderLayout.WEST);
	}

	public static final void main(String args[]) {
		try {
			JFrame frame = new JFrame("SlushBucket2");
			SlushBucket2 bucket = new SlushBucket2();
//			bucket.setRemoveAllButtonState(false);
			bucket.setSelectAllButtonState(false);
			frame.getContentPane().add(bucket, BorderLayout.CENTER);
			frame.pack();
			frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
			frame.show();

		} catch (Exception ioe) {
			ioe.printStackTrace();
		}
	}
	
	public void fireSelect() {
	}

	public void fireSelectAll() {
	}

	public void fireRemove() {
	}

	public void fireRemoveAll() {
	}

	public void setAllButtonsVisible(boolean visible) {
		removeAllButton.setVisible(visible);
		selectAllButton.setVisible(visible);
	}
	
	public void setRemoveAllButtonState(boolean active) {
		removeAllButton.setEnabled(active);
	}

	public void setSelectAllButtonState(boolean active) {
		selectAllButton.setEnabled(active);
	}

}