package gov.va.med.hds.cd.spectrum;

import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Vector;

import javax.swing.UIDefaults;
import javax.swing.UIManager;

public class UIList {
    public static void main(String[] args) {
    	try {
			UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
		} catch (Exception e) {
			throw new RuntimeException(e);
		}
    	
        // Groups of setting objects 
        Vector itemGroups = new Vector();

        // Map group name -> Vector number above 
        Hashtable itemList = new Hashtable();

        UIDefaults uiDefaults = UIManager.getDefaults();

        for (Enumeration enum = uiDefaults.keys(); enum.hasMoreElements();) {
            Object setting = enum.nextElement();
            String settingName = setting.toString();
            int dotIndex = settingName.indexOf(".");

            // if . found then use only first name for group 
            if (dotIndex != -1) {
                settingName = settingName.substring(0, settingName.indexOf("."));
            }

            // If itemList has a group named setting name then just 
            // add the setting to the group 
            if (itemList.containsKey(settingName)) {
                Integer groupNum = (Integer) itemList.get(settingName);
                Vector group = (Vector) itemGroups.elementAt(groupNum.intValue());
                group.add(setting);
            } else {
                // Else create a new group and add the setting 
                itemList.put(settingName, new Integer(itemGroups.size()));

                Vector group = new Vector();
                group.add(setting);
                itemGroups.add(group);
            }
        }

        // For each group 
        for (int counter = 0; counter < itemGroups.size(); counter++) {
            Vector items = (Vector) itemGroups.elementAt(counter);
            System.out.println("");

            // Print out each setting and value 
            for (int counter2 = 0; counter2 < items.size(); counter2++) {
                Object setting = items.elementAt(counter2);
                System.out.println(setting + "\t=\t" + uiDefaults.get(setting));
            }
        }

        System.out.println("\nDone.");
        System.exit(0);
    }
}
