package gov.va.med.hds.cd.spectrum.bucket;

import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

import javax.swing.DefaultComboBoxModel;
import javax.swing.DefaultListModel;
import javax.swing.JList;
import javax.swing.JScrollPane;
import javax.swing.ListCellRenderer;
import javax.swing.ListModel;
import javax.swing.MutableComboBoxModel;
import javax.swing.event.ListDataEvent;
import javax.swing.event.ListDataListener;

/**
 * An AbstractSlushBucket with a JList on the right hand side.
 */
public abstract class AbstractListBucket extends AbstractSlushBucket {
	private JList outBucketList = new JList();
	private JScrollPane outBucket;
	private MutableComboBoxModel outBucketModel;
	private static final int OUTBUCKET_SELECT_CLICK_COUNT = 2;

	public AbstractListBucket() {
		super();
		outBucketList.setPrototypeCellValue("01234567890123456789012345");
		outBucket = new JScrollPane(outBucketList);
		outBucket.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
		outBucket.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
		outBucketList.setModel(new DefaultComboBoxModel());
		outBucketList.addMouseListener(new MouseListener() {
			public void mouseClicked(MouseEvent e) {
				if (e.getClickCount() == OUTBUCKET_SELECT_CLICK_COUNT) {
					fireRemove();
				}
			}
			public void mousePressed(MouseEvent e) {
			}
			public void mouseReleased(MouseEvent e) {
			}
			public void mouseEntered(MouseEvent e) {
			}
			public void mouseExited(MouseEvent e) {
			}
		});
		setOutBucket(outBucket);
	}
	public void fireRemove() {
		Object[] items = outBucketList.getSelectedValues();
		for (int i = 0; i < items.length; i++) {
			outBucketModel.removeElement(items[i]);
		}
	}

	public void fireRemoveAll() {
		while (outBucketModel.getSize() > 0) {
			outBucketModel.removeElementAt(0);
		}
	}

	private void updateRemoveButtonsState(ListDataEvent e) {
		ListModel l = (ListModel)e.getSource();
		if(l.getSize()==0)
			setRemoveButtonsState(false);
		else
			setRemoveButtonsState(true);
	}
	public void setOutBucketModel(Object listModel) {
		if (listModel != null) {
			outBucketModel = (MutableComboBoxModel) listModel;
			outBucketList.setModel(outBucketModel);
			outBucketModel.addListDataListener(new ListDataListener(){
				public void intervalAdded(ListDataEvent e) {
					updateRemoveButtonsState(e);
				}
				public void intervalRemoved(ListDataEvent e) {
					updateRemoveButtonsState(e);
				}
				public void contentsChanged(ListDataEvent e) {}
			});
		} else {
			ListModel lm = new DefaultListModel();
			outBucketList.setModel(lm);
			lm.addListDataListener(new ListDataListener(){
				public void intervalAdded(ListDataEvent e) {
					updateRemoveButtonsState(e);
				}
				public void intervalRemoved(ListDataEvent e) {
					updateRemoveButtonsState(e);
				}
				public void contentsChanged(ListDataEvent e) {}
			});
		}		
	}

	public void setOutBucketSelectionMode(int selectionMode) {
		outBucketList.setSelectionMode(selectionMode);
	}

	public Object getOutBucketModel() {
		return outBucketModel;
	}

	public Object[] getOutBucketSelectedValues() {
		return outBucketList.getSelectedValues();
	}

	public void setOutBucketCellRenderer(ListCellRenderer renderer) {
		outBucketList.setCellRenderer(renderer);
	}

}
