package gov.va.med.hds.cd.spectrum.bucket;

import javax.swing.MutableComboBoxModel;

import gov.va.med.hds.cd.spectrum.longlist.IBufferModel;
import gov.va.med.hds.cd.spectrum.longlist.ILongListComponentListener;
import gov.va.med.hds.cd.spectrum.longlist.ILongListEvent;
import gov.va.med.hds.cd.spectrum.longlist.LongListLookup;

public class BufferedSlushBucket extends AbstractListBucket {
	private LongListLookup inBucket = new LongListLookup();
//	private BufferedListLookupBox inBucket = new BufferedListLookupBox();

	public BufferedSlushBucket() {
		super();
		setInBucket(inBucket);
		inBucket.addLongListListener(new ILongListComponentListener() {
			public void actionPerformed(ILongListEvent e) {
				if (e.getID()==ILongListEvent.SELECT) {
					fireSelect();
				}
			}
		});
		super.setSelectAllButtonState(false);
	}
	
	private Object convert(Object item) {
		Object newItem = item;
		if (getConverter() != null) {
			newItem = getConverter().convert(item);
		}
		return newItem;
	}
	
	public void fireSelect() {
		fireAction(SELECT_ACTION);
		MutableComboBoxModel outModel = (MutableComboBoxModel)super.getOutBucketModel();
		Object item = null;
		if ((item=inBucket.getSelectedValue())!=null) {
			item = convert(item);
			if (!contains(outModel,item)) {
				outModel.addElement(item);
			}
		}
	}

	private boolean contains(MutableComboBoxModel outModel,Object item) {
		boolean result = false;
		for (int i=0;i<outModel.getSize();i++) {
			if ((outModel.getElementAt(i)).equals(item)) {
				result = true;
				break;
			}
		}
		return result;
	}


	public void fireSelectAll() {
		fireAction(SELECT_ALL_ACTION);
	}

	/**
	 * Method getInBucketModel.
	 * @return IBufferModel
	 */
	public Object getInBucketModel() {
		return inBucket.getModel();
	}
	
	/**
	 * @see gov.va.med.hds.cd.spectrum.AbstractSlushBucket#getInBucketSelectedValues()
	 */
	public Object[] getInBucketSelectedValues() {
		if (inBucket.getSelectedValue()!=null) {
			Object[] result = new Object[1];
			result[0] = inBucket.getSelectedValue();
			return result;
		}
		else {
			return new Object[0];
		}
	}

	/**
	 * @see gov.va.med.hds.cd.spectrum.AbstractSlushBucket#setInBucketModel(Object)
	 */
	public void setInBucketModel(Object model) {
		try {
			inBucket.setModel((IBufferModel)model);
		}
		catch (Exception e) {
			throw new RuntimeException(e);
		}
	}

	/**
	 * @see gov.va.med.hds.cd.spectrum.AbstractSlushBucket#setInBucketSelectionMode(int)
	 */
	public void setInBucketSelectionMode(int selectionMode) {
	}

}