/*
 * Created on Jun 5, 2003 by vhaislmonsos
 */
package gov.va.med.hds.cd.spectrum.checklist;

import javax.swing.event.EventListenerList;

/**
 * Implements the ICheckableModel to manage the check changed event for a collection
 * of ICheckable items.
 */
public class CheckableModel implements ICheckableModel {
	private EventListenerList listeners = new EventListenerList();

	public CheckableModel() {
		super();
	}

	public void addCheckableListener(ICheckableListener listener) {
		listeners.add(ICheckableListener.class, listener);
	}

	public void removeCheckableListener(ICheckableListener listener) {
		listeners.remove(ICheckableListener.class, listener);
	}

	public void fireCheckChangeEvent(Object source, ICheckable[] items) {
		if (source==null) {
			source = this;
		}
		if (listeners.getListenerCount()>0) {
			ICheckEvent event = new CheckEvent(source, items);
			ICheckableListener[] list = (ICheckableListener[])listeners.getListeners(ICheckableListener.class);
			for (int i = 0; i < list.length; i++) {
				list[i].checkChanged(event);
			}
		}
	}

}
