/*
 * Created on Jun 4, 2003 by vhaislmonsos
 */
package gov.va.med.hds.cd.spectrum.checklist;

/**
 * Decorator to a list item to provide selection methods.  This interface should not
 * be inherited directly, but extended by subordinates.
 */
public interface ICheckable {

	/**
	 * Returns the checked state of the object.
	 * @return checkedState
	 */
	boolean isChecked();
	
	/**
	 * Sets the checked state.
	 * @param checkedState
	 */
	void setChecked(boolean checked);
}
