package gov.va.med.hds.cd.spectrum.date;

import java.awt.event.KeyListener;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;

public interface IDateComboPopup {
	/**
	 * Shows the popup
	 */
	public void showPopup();

	/**
	 * Hides the popup
	 */
	public void hidePopup();

	/**
	 * Returns true if the popup is visible (currently being displayed).
	 * 
	 * @return <code>true<code> if the component is visible; <code>false</code>
	 * otherwise.
	 */
	public boolean isVisible();

	/**
	 * Returns a mouse listener that will be added to the combo box or null.
	 * If this method returns null then it will not be added to the combo box.
	 *
	 * @return a <code>MouseListener</code> or null
	 */
	public MouseListener getMouseListener();

	/**
	 * Returns a mouse motion listener that will be added to the combo box or null.
	 * If this method returns null then it will not be added to the combo box.
	 *
	 * @return a <code>MouseMotionListener</code> or null
	 */
	public MouseMotionListener getMouseMotionListener();

	/**
	 * Returns a key listener that will be added to the combo box or null.
	 * If this method returns null then it will not be added to the combo box.
	 *
	 * @param a <code>KeyListener</code> or null
	 */
	public KeyListener getKeyListener();
}
