/*
 * Created on May 9, 2003
 *
 * To change this generated comment go to 
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package gov.va.med.hds.cd.spectrum.dhtml;

import java.awt.Color;
import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.FocusTraversalPolicy;
import java.awt.Graphics;
import java.awt.Rectangle;
import java.awt.Shape;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.Collections;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

import javax.accessibility.AccessibleContext;
import javax.swing.JButton;
import javax.swing.JEditorPane;
import javax.swing.LayoutFocusTraversalPolicy;
import javax.swing.SwingUtilities;
import javax.swing.event.HyperlinkEvent;
import javax.swing.plaf.basic.BasicGraphicsUtils;
import javax.swing.text.AttributeSet;
import javax.swing.text.BadLocationException;
import javax.swing.text.ComponentView;
import javax.swing.text.DefaultHighlighter;
import javax.swing.text.Document;
import javax.swing.text.Element;
import javax.swing.text.ElementIterator;
import javax.swing.text.Highlighter;
import javax.swing.text.JTextComponent;
import javax.swing.text.Position;
import javax.swing.text.StyleConstants;
import javax.swing.text.View;
import javax.swing.text.html.HTML;
import javax.swing.text.html.HTMLDocument;

import gov.va.med.hds.cd.spectrum.dhtml.scriptlet.ExpandCollapse;

/**
 * @author VHAISLTUMAD
 *
 * Strategy:
 * 
 * Create these two delegating components, and add them to the editor pane.
 *
 *
 * To change this generated comment go to 
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
public class HTMLFocusTraversalPolicy extends FocusTraversalPolicy
    implements FocusListener, MouseListener 
{

    JEditorPane editorPane;
    HyperlinkFocusDelegate delegate1, delegate2;
    FocusHighlightPainter focusPainter;
    FocusTraversalPolicyAdvisor focusAdvisor;

    public HTMLFocusTraversalPolicy(JEditorPane editorPane) {
        this.editorPane = editorPane;
        this.focusAdvisor = new FocusTraversalPolicyAdvisor();
        this.focusPainter = new FocusHighlightPainter(Color.black);
        this.delegate1 = new HyperlinkFocusDelegate(0);
        this.delegate2 = new HyperlinkFocusDelegate(1);
        editorPane.addFocusListener(this);
        editorPane.addMouseListener(this);
    }
    

    public Component getComponentAfter(Container focusCycleRoot,
                                       Component aComponent) {
            
        if (focusCycleRoot == editorPane && !editorPane.isEditable()) {
            List elements = enumerateFocusableThings();
            if (!elements.isEmpty()) {
                int pos = findThing(elements, aComponent) + 1;
                if (pos >= elements.size()) pos = 0;
                return ((FocusableThing) elements.get(pos)).getComponent();
            }
        }
        
        Container rootAncestor = editorPane.getFocusCycleRootAncestor();
        if (rootAncestor == null) return null;
        return rootAncestor.getFocusTraversalPolicy().getComponentAfter
            (rootAncestor, editorPane);
    }


    public Component getComponentBefore(Container focusCycleRoot,
                                        Component aComponent) {
            
        if (focusCycleRoot == editorPane && !editorPane.isEditable()) {
            List elements = enumerateFocusableThings();
            if (!elements.isEmpty()) {
                int pos = findThing(elements, aComponent) - 1;
                if (pos < 0) pos = elements.size() - 1;
                return ((FocusableThing) elements.get(pos)).getComponent();
            }
        }
                
        Container rootAncestor = editorPane.getFocusCycleRootAncestor();
        if (rootAncestor == null) return null;
        return rootAncestor.getFocusTraversalPolicy().getComponentBefore
            (rootAncestor, editorPane);
    }

    public Component getFirstComponent(Container focusCycleRoot) {
        if (focusCycleRoot == editorPane && !editorPane.isEditable()) {
            List elements = enumerateFocusableThings();
            if (!elements.isEmpty())
                return ((FocusableThing) elements.get(0)).getComponent();            
        }
        
        Container rootAncestor = editorPane.getFocusCycleRootAncestor();
        if (rootAncestor == null) return null;
        return rootAncestor.getFocusTraversalPolicy().getFirstComponent
            (focusCycleRoot);
    }

    public Component getLastComponent(Container focusCycleRoot) {
        if (focusCycleRoot == editorPane && !editorPane.isEditable()) {
            List elements = enumerateFocusableThings();
            if (!elements.isEmpty()) {
                int pos = elements.size() - 1;
                return ((FocusableThing) elements.get(pos)).getComponent();
            }            
        }
        
        Container rootAncestor = editorPane.getFocusCycleRootAncestor();
        if (rootAncestor == null) return null;
        return rootAncestor.getFocusTraversalPolicy().getLastComponent
            (focusCycleRoot);
    }

    public Component getDefaultComponent(Container focusCycleRoot) {
        if (focusCycleRoot == editorPane && !editorPane.isEditable()) {
            int caretPos = editorPane.getCaretPosition();
            List elements = enumerateFocusableThings(caretPos);
            if (!elements.isEmpty())
                return ((FocusableThing) elements.get(0)).getComponent();
        }
                    
        return getFirstComponent(focusCycleRoot);
    }
    
    
    private class FocusTraversalPolicyAdvisor extends LayoutFocusTraversalPolicy {
        protected boolean accept(Component aComponent) {
            return (aComponent != editorPane && super.accept(aComponent));
        }
    }
    
    
    
    private abstract class FocusableThing {
        protected Element e;
        public abstract Component getComponent();
        public abstract boolean matches(Component c);
        public boolean matches(Element e) { return this.e == e; }
        public Element getElement() { return e; }
    }
    
    private class FocusableHyperlinkElement extends FocusableThing {
        
        public FocusableHyperlinkElement(Element e) { this.e = e; }

        public boolean matches(Component c) {
            return ((c instanceof HyperlinkFocusDelegate) &&
                    matches(((HyperlinkFocusDelegate) c).getElement()));
        }

        public Component getComponent() {
            if (matches(delegate1.getElement())) return delegate1;
            if (matches(delegate2.getElement())) return delegate2;
            HyperlinkFocusDelegate result =
                (delegate1.hasFocus() ? delegate2 : delegate1);
            result.setElement(e);
            return result;
        }
        
    }
    
    private class FocusableComponentElement extends FocusableThing {
        
        private ComponentView v;
        private Component c;
        
        public FocusableComponentElement(ComponentView v, Component c) {
            this.v = v; 
            this.c = c;
            this.e = v.getElement();
        }

        public boolean matches(Component c) {
            Component lookingForComponent = this.c;          
            while (c != null) {
                if (c == lookingForComponent) return true;
                c = c.getParent();
            }
            return false;
        }

        public Component getComponent() {
            return registerFocusableComponent(c, v);
        }        
        
    }
    
    
    private int findThing(List elements, Component c) {
        Iterator i = elements.iterator();
        int pos = 0;
        while (i.hasNext()) {
            if (((FocusableThing) i.next()).matches(c))
                return pos;
            pos++;
        }
        
        return -1;
    }
    
    private List enumerateFocusableThings() {
        return enumerateFocusableThings(0);
    }
    
    private List enumerateFocusableThings(int startPos) {
        Document doc = editorPane.getDocument();
        if (doc == null) return Collections.EMPTY_LIST;
        
        List focusableComponents = getFocusableComponents();
        List componentElements = getComponentViewElements(focusableComponents);    
        FocusableThing nextComponent = getNext(componentElements);
                
        List result = new LinkedList();
        
        ElementIterator elements = new ElementIterator(doc);
        Element e = null;
        int hiddenUntil = startPos-1;
        while ((e = elements.next()) != null) {
            if (ExpandCollapse.isDisplayNone(e))
                hiddenUntil = Math.max(hiddenUntil, e.getEndOffset());
                
            if (nextComponent != null && nextComponent.matches(e)) {
                if (e.getEndOffset() > hiddenUntil)
                    result.add(nextComponent);
                nextComponent = getNext(componentElements);
            } else if (isHyperlinkElement(e))
                if (e.getEndOffset() > hiddenUntil)
                    result.add(new FocusableHyperlinkElement(e));
        }
        
        return result;
    }


    /** Extract and return the first item from a list, or return null if the
     * list is empty. */
    private FocusableThing getNext(List elements) {
        if (elements == null || elements.isEmpty())
            return null;
        else
            return (FocusableThing) elements.remove(0);
    }

    /** Return true if the given element represents an HTML hyperlink. */
    private boolean isHyperlinkElement(Element elem) {
        AttributeSet attrs = elem.getAttributes();
        Object elemName = attrs.getAttribute(StyleConstants.NameAttribute);
        return (elemName != HTML.Tag.LINK && 
            getAttribValue(attrs, HTML.Attribute.HREF) != null);
    }


    /** Get a list of the focusable Components under the editor pane in the 
     * AWT containment hierarchy
     */
    private List getFocusableComponents() {
        synchronized (editorPane) {
            FocusTraversalPolicy currentPolicy = editorPane.getFocusTraversalPolicy();
            editorPane.setFocusTraversalPolicy(focusAdvisor);
            
            LinkedList result = new LinkedList();
            Component c = focusAdvisor.getFirstComponent(editorPane);
            while (c != null) {
                if (result.contains(c)) 
                    break;
                result.add(c);
                c = focusAdvisor.getComponentAfter(editorPane, c);
            }
            
            editorPane.setFocusTraversalPolicy(currentPolicy);        
            return result;
        }
    }
    
    /** Return a list of all the Elements in the current document which are
     * currently being represented by instances of ComponentView.
     */
    private List getComponentViewElements(List focusableComponents) {
        List result = new LinkedList();
        getComponentViewElements(editorPane.getUI().getRootView(editorPane), 
            focusableComponents, result);
        return result;
    }

    /** Compile a list of all the Elements on or underneath View which are
     * currently being represented by instances of ComponentView.
     */
    private void getComponentViewElements(View view, List focusableComponents, List result) {
        if (view instanceof ComponentView) {
            ComponentView cv = (ComponentView) view;
            Component c = cv.getComponent();
            getComponentViewElements(cv, c, focusableComponents, result);
        } else if (view != null) {
            for (int i = 0;   i < view.getViewCount();   i++)
                getComponentViewElements(view.getView(i), focusableComponents, result);
        }
    }
    
    /** Compile a list of all the focusable components underneath the given 
     * ComponentView.
     */
    private void getComponentViewElements(ComponentView view, Component parent, 
        List focusableComponents, List result) {
        
        if (parent == null) return;
        
        Iterator i = focusableComponents.iterator();
        Component comp, c;
        while (i.hasNext()) {
            comp = c = (Component) i.next();
            while (c != null) {
                if (c == parent) {
                    result.add(new FocusableComponentElement(view, comp));
                    break;
                }
                c = c.getParent();
            }            
        }
    }
    

    /*
     * Returns the object in an AttributeSet matching a key
     */
    static private Object getAttribValue(
        AttributeSet attr,
        HTML.Attribute key) {
        Enumeration names = attr.getAttributeNames();
        while (names.hasMoreElements()) {
            Object nextKey = names.nextElement();
            Object nextVal = attr.getAttribute(nextKey);
            if (nextVal instanceof AttributeSet) {
                Object value = getAttribValue((AttributeSet) nextVal, key);
                if (value != null) {
                    return value;
                }
            } else if (nextKey == key) {
                return nextVal;
            }
        }
        return null;
    }
    
    private HashMap focusableComponents = new HashMap();
    
    private Component registerFocusableComponent(Component c, ComponentView v) {
        synchronized (focusableComponents) {
            if (!focusableComponents.containsKey(c)) {
                focusableComponents.put(c, v);
                c.addFocusListener(this);
            }
        }
        return c;
    }
    
    protected void scrollToElement(Element e) {
        if (e.getDocument() != editorPane.getDocument()) return;

        int p0 = e.getStartOffset();
        int p1 = e.getEndOffset();
        editorPane.setCaretPosition(p1);
        editorPane.setCaretPosition(p0);
    }
    
    private boolean mouseDown = false;
    
    public void mousePressed(MouseEvent e)  { mouseDown = true;  }
    public void mouseReleased(MouseEvent e) { mouseDown = false; }        

    public void mouseClicked(MouseEvent e) { }
    public void mouseEntered(MouseEvent e) { }
    public void mouseExited(MouseEvent e) { }        
    
    
    private boolean caretInHyperlink() {
        Document doc = editorPane.getDocument();
        if (doc == null) return false;
        
        int caretPos = editorPane.getCaretPosition();
        
        ElementIterator elements = new ElementIterator(doc);
        Element e = null;
        while ((e = elements.next()) != null) {
            if (e.getStartOffset() > caretPos)
                break;
            if (e.getStartOffset() <= caretPos &&
                e.getEndOffset() >= caretPos &&
                isHyperlinkElement(e))
                return true;
        }

        return false;
    }

    
    public void focusGained(FocusEvent e) {        
        Component comp = e.getComponent(); 
        if (comp == editorPane && !editorPane.isEditable()) {
            if (!mouseDown || caretInHyperlink())
                SwingUtilities.invokeLater(focusTransferrer);
        
        } else {
            View v = (View) focusableComponents.get(comp);
            if (v != null) scrollToElement(v.getElement());
        }
    }




    public void focusLost(FocusEvent e) {
        mouseDown = false; 
    }
    
    private Runnable focusTransferrer = new Runnable() {
        public void run() {
            Component c = getDefaultComponent(editorPane);
            if (c == null || c.requestFocusInWindow() == false)
                editorPane.transferFocus();
        }
    };


    private boolean documentContainsElement(Element elem) {
        if (elem == null) return false;
        
        Document doc = editorPane.getDocument();
        if (doc == null) return false;
        
        ElementIterator elements = new ElementIterator(doc);
        Element e = null;
        while ((e = elements.next()) != null) {
            if (e == elem) return true;
        }
        return false;
    }



    /** A component that can recieve focus on behalf of an HTML hyperlink.
     */
    private class HyperlinkFocusDelegate extends JButton
        implements FocusListener, ActionListener 
    {
        
        Element documentElement = null;
        Object highlightTag = null;
        
        public HyperlinkFocusDelegate(int pos) {
            super();
            editorPane.add(this);
            addFocusListener(this);
            addActionListener(this);
            
            Dimension d = new Dimension(0, 0);
            setMinimumSize(d);
            setPreferredSize(d);
            setMaximumSize(d);
            setBounds(pos, 0, 0, 0);
        }
        
        public Element getElement() {
            return documentElement;
        }
        
        public void setElement(Element e) {
            documentElement = e;
            if (getParent() != editorPane)
                editorPane.add(this);
        }
        
        public void focusGained(FocusEvent e) {
    
            if (!documentContainsElement(documentElement)) {            
                
                // transfer the focus to the default hyperlink or component.
                SwingUtilities.invokeLater(focusTransferrer);
                return;
            }

            Highlighter highlighter = editorPane.getHighlighter();
            if (highlighter == null) return;

            scrollToElement(documentElement);

            int p0 = documentElement.getStartOffset();
            int p1 = documentElement.getEndOffset();
    
            try {
                if (highlightTag != null) {
                    highlighter.changeHighlight(highlightTag, p0, p1);
                } else {
                    highlightTag = highlighter.addHighlight(p0, p1, focusPainter);
                }
            } catch (BadLocationException ble) {
                ble.printStackTrace();
            }
        }

        public void focusLost(FocusEvent e) {

            if (highlightTag != null) {
                Highlighter highlighter = editorPane.getHighlighter();
                if (highlighter != null)
                    highlighter.removeHighlight(highlightTag);
                highlightTag = null;
            }
        }


        public void paint(Graphics g) {
            // do nothing.  We don't want this component to have an 
            // appearance.
        }


        public void actionPerformed(ActionEvent e) {

            Document d = editorPane.getDocument();
            if ((d != documentElement.getDocument()) || 
                !(d instanceof HTMLDocument))
                return;

            HTMLDocument doc = (HTMLDocument) d;

            AttributeSet attr = documentElement.getAttributes();
            Object href = getAttribValue(attr, HTML.Attribute.HREF);
            if (!(href instanceof String))
                return;

            URL url = null;
            try {
                URL page = (URL) doc.getProperty
                    (Document.StreamDescriptionProperty);
                url = new URL(page, (String) href);
                href = url.toExternalForm();
            } catch (MalformedURLException m) { }
            
            HyperlinkEvent linkEvent =
                new HyperlinkEvent(
                    editorPane,
                    HyperlinkEvent.EventType.ACTIVATED,
                    url,
                    (String) href,
                    documentElement);
            editorPane.fireHyperlinkUpdate(linkEvent);
        }

		public AccessibleContext getAccessibleContext() {
			return editorPane.getAccessibleContext();
		}

    }


    /** Class for painting a focus rectangle around an HTML hyperlink.
     */
    private class FocusHighlightPainter
        extends DefaultHighlighter.DefaultHighlightPainter {

        FocusHighlightPainter(Color color) {
            super(color);
        }

        /** Paint a portion of a highlight. */
        public Shape paintLayer(Graphics g, int offs0, int offs1,
            Shape bounds, JTextComponent c, View view) {

            Rectangle rect = null;

            if (offs0 == view.getStartOffset() && offs1 == view.getEndOffset()) {
                rect = getRect(bounds);

            } else try {
                rect = getRect(view.modelToView(offs0, Position.Bias.Forward, 
                    offs1, Position.Bias.Backward, bounds));
            } catch (BadLocationException e) { }

            if (rect != null) {
                g.setColor(getColor());
                BasicGraphicsUtils.drawDashedRect
                    (g, rect.x, rect.y, rect.width, rect.height);
            }
            
            return rect;
        }

        /** Convienence routine: convert Shape to Rectangle */
        private final Rectangle getRect(Shape shape) {
            if (shape instanceof Rectangle)
                return (Rectangle) shape;
            else
                return shape.getBounds();
        }
    }

}
