package gov.va.med.hds.cd.spectrum.dhtml.scriptlet;

import java.lang.reflect.Method;

class ScriptletAction {

    private Object instance;
    private Method method;
    boolean useEvent;

    public ScriptletAction(Object instance, Method method, boolean useEvent) {
        this.instance = instance;
        this.method = method;
        this.useEvent = useEvent;
    }

    public Object invoke(IScriptletEvent event, Object[] args) {
        try {
            if (useEvent) {
                Object[] realArgs = new Object[args.length + 1];
                realArgs[0] = event;
                if (args.length > 0)
                    System.arraycopy(args, 0, realArgs, 1, args.length);
                args = realArgs;
            }

            return method.invoke(instance, args);
        } catch (Exception e) {
            return e;
        }
    }

    public boolean equals(Object o) {
        return (
            o instanceof ScriptletAction
                && ((ScriptletAction) o).method == this.method);
    }

    public int hashCode() {
        return method.hashCode();
    }

}
