package gov.va.med.hds.cd.spectrum.longlist;

/**
 * Implements IBufferItem, and provides a convenience object to store items in an
 * IBufferList.
 */
public class BufferItem implements IBufferItem {
	private Object value = new String();
	private Object id = new String();
	private static final char sep = 0x0;

	
	/**
	 * Constructor for BufferItem.
	 */
	public BufferItem() {
		super();
	}
	
	public BufferItem(Object value, Object id) {
		super();
		this.value = value;
		this.id = id;
	}

	public Object getId() {
		return id;
	}

	public Object getValue() {
		return value;
	}

	public void setId(Object id) {
		this.id = id;
	}

	public void setValue(Object value) {
		this.value = value;
	}
	
	public String getKey() {
		return value.toString().toUpperCase() + sep + id.toString().toUpperCase();
	}
	
	public String toString() {
		return value.toString();
	}

	/**
	 * @see java.lang.Object#equals(Object)
	 */
	public boolean equals(Object o) {
		return (o instanceof IBufferItem) && (getKey().compareTo(((IBufferItem)o).getKey())==0);
	}

	/**
	 * @see java.lang.Comparable#compareTo(Object)
	 */
	public int compareTo(Object o) {
		return getKey().compareTo(((IBufferItem)o).getKey());
	}

}
