package gov.va.med.hds.cd.spectrum.longlist;

import java.util.EventObject;

/**
 * Implements an IDataNeededEvent for communicating data needs.
 */
public class DataNeededEvent extends EventObject implements IDataNeededEvent {
	private int direction = 1;
	private Object startingAt = new String();
	private int length = 1;
	private boolean dataSearch = false;

	/**
	 * Constructor for DataNeededEvent.
	 * @param source
	 */
	public DataNeededEvent(Object source) {
		super(source);
	}

	/**
	 * Constructor DataNeededEvent.
	 * @param bufferModel
	 * @param start
	 * @param direction
	 * @param length
	 * @param dataSearch
	 */
	public DataNeededEvent(Object source,Object startingAt,int direction,int length,boolean isDataSearch) {
		this(source);
		this.startingAt = startingAt;
		this.direction = direction;
		this.length = length;
		this.dataSearch = isDataSearch;
	}

	/**
	 * Constructor DataNeededEvent.
	 * @param mClinBufferListDAOFactoryTest
	 * @param object
	 * @param i
	 * @param i1
	 */
	public DataNeededEvent(Object source,Object startingAt,int direction,int length) {
		this(source,startingAt,direction,length,false);
	}
	
	public int getDirection() {
		return direction;
	}

	public int getLength() {
		return length;
	}

	public Object getStartingAt() {
		return startingAt;
	}

	public void setDirection(int direction) {
		this.direction = direction;
	}

	public void setLength(int length) {
		this.length = length;
	}

	public void setStartingAt(Object startingAt) {
		this.startingAt = startingAt;
	}

	public boolean isDataSearch() {
		return dataSearch;
	}

	public void setDataSearch(boolean dataSearch) {
		this.dataSearch = dataSearch;
	}

}
