package gov.va.med.hds.cd.spectrum.longlist;



/**
 * @author vhaislmonsos
 *
 */
public class DataRequest {
	private int requestID = IBufferModel.NO_REQUEST;
	private Object startAt;
	private int size = 0;
	
	/**
	 * Remove public default constructor for DataRequest.
	 */
	private DataRequest() {
		super();
	}
	
	/**
	 * Method DataRequest.
	 * @param requestID
	 */
	public DataRequest(int requestID) {
		//Can be used by RESET, TOP, BOTTOM, NEXT, & PREV
		this();
		this.requestID = requestID;
	}

	/**
	 * Method DataRequest.
	 * @param requestID
	 * @param size
	 */
	public DataRequest(int requestID, int size) {
		this();
		this.requestID = requestID;
		this.size = size;
	}
	
	/**
	 * Method DataRequest.
	 * @param requestID
	 * @param start
	 */
	public DataRequest(int requestID, Object start) {
		//Can be used by all
		this();
		this.requestID = requestID;
		this.startAt = start;
	}

	/**
	 * Method DataRequest.
	 * @param requestID
	 * @param start
	 * @param size
	 */
	public DataRequest(int requestID, Object start, int size) {
		//Can be used by all
		this();
		this.requestID = requestID;
		this.startAt = start;
		this.size = size;
	}

	/**
	 * Returns the requestID.
	 * @return int
	 */
	public int getRequestID() {
		return requestID;
	}

	/**
	 * Returns the size.
	 * @return int
	 */
	public int getSize() {
		return size;
	}

	/**
	 * Returns the startAt.
	 * @return Object
	 */
	public Object getStartAt() {
		return startAt;
	}

	/**
	 * Sets the requestID.
	 * @param requestID The requestID to set
	 */
	public void setRequestID(int requestID) {
		this.requestID = requestID;
	}

	/**
	 * Sets the size.
	 * @param size The size to set
	 */
	public void setSize(int size) {
		this.size = size;
	}

	/**
	 * Sets the startAt.
	 * @param startAt The startAt to set
	 */
	public void setStartAt(Object startAt) {
		this.startAt = startAt;
	}

}
