/*
 * Initially Created on Mar 18, 2003 by vhaislmonsos
 *
 */
package gov.va.med.hds.cd.spectrum.longlist;

/**
 * This interface is for items that are used in the IBufferModel.
 */
public interface IBufferItem extends Comparable {
	
	/**
	 * Returns the ID of this buffer item.
	 * @return Object
	 */
	Object getId();
	
	/**
	 * Returns the value of this buffer item.
	 * @return Object
	 */
	Object getValue();
	
	/**
	 * Sets the buffer item ID.
	 * @param id The id to set
	 */
	void setId(Object id);
	
	/**
	 * Sets the buffer item value.
	 * @param value The value to set
	 */
	void setValue(Object value);
	
	/**
	 * Returns the key, which is used to compare buffer items with each other.
	 * @return String
	 */
	String getKey();
}