/*
 * Initially Created on May 7, 2003 by vhaislmonsos
 *
 */
package gov.va.med.hds.cd.spectrum.longlist;

/**
 * Event used by a long list to indicate data needed.
 */
public interface IDataNeededEvent {
	
	/**
	 * Returns the direction.
	 * @return int
	 */
	int getDirection();
	
	/**
	 * Returns the length.
	 * @return int
	 */
	int getLength();
	
	/**
	 * Returns the startingAt.
	 * @return String
	 */
	Object getStartingAt();
	
	/**
	 * Sets the direction.
	 * @param direction The direction to set
	 */
	void setDirection(int direction);
	
	/**
	 * Sets the length.
	 * @param length The length to set
	 */
	void setLength(int length);
	
	/**
	 * Sets the startingAt object.
	 * @param startingAt The startingAt object to set
	 */
	void setStartingAt(Object startingAt);
	
	/**
	 * Returns the dataSearch.
	 * @return boolean
	 */
	boolean isDataSearch();
	
	/**
	 * Sets the dataSearch.
	 * @param dataSearch The dataSearch to set
	 */
	void setDataSearch(boolean dataSearch);
	
	/**
	 * Returns the source of the event.
	 * @return source
	 */
	Object getSource();
	
}