/*
 * Initially Created on Mar 20, 2003 by vhaislmonsos
 *
 */
package gov.va.med.hds.cd.spectrum.longlist;

/**
 * Event object interface for long list component communication.
 */
public interface ILongListEvent {
	public static final int UP = 1;
	public static final int DOWN = 2;
	public static final int PAGE_UP = 3;
	public static final int PAGE_DOWN = 4;
	public static final int HOME = 5;
	public static final int END = 6;
	public static final int SEARCH = 7;
	public static final int SELECT = 8;
	public static final int SELECT_CHANGE = 9;
	
	/**
	 * Returns the source object of the event.
	 * @return Object
	 */
	Object getSource();
	
	/**
	 * Returns the event ID.
	 * @return int
	 */
	int getID();
	
	/**
	 * Sets the event ID.
	 * @param id
	 */
	void setID(int id);
	
	/**
	 * Returns the parameter object from the event.
	 * @return Object
	 */
	Object getParameter();
	
	/**
	 * Sets the event parameter.
	 * @param parm
	 */
	void setParameter(Object parm);

}
