/*
 * Initially Created on Mar 24, 2003 by vhaislmonsos
 *
 */
package gov.va.med.hds.cd.spectrum.longlist;

import javax.swing.ListModel;

/**
 * Extends JList functionality for a long list component.
 */
public interface ISearchList extends ILongListComponent, IFocusable {
	
	/**
	 * This method is exposed for this interface.
	 * @param model
	 */
	void setModel(ListModel model);
	
	/**
	 * Returns the number of lines currently displayable by this component.
	 * @return int
	 */
	int getVisibleRowSize();
	
	/**
	 * Returns the currently selected line; -1 if a line is not selected.
	 * @return int
	 */
	int getSelectedRow();

	/**
	 * Sets the row in the display that should be selected.
	 * @param row
	 */
	void setSelectedRow(int row);

	/**
	 * Returns the currently selected item.
	 * @return Object
	 */
	Object getSelectedValue();

	/**
	 * @param value
	 */
	void setPrototypeCellValue(Object value);
	
	/**
	 * @return height - in pixels
	 */
	int getFixedCellHeight();
	
	/**
	 * @return width - in pixels
	 */
	int getFixedCellWidth();
	
	/**
	 * @param height
	 */
	void setFixedCellHeight(int height);
	
	/**
	 * @param width
	 */
	void setFixedCellWidth(int width);
	
}
