/*
 * Initially Created on Mar 20, 2003 by vhaislmonsos
 *
 */
package gov.va.med.hds.cd.spectrum.longlist;

import javax.swing.text.Caret;


/**
 * Organizes key and mouse events for the ILongListLookup component.
 */
public interface ISearchTextBox extends ILongListComponent {
	
	/**
	 * Returns the number of milliseconds the component waits before firing a search event.
	 * @return int
	 */
	int getTimerTime();
	
	/**
	 * Sets the number of milliseconds the component waits before firing a search event.
	 * @param timerTime
	 */
	void setTimerTime(int timerTime);

	/**
	 * Returns the text in the text box.
	 * @return String
	 */
	String getText();

	/**
	 * Sets the text box string.
	 * @param string
	 */
	void setText(String string);
	
	/**
	 * Delegates to parent class.
	 * @return Caret
	 */
	Caret getCaret();
	
	/**
	 * Delegates to parent method.
	 * @return boolean
	 */
	boolean isFocusOwner();
	
	/**
	 * Delegates to parent method.
	 */
	boolean requestFocusInWindow();
}