/*
 * Initially Created on Mar 20, 2003 by vhaislmonsos
 */
package gov.va.med.hds.cd.spectrum.longlist;

import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import javax.swing.event.EventListenerList;

/**
 * Dummy model that returns controller events.
 */
public class ScrollBarModel implements IScrollBarModel {
	private EventListenerList listenerList = new EventListenerList();
	private int value = 50;
	private boolean adjusting = false;
	private int maxValue = 100;
	private int minValue = 0;
	private int extent = 10;
	private int tempNewValue = -1;

	public int getMinimum() {return minValue;}

	public void setMinimum(int newMinimum) {}

	public int getMaximum() {return maxValue;}

	public void setMaximum(int newMaximum) {}

	public int getValue() {
		return value;
	}

	public void setValue(int newValue) {
		if (adjusting) {
			tempNewValue = newValue;
			return;
		} 
		if (newValue+1==value) {
			fireListEvent(ILongListEvent.UP);
		}
		else if (newValue-1==value) {
			fireListEvent(ILongListEvent.DOWN);
		}
		else if (newValue==maxValue-extent) {
			fireListEvent(ILongListEvent.END);
		}
		else if (newValue==minValue) {
			fireListEvent(ILongListEvent.HOME);
		}
		else if (newValue<value-1) {
			fireListEvent(ILongListEvent.PAGE_UP);
		}
		else if (newValue>value+1) {
			fireListEvent(ILongListEvent.PAGE_DOWN);
		}
	}

	public void setValueIsAdjusting(boolean b) {
		this.adjusting = b;
		if (!adjusting && tempNewValue!=-1) {
			setValue(tempNewValue);
			tempNewValue = -1;
		}
	}

	public boolean getValueIsAdjusting() {
		return adjusting;
	}

	public int getExtent() {return extent;}

	public void setExtent(int newExtent) {}

	public void setRangeProperties(
		int value,
		int extent,
		int min,
		int max,
		boolean adjusting) {
		setValueIsAdjusting(adjusting);
		setValue(value);
	}

	public void addChangeListener(ChangeListener x) {
		listenerList.add(ChangeListener.class, x);
	}

	public void removeChangeListener(ChangeListener x) {
		listenerList.remove(ChangeListener.class, x);
	}
	
	public void addLongListListener(ILongListComponentListener l) {
		listenerList.add(ILongListComponentListener.class, l);
	}

	public void removeLongListListener(ILongListComponentListener l) {
		listenerList.remove(ILongListComponentListener.class, l);
	}
	
	private void fireListEvent(int eventID) {
		if (listenerList.getListenerCount(ILongListComponentListener.class)>0) {
			ILongListEvent event = new LongListEvent(this);
			event.setID(eventID);
			ILongListComponentListener[] listeners = (ILongListComponentListener[])listenerList.getListeners(ILongListComponentListener.class);
			for (int i = 0; i < listeners.length; i++) {
				listeners[i].actionPerformed(event);
			}
		}
	}
	
	private void fireChangeEvent() {
		if (listenerList.getListenerCount(ChangeListener.class)>0) {
			ChangeEvent event = new ChangeEvent(this);
			ChangeListener[] listeners = (ChangeListener[])listenerList.getListeners(ChangeListener.class);
			for (int i = 0; i < listeners.length; i++) {
				listeners[i].stateChanged(event);
			}
		}
	}

	public void setNewValue(int newValue) {
		value = newValue;
		fireChangeEvent();
	}

}
