package gov.va.med.hds.cd.spectrum.plaf.metal;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Insets;
import java.awt.Rectangle;

import javax.swing.plaf.metal.MetalLookAndFeel;

import gov.va.med.hds.cd.spectrum.plaf.basic.BasicMultiSplitPaneDivider;
import gov.va.med.hds.cd.spectrum.plaf.basic.BasicMultiSplitPaneUI;

public class MetalMultiSplitPaneDivider extends BasicMultiSplitPaneDivider {
	private MetalBumps bumps =
		new MetalBumps(
			10,
			10,
			MetalLookAndFeel.getControlHighlight(),
			MetalLookAndFeel.getControlDarkShadow(),
			MetalLookAndFeel.getControl());

	private MetalBumps focusBumps =
		new MetalBumps(
			10,
			10,
			MetalLookAndFeel.getPrimaryControlHighlight(),
			MetalLookAndFeel.getPrimaryControlDarkShadow(),
			MetalLookAndFeel.getPrimaryControl());

	private int inset = 2;

	private Color controlColor = MetalLookAndFeel.getControl();
	private Color primaryControlColor = MetalLookAndFeel.getPrimaryControl();

	public MetalMultiSplitPaneDivider(BasicMultiSplitPaneUI ui) {
		super(ui);
	}

	public void paint(Graphics g) {
		MetalBumps usedBumps;
		if (pane.hasFocus()) {
			usedBumps = focusBumps;
			g.setColor(primaryControlColor);
		} else {
			usedBumps = bumps;
			g.setColor(controlColor);
		}
		Rectangle clip = g.getClipBounds();
		Insets insets = getInsets();
		g.fillRect(clip.x, clip.y, clip.width, clip.height);
		Dimension size = getSize();
		size.width -= inset * 2;
		size.height -= inset * 2;
		int drawX = inset;
		int drawY = inset;
		if (insets != null) {
			size.width -= (insets.left + insets.right);
			size.height -= (insets.top + insets.bottom);
			drawX += insets.left;
			drawY += insets.top;
		}
		usedBumps.setBumpArea(size);
		usedBumps.paintIcon(this, g, drawX, drawY);
		super.paint(g);
	}
}