package gov.va.med.hds.cd.spectrum.plaf.windows;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;

import javax.swing.UIManager;

import gov.va.med.hds.cd.spectrum.plaf.basic.BasicMultiSplitPaneDivider;
import gov.va.med.hds.cd.spectrum.plaf.basic.BasicMultiSplitPaneUI;

/**
 * Divider used for Windows split pane.
 */
public class WindowsMultiSplitPaneDivider extends BasicMultiSplitPaneDivider {

	/**
	 * Creates a new Windows SplitPaneDivider
	 */
	public WindowsMultiSplitPaneDivider(BasicMultiSplitPaneUI ui) {
		super(ui);
	}

	/**
	 * Paints the divider.
	 */
	public void paint(Graphics g) {
		Color bgColor =
			(pane.hasFocus())
				? UIManager.getColor("SplitPane.shadow")
				: getBackground();
		Dimension size = getSize();

		if (bgColor != null) {
			g.setColor(bgColor);
			g.fillRect(0, 0, size.width, size.height);
		}
		super.paint(g);
	}
}
