/*
=====================================================================

  ColumnComparator.java
  
  Created by Claude Duguay
  Copyright (c) 2002
  
=====================================================================
*/

package gov.va.med.hds.cd.spectrum.sorttable;

import java.util.Comparator;
import java.util.Vector;

public class ColumnComparator
  implements Comparator
{
  protected int index;
  protected boolean ascending;
  
  public ColumnComparator(int index, boolean ascending)
  {
    this.index = index;
    this.ascending = ascending;
  }
  
  public int compare(Object one, Object two) 
  {
    if (one instanceof Vector &&
        two instanceof Vector)
    {
      Vector vOne = (Vector)one;
      Vector vTwo = (Vector)two;
      Object oOne = vOne.elementAt(index);
      Object oTwo = vTwo.elementAt(index);
      if (oOne instanceof Comparable &&
          oTwo instanceof Comparable)
      {
        Comparable cOne = (Comparable)oOne;
        Comparable cTwo = (Comparable)oTwo;
        if (ascending)
        {
          return cOne.compareTo(cTwo);
        }
        else
        {
          return cTwo.compareTo(cOne);
        }
      }
    }
    return 1;
  }
}

