/*
 * Created on Mar 25, 2003 2:35:32 PM
 */
package gov.va.med.hds.cd.spectrum.text;

import java.awt.Dimension;

import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.JList;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.ListModel;
import javax.swing.border.EmptyBorder;

import gov.va.med.hds.cd.spectrum.longlist.BufferedListLookupBox;

/**
 *
 * @author Joel Russell
 *
 * Department of Veterans Affairs
 * OI Field Office - Salt Lake City
 * Health Data Systems
 * 
 **/
public class OrderedListField extends JPanel {
	private Object initialValue;
	private BufferedListLookupBox lookupBox;
	private JList list;
	private JScrollPane listScrollPane;
	private Object[] model;
	private JPanel buttonPanel;
	private JButton addButton;
	private JButton upButton;
	private JButton downButton;
	private JButton removeButton;
	private int listWidth;
	private int listHeight;
	
	public OrderedListField(int width, int height) {
		super();
		
		this.list = new JList();
		this.listWidth = width;
		this.listHeight = height;
		setComponentSize(this.list, new Dimension(width, height));
		
		initGUI();
	}

	public OrderedListField(Object[] model, int width, int height) {
		super();

		this.model = model;
		this.list = new JList(model);
		this.listWidth = width;
		this.listHeight = height;
		setComponentSize(this.list, new Dimension(width, height));
		
		initGUI();
	}
	
	private void initGUI() {
		setLayout(new BoxLayout(this, BoxLayout.X_AXIS));
		addButton = new JButton("Add...");
		upButton = new JButton("Up");
		downButton = new JButton("Down");
		removeButton = new JButton("Remove");
		
		buttonPanel = new JPanel();
		buttonPanel.setLayout(new BoxLayout(buttonPanel, BoxLayout.Y_AXIS));
		
		buttonPanel.setBorder(new EmptyBorder(10, 10, 10, 10));
		buttonPanel.add(addButton);
		buttonPanel.add(Box.createVerticalGlue());
		buttonPanel.add(upButton);
		buttonPanel.add(Box.createVerticalGlue());
		buttonPanel.add(downButton);
		buttonPanel.add(Box.createVerticalGlue());
		buttonPanel.add(removeButton);
		buttonPanel.add(Box.createVerticalGlue());
		
		listScrollPane = new JScrollPane(list);
		setComponentSize(listScrollPane, new Dimension(listWidth, listHeight));

		add(listScrollPane);
		add(Box.createHorizontalGlue());
		add(buttonPanel);		
	}

	private void setComponentSize(JComponent component, Dimension dimension) {
		component.setMaximumSize(dimension);
		component.setMinimumSize(dimension);
		component.setPreferredSize(dimension);
	}

	private void doShowList() {
		int result =
			JOptionPane.showOptionDialog(
				getRootPane(),
				lookupBox,
				"Choose an Item",
				JOptionPane.OK_CANCEL_OPTION,
				JOptionPane.PLAIN_MESSAGE,
				null,
				null,
				initialValue);
//		if (result == JOptionPane.OK_OPTION) {
//			model.(lookupBox.getSelectedValue());
//			fireItemSelected(lookupBox.getSelectedValue());
//		}
	}
	
	public ListModel getList() {
		return list.getModel();
	}
	
	public void setList(Object[] listData) {
		list.setListData(listData);
		list.revalidate();
	}
}
