package gov.va.med.hds.cd.spectrum.wizard;

public interface IWizardPage {
	/**
	 * The page returns true if it has no page errors which prevent the user from
	 * continuing.  If false, the reason for the error can be retrieved with the 
	 * getErrorMessage method.
	 * @return boolean
	 */
	boolean isOkToGoNext();
	
	/**
	 * Returns an error message for the page (see the isOkToGoNext method.)  If there
	 * is no current error condition, this method returns an empty string ("").
	 * @return String
	 */
	String getErrorMessage();
	
	/**
	 * The user is allowed to click the finish button from this page.
	 * @return boolean
	 */
	boolean isFinishAllowed();
	
	/**
	 * Title to be displayed in conjunction with this page.
	 * @return String
	 */
	String getTitle();
	
}
