package gov.va.med.hds.cd.spectrum.wizard;





/**
 * @author vhaislmonsos
 *
 */
public abstract class WaitPageSetModel extends AbstractPageSetModel {
	/**
	 * Constructor for WaitPageSetModel.
	 */
	public WaitPageSetModel() {
		super();
	}

	/**
	 * @see gov.va.med.hds.cd.spectrum.IPageSetModel#size()
	 */
	public int size() {
		return 1;
	}

	/**
	 * @see gov.va.med.hds.cd.spectrum.IPageSetModel#getCurrentPageNum()
	 */
	public int getCurrentPageNum() {
		return 1;
	}

	/**
	 * @see gov.va.med.hds.cd.spectrum.IPageSetModel#getCurrentPage()
	 */
	public IWizardPage getCurrentPage() {
		return getWaitPage();
	}

	/**
	 * @see gov.va.med.hds.cd.spectrum.IPageSetModel#getPrevRequest()
	 */
	public void getPrevRequest() {
		firePageReady();
	}

	/**
	 * @see gov.va.med.hds.cd.spectrum.IPageSetModel#getNextRequest()
	 */
	public void getNextRequest() {
		firePageReady();
	}

	/**
	 * @see gov.va.med.hds.cd.spectrum.IPageSetModel#getFinishRequest()
	 */
	public void getFinishRequest() {
		firePageReady();
	}

	/**
	 * @see gov.va.med.hds.cd.spectrum.IPageSetModel#isFirstPage()
	 */
	public boolean isFirstPage() {
		return true;
	}

	/**
	 * @see gov.va.med.hds.cd.spectrum.IPageSetModel#isLastPage()
	 */
	public boolean isLastPage() {
		return true;
	}

	/**
	 * @see gov.va.med.hds.cd.spectrum.IPageSetModel#reset()
	 */
	public void reset() {
		firePageReady();
	}
	
	public abstract IWizardPage getWaitPage();

	public void goToPageRequest(int pageNum) {
		firePageReady();
	}

}
