package gov.va.med.hds.task;

import java.util.EventListener;


/** Interface for an object which would like to be notified of changes
 * to tasks
 */
public interface ITaskChangeListener extends EventListener {

    /** Invoked when a new task has been created and saved. 
     * 
     * @param e an event describing the added task
     */
	public void taskAdded(TaskChangeEvent e);


    /** Invoked when changes to a task have been saved.
     * 
     * @param e an event describing the changed task
     */
	public void taskChanged(TaskChangeEvent e);


    /** Invoked when a task has been deleted.
     * 
     * @param e an event describing the deleted task
     */
	public void taskDeleted(TaskChangeEvent e);

}
