/*
 * Created on Jun 10, 2003
 */
package gov.va.med.hds.task;


/** The API for the task editor plugin.
 */
public interface ITaskPlugin {
    
    
    /** The ID of the plugin, in the runtime plugin registry */
    public static final String PLUGIN_ID = "gov.va.med.hds.task";


    /** Generate a URL that, when displayed, will walk the user through a
     * &quot;link to task&quot; operation.
     * 
     * @param linkedItemName the name of the item which should be linked to
     *    a task (for display purposes)
     * @param linkedItemType the type of the item (this should match a declared
     *    linkable item type, from the manifests)  
     * @param linkedItemID the ID of the item
     * @param patientID the ID of the patient for which the task should be
     *    created.
     * @return the String representation of a URL 
     */
	public String getLinkToTaskURL(
		String linkedItemName,
		String linkedItemType,
		String linkedItemID,
		Object patientID);

}