package gov.va.med.hds.task.data;

import java.util.Date;
import java.util.List;

public interface ITask {


    public TaskID getID();
    public void setID(TaskID id) throws IllegalStateException;
    
    public Object getPatientID();
    public Object getCreatingUserID();
    public boolean creatingUserMatches(Object userID);
    public Date getCreationDate();
    
    public String getSubject();
    public void setSubject(String subject);
    
    public String getPriority();
    public void setPriority(String priority);
    
    public Date getDueDate();
    public void setDueDate(Date dueDate);
    
    public Date getCompletionDate();
    public Object getCompletingUserID();
    public void markTaskComplete(Date when, Object userID);
    public void markTaskIncomplete();

    public Date getDeletionDate();
    public Object getDeletingUserID();
    public void markTaskDeleted(Date when, Object userID);

    public List getLinkedItems();
    public void addLinkedItem(String itemType, String itemID);
    public void removeLinkedItem(String itemType, String itemID);

    public boolean isDirty();
    public void save() throws TaskDataAccessException;

}
