package gov.va.med.hds.task.data;

public class TaskID {
    
    private long id;
        
    public TaskID(Object id) {
        if (id == null)
            throw new NullPointerException();
            
        if (id instanceof Number)
            this.id = ((Number) id).longValue();
        else if (id instanceof TaskID)
            this.id = ((TaskID) id).id;
        else try {
            String idStr = id.toString();
            if (idStr.startsWith("TSK:"))
                idStr = idStr.substring(4);
            this.id = Long.parseLong(idStr);
        } catch (NumberFormatException nfe) {
            throw new IllegalArgumentException("Invalid task ID '"+id+"'");
        }
    }
    
    public long getNumericID() {
        return id;
    }    
        
    public boolean equals(Object obj) {
        return (obj instanceof TaskID && ((TaskID) obj).id == id);
    }

    public int hashCode() {
        return (int)(id ^ (id >>> 32));
    }
    
    public String toString() {
        return Long.toString(id);
    }

}
