/*
 * Created on Jun 2, 2003
 *
 * To change this generated comment go to 
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package gov.va.med.hds.task.data.internal;

import java.util.Date;

import gov.va.med.hds.cd.daoregistry.IDaoRegistry;
import gov.va.med.hds.cd.runtime.IRuntimeContext;
import gov.va.med.hds.util.dao.IServerDateDAO;

/**
 * @author vhaisltumad
 *
 * To change this generated comment go to 
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
public class MDateProvider extends CurrentDateProvider {
    
    IRuntimeContext runtime;
    IServerDateDAO dateDAO;
        
    public MDateProvider(IRuntimeContext runtime) {
        this.runtime = runtime;
        this.dateDAO = null;
    }
        
    private void init() {
        try {
            IDaoRegistry daoRegistry =
                (IDaoRegistry) runtime.getPluginInstance(IDaoRegistry.PLUGIN_ID);
            dateDAO = (IServerDateDAO) daoRegistry.getDAO(IServerDateDAO.class.getName());                    
        } catch (Exception e) {
            runtime.getLogger(getClass()).error("Unable to get reference to instance of " + IServerDateDAO.class.getName(), e);
        }
    }
    
    public Date now() {
        if (dateDAO == null) 
            init();
        try {
            return dateDAO.getDate();
        } catch (Exception e) {
			runtime.getLogger(MDateProvider.class).error(
				"Unable to retrieve the current date/time from M; using client date/time",
				e);
            return new Date();
        } 
    }

}
