/*
 * Created on Jul 7, 2003
 *
 * To change this generated comment go to 
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package gov.va.med.hds.task.data.internal;

import java.io.BufferedReader;
import java.io.StringReader;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

import gov.va.med.hds.cd.m.IMumps;
import gov.va.med.hds.cd.m.IMumpsFactory;
import gov.va.med.hds.cd.runtime.IConfigurationElement;
import gov.va.med.hds.cd.runtime.IPluginDescriptor;
import gov.va.med.hds.cd.runtime.IRuntimeContext;
import gov.va.med.hds.task.ITaskPlugin;
import gov.va.med.hds.task.data.INameListDAO;
import gov.va.med.hds.task.data.TaskDataAccessException;
import gov.va.med.hds.util.mumps.StringUtil;

/** Looks up the full name of a user, given the user ID.
 */
public class MNameListDAO implements INameListDAO {
    
    private static final String ID2EXT_RPC_KEY = "ID2EXT";
    private static final String FILE_NUM = "200";
    
    
    protected IRuntimeContext runtime;
    protected IMumps mumps;

    public void setInitializationData(
        IRuntimeContext runtime,
        IConfigurationElement config,
        String propertyName,
        Object data)
        throws Exception {
        
        this.runtime = runtime;
        IPluginDescriptor desc = runtime.getPluginRegistry().getPluginDescriptor(ITaskPlugin.PLUGIN_ID);
        mumps = ((IMumpsFactory)runtime.getPluginInstance(IMumpsFactory.PLUGIN_ID)).create(desc);
    }

    private String getKey(Object text) {
        return StringUtil.piece(text.toString(), '^', 1);
    }

    private String getValue(Object text) {
        return StringUtil.piece(text.toString(), '^', 2);
    }

    public void get(Map items) throws TaskDataAccessException {        
        if (items.size() > 0) {
            String result = null;
            List parms = new LinkedList();
            parms.add(FILE_NUM);
            parms.add(items.keySet());
            try {
                result = mumps.callRPC(ID2EXT_RPC_KEY, parms);
            }
            catch (Exception e) {
                throw new TaskDataAccessException(e);
            }
            BufferedReader reader = new BufferedReader(new StringReader(result));
            items.clear();
            String line = null;
            try {
                while ((line=reader.readLine())!=null) {
                    String value = getValue(line);
                    String key = getKey(line);
                    if ((value.length() > 0) && (key.length()>0)) {
                        items.put(key,value);
                    }
                }
            }
            catch (Exception e) {
                throw new TaskDataAccessException("Invalid database data.",e);
            }
        }
    }

}
