package gov.va.med.hds.cd.url.internal;

import java.io.IOException;
import java.net.URL;
import java.net.URLConnection;

import gov.va.med.hds.cd.runtime.IRuntimeContext;
import gov.va.med.hds.cd.url.IContentProvider;
import gov.va.med.hds.cd.url.URLPluginException;


class ClasspathProvider implements IContentProvider {

    private ClassLoader loader;

    public ClasspathProvider(ClassLoader loader) {
        this.loader = loader;
    }

    /** Initializes the data access object */
    public void init(IRuntimeContext runtime) {}

    /** Open a connection to the named resource */
    public URLConnection connect(IRuntimeContext runtime, URL u, String id)
        throws IOException
    {
        URL resourceURL = loader.getResource(id.substring(1));
        if (resourceURL == null)
            throw new URLPluginException
                ("Resource '"+id+"' not found for URL '"+u+"'");

        return resourceURL.openConnection();
    }

}
