package gov.va.med.hds.cd.url.internal.cdtp;

import java.io.IOException;
import java.net.URL;
import java.net.URLConnection;
import java.net.URLStreamHandler;

import gov.va.med.hds.cd.runtime.IRuntimeContext;
import gov.va.med.hds.cd.url.internal.URLPlugin;

public class Handler extends URLStreamHandler {

    private static IRuntimeContext runtime;
    private static URLPlugin urlPlugin;
    

    public static void install(IRuntimeContext runtimeContext, URLPlugin plugin) {
        // Note: this implementation takes a simplistic approach for now,
        // assuming that there is only one instance of IRuntimeContext and
        // only one instance of URLPlugin in the current JVM.
        //
        // if this assumption becomes invalid in the future, cdtp URLs will
        // need to contain an authority portion which specifies which
        // IRuntimeContext to connect to.

        runtime = runtimeContext;
        urlPlugin = plugin;
    }
    

    protected URLConnection openConnection(URL u) throws IOException {
        return urlPlugin.openConnection(u);
    }

}
