package gov.va.med.hds.cd.url.test;

import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.net.URL;
import java.net.URLConnection;
import java.util.Map;

import gov.va.med.hds.cd.url.internal.CDServletContentProvider;

public class DummyContentProvider extends CDServletContentProvider {

    public DummyContentProvider() {
        super(null);
    }

    protected URLConnection openConnection(
        URL u,
        String id,
        String extraPath,
        Map parameters)
        throws IOException {
            
        return new DummyURLConnection(u);
    }


    private class DummyURLConnection extends URLConnection {
        
        private InputStream content;
        
        public DummyURLConnection(URL u) {
            super(u);
            content = new ByteArrayInputStream(u.toString().getBytes());               
        }
        
        public void connect() { }
        
        public InputStream getInputStream() {
            return content;
        }
    }

}
