package gov.va.med.hds.cd.url;

import java.io.IOException;

/**
 * When plugins encounter a problem with the handling of a URL, they may choose
 * to throw an exception.  For compatibility with the java URL handling
 * framework, that exception must be a subclass of IOException. Although
 * plugins are free to throw any IOException, if they choose to define a custom
 * exception class they are encouraged to extend this class, to uniquely
 * identify exceptions arising from URLPlugin functionality.
 */
public class URLPluginException extends IOException {

    public URLPluginException() {
        super();
    }

    /**
     * @see java.lang.Throwable#Throwable(String)
     */
    public URLPluginException(String message) {
        super(message);
    }
    
}
