package gov.va.med.hds.util.dao;

import gov.va.med.hds.cd.daoregistry.IDataAccessObject;

/**
 * Data Access Object abstraction to get site specific information 
 */
public interface ISiteDAO extends IDataAccessObject{
	/**
	 * Gets the site's division name
	 * @return
	 * @throws SiteInfoRequestException
	 */
	String getDivisionName() throws SiteInfoRequestException;
	/**
	 * Gets the site's primary station ID
	 * @return
	 * @throws SiteInfoRequestException
	 */
    String getPrimaryStationID() throws SiteInfoRequestException;
    /**
     * Gets the site's integration name
     * @return
     * @throws SiteInfoRequestException
     */
	String getIntegrationName() throws SiteInfoRequestException;
}
