package gov.va.med.hds.util.m.test;

import gov.va.med.hds.cd.runtime.internal.Runtime;
import gov.va.med.hds.cd.runtime.itest.IntegrationTestRuntimeContextHolder;
import gov.va.med.hds.cd.runtime.test.TestRuntime;
import gov.va.med.hds.cd.security.ConnectionFailedException;
import gov.va.med.hds.cd.security.ISecurity;
import junit.extensions.TestSetup;
import junit.framework.Test;
import junit.framework.TestSuite;

/**
 * @author VHAISLMONSOS
 *
 * Feb 28, 2003 2:17:14 PM
 */
public class AllTests {
	private static ISecurity securityPlugin = null;

	public static void main(String[] args) {
		junit.textui.TestRunner.run(AllTests.class);
	}

	public static Test suite() {
		TestSuite suite = new TestSuite("Test for gov.va.med.hds.util.m.test");
		//$JUnit-BEGIN$
		suite.addTest(new TestSuite(SiteDAOTest.class));
		suite.addTest(new TestSuite(ServerDateDAOTest.class));
		//$JUnit-END$

		TestSetup wrapper = new TestSetup(suite) {
			protected void setUp()
				throws Exception, ConnectionFailedException {
				oneTimeSetUp();
			}
			protected void tearDown() throws Exception, SecurityException {
				oneTimeTearDown();
			}
		};

		return wrapper;
	}
	
	public static void oneTimeSetUp() throws Exception, ConnectionFailedException {
		TestRuntime runtime = new TestRuntime();
		runtime.readPluginDescriptors(
			AllTests.class.getResourceAsStream("registry.xml"));
		runtime.readSettings(
			AllTests.class.getResourceAsStream("CacheSettings.xml"));
//		runtime.readSettings(
//			AllTests.class.getResourceAsStream("RecordSettings.xml"));
		IntegrationTestRuntimeContextHolder.setInstance(runtime);
		securityPlugin = (ISecurity) runtime.getPluginInstance(ISecurity.PLUGIN_ID);
		securityPlugin.login();
	}
	
	public static void oneTimeTearDown() throws SecurityException, Exception {
		securityPlugin.logout();
		((Runtime) IntegrationTestRuntimeContextHolder.getInstance())
			.shutdown();
	}
}
