package gov.va.med.hds.util.m;

import gov.va.med.hds.cd.m.IMumps;
import gov.va.med.hds.cd.m.IMumpsFactory;
import gov.va.med.hds.cd.runtime.IConfigurationElement;
import gov.va.med.hds.cd.runtime.IPluginDescriptor;
import gov.va.med.hds.cd.runtime.IRuntimeContext;
import gov.va.med.hds.util.dao.IServerDateDAO;
import gov.va.med.hds.util.dao.UtilDaoException;
import gov.va.med.hds.util.mumps.StringUtil;

import java.util.Date;
import java.util.LinkedList;
import java.util.List;

/**
 * @author vhaislmonsos
 *
 * Feb 18, 2003 1:40:00 PM
 */
public class ServerDateDAO implements IServerDateDAO {
	private static final String DATE_TIME_RPC_KEY = "DT";
	private IMumps mumps;
	private final List parms = new LinkedList();

	/**
	 * Constructor for MServerDateDAO.
	 */
	public ServerDateDAO() {
		super();
		parms.add("NOW");
	}

	/**
	 * @see gov.va.med.hds.server.IDateTimeSupplier#getDateTime()
	 */
	public Date getDate() throws UtilDaoException {
		Date date = null;
		String result = null;
		try {
			result = mumps.callRPC(DATE_TIME_RPC_KEY,parms);
		}
		catch (Exception e) {
			throw new Error(e);
		}
		if ((result!=null) && (result.length()>0)) {
			date = StringUtil.fmDateToDate(result);
		}
		return date;
	}
	/* (non-Javadoc)
	 * @see gov.va.med.hds.cd.runtime.IExecutableExtension#setInitializationData(gov.va.med.hds.cd.runtime.IRuntimeContext, gov.va.med.hds.cd.runtime.IConfigurationElement, java.lang.String)
	 */
	public void setInitializationData(IRuntimeContext runtime, IConfigurationElement config, String propertyName, Object data) throws Exception {
		IPluginDescriptor desc = runtime.getPluginRegistry().getPluginDescriptor(IUtilMConstants.PLUGIN_ID);
		mumps = ((IMumpsFactory) runtime.getPluginInstance(IMumpsFactory.PLUGIN_ID)).create(desc);
	}
}
