package gov.va.med.hds.util.test;
import gov.va.med.hds.util.collections.Fifo;
import gov.va.med.hds.util.collections.FifoException;
import gov.va.med.hds.util.collections.IFifo;

import junit.framework.TestCase;
public class FifoTest extends TestCase {
	public FifoTest(String arg0) {
		super(arg0);
	}
	protected void setUp() throws Exception {
		super.setUp();
	}
	public void testSingleAdd() throws FifoException {
		IFifo fifo= new Fifo(5);
		fifo.add("Some string");
		assertEquals(1, fifo.getCount());
		assertEquals("Some string", (String) fifo.pop());
		assertEquals(0, fifo.getCount());
	}
	public void testMultipleTypeAdds() throws FifoException {
		IFifo fifo= new Fifo(5);
		fifo.add(new Integer(1));
		fifo.add("two");
		fifo.add(new Long(3));
		fifo.add(new Float(4.0));
		fifo.add("five");
		assertEquals(new Integer(1), (Integer) fifo.pop());
		assertEquals("two", fifo.pop());
		assertEquals(new Long(3), (Long) fifo.pop());
		assertEquals(new Float(4.0), (Float) fifo.pop());
		assertEquals("five", fifo.pop());
	}
	public void testAddException() throws FifoException {
		IFifo fifo= new Fifo(1);
		fifo.add("first");
		try {
			fifo.add("second");
			fail("second add should have failed");
		} catch (FifoException e) {}
	}
	public void testPopException() throws FifoException {
		IFifo fifo= new Fifo(3);
		Object o;
		try {
			o= fifo.pop();
			fail("pop on empty Fifo should have failed");
		} catch (FifoException e) {}
		fifo.add("first");
		fifo.add("second");
		fifo.add("third");
		fifo.pop();
		fifo.pop();
		fifo.pop();
		try {
			fifo.pop();
			fail("fourth pop should have failed");
		} catch (FifoException e) {}
	}
	public void testFifoScroll() throws FifoException {
		IFifo fifo= new Fifo(3);
		fifo.add("first");
		fifo.add("second");
		fifo.add("third");
		assertEquals("first", fifo.pop());
		fifo.add("fourth");
		assertEquals("second", fifo.pop());
		fifo.add("fifth");
		assertEquals("third", fifo.pop());
		fifo.add("sixth");
		assertEquals("fourth", fifo.pop());
		assertEquals("fifth", fifo.pop());
		assertEquals("sixth", fifo.pop());
		try {
			fifo.pop();
			fail("last pop should have failed");
		} catch (FifoException e) {}
	}
	protected void tearDown() throws Exception {
		super.tearDown();
	}
}
