package gov.va.med.hds.util.test;

import gov.va.med.hds.util.collections.ListUtil;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

import javax.swing.JPanel;

import junit.framework.TestCase;

/**
 * @author vhaislmonsos
 *
 * Dec 13, 2002 3:46:35 PM
 */
public class ListUtilTest extends TestCase {

	/**
	 * Constructor for ListUtilTest.
	 * @param arg0
	 */
	public ListUtilTest(String arg0) {
		super(arg0);
	}

	public static void main(String[] args) {
		junit.textui.TestRunner.run(ListUtilTest.class);
	}

	public void testCopy() {
		List l1 = new ArrayList();
		List l2 = new ArrayList();
		
		for (int i=0; i<10000; i++) {
			l1.add(new String(Integer.toString(i)));
			l2.add(new String(Integer.toString(-i)));
		}
		JPanel fred = new JPanel();
		fred.setToolTipText("High Their");
		l1.add(fred);
		for (int i=0; i<100; i++) {
			l2.add(new String(Integer.toString(i)));
		}
		
		ListUtil.copy(l1,l2);
		assertEquals("ListUtil.copy failed:",10001,l2.size());
		Iterator it = l2.iterator();
		int i=0;
		while (it.hasNext()) {
			String item = (String)it.next();
			assertEquals("ListUtil.copy failed:",i++,Integer.parseInt(item));
			if (i==10000) {break;}
		}
		assertEquals("ListUtil.copy failed:","High Their",((JPanel)it.next()).getToolTipText());
		
		l2 = new LinkedList();
		ListUtil.copy(l1,l2);
		assertEquals("ListUtil.copy failed:",10001,l2.size());
		it = l2.iterator();
		i=0;
		while (it.hasNext()) {
			String item = (String)it.next();
			assertEquals("ListUtil.copy failed:",i++,Integer.parseInt(item));
			if (i==10000) {break;}
		}
		assertEquals("ListUtil.copy failed:","High Their",((JPanel)it.next()).getToolTipText());
		
	}
	
	public void testCompareStrings() {
		List l1 = new ArrayList();
		List l2 = new ArrayList();
		
		for (int i=0; i<10000; i++) {
			l1.add(new String(Integer.toString(i)));
			l2.add(new String(Integer.toString(-i)));
		}
		String fred = new String("Hello");
		l2.add(fred);
		assertFalse("ListUtil.compareStrings failed: expected false comparison.",ListUtil.equals(l1,l2));
		l2.remove(fred);
		assertFalse("ListUtil.compareStrings failed: expected false comparison.",ListUtil.equals(l1,l2));
		ListUtil.copy(l2,l1);
		assertTrue("ListUtil.compareStrings failed: expected true comparison.",ListUtil.equals(l1,l2));
		assertTrue("ListUtil.compareStrings failed: expected true comparison.",ListUtil.equals(l2,l1));
		assertTrue("ListUtil.compareStrings failed: expected true comparison.",ListUtil.equals(l1,l1));
	}
}
