package gov.va.med.hds.util.test;

import gov.va.med.hds.util.mumps.NameValuePair;

import junit.framework.TestCase;

/**
 * @author vhaislmonsos
 *
 * Nov 7, 2002 5:54:52 PM
 */
public class NameValuePairTest extends TestCase {

	private String inv1 = "This is a string without a left or right part";
	private String inv2 = "= that";
	private String inv3 = "=that";
	private String valid1 = "this=that";
	private String valid2 = "this = that";
	private String valid3 = "thisone=";
	private String valid4 = "a=b";
	private int count = 0;
	/**
	 * Constructor for NameValuePairTest.
	 * @param arg0
	 */
	public NameValuePairTest(String arg0) {
		super(arg0);
	}

	public static void main(String[] args) {
		junit.textui.TestRunner.run(NameValuePairTest.class);
	}

	public void testGetNameValuePairInvalid() {
		NameValuePair pair = new NameValuePair(inv1);
		assertNotNull("NameValuePair constructor failed.",pair);
		
		assertNotNull("StringUtil.getRight failed: should return a non-null value.",pair.getRight());
		assertNotNull("StringUtil.getLeft failed: should return a non-null name.",pair.getLeft());
		
		count = 0;
		try {
			pair = new NameValuePair(null);
		}
		catch (NullPointerException e) {
			count++;
		}
		catch (Exception e) {
			fail("StringUtil: Unexpected exception thrown:" + e.getMessage());
		}
		assertEquals("StringUtil: NullPointerException not thrown:",1,count);
		
	}
	
	public void testGetLeft() {
		NameValuePair pair = new NameValuePair(inv1);
		assertEquals("StringUtil.getLeft failed:","This is a string without a left or right part",pair.getLeft());
		pair = null;
		
		count = 0;
		try {
			pair = new NameValuePair(inv2);
		} 
		catch (IllegalArgumentException e) {
			count++;
		}
		catch (Exception e) {
			fail("StringUtil.getLeft: Unexpected exception thrown:" + e.getMessage());
		}
		finally {
			assertNull("StringUtil should by null.",pair);
		}
		assertEquals("StringUtil: IllegalArgumentException not thrown:",1,count);
		
		count = 0;
		try {
			pair = new NameValuePair(inv3);
		} 
		catch (IllegalArgumentException e) {
			count++;
		}
		catch (Exception e) {
			fail("StringUtil.getLeft: Unexpected exception thrown:" + e.getMessage());
		}
		finally {
			assertNull("StringUtil should by null.",pair);
		}
		assertEquals("StringUtil: IllegalArgumentException not thrown:",1,count);
		
		pair = new NameValuePair(valid1);
		assertEquals("StringUtil.getLeft failed:","this",pair.getLeft());
		
		pair = new NameValuePair(valid2);
		assertEquals("StringUtil.getLeft failed:","this ",pair.getLeft());
		
		pair = new NameValuePair(valid3);
		assertEquals("StringUtil.getLeft failed:","thisone",pair.getLeft());
		
		pair = new NameValuePair(valid4);
		assertEquals("StringUtil.getLeft failed:","a",pair.getLeft());
	}
	
	public void testGetRight() {
		NameValuePair pair = new NameValuePair(inv1);
		assertEquals("StringUtil.getRight failed:","",pair.getRight());
		pair = null;
		
		pair = new NameValuePair(valid1);
		assertEquals("StringUtil.getRight failed:","that",pair.getRight());
		
		pair = new NameValuePair(valid2);
		assertEquals("StringUtil.getRight failed:"," that",pair.getRight());

		pair = new NameValuePair(valid3);
		assertEquals("StringUtil.getRight failed:","",pair.getRight());
		
		pair = new NameValuePair(valid4);
		assertEquals("StringUtil.getRight failed:","b",pair.getRight());
	}
}
