package gov.va.med.hds.util.test;

import gov.va.med.hds.util.os.OSUtils;

import java.awt.Frame;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import javax.swing.JFrame;

import junit.framework.TestCase;

/**
 * 
 */
public class OSUtilsTest extends TestCase {

// JMTODO add native methods to determine if a window is STAYONTOP, or is the foreground
// window, so that these unit tests can be completed.
    //	public void testSetForegroundWindow() {
    //		try {
    //			OSUtils.setForegroundWindow(7080262);
    //		} catch(UnsatisfiedLinkError e) {
    //		}
    //    }

    //	public void testStayOnTop() {
    //		try {
    //			JOptionPane.showMessageDialog(null, "About to stay on top");
    //			long handle = 1050116;
    //			OSUtils.setStayOnTop(handle, true);
    //			JOptionPane.showMessageDialog(null, "About to stop staying on top");
    //			OSUtils.setStayOnTop(handle, false);
    //			JOptionPane.showMessageDialog(null, "About to restore and stay on top");
    //			OSUtils.displayAndStayOnTop(handle);
    //			JOptionPane.showMessageDialog(null, "About to stop staying on top");
    //			OSUtils.setStayOnTop(handle, false);
    //		} catch(UnsatisfiedLinkError e) {
    //		}
    //    }

    public void testOSWindowTests() {
        try {
            JFrame frame = new JFrame("Whatever");
            try {
                long handle = OSUtils.getWindowHandle(frame);
                assertEquals(0, handle);
                frame.show();
                handle = OSUtils.getWindowHandle(frame);
                assertTrue(handle != 0);

                frame.setExtendedState(Frame.ICONIFIED);
                assertTrue((frame.getExtendedState() & Frame.ICONIFIED) == Frame.ICONIFIED);
                OSUtils.restoreWindowIfMinimized(handle);
                assertFalse((frame.getExtendedState() & Frame.ICONIFIED) == Frame.ICONIFIED);
                frame.setExtendedState(Frame.ICONIFIED);
                assertTrue((frame.getExtendedState() & Frame.ICONIFIED) == Frame.ICONIFIED);
                OSUtils.setAndRestoreForegroundWindow(handle);
                assertFalse((frame.getExtendedState() & Frame.ICONIFIED) == Frame.ICONIFIED);

            } finally {
                frame.dispose();
            }
        } catch (UnsatisfiedLinkError e) {
        }
    }

    //********************
    //*** end of tests ***
    //********************

    public OSUtilsTest(String name) {
        super(name);
    }

    protected void setUp() throws Exception {
        super.setUp();
    }

    protected void tearDown() throws Exception {
        super.tearDown();
    }
    private static final int NONE = 0;
    private static final int ICONIFIED = 1;
    private static final int DEICONIFIED = 2;
    private static final int ACTIVATED = 3;
    private static final int DEACTIVATED = 4;

    private int lastCode = NONE;
    private WindowEvent lastEvent = null;

    public void windowEvent(int code, WindowEvent e) {
        lastEvent = e;
        lastCode = code;
    }
}
