package gov.va.med.hds.util;
/**
 * Should be implemented if an object uses resources that 
 * must excplicitely be destroyed. Examples of such resources
 * are COM connections and database connections.
 */
public interface IDisposable {
	
	/**
	 * Disposes of any resources that are not guaranteed
	 * to be disposed of by the garbage collector.
	 * @throws DisposeException
	 */
	void dispose() throws DisposeException;
}
