package gov.va.med.hds.util.collections;
/**
 * Provides a basic abstration of a first-in-first-out queue or FIFO.
 */
public interface IFifo {	/**
	 * Adds an object to the queue
	 * @param o
	 */
	void add(Object o) throws FifoException;

	/**
	 * Pops the least recently added object off the queue
	 * @return Object
	 * @throws FifoException
	 */
	Object pop() throws FifoException;

	/**
	 * The count of objects on the queue
	 * @return long
	 */
	long getCount();
}
