/*
 * Created on May 7, 2003
 *
 * To change this generated comment go to 
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package gov.va.med.hds.util.date;

import java.text.DateFormat;
import java.text.ParsePosition;
import java.text.SimpleDateFormat;
import java.util.Date;

/**
 * @author vhaisltumad
 *
 * To change this generated comment go to 
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
public class FlexibleDateFormat extends SimpleDateFormat {
    
    private static final String DEFAULT_FORMAT = "MMM dd, yyyy";
    private DateFormat[] extraFormats;

    public FlexibleDateFormat() {
        this(DEFAULT_FORMAT);
        
        // use strict parsing by default
        setLenient(false);
    }

    public FlexibleDateFormat(String pattern) {
        super(pattern);
        
        extraFormats = new DateFormat[4];
        extraFormats[0] = DateFormat.getDateInstance(DateFormat.LONG);
        extraFormats[1] = DateFormat.getDateInstance(DateFormat.MEDIUM);
        extraFormats[2] = DateFormat.getDateInstance(DateFormat.SHORT);
        extraFormats[3] = DateFormat.getDateInstance(DateFormat.FULL);
    }
    
    
    public Date parse(String text, ParsePosition pos) {
        Date result = super.parse(text, pos);
        if (result != null) return result;
        
        for (int i = 0;   i < extraFormats.length;   i++) {
            result = extraFormats[i].parse(text, pos);     
            if (result != null) return result;
        }
        
        return null;
    }
    

	public void setLenient(boolean lenient) {
		super.setLenient(lenient);
        for (int i = 0; i < extraFormats.length; i++) {
			extraFormats[i].setLenient(lenient);
		}
	}

}
