/*
 * Created on Apr 9, 2003 1:13:00 PM
 */
package gov.va.med.hds.util.date;

import java.text.DecimalFormat;
import java.text.FieldPosition;
import java.text.ParsePosition;

/**
 *
 * @author David Tuma
 *
 **/
public class RelativeDateFormat extends DecimalFormat {
	private DecimalFormat plainNumber = new DecimalFormat();
	public RelativeDateFormat() {
		super("'T+'#;'T'-#");
	}
	public StringBuffer format(double number,
							   StringBuffer toAppendTo,
							   FieldPosition pos) {
		if (number == 0) {
			pos.setBeginIndex(0);
			pos.setEndIndex(1);
			return toAppendTo.append("T");
		} else
			return super.format(number, toAppendTo, pos);
	}
	public StringBuffer format(long number,
							   StringBuffer toAppendTo,
							   FieldPosition pos) {
		if (number == 0) {
			pos.setBeginIndex(0);
			pos.setEndIndex(1);
			return toAppendTo.append("T");
		} else
			return super.format(number, toAppendTo, pos);
	}

	public Number parse(String val, ParsePosition parsePosition) {
		int start = parsePosition.getIndex();
		val = val.toUpperCase();
		String cmp = val.substring(start);
		if ("T".equals(cmp) || "NOW".equalsIgnoreCase(cmp)) {
			parsePosition.setIndex(start+1);
			return new Integer(0);
		}
		if (cmp.length() == 0) return null;
		if (cmp.charAt(0) != 'T')
			return plainNumber.parse(val, parsePosition);

		return super.parse(val, parsePosition);
	}

}
