package gov.va.med.hds.util.io;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.net.URL;

public class FileUtilities {

	public static void copy(File from, File to) throws CopyFailedException {
		FileInputStream fis;
		try {
			fis = new FileInputStream(from);
		} catch (Exception e) {
			throw new CopyFailedException(e);
		}
		internalCopy(fis, to);
	}

	public static void copy(URL from, File to) throws CopyFailedException {
		InputStream fis;
		try {
			fis = from.openConnection().getInputStream();
		} catch (Exception e) {
			throw new CopyFailedException(e);
		}
		internalCopy(fis, to);
	}

	public static void internalCopy(InputStream fis, File to)
		throws CopyFailedException {
		try {
			FileOutputStream fos = new FileOutputStream(to);
			try {
				byte[] buf = new byte[1024];
				int i = 0;
				while ((i = fis.read(buf)) != -1) {
					fos.write(buf, 0, i);
				}
			} finally {
				fos.close();
				fis.close();
			}
		} catch (Exception e) {
			throw new CopyFailedException(e);
		}
	}

	public static String getFileExtension(File file) {
		if (file != null) {
			String filename = file.getName();
			int i = filename.lastIndexOf('.');
			if (i > 0 && i < filename.length() - 1) {
				return filename.substring(i + 1).toLowerCase();
			};
		}
		return null;
	}
}
