/*
 * Created on Jun 9, 2003
 *
 * To change this generated comment go to 
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package gov.va.med.hds.util.io;

import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import java.net.URLEncoder;
import java.util.Collections;
import java.util.HashMap;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.StringTokenizer;

/**
 * @author vhaisltumad
 *
 * To change this generated comment go to 
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
public class HTMLUtil {

	public static final String urlEncode(String s) {
		try {
			return URLEncoder.encode(s, "UTF-8");
		} catch (UnsupportedEncodingException e) {
			// "can't happen" - UTF-8 is guaranteed to be supported on all
			// Java platforms
			return null;
		}
	}

	public static final String urlDecode(String s) throws IOException {
		try {
			return URLDecoder.decode(s, "UTF-8");
		} catch (UnsupportedEncodingException e) {
			// "can't happen" - UTF-8 is guaranteed to be supported on all
			// Java platforms
			return null;
		} catch (IllegalArgumentException iae) {
			throw new IOException(
				"Not a valid url-encoded string: '" + s + "'");
		}
	}

	public static Map parseQueryParameters(String query) throws IOException {
		if (query == null || query.length() == 0)
			return Collections.EMPTY_MAP;

		Map parameters = new HashMap();
		Map lists = new HashMap();
		StringTokenizer params = new StringTokenizer(query, "&");
		String param, name, val;
		int equalsPos;
		while (params.hasMoreTokens()) {
			param = params.nextToken();
			equalsPos = param.indexOf('=');
			if (equalsPos == 0 || param.length() == 0)
				continue;
			else
				try {
                    if (equalsPos == -1) {
                        // no equals?  infer the value 'true'
                        name = urlDecode(param);
                        val = "true";
                    } else {
    					// parse the name and the value
    					name = urlDecode(param.substring(0, equalsPos));
    					val = urlDecode(param.substring(equalsPos + 1));
                    }

					// save the name/value pair into the result map
					if (!parameters.containsKey(name))
						parameters.put(name, val);

					// add the value to a list in the list map
					List l = (List) lists.get(name);
					if (l == null)
						lists.put(name, l = new LinkedList());
					l.add(val);
				} catch (IOException ioe) {
					throw ioe;
				} catch (Exception e) {
					throw new IOException(
						"Invalid query parameter string '" + query + "'");
				}
		}

		// convert each list to a String array, and add that array to the
		// result map with a special name.
		Iterator i = lists.entrySet().iterator();
		Map.Entry e;
		String[] stringArray = new String[0];
		while (i.hasNext()) {
			e = (Map.Entry) i.next();
			name = (String) e.getKey();
			parameters.put(
				name + "[]",
				((List) e.getValue()).toArray(stringArray));
		}

		return parameters;
	}

	private static final String XML_CHARS = "'<>&\"";
	private static final String HTML_CHARS = XML_CHARS.substring(1);

    /** Escape HTML and/or XML entities in a String.
     * 
     * @param value the <code>String</code> value to escape.
     * @param xml <code>true</code> to generate XML-compliant output,
     * <code>false</code> to generate output suitable for HTML.
     * @return String an escaped version of the original value.
     */
	public static String escapeEntities(String value, boolean xml) {
		String delim = (xml ? XML_CHARS : HTML_CHARS);
		StringTokenizer tok = new StringTokenizer(value, delim, true);
		StringBuffer result = new StringBuffer();
		String token;
		while (tok.hasMoreTokens()) {
			token = tok.nextToken();
			if ("<".equals(token))
				result.append("&lt;");
			else if (">".equals(token))
				result.append("&gt;");
			else if ("&".equals(token))
				result.append("&amp;");
			else if ("\"".equals(token))
				result.append("&quot;");
			else if ("'".equals(token))
				result.append("&apos;");
			else
				result.append(token);
		}
		return result.toString();
	}

}
