package gov.va.med.hds.util.io;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.InputStream;

/**
 * @author vhaislmerrij
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public class StreamUtilities {

	private static int defaultBufSize = 1024;

	public static byte[] convertStreamToByteArray(InputStream in)
		throws IOException {
		return convertStreamToByteArray(in, false, defaultBufSize);
	}

	public static byte[] convertStreamToByteArray(
		InputStream in,
		boolean close)
		throws IOException {
		
		return convertStreamToByteArray(in, close, defaultBufSize);
	}

	public static byte[] convertStreamToByteArray(
		InputStream in,
		boolean close,
		int bufSize)
		throws IOException {
		
		byte[] result = null;
		ByteArrayOutputStream slurpBuffer = new ByteArrayOutputStream();
		byte[] buffer = new byte[bufSize];
		int bytesRead;
		while ((bytesRead = in.read(buffer)) != -1)
			slurpBuffer.write(buffer, 0, bytesRead);
		result = slurpBuffer.toByteArray();
		if (close)
			try {
				in.close();
			} catch (IOException ioe) {}
		return result;
	}
}
