package gov.va.med.hds.util.mumps;

import java.util.Arrays;

/**
 * @author vhaislmonsos
 *
 * Dec 17, 2002 10:40:23 AM
 */
public class ArrayUtil {

	/**
	 * Sorts the input array by the 2nd piece of the string.  For example, if the
	 * array is a list of strings like
	 * 		1^zebra
	 * 		2^lion
	 * 		3^bear
	 * 		4^tiger
	 * 
	 * It sorts the array on the second piece so the resulting values are like
	 * 		3^bear
	 * 		2^lion
	 * 		4^tiger
	 * 		1^zebra
	 * 
	 * @param inputArray
	 * @param separator
	 */
	public static void sortNameValueStrings(String[] inputArray, char separator) {
		String[] result = new String[inputArray.length];
		for (int i=0; i<inputArray.length; i++) {
			result[i] = StringUtil.piece(inputArray[i],separator,2) + separator + StringUtil.piece(inputArray[i],separator,1);
		}
		Arrays.sort(result);
		for (int i=0; i<result.length; i++) {
			inputArray[i] = StringUtil.piece(result[i],separator,2) + separator + StringUtil.piece(result[i],separator,1);
		}
		
	}
}
