package gov.va.med.hds.util.mumps;

/**
 * @author vhaislmonsos
 *
 * Nov 7, 2002 5:30:53 PM
 */
public class NameValuePair {

	private String left = null;
	private String right = null;
	/**
	 * Constructor for NameValuePair.
	 */
	private NameValuePair() {
		super();
	}

	public NameValuePair(String input) throws IllegalArgumentException, NullPointerException {
		if (input==null) {
			throw new NullPointerException("Null name/value pair.");
		}
		left = StringUtil.piece(input, '=', 1);
		if (left.length()<1) {
			throw new IllegalArgumentException("Invalid name/value pair value:" + input);
		}
		if (input.length() > left.length()) {
			right = input.substring(left.length() + 1);
		}
		else {
			right = "";
		}
	}
	
	/**
	 * Returns the left.
	 * @return String
	 */
	public String getLeft() {
		return left;
	}

	/**
	 * Returns the right.
	 * @return String
	 */
	public String getRight() {
		return right;
	}

}
