package gov.va.med.hds.util.swingworker.example.bigeg;

import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import java.io.File;

import javax.swing.JFrame;
import javax.swing.SwingUtilities;
import javax.swing.UIManager;

public class ThreadsExample {

    /**
     * This is strictly boilerplate: set the look and feel, configure the
     * frame, pack(), show().
     */
    public static void main(String[] args) {
        String laf = UIManager.getCrossPlatformLookAndFeelClassName();
        try {
            UIManager.setLookAndFeel(laf);
        }
        catch (Exception e) {
            e.printStackTrace();
            System.exit(1);
        }
        JFrame f = new JFrame("Worker Thread Examples");
        WindowListener l = new WindowAdapter() {
            public void windowClosing(WindowEvent e) {System.exit(0);}
        };
        f.addWindowListener(l); 
        //URI uri = ThreadsExample.class.getResource("/gov/va/med/hds/common/swingworker/internal/example/bigeg");
        final ExampleContainer c = new ExampleContainer(
                new File("Example1.java"));
        f.getContentPane().add(c);
        f.pack();
        f.show();
        SwingUtilities.invokeLater(new Runnable() {
            public void run() {
                c.setFocus();  //can't do this until now
            }
        });
    }

}
