package gov.va.med.hds.cd.workspace;


public class EventRegistrar {

	public static void connectSources(
		IMulticaster m,
		Object source,
		SourceOfEventDescriptor[] events)
		throws ClassNotFoundException, InvalidEventSourceException {
		for (int i = 0; i < events.length; i++) {
			String eventClassName = events[i].getEventClassName();
			Class eventClass =
				source.getClass().getClassLoader().loadClass(eventClassName);
			m.addSource(eventClass, source);
		}
	}

	public static void connectListeners(
		IMulticaster m,
		Object listener,
		ListenerOfEventDescriptor[] events)
		throws ClassNotFoundException, InvalidEventListenerException {
		for (int i = 0; i < events.length; i++) {
			String eventClassName = events[i].getEventClassName();
			Class eventClass =
				listener.getClass().getClassLoader().loadClass(eventClassName);
			m.addListener(eventClass, listener);
		}
	}

	public static void disconnectListeners(
		IMulticaster m,
		Object listener,
		ListenerOfEventDescriptor[] events) throws ClassNotFoundException {
		for (int i = 0; i < events.length; i++) {
			String eventClassName = events[i].getEventClassName();
			Class eventClass =
				listener.getClass().getClassLoader().loadClass(eventClassName);
			m.removeListener(eventClass, listener);
		}
	}

	public static void disconnectSources(
		IMulticaster m,
		Object source,
		SourceOfEventDescriptor[] events) throws ClassNotFoundException {
			for (int i = 0; i < events.length; i++) {
				String eventClassName = events[i].getEventClassName();
				Class eventClass =
					source.getClass().getClassLoader().loadClass(eventClassName);
				m.removeSource(eventClass, source);
			}
	}
}
