package gov.va.med.hds.cd.workspace.internal;

import java.util.LinkedList;
import java.util.List;

import gov.va.med.hds.cd.runtime.IConfigurationElement;
import gov.va.med.hds.cd.workspace.IWorkspaceConstants;
import gov.va.med.hds.cd.workspace.ListenerOfEventDescriptor;
import gov.va.med.hds.cd.workspace.SourceOfEventDescriptor;


public class ModelDescriptor implements IWorkspaceConstants, IModelDescriptor {
	
	private IConfigurationElement element;
	private List sourcesOf = new LinkedList();
	private List listenersOf = new LinkedList();
	
	public ModelDescriptor(IConfigurationElement element) {
		this.element = element;
	}

	public String getId() {
		return element.getAttribute(ID_ATTRIBUTE);
	}

	public String getScope() {
		return element.getAttribute(SCOPE_ATTRIBUTE);
	}

	public String getClassName() {
		return element.getAttribute(CLASS_ATTRIBUTE);
	}

	public void addSourceOfEvent(String eventClassName) {
		sourcesOf.add(new SourceOfEventDescriptor(eventClassName));
	}

	public void addListenerOfEvent(String eventClassName) {
		listenersOf.add(new ListenerOfEventDescriptor(eventClassName));
	}

	public SourceOfEventDescriptor[] getSourceOfEventDescriptors() {
		return (SourceOfEventDescriptor[]) sourcesOf.toArray(new SourceOfEventDescriptor[sourcesOf.size()]);
	}

	public ListenerOfEventDescriptor[] getListenerOfEventDescriptors() {
		return (ListenerOfEventDescriptor[]) listenersOf.toArray(new ListenerOfEventDescriptor[listenersOf.size()]);
	}

	public Object createModel() throws Exception {
		return element.createExecutableExtension(CLASS_ATTRIBUTE);
	}
}
