package gov.va.med.hds.cd.workspace.internal;

import java.util.HashMap;
import java.util.Map;

import gov.va.med.hds.cd.runtime.logging.ILogger;
import gov.va.med.hds.cd.runtime.logging.ILoggingCapable;
import gov.va.med.hds.cd.workspace.IModelSpace;
import gov.va.med.hds.cd.workspace.IWorkspaceScope;

public class ModelSpace implements IModelSpace {
	
	private Map models = new HashMap();
	private ILogger log;
	private IWorkspaceScope scope;
	
	public ModelSpace(ILoggingCapable logging, WorkspaceScope scope) {
		this.log = logging.getLogger(getClass());
		this.scope = scope;
	}

	public IWorkspaceScope getScope() {
		return scope;
	}

	public Object getModel(String id) {
		return models.get(id);
	}

	public void putModel(String id, Object model) {
		models.put(id, model);
	}

	public boolean containsModel(String id) {
		return models.containsKey(id);
	}

}
