package gov.va.med.hds.cd.workspace.internal;

import gov.va.med.hds.cd.runtime.logging.ILoggingCapable;
import gov.va.med.hds.cd.workspace.IModelSpace;
import gov.va.med.hds.cd.workspace.IMulticaster;
import gov.va.med.hds.cd.workspace.IWorkspaceScope;

public class WorkspaceScope implements IWorkspaceScope {

	private String id;
	private IMulticaster caster;
	private IModelSpace modelSpace;

	public WorkspaceScope(ILoggingCapable logging, String id) {
		this.id = id;
		this.caster = new Multicaster(logging, this);
		this.modelSpace = new ModelSpace(logging, this);
	}

	public String getId() {
		return id;
	}

	public IMulticaster getMulticaster() {
		return caster;
	}

	public IModelSpace getModelSpace() {
		return modelSpace;
	}
}
