package junit.extensions.jfcunit;

/**
 * Used to report exit status of classes which call System.exit().
 *
 * @author <a href="mailto:vraravam@thoughtworks.com">Vijay Aravamudhan : ThoughtWorks Inc.</a>
 */
public class ExitException extends SecurityException {
    /**
     * Status code 
     */
    private int status;

    /**
     * Constructs an exit exception.
     *
     * @param status the status code returned via System.exit()
     */
    public ExitException(int status) {
        super("ExitException: status " + status);
        this.status = status;
    }

    /**
     * The status code returned by System.exit()
     *
     * @return the status code returned by System.exit()
     */
    public int getStatus() {
        return status;
    }
}