package junit.extensions.jfcunit.xml;
import junit.extensions.xml.XMLConstants;
import junit.extensions.jfcunit.eventdata.EventDataConstants;

/**
 * This class defines the common tokens which are
 * used in parsing the XML file.
 * @author Kevin Wilson
 */
public interface JFCXMLConstants extends XMLConstants, EventDataConstants {

    // TestCase
    /** robot */
    public static final String ROBOT     = "robot";
    /** awtthread */
    public static final String AWTTHREAD = "awtthread";
    /** action */
    public static final String ACTION    = "action";
    /** flush */
    public static final String FLUSH     = "flush";
    /** pause */
    public static final String PAUSE     = "pause";
    /** resume */
    public static final String RESUME    = "resume";
    /** sleep */
    public static final String SLEEP     = "sleep";
    /** duration */
    public static final String DURATION  = "duration";
    /** key */
    public static final String KEY       = "key";
    /** click */
    public static final String CLICK     = "click";
    /** drag */
    public static final String DRAG      = "drag";
    /** debug */
    public static final String DEBUG     = "debug";
    /** recording */
    public static final String RECORDING = "recording";

    /** type */
    public static final String TYPE = "type";

    // Finders
    /** find */
    public static final String FIND = "find";
    /** class */
    public static final String CLASS = "class";
    /** index */
    public static final String INDEX = "index";
    /** label */
    public static final String LABEL = "label";
    /** iconfile */
    public static final String ICONFILE = "iconfile";
    /** icondesc */
    public static final String ICONDESCRIPTION = "icondesc";
    /** caseindependent */
    public static final String CASEINDEPENDENT = "caseindependent";
    /** container */
    public static final String CONTAINER = "container";

    // Common Event Data
    /** sleeptime */
    public static final String SLEEPTIME = "sleeptime";
    /** modifiers */
    public static final String MODIFIERS = "modifiers";
    /** popup */
    public static final String POPUPTRIGGER = "popup";
    /** position */
    public static final String POSITION = "position";
    /** reference */
    public static final String REFERENCE = "reference";
    /** clicks */
    public static final String CLICKS = "clicks";
    /** title */
    public static final String TITLE = "title";

    // JTable, JTableHeader
    /** row */
    public static final String ROW = "row";
    /** column */
    public static final String COLUMN = "column";

    // JTree
    /** node */
    public static final String NODEVALUE = "node";

    // Spinner
    /** sub */
    public static final String SUBCOMPONENT = "sub";
    /** up */
    public static final String UP = "up";
    /** down */
    public static final String DOWN = "down";
    /** editor */
    public static final String EDITOR = "editor";

    // Wheel
    /** amount */
    public static final String AMOUNT = "amount";
    /** rotation */
    public static final String ROTATION = "rotation";

    // String event data
    /** string */
    public static final String STRING = "string";
    /** code */
    public static final String CODE = "code";

    /** finder */
    public static final String FINDER = "finder";

    // Modifiers
    /** button1 */
    public static final String BUTTON1 = "button1";
    /** button2 */
    public static final String BUTTON2 = "button2";
    /** button3 */
    public static final String BUTTON3 = "button3";
    /** meta */
    public static final String META    = "meta";
    /** shift */
    public static final String SHIFT   = "shift";
    /** control */
    public static final String CONTROL = "control";
    /** alt */
    public static final String ALT     = "alt";
    /** altgraph */
    public static final String ALTGR   = "altgraph";

    // Drag
    /** source */
    public static final String SOURCE = "source";
    /** destination */
    public static final String DESTINATION = "destination";
    /** point */
    public static final String POINT = "point";

}