package junit.extensions.xml;

import junit.framework.Test;

/**
 * Test Case Interface for running XML Script based testing.
 *
 * @author Kevin Wilson
 */
public interface IXMLTestCase extends Test {

    /**
     * Set the name for the test case.
     * @param name Name of the test case.
     */
    void setName(String name);

    /**
     * For each test (method) element, the found objects has to be cleared
     */
    void clearFoundObjects();

    /**
     * Add each found object into the cache map.
     *
     * @param name    The name of the found object
     * @param obj     The actual object that was found
     */
    void addFoundObject(String name, Object obj);

    /**
     * Retrieve the object that was found previously.
     *
     * @param name    The name of the object that was found
     * @return    The object to be retrieved
     */
    Object getFoundObject(String name);
}
