package junit.extensions.xml;

import junit.framework.Test;

/**
 * Test Case for running XML Script based testing.
 *
 * @author Kevin Wilson
 */
public interface IXMLTestSuite extends Test, XMLConstants {
    /**
     * Add the test to this suite.
     * @param test test to be added.
     */
    void addTest(Test test);

    /**
     * Returns the filename.
     *
     * @return String   The name of the test xml script file
     */
    String getFileName();

    /**
     * Add the given XML file to the TestSuite.
     *
     * @param  xmlFileName    The name of the test script file to be added.
     * @exception   Exception   can be thrown.
     */
    void addFile(String xmlFileName) throws Exception;
}
