/**
 * Title:        TestPackage
 * Description:  A class putting all tests of this package together.
 * Copyright:    Copyright (c) 2000 Andreas Heilwagen
 *
 *   Permission to reproduce and create derivative works from the Software 
 *   ("Software Derivative Works") is hereby granted to you under the copyrights
 *   of Andreas Heilwagen. Andreas Heilwagen also grant you the right to
 *   distribute the Software and Software Derivative Works.
 *
 *   Andreas Heilwagen licenses the Software to you on an "AS IS" basis, without
 *   warranty of any kind. Andreas Heilwagen HEREBY EXPRESSLY DISCLAIMS ALL
 *   WARRANTIES OR CONDITIONS, EITHER EXPRESS OR IMPLIED, INCLUDING, BUT NOT
 *   LIMITED TO, THE IMPLIED WARRANTIES OR CONDITIONS OF MERCHANTABILITY, NON
 *   INFRINGEMENT AND FITNESS FOR A PARTICULAR PURPOSE. You are solely
 *   responsible for determining the appropriateness of using the Software and
 *   assume all risks associated with the use and distribution of this Software,
 *   including but not limited to the risks of program errors, damage to or loss
 *   of data, programs or equipment, and unavailability or interruption of
 *   operations. ANDREAS HEILWAGEN WILL NOT BE LIABLE FOR ANY DIRECT DAMAGES OR
 *   FOR ANY SPECIAL, INCIDENTAL, OR INDIRECT DAMAGES OR FOR ANY ECONOMIC
 *   CONSEQUENTIAL DAMAGES (INCLUDING LOST PROFITS OR SAVINGS), EVEN IF ANDREAS
 *   HEILWAGEN HAD BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. Andreas 
 *   Heilwagen will not be liable for the loss of, or damage to, your records or
 *   data, or any damages claimed by you based on a third party claim.
 *
 *   You agree to distribute the Software and any Software Derivatives under a
 *   license agreement that: 1) is sufficient to notify all licensees of the
 *   Software and Software Derivatives that Andreas Heilwagen assumes no
 *   liability for any claim that may arise regarding the Software or Software
 *   Derivatives, and 2) that disclaims all warranties, both express and implied,
 *   from Andreas Heilwagen regarding the Software and Software Derivatives. (If
 *   you include this Agreement with any distribution of the Software and
 *   Software Derivatives you will have met this requirement). You agree that you
 *   will not delete any copyright notices in the Software.
 *
 *   This Agreement is the exclusive statement of your rights in the Software
 *   as provided by Andreas Heilwagen. Except for the licenses granted to you in
 *   the second paragraph above, no other licenses are granted hereunder, by
 *   estoppel, implication or otherwise.
 *
 * @author Andreas Heilwagen
 *
 * $Id: TestPackage.java,v 1.2 2001/12/14 11:27:26 aheilwag Exp $
 * 
 * $Log: TestPackage.java,v $
 * Revision 1.2  2001/12/14 11:27:26  aheilwag
 * changes to the JUnit test cases moved to JUnitX and JUnitX now beeing a
 * module on top of JUnit
 *
 * Revision 1.1  2001/12/14 09:30:40  aheilwag
 * moved test cases from junit to junitx
 *
 * Revision 1.2  2000/11/10 19:53:21  aheilwag
 * added cvs tags
 *
 */


package tests.junitx;


import junit.framework.*;
import junitx.framework.*;


/**
 * puts together a suite of test cases
 */

public class TestPackage implements junitx.framework.TestPackage
{
  public static Test suite()
  {
    TestSuite suite = new TestSuite ("JUnitX test suite");

    suite.addTestSuite (tests.junitx.framework.TestTest.class);
    suite.addTestSuite (tests.junitx.framework.TestListenerTest.class);
    suite.addTestSuite (tests.junitx.framework.TestTestCaseClassLoader.class);
//  suite.addTestSuite (tests.junitx.framework.TestExceptions.class);
    suite.addTestSuite (tests.junitx.framework.TestInverter.class);
    suite.addTestSuite (tests.junitx.framework.TestProxiedInverter.class);
    suite.addTestSuite (tests.junitx.framework.TestPrivate.class);
    suite.addTestSuite (tests.junitx.framework.TestSimpleTypes.class);
    suite.addTestSuite (tests.junitx.framework.TestInner.class);
    suite.addTestSuite (tests.junitx.framework.TestTestProxy.class);
    suite.addTestSuite (tests.junitx.framework.suite.TestSuite.class);
    suite.addTestSuite (tests.junitx.extensions.TestExceptionTestCase.class);
    suite.addTestSuite (tests.junitx.extensions.TestExtensions.class);
    suite.addTestSuite (tests.junitx.money.TestMoney.class);

//  shows that tests across threads are not possible yet
//  suite.addTestSuite (tests.junitx.framework.TestThreads.class);

    return suite;
  }
}
