/**
 * Title:        TestSimple
 * Description:  A simple test case example
 * Copyright:    Copyright (c) 2000 Kent Beck and Erich Gamma
 *
 *   Permission to reproduce and create derivative works from the Software 
 *   ("Software Derivative Works") is hereby granted to you under the copyrights
 *   of Kent Beck and Erich Gamma. Kent Beck and Erich Gamma also grant you 
 *   the right to distribute the Software and Software Derivative Works.
 *
 *   Kent Beck and Erich Gamma licenses the Software to you on an "AS IS" basis,
 *   without warranty of any kind. Kent Beck and Erich Gamma HEREBY
 *   EXPRESSLY DISCLAIMS ALL WARRANTIES OR CONDITIONS, EITHER EXPRESS OR
 *   IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OR 
 *   CONDITIONS OF MERCHANTABILITY, NON INFRINGEMENT AND FITNESS FOR A 
 *   PARTICULAR PURPOSE. You are solely responsible for determining the 
 *   appropriateness of using the Software and assume all risks associated with
 *   the use and distribution of this Software, including but not limited to 
 *   the risks of program errors, damage to or loss of data, programs or 
 *   equipment, and unavailability or interruption of operations. KENT BECK AND
 *   ERICH GAMMA WILL NOT BE LIABLE FOR ANY DIRECT DAMAGES OR FOR ANY SPECIAL, 
 *   INCIDENTAL, OR INDIRECT DAMAGES OR FOR ANY ECONOMIC CONSEQUENTIAL DAMAGES 
 *   (INCLUDING LOST PROFITS OR SAVINGS), EVEN IF KENT BECK AND ERICH GAMMA HAD
 *   BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. Kent Beck and Erich Gamma 
 *   will not be liable for the loss of, or damage to, your records or data, or
 *   any damages claimed by you based on a third party claim.
 *
 *   You agree to distribute the Software and any Software Derivatives under a
 *   license agreement that: 1) is sufficient to notify all licensees of the
 *   Software and Software Derivatives that Kent Beck and Erich Gamma assumes
 *   no liability for any claim that may arise regarding the Software or
 *   Software Derivatives, and 2) that disclaims all warranties, both express
 *   and implied, from Kent Beck and Erich Gamma regarding the Software and
 *   Software Derivatives. (If you include this Agreement with any distribution
 *   of the Software and Software Derivatives you will have met this
 *   requirement). You agree that you will not delete any copyright notices in
 *   the Software.
 *
 *   This Agreement is the exclusive statement of your rights in the Software
 *   as provided by Kent Beck and Erich Gamma. Except for the licenses
 *   granted to you in the second paragraph above, no other licenses are granted
 *   hereunder, by estoppel, implication or otherwise.
 *
 * @author Kent Beck
 * @author Erich Gamma
 *
 * $Id: TestSimple.java,v 1.2 2001/12/14 11:27:27 aheilwag Exp $
 * 
 * $Log: TestSimple.java,v $
 * Revision 1.2  2001/12/14 11:27:27  aheilwag
 * changes to the JUnit test cases moved to JUnitX and JUnitX now beeing a
 * module on top of JUnit
 *
 * Revision 1.1  2001/12/14 09:30:40  aheilwag
 * moved test cases from junit to junitx
 *
 * Revision 1.2  2000/11/10 19:58:00  aheilwag
 * added cvs tags
 *
 */


package tests.junitx.samples;


import junit.framework.*;


/**
 * Some simple tests.
 */

public class TestSimple extends TestCase
{
  protected int _value1;
  protected int _value2;


  /**
   * constructor.
   *
   * @param   aName       a test name
   */

  public TestSimple (String aName)
  {
    super (aName);
  }


  /**
   * setup fixture.
   */

  protected void setUp ()
  {
    _value1 = 2;
    _value2 = 3;
  }


  /**
   * create test suite.
   */

  static public Test suite ()
  {
    /**
     * the type safe way

    TestSuite suite = new TestSuite ();

    suite.addTest (new TestSimple ("add")
    {
      protected void runTest ()
      {
        testAdd ();
      }
    });

    suite.addTest (new TestSimple ("testDivideByZero")
    {
      protected void runTest ()
      {
        testDivideByZero ();
      }
    });

    return suite;
    */

    /**
     * the dynamic way
     */

    return new TestSuite (tests.junitx.samples.TestSimple.class);
  }


  /**
   * test addition.
   */

  public void testAdd ()
  {
    double result = _value1 + _value2;

    // forced failure result == 5

    assert (result == 6);
  }


  /**
   * test divide by zero
   */

  public void testDivideByZero ()
  {
    int zero   = 0;
    int result = 8 / zero;
  }


  /**
   * tests for equality.
   */

  public void testEquals ()
  {
    assertEquals (12,  12);
    assertEquals (12L, 12L);
    assertEquals (new Long(12), new Long(12));
 
    assertEquals ("Size", 12, 13);
    assertEquals ("Capacity", 12.0, 11.99, 0.0);
  }
}
